(function(a){$telerik.findAutoComplete=$find;
$telerik.toAutoComplete=function(r){return r;
};
Type.registerNamespace("Telerik.Web.UI");
var c=Telerik.Web.UI,b=Sys.Serialization.JavaScriptSerializer,h={0:"contains",1:"startswith"},m=1,e=".",l=2,k="racHovered",i="racFocused",q="racTokenList",p="racToken",j="racFocused",n="racSelected",o="racShowAll",d=46,g=113,f=0;
a.registerEnum(c,"RadAutoCompleteInputType",{Token:0,Text:1});
a.registerEnum(c,"RadAutoCompleteFilter",{Contains:0,StartsWith:1});
a.registerEnum(c,"RadAutoCompleteDropDownPosition",{Automatic:0,Static:1});
a.registerEnum(c,"RadAutoCompleteBinding",{Callback:0,WebService:1,OData:2,ClientDataSource:3});
c.AutoCompleteBoxAttributeCollection=function(){this._data={};
this._keys=[];
};
c.AutoCompleteBoxAttributeCollection.prototype={getAttribute:function(r){return this._data[r];
},setAttribute:function(r,s){this._add(r,s);
},_add:function(r,s){if(Array.indexOf(this._keys,r)<0){Array.add(this._keys,r);
}this._data[r]=s;
},removeAttribute:function(r){Array.remove(this._keys,r);
delete this._data[r];
},_load:function(r){for(var s in r){this._add(s,r[s]);
}},get_count:function(){return this._keys.length;
}};
c.AutoCompleteBoxAttributeCollection.registerClass("Telerik.Web.UI.AutoCompleteBoxAttributeCollection");
c.RadAutoCompleteBox=function(r){c.RadAutoCompleteBox.initializeBase(this,[r]);
this._entryData=null;
this._dropDownItemData=null;
this._children=null;
this._inputElement=null;
this._originalText="";
this._log=new c.ChangeLog();
this._attributes=new c.AutoCompleteBoxAttributeCollection(this);
this._persistChanges=true;
this._postBackReference=null;
this._postBackOnRemove=false;
this._postBackOnAdd=false;
this._postBackOnChange=false;
this._animationContainer=null;
this._enabled=true;
this._dropDown=null;
this._entries=[];
this._uniqueId=null;
this._requestTimer=null;
this._requestInProgress=false;
this._selectedToken=null;
this._flatBinder=null;
this._bindingMode=null;
this._webServiceSettings=null;
this._webServiceLoader=null;
this._clientDropDownTemplate=null;
this._emptyMessage=null;
this._tokensSettings=[];
this._textSettings=[];
this._removeTokenTitle="";
this._requestDelay=250;
this._loadingIcon=null;
this._showAllResultsText="";
this._clientDataSource=null;
this._clientDataSourceID="";
this._dataTextField="";
this._dataValueField="";
this._odataClientSettings=null;
this._highlightFirstMatch=true;
this._shouldFocus=false;
this._expandAnimation=new c.AnimationSettings({});
this._collapseAnimation=new c.AnimationSettings({});
this._enableScreenBoundaryDetection=true;
this._enableDirectionDetection=false;
this._ariaSettings=null;
};
c.RadAutoCompleteBox.prototype={initialize:function(){var u=this,r=a(this._element),s=a(this.get_inputElement());
c.RadAutoCompleteBox.callBaseMethod(this,"initialize");
this._log.initialize();
if(this._isInTokenMode()){r.on("click",".racRemoveTokenLink",function(v){u._onRemoveLinkClick(v);
});
r.on("click",e+p,function(v){u._onTokenClick(v);
});
r.on("mousedown",e+p,function(v){v.preventDefault();
});
r.on("mouseenter",e+p,function(v){u._onTokenMouseover(v);
});
r.on("mouseleave",e+p,function(v){u._onTokenMouseout(v);
});
if(this.get_tokensSettings().allowTokenEditing){r.on("dblclick",".racToken",function(v){u._onTokenDblClick(v);
v.stopPropagation();
});
r.on("keydown",".racEditTokenInput",function(v){u._onEditInputKeyDown(v);
});
r.on("blur",".racEditTokenInput",function(v){u._onEditInputBlur(v);
});
}}r.on({click:function(v){u._onInputCellClick(v);
},mouseenter:function(v){u._onMouseenter(v);
},mouseleave:function(v){u._onMouseleave(v);
}});
s.attr({autocomplete:"off",size:20}).on({keydown:function(v){u._onKeyDown(v);
},keypress:function(v){u._onKeyPress(v);
},keyup:function(v){u._onKeyUp(v);
},paste:function(v){u._onPaste(v);
},blur:function(v){u._onBlur(v);
},focusin:function(v){u._onFocus(v);
}});
if(this.get_showLoadingIcon()){this._createLoadingIcon();
}this._initializeDropDown();
this._initializeInputWidth(true);
this._createChildControls();
this._cdInitDelegate=a.proxy(this._initializeClientDataSource,this);
Sys.Application.add_load(this._cdInitDelegate);
var t=this.get_text();
if(!this._isInTokenMode()){this._originalText=this.get_text();
}this.get_element().value=t;
this._initializeValidatorChangeEvent();
if(this.get_isUsingODataSource()){this._initializeODataSourceBinder();
}this._bindingMode=this._determineBindingMode();
this._toggleEmptyMessage();
this._updateInputSize(true);
if(this._enableClientFiltering){if(this._bindingMode!=c.RadAutoCompleteBinding.Callback){a(this._dropDown.get_itemsContainer()).empty();
this._requestItems("",true);
}this._dropDown.hideItems();
}if(!this._enabled){this.disable();
}if(this._shouldFocus){s.focus();
}if(this.get_enableAriaSupport()){this._applyAriaSupport();
}this._raiseControlEvent(this,"load",{});
},dispose:function(){c.RadAutoCompleteBox.callBaseMethod(this,"dispose");
this._dropDown.dispose();
a(this._element).add(this.get_inputElement()).off();
},_initializeValidatorChangeEvent:function(r){var u=this._inputElement,t="if(!event) return; var t = event.srcElement || event.target; if (!t._shouldTriggerChange) return; ",s=u.onchange;
if(typeof(s)=="function"){s=s.toString();
s=s.substring(s.indexOf("{")+1,s.lastIndexOf("}"));
u.onchange=new Function("event",t+" "+s);
}},get_rippleZonesConfiguration:function(){return[{element:this.get_dropDownElement(),rippleConfigurations:[{containerSelector:".racItemHovered,.racShowAll"}]}];
},enable:function(){this.set_enabled(true);
},disable:function(){this.set_enabled(false);
},clear:function(){this._dropDown.close();
},createEntry:function(u,v,r){var t=new c.AutoCompleteBoxEntry(),s={text:u,value:v,attributes:r};
t._initialize(s,this);
return t;
},query:function(s){var u=this,t=(this.get_maxResultCount()==-1),r=u._dropDown;
s=s||this.get_searchString();
u._cachedSearchString=s;
clearTimeout(this._requestTimer);
if(!s||s.length<this.get_minFilterLength()){this.clear();
}else{if(this.get_enableClientFiltering()){r.filterItems(s,t);
r.open(u._getDropDownPositionInfo());
}else{this._requestTimer=setTimeout(function(){u._requestItems(s,t);
},this._requestDelay);
}}},saveClientState:function(){var r=(this._log._logEntries!==null)?this._log.serialize():"[]";
return'{"enabled":'+this._enabled+',"logEntries":'+r+"}";
},updateClientState:function(){if(this._shouldUpdateClientState){this.set_clientState(this.saveClientState());
}},_applyAriaSupport:function(){this._applyInputElementAttributes();
this._applyDropDownElementAttributes();
this._applyTokenListAttributes();
if(this._ariaSettings){var s=b.deserialize(this._ariaSettings);
var r=new c.WaiAriaDecorator(this.get_inputElement(),s);
r.setAttributes();
}},_applyInputElementAttributes:function(){var v=this,r=a(v.get_element()),s=r.find(".racLabel"),u=v.get_id()+"_label",t=v.get_inputElement();
a(t).attr({role:"textbox","aria-haspopup":true,"aria-expanded":false,"aria-readonly":false,"aria-disabled":!v.get_enabled(),"aria-busy":false,"aria-owns":v.get_id()+"_listbox "+v.get_id()+"_tokens"});
if(s.length>0){a(t).attr("aria-labelledby",u);
s.attr("id",u);
}else{if(v.get_element().title){a(t).attr("aria-label",v.get_element().title);
}}t.setAttribute("aria-autocomplete","listbox");
},_applyDropDownElementAttributes:function(){var s=this,r=a(s.get_dropDownElement());
r.attr({role:"listbox","aria-live":"polite",id:s.get_id()+"_listbox"});
},_applyTokenListAttributes:function(){var s=this,r=a(s.get_element()).find(".racTokenList");
r.attr({role:"list","aria-hidden":"false","aria-readonly":"false",id:s.get_id()+"_tokens"});
},_applyTokenAriaAttributes:function(){var t=this,s=t.get_inputElement(),r=a(t._selectedToken);
if(t._selectedToken){r.attr({role:"option","aria-label":r.text(),"aria-readonly":!t.get_allowTokenEditing(),id:t.get_id()+"_focusedToken"});
a(s).attr({role:"listbox","aria-activedescendant":t.get_id()+"_focusedToken"});
}else{a(s).attr("role","textbox");
a(s).attr("aria-activedescendant",a(s).attr("id"));
a(s).attr("aria-expanded",false);
}},_addEntry:function(r){this.get_entries()._add(r);
if(this._postBackOnAdd){this._postback({command:"Add",text:r.get_text(),value:r.get_value(),attributes:r.get_attributes()._data});
}else{this._logChanges();
}},_addTextToken:function(r){var s=r._renderTextToken();
this._insertToken(r,s,".racTextToken");
},_addToken:function(r){var s=r._renderToken();
this._insertToken(r,s,".racToken");
},_insertToken:function(u,v,t){var r=a(this.get_inputElement()),s;
a(v).insertBefore(r);
s=r.parent().find(t).last();
s.data("entry",u);
u.set_token(s[0]);
r.val("");
},_addEntryFromItem:function(s){if(!this._isInTokenMode()&&this.get_allowCustomEntry()){this._appendEntryText(s.get_text(),!this._isInSingleSelectionMode());
return;
}var r=this._createEntryFromDropDownItem(s);
this._appendEntryText(s.get_text(),!this._isInSingleSelectionMode());
this._addEntry(r);
},_appendEntryText:function(t,r){var w=this.get_text(),x,u=this.get_inputElement(),s=this.get_delimiter().charAt(0)+" ",v="";
x=this._getDelimiterIndex(w);
if(x!=-1&&!this._isInTokenMode()&&this.get_allowCustomEntry()){if(!this._getIsDoubleSymbolDelimiter()){v=w.substring(0,x)+s;
}else{v=w.substring(0,x+1)+" ";
}}v+=t;
if(r){v+=s;
}u.value=v;
this._updateInputSize();
},_clearTokenSelection:function(){a(this._selectedToken).removeClass(j);
this._selectedToken=null;
},_createChildControls:function(){var r=this,t=this._entryData,s=new c.AutoCompleteBoxEntryCollection(r);
this._children=s;
this._childControlsCreated=true;
if(this.get_enableClientFiltering()&&this._dropDownItemData){this._populateDropDown(this._dropDownItemData,true);
}if(!this._entryData){return;
}a.each(t,function(u){var v=new c.AutoCompleteBoxEntry();
v._initialize(t[u],r);
s._add(v);
});
this._originalText=this.get_text();
this._logChanges();
},_createLoadingIcon:function(){var r=document.createElement("span");
var s=this.get_renderMode()===c.RenderMode.Classic;
r.className=s?"racLoadingIcon":"p-icon p-i-loading";
r.style.display="none";
a(this.get_inputElement()).after(r);
this._loadingIcon=r;
},_createEntryFromDropDownItem:function(r){return this.createEntry(r.get_text(),r.get_value(),r.get_attributes()._data);
},_createEntriesFromText:function(z){var t,x,r=this.get_delimiter(),w;
if(!this._getIsDoubleSymbolDelimiter()){t=this.get_text().split(r);
}else{x=this._getDoubleCharRegExp(r);
t=this.get_text().split(x);
}w=t.length;
this.get_entries().clear();
if(this._isInSingleSelectionMode()){if(z){this._addEntry(this.createEntry(z));
}}else{for(var v=0;
v<w;
v++){var u=t[v].trim();
if(u){this._addEntry(this.createEntry(u));
if(this._getIsDoubleSymbolDelimiter()){var y=z.indexOf(u),s=z.substr(y+u.length,1);
z=z.substr(z.indexOf(s));
}}}}},_determineBindingMode:function(){if(this._clientDataSourceID){return c.RadAutoCompleteBinding.ClientDataSource;
}else{if(this.get_odataClientSettings()){return c.RadAutoCompleteBinding.OData;
}else{if(this.get_webServiceSettings()){return c.RadAutoCompleteBinding.WebService;
}else{return c.RadAutoCompleteBinding.Callback;
}}}},_requestItems:function(t,u){var r=c.RadAutoCompleteBinding,s={searchString:t,showAllResults:u};
switch(this.get_bindingMode()){case r.WebService:this._doLoadOnDemandFromWebService(s);
break;
case r.OData:this._doLoadOnDemandUsingOData(s);
break;
case r.Callback:this._doLoadOnDemand(s);
break;
case r.ClientDataSource:this._doLoadOnDemandFromClientDataSource(s);
break;
}},_loadDropDownItems:function(r,s,t){this._raiseControlEvent(this,"requested",{data:r,text:this.get_searchString()});
this._dropDown._clientTemplate=this._clientDropDownTemplate;
this._populateDropDown(r,false,t,s);
},_doLoadOnDemandUsingOData:function(s){var z=this,u=s.searchString,x=s.showAllResults,y=this.get_odataClientSettings().DataTextField,v=x?-1:this.get_maxResultCount(),t={ShowAllResults:s.showAllResults};
z._onRequestStart();
var w={events:{requesting:function(A){var B=A.get_options();
if(!z.get_enableClientFiltering()){A.set_filterExpressions({field:y,operator:h[z.get_filter()],value:u});
}if(v>0){B.data.take=v;
}B.context=t;
},success:function(A,B){if(z._requestInProgress){z._onODataResponse(A,B,arguments[2]);
z._onRequestEnd();
}},fail:function(A){if(z._requestInProgress){z._onErrorReceived("Request failed","");
z._onRequestEnd();
}}}};
var r=this._raiseCancellableControlEvent(this,"requesting",{text:this.get_searchString()});
if(r){return;
}this._flatBinder.fetch(w);
},_onODataResponse:function(v,s,r){var t=(s==v.length),u=(r&&!r.ShowAllResults)?!t:false;
this._loadDropDownItems(v,null,u);
},_doLoadOnDemand:function(v){var w=v.searchString,r={Text:w,ShowAllResults:v.showAllResults},x=Function.createDelegate(this,this._onCallbackResponse),y=Function.createDelegate(this,this._onCallbackError),t=new c.CallbackSettings({id:this._uniqueId,arguments:b.serialize(r),onCallbackSuccess:x,context:{ShowAllResults:v.showAllResults},onCallbackError:y,isAsync:true});
this._onRequestStart();
var u=this._raiseCancellableControlEvent(this,"requesting",{text:w});
if(u){return;
}var s=new c.CallbackLoader(t);
s.invokeCallbackMethod();
},_onCallbackResponse:function(v,s){if(!this._requestInProgress){return;
}var w=v.split("_$$_"),t=a.parseJSON(w[0]),r=a(this.get_dropDownElement()).find("ul"),u=(s&&!s.ShowAllResults)?(w[2]!="True"):false;
r.html(w[1]);
this._raiseControlEvent(this,"requested",{data:t,text:this.get_searchString()});
this._populateDropDown(t,true,u);
this._onRequestEnd();
},_onCallbackError:function(r){if(!this._requestInProgress){return;
}this._onErrorReceived(r,this.get_searchString());
this._onRequestEnd();
},_doLoadOnDemandFromClientDataSource:function(u){this._onRequestStart();
var s=this._raiseCancellableControlEvent(this,"requesting",{text:u.searchString});
if(s){return;
}var t=this._clientDataSource,r=this;
if(t.get_data().length===0){t.fetch(function(){r._processClientDataSourceData(u);
});
}else{r._processClientDataSourceData(u);
}},_loadItemsFromData:function(r,w){var t=r,u=this.get_maxResultCount(),v,s={dataTextField:this._dataTextField,dataValueField:this._dataValueField};
if(w){v=false;
}else{if(u<t.length){t=t.slice(0,u);
v=true;
}else{v=false;
}}this._loadDropDownItems(t,s,v);
this._onRequestEnd();
},_processClientDataSourceData:function(v){if(!this._requestInProgress){return;
}var t=this._clientDataSource,s=this;
var u,r=Telerik.Web.UI.ClientDataSource.FilterOperator;
if(this.get_filter()==Telerik.Web.UI.RadAutoCompleteFilter.Contains){u=r.Contains;
}else{u=r.StartsWith;
}t.get_filterExpressions().clear();
t.get_filterExpressions().add([{fieldName:this._dataTextField,value:v.searchString,operator:u}]);
t.fetch(function(){var w=t.view();
s._loadItemsFromData(w,v.showAllResults);
});
},_doLoadOnDemandFromWebService:function(s){var u=s.searchString,x=s.showAllResults,y={Text:u,MaxResultCount:x?-1:this.get_maxResultCount(),IsCaseSensitive:this.get_isCaseSensitive()},t={ShowAllResults:s.showAllResults},v={context:y},z=this.get_webServiceSettings(),w=z;
this._onRequestStart();
var r=this._raiseCancellableControlEvent(this,"requesting",v);
if(r){return;
}this._webServiceLoader=new c.WebServiceLoader(z);
if(w.get_isWcf()){v.context=this._webServiceLoader._serializeDictionaryAsKeyValuePairs(v.context);
}this._webServiceLoader.add_loadingSuccess(Function.createDelegate(this,this._onWebServiceResponse));
this._webServiceLoader.add_loadingError(Function.createDelegate(this,this._onWebServiceError));
this._webServiceLoader.loadData(v,t);
},_onWebServiceResponse:function(x,s){if(!this._requestInProgress){return;
}var t=s.get_data().Items,u=this.get_maxResultCount(),y=s.get_context().ShowAllResults,r=s.get_data().EndOfItems,v=(s&&!y)?!r:false,w;
if(u!=-1&&u<t.length){if(y){v=false;
}else{t=t.slice(0,u);
v=true;
}}w=t;
this._loadDropDownItems(w,null,v);
this._onRequestEnd();
},_onWebServiceError:function(t,s){if(!this._requestInProgress){return;
}var r=s.get_message(),u=s.get_context();
this._onErrorReceived(r,u);
this._onRequestEnd();
},_onErrorReceived:function(s,u){var t=(s.indexOf("DataSource not set")!=-1),r={errorMessage:s};
if(this._raiseCancellableControlEvent(this,"requestFailed",r)){return;
}if(t){alert("The control DataSource(or DataSourceID) is not set.");
}else{alert(s);
}},_onRequestStart:function(){if(this.get_showLoadingIcon()){a(this._loadingIcon).show();
if(this.get_enableAriaSupport()){a(this.get_inputElement()).attr("aria-busy",true);
}}this._requestInProgress=true;
},_onRequestEnd:function(){if(this.get_showLoadingIcon()){a(this._loadingIcon).hide();
if(this.get_enableAriaSupport()){a(this.get_inputElement()).attr("aria-busy",false);
}}this._requestInProgress=false;
},_ensureChildControls:function(){if(!this._childControlsCreated){this._createChildControls();
this._childControlsCreated=true;
}},_focusInput:function(r){var s=this;
s.get_inputElement().focus();
},_getEntriesTexts:function(){var u=[],r=this.get_entries(),s=r.get_count();
if(this._isInSingleSelectionMode()){if(s>0){return r.getEntry(0).get_text();
}else{return"";
}}for(var t=0;
t<s;
t++){u[u.length]=r.getEntry(t).get_text();
if(this._getIsDoubleSymbolDelimiter()&&!this._isInTokenMode()){u[u.length]=this.get_delimiter().charAt(0);
}else{u[u.length]=this.get_delimiter();
}u[u.length]=" ";
}return u.join("");
},_initializeDropDown:function(){var w=this,t=a(this._element).find(".racSlide").get(0),r=a(t).children(".RadAutoCompleteBoxPopup"),u=a(this._element).find(".racLabel").outerWidth();
if(u){u+=1;
}var s={enableClientFiltering:this.get_enableClientFiltering(),filter:this.get_filter(),maxResultCount:this.get_maxResultCount(),isCaseSensitive:this.get_isCaseSensitive(),showAllResultsText:this._showAllResultsText,highlightFirstMatch:this._highlightFirstMatch,width:this.get_dropDownWidth()||(a(this._element).width()-u),height:this.get_dropDownHeight(),anchor:this._element,expandAnimation:this.get_expandAnimation(),collapseAnimation:this.get_collapseAnimation(),enableScreenBoundaryDetection:this.get_enableScreenBoundaryDetection(),enableDirectionDetection:this.get_enableDirectionDetection()};
this._dropDown=new c.RadAutoCompleteBox.DropDown(t,s);
if($telerik.isIE7){var v=r.outerWidth(true),x=r.css("width");
if(x.indexOf("%")==-1){x=parseInt(x,10);
if(x!==0){r.width(x-(v-x));
}}}this._dropDown.on({itemDataBound:w._onDropDownItemDataBound,dropDownMouseUp:w._onDropDownMouseUp,dropDownItemClicked:w._onDropDownItemClicked,dropDownOpening:w._onDropDownOpening,dropDownOpened:w._onDropDownOpened,dropDownClosing:w._onDropDownClosing,dropDownClosed:w._onDropDownClosed,ShowAllClick:w._onShowAllClick,ShowAllFocus:w._onShowAllFocus},this);
},_initializeInputWidth:function(v){var r=a(this._element),u=this.get_inputElement(),t=r.find(".racTokenList"),s=r.find(".racLabel"),w=s.get(0);
if(w){var x=s.outerWidth()+m,y=t.outerWidth()-t.width(),z=r.width();
t.width(z-(x+y));
}if(!this._isInTokenMode()&&this.get_allowCustomEntry()){u.style.width="100%";
this._updateText(v);
}},_initializeODataSourceBinder:function(){var s=this.get_odataClientSettings().ODataSourceID,r=$find(s);
if(!r){var t=String.format("DataSource with id {0} was not found on the page",s);
alert(t);
}else{this._flatBinder=new c.RadODataDataSource.Binder.Flat(r,this);
this._flatBinder.initialize();
}},_initializeClientDataSource:function(){if(this._clientDataSourceID){this._clientDataSource=$find(this._clientDataSourceID);
}Sys.Application.remove_load(this._cdInitDelegate);
},_isInTokenMode:function(){return this.get_inputType()==c.RadAutoCompleteInputType.Token;
},_isInSingleSelectionMode:function(){return(!this._isInTokenMode()&&this.get_textSettings().selectionMode===0);
},_logChanges:function(){this._logEntries();
this.updateClientState();
this.get_element().value=this.get_text();
},_logEntries:function(){var s=this.get_entries(),r=s.get_count();
this._log.initialize();
for(var t=0;
t<r;
t++){this._log.logInsert(s.getEntry(t));
}},_populateDropDown:function(r,u,v,s){var t=this._dropDown,w=r.length;
if(r.length){t.populate(r,u,s);
if(v&&w>=this.get_maxResultCount()){t._addShowAllButton();
}else{t._removeShowAllButton();
}if(!this.get_enableClientFiltering()){t.open(this._getDropDownPositionInfo());
if(this._highlightFirstMatch){t.highlightNext();
}}}else{this.clear();
}},_getDropDownPositionInfo:function(){var r={automaticPosition:(this.get_dropDownPosition()==c.RadAutoCompleteDropDownPosition.Automatic),simpleTextMode:(!this._isInTokenMode()&&this.get_allowCustomEntry()),delimiter:this.get_delimiter()};
return r;
},_raiseControlEvent:function(s,t,r){a.raiseControlEvent(s,t,r);
},_raiseCancellableControlEvent:function(s,t,r){return a.raiseCancellableControlEvent(s,t,r);
},_removeEntry:function(r){var s=r.get_index();
this.get_entries()._remove(r);
if(this._postBackOnRemove){this._postback({command:"Remove",index:s});
}},_removeTextToken:function(r){this._removeToken(r);
},_removeToken:function(r){var s=r.get_token();
a(s).remove();
},_shouldApplyEmptyMessage:function(){return(this.get_entries().get_count()===0&&this.get_emptyMessage());
},_toggleEmptyMessage:function(s){var r=a(this.get_inputElement());
if(this._shouldApplyEmptyMessage()){r.val(this.get_emptyMessage());
if(r.is(":not(.racEmptyMessage)")){r.addClass("racEmptyMessage");
}}else{if(r.is(".racEmptyMessage")){r.get(0).className="racInput";
}}this._updateInputSize(s);
},_toggleClassName:function(t,r,s){if(!this.get_enabled()){return;
}r.toggleClass(s,t);
},_updateInputSize:function(v){var y=this,s=this._element,r=a(s),u=this.get_inputElement(),x=u.value,w=0;
if(v){if(x.length>0){u.size=x.length;
}else{if(x.length===0){u.size=l;
}}}else{var z=s.offsetHeight,t=0;
if(!this._isMaxWidthRemoved&&!this.get_showLoadingIcon()){a(u).css("maxWidth","none");
this._isMaxWidthRemoved=true;
}if(this._isInTokenMode()){u.style.width=y._dropDown._getTextWidth(x)+10+"px";
}else{if(this.get_allowCustomEntry()&&this.get_element().style.width.indexOf("%")!=-1){u.style.width="100%";
}else{r.find(".racTextToken").each(function(B,A){t+=a(A).outerWidth(true);
});
w=r.outerWidth(true)-t-a(this._loadingIcon).outerWidth(true);
if(w>0&&this.get_allowCustomEntry()){a(u).width(w);
}else{u.style.width=y._dropDown._getTextWidth(x)+10+"px";
}}}if(z!==s.offsetHeight){this._dropDown.position(this._getDropDownPositionInfo());
}}},_updateText:function(s){var r=this.get_inputElement(),t=this._getEntriesTexts();
r.value=t;
this._updateInputSize(s);
},_getIsDelimiter:function(r){var t=false,s=this.get_delimiter();
if(this._getIsDoubleSymbolDelimiter()){t=(r===s.charCodeAt(0)||r===s.charCodeAt(1));
}else{t=r===s.charCodeAt(0);
}return t;
},_getDelimiterIndex:function(u){var r=this.get_delimiter();
if(this._getIsDoubleSymbolDelimiter()){var s=u.lastIndexOf(r.charAt(0)),t=u.lastIndexOf(r.charAt(1));
return Math.max(s,t);
}return u.lastIndexOf(r.charAt(0));
},_getIsDoubleSymbolDelimiter:function(){return this.get_delimiter().length>1;
},_getDoubleCharRegExp:function(r){return new RegExp("["+r.charAt(0)+"|"+r.charAt(1)+"]");
},_onFocus:function(s){var t=this.get_inputElement();
var r=a(this.get_element()).find(e+q);
this._toggleClassName(true,r,i);
if(a(t).is(".racEmptyMessage")){a(t).removeClass("racEmptyMessage");
t.value="";
}if(!this._isInTokenMode()){this._putCursorAtEnd(t);
}this._originalText=this.get_text();
},_putCursorAtEnd:function(s){var r=a(s);
if(s.setSelectionRange){var t=r.val().length;
s.setSelectionRange(t,t);
}else{r.val(r.val());
}},_onBlur:function(u){var x=this.get_text();
var t=this._dropDown;
var s=this._dropDown.select();
var w=this.get_inputElement();
var r=a(this.get_element()).find(e+q);
if(!t._shouldBlurAutoComplete&&!s){return;
}if(!t._shouldBlurAutoComplete&&s&&s.get_text()!=x){return;
}this._onRequestEnd();
this._toggleClassName(false,r,i);
if(this._requestTimer){clearTimeout(this._requestTimer);
}t.close();
this._clearTokenSelection();
if(s){this._addEntryFromItem(s);
x=this.get_text();
}if(!this.get_allowCustomEntry()){w.value="";
x=this.get_text();
}if(x==this._originalText&&s){if(!t._isScroll){this._toggleEmptyMessage();
return;
}}this.get_element().value=x;
w._shouldTriggerChange=true;
a(w).trigger("change");
w._shouldTriggerChange=undefined;
if(this._isInTokenMode()){if(this.get_allowCustomEntry()&&this.get_searchString()&&!s){var v=this.createEntry(this.get_searchString());
this._addEntry(v);
}}else{if(this.get_allowCustomEntry()){this._createEntriesFromText(x);
this._updateText();
}if(x!==this._originalText){this._onTextChanged(x);
if(this._postBackOnChange){this._logChanges();
this._postback({command:"Change",text:x});
}}}this._originalText=x;
this._logChanges();
this._toggleEmptyMessage();
},_onInputCellClick:function(r){if(!this._enabled){return;
}if(this.get_inputElement().value==this.get_emptyMessage()){this.get_inputElement().value="";
}if(r.target.className!="racEditTokenInput"){this._focusInput();
}},_onMouseenter:function(s){var r=a(this.get_element()).find(e+q);
this._toggleClassName(true,r,k);
},_onMouseleave:function(s){var r=a(this.get_element()).find(e+q);
this._toggleClassName(false,r,k);
},_onKeyDown:function(y){var J=this,x=this._dropDown,u,B,C=this.get_inputElement(),H=C.value,I=H.length,K=this._isInTokenMode()?p:"racTextToken",s=a(this.get_element()).find("."+K).last(),v=function(M,L){M._appendEntryText(u.get_text(),false);
u.ensureVisible(L);
M._dropDown.position(M._getDropDownPositionInfo());
};
if(y.keyCode!==Sys.UI.Key.backspace&&y.keyCode!==Sys.UI.Key.left&&y.keyCode!==Sys.UI.Key.right&&y.keyCode!==g&&y.keyCode!==d&&this._selectedToken){this._clearTokenSelection();
}setTimeout(function(){J._updateInputSize();
},10);
switch(y.keyCode){case Sys.UI.Key.left:case Sys.UI.Key.right:if(I===0){if(this._selectedToken){var G=(y.keyCode===Sys.UI.Key.left)?a(J._selectedToken).prev():a(this._selectedToken).next();
if(J.get_enableAriaSupport()){a(J._selectedToken).removeAttr("id");
}J._clearTokenSelection();
if(G&&G.hasClass(K)){G.addClass(j);
J._selectedToken=G.get(0);
}}else{if(J._isInTokenMode()||!J.get_allowCustomEntry()){s.addClass(j);
J._selectedToken=s.get(0);
}}if(J.get_enableAriaSupport()){J._applyTokenAriaAttributes();
}}break;
case Sys.UI.Key.up:if(J.get_enableAriaSupport()){a(C).attr("aria-activedescendant",a(C).attr("id"));
}y.preventDefault();
x.highlightPrev();
u=x.get_activeItem();
if(u){v(this,false);
}break;
case Sys.UI.Key.down:if(J.get_enableAriaSupport()){a(C).attr("aria-activedescendant",a(C).attr("id"));
}if(!x.isVisible()&&I>0){J.query();
if(!J._highlightFirstMatch){return;
}}y.preventDefault();
x.highlightNext();
u=x.get_activeItem();
if(u){v(this,true);
}break;
case Sys.UI.Key.esc:if(x.isVisible()){this._appendEntryText(this._cachedSearchString,false);
x.close();
}else{C.value="";
}break;
case Sys.UI.Key.enter:var E=x.select(),A,r=a(x.get_itemsContainer()),t=r.siblings(e+o),D=t.hasClass(j);
if(J.get_enableAriaSupport()){if(!D){a(C).attr("role","textbox");
}a(C).attr("aria-expanded",D);
a(C).attr("aria-activedescendant",a(C).attr("id"));
}y.preventDefault();
if(D){J._onShowAllClick();
return;
}if(E){this._addEntryFromItem(E);
}else{var F=this.get_searchString();
if(F.length===0){return;
}if(this.get_allowCustomEntry()&&!this._isInSingleSelectionMode()){if(this._isInTokenMode()){A=this.createEntry(F);
this._addEntry(A);
}else{var z=false,w=this.get_delimiter();
H=this.get_text();
if(this._getIsDoubleSymbolDelimiter()){z=this._endsWith(H,w.charAt(0))||this._endsWith(H,w.charAt(1));
if(!z){C.value+=w.charAt(0)+" ";
}}else{C.value+=w;
}}}if(this.get_allowCustomEntry()&&!this._isInTokenMode()){this._createEntriesFromText(H);
this._toggleEmptyMessage();
this._updateText();
}}this._updateInputSize();
this.clear();
break;
case Sys.UI.Key.backspace:if(I===0){if(this._selectedToken){B=a(this._selectedToken).data()["entry"];
this._removeEntry(B);
this._selectedToken=null;
}else{if(this._isInTokenMode()||!this.get_allowCustomEntry()){s.addClass(j);
this._selectedToken=s.get(0);
}}if(J.get_enableAriaSupport()){if(J._selectedToken){J._applyTokenAriaAttributes();
}else{a(C).attr("aria-activedescendant",a(C).attr("id"));
a(C).attr("aria-expanded",false);
}}}break;
case d:if(this._selectedToken){B=a(this._selectedToken).data()["entry"];
this._removeEntry(B);
this._selectedToken=null;
if(J.get_enableAriaSupport()){a(C).attr("aria-activedescendant",a(C).attr("id"));
a(C).attr("aria-expanded",false);
}}break;
case g:if(J._isInTokenMode()&&J.get_allowCustomEntry()&&J.get_allowTokenEditing()){J._switchToEditMode(J._selectedToken);
}break;
}},_onKeyPress:function(s){var r=s.keyCode?s.keyCode:s.charCode,u=this._getIsDelimiter(r),t;
if(u&&!this._isInSingleSelectionMode()){if(!this._isInTokenMode()&&this.get_allowCustomEntry()){return;
}s.preventDefault();
var v=this.get_searchString();
if(!v||v==" "||v.length===0||!this.get_allowCustomEntry()){return;
}t=this.createEntry(v);
this._addEntry(t);
this.clear();
}},_endsWith:function(r,s){return r.indexOf(s,r.length-s.length)!==-1;
},_onKeyUp:function(t){var r=t.keyCode,y=Sys.UI.Key,w=r===y.backspace,x=r!=y.up&&r!=y.down&&r!=y.enter&&r!=y.tab&&r!=y.esc&&!w,u=false,s=this.get_delimiter(),A=this.get_text(),v;
if(s.length>1){u=this._endsWith(A,s.charAt(0))||this._endsWith(A,s.charAt(1));
}else{u=this._endsWith(A,s);
}if(x||w){if(!u){this.query();
}else{var z=this.get_searchString(r);
if(!z&&z.length===0||!this.get_allowCustomEntry()){return;
}if(z!==""){v=this.createEntry(z);
this._addEntry(v);
this.clear();
}}}},_onPaste:function(r){var s=this;
setTimeout(function(){s._updateInputSize();
s.query();
},1);
},_onRemoveLinkClick:function(r){if(!this._enabled){return;
}var s=a(r.target).closest(".racToken").data()["entry"];
this._removeEntry(s);
this._logChanges();
},_onEditInputKeyDown:function(r){if(!this._enabled){return;
}var s=a(r.target.parentElement).data()["entry"],t=a(r.target).get(0),u=t.value,v=a(r.target.parentElement.firstChild).get(0);
switch(r.keyCode){case Sys.UI.Key.enter:r.preventDefault();
if(u!=s.get_text()&&u!==""){v.nodeValue=u;
s.set_text(u);
}else{v.nodeValue=s.get_text();
}this._removeTokenEditInput(t);
this._logChanges();
this.get_inputElement().focus();
return false;
break;
case Sys.UI.Key.esc:v.nodeValue=s.get_text();
this._removeTokenEditInput(t);
this.get_inputElement().focus();
break;
default:return false;
}},_onEditInputBlur:function(r){if(!this._enabled||this._preventTokenBlur){return;
}var s=a(r.target.parentElement).data()["entry"],t=a(this.get_element()).find(".racEditTokenInput").get(0),u=a(r.target.parentElement.firstChild).get(0);
u.nodeValue=s.get_text();
this._removeTokenEditInput(t);
},_onTokenClick:function(s){if(!this._enabled){return;
}var r=a(s.currentTarget);
if(r.hasClass(p)){this._selectedToken=s.currentTarget;
r.addClass(j);
}},_onTokenMouseover:function(s){var r=a(s.currentTarget);
this._toggleClassName(true,r,k);
},_onTokenMouseout:function(s){var r=a(s.currentTarget);
this._toggleClassName(false,r,k);
},_onTokenDblClick:function(r){this._switchToEditMode(r.currentTarget);
},_switchToEditMode:function(x){if(!this._enabled){return;
}var u=a(this.get_element()).find(".racEditTokenInput.radPreventDecorate");
if(u.get(0)!==undefined){var w=u.parent(),s=a(w).data()["entry"],A;
A=a(w).contents().filter(function(){return this.nodeType==3;
});
A.nodeValue=s.get_text();
this._removeTokenEditInput(u);
}var t=document.createElement("input");
var y=a(x.firstChild).get(0).nodeValue;
var r=a(t);
var v=a(x).width();
var z;
r.attr("type","text").val(y).width(v).addClass("racEditTokenInput radPreventDecorate");
if(this.get_enableAriaSupport()){r.attr("role","option");
r.attr("id",this.get_id()+"_selectedToken");
a(this.get_inputElement()).attr("aria-activedescendant",this.get_id()+"_selectedToken");
}a(x).addClass(n);
a(x.firstChild).get(0).nodeValue="";
a(x).find(".racRemoveTokenLink").before(t);
r.focus();
z=y?y.length:f;
this._selectInputText(t,z);
},_removeTokenEditInput:function(r){a(r.parentElement).removeClass(n);
this._preventTokenBlur=true;
a(r).remove();
this._preventTokenBlur=false;
},_selectInputText:function(s,u){var t=0,r=u;
if(s.createTextRange){var v=s.createTextRange();
v.moveStart("character",t);
v.moveEnd("character",r);
v.select();
}else{s.setSelectionRange(t,r);
}},_onDropDownItemDataBound:function(r){this._raiseControlEvent(this,"dropDownItemDataBound",r);
},_onDropDownOpening:function(r){var s=this._raiseCancellableControlEvent(this,"dropDownOpening",r);
r.set_cancel(s);
},_onDropDownOpened:function(t){var u=this,r=a(u._dropDown.get_itemsContainer()),s=r.siblings(e+o);
if(u.get_enableAriaSupport()){a(u.get_inputElement()).attr("role","listbox");
a(u.get_inputElement()).attr("aria-expanded",true);
r.find("li").attr("role","option");
if(u._dropDown._hasShowAllButton){s.attr({role:"option","aria-label":u._showAllResultsText,id:u.get_id()+"_showAll"});
}}this._raiseControlEvent(this,"dropDownOpened",t);
},_onDropDownClosing:function(r){var s=this._raiseCancellableControlEvent(this,"dropDownClosing",r);
r.set_cancel(s);
},_onDropDownClosed:function(s){var r=a(this.get_inputElement());
if(this.get_enableAriaSupport()){r.attr({role:"textbox","aria-activedescendant":r.attr("id"),"aria-expanded":false});
}this._raiseControlEvent(this,"dropDownClosed",s);
},_onDropDownMouseUp:function(r){this._focusInput();
},_onDropDownItemClicked:function(r){var s=r.get_item(),t=this;
if(s){setTimeout(function(){t._addEntryFromItem(s);
t._updateInputSize();
},10);
}},_onShowAllClick:function(r){var s=this.get_searchString();
if(this.get_enableClientFiltering()){this._dropDown.filterItems(s,true);
this._dropDown.open(this._getDropDownPositionInfo());
}else{this._requestItems(s,true);
}},_onShowAllFocus:function(s){var u=this,r=a(u.get_inputElement()),t=u.get_id()+"_showAll";
if(u.get_enableAriaSupport()){r.attr({"aria-activedescendant":t});
}this._appendEntryText(this._cachedSearchString,false);
},_onEntryAdding:function(r){var s=a.extendEventArgs(new Sys.CancelEventArgs(),{entry:r});
return this._raiseCancellableControlEvent(this,"entryAdding",s);
},_onEntryAdded:function(r){this._raiseControlEvent(this,"entryAdded",a.extendEventArgs({},{entry:r}));
},_onEntryRemoving:function(r){var s=a.extendEventArgs(new Sys.CancelEventArgs(),{entry:r});
return this._raiseCancellableControlEvent(this,"entryRemoving",s);
},_onEntryRemoved:function(r){this._raiseControlEvent(this,"entryRemoved",a.extendEventArgs({},{entry:r}));
},_onTextChanged:function(r){this._raiseControlEvent(this,"textChanged",a.extendEventArgs({},{text:r}));
},_postback:function(r){if(!this._postBackReference){return;
}var t=this._serializePostbackCommand(r),s=this._postBackReference.replace("arguments",t);
eval(s);
},_serializePostbackCommand:function(r){var s=b.serialize(r);
return encodeURIComponent(s.replace(/'/g,"&squote"));
},get_requestDelay:function(){return this._requestDelay;
},set_requestDelay:function(r){this._requestDelay=r;
},get_attributes:function(){return this._attributes;
},set_attributes:function(r){this._attributes._load(r);
},_getChildren:function(){this._ensureChildControls();
return this._children;
},get_entries:function(){return this._getChildren();
},set_enabled:function(t){var r=a(this.get_inputElement()),s=a(this._element).find(".racTokenList");
this._enabled=t;
if(!t){r.attr("disabled","disabled");
}else{r.removeAttr("disabled");
}s.toggleClass("racDisabled",!t);
if(this.get_enableAriaSupport()){r.attr("aria-disabled",!t);
}this.updateClientState();
},get_enabled:function(){return this._enabled;
},get_inputElement:function(){if(!this._inputElement){this._inputElement=a(this.get_element()).find(".racInput").get(0);
}return this._inputElement;
},get_entryData:function(){return this._entryData;
},get_dropDownItemData:function(){return this._dropDownItemData;
},get_text:function(){var r=this.get_inputElement().value;
if(!this._isInTokenMode()&&this.get_allowCustomEntry()){return r;
}else{return this._getEntriesTexts()+r;
}},get_searchString:function(){var s,v=this.get_text(),r=this.get_delimiter(),u=this._getDoubleCharRegExp(r),w=[];
if(!this._isInSingleSelectionMode()){if(!this._getIsDoubleSymbolDelimiter()){s=this.get_text().split(r);
}else{if(!this.get_allowCustomEntry()){s=this.get_inputElement().value;
}else{s=this.get_text().split(u);
}}}else{s=this.get_text().split(u);
}for(var t=0;
t<s.length;
t++){if(s[t]!==null){w.push(s[t]);
}}if(!this._isInSingleSelectionMode()){if(w[w.length-1]!==undefined){return w[w.length-1].trimStart();
}else{return s;
}}return v;
},get_bindingMode:function(){return this._bindingMode;
},get_dropDownElement:function(){return this._dropDown._element;
},set_entryData:function(r){this._entryData=r;
},set_dropDownItemData:function(r){this._dropDownItemData=r;
},get_emptyMessage:function(){return this._emptyMessage;
},set_emptyMessage:function(r){if(this._emptyMessage!==r){this._emptyMessage=r;
}},get_webServiceSettings:function(){return this._webServiceSettings;
},get_flatModel:function(){var r=this.get_odataClientSettings();
return c.RadODataDataSource.Binder.Flat.Model(r);
},set_webServiceSettings:function(s){var r=b.deserialize(s);
this._webServiceSettings=new c.WebServiceSettings(r);
},get_isUsingODataSource:function(){return this._odataClientSettings!==null;
},get_tokensSettings:function(){return this._tokensSettings;
},set_tokensSettings:function(r){this._tokensSettings=Sys.Serialization.JavaScriptSerializer.deserialize(r);
},get_allowTokenEditing:function(){if(!this._tokensSettings.allowTokenEditing){this._tokensSettings.allowTokenEditing=false;
}return this._tokensSettings.allowTokenEditing;
},set_allowTokenEditing:function(r){this._tokensSettings.allowTokenEditing=r;
},get_textSettings:function(){return this._textSettings;
},set_textSettings:function(r){this._textSettings=Sys.Serialization.JavaScriptSerializer.deserialize(r);
},get_expandAnimation:function(){return this._expandAnimation;
},set_expandAnimation:function(s){var r=b.deserialize(s);
this._expandAnimation=new c.AnimationSettings(r);
if(this._dropDown&&this._dropDown._dropDown){this._dropDown._dropDown.set_expandAnimation(this._expandAnimation);
}},get_collapseAnimation:function(){return this._collapseAnimation;
},set_collapseAnimation:function(s){var r=b.deserialize(s);
this._collapseAnimation=new c.AnimationSettings(r);
if(this._dropDown&&this._dropDown._dropDown){this._dropDown._dropDown.set_collapseAnimation(this._collapseAnimation);
}},get_enableScreenBoundaryDetection:function(){return this._enableScreenBoundaryDetection;
},set_enableScreenBoundaryDetection:function(r){this._enableScreenBoundaryDetection=r;
if(this._dropDown&&this._dropDown._dropDown){this._dropDown._dropDown.set_enableScreenBoundaryDetection(r);
}},get_enableDirectionDetection:function(){return this._enableDirectionDetection;
},set_enableDirectionDetection:function(r){this._enableDirectionDetection=r;
if(this._dropDown&&this._dropDown._dropDown){this._dropDown._dropDown.set_enableDirectionDetection(r);
}},repaint:function(){this._initializeInputWidth(true);
}};
a.registerControlProperties(c.RadAutoCompleteBox,{filter:0,inputType:0,dropDownPosition:0,allowCustomEntry:false,delimiter:";",odataClientSettings:null,enableClientFiltering:false,minFilterLength:1,maxResultCount:-1,showLoadingIcon:true,isCaseSensitive:false,dropDownWidth:"",dropDownHeight:"",enableAriaSupport:false});
a.registerControlEvents(c.RadAutoCompleteBox,["load","dropDownItemDataBound","dropDownOpening","dropDownOpened","dropDownClosing","dropDownClosed","entryAdding","entryAdded","entryRemoving","entryRemoved","textChanged","requesting","requested","requestFailed"]);
c.RadAutoCompleteBox.registerClass("Telerik.Web.UI.RadAutoCompleteBox",c.RadWebControl);
})($telerik.$);
(function(b,a){var c=b.RadAutoCompleteBox,d=".",h="racShowAll",g="RadAutoCompleteBoxPopup",f="racList",e="racItem";
c.DropDown=function(j,i){a.observable(this);
this._element=j;
this._popup=null;
this._items=[];
this._activeElement=null;
this._shouldBlurAutoComplete=true;
this._isScroll=false;
this._clientTemplate=null;
this._enableClientFiltering=i.enableClientFiltering;
this._filter=i.filter;
this._maxResultCount=i.maxResultCount;
this._matchesCount=0;
this._isCaseSensitive=i.isCaseSensitive;
this._showAllResultsText=i.showAllResultsText;
this._highlightFirstMatch=i.highlightFirstMatch;
this._width=i.width;
this._height=i.height;
this._parent=i.anchor;
this._expandAnimation=i.expandAnimation;
this._collapseAnimation=i.collapseAnimation;
this._enableScreenBoundaryDetection=i.enableScreenBoundaryDetection;
this._enableDirectionDetection=i.enableDirectionDetection;
this._dropDown=null;
this._hasShowAllButton=false;
this.init();
};
c.DropDown.prototype={get_itemsContainer:function(){var j=this.get_popup(),i=a(j).children(d+f).get(0);
return i;
},get_popup:function(){if(!this._popup){this._popup=a(this._element).find(d+g).get(0);
}return this._popup;
},get_activeItem:function(){var i=this._activeElement;
return i?i._item:null;
},getItem:function(i){return this._items[i];
},get_items:function(){return this._items;
},get_clientTemplate:function(){return this._clientTemplate;
},set_clientTemplate:function(i){this._clientTemplate=i;
},init:function(){var i=this;
this._initializeDropDown();
a(this.get_popup()).on({mousedown:function(j){i._shouldBlurAutoComplete=false;
},mouseup:function(j){i._shouldBlurAutoComplete=true;
i._onDropDownMouseUp(j);
},click:function(j){i._onShowAllClick(j);
}},d+h);
a(this.get_itemsContainer()).on({click:function(j){i._onDropDownClick(j);
i.close();
},mousedown:function(j){i._shouldBlurAutoComplete=false;
},mouseup:function(j){i._shouldBlurAutoComplete=true;
i._onDropDownMouseUp(j);
},scroll:function(j){if($telerik.isIE){i._isScroll=true;
setTimeout(function(){i._shouldBlurAutoComplete=true;
},0);
i._onDropDownMouseUp(j);
}},mouseover:function(j){i._onDropDownHover(j);
},mouseout:function(j){i._onDropDownOut(j);
}});
},_initializeDropDown:function(){this._dropDown=new b.DropDown(this._element,{direction:2,expandAnimation:this._expandAnimation,collapseAnimation:this._collapseAnimation,enableScreenBoundaryDetection:this._enableScreenBoundaryDetection,anchor:this._parent,width:this._width||"auto",height:this._height,enableDirectionDetection:this._enableDirectionDetection});
this._dropDown.on({opening:this._onDropDownOpening,opened:this._onDropDownOpened,closing:this._onDropDownClosing,closed:this._onDropDownClosed,reflowing:this._onDropDownReflowing,reflowed:this._onDropDownReflowed,collapseAnimationEnded:this._onCollapseAnimationEnded},this);
this._dropDown.initialize();
this._dropDown.updateSize();
},dispose:function(){this.disposeObservable();
this._positionInfo=null;
if(this._dropDown){this._dropDown.dispose();
this._dropDown=null;
}a(document).add(this.get_itemsContainer()).off();
this.clear();
a(this._element).remove();
this._element=null;
},populate:function(j,l,k){var m=this,i=a(this.get_itemsContainer()).find(d+e);
if(!l){this.clear();
}a.each(j,function(p,n){var q=new c.DropDownItem(n,k);
m.trigger("itemDataBound",a.extendEventArgs({},{item:q,dataItem:n}));
if(m._clientTemplate){q._renderedClientTemplate=b.TemplateRenderer.renderTemplate(n,m,q);
}else{if(l){var o=i.get(p);
q._setElement(o);
o._item=q;
}}m._items.push(q);
});
if(!l){this.render();
}},clear:function(){this._activeElement=null;
if(this._enableClientFiltering){this.hideItems();
return;
}var k=this.get_items();
for(var j=0;
j<k.length;
j++){k[j].dispose();
}this._items=[];
this._removeShowAllButton();
a(this.get_itemsContainer()).empty();
},open:function(j){var i=this._dropDown;
this._positionInfo=j;
if(i.isVisible()){i.resolveScreenBoundaries();
i.position();
}else{i.show();
}this.position(j);
},position:function(k){var i=a(this._element),j=this._getDropDownHorizontalOffset(k);
i.css({left:j+"px"});
},select:function(){var j=this.get_activeItem(),i=a.extendEventArgs(new Sys.CancelEventArgs(),{item:j});
this.trigger("itemSelecting",i);
if(i.get_cancel()){return;
}this.trigger("itemSelected",a.extendEventArgs({},{item:j}));
return j;
},close:function(){this._toggleShowAllFocus(false);
this._dropDown.hide();
},filterItems:function(k,l){var j=true;
var i=function(n,q){var s=this,p=s._maxResultCount,o=s._isCaseSensitive?n.get_text():n.get_text().toLowerCase(),r=o.indexOf(q),m=s._filter===0?r!==-1:r===0;
if(l){s._removeShowAllButton();
}else{s._addShowAllButton();
}if(m){s._matchesCount+=1;
}if(!l&&s._matchesCount>p){m=false;
}if(m===true){a(n._element).show();
if(s._highlightFirstMatch&&j){s.updateActiveItem(s.get_activeItem(),n);
j=false;
}}else{if(m===false){a(n._element).hide();
if(s._activeElement===n._element){s.toggleHighlight(n,false);
}}}};
this._matchesCount=0;
if(!this._isCaseSensitive){k=k.toLowerCase();
}this.process(0,k,i);
},hideItems:function(){var i=function(j){a(j._element).hide();
};
this.process(0,"",i);
},process:function(l,k,i){var m=this,j=this._items;
clearTimeout(this._filterTimer);
this._filterTimer=setTimeout(function(){var n=l,p=j.length,q=new Date().getTime(),o;
while(n<p&&(new Date().getTime()-q)<50){o=j[n];
i.apply(m,[o,k]);
n++;
}if(n<p){m.process(n,k,i);
}},10);
},highlightNext:function(){this.updateActiveItem(this.get_activeItem(),this._getNextItem(1));
},highlightPrev:function(){this.updateActiveItem(this.get_activeItem(),this._getNextItem(-1));
},render:function(){var i=a(this.get_itemsContainer());
a.each(this._items,function(j,k){i.append(k.render());
});
},updateActiveItem:function(j,i){var k=(!i)&&this._hasShowAllButton;
if(k){this.trigger("ShowAllFocus");
}this._toggleShowAllFocus(k);
this.toggleHighlight(j,false);
this.toggleHighlight(i,true);
},toggleHighlight:function(i,j){if(i){i.set_highlight(j);
this._activeElement=j?i.get_element():null;
}},isVisible:function(){return this._dropDown.isVisible();
},_onDropDownOpening:function(j){var i=new Sys.CancelEventArgs();
this.trigger("dropDownOpening",i);
j.set_cancel(i.get_cancel());
},_onDropDownOpened:function(){var i=new Sys.EventArgs();
this._adjustChildListElementHeight();
this.trigger("dropDownOpened",i);
},_onDropDownClosing:function(j){var i=new Sys.CancelEventArgs();
this.trigger("dropDownClosing",i);
j.set_cancel(i.get_cancel());
},_onDropDownClosed:function(){var i=new Sys.EventArgs();
this.toggleHighlight(this.get_activeItem(),false);
this.trigger("dropDownClosed",i);
},_onDropDownReflowing:function(){a(this.get_itemsContainer()).height("");
},_onDropDownReflowed:function(){this.position(this._positionInfo);
this._adjustChildListElementHeight();
},_onCollapseAnimationEnded:function(){this.clear();
a(this.get_itemsContainer()).height("");
},_addShowAllButton:function(){var i=a(this.get_itemsContainer());
if(i.siblings(d+h).length===0){i.after("<div class='"+h+"'><span>"+this._showAllResultsText+"</span></div>");
}this._hasShowAllButton=true;
this._adjustChildListElementHeight();
},_removeShowAllButton:function(){var i=a(this.get_itemsContainer()),j=i.siblings(d+h);
if(j.length>0){j.remove();
}this._hasShowAllButton=false;
this._adjustChildListElementHeight();
},_toggleShowAllFocus:function(k){var i=a(this.get_itemsContainer()),j=i.siblings(d+h);
j.toggleClass("racFocused",k);
},_adjustChildListElementHeight:function(){var j=a(this.get_popup());
if(j[0].style.height===""){return;
}var l=j.height(),k=j.find(d+h),i=a(this.get_itemsContainer()),m=k.outerHeight(true),n;
if(l>0){n=l-m;
i.css("height",n);
}},_onDropDownHover:function(i){var j=this._extractItemFromDomElement(i.target);
this.updateActiveItem(this.get_activeItem(),j);
},_onDropDownOut:function(i){this.toggleHighlight(this.get_activeItem(),false);
},_onDropDownClick:function(j){var k=this._extractItemFromDomElement(j.target);
this.updateActiveItem(this.get_activeItem(),k);
this.select();
var i=a.extendEventArgs(new Sys.EventArgs(),{item:k});
this.trigger("dropDownItemClicked",i);
},_onDropDownMouseUp:function(i){this.trigger("dropDownMouseUp",null);
},_onShowAllClick:function(i){i.preventDefault();
this.trigger("ShowAllClick",i);
},_extractItemFromDomElement:function(i){while(i.nodeType!==9){if(i._item&&a(i).is(d+e)){return i._item;
}i=i.parentNode;
}return null;
},_getDropDownHorizontalOffset:function(s){var j=a(this._parent),i=a(this._element),q=j.offset().left,k=s&&s.automaticPosition,o=k?this._getInputLastDelimiterOffset(s):j.offset().left,r=q+j.width(),m=i.find(d+g).outerWidth(true)||i.width(),t=o+m-r,n=j.find(".racLabel").outerWidth();
var p=this._dropDown._getHiddenElementOffsetParent(this._element);
var l=$telerik.getComputedStyle(document.body,"position",null);
q+=n;
if(!k&&n){o+=n;
}if(t>0){o-=t;
}if(o<q+10){o=q;
}if(p!==document.body||l==="relative"||l==="absolute"){o-=a(p).offset().left;
}return o;
},_getInputLastDelimiterOffset:function(n){var m=this._parent,i=a(m).find(".racInput"),l=i.offset().left;
if(n&&n.simpleTextMode){var k=i.val(),j=7;
k=k.substring(0,k.lastIndexOf(n.delimiter));
l+=this._getTextWidth(k)+j;
}return l;
},_getTextWidth:function(j){var i=a(this._parent).find(".racInput")[0],k=this._createTextSizingDiv(i),l;
document.body.appendChild(k);
k.style.width="0";
k.style.height="0";
k.style.overflow="hidden";
k.innerHTML=$telerik.htmlEncode(j);
k.style.width="auto";
l=k.offsetWidth;
setTimeout(function(){document.body.removeChild(k);
},0);
return l;
},_createTextSizingDiv:function(n){var o=document.createElement("div"),j=["font-size","font-family","font-weight","font-variant","font-style","text-transform"],k=["fontSize","fontFamily","fontWeight","fontVariant","fontStyle","textTransform"];
o.style.position="absolute";
o.style.display="block";
o.style.visibility="hidden";
if($telerik.getComputedStyle(n,j[0],null)===null){j=k;
}for(var l=0,m=j.length;
l<m;
l++){o.style[k[l]]=$telerik.getComputedStyle(n,j[l],null);
}return o;
},_getNextItem:function(l){var k=a(this.get_itemsContainer()).children("li:visible"),i=a(this._activeElement),j;
if(i.length===0||!i.is(":visible")){j=(l==1)?k.first(":visible"):k.last(":visible");
}else{j=(l==1)?i.nextAll(":visible").first():i.prevAll(":visible").first();
}if(j.length!==0){return j[0]._item;
}return null;
}};
b.RadAutoCompleteBox.DropDown.registerClass("Telerik.Web.UI.RadAutoCompleteBox.DropDown");
})(Telerik.Web.UI,$telerik.$);
(function(b,a){b.RadAutoCompleteBox.DropDownItem=function(c,d){this._text="";
this._value="";
this._template=null;
this._element=null;
this._attributes=null;
this._load(c,d);
};
b.RadAutoCompleteBox.DropDownItem.prototype={_load:function(c,d){if(d){if(typeof(c[d.dataTextField])!="undefined"){this._text=c[d.dataTextField];
}if(typeof(c[d.dataValueField])!="undefined"&&c.Value!==""){this._value=c[d.dataValueField];
}}else{this._text=c.text||c.Text;
this._value=c.value||c.Value;
}if(c.Attributes){this.get_attributes()._load(c.Attributes);
}},_renderBegingTag:function(c){c[c.length]="<li class='racItem";
if(this._renderedClientTemplate){c[c.length]=" racTemplate";
}c[c.length]="'>";
},_renderBody:function(c){if(this._renderedClientTemplate){c[c.length]=this._renderedClientTemplate;
}else{c[c.length]=this.get_text();
}},_renderEndTag:function(c){c[c.length]="</li>";
},_setElement:function(c){this._element=c;
},dispose:function(){this._element._item=null;
this._element=null;
},render:function(){if(!this._element){var c=[];
this._renderBegingTag(c);
this._renderBody(c);
this._renderEndTag(c);
this._element=a(c.join("")).get(0);
}this._element._item=this;
return this._element;
},get_text:function(){return this._text;
},get_value:function(){return this._value;
},get_attributes:function(){if(!this._attributes){this._attributes=new b.AutoCompleteBoxAttributeCollection(this);
}return this._attributes;
},set_highlight:function(c){a(this._element).toggleClass("racItemHovered",c);
},get_element:function(){return this._element;
},ensureVisible:function(c){if(!this._getIsVisible()){this.scrollIntoView(c);
}},_getIsVisible:function(){var d=this.get_element(),e=this._getScrollableElement(),f=d.offsetTop,c=f+d.offsetHeight;
return f>=e.scrollTop&&(c-e.scrollTop)<=e.offsetHeight;
},_getScrollableElement:function(){return this.get_element().parentNode;
},scrollIntoView:function(c){var d=this.get_element(),f=d.offsetTop,e=this._getScrollableElement();
if(c){f+=d.offsetHeight-e.offsetHeight;
}e.scrollTop=f;
},get_clientTemplate:function(){return null;
}};
b.RadAutoCompleteBox.DropDownItem.registerClass("Telerik.Web.UI.RadAutoCompleteBox.DropDownItem");
})(Telerik.Web.UI,$telerik.$);
(function(b,a){Type.registerNamespace("Telerik.Web.UI");
b.AutoCompleteBoxEntryCollection=function(c){this._array=[];
this._owner=c;
};
b.AutoCompleteBoxEntryCollection.prototype={add:function(c){var d=this._owner;
this._add(c);
d._logChanges();
if(!d._isInTokenMode()&&d.get_allowCustomEntry()){d._updateText();
}},clear:function(){var c=this._owner;
this._array=[];
c._logChanges();
a(c.get_element()).find(".racToken, .racTextToken").remove();
if(!c._isInTokenMode()){c._updateText();
}c._toggleEmptyMessage();
},insert:function(d,c){Array.insert(this._array,d,c);
c.set_parent(this._owner);
},remove:function(c){var d=this._owner;
this._remove(c);
d._logChanges();
if(!d._isInTokenMode()&&d.get_allowCustomEntry()){d._updateText();
}d._toggleEmptyMessage();
},get_count:function(){return this._array.length;
},getEntry:function(c){return this._array[c];
},indexOf:function(c){for(var d=0,e=this._array.length;
d<e;
d++){if(this._array[d]===c){return d;
}}return -1;
},forEach:function(e){for(var d=0,c=this.get_count();
d<c;
d++){e(this._array[d]);
}},toArray:function(){return this._array.slice(0);
},_add:function(c){var f=this._owner,d=this._array.length,e=f._isInTokenMode();
if(e&&f._onEntryAdding(c)){f.get_inputElement().value="";
return;
}if(f._isInSingleSelectionMode()){this._array=[];
a(f.get_element()).find(".racTextToken").remove();
d=0;
}this.insert(d,c);
if(e){f._addToken(c);
f._onEntryAdded(c);
}else{if(!f.get_allowCustomEntry()){f._addTextToken(c);
}}},_remove:function(c){var e=this._owner,d=e._isInTokenMode();
if(d&&e._onEntryRemoving(c)){return;
}Array.remove(this._array,c);
c.set_parent(null);
c._control=null;
if(d){e._removeToken(c);
e._onEntryRemoved(c);
}else{if(!e.get_allowCustomEntry()){e._removeTextToken(c);
}}}};
b.AutoCompleteBoxEntryCollection.registerClass("Telerik.Web.UI.AutoCompleteBoxEntryCollection");
})(Telerik.Web.UI,$telerik.$);
(function(b,a){Type.registerNamespace("Telerik.Web.UI");
b.AutoCompleteBoxEntry=function(){b.AutoCompleteBoxEntry.initializeBase(this);
this._parent=null;
this._itemData={};
this._text="";
this._value="";
this._tokenElement=null;
this._attributes=null;
};
b.AutoCompleteBoxEntry.prototype={_initialize:function(c,d){this._parent=d;
this._loadItemData(c);
},_loadItemData:function(c){if(typeof(c.text)!="undefined"){this._setText(c.text);
}if(typeof(c.value)!="undefined"&&c.value!==""){this.set_value(c.value);
}if(c.attributes){this.get_attributes()._load(c.attributes);
}},_getEncodedText:function(){return $telerik.htmlEncode(this.get_text());
},_renderToken:function(){var c=[];
var d="p-icon p-i-close";
c[c.length]="<span class='racToken'>";
c[c.length]=this._getEncodedText();
c[c.length]="<a class='racRemoveTokenLink' title='"+this._parent._removeTokenTitle+"'>";
c[c.length]="<span class='"+d+"'></span>";
c[c.length]="</a>";
c[c.length]="</span>";
return c.join("");
},_renderTextToken:function(){var c=[],d=this._parent;
c[c.length]="<span class='racTextToken'>";
c[c.length]=this._getEncodedText();
if(!d._isInSingleSelectionMode()){c[c.length]=d.get_delimiter().charAt(0);
}c[c.length]=" </span>";
return c.join("");
},get_attributes:function(){if(!this._attributes){this._attributes=new b.AutoCompleteBoxAttributeCollection(this);
}return this._attributes;
},get_index:function(){if(!this.get_parent()){return -1;
}return this.get_parent()._getChildren().indexOf(this);
},get_text:function(){var c="",d=this._text;
return typeof d==="undefined"?c:d;
},set_text:function(g){if(typeof g!=="string"||g===""){return;
}this._setText(g);
if(!this.get_token()){return;
}var e=a(this.get_token());
var d=this._parent;
var f=this._getEncodedText();
var c=e.find(".racRemoveTokenLink")[0].outerHTML;
if(!d._isInTokenMode()&&!d._isInSingleSelectionMode()){f+=d.get_delimiter().charAt(0);
}e.html(f);
if(c.length){e.append(c);
}},_setText:function(c){this._text=c;
},_getData:function(){var c={text:this.get_text(),value:this.get_value()};
if(this.get_attributes().get_count()>0){c.attributes=this.get_attributes()._data;
}return c;
},_getHierarchicalIndex:function(){return this.get_index();
},_setSelected:function(d){var c=this.get_token();
if(c){a(c).toggleClass("racFocused",d);
}}};
a.registerControlProperties(b.AutoCompleteBoxEntry,{token:null,parent:null,value:""});
b.AutoCompleteBoxEntry.registerClass("Telerik.Web.UI.AutoCompleteBoxEntry");
})(Telerik.Web.UI,$telerik.$);
if(typeof(Sys)!=='undefined')Sys.Application.notifyScriptLoaded();