Type.registerNamespace("Telerik.Web.UI.Spell");
(function(){var a=$telerik.$;
var b=Telerik.Web.UI;
var c=function(d){return d&&d.nodeName=="A";
};
b.Spell.SpellDialog=function(d){b.Spell.SpellDialog.initializeBase(this,[d]);
this._clientParameters=null;
this._spell=null;
this._modeChangedHandler=null;
this._suggestionsDblClickHandler=null;
this._spellProcessor=null;
this._contentDisplay=null;
this._windowClosingDelegate=null;
};
b.Spell.SpellDialog.prototype={initialize:function(){b.Spell.SpellDialog.callBaseMethod(this,"initialize");
this.initChildControls();
},dispose:function(){if(this._contentDisplay){this._contentDisplay.remove_modeChanged(this._modeChangedHandler);
this._modeChangedHandler=null;
this._contentDisplay.remove_suggestionsDblClick(this._suggestionsDblClickHandler);
this._suggestionsDblClickHandler=null;
}this._windowClosingDelegate=null;
b.Spell.SpellDialog.callBaseMethod(this,"dispose");
},clientInit:function(e){this._suggestions.disabled=false;
this._suggestions.options.length=0;
this._suggestions.disabled=true;
this.enableButton(this._cancel);
this._getChildElement("TextContainer").innerHTML="";
this._clientParameters=e;
this._spell=this._clientParameters.spell;
this._textSource=this._clientParameters.textSource;
if(!this._textSource||!this._textSource.get_text){alert("This textsource does not support the get_text() method.");
return;
}var g=b.Dialogs.CommonDialogScript.get_windowReference();
var d=g.BrowserWindow;
this._origFn=d.Function._validateParams;
try{d.Function._validateParams=new d.Function();
}catch(f){}Sys.Application.add_unload(Function.createDelegate(this,this.restoreFrameworkCode));
this._windowClosingDelegate=Function.createDelegate(this,this.prepareClose);
g.add_close(this._windowClosingDelegate);
this._textToCheck=this.escapeNewLines(this._textSource.get_text());
if(this._clientParameters.dictionaryLanguage){this.get_service().set_language(this._clientParameters.dictionaryLanguage);
}this.get_service().spellCheck(this._textToCheck);
},initChildControls:function(){var d=b.Dialogs.CommonDialogScript.get_windowReference();
d.set_title(this.get_localization().Title);
this._suggestions=this._getChildElement("Suggestions");
this._formDecorator=this._findChildControl("spellDecorator");
this._ignore=this.getConfiguredButton("Ignore",this.ignoreHandler);
this._ignoreAll=this.getConfiguredButton("IgnoreAll",this.ignoreAllHandler);
this._addCustom=this.getConfiguredButton("AddCustom",this.addCustomHandler);
this._change=this.getConfiguredButton("Change",this.changeHandler);
this._changeAll=this.getConfiguredButton("ChangeAll",this.changeAllHandler);
this._undo=this.getConfiguredButton("Undo",this.undoHandler);
this._cancel=this.getConfiguredButton("Cancel",this.cancelHandler);
},ignoreHandler:function(d){if(this._contentDisplay.get_editMode()){this._contentDisplay.switchMode();
}else{this._spellProcessor.ignore();
this.raiseOnClientWordIgnoredEvent(false);
this.moveForward();
}return $telerik.cancelRawEvent(d);
},ignoreAllHandler:function(d){if(this._ignoreAll.disabled){return $telerik.cancelRawEvent(d);
}this._spellProcessor.ignoreAll();
this.raiseOnClientWordIgnoredEvent(true);
this.moveForward();
return $telerik.cancelRawEvent(d);
},addCustomHandler:function(f){if(this._addCustom.disabled){return $telerik.cancelRawEvent(f);
}var d=this._spellProcessor.currentBadWord().wordString;
if(!this.confirm(this.get_localization()["AddWord1"]+d+this.get_localization()["AddWord2"])){return $telerik.cancelRawEvent(f);
}this.disableAllButtons();
this.get_service().addCustomWord(d);
return $telerik.cancelRawEvent(f);
},changeHandler:function(d){if(this._change.disabled){return $telerik.cancelRawEvent(d);
}this.changeCurrentWord(this._contentDisplay.replacementWord());
return $telerik.cancelRawEvent(d);
},changeAllHandler:function(d){if(this._changeAll.disabled){return $telerik.cancelRawEvent(d);
}if(this._spellProcessor.allWordsFixed()){return $telerik.cancelRawEvent(d);
}this._spellProcessor.changeAll(this._contentDisplay.replacementWord());
this.raiseOnClientWordCorrectedEvent(true);
this.moveForward();
return $telerik.cancelRawEvent(d);
},undoHandler:function(d){if(this._undo.disabled){return $telerik.cancelRawEvent(d);
}var f=this._spellProcessor.lastActionBadWordStartCharOffsets();
this._spellProcessor.undo();
this.raiseOnClientActionUndoneEvent(f);
this.processCurrentStep();
return $telerik.cancelRawEvent(d);
},cancelHandler:function(d){if(this._cancel.disabled){return $telerik.cancelRawEvent(d);
}this.closeDialog(this._spellProcessor&&this._spellProcessor.textChanged()&&this.confirm(this.get_localization()["Confirm"]));
return $telerik.cancelRawEvent(d);
},confirm:function(d){return window.confirm(d);
},disableButton:function(d){b.RadFormDecorator.set_enabled(d,false);
var e=d.parentNode;
if(c(e)){e.setAttribute("tabindex","-1");
e.setAttribute("disabled","disabled");
}},enableButton:function(d){b.RadFormDecorator.set_enabled(d,true);
var e=d.parentNode;
if(c(e)){e.removeAttribute("tabindex");
e.removeAttribute("disabled");
}},setButtonEnabled:function(d,e){if(e){this.enableButton(d);
}else{this.disableButton(d);
}},getConfiguredButton:function(e,f){var d=this._getChildElement(e);
if(d){$addHandlers(d,{click:f},this);
d.disabled=true;
}return d;
},get_service:function(){if(this._service==null){this._service=$create(b.SpellCheckService,null,null,null);
this._service.set_configuration(this.get_serviceConfiguration());
this._service.set_url(this.get_serviceUrl());
this._service.add_complete(Function.createDelegate(this,this.spellCheckResponseReceived));
}return this._service;
},changeCurrentWord:function(d){if(this._spellProcessor.allWordsFixed()){return;
}this._spellProcessor.change(d);
this.raiseOnClientWordCorrectedEvent(false);
this.moveForward();
},moveForward:function(){this._spellProcessor.moveToNextWord();
this.processCurrentStep();
},processCurrentStep:function(){if(!this._spellProcessor.allWordsFixed()){this.updateContent();
}else{this.closeDialog(true);
}},restoreFrameworkCode:function(){if(null!=this._origFn){var e=b.Dialogs.CommonDialogScript.get_windowReference();
if(e){var d=e.BrowserWindow;
d.Function._validateParams=this._origFn;
}this._origFn=null;
}},prepareClose:function(d){if(null!=this._windowClosingDelegate){var e=b.Dialogs.CommonDialogScript.get_windowReference();
e.remove_close(this._windowClosingDelegate);
this._windowClosingDelegate=null;
this.restoreFrameworkCode();
}this.disableAllButtons();
this.raiseDialogClosingEvents();
if(this._spellProcessor){if(this._spellProcessor.allWordsFixed()){this._spell.set_spellChecked(true);
}if(d){this.applyChanges();
}this._spellProcessor=null;
}},closeDialog:function(d){this.prepareClose(d);
this._spell.raiseEvent("clientDialogClosing",Sys.EventArgs.Empty);
b.Dialogs.CommonDialogScript.get_windowReference().close();
},spellCheckResponseReceived:function(g,d){if(d.AddCustomWord){var e=this._spellProcessor.currentBadWord().wordString;
this._spellProcessor.processCustomWordAddition();
this.raiseOnClientCustomWordAddedEvent(e);
this.processCurrentStep();
this.enableButton(this._cancel);
}else{var f={textToCheck:this._textToCheck,badWords:d.badWords,wordOffsets:d.wordOffsets};
this._spellProcessor=$create(b.Spell.SpellProcessor,f,null,null);
if(!this._spellProcessor.allWordsFixed()){this.initContentDisplay();
this.updateContent();
this._contentDisplay.get_textContainer().focus();
}else{this.closeDialog(true);
}}},escapeNewLines:function(e){var d=e.replace(/\n/gi,"&nbsp;<telerikcr />");
d=d.replace(/\r/gi,"<teleriklf />");
return d;
},unEscapeNewLines:function(e){var d=e.replace(/(&nbsp;)?<telerikcr\s*\/>/gi,"\n");
d=d.replace(/<teleriklf\s*\/>/gi,"\r");
return d;
},updateContent:function(){var d=this._contentDisplay;
if(d.get_editMode()){d.switchMode();
}d.showText(this._spellProcessor.currentErrorContent());
this.focusCurrentError();
d.fillSuggestions(this._spellProcessor.currentSuggestions());
this.updateButtonStates();
},focusCurrentError:function(){var e=document.getElementById(this._spellProcessor.highlightedElementId());
var d=this._contentDisplay;
if(e&&!d.get_editMode()){var f=function(){if(e&&e.parentNode){var g=e.offsetTop-($telerik.isIE?0:2*e.offsetHeight);
d.get_textContainer().scrollTop=g;
e.focus();
}};
if($telerik.isIE){window.setTimeout(f,0);
}else{f();
}}},disableAllButtons:function(){this.disableButton(this._ignore);
this.disableButton(this._ignoreAll);
this.disableButton(this._change);
this.disableButton(this._changeAll);
this.disableButton(this._undo);
this.disableButton(this._cancel);
if(this._addCustom){this.disableButton(this._addCustom);
}},initContentDisplay:function(){this._modeChangedHandler=Function.createDelegate(this,this.contentDisplay_modeChanged);
this._suggestionsDblClickHandler=Function.createDelegate(this,this.contentDisplay_suggestionsDblClick);
var e={localization:this.get_localization(),textContainer:this._getChildElement("TextContainer"),textEditor:this._getChildElement("TextEditor"),suggestions:this._suggestions,formDecorator:this._formDecorator};
var d={modeChanged:this._modeChangedHandler,suggestionsDblClick:this._suggestionsDblClickHandler};
if(!this._contentDisplay){this._contentDisplay=$create(b.Spell.ContentDisplay,e,d,null);
}this._contentDisplay.focus();
},updateButtonStates:function(){var d=this._spellProcessor.currentSuggestions().length>0;
this.enableButton(this._ignore);
this.setButtonEnabled(this._ignoreAll,!this._contentDisplay.get_editMode());
this.setButtonEnabled(this._undo,this._spellProcessor.currentUndoAction()!=null);
this.setButtonEnabled(this._change,this._contentDisplay.get_editMode()||d);
this.setButtonEnabled(this._changeAll,!this._contentDisplay.get_editMode()&&d);
if(this._addCustom!=null){this.setButtonEnabled(this._addCustom,!this._contentDisplay.get_editMode());
}this._ignore.innerHTML=this._contentDisplay.get_editMode()?this.get_localization()["UndoEdit"]:this.get_localization()["Ignore"];
},contentDisplay_modeChanged:function(f,d){if(d.acceptChange){return this.changeCurrentWord(d.acceptChange);
}var e="";
if(d.editMode){e=this._spellProcessor.currentBadWord().wordString;
}else{e=this._spellProcessor.currentErrorContent();
}this.updateButtonStates();
this._contentDisplay.showText(e);
this.focusCurrentError();
},contentDisplay_suggestionsDblClick:function(d,e){if(this._spellProcessor.currentSuggestions().length>0){this.changeCurrentWord(e.selectedValue);
}else{alert(this.get_localization()["Nosuggestions"]);
}},applyChanges:function(){this._textSource.set_text(this.unEscapeNewLines(this._spellProcessor.get_textToCheck()));
},raiseDialogClosingEvents:function(){if(this._spellProcessor&&this._spellProcessor.allWordsFixed()){var e=false;
var d={suppressCompleteMessage:function(f){e=f;
}};
this._spell.raiseEvent("clientCheckFinished",d);
if(!e){alert(this.get_localization()["SpellCheckComplete"]);
}}else{this._spell.raiseEvent("clientCheckCancelled",Sys.EventArgs.Empty);
}},raiseOnClientWordCorrectedEvent:function(e){var f=this._spellProcessor.currentBadWord();
var d={originalWord:f.originalWordString,newWord:f.wordString,offsets:this._spellProcessor.lastActionBadWordStartCharOffsets(),changeAll:e};
this._spell.raiseEvent("clientWordCorrected",d);
},raiseOnClientWordIgnoredEvent:function(e){var f=this._spellProcessor.currentBadWord();
var d={ignoreWord:f.originalWordString,offsets:this._spellProcessor.lastActionBadWordStartCharOffsets(),ignoreAll:e};
this._spell.raiseEvent("clientWordIgnored",d);
},raiseOnClientActionUndoneEvent:function(e){var f=this._spellProcessor.currentBadWord();
var d={originalWord:f.originalWordString,offsets:e};
this._spell.raiseEvent("clientActionUndone",d);
},raiseOnClientCustomWordAddedEvent:function(e){var d={customWord:e};
this._spell.raiseEvent("clientCustomWordAdded",d);
}};
a.registerControlProperties(b.Spell.SpellDialog,{serviceConfiguration:null,serviceUrl:null,localization:{}});
b.Spell.SpellDialog.registerClass("Telerik.Web.UI.Spell.SpellDialog",b.RadWebControl,Telerik.Web.IParameterConsumer);
a.registerEnum(b.Spell,"SpellProcessorActions",{Change:0,ChangeAll:1,Ignore:2,IgnoreAll:4,AddCustom:8});
b.Spell.SpellProcessor=function(){b.Spell.SpellProcessor.initializeBase(this);
this._undoActions=[];
this._surroundingWordsCount=10;
};
b.Spell.SpellProcessor.prototype={initialize:function(){b.Spell.SpellProcessor.callBaseMethod(this,"initialize");
},dispose:function(){b.Spell.SpellProcessor.callBaseMethod(this,"dispose");
},moveToNextWord:function(){var d=this.nextBadWordIndex();
if(d<0){return;
}this.set_currentBadWordIndex(d);
},moveToPreviousWord:function(){this.set_currentBadWordIndex(this.nextBadWordIndex(0));
},nextBadWordIndex:function(e){if(typeof(e)=="undefined"){e=this.get_currentBadWordIndex();
}for(var d=e;
d<this.get_badWords().length;
d++){if(this.getBadWord(d).originalWordString==null){return d;
}}return -1;
},allWordsFixed:function(){return this.nextBadWordIndex()<0;
},currentErrorContent:function(){var d=this.currentBadWord();
return this.startString(this.get_currentBadWordIndex(),true)+"<a style='border-bottom: 1px dotted red;font-weight: bold;' id="+this.highlightedElementId()+">"+d.wordString+"</a>"+this.endString(this.get_currentBadWordIndex(),true);
},highlightedElementId:function(){return"spell_highlight_"+this.currentBadWord().wordString;
},startString:function(d,e){var g=0;
var f=this.getBadWord(d);
if(e&&(f.textOffset>this._surroundingWordsCount)){var h=f.textOffset-this._surroundingWordsCount;
g=this.get_wordOffsets()[h];
}return this.get_textToCheck().substring(g,this.wordStartCharIndex(d));
},endString:function(d,e){var g=this.get_textToCheck().length;
var f=this.getBadWord(d);
if(e&&(this.get_wordOffsets().length>f.textOffset+this._surroundingWordsCount)){var h=f.textOffset+this._surroundingWordsCount;
g=this.get_wordOffsets()[h];
}return this.get_textToCheck().substring(this.wordEndCharIndex(d),g);
},wordStartCharIndex:function(d){return this.get_wordOffsets()[this.wordOffset(d)];
},wordEndCharIndex:function(d){return this.wordStartCharIndex(d)+this.getBadWord(d).wordString.length;
},getBadWord:function(d){return this.get_badWords()[d];
},currentBadWord:function(){return this.getBadWord(this.get_currentBadWordIndex());
},wordOffset:function(d){return this.getBadWord(d).textOffset;
},currentWordOffset:function(){return this.currentBadWord().textOffset;
},currentSuggestions:function(){return this.currentBadWord().suggestionsString;
},ignore:function(){this.changeWord(this.currentBadWord().wordString,b.Spell.SpellProcessorActions.Ignore);
},ignoreAll:function(){this.changeAllWords(this.currentBadWord().wordString,b.Spell.SpellProcessorActions.IgnoreAll);
},change:function(d){this.changeWord(d,b.Spell.SpellProcessorActions.Change);
},changeAll:function(d){this.changeAllWords(d,b.Spell.SpellProcessorActions.ChangeAll);
},processCustomWordAddition:function(){var f=this.sameWordStringBadWordIndexes();
for(var e=f.length-1;
e>=0;
e--){var d=f[e];
this.get_badWords().splice(d,1);
}this.moveToNextWord();
},changeWord:function(f,e){var d=[this.get_currentBadWordIndex()];
this.processChange(d,f,false,e);
this.registerUndoStep(d);
},changeAllWords:function(f,e){var d=this.sameWordStringBadWordIndexes();
this.processChange(d,f,false,e);
this.registerUndoStep(d);
},changeText:function(d,e){this.set_textToCheck(this.startString(d,false)+e+this.endString(d,false));
},offsetsByBadWordIndexes:function(d){var f=[];
for(var e=0;
e<d.length;
e++){f[f.length]=this.wordOffset(d[e]);
}return f;
},lastActionBadWordOffsets:function(){var d=this.currentUndoAction();
return this.offsetsByBadWordIndexes(d);
},lastActionBadWordStartCharOffsets:function(){var f=[];
var d=this.lastActionBadWordOffsets();
for(var e=0;
e<d.length;
e++){f[f.length]=this.get_wordOffsets()[d[e]];
}return f;
},sameWordStringBadWordIndexes:function(){var e=this.currentBadWord().wordString;
var f=[this.get_currentBadWordIndex()];
for(var d=this.get_currentBadWordIndex()+1;
d<this.get_badWords().length;
d++){if(this.getBadWord(d).wordString==e){f[f.length]=d;
}}return f;
},undo:function(){var d=this.currentUndoAction();
var e=this.getBadWord(d[0]).originalWordString;
this.processChange(d,e,true);
this.unregisterUndoStep();
this.moveToPreviousWord();
},correctWord:function(d,f,e){if(this.getBadWord(d).originalWordString){return;
}var g=this.getBadWord(d);
g.originalWordString=g.wordString;
g.wordString=f;
g.correctionAction=e;
},restoreWord:function(d){var e=this.getBadWord(d);
e.wordString=e.originalWordString;
e.originalWordString=null;
e.correctionAction=null;
},processChange:function(e,l,k,f){for(var j=0;
j<e.length;
j++){var g=e[j];
var d=this.getBadWord(g);
var h=l.length-d.wordString.length;
this.adjustOffsetsAfterChangedWord(d,h);
this.changeText(g,l);
if(k){this.restoreWord(g);
}else{this.correctWord(g,l,f);
}}},adjustOffsetsAfterChangedWord:function(d,e){for(var f=d.textOffset+1;
f<this.get_wordOffsets().length;
f++){this.get_wordOffsets()[f]+=e;
}},currentUndoAction:function(){if(this._undoActions.length==0){return null;
}return this._undoActions[this._undoActions.length-1];
},registerUndoStep:function(d){this._undoActions[this._undoActions.length]=d;
},unregisterUndoStep:function(){this._undoActions=this._undoActions.slice(0,-1);
},textChanged:function(){for(var e=0;
e<this.get_currentBadWordIndex();
e++){var d=this.getBadWord(e).correctionAction;
if(d==b.Spell.SpellProcessorActions.Change||d==b.Spell.SpellProcessorActions.ChangeAll){return true;
}}return false;
}};
a.registerControlProperties(b.Spell.SpellProcessor,{currentBadWordIndex:0,textToCheck:null,badWords:null,wordOffsets:null});
b.Spell.SpellProcessor.registerClass("Telerik.Web.UI.Spell.SpellProcessor",Sys.Component);
b.Spell.ContentDisplay=function(){b.Spell.ContentDisplay.initializeBase(this);
};
b.Spell.ContentDisplay.prototype={initialize:function(){b.Spell.ContentDisplay.callBaseMethod(this,"initialize");
this.attachEventHandlers();
this.get_suggestions().disabled=false;
},attachEventHandlers:function(){this.attachSuggestionsHandlers();
$addHandlers(this.get_textContainer(),{click:this.switchMode,keydown:this._contentKeyHandler},this);
$addHandlers(this.get_textEditor(),{keydown:this._textEditorKeyHandler},this);
},attachSuggestionsHandlers:function(){var d=this.getSuggestionUI();
this._attachSuggestionsHandlersToNode(d);
},_attachSuggestionsHandlersToNode:function(d){d&&$addHandlers(d,{dblclick:this.suggestionsDblClick,keydown:this._suggestionsKeyHandler},this);
},dispose:function(){var d=this.getSuggestionUI();
d&&$clearHandlers(d);
$clearHandlers(this.get_suggestions());
$clearHandlers(this.get_textContainer());
$clearHandlers(this.get_textEditor());
this.set_textContainer(null);
this.set_textEditor(null);
this.set_suggestions(null);
this.set_localization(null);
b.Spell.ContentDisplay.callBaseMethod(this,"dispose");
},showText:function(e){if(this.get_editMode()){this.get_textEditor().value=e;
}else{try{this.get_textContainer().innerHTML=e;
}catch(d){e=e.replace(/<\/?form[^>]*>/gi,"");
this.get_textContainer().innerHTML=e;
}}},focus:function(){if(this.get_editMode()){this.get_textEditor().focus();
}else{if(this.get_suggestions().disabled){this.get_suggestions().disabled=false;
}this.get_suggestions().focus();
}},switchMode:function(g){var f=g||{};
var e=!this.get_editMode();
var i=this.get_textEditor();
var d=this.get_textContainer();
var h=this.getSuggestionUI();
this.set_editMode(e);
if(e){d.style.display="none";
h.tabIndex="-1";
i.style.display="block";
i.focus();
}else{i.style.display="none";
h.tabIndex="2";
d.style.display="";
d.focus();
}this.get_suggestions().disabled=e;
this.raiseEvent("modeChanged",{editMode:this.get_editMode(),acceptChange:f.acceptChange});
},replacementWord:function(){if(this.get_editMode()){return this.get_textEditor().value;
}else{return this.selectedSuggestion();
}},selectedSuggestion:function(){return this.get_suggestions().options[this.get_suggestions().selectedIndex].value;
},fillSuggestions:function(e){this.clearSuggestions();
if(e.length>0){for(var d=0;
d<e.length;
d++){this.addSuggestion(e[d]);
}}else{this.addSuggestion(this.get_localization()["Nosuggestions"]);
}this.get_suggestions().selectedIndex=0;
this.updateSuggestionsSelect();
},updateSuggestionsSelect:function(){var d=this.get_suggestions();
this.get_formDecorator().updateSelect(d);
this._attachSuggestionsHandlersToNode(b.RadFormDecorator.getDecoratedElement(d));
},clearSuggestions:function(){this.get_suggestions().options.length=0;
},addSuggestion:function(d){this.get_suggestions().options[this.get_suggestions().options.length]=new Option(d,d);
},getSuggestionUI:function(){return b.RadFormDecorator.getDecoratedElement(this.get_suggestions())||this.get_suggestions();
},suggestionsDblClick:function(){this.raiseEvent("suggestionsDblClick",{selectedValue:this.selectedSuggestion()});
var d=this.getSuggestionUI();
d.focus();
},_contentKeyHandler:function(d){var g=d.rawEvent;
var f=g.which||g.keyCode;
if(f===Sys.UI.Key.enter){this.switchMode();
$telerik.cancelRawEvent(g);
}},_textEditorKeyHandler:function(d){var g=d.rawEvent;
var f=g.which||g.keyCode;
if(f===Sys.UI.Key.enter){this.switchMode({acceptChange:this.get_textEditor().value});
$telerik.cancelRawEvent(g);
}else{if(f===Sys.UI.Key.esc){this.switchMode();
$telerik.cancelRawEvent(g);
}}},_suggestionsKeyHandler:function(d){var g=d.rawEvent;
var f=g.which||g.keyCode;
if(f===Sys.UI.Key.enter||f===Sys.UI.Key.space){this.suggestionsDblClick();
$telerik.cancelRawEvent(g);
}},raiseEvent:function(e,d){var f=this.get_events().getHandler(e);
if(f){if(!d){d=Sys.EventArgs.Empty;
}f(this,d);
}}};
a.registerControlProperties(b.Spell.ContentDisplay,{localization:null,suggestions:null,formDecorator:null,textContainer:null,editMode:false,textEditor:null});
a.registerControlEvents(b.Spell.ContentDisplay,["suggestionsDblClick","modeChanged"]);
b.Spell.ContentDisplay.registerClass("Telerik.Web.UI.Spell.ContentDisplay",Sys.Component);
})();
if(typeof(Sys)!=='undefined')Sys.Application.notifyScriptLoaded();