(function(b,a){a("util/text-metrics",["kendo.core"],b);
}(function(){(function(a){window.kendo.util=window.kendo.util||{};
var e=kendo.Class.extend({init:function(j){this._size=j;
this._length=0;
this._map={};
},put:function(k,m){var l=this._map;
var j={key:k,value:m};
l[k]=j;
if(!this._head){this._head=this._tail=j;
}else{this._tail.newer=j;
j.older=this._tail;
this._tail=j;
}if(this._length>=this._size){l[this._head.key]=null;
this._head=this._head.newer;
this._head.older=null;
}else{this._length++;
}},get:function(k){var j=this._map[k];
if(j){if(j===this._head&&j!==this._tail){this._head=j.newer;
this._head.older=null;
}if(j!==this._tail){if(j.older){j.older.newer=j.newer;
j.newer.older=j.older;
}j.older=this._tail;
j.newer=null;
this._tail.newer=j;
this._tail=j;
}return j.value;
}}});
function g(k){var l=[];
for(var j in k){l.push(j+k[j]);
}return l.sort().join("");
}function d(l){var j=2166136261;
for(var k=0;
k<l.length;
++k){j+=(j<<1)+(j<<4)+(j<<7)+(j<<8)+(j<<24);
j^=l.charCodeAt(k);
}return j>>>0;
}function i(){return{width:0,height:0,baseline:0};
}var b={baselineMarkerSize:1};
var c;
if(typeof document!=="undefined"){c=document.createElement("div");
c.style.cssText="position: absolute !important; top: -4000px !important; width: auto !important; height: auto !important;padding: 0 !important; margin: 0 !important; border: 0 !important;line-height: normal !important; visibility: hidden !important; white-space: nowrap!important;";
}var h=kendo.Class.extend({init:function(j){this._cache=new e(1000);
this.options=a.extend({},b,j);
},measure:function(s,q,k){if(!s){return i();
}var r=g(q);
var m=d(s+r);
var l=this._cache.get(m);
if(l){return l;
}var p=i();
var o=k||c;
var j=this._baselineMarker().cloneNode(false);
for(var n in q){var t=q[n];
if(typeof t!=="undefined"){o.style[n]=t;
}}o.textContent=s;
o.appendChild(j);
document.body.appendChild(o);
if(String(s).length){p.width=o.offsetWidth-this.options.baselineMarkerSize;
p.height=o.offsetHeight;
p.baseline=j.offsetTop+this.options.baselineMarkerSize;
}if(p.width>0&&p.height>0){this._cache.put(m,p);
}o.parentNode.removeChild(o);
return p;
},_baselineMarker:function(){var j=document.createElement("div");
j.style.cssText="display: inline-block; vertical-align: baseline;width: "+this.options.baselineMarkerSize+"px; height: "+this.options.baselineMarkerSize+"px;overflow: hidden;";
return j;
}});
h.current=new h();
function f(l,k,j){return h.current.measure(l,k,j);
}kendo.deepExtend(kendo.util,{LRUCache:e,TextMetrics:h,measureText:f,objectKey:g,hashKey:d});
}(window.kendo.jQuery));
},typeof define=="function"&&define.amd?define:function(a,b,c){(c||b)();
}));
(function(b,a){a("kendo.gantt",["kendo.data","kendo.popup","kendo.window","kendo.resizable","kendo.gantt.list","kendo.gantt.timeline","kendo.grid","kendo.pdf"],b);
}(function(){var a={id:"gantt",name:"Gantt",category:"web",description:"The Gantt component.",depends:["data","popup","resizable","window","gantt.list","gantt.timeline","grid"]};
(function(b,ah){var H=window.kendo;
var aa="matchMedia" in window;
var f=H.support.browser;
var K=H.support.mobileOS;
var M=H.Observable;
var aj=H.ui.Widget;
var k=H.data.DataSource;
var O=H.data.ObservableObject;
var N=H.data.ObservableArray;
var U=H.data.Query;
var E=b.isArray;
var D=b.inArray;
var F=H.isFunction;
var T=b.proxy;
var u=b.extend;
var G=b.isPlainObject;
var J=b.map;
var Q=H._outerWidth;
var P=H._outerHeight;
var I=H.keys;
var o=3;
var L=".kendoGantt";
var R="p0";
var ab="tabIndex";
var h="click";
var ak="width";
var Z="string";
var q={down:{origin:"bottom left",position:"top left"},up:{origin:"top left",position:"bottom left"}};
var e="aria-activedescendant";
var c="gantt_active_cell";
var d="action-option-focused";
var r=".";
var ac="Are you sure you want to delete this task?";
var p="Are you sure you want to delete this dependency?";
var af=H.template('<button class="#=styles.buttonToggle#" type="button"><span class="#=styles.iconToggle#"></span></button>');
var g='<button class="#=styles.button# #=className#" type="button" #if (action) {#data-action="#=action#"#}#><span class="#=iconClass#"></span><span>#=text#</span></button>';
var i='<a class="#=className#" #=attr# href="\\#">#=text#</a>';
var ai=H.template('<li class="#=styles.currentView# #=styles.viewButtonDefault#"><a href="\\#" class="#=styles.link#">&nbps;</a></li>');
var C=H.template('<ul class="#=styles.viewsWrapper#">#for(var view in views){#<li class="#=styles.viewButtonDefault# #=styles.viewButton#-#= view.toLowerCase() #" data-#=ns#name="#=view#"><a href="\\#" class="#=styles.link#">#=views[view].title#</a></li>#}#</ul>');
var ad=H.template('<div class="#=styles.popupWrapper#"><ul class="#=styles.popupList#" role="listbox">#for(var i = 0, l = actions.length; i < l; i++){#<li class="#=styles.item#" data-action="#=actions[i].data#" role="option">#=actions[i].text#</span>#}#</ul></div>');
var m=function(am,an){var al={name:an.field};
var ao=an.model.fields[an.field].validation;
if(ao&&G(ao)&&ao.message){al[H.attr("dateCompare-msg")]=ao.message;
}b('<input type="text" required '+H.attr("type")+'="date" '+H.attr("role")+'="datetimepicker" '+H.attr("bind")+'="value:'+an.field+'" '+H.attr("validate")+"='true' />").attr(al).appendTo(am);
b("<span "+H.attr("for")+'="'+an.field+'" class="k-invalid-msg"/>').hide().appendTo(am);
};
var W=function(al,am){b('<a href="#" class="'+am.styles.button+'">'+am.messages.assignButton+"</a>").click(am.click).appendTo(al);
};
var A={wrapper:"k-widget k-gantt",rowHeight:"k-gantt-rowheight",listWrapper:"k-gantt-layout k-gantt-treelist",list:"k-gantt-treelist",timelineWrapper:"k-gantt-layout k-gantt-timeline",timeline:"k-gantt-timeline",splitBarWrapper:"k-splitbar k-state-default k-splitbar-horizontal k-splitbar-draggable-horizontal k-gantt-layout",splitBar:"k-splitbar",splitBarHover:"k-splitbar-horizontal-hover",popupWrapper:"k-list-container",popupList:"k-list k-reset",resizeHandle:"k-resize-handle",icon:"k-icon",item:"k-item",line:"k-line",buttonDelete:"k-gantt-delete",buttonCancel:"k-gantt-cancel",buttonSave:"k-gantt-update",buttonToggle:"k-gantt-toggle",primary:"k-primary",hovered:"k-state-hover",selected:"k-state-selected",focused:"k-state-focused",gridHeader:"k-grid-header",gridHeaderWrap:"k-grid-header-wrap",gridContent:"k-grid-content",popup:{form:"k-popup-edit-form",editForm:"k-gantt-edit-form",formContainer:"k-edit-form-container",resourcesFormContainer:"k-resources-form-container",message:"k-popup-message",buttonsContainer:"k-edit-buttons k-state-default",button:"k-button",editField:"k-edit-field",editLabel:"k-edit-label",resourcesField:"k-gantt-resources"},toolbar:{headerWrapper:"k-floatwrap k-header k-gantt-toolbar",footerWrapper:"k-floatwrap k-header k-gantt-toolbar",toolbar:"k-gantt-toolbar",expanded:"k-state-expanded",views:"k-gantt-views",viewsWrapper:"k-reset k-header k-gantt-views",actions:"k-gantt-actions",button:"k-button k-button-icontext",buttonToggle:"k-button k-button-icon k-gantt-toggle",iconPlus:"k-icon k-i-plus",iconPdf:"k-icon k-i-file-pdf",iconToggle:"k-icon k-i-layout-1-by-4",viewButtonDefault:"k-state-default",viewButton:"k-view",currentView:"k-current-view",link:"k-link",pdfButton:"k-gantt-pdf",appendButton:"k-gantt-create"}};
function Y(al){return"["+H.attr("uid")+(al?"='"+al+"']":"]");
}function ag(al){delete al.name;
delete al.prefix;
delete al.remove;
delete al.edit;
delete al.add;
delete al.navigate;
return al;
}function l(ap){if(ap.filter("[name=end], [name=start]").length){var ao=ap.attr("name");
var ar=H.widgetInstance(ap,H.ui);
var am={};
var al=ap;
var an;
var aq;
while(al!==window&&!an){al=al.parent();
an=al.data("kendoEditable");
}aq=an?an.options.model:null;
if(!aq){return true;
}am.start=aq.start;
am.end=aq.end;
am[ao]=ar?ar.value():H.parseDate(ap.value());
return am.start<=am.end;
}return true;
}function v(ap,al){var aq=ap.parents("["+H.attr("role")+'="gantt"]');
var ao=[];
var an=X(aq);
ap.attr(ab,0);
if(al){an.each(function(ar,at){ao[ar]=b(at).scrollTop();
});
}try{ap[0].setActive();
}catch(am){ap[0].focus();
}if(al){an.each(function(ar,at){b(at).scrollTop(ao[ar]);
});
}}function X(al){return b(al).parentsUntil("body").filter(function(ao,an){var am=H.getComputedStyles(an,["overflow"]);
return am.overflow!="visible";
}).add(window);
}var n;
var ae=M.extend({init:function(al,am){M.fn.init.call(this);
this.element=al;
this.options=u(true,{},this.options,am);
this._popup();
},options:{direction:"down",navigatable:false},_current:function(an){var am=w.styles;
var al=this.list.find(r+am.focused);
var ao=al[an]();
if(ao.length){al.removeClass(am.focused).removeAttr("id");
ao.addClass(am.focused).attr("id",d);
this.list.find("ul").removeAttr(e).attr(e,d);
}},_popup:function(){var aq=this;
var an=w.styles;
var ao="li"+r+an.item;
var am=r+an.toolbar.appendButton;
var al=this.options.messages.actions;
var ap=this.options.navigatable;
this.list=b(ad({styles:an,actions:[{data:"add",text:al.addChild},{data:"insert-before",text:al.insertBefore},{data:"insert-after",text:al.insertAfter}]}));
this.element.append(this.list);
this.popup=new H.ui.Popup(this.list,u({anchor:this.element.find(am),open:function(){aq._adjustListWidth();
},animation:this.options.animation},q[this.options.direction]));
this.element.on(h+L,am,function(at){var au=b(this);
var ar=au.attr(H.attr("action"));
at.preventDefault();
if(ar){aq.trigger("command",{type:ar});
}else{aq.popup.open();
if(ap){aq.list.find("li:first").addClass(an.focused).attr("id",d).end().find("ul").attr({TABINDEX:0,"aria-activedescendant":d}).focus();
}}});
this.list.find(ao).hover(function(){b(this).addClass(an.hovered);
},function(){b(this).removeClass(an.hovered);
}).end().on(h+L,ao,function(){aq.trigger("command",{type:b(this).attr(H.attr("action"))});
aq.popup.close();
});
if(ap){this.popup.bind("close",function(){aq.list.find(ao).removeClass(an.focused).end().find("ul").attr(ab,0);
aq.element.parents("["+H.attr("role")+'="gantt"]').find(r+an.gridContent+" > table:first").focus();
});
this.list.find("ul").on("keydown"+L,function(ar){var at=ar.keyCode;
switch(at){case I.UP:ar.preventDefault();
aq._current("prev");
break;
case I.DOWN:ar.preventDefault();
aq._current("next");
break;
case I.ENTER:aq.list.find(r+an.focused).click();
break;
case I.ESC:ar.preventDefault();
aq.popup.close();
break;
}});
}},_adjustListWidth:function(){var ao=this.list;
var an=w.styles;
var aq=ao[0].style.width;
var ar=this.element.find(r+an.toolbar.appendButton);
var ap=Q(ao);
var al;
var am;
if(!ao.data(ak)&&aq){return;
}al=window.getComputedStyle?window.getComputedStyle(ar[0],null):0;
am=al?parseFloat(al.width):Q(ar);
if(al&&(f.mozilla||f.msie)){am+=parseFloat(al.paddingLeft)+parseFloat(al.paddingRight)+parseFloat(al.borderLeftWidth)+parseFloat(al.borderRightWidth);
}if(ao.css("box-sizing")!=="border-box"){aq=am-(Q(ao)-ao.width());
}else{aq=am;
}if(ap>aq){aq=ap;
}ao.css({fontFamily:ar.css("font-family"),width:aq}).data(ak,aq);
},destroy:function(){clearTimeout(this._focusTimeout);
this.popup.destroy();
this.element.off(L);
this.list.off(L);
this.unbind();
}});
var j=function(am,al){return function(ap){ap=E(ap)?{data:ap}:ap;
var ao=ap||{};
var an=ao.data;
ao.data=an;
if(!(ao instanceof am)&&ao instanceof k){throw new Error("Incorrect DataSource type. Only "+al+" instances are supported");
}return ao instanceof am?ao:new am(ao);
};
};
var y=H.data.Model.define({id:"id",fields:{id:{type:"number"},predecessorId:{type:"number"},successorId:{type:"number"},type:{type:"number"}}});
var z=k.extend({init:function(al){k.fn.init.call(this,u(true,{},{schema:{modelBase:y,model:y}},al));
},successors:function(al){return this._dependencies("predecessorId",al);
},predecessors:function(al){return this._dependencies("successorId",al);
},dependencies:function(al){var am=this.predecessors(al);
var an=this.successors(al);
am.push.apply(am,an);
return am;
},_dependencies:function(am,ao){var al=this.view();
var an={field:am,operator:"eq",value:ao};
al=new U(al).filter(an).toArray();
return al;
}});
z.create=j(z,"GanttDependencyDataSource");
var B=H.data.Model.define({duration:function(){var al=this.end;
var am=this.start;
return al-am;
},isMilestone:function(){return this.duration()===0;
},_offset:function(ao){var al=["start","end"];
var an;
for(var am=0;
am<al.length;
am++){an=new Date(this.get(al[am]).getTime()+ao);
this.set(al[am],an);
}},id:"id",fields:{id:{type:"number"},parentId:{type:"number",defaultValue:null,validation:{required:true}},orderId:{type:"number",validation:{required:true}},title:{type:"string",defaultValue:"New task"},start:{type:"date",validation:{required:true}},end:{type:"date",validation:{required:true,dateCompare:l,message:"End date should be after or equal to the start date"}},percentComplete:{type:"number",validation:{required:true,min:0,max:1,step:0.01}},summary:{type:"boolean"},expanded:{type:"boolean",defaultValue:true}}});
var x=k.extend({init:function(al){k.fn.init.call(this,u(true,{},{schema:{modelBase:B,model:B}},al));
},remove:function(an){var am=an.get("parentId");
var al=this.taskAllChildren(an);
this._removeItems(al);
an=k.fn.remove.call(this,an);
this._childRemoved(am,an.get("orderId"));
return an;
},add:function(al){if(!al){return;
}al=this._toGanttTask(al);
return this.insert(this.taskSiblings(al).length,al);
},insert:function(al,am){if(!am){return;
}am=this._toGanttTask(am);
am.set("orderId",al);
am=k.fn.insert.call(this,al,am);
this._reorderSiblings(am,this.taskSiblings(am).length-1);
this._resolveSummaryFields(this.taskParent(am));
return am;
},taskChildren:function(ao){var al=this.view();
var am={field:"parentId",operator:"eq",value:null};
var an=this._sort&&this._sort.length?this._sort:{field:"orderId",dir:"asc"};
var ap;
if(!!ao){ap=ao.get("id");
if(ap===ah||ap===null||ap===""){return[];
}am.value=ap;
}al=new U(al).filter(am).sort(an).toArray();
return al;
},taskAllChildren:function(an){var am=[];
var ao=this;
var al=function(ap){var aq=ao.taskChildren(ap);
am.push.apply(am,aq);
J(aq,al);
};
if(!!an){al(an);
}else{am=this.view();
}return am;
},taskSiblings:function(am){if(!am){return null;
}var al=this.taskParent(am);
return this.taskChildren(al);
},taskParent:function(al){if(!al||al.get("parentId")===null){return null;
}return this.get(al.parentId);
},taskLevel:function(an){var al=0;
var am=this.taskParent(an);
while(am!==null){al+=1;
am=this.taskParent(am);
}return al;
},taskTree:function(aq){var an=[];
var am;
var ar=this.taskChildren(aq);
for(var ao=0,ap=ar.length;
ao<ap;
ao++){am=ar[ao];
an.push(am);
if(am.get("expanded")){var al=this.taskTree(am);
an.push.apply(an,al);
}}return an;
},update:function(ap,aq){var ar=this;
var ao;
var an=function(ax,aw){var at=ar.taskAllChildren(ax);
for(var au=0,av=at.length;
au<av;
au++){at[au]._offset(aw);
}};
var am=function(at){var au=at.field;
var av=at.sender;
switch(au){case"start":ar._resolveSummaryStart(ar.taskParent(av));
an(av,av.get(au).getTime()-ao.getTime());
break;
case"end":ar._resolveSummaryEnd(ar.taskParent(av));
break;
case"percentComplete":ar._resolveSummaryPercentComplete(ar.taskParent(av));
break;
case"orderId":ar._reorderSiblings(av,ao);
break;
}};
if(aq.parentId!==ah){ao=ap.get("parentId");
if(ao!==aq.parentId){ap.set("parentId",aq.parentId);
ar._childRemoved(ao,ap.get("orderId"));
ap.set("orderId",ar.taskSiblings(ap).length-1);
ar._resolveSummaryFields(ar.taskParent(ap));
}delete aq.parentId;
}ap.bind("change",am);
for(var al in aq){ao=ap.get(al);
ap.set(al,aq[al]);
}ap.unbind("change",am);
},_resolveSummaryFields:function(al){if(!al){return;
}this._updateSummary(al);
if(!this.taskChildren(al).length){return;
}this._resolveSummaryStart(al);
this._resolveSummaryEnd(al);
this._resolveSummaryPercentComplete(al);
},_resolveSummaryStart:function(am){var an=this;
var al=function(au){var ao=an.taskChildren(au);
var at=ao[0].start.getTime();
var ap;
for(var aq=1,ar=ao.length;
aq<ar;
aq++){ap=ao[aq].start.getTime();
if(ap<at){at=ap;
}}return new Date(at);
};
this._updateSummaryRecursive(am,"start",al);
},_resolveSummaryEnd:function(am){var an=this;
var al=function(au){var ao=an.taskChildren(au);
var at=ao[0].end.getTime();
var ap;
for(var aq=1,ar=ao.length;
aq<ar;
aq++){ap=ao[aq].end.getTime();
if(ap>at){at=ap;
}}return new Date(at);
};
this._updateSummaryRecursive(am,"end",al);
},_resolveSummaryPercentComplete:function(am){var an=this;
var al=function(ap){var ao=an.taskChildren(ap);
var aq=new U(ao).aggregate([{field:"percentComplete",aggregate:"average"}]);
return aq.percentComplete.average;
};
this._updateSummaryRecursive(am,"percentComplete",al);
},_updateSummaryRecursive:function(ao,am,al){if(!ao){return;
}var ap=al(ao);
ao.set(am,ap);
var an=this.taskParent(ao);
if(an){this._updateSummaryRecursive(an,am,al);
}},_childRemoved:function(aq,an){var ap=aq===null?null:this.get(aq);
var al=this.taskChildren(ap);
for(var am=an,ao=al.length;
am<ao;
am++){al[am].set("orderId",am);
}this._resolveSummaryFields(ap);
},_reorderSiblings:function(au,ap){var aq=au.get("orderId");
var al=aq>ap;
var at=al?ap:aq;
var am=al?aq:ap;
var ao=al?at:at+1;
var ar=this.taskSiblings(au);
am=Math.min(am,ar.length-1);
for(var an=at;
an<=am;
an++){if(ar[an]===au){continue;
}ar[an].set("orderId",ao);
ao+=1;
}},_updateSummary:function(am){if(am!==null){var al=this.taskChildren(am).length;
am.set("summary",al>0);
}},_toGanttTask:function(al){if(!(al instanceof B)){var am=al;
al=this._createNewModel();
al.accept(am);
}return al;
}});
x.create=j(x,"GanttDataSource");
u(true,H.data,{GanttDataSource:x,GanttTask:B,GanttDependencyDataSource:z,GanttDependency:y});
var t={desktop:{dateRange:m,resources:W}};
var s=H.Observable.extend({init:function(al,am){H.Observable.fn.init.call(this);
this.element=al;
this.options=u(true,{},this.options,am);
this.createButton=this.options.createButton;
},fields:function(am,ap){var at=this;
var aq=this.options;
var ao=aq.messages.editor;
var ar=aq.resources;
var an;
var al=function(au){au.preventDefault();
ar.editor(at.container.find(r+w.styles.popup.resourcesField),ap);
};
if(aq.editable.template){an=b.map(ap.fields,function(av,au){return{field:au};
});
}else{an=[{field:"title",title:ao.title},{field:"start",title:ao.start,editor:am.dateRange},{field:"end",title:ao.end,editor:am.dateRange},{field:"percentComplete",title:ao.percentComplete,format:R}];
if(ap.get(ar.field)){an.push({field:ar.field,title:ao.resources,messages:ao,editor:am.resources,click:al,styles:w.styles.popup});
}}return an;
},_buildEditTemplate:function(ar,an,al){var av=this.options.resources;
var ax=this.options.editable.template;
var aw=u({},H.Template,this.options.templateSettings);
var at=aw.paramName;
var au=w.styles.popup;
var ao="";
if(ax){if(typeof ax===Z){ax=window.unescape(ax);
}ao+=H.template(ax,aw)(ar);
}else{for(var ap=0,aq=an.length;
ap<aq;
ap++){var am=an[ap];
ao+='<div class="'+au.editLabel+'"><label for="'+am.field+'">'+(am.title||am.field||"")+"</label></div>";
if(am.field===av.field){ao+='<div class="'+au.resourcesField+'" style="display:none"></div>';
}if(!ar.editable||ar.editable(am.field)){al.push(am);
ao+="<div "+H.attr("container-for")+'="'+am.field+'" class="'+au.editField+'"></div>';
}else{var ay="#:";
if(am.field){am=H.expr(am.field,at);
ay+=am+"==null?'':"+am;
}else{ay+="''";
}ay+="#";
ay=H.template(ay,aw);
ao+='<div class="'+au.editField+'">'+ay(ar)+"</div>";
}}}return ao;
}});
var S=s.extend({destroy:function(){this.close();
this.unbind();
},editTask:function(al){this.editable=this._createPopupEditor(al);
},close:function(){var am=this;
var al=function(){if(am.editable){am.editable.destroy();
am.editable=null;
am.container=null;
}if(am.popup){am.popup.destroy();
am.popup=null;
}};
if(this.editable&&this.container.is(":visible")){am.trigger("close",{window:am.container});
this.container.data("kendoWindow").bind("deactivate",al).close();
}else{al();
}},showDialog:function(ap){var al=ap.buttons;
var ar=w.styles.popup;
var am=H.format('<div class="{0}"><div class="{1}"><p class="{2}">{3}</p><div class="{4}">',ar.form,ar.formContainer,ar.message,ap.text,ar.buttonsContainer);
for(var an=0,ao=al.length;
an<ao;
an++){am+=this.createButton(al[an]);
}am+="</div></div></div>";
var at=this.element;
if(this.popup){this.popup.destroy();
}var aq=this.popup=b(am).appendTo(at).eq(0).on("click",r+ar.button,function(av){av.preventDefault();
aq.close();
var au=b(av.currentTarget).index();
al[au].click();
}).kendoWindow({modal:true,resizable:false,draggable:false,title:ap.title,visible:false,deactivate:function(){this.destroy();
at.focus();
}}).getKendoWindow();
aq.center().open();
},_createPopupEditor:function(av){var aw=this;
var at={};
var ar=this.options.messages;
var ap=w.styles;
var au=ap.popup;
var aq=H.format('<div {0}="{1}" class="{2} {3}"><div class="{4}">',H.attr("uid"),av.uid,au.form,au.editForm,au.formContainer);
var ao=this.fields(t.desktop,av);
var am=[];
aq+=this._buildEditTemplate(av,ao,am);
aq+='<div class="'+au.buttonsContainer+'">';
aq+=this.createButton({name:"update",text:ar.save,className:w.styles.primary});
aq+=this.createButton({name:"cancel",text:ar.cancel});
if(aw.options.editable.destroy!==false){aq+=this.createButton({name:"delete",text:ar.destroy});
}aq+="</div></div></div>";
var al=this.container=b(aq).appendTo(this.element).eq(0).kendoWindow(u({modal:true,resizable:false,draggable:true,title:ar.editor.editorTitle,visible:false,close:function(ax){if(ax.userTriggered){if(aw.trigger("cancel",{container:al,model:av})){ax.preventDefault();
}}}},at));
var an=al.kendoEditable({fields:am,model:av,clearContainer:false,validateOnBlur:true,target:aw.options.target}).data("kendoEditable");
H.cycleForm(al);
if(!this.trigger("edit",{container:al,model:av})){al.data("kendoWindow").center().open();
al.on(h+L,r+ap.buttonCancel,function(ax){ax.preventDefault();
ax.stopPropagation();
aw.trigger("cancel",{container:al,model:av});
});
al.on(h+L,r+ap.buttonSave,function(ax){ax.preventDefault();
ax.stopPropagation();
var az=aw.fields(t.desktop,av);
var aC={};
var ay;
for(var aA=0,aB=az.length;
aA<aB;
aA++){ay=az[aA].field;
aC[ay]=av.get(ay);
}aw.trigger("save",{container:al,model:av,updateInfo:aC});
});
al.on(h+L,r+ap.buttonDelete,function(ax){ax.preventDefault();
ax.stopPropagation();
aw.trigger("remove",{container:al,model:av});
});
}else{aw.trigger("cancel",{container:al,model:av});
}return an;
}});
var V=aj.extend({init:function(al,am){aj.fn.init.call(this,al,am);
this.wrapper=this.element;
this.model=this.options.model;
this.resourcesField=this.options.resourcesField;
this.createButton=this.options.createButton;
this._initContainer();
this._attachHandlers();
},events:["save"],open:function(){this.window.center().open();
},close:function(){this.window.bind("deactivate",T(this.destroy,this)).close();
},destroy:function(){this._dettachHandlers();
this.grid.destroy();
this.grid=null;
this.window.destroy();
this.window=null;
aj.fn.destroy.call(this);
H.destroy(this.wrapper);
this.element=this.wrapper=null;
},_attachHandlers:function(){var am=w.styles;
var an=this.grid;
var al=this._cancelProxy=T(this._cancel,this);
this.container.on(h+L,r+am.buttonCancel,this._cancelProxy);
this._saveProxy=T(this._save,this);
this.container.on(h+L,r+am.buttonSave,this._saveProxy);
this.window.bind("close",function(ao){if(ao.userTriggered){al(ao);
}});
an.wrapper.on(h+L,"input[type='checkbox']",function(){var ao=b(this);
var aq=b(ao).closest("tr");
var ap=an.dataSource.getByUid(aq.attr(H.attr("uid")));
var ar=b(ao).is(":checked")?1:"";
ap.set("value",ar);
});
},_dettachHandlers:function(){this._cancelProxy=null;
this._saveProxy=null;
this.container.off(L);
this.grid.wrapper.off();
},_cancel:function(al){al.preventDefault();
this.close();
},_save:function(al){al.preventDefault();
this._updateModel();
if(!this.wrapper.is(r+w.styles.popup.resourcesField)){this.trigger("save",{container:this.wrapper,model:this.model});
}this.close();
},_initContainer:function(){var an=this;
var am=w.styles.popup;
var al=H.format('<div class="{0} {1}"><div class="{2} {3}"/></div>"',am.form,am.editForm,am.formContainer,am.resourcesFormContainer);
al=b(al);
this.container=al.find(r+am.resourcesFormContainer);
this.window=al.kendoWindow({modal:true,resizable:false,draggable:true,visible:false,title:this.options.messages.resourcesEditorTitle,open:function(){an.grid.resize(true);
}}).data("kendoWindow");
this._resourceGrid();
this._createButtons();
},_resourceGrid:function(){var an=this;
var am=this.options.messages;
var al=b('<div id="resources-grid"/>').appendTo(this.container);
this.grid=new H.ui.Grid(al,{columns:[{field:"name",title:am.resourcesHeader,template:"<label><input type='checkbox' value='#=name#'# if (value > 0 && value !== null) {#checked='checked'# } #/>#=name#</labe>"},{field:"value",title:am.unitsHeader,template:function(ao){var aq=ao.format;
var ap=ao.value!==null?ao.value:"";
return aq?H.toString(ap,aq):ap;
}}],height:280,sortable:true,editable:true,filterable:true,dataSource:{data:an.options.data,schema:{model:{id:"id",fields:{id:{from:"id"},name:{from:"name",type:"string",editable:false},value:{from:"value",type:"number",defaultValue:""},format:{from:"format",type:"string"}}}}},save:function(ao){var ap=!!ao.values.value;
ao.container.parent().find("input[type='checkbox']").prop("checked",ap);
}});
},_createButtons:function(){var al=this.options.buttons;
var am='<div class="'+w.styles.popup.buttonsContainer+'">';
for(var an=0,ao=al.length;
an<ao;
an++){am+=this.createButton(al[an]);
}am+="</div>";
this.container.append(am);
},_updateModel:function(){var ao=[];
var ap;
var al=this.grid.dataSource.data();
for(var am=0,an=al.length;
am<an;
am++){ap=al[am].get("value");
if(ap!==null&&ap>0){ao.push(al[am]);
}}this.model[this.resourcesField]=ao;
}});
var w=aj.extend({init:function(al,an,am){if(E(an)){an={dataSource:an};
}n={append:{text:"Add Task",action:"add",className:w.styles.toolbar.appendButton,iconClass:w.styles.toolbar.iconPlus},pdf:{text:"Export to PDF",className:w.styles.toolbar.pdfButton,iconClass:w.styles.toolbar.iconPdf}};
aj.fn.init.call(this,al,an);
if(am){this._events=am;
}this._wrapper();
this._resources();
if(!this.options.views||!this.options.views.length){this.options.views=["day","week","month"];
}this._timeline();
this._toolbar();
this._footer();
this._adjustDimensions();
this._preventRefresh=true;
this.view(this.timeline._selectedViewName);
this._preventRefresh=false;
this._dataSource();
this._assignments();
this._dropDowns();
this._list();
this._dependencies();
this._resizable();
this._scrollable();
this._dataBind();
this._attachEvents();
this._createEditor();
H.notify(this);
},events:["dataBinding","dataBound","add","edit","remove","cancel","save","change","navigate","moveStart","move","moveEnd","resizeStart","resize","resizeEnd","columnResize"],options:{name:"Gantt",autoBind:true,navigatable:false,selectable:true,editable:true,resizable:false,columnResizeHandleWidth:o,columns:[],views:[],dataSource:{},dependencies:{},resources:{},assignments:{},taskTemplate:null,messages:{save:"Save",cancel:"Cancel",destroy:"Delete",deleteTaskConfirmation:ac,deleteDependencyConfirmation:p,deleteTaskWindowTitle:"Delete task",deleteDependencyWindowTitle:"Delete dependency",views:{day:"Day",week:"Week",month:"Month",year:"Year",start:"Start",end:"End"},actions:{append:"Add Task",addChild:"Add Child",insertBefore:"Add Above",insertAfter:"Add Below",pdf:"Export to PDF"},editor:{editorTitle:"Task",resourcesEditorTitle:"Resources",title:"Title",start:"Start",end:"End",percentComplete:"Complete",resources:"Resources",assignButton:"Assign",resourcesHeader:"Resources",unitsHeader:"Units"}},showWorkHours:true,showWorkDays:true,toolbar:null,workDayStart:new Date(1980,1,1,8,0,0),workDayEnd:new Date(1980,1,1,17,0,0),workWeekStart:1,workWeekEnd:5,hourSpan:1,snap:true,height:600,listWidth:"30%",rowHeight:null},select:function(am){var al=this.list;
if(!am){return al.select();
}al.select(am);
return;
},clearSelection:function(){this.list.clearSelection();
},destroy:function(){aj.fn.destroy.call(this);
if(this.dataSource){this.dataSource.unbind("change",this._refreshHandler);
this.dataSource.unbind("progress",this._progressHandler);
this.dataSource.unbind("error",this._errorHandler);
}if(this.dependencies){this.dependencies.unbind("change",this._dependencyRefreshHandler);
this.dependencies.unbind("error",this._dependencyErrorHandler);
}if(this.timeline){this.timeline.unbind();
this.timeline.destroy();
}if(this.list){this.list.unbind();
this.list.destroy();
}if(this.footerDropDown){this.footerDropDown.destroy();
}if(this.headerDropDown){this.headerDropDown.destroy();
}if(this._editor){this._editor.destroy();
}if(this._resizeDraggable){this._resizeDraggable.destroy();
}this.toolbar.off(L);
if(aa){this._mediaQuery.removeListener(this._mediaQueryHandler);
this._mediaQuery=null;
}b(window).off("resize"+L,this._resizeHandler);
b(this.wrapper).off(L);
this.toolbar=null;
this.footer=null;
},setOptions:function(an){var am=H.deepExtend({},this.options,an);
var al=this._events;
if(!an.views){var ao=this.view().name;
am.views=b.map(this.options.views,function(ar){var ap=G(ar);
var aq=ap?typeof ar.type!=="string"?ar.title:ar.type:ar;
if(ao===aq){if(ap){ar.selected=true;
}else{ar={type:aq,selected:true};
}}else{if(ap){ar.selected=false;
}}return ar;
});
}if(!an.dataSource){am.dataSource=this.dataSource;
}if(!an.dependencies){am.dependencies=this.dependencies;
}if(!an.resources){am.resources=this.resources;
}if(!an.assignments){am.assignments=this.assignments;
}this.destroy();
this.element.empty();
this.options=null;
this.init(this.element,am,al);
aj.fn._setEvents.call(this,am);
},_attachEvents:function(){this._resizeHandler=T(this.resize,this,false);
b(window).on("resize"+L,this._resizeHandler);
},_wrapper:function(){var al=w.styles;
var ao=[al.icon,al.resizeHandle].join(" ");
var an=this.options;
var am=an.height;
var ap=an.width;
this.wrapper=this.element.addClass(al.wrapper).append("<div class='"+al.listWrapper+"'><div></div></div>").append("<div class='"+al.splitBarWrapper+"'><div class='"+ao+"'></div></div>").append("<div class='"+al.timelineWrapper+"'><div></div></div>");
this.wrapper.find(r+al.list).width(an.listWidth);
if(am){this.wrapper.height(am);
}if(ap){this.wrapper.width(ap);
}if(an.rowHeight){this.wrapper.addClass(al.rowHeight);
}},_toolbar:function(){var at=this;
var ao=w.styles;
var aA=r+ao.toolbar.views+" > li";
var ar=r+ao.toolbar.pdfButton;
var aw=r+ao.buttonToggle;
var an=r+ao.gridContent;
var ay=b(r+ao.list);
var au=b(r+ao.timeline);
var aq=ao.hovered;
var al=this.options.toolbar;
var am=b("<div class='"+ao.toolbar.actions+"'>");
var ax;
var az;
var av;
var ap=function(aB){if(aB.matches){ay.css({display:"none","max-width":0});
}else{ay.css({display:"inline-block",width:"30%","max-width":"none"});
au.css("display","inline-block");
at.refresh();
au.find(an).scrollTop(at.scrollTop);
}at._resize();
};
if(!F(al)){al=typeof al===Z?al:this._actions(al);
al=T(H.template(al),this);
}av=b(af({styles:ao.toolbar}));
az=b(C({ns:H.ns,views:this.timeline.views,styles:ao.toolbar}));
am.append(al({}));
ax=b("<div class='"+ao.toolbar.headerWrapper+"'>").append(av).append(az).append(am);
if(az.find("li").length>1){az.prepend(ai({styles:ao.toolbar}));
}this.wrapper.prepend(ax);
this.toolbar=ax;
if(aa){this._mediaQueryHandler=T(ap,this);
this._mediaQuery=window.matchMedia("(max-width: 480px)");
this._mediaQuery.addListener(this._mediaQueryHandler);
}ax.on(h+L,aA,function(aC){aC.preventDefault();
var aD=at.list;
var aE=b(this).attr(H.attr("name"));
var aB=az.find(r+ao.toolbar.currentView);
if(aB.is(":visible")){aB.parent().toggleClass(ao.toolbar.expanded);
}if(aD.editable&&aD.editable.trigger("validate")){return;
}if(!at.trigger("navigate",{view:aE})){at.view(aE);
}}).on(h+L,ar,function(aB){aB.preventDefault();
at.saveAsPDF();
}).on(h+L,aw,function(aB){aB.preventDefault();
if(ay.is(":visible")){ay.css({display:"none",width:"0"});
au.css({display:"inline-block",width:"100%"});
at.refresh();
au.find(an).scrollTop(at.scrollTop);
}else{au.css({display:"none",width:0});
ay.css({display:"inline-block",width:"100%","max-width":"none"}).find(an).scrollTop(at.scrollTop);
}at._resize();
});
this.wrapper.find(r+ao.toolbar.toolbar+" li").hover(function(){b(this).addClass(aq);
},function(){b(this).removeClass(aq);
});
},_actions:function(){var aq=this.options;
var am=aq.editable;
var al=aq.toolbar;
var an="";
if(!E(al)){if(am&&am.create!==false){al=["append"];
}else{return an;
}}for(var ao=0,ap=al.length;
ao<ap;
ao++){an+=this._createButton(al[ao]);
}return an;
},_footer:function(){var an=this.options.editable;
if(!an||an.create===false){return;
}var ap=w.styles.toolbar;
var aq=this.options.messages.actions;
var am=b(H.template(g)(u(true,{styles:ap},n.append,{text:aq.append})));
var al=b("<div class='"+ap.actions+"'>").append(am);
var ao=b("<div class='"+ap.footerWrapper+"'>").append(al);
this.wrapper.append(ao);
this.footer=ao;
},_createButton:function(am){var aq=am.template||g;
var ao=this.options.messages.actions;
var an=typeof am===Z?am:am.name||am.text;
var al=n[an]?n[an].className:"k-gantt-"+(an||"").replace(/\s/g,"");
var ap={iconClass:"",action:"",text:an,className:al,styles:w.styles.toolbar};
if(!an&&!(G(am)&&am.template)){throw new Error("Custom commands should have name specified");
}ap=u(true,ap,n[an],{text:ao[an]});
if(G(am)){if(am.className&&D(ap.className,am.className.split(" "))<0){am.className+=" "+ap.className;
}ap=u(true,ap,am);
}return H.template(aq)(ap);
},_adjustDimensions:function(){var al=this.element;
var an=w.styles;
var ao=r+an.list;
var ar=r+an.timeline;
var ap=r+an.splitBar;
var at=P(this.toolbar);
var am=this.footer?P(this.footer):0;
var au=al.height();
var av=al.width();
var aq=Q(al.find(ap));
var aw=Q(al.find(ao));
al.children([ao,ar,ap].join(",")).height(au-(at+am)).end().children(ar).width(av-(aq+aw));
if(av<aw+aq){al.find(ao).width(av-aq);
}},_scrollTo:function(ar){var at=this.timeline.view();
var ao=this.list;
var am=H.attr("uid");
var an=typeof ar==="string"?ar:ar.closest("tr"+Y()).attr(am);
var al;
var aq;
var ap=function(){if(aq.length!==0){al();
}};
if(at.content.is(":visible")){aq=at.content.find(Y(an));
al=function(){at._scrollTo(aq);
};
}else{aq=ao.content.find(Y(an));
al=function(){aq.get(0).scrollIntoView();
};
}ap();
},_dropDowns:function(){var ap=this;
var am=r+w.styles.toolbar.actions;
var al=this.options.messages.actions;
var aq=this.timeline;
var an=this.options.editable;
var ao=function(at){var aB=at.type;
var aw;
var ar=ap.dataSource;
var aA=ar._createNewModel();
var ay=ap.dataItem(ap.select());
var ax=ar.taskParent(ay);
var av=aq.view()._timeSlots()[0];
var az=aB==="add"?ay:ax;
var au=ap.list.editable;
if(au&&au.trigger("validate")){return;
}aA.set("title","New task");
if(az){aA.set("parentId",az.get("id"));
aA.set("start",az.get("start"));
aA.set("end",az.get("end"));
}else{aA.set("start",av.start);
aA.set("end",av.end);
}if(aB!=="add"){aw=ay.get("orderId");
aw=aB==="insert-before"?aw:aw+1;
}ap._createTask(aA,aw);
};
if(!an||an.create===false){return;
}this.footerDropDown=new ae(this.footer.children(am).eq(0),{messages:{actions:al},direction:"up",animation:{open:{effects:"slideIn:up"}},navigatable:ap.options.navigatable});
this.headerDropDown=new ae(this.toolbar.children(am).eq(0),{messages:{actions:al},navigatable:ap.options.navigatable});
this.footerDropDown.bind("command",ao);
this.headerDropDown.bind("command",ao);
},_list:function(){var av=this;
var ar=av.options.navigatable;
var ao=w.styles;
var aq=this.wrapper.find(r+ao.list);
var an=aq.find("> div");
var aw=this.wrapper.find(r+ao.toolbar.actions+" > button");
var at={columns:this.options.columns||[],dataSource:this.dataSource,selectable:this.options.selectable,editable:this.options.editable,resizable:this.options.resizable,columnResizeHandleWidth:this.options.columnResizeHandleWidth,listWidth:Q(aq),resourcesField:this.resources.field,rowHeight:this.options.rowHeight};
var am=at.columns;
var al;
var au=function(){if(ar){av._current(av._cachedCurrent);
v(av.list.content.find("table"),true);
}delete av._cachedCurrent;
};
for(var ap=0;
ap<am.length;
ap++){al=am[ap];
if(al.field===this.resources.field&&typeof al.editor!=="function"){al.editor=T(this._createResourceEditor,this);
}}this.list=new H.ui.GanttList(an,at);
this.list.bind("render",function(){av._navigatable();
},true).bind("edit",function(ax){av._cachedCurrent=ax.cell;
if(av.trigger("edit",{task:ax.model,container:ax.cell})){ax.preventDefault();
}}).bind("cancel",function(ax){if(av.trigger("cancel",{task:ax.model,container:ax.cell})){ax.preventDefault();
}au();
}).bind("update",function(ax){av._updateTask(ax.task,ax.updateInfo);
au();
}).bind("change",function(){av.trigger("change");
var ax=av.list.select();
if(ax.length){aw.removeAttr("data-action","add");
av.timeline.select("[data-uid='"+ax.attr("data-uid")+"']");
}else{aw.attr("data-action","add");
av.timeline.clearSelection();
}}).bind("columnResize",function(ax){av.trigger("columnResize",{column:ax.column,oldWidth:ax.oldWidth,newWidth:ax.newWidth});
});
},_timeline:function(){var ap=this;
var an=w.styles;
var ao=ag(u(true,{resourcesField:this.resources.field},this.options));
var am=this.wrapper.find(r+an.timeline+" > div");
var al=r+an.toolbar.currentView+" > "+r+an.toolbar.link;
this.timeline=new H.ui.GanttTimeline(am,ao);
this.timeline.bind("navigate",function(aq){var at=aq.view.replace(/\./g,"\\.").toLowerCase();
var ar=ap.toolbar.find(r+an.toolbar.views+" > li").removeClass(an.selected).end().find(r+an.toolbar.viewButton+"-"+at).addClass(an.selected).find(r+an.toolbar.link).text();
ap.toolbar.find(al).text(ar);
ap.refresh();
}).bind("moveStart",function(aq){var ar=ap.list.editable;
if(ar&&ar.trigger("validate")){aq.preventDefault();
return;
}if(ap.trigger("moveStart",{task:aq.task})){aq.preventDefault();
}}).bind("move",function(aq){var au=aq.task;
var at=aq.start;
var ar=new Date(at.getTime()+au.duration());
if(ap.trigger("move",{task:au,start:at,end:ar})){aq.preventDefault();
}}).bind("moveEnd",function(aq){var au=aq.task;
var at=aq.start;
var ar=new Date(at.getTime()+au.duration());
if(!ap.trigger("moveEnd",{task:au,start:at,end:ar})){ap._updateTask(ap.dataSource.getByUid(au.uid),{start:at,end:ar});
}}).bind("resizeStart",function(aq){var ar=ap.list.editable;
if(ar&&ar.trigger("validate")){aq.preventDefault();
return;
}if(ap.trigger("resizeStart",{task:aq.task})){aq.preventDefault();
}}).bind("resize",function(aq){if(ap.trigger("resize",{task:aq.task,start:aq.start,end:aq.end})){aq.preventDefault();
}}).bind("resizeEnd",function(aq){var ar=aq.task;
var at={};
if(aq.resizeStart){at.start=aq.start;
}else{at.end=aq.end;
}if(!ap.trigger("resizeEnd",{task:ar,start:aq.start,end:aq.end})){ap._updateTask(ap.dataSource.getByUid(ar.uid),at);
}}).bind("percentResizeStart",function(aq){var ar=ap.list.editable;
if(ar&&ar.trigger("validate")){aq.preventDefault();
}}).bind("percentResizeEnd",function(aq){ap._updateTask(ap.dataSource.getByUid(aq.task.uid),{percentComplete:aq.percentComplete});
}).bind("dependencyDragStart",function(aq){var ar=ap.list.editable;
if(ar&&ar.trigger("validate")){aq.preventDefault();
}}).bind("dependencyDragEnd",function(ar){var aq=ap.dependencies._createNewModel({type:ar.type,predecessorId:ar.predecessor.id,successorId:ar.successor.id});
ap._createDependency(aq);
}).bind("select",function(aq){var ar=ap.list.editable;
if(ar){ar.trigger("validate");
}ap.select("[data-uid='"+aq.uid+"']");
}).bind("editTask",function(aq){var ar=ap.list.editable;
if(ar&&ar.trigger("validate")){return;
}ap.editTask(aq.uid);
}).bind("clear",function(){ap.clearSelection();
}).bind("removeTask",function(aq){var ar=ap.list.editable;
if(ar&&ar.trigger("validate")){return;
}ap.removeTask(ap.dataSource.getByUid(aq.uid));
}).bind("removeDependency",function(aq){var ar=ap.list.editable;
if(ar&&ar.trigger("validate")){return;
}ap.removeDependency(ap.dependencies.getByUid(aq.uid));
});
},_dataSource:function(){var am=this.options;
var al=am.dataSource;
al=E(al)?{data:al}:al;
if(this.dataSource&&this._refreshHandler){this.dataSource.unbind("change",this._refreshHandler).unbind("progress",this._progressHandler).unbind("error",this._errorHandler);
}else{this._refreshHandler=T(this.refresh,this);
this._progressHandler=T(this._requestStart,this);
this._errorHandler=T(this._error,this);
}this.dataSource=H.data.GanttDataSource.create(al).bind("change",this._refreshHandler).bind("progress",this._progressHandler).bind("error",this._errorHandler);
},_dependencies:function(){var am=this.options.dependencies||{};
var al=E(am)?{data:am}:am;
if(this.dependencies&&this._dependencyRefreshHandler){this.dependencies.unbind("change",this._dependencyRefreshHandler).unbind("error",this._dependencyErrorHandler);
}else{this._dependencyRefreshHandler=T(this.refreshDependencies,this);
this._dependencyErrorHandler=T(this._error,this);
}this.dependencies=H.data.GanttDependencyDataSource.create(al).bind("change",this._dependencyRefreshHandler).bind("error",this._dependencyErrorHandler);
},_resources:function(){var am=this.options.resources;
var al=am.dataSource||{};
this.resources={field:"resources",dataTextField:"name",dataColorField:"color",dataFormatField:"format"};
u(this.resources,am);
this.resources.dataSource=H.data.DataSource.create(al);
},_assignments:function(){var al=this.options.assignments;
var am=al.dataSource||{};
if(this.assignments){this.assignments.dataSource.unbind("change",this._assignmentsRefreshHandler);
}else{this._assignmentsRefreshHandler=T(this.refresh,this);
}this.assignments={dataTaskIdField:"taskId",dataResourceIdField:"resourceId",dataValueField:"value"};
u(this.assignments,al);
this.assignments.dataSource=H.data.DataSource.create(am);
this.assignments.dataSource.bind("change",this._assignmentsRefreshHandler);
},_createEditor:function(){var am=this;
var al=this._editor=new S(this.wrapper,u({},this.options,{target:this,resources:{field:this.resources.field,editor:T(this._createResourceEditor,this)},createButton:T(this._createPopupButton,this)}));
al.bind("cancel",function(an){var ao=am.dataSource.getByUid(an.model.uid);
if(am.trigger("cancel",{container:an.container,task:ao})){an.preventDefault();
return;
}am.cancelTask();
}).bind("edit",function(an){var ao=am.dataSource.getByUid(an.model.uid);
if(am.trigger("edit",{container:an.container,task:ao})){an.preventDefault();
}}).bind("save",function(an){var ao=am.dataSource.getByUid(an.model.uid);
am.saveTask(ao,an.updateInfo);
}).bind("remove",function(an){am.removeTask(an.model.uid);
}).bind("close",am._onDialogClose);
},_onDialogClose:function(){},_createResourceEditor:function(al,aq){var at=this;
var ap=aq instanceof O?aq:aq.model;
var an=ap.get("id");
var ao=this.options.messages;
var ar=at.resources.field;
var am=this._resourceEditor=new V(al,{resourcesField:ar,data:this._wrapResourceData(an),model:ap,messages:u({},ao.editor),buttons:[{name:"update",text:ao.save,className:w.styles.primary},{name:"cancel",text:ao.cancel}],createButton:T(this._createPopupButton,this),save:function(au){at._updateAssignments(au.model.get("id"),au.model.get(ar));
}});
am.open();
},_createPopupButton:function(al){var am=al.name||al.text;
var an={className:w.styles.popup.button+" k-gantt-"+(am||"").replace(/\s/g,""),text:am,attr:""};
if(!am&&!(G(al)&&al.template)){throw new Error("Custom commands should have name specified");
}if(G(al)){if(al.className){al.className+=" "+an.className;
}an=u(true,an,al);
}return H.template(i)(an);
},view:function(al){return this.timeline.view(al);
},range:function(am){var al=this.dataSource;
var ao=this.view();
var an=this.timeline;
if(am){ao.options.range={start:am.start,end:am.end};
an._render(al.taskTree());
an._renderDependencies(this.dependencies.view());
}return{start:ao.start,end:ao.end};
},date:function(al){var am=this.view();
if(al){am.options.date=al;
am._scrollToDate(al);
}return am.options.date;
},dataItem:function(an){if(!an){return null;
}var am=this.list;
var al=am.content.find(an);
return am._modelFromElement(al);
},setDataSource:function(al){this.options.dataSource=al;
this._dataSource();
this.list._setDataSource(this.dataSource);
if(this.options.autoBind){al.fetch();
}},setDependenciesDataSource:function(al){this.options.dependencies=al;
this._dependencies();
if(this.options.autoBind){al.fetch();
}},items:function(){return this.wrapper.children(".k-task");
},_updateAssignments:function(aq,ax){var an=this.assignments.dataSource;
var ay=this.assignments.dataTaskIdField;
var aw=this.assignments.dataResourceIdField;
var ao=false;
var am=new U(an.view()).filter({field:ay,operator:"eq",value:aq}).toArray();
var al;
var av;
var az;
while(am.length){al=am[0];
for(var ap=0,at=ax.length;
ap<at;
ap++){av=ax[ap];
if(al.get(aw)===av.get("id")){az=ax[ap].get("value");
this._updateAssignment(al,az);
ax.splice(ap,1);
ao=true;
break;
}}if(!ao){this._removeAssignment(al);
}ao=false;
am.shift();
}for(var ar=0,au=ax.length;
ar<au;
ar++){av=ax[ar];
this._createAssignment(av,aq);
}an.sync();
},cancelTask:function(){var am=this._editor;
var al=am.container;
if(al){am.close();
}},editTask:function(an){var al=typeof an==="string"?this.dataSource.getByUid(an):an;
if(!al){return;
}var am=this.dataSource._createNewModel(al.toJSON());
am.uid=al.uid;
this.cancelTask();
this._editTask(am);
},_editTask:function(al){this._editor.editTask(al);
},saveTask:function(ao,ap){var an=this._editor;
var al=an.container;
var am=an.editable;
if(al&&am&&am.end()){this._updateTask(ao,ap);
}},_updateTask:function(am,an){var al=this.resources.field;
if(!this.trigger("save",{task:am,values:an})){this._preventRefresh=true;
this.dataSource.update(am,an);
if(an[al]){this._updateAssignments(am.get("id"),an[al]);
}this._syncDataSource();
}},_updateAssignment:function(al,an){var am=this.assignments.dataValueField;
al.set(am,an);
},removeTask:function(an){var am=this;
var al=typeof an==="string"?this.dataSource.getByUid(an):an;
if(!al){return;
}this._taskConfirm(function(ao){if(!ao){am._removeTask(al);
}},al);
},_createTask:function(an,am){if(!this.trigger("add",{task:an,dependency:null})){var al=this.dataSource;
this._preventRefresh=true;
if(am===ah){al.add(an);
}else{al.insert(am,an);
}this._scrollToUid=an.uid;
this._syncDataSource();
}},_createDependency:function(al){if(!this.trigger("add",{task:null,dependency:al})){this._preventDependencyRefresh=true;
this.dependencies.add(al);
this._preventDependencyRefresh=false;
this.dependencies.sync();
}},_createAssignment:function(ap,ao){var am=this.assignments;
var an=am.dataSource;
var at=am.dataTaskIdField;
var aq=am.dataResourceIdField;
var ar=am.dataValueField;
var al=an._createNewModel();
al[at]=ao;
al[aq]=ap.get("id");
al[ar]=ap.get("value");
an.add(al);
},removeDependency:function(an){var am=this;
var al=typeof an==="string"?this.dependencies.getByUid(an):an;
if(!al){return;
}this._dependencyConfirm(function(ao){if(!ao){am._removeDependency(al);
}},al);
},_removeTaskDependencies:function(ao,al){this._preventDependencyRefresh=true;
for(var am=0,an=al.length;
am<an;
am++){this.dependencies.remove(al[am]);
}this._preventDependencyRefresh=false;
this.dependencies.sync();
},_removeTaskAssignments:function(aq){var am=this.assignments.dataSource;
var al=am.view();
var an={field:this.assignments.dataTaskIdField,operator:"eq",value:aq.get("id")};
al=new U(al).filter(an).toArray();
this._preventRefresh=true;
for(var ao=0,ap=al.length;
ao<ap;
ao++){am.remove(al[ao]);
}this._preventRefresh=false;
am.sync();
},_removeTask:function(am){var al=this.dependencies.dependencies(am.id);
if(!this.trigger("remove",{task:am,dependencies:al})){this._removeTaskDependencies(am,al);
this._removeTaskAssignments(am);
this._preventRefresh=true;
if(this.dataSource.remove(am)){this._syncDataSource();
}this._preventRefresh=false;
}},_removeDependency:function(al){if(!this.trigger("remove",{task:null,dependencies:[al]})){if(this.dependencies.remove(al)){this.dependencies.sync();
}}},_removeAssignment:function(al){this.assignments.dataSource.remove(al);
},_taskConfirm:function(al,an){var am=this.options.messages;
this._confirm(al,{model:an,text:am.deleteTaskConfirmation,title:am.deleteTaskWindowTitle});
},_dependencyConfirm:function(al,am){var an=this.options.messages;
this._confirm(al,{model:am,text:an.deleteDependencyConfirmation,title:an.deleteDependencyWindowTitle});
},_confirm:function(am,ap){var an=this.options.editable;
var ao;
var al;
if(an===true||an.confirmation!==false){ao=this.options.messages;
al=[{name:"delete",text:ao.destroy,className:w.styles.primary,click:function(){am();
}},{name:"cancel",text:ao.cancel,click:function(){am(true);
}}];
this.showDialog(u(true,{},ap,{buttons:al}));
}else{am();
}},showDialog:function(al){this._editor.showDialog(al);
},refresh:function(){if(this._preventRefresh||this.list.editable){return;
}this._progress(false);
var ao=this.dataSource;
var aq=ao.taskTree();
var ap=this._scrollToUid;
var an;
var am;
var al=-1;
if(this.current){am=this.current.closest("tr").attr(H.attr("uid"));
al=this.current.index();
}if(this.trigger("dataBinding")){return;
}if(this.resources.dataSource.data().length!==0){this._assignResources(aq);
}if(this._editor){this._editor.close();
}this.clearSelection();
this.list._render(aq);
this.timeline._render(aq);
this.timeline._renderDependencies(this.dependencies.view());
if(ap){this._scrollTo(ap);
this.select(Y(ap));
}if((ap||am)&&al>=0){an=this.list.content.find("tr"+Y(ap||am)+" > td:eq("+al+")");
this._current(an);
}this._scrollToUid=null;
this.trigger("dataBound");
},refreshDependencies:function(){if(this._preventDependencyRefresh){return;
}if(this.trigger("dataBinding")){return;
}this.timeline._renderDependencies(this.dependencies.view());
this.trigger("dataBound");
},_assignResources:function(at){var ar=this.resources;
var an=this.assignments;
var ao=function(){var av=an.dataSource.view();
var aw={field:an.dataTaskIdField};
av=new U(av).group(aw).toArray();
return av;
};
var am=ao();
var al=function(ay,av){var az=ay.get("id");
H.setter(ar.field)(ay,new N([]));
for(var aw=0,ax=am.length;
aw<ax;
aw++){if(am[aw].value===az){av(ay,am[aw].items);
}}};
var au=function(aD,ax){for(var ay=0,az=ax.length;
ay<az;
ay++){var aw=ax[ay];
var aA=ar.dataSource.get(aw.get(an.dataResourceIdField));
var aC=aw.get(an.dataValueField);
var aB=aw.get(an.dataResourceIdField);
var aE=aA.get(ar.dataFormatField)||R;
var av=H.toString(aC,aE);
aD[ar.field].push(new O({id:aB,name:aA.get(ar.dataTextField),color:aA.get(ar.dataColorField),value:aC,formatedValue:av}));
}};
for(var ap=0,aq=at.length;
ap<aq;
ap++){al(at[ap],au);
}},_wrapResourceData:function(an){var au=this;
var ar=[];
var ap;
var aq=this.resources.dataSource.view();
var al=this.assignments.dataSource.view();
var at=new U(al).filter({field:au.assignments.dataTaskIdField,operator:"eq",value:an}).toArray();
var av=function(aw){var ax=null;
new U(at).filter({field:au.assignments.dataResourceIdField,operator:"eq",value:aw}).select(function(ay){ax+=ay.get(au.assignments.dataValueField);
});
return ax;
};
for(var am=0,ao=aq.length;
am<ao;
am++){ap=aq[am];
ar.push({id:ap.get("id"),name:ap.get(au.resources.dataTextField),format:ap.get(au.resources.dataFormatField)||R,value:av(ap.id)});
}return ar;
},_syncDataSource:function(){this._preventRefresh=false;
this._requestStart();
this.dataSource.sync();
},_requestStart:function(){this._progress(true);
},_error:function(){this._progress(false);
},_progress:function(al){H.ui.progress(this.element,al);
},_resizable:function(){var an=this;
var au=this.wrapper;
var am=w.styles;
var al=r+am.gridContent;
var at=au.find(r+am.list);
var aq=au.find(r+am.timeline);
var ar;
var ap;
var ao;
this._resizeDraggable=au.find(r+am.splitBar).height(at.height()).hover(function(){b(this).addClass(am.splitBarHover);
},function(){b(this).removeClass(am.splitBarHover);
}).end().kendoResizable({orientation:"horizontal",handle:r+am.splitBar,start:function(){ar=at.width();
ap=aq.width();
ao=aq.find(al).scrollLeft();
},resize:function(aw){var av=aw.x.initialDelta;
if(H.support.isRtl(au)){av*=-1;
}if(ar+av<0||ap-av<0){return;
}at.width(ar+av);
aq.width(ap-av);
aq.find(al).scrollLeft(ao+av);
an.timeline.view()._renderCurrentTime();
}}).data("kendoResizable");
},_scrollable:function(){var ao=this;
var am=w.styles;
var al=r+am.gridContent;
var an=r+am.gridHeaderWrap;
var aq=this.timeline.element.find(an);
var ap=this.timeline.element.find(al);
var at=this.list.element.find(an);
var ar=this.list.element.find(al);
if(K){ar.css("overflow-y","auto");
}ap.on("scroll",function(){ao.scrollTop=this.scrollTop;
aq.scrollLeft(this.scrollLeft);
ar.scrollTop(this.scrollTop);
});
ar.on("scroll",function(){at.scrollLeft(this.scrollLeft);
}).on("DOMMouseScroll"+L+" mousewheel"+L,function(av){var aw=ap.scrollTop();
var au=H.wheelDeltaY(av);
if(au){av.preventDefault();
b(av.currentTarget).one("wheel"+L,false);
ap.scrollTop(aw+-au);
}});
},_navigatable:function(){var aA=this;
var ax=this.options.navigatable;
var ap=this.options.editable;
var at=this.list.header.find("table");
var an=this.list.content.find("table");
var ar=w.styles;
var au=H.support.isRtl(this.wrapper);
var aB=this.timeline.element.find(r+ar.gridContent);
var az=at.add(an);
var al=Y();
var am;
var aq={collapse:false,expand:true};
var ay=function(aD){var aE=aA.timeline.view()._timeSlots()[0].offsetWidth;
aB.scrollLeft(aB.scrollLeft()+(aD?-aE:aE));
};
var aw=function(aE){var aF=aA.current.parent("tr"+Y());
var aD=aA.current.index();
var aG=aF[aE]();
if(aA.select().length!==0){aA.clearSelection();
}if(aG.length!==0){aA._current(aG.children("td:eq("+aD+")"));
aA._scrollTo(aA.current);
}else{if(aA.current.is("td")&&aE=="prev"){v(at);
}else{if(aA.current.is("th")&&aE=="next"){v(an);
}}}};
var av=function(aD){var aE=aA.current[aD]();
if(aE.length!==0){aA._current(aE);
am=aA.current.index();
}};
var aC=function(aE){var aD=aA.dataItem(aA.current);
if(aD.summary&&aD.expanded!==aE){aD.set("expanded",aE);
}};
var ao=function(){var aD=aA.options.editable;
if(!aD||aD.destroy===false||aA.list.editable){return;
}var aE=aA.select();
var aF=H.attr("uid");
if(aE.length){aA.removeTask(aE.attr(aF));
}};
b(this.wrapper).on("mousedown"+L,"tr"+al+", div"+al+":not("+r+ar.line+")",function(aF){var aE=b(aF.currentTarget);
var aG=b(aF.target).is(":button,a,:input,a>.k-icon,textarea,span.k-icon,span.k-link,.k-input,.k-multiselect-wrap");
var aD;
if(aF.ctrlKey){return;
}if(ax){if(aE.is("tr")){aD=b(aF.target).closest("td");
}else{aD=aA.list.content.find("tr"+Y(aE.attr(H.attr("uid")))+" > td:first");
}aA._current(aD);
}if((ax||ap)&&!aG){aA._focusTimeout=setTimeout(function(){v(aA.list.content.find("table"),true);
},2);
}});
if(ax!==true){an.on("keydown"+L,function(aD){if(aD.keyCode==I.DELETE){ao();
}});
return;
}az.on("focus"+L,function(){var aF=this===an.get(0)?"td":"th";
var aE=aA.select();
var aD=aA.current||b(aE.length?aE:this).find(aF+":eq("+(am||0)+")");
aA._current(aD);
}).on("blur"+L,function(){aA._current();
if(this==at){b(this).attr(ab,-1);
}}).on("keydown"+L,function(aD){var aF=aD.keyCode;
var aE;
if(!aA.current){return;
}aE=aA.current.is("td");
switch(aF){case I.RIGHT:aD.preventDefault();
if(aD.altKey){ay();
}else{if(aD.ctrlKey){aC(au?aq.collapse:aq.expand);
}else{av(au?"prev":"next");
}}break;
case I.LEFT:aD.preventDefault();
if(aD.altKey){ay(true);
}else{if(aD.ctrlKey){aC(au?aq.expand:aq.collapse);
}else{av(au?"next":"prev");
}}break;
case I.UP:aD.preventDefault();
aw("prev");
break;
case I.DOWN:aD.preventDefault();
aw("next");
break;
case I.SPACEBAR:aD.preventDefault();
if(aE){aA.select(aA.current.closest("tr"));
}break;
case I.ENTER:aD.preventDefault();
if(aE){if(aA.options.editable&&aA.options.editable.update!==false){aA._cachedCurrent=aA.current;
aA.list._startEditHandler(aA.current);
b(this).one("keyup",function(aG){aG.stopPropagation();
});
}}else{aA.current.children("a.k-link").click();
}break;
case I.ESC:aD.stopPropagation();
break;
case I.DELETE:if(aE){ao();
}break;
default:if(aF>=49&&aF<=57){aA.view(aA.timeline._viewByIndex(aF-49));
}break;
}});
},_current:function(am){var an=w.styles;
var al;
if(this.current&&this.current.length){this.current.removeClass(an.focused).removeAttr("id");
}if(am&&am.length){this.current=am.addClass(an.focused).attr("id",c);
al=b(H._activeElement());
if(al.is("table")&&this.wrapper.find(al).length>0){al.removeAttr(e).attr(e,c);
}}else{this.current=null;
}},_dataBind:function(){var am=this;
if(am.options.autoBind){this._preventRefresh=true;
this._preventDependencyRefresh=true;
var al=b.map([this.dataSource,this.dependencies,this.resources.dataSource,this.assignments.dataSource],function(an){return an.fetch();
});
b.when.apply(null,al).done(function(){am._preventRefresh=false;
am._preventDependencyRefresh=false;
am.refresh();
});
}},_resize:function(){this._adjustDimensions();
this.timeline.view()._adjustHeight();
this.timeline.view()._renderCurrentTime();
this.list._adjustHeight();
}});
if(H.PDFMixin){H.PDFMixin.extend(w.fn);
w.fn._drawPDF=function(){var am=w.styles;
var an="."+am.list;
var ao=this.wrapper.find(an).width();
var al=this.wrapper.clone();
al.find(an).css("width",ao);
return this._drawPDFShadow({content:al},{avoidLinks:this.options.pdf.avoidLinks});
};
}H.ui.plugin(w);
u(true,w,{styles:A});
}(window.kendo.jQuery));
return window.kendo;
},typeof define=="function"&&define.amd?define:function(a,b,c){(c||b)();
}));
if(typeof(Sys)!=='undefined')Sys.Application.notifyScriptLoaded();