(function(a){Type.registerNamespace("Telerik.Web.UI");
Telerik.Web.UI.LayoutBuilder=function(b){Telerik.Web.UI.LayoutBuilder.initializeBase(this,[b]);
this._requireCellId=false;
this._layoutXmlFile="";
this._layoutWidth="";
this._layoutHeight="";
this._idCounter=100;
};
Telerik.Web.UI.LayoutBuilder.prototype={initialize:function(){Telerik.Web.UI.LayoutBuilder.callBaseMethod(this,"initialize");
this.loadClientState();
this.updateClientState();
},get_requireCellId:function(){return this._requireCellId;
},set_requireCellId:function(b){this._requireCellId=b;
},get_layoutXmlFile:function(){return this._layoutXmlFile;
},set_layoutXmlFile:function(b){this._layoutXmlFile=b;
},get_layoutWidth:function(){return this._layoutWidth;
},set_layoutWidth:function(c){this._layoutWidth=c;
var b=this._selectedTable;
if(b){b.removeAttribute("width");
b.style.width=this._layoutWidth;
}},get_layoutHeight:function(){return this._layoutHeight;
},set_layoutHeight:function(c){this._layoutHeight=c;
var b=this._selectedTable;
if(b){b.removeAttribute("height");
b.style.height=this._layoutHeight;
}},_getElementAttributesHtml:function(f){var g="";
if(f){var c=f.attributes;
var d=c.length;
for(var h=0;
h<d;
h++){var b=c[h].name;
var e=f.getAttribute(b,2);
if(e&&!((b=="colSpan"||b=="rowSpan")&&e=="1")&&b!="tabIndex"&&b!="contentEditable"&&b!="style"){g+=" "+b.toLowerCase()+'="'+e+'"';
}}var j=f.style.cssText;
if(j){g+=' style="'+j+'"';
}}return g;
},get_serializedTableOuterHtml:function(){if(!this._selectedTable){return"";
}var l="<table ";
l+=this._getElementAttributesHtml(this._selectedTable);
l+=" >";
var h=this._selectedTable.rows;
var k=h.length;
for(var e=0;
e<k;
e++){var g=h[e];
l+="<tr";
l+=this._getElementAttributesHtml(g);
l+=">";
var c=g.cells;
var d=c.length;
for(var f=0;
f<d;
f++){var b=c[f];
l+="<td";
l+=this._getElementAttributesHtml(b);
l+=" >";
l+="<![CDATA["+b.innerHTML+"]]></td>";
}l+="</tr>";
}l+="</table>";
return l;
},_getUniqueCellId:function(){this._idCounter++;
return(this.get_id()+this._idCounter+(new Date()-100));
},_setCellId:function(b){if(!b){return;
}if(this._requireCellId){var c=b.getAttribute("id");
if(!c){c=this._getUniqueCellId();
b.setAttribute("id",c);
}}},_setAllCellsId:function(){if(!this._selectedTable){return;
}var f=this._selectedTable.rows;
var g=f.length;
for(var d=0;
d<g;
d++){var b=f[d].cells;
var c=b.length;
for(var e=0;
e<c;
e++){this._setCellId(b[e]);
}}},loadClientState:function(){var e=$get(this.get_clientStateFieldID());
if(e){var f=e.value;
var d=Sys.Serialization.JavaScriptSerializer.deserialize(f);
if(d.TableHtml){var g=this.decodePostbackContent(d.TableHtml);
g=this.unEscapeNewLines(g);
var b=document.createElement("div");
b.innerHTML=g;
var c=b.firstChild;
if(c&&c.tagName=="TABLE"){this.set_selectedTable(c);
}}}},saveClientState:function(){var c=this.get_serializedTableOuterHtml();
var b={TableHtml:(this._selectedTable)?this.encodePostbackContent(c):""};
return Sys.Serialization.JavaScriptSerializer.serialize(b);
},escapeNewLines:function(c){var b=c.replace(/\n/gi,"&nbsp;<telerikcr />");
b=b.replace(/\r/gi,"<teleriklf />");
return b;
},unEscapeNewLines:function(c){var b=c.replace(/(&nbsp;)?<telerikcr\s*\/>/gi,"\n");
b=b.replace(/<teleriklf\s*\/>/gi,"\r");
return b;
},_encodeSelectedTable:function(c,f){var b=new Array("%","<",">","!",'"',"#","$","&","'","(",")",",",":",";","=","?","[","]","\\","^","`","{","|","}","~","+");
var e=c,d;
if(f){for(d=0;
d<b.length;
d++){e=e.replace(new RegExp("\\x"+b[d].charCodeAt(0).toString(16),"ig"),"%"+b[d].charCodeAt(0).toString(16));
}}else{for(d=b.length-1;
d>=0;
d--){e=e.replace(new RegExp("\\%"+b[d].charCodeAt(0).toString(16),"ig"),b[d]);
}}return e;
},encodePostbackContent:function(b){return this._encodeSelectedTable(b,true);
},decodePostbackContent:function(b){return this._encodeSelectedTable(b,false);
},_insertCell:function(f,d,e,g){var c=[f,d,e,g];
var b=Telerik.Web.UI.LayoutBuilder.callBaseMethod(this,"_insertCell",c);
this._setCellId(b);
return b;
},executeCommand:function(c,b){var d=[c,b];
Telerik.Web.UI.LayoutBuilder.callBaseMethod(this,"executeCommand",d);
this.updateClientState();
},set_selectedTable:function(e){var b=[];
b[0]=e;
Telerik.Web.UI.LayoutBuilder.callBaseMethod(this,"set_selectedTable",b);
if(this._requireCellId){this._setAllCellsId();
}this.updateClientState();
var d=this._selectedTable;
if(d){var f=d.style.width;
if(!f){f=d.getAttribute("width");
}this._layoutWidth=f;
var c=d.style.height;
if(!c){c=d.getAttribute("height");
}this._layoutHeight=c;
}}};
Telerik.Web.UI.LayoutBuilder.registerClass("Telerik.Web.UI.LayoutBuilder",Telerik.Web.UI.LayoutBuilderEngine);
})();
if(typeof(Sys)!=='undefined')Sys.Application.notifyScriptLoaded();