Type.registerNamespace("Telerik.Web.UI");
Type.registerNamespace("Telerik.Web.UI.Editor");
(function(b,a){b.TrackChangesConstants={CssClassInsert:"Change_Insert",CssClassDelete:"Change_Delete",CssClassComment:"reComment",CssClassFormat:"reFormat",CssClassDeletTR:"Delete_TR",CssClassInsertTR:"Insert_TR",CssClass:"trackchanges_curr_rev",CssClassNamePrefixComment:"reComment",CssClassNamePrefixFormat:"reFormat",CssClassNamePrefixInsertTR:"reIns",CssClassNamePrefixDeleteTR:"reDel",TagInsert:"ins",TagDelete:"del",TagComment:"font",TagFormat:"font",Attribute:{Title:"title",Timestamp:"timestamp",Cite:"cite",BrowserCommand:"command",Author:"author",Comment:"comment"},CommentsRegex:new RegExp("reComment","ig"),InsTagMatchRegex:new RegExp("<ins[^>]*>.*","i"),DelTagMatchRegex:new RegExp("<del[^>]*>.*","i"),BlockTagMatchRegex:new RegExp("<(?:p|div)[^>]*>.*?</(?:p|div)>","i"),JustifyBlockTags:"|div|p|"};
b.TrackChangesCommandStrings={AcceptTrackChange:"Accept Trackchange",RejectTrackChange:"Reject TrackChange",RemoveTrackChange:"Remove TrackChange",AddComment:"Add Comment",RemoveComment:"Remove Comment",TrackChange:"Apply TrackChange",Delete:"Delete"};
a.registerEnum(b,"SelectionType",{Text:0,Control:1,Range:2});
a.registerEnum(b,"TrackChangesElementType",{Insert:1,Delete:2,FormatChange:3,JustifyFormatChange:4,Comment:5});
})(Telerik.Web.UI.Editor,$telerik.$);
Type.registerNamespace("$T.Editor");
(function(d,a,c,b){var f=c.Utils;
var e=c.TrackChangesUtils={wrapElementInTrackChangeDelete:function(i,g,j,h){e._wrapElementInTrackChangeElement(b.TagDelete,i,b.CssClassDelete,g,j,h);
},_wrapElementInTrackChangeElement:function(t,n,j,h,u,m){if(t=="del"&&n.tagName=="HR"){return true;
}var s="";
if(t=="del"){s="Deleted by ";
}else{if(t=="ins"){s="Inserted by ";
}else{if(t=="font"){s="Formatted by ";
}}}if(!u){u=new Date().getTime();
}if(n.tagName=="BODY"){for(var o=0;
o<n.childNodes.length;
o++){var g=n.childNodes[o];
var q=g.ownerDocument.createElement(t);
q.className=j;
q.setAttribute(b.Attribute.Cite,h);
q.setAttribute(b.Attribute.Timestamp,u);
q.setAttribute(b.Attribute.Title,s+h+" on "+new Date(u).toLocaleString());
if(t=="del"){q.setAttribute("name",m.get_deletedElemName());
}n.insertBefore(q,g);
q.appendChild(g);
e.getDomRange(m).selectNodeContents(q);
}}else{try{var p=m.get_document().createElement(t);
p.className=j;
p.setAttribute(b.Attribute.Cite,h);
p.setAttribute(b.Attribute.Timestamp,u);
p.setAttribute(b.Attribute.Title,s+h+" on "+new Date(u).toLocaleString());
if(t=="del"){p.setAttribute("name",m.get_deletedElemName());
if(n.nodeName!="#text"&&n.contentEditable.match(/(true|false)/i)){var r=n;
while(r.nodeName!="BODY"){if(r.nodeName=="A"&&r.contentEditable.match(/(true|false)/i)){break;
}r=r.parentElement;
}n=r;
}}if(n.parentNode){n.parentNode.insertBefore(p,n);
p.appendChild(n);
var k=e.getDomRange(m);
k.selectNodeContents(p);
k.select();
}else{n.outerHTML=$telerik.getOuterHtml(p);
m.selectElement(n);
}m.getSelection().getRange().collapse(false);
}catch(l){}}},_wrapTextInTrackChange:function(q,j,r,i,s,g,l){if(!r){return null;
}var p="";
if(q=="del"){p="Deleted by ";
}else{if(q=="ins"){p="Inserted by ";
}else{if(q=="font"){p="Formatted by ";
}}}if(!s){s=new Date().getTime();
}var h="";
if(g){for(var m in g){h+=" "+m+"='"+g[m]+"'";
}}var t="";
if(typeof(l)!="undefined"&&l!=null&&l!=false){if(q=="ins"){var o='<a href="'+l.href+'" >';
var k="</a>";
t=o+"<"+q+" class='"+j+"' "+b.Attribute.Cite+"='"+i+"' "+b.Attribute.Timestamp+"='"+s+"' "+b.Attribute.Title+"='"+p+i+" on "+new Date(s).toLocaleString()+"'"+h+">"+(r.replace(/^\s+/ig,"&nbsp;"))+"</"+q+">"+k;
}}else{t="<"+q+" class='"+j+"' "+b.Attribute.Cite+"='"+i+"' "+b.Attribute.Timestamp+"='"+s+"' "+b.Attribute.Title+"='"+p+i+" on "+new Date(s).toLocaleString()+"'"+h+">"+(r.replace(/^\s+/ig,"&nbsp;"))+"</"+q+">";
}return t;
},wrapElementInTrackChanageComment:function(i,h){var g=h.get_author();
var k=i.ownerDocument.createElement(b.TagComment);
k.className=b.CssClassComment+" "+h.get_userCssId();
k.setAttribute("id",h.get_commentID());
k.setAttribute(b.Attribute.Comment," ");
k.setAttribute(b.Attribute.Author,g);
k.setAttribute(b.Attribute.Title," ");
k.setAttribute(b.Attribute.Timestamp,new Date().getTime());
if(i.nodeName=="TABLE"){k.innerHTML=$telerik.getOuterHtml(i);
var j=$telerik.getOuterHtml(k);
h.selectElement(i);
h.executeBrowserCommand("Delete");
var l=h.getSelection().getRange();
l.pasteHTML(j);
l.move("character",-1);
l.select();
}else{i.parentElement.replaceChild(k,i);
k.appendChild(i);
h.selectElement(i);
}},removeInsertTrackChangeChildren:function(g){a(b.TagInsert,g).remove();
},removeNodeTracking:function(h){if(h.nodeType!=1){return;
}var g=h.getAttribute("alignOrig");
if(g){if(g=="none"){h.removeAttribute("align");
h.style.textAlign="";
}else{h.setAttribute("align",g);
h.style.textAlign=g;
}}e.clearTrackingAttributes(h);
if(f.canHaveChildren(h)&&/^[\u200b]?$/.test(h.innerHTML)&&!f.isBlockElement(h)){a(h).remove();
}},clearTrackingAttributes:function(g){if(g.nodeType!=1){return;
}g.removeAttribute(b.Attribute.Author);
e.removeTrackChangesCommand(g);
g.removeAttribute(b.Attribute.Timestamp);
g.className=g.getAttribute("originalCssClass")||"";
if(!g.className){g.removeAttribute("class");
}g.removeAttribute(b.Attribute.Title);
g.removeAttribute("alignOrig");
if(g.getAttribute("cssproperty")){g.removeAttribute("cssproperty");
}if(g.getAttribute("originalvalue")){g.removeAttribute("originalvalue");
}if(g.getAttribute("iswrapper")){g.removeAttribute("iswrapper");
}},getTrackedParentNode:function(j,k,g){var h=g||function(){return true;
},i=function(l){return k?k===l:f.isEditorContentArea(l);
};
while(j&&!i(j)){if(h(j)&&e.isTrackChangeElement(j)){return j;
}j=j.parentNode;
}return null;
},getParentTrackChangesInsertNode:function(h,i){var g=function(j){return f.isTag(j,"ins");
};
return e.getTrackedParentNode(h,i,g);
},getParentTrackChangesDeleteNode:function(g,h){return e.getTrackedParentNode(g,h,e.isChangeDelete);
},isChangeDelete:function(g){return f.isTag(g,"del")&&e.getTrackChangesCommand(g)!="StrikeThrough";
},getTrackedAncestor:function(g){var h=e.getTrackedParentNode(g),i=null;
while(h&&!f.isBlockElement(h)){i=h;
h=e.getTrackedParentNode(h.parentNode);
}return i;
},findTrackChangesParentElement:function(g,j){var h=j&&j.ignoreComments;
var l=f.getElementParentByCondition(g,function(m){return e.isTrackChangeElement(m)||(h?null:e.isCommentElement(m));
});
if(!l){return null;
}var k={HtmlElement:null,Type:null,User:""};
var i=l.nodeName.toLowerCase();
k.HtmlElement=l;
k.User=l.getAttribute(b.Attribute.Author)||l.getAttribute(b.Attribute.Cite);
k.BrowserCommand=e.getTrackChangesCommand(l);
k.Type=/Align|Justify/i.test(k.BrowserCommand)?c.TrackChangesElementType.JustifyFormatChange:/Bold|Italic|Underline|StrikeThrough|Superscript|Subscript|Indent|Outdent|LinkManager|InsertLink|InsertOrderedList|InsertUnorderedList/i.test(k.BrowserCommand)?c.TrackChangesElementType.FormatChange:i==b.TagInsert?c.TrackChangesElementType.Insert:i==b.TagDelete?c.TrackChangesElementType.Delete:c.TrackChangesElementType.Comment;
return k;
},findTrackChangesParentNode:function(h,i){var j=f.getElementParentByTag(h,i);
var g=!!e.isTrackChangeElement(j);
return g?j:null;
},findParentComment:function(g){while(g&&!f.isEditorContentArea(g)){if(e.isCommentElement(g)){return g;
}g=g.parentNode;
}return null;
},isCommentElement:function(g){if(!g||f.isTextNode(g)){return false;
}return Sys.UI.DomElement.containsCssClass(g,b.CssClassNamePrefixComment);
},_isInTrackChangeElement:function(i,g,h){if(i==null){return false;
}if(i.Type==h){if(g==null){return true;
}else{if(g==i.User){return true;
}}}return false;
},isTrackChangeElement:function(g){if(!g||f.isTextNode(g)){return false;
}var h=g.nodeName.toLowerCase();
if((h==b.TagInsert||h==b.TagDelete)&&g.getAttribute(b.Attribute.Title)&&g.getAttribute(b.Attribute.Timestamp)){return true;
}return Sys.UI.DomElement.containsCssClass(g,b.CssClassNamePrefixFormat);
},setTrackChangesAttributes:function(k,j,i,n,m){m=m||new Date().getTime();
var h=b.Attribute;
if(j=="Outdent"&&e.isTrackChangeElement(k)&&f.isTag(k,"li")&&e.getTrackChangesCommand(k)==j){if(k.getAttribute("previousoutdent")){var l=k.getAttribute("previousoutdent");
k.setAttribute("previousoutdent",l+","+k.getAttribute("timestamp"));
}else{k.setAttribute("previousoutdent",k.getAttribute("timestamp"));
}}k.setAttribute(h.Author,i);
e.setTrackChangesCommand(k,j);
k.setAttribute(h.Timestamp,m);
var g=j=="Insert"?"Inserted":j=="Delete"?"Deleted":"Formatted";
k.setAttribute(h.Title,g+" by "+i+" on "+new Date(parseInt(m,10)).toLocaleString());
k.className=(j=="Insert"||j=="Delete")?n:b.CssClassFormat+" "+n;
},getTrackChangesCommand:function(g){return g.getAttribute(b.Attribute.BrowserCommand)||g.getAttribute("browsercommand");
},removeTrackChangesCommand:function(h){var g=b.Attribute.BrowserCommand;
if(h.getAttribute(g)){h.removeAttribute(g);
}if(h.getAttribute("innercommand")){h.removeAttribute("innercommand");
}if(h.getAttribute("browsercommand")){h.removeAttribute("browsercommand");
}},setTrackChangesCommand:function(h,g){e.removeTrackChangesCommand(h);
h.setAttribute(b.Attribute.BrowserCommand,g);
},enumerateElemetsInRange:function(i){if(!i){return null;
}i=c.DomRange.toDomRange(i);
var j=i.cloneRange();
var h=i.getParentElement();
function g(l){var o=[];
j.selectNodeContents(l);
if(i.inRange(j)){o.push(l);
return o;
}var m=0;
for(;
m<l.childNodes.length;
m++){var k=l.childNodes(m);
if(!k.canHaveHTML){continue;
}var n=g(k);
if(n.length>0){o=o.concat(n);
}}return o;
}return g(h);
},enumerateNodesInRange:function(j){var l=[];
j=new d.Editor.DomRange(j);
var m=j.getParentElement();
if(m==null){return l;
}if(!m.tagName){m=m.parentNode;
}var k=j.cloneRange();
k.selectNodeContents(m);
if(!f.isEditorContentArea(m)&&this.intersect(k,j)){l.push(m);
}for(var h=0;
h<m.children.length;
h++){var g=m.children[h];
if(!g.innerHTML){continue;
}k.selectNodeContents(g);
if(this.intersect(k,j)){l.push(g);
}}j.select();
return l;
},enumerateElemetsInSelection:function(j){if(!j){return null;
}var i=c.DomRange.toDomRange(j.getRange(true));
var k=i.cloneRange();
var h=i.getParentElement();
function g(m){var p=[];
k.selectNodeContents(m);
if(i.inRange(k)){p.push(m);
return p;
}var n=0;
for(;
n<m.childNodes.length;
n++){var l=m.childNodes(n);
if(!l.canHaveHTML){continue;
}var o=g(l);
if(o.length>0){p=p.concat(o);
}}return p;
}return g(h);
},intersect:function(g,h){return !((g.compareBoundaryPoints(d.Editor.DomRange.START_TO_START,h)==-1&&g.compareBoundaryPoints(d.Editor.DomRange.START_TO_END,h)==-1)||(g.compareBoundaryPoints(d.Editor.DomRange.END_TO_START,h)==1&&g.compareBoundaryPoints(d.Editor.DomRange.END_TO_END,h)==1));
},intersectIERange:function(g,h){g=c.DomRange.toDomRange(g);
h=c.DomRange.toDomRange(h);
return !((g.compareBoundaryPoints("StartToStart",h)==-1&&g.compareBoundaryPoints("EndToStart",h)==-1)||(g.compareBoundaryPoints("StartToEnd",h)==1&&g.compareBoundaryPoints("EndToEnd",h)==1));
},getDomRange:function(g,h){var j=g.getSelection(),i=j.getRange();
if(!i){j.selectElement(g.get_contentArea());
j.collapse();
i=j.getRange();
}return new c.DomRange(i,h);
},getSameTrackingSiblings:function(g){var h=g.getAttribute("timestamp");
return a(g.parentNode).children().filter(function(){var i=this.getAttribute?this.getAttribute("timestamp"):null;
return i&&i==h;
});
},getSameTrackNodes:function(g,h){var j=h.getAttribute("timestamp");
if(!j){return a();
}var i=String.format("[timestamp={0}]",j.toString());
return a(g).find(i);
}};
})(Telerik.Web.UI,$telerik.$,Telerik.Web.UI.Editor,Telerik.Web.UI.Editor.TrackChangesConstants);
Type.registerNamespace("Telerik.Web.UI.Editor");
(function(d,a,c,b){a.extend(c.DefaultToolAdapter.prototype,{onContextMenu:function(j){var k=this.get_editor();
if(!this._contextMenusEnabled||k.get_mode()!=d.EditModes.Design){return;
}this.createContextMenus();
var l=this._getContextElement(j);
if((c.Utils.isTag(l,"img")&&l.getAttribute("isflash")=="true")||(k.get_enableImmutableElements()&&c.Utils.isImmutableNode(l))){return;
}var h=this._contextMenuFunctionality;
var f=c.Utils.getElementParentByCondition(l,function(q){var e=h.getContextMenuByTagName(q.nodeName);
e=e||(c.Utils.isTag(q,"th")?h.getContextMenuByTagName("TD"):e);
return !!e;
});
var i=f?f.nodeName:"*";
if(c.Utils.isTag(f,"th")&&!h.getContextMenuByTagName("TH")){i="TD";
}var g;
var n=c.TrackChangesUtils.findTrackChangesParentElement(l);
if(n){if(n.Type==c.TrackChangesElementType.Comment){g=this.createContextMenuWithTrackChangeCommentItems(i);
}else{g=this.createContextMenuWithTrackChangeItems(i);
}}else{g=this.createContextMenuWithTrackChangeDefaultItems(i)||h.getContextMenuByTagName(i);
}if(g){var o={contentAreaMode:this.get_contentAreaMode(),docNode:document.documentElement||document,editorContentAreaElement:k.get_contentAreaElement()};
this._contextMenuFunctionality.showContextMenu(g,j,o);
if($telerik.isSafari){try{var p=l.tagName;
if(p=="IMG"||p=="TABLE"||p=="TD"||p=="TR"){k.selectElement(l);
}}catch(m){}}}return $telerik.cancelRawEvent(j);
},createContextMenuWithTrackChangeDefaultItems:function(e){return this._createContextMenuWithTrackChangeItems(e,"TrackChangeDefault");
},createContextMenuWithTrackChangeItems:function(e){return this._createContextMenuWithTrackChangeItems(e,"TrackChangeFormat");
},createContextMenuWithTrackChangeCommentItems:function(e){return this._createContextMenuWithTrackChangeItems(e,"TrackChangeComment");
},_createContextMenuWithTrackChangeItems:function(g,p){var m=g+"::"+p;
var h=this._contextMenuFunctionality.getContextMenuByTagName(m);
if(h){return h;
}var j=this.get_editor();
var f=j.get_contextMenusJSON();
var e=null;
for(var l=0;
l<f.length;
l++){if(f[l].tagName==p){e=f[l];
break;
}}if(!e){return null;
}var k={valueSelected:this._onDropDownValueSelectedDelegate,show:this._onDropDownBeforeShowDelegate,hide:this._onDropDownHideDelegate};
var n={contextMenuId:g,trackChangeGroup:p};
var o=this._contextMenuFunctionality.createContextMenu(k,e,j,n);
return o;
}});
})(Telerik.Web.UI,$telerik.$,Telerik.Web.UI.Editor,Telerik.Web.UI.Editor.TrackChangesConstants);
Type.registerNamespace("Telerik.Web.UI");
Type.registerNamespace("Telerik.Web.UI.Editor");
(function(b,a){b.Editor.Dialogs=(function(){var s=-75;
var j=0;
var q=true;
var o=0.5;
var n="#FFF";
var h=false;
var l="&nbsp;OK&nbsp;";
var e="&nbsp;Cancel&nbsp;";
var g=null;
var c=$telerik.$;
var d=function(u,w,v,t){if(w==null){w="Alert";
}r(w,u,null,"alert",v,function(x){if(t){t(x);
}});
};
var f=function(u,w,v,t){if(w==null){w="Confirm";
}r(w,u,null,"confirm",v,function(x){if(t){t(x);
}});
};
var r=function(H,w,J,I,G,t){i();
m("show");
var z=c('<div class="rePopupContainer'+(G?" "+G:"")+'">');
var E=c('<h1 class="rePopupTitle"></h1>');
var A=c('<div class="rePopupContent">');
var B=c('<div class="rePopupMessage"></div>');
c("body").append(z);
z.append(E).append(A);
A.append(B);
if(g){z.addClass(g);
}var F=$telerik.isIE6?"absolute":"fixed";
z.css({position:F,zIndex:99999,padding:0,margin:0});
E.text(H);
A.addClass(I);
B.text(w);
B.html(B.text().replace(/\n/g,"<br />"));
z.css({minWidth:z.outerWidth(),maxWidth:z.outerWidth()});
p();
k(true);
if(I=="alert"||I=="confirm"){var x=c('<div class="rePopupButtonContainer"></div>');
var C=c('<input type="button" value="'+l+'" class="rePopupButton ok" />');
B.after(x);
x.append(C);
var u=C;
if(I=="confirm"){var y=c('<input type="button" value="'+e+'" class="rePopupButton cancel" />');
x.append(y);
u=u.add(y);
}var D=C.val();
u.click(function(K){i();
if(t){t(K.target.value==D);
}}).keypress(function(K){if(K.keyCode==13||K.keyCode==27){c(K.target).trigger("click");
}});
}if(h){try{z.draggable({handle:E,revert:true,containment:"window"});
E.css({cursor:"move"});
}catch(v){}}};
var i=function(){var u=c(".rePopupContainer");
try{u.remove();
}catch(t){}m("hide");
k(false);
};
var m=function(v){var u=c(".rePopupOverlay");
switch(v){case"show":m("hide");
u=c('<div class="rePopupOverlay"></div>');
c("BODY").append(u.css({position:"absolute",zIndex:99998,top:"0px",left:"0px",width:"100%",height:c(document).height(),background:n,opacity:o}));
break;
case"hide":try{u.remove();
}catch(t){}break;
}};
var p=function(){var u=c(".rePopupContainer");
var v=c(".rePopupOverlay");
var w=((c(window).height()/2)-(u.outerHeight()/2))+s;
var t=((c(window).width()/2)-(u.outerWidth()/2))+j;
if(w<0){w=0;
}if(t<0){t=0;
}if($telerik.isIE6){w=w+c(window).scrollTop();
}u.css({top:w+"px",left:t+"px"});
v.height(c(document).height());
};
var k=function(t){if(q){switch(t){case true:c(window).bind("resize",p);
break;
case false:c(window).unbind("resize",p);
break;
}}};
return{showAlert:function(u,w,v,t){d(u,w,v,t);
},showConfirm:function(u,w,v,t){f(u,w,v,t);
},showOverlay:function(t,u){if(t){n=t;
}if(u){o=u;
}m("show");
},hideOverlay:function(){m("hide");
}};
})();
})(Telerik.Web.UI,$telerik.$);
(function(a,b,c){var d=b.Utils;
b.DomTreeTraverser=function(e,f){this.stopCondition=e;
this.topNode=f;
};
b.DomTreeTraverser.prototype={left:function(e,g){var f=this.toDomLocation(e,g);
return this.traverse(f,{next:function(h){return h&&h.previousSibling;
},nextPos:function(h){return(h&&(d.isTextNode(h)?h.nodeValue.length:h.childNodes.length))||0;
},nextChild:function(i){var h;
return(i.isPositionAfterNodes()&&i.validNode())||((h=i.locatedNode())&&h.previousSibling);
}});
},right:function(e,g){var f=this.toDomLocation(e,g);
return this.traverse(f,{next:function(h){return h&&h.nextSibling;
},nextPos:function(h){return 0;
},nextChild:function(h){return h.locatedNode();
}});
},traverse:function(f,e){this._direction=e;
return this._traverseTree(f);
},_traverseTree:function(h){var f=h.node,j=h.position,g=this._direction;
if(!f||this.stopCondition(f,j)){return this.toDomLocation(f,j);
}var i=g.next(f),e=g.nextChild(h);
if(e){return this._traverseNext(e);
}else{if(i){return this._traverseNext(i);
}else{while(f&&f.parentNode!=this.topNode&&!g.next(f)){f=f.parentNode;
}return this._traverseNext(g.next(f));
}}},_traverseNext:function(f){var e=this.toDomLocation(f,this._direction.nextPos(f));
return this._traverseTree(e);
},toDomLocation:function(e,f){return new b.DomLocation(e,f);
}};
b.DomLocation=function(e,f){this.node=e;
this.nodesCount=this.node?this.node.childNodes.length:0;
this.position=f;
};
b.DomLocation.prototype={locatedNode:function(){return this.nodeAt(this.position);
},validNode:function(){return this.validNodeAt(this.position);
},nodeAt:function(e){return this.node.childNodes[e];
},validNodeAt:function(e){var f=Math.max(0,Math.min(this.nodesCount-1,e));
return this.nodeAt(f);
},isPositionAfterNodes:function(){return this.position>=this.nodesCount;
}};
})($telerik.$,Telerik.Web.UI.Editor);
Type.registerNamespace("Telerik.Web.UI");
Type.registerNamespace("Telerik.Web.UI.Editor");
(function(b,a){b.EditorDropDown.prototype.__original_scrollIntoView=b.EditorDropDown.prototype._scrollIntoView;
a.extend(b.EditorDropDown.prototype,{_scrollIntoView:function(d,g){if(!d||!d.parentNode){return;
}var i=null;
var h=0;
var f=d.parentNode;
while(f!=null){if(f.tagName=="BODY"){var c=f.ownerDocument;
if(!$telerik.isIE&&c.defaultView&&c.defaultView.frameElement){h=c.defaultView.frameElement.offsetHeight;
}i=f;
break;
}var e=$telerik.getCurrentStyle(f,"overflowY");
if(e=="scroll"||e=="auto"){i=f;
break;
}f=f.parentNode;
}if(!i){return;
}if(!h){h=i.offsetHeight;
}if(h<d.offsetTop+d.offsetHeight){i.scrollTop=(d.offsetTop+d.offsetHeight)-h;
}else{if(d.offsetTop<i.scrollTop){i.scrollTop=d.offsetTop;
}}}});
})(Telerik.Web.UI,$telerik.$);
(function(a,b,c){var d=b.Utils;
b.PlainTextSelector=function(f,g){this.toLeft=f;
var e=f?function(h,i){return d.isSignificantTextNode(h)&&(i>0&&i<=h.nodeValue.length);
}:function(h,i){return d.isSignificantTextNode(h)&&(i>=0&&i<h.nodeValue.length);
};
this.traverser=new b.DomTreeTraverser(e,g);
};
b.PlainTextSelector.prototype={selectNext:function(i){var g=i.startContainer,n=this.toLeft,h=i.startOffset,f=this.toLeft?this.traverser.left(g,h):this.traverser.right(g,h),j=n?-1:1,e=j;
if(f.node){var k=f.node.nodeValue,m=f.position,l;
while(k.charAt(m+j).match(/[\t\n\r]/)){j+=e;
}if(n){l=m;
m=m+j;
}else{l=m+j;
}i.setStart(f.node,m);
i.setEnd(f.node,l);
i.select();
}}};
})($telerik.$,Telerik.Web.UI.Editor);
Type.registerNamespace("Telerik.Web.UI");
Type.registerNamespace("Telerik.Web.UI.Editor");
(function(d,a,c,b,h){c.isControlOnDrag=false;
c.dragIsCancelled=false;
c.placeHolderID=null;
c.isPlaceHolder=false;
c.hasBeenDropped=false;
c.isHyperLink=false;
var e=["ul","ol","td","h1","h2","h3","h4","h5","h6","dd"];
var i=c.Utils;
var g=c.TrackChangesUtils;
var f=Telerik.Web.Browser;
a.registerControlProperties(d.RadEditor,{enableTrackChangesOverride:false,isAuthor:false,author:"",userCssId:"",tcInfoContainer:null,rangeStorage:null,enableCarriageReturn:false,enableInsertParagraphShortCut:false,enableShiftEnterShortCut:false,enableBoldShortCut:false,enableItalicShortCut:false,enableUnderlineShortCut:false,tempElement:document.createElement("div"),cancelBackspaceEventCaretPosition:0,cachedRange:null,elementToMove:null,reselectRange:false,iRange:null,origCutRange:null,contextMenuItems:null,commentID:"radTempCommentID",hasWorkFlowRole:false,canAcceptTrackChanges:false,canAcceptTrackChange:false,canRejectTrackChange:false,overrideWorkFlowAction:false,keyDownEvent:null,paragraphInserted:null,deletedElemName:"",origClipboardDataAsHtml:"",modifiedClipboardDataWithPlaceHolder:"",lockFormatting:true,copyCommandHit:false,clipboardData:{contentFromEditor:false,contentHTML:"",fromSelectionType:""},cutElement:{htmlText:null,selectionType:null,element:null}});
d.RadEditor.prototype.__original_initialize=d.RadEditor.prototype.initialize;
d.RadEditor.prototype.__original_pasteHtml=d.RadEditor.prototype.pasteHtml;
d.RadEditor.prototype.__original__initEvents=d.RadEditor.prototype._initEvents;
d.RadEditor.prototype.__original_onResizeEnd=d.RadEditor.prototype._onResizeEnd;
d.RadEditor.prototype.__original_getToolState=d.RadEditor.prototype.getToolState;
a.extend(d.RadEditor.prototype,{initialize:function(){var j=this;
j.__original_initialize(true);
var k=j.get_filtersManager();
k.removeFilterByName("FixUlBoldItalic");
k.removeFilterByName("FixEnclosingP");
c.UpdateCommandsArray.AcceptAllTrackChanges=new c.TrackChangesCommands.AcceptTrackChanges("Accept All Track Changes",j,null);
c.UpdateCommandsArray.AcceptTrackChange=c.UpdateCommandsArray.AcceptTrackChanges=new c.TrackChangesCommands.AcceptTrackChanges(null,j,null);
c.UpdateCommandsArray.RejectAllTrackChanges=new c.TrackChangesCommands.RejectTrackChanges("Reject All Track Changes",j,null);
c.UpdateCommandsArray.RejectTrackChange=c.UpdateCommandsArray.RejectTrackChanges=new c.TrackChangesCommands.RejectTrackChanges(null,j,null);
c.UpdateCommandsArray.RemoveTrackChanges=new c.TrackChangesCommands.RemoveTrackChanges(null,j,null);
c.UpdateCommandsArray.RemoveAllComments=new c.TrackChangesCommands.RemoveTrackChanges("Remove All Comments",j,null);
c.UpdateCommandsArray.RemoveComment=new c.TrackChangesCommands.RemoveTrackChanges(null,j,null);
c.UpdateCommandsArray.AddComment=new c.TrackChangesCommands.AddComment(null,j,null);
c.UpdateCommandsArray.EnableTrackChanges=new c.TrackChangesCommands.EnableTrackChanges(null,j,null);
c.UpdateCommandsArray.EnableTrackChangesOverride=new c.TrackChangesCommands.EnableTrackChangesOverride(null,j,null);
j.add_pasteDom(Function.createDelegate(j,j._pasteDomHandler));
j.add_pasteBlockElement(Function.createDelegate(j,j._pasteBlockElementHandler));
j.add_commandExecuted(Function.createDelegate(j,j._commandExecutedUndoRedoHandler));
j._raiseEditorLoad();
},executeCommand:function(m,n,j){var k=this;
if(!m.get_window()){m.set_window(k.get_contentWindow());
}if(false!=n&&!k.isOpera){k.setFocus();
}var o=k.shouldTrackChanges(),l;
if(o){l={formattingChanged:k._formattingChangedHandler};
m.on(l,k);
}k._commandsManager.execute(m,j);
if(o){m.off(l,k);
}},_formattingChangedHandler:function(j){var o=this,p=j.get_elements()||[],l=j.get_command(),k=o.get_author(),m=l.get_title();
var n=c.TrackerFactory.getCommandTracker(m,o);
if(!n){return;
}if(!j.get_applyFormat()){m="Remove "+m;
}if(l._innerCommand){n._innerCommand=l._innerCommand;
}for(var q=p.length-1;
q>=0;
q--){var r=p[q].node;
if(g.isTrackChangeElement(r)&&!i.isBlockElement(r)&&r.getAttribute(b.Attribute.Author)==k){p.splice(q,1);
}}n.trackFormattedNodes(p,m);
},_domChangedHandler:function(m,j){if(!m.shouldTrackChanges()){return;
}var k=j.get_commandName(),n=j.get_value(),l=c.TrackerFactory.getCommandTracker(k,m);
if(l){l.trackFormatting(n,k,m.get_author());
}},_trackChangesAttributesHandler:function(j){var m=this,n=j.get_elements()||[],k=j.get_command(),l=k.get_title();
var q=new Date().getTime();
for(var o=0;
o<n.length;
o++){var p=n[o].node;
if(p){m.setTrackChangesAttributes(p,l,q);
}}},get_htmlAcceptChanges:function(l,n){var m=this.get_html();
var j=this.get_filtersManager();
c.TrackChanges.setEditor(this);
c.TrackChanges.acceptAllChangesSilently();
if(n==true){j.add(new c.StripCommentsFilter());
}var k=this.get_html(l==true);
if(n==true){j.removeFilterByName("StripCommentsFilter");
}d.Editor.Utils.setElementInnerHtml(this.get_contentArea(),m);
return k;
},get_htmlRejectChanges:function(l,n){var m=this.get_html();
var j=this.get_filtersManager();
c.TrackChanges.setEditor(this);
c.TrackChanges.rejectAllChangesSilently();
if(n==true){j.add(new c.StripCommentsFilter());
}var k=this.get_html(l==true);
if(n==true){j.removeFilterByName("StripCommentsFilter");
}d.Editor.Utils.setElementInnerHtml(this.get_contentArea(),m);
return k;
},get_htmlStripComments:function(){var l=this.get_html();
var j=this.get_filtersManager();
j.add(new c.StripCommentsFilter());
var k=this.get_html(true);
j.removeFilterByName("StripCommentsFilter");
d.Editor.Utils.setElementInnerHtml(this.get_contentArea(),l);
return k;
},_commandExecutedUndoRedoHandler:function(p,j){var m=j.get_commandName?j.get_commandName():null;
var s=m=="Undo";
var r=m=="Redo";
if(!s&&!r){return;
}var o=p.get_commandsManager();
var n=o.get_commands();
var l=o._currentCommandIndex;
l+=s?1:0;
l=Math.min(l,n.length-1);
l=Math.max(l,0);
var k=n[l];
if(!k||k.get_title()!="Delete"){return;
}var t=k.options;
if(t&&t.collapsedRange){var u=p.getDomRange();
var q=t.isDeleteLeft;
u.collapse(s?!q:q);
u.select();
}},pasteHtml:function(n,m,l,k,j){var o=this;
if(!o.shouldTrackChanges()){o.__original_pasteHtml(n,m,l,k,j);
return;
}var p=g.getDomRange(o);
if(!p.collapsed){o._executeDeleteCommand(false);
p=g.getDomRange(o);
p.collapse(false);
p.select();
}o.__original_pasteHtml(n,m,l,k,j);
},_clearTrackedInlineAncestors:function(n,j){var m=this;
var l=m.get_document();
var p=c.DomRange.createRange(l);
var o=l.createTextNode("a");
n.parentNode.replaceChild(o,n);
p.selectNodeContents(o);
p.select();
var k=new c.TrackChangesRemoveFormat(m,{removeTrackedNodes:!j});
k.onExecute();
o.parentNode.replaceChild(n,o);
},_pasteDomHandler:function(m,j){var k=j.get_element(),l=j.get_cursor();
if(m.get_enableTrackChanges()&&m.get_enableTrackChangesOverride()&&g.getTrackedAncestor(l)){var n=!/[<>]/.test(k.innerHTML);
m._clearTrackedInlineAncestors(l,n);
}if(m.shouldTrackChanges()){m._pasteDomEnabledTrackChanges(k,l);
}if(m.get_enableComments()){m._pasteDomEnabledComments(l);
}},_pasteDomEnabledTrackChanges:function(j,l){var m=this;
m._acceptAllTrackChanges(j);
var o=g.findTrackChangesParentNode(l,"DEL");
if(o){a(l).insertAfter(o);
}var p=g.findTrackChangesParentNode(l,"INS");
if(p){m._insertElement=p.cloneNode(true);
i.removeChildren(m._insertElement);
return;
}var n=m._createInsertTrackChangeNode(),k=n.cloneNode(true);
m._insertElement=n;
if(!i.getElementParentByTag(l,"P")){a(j).wrapInner(k);
return;
}this._wrapFirstInlineChildren(j,k);
},_pasteDomEnabledComments:function(k){var j=c.TrackChangesUtils.findParentComment(k);
if(j){a(k).insertAfter(j);
}},_wrapFirstInlineChildren:function(k,n){var m=k.ownerDocument.createDocumentFragment();
for(var l=0;
l<k.childNodes.length;
l++){var j=k.childNodes[l];
if(i.isTextNode(j)&&i.isTextNodeEmpty(j)&&!m.childNodes.length){continue;
}if(!i.isBlockElement(j)){m.appendChild(j);
l--;
}else{break;
}}if(m.childNodes.length){k.insertBefore(n,k.firstChild);
n.appendChild(m);
}},_pasteBlockElementHandler:function(k,j){if(k.shouldTrackChanges()){var l=j.get_element();
var m=k._insertElement;
var n=c.Utils.getElementParentByTag(l,"INS");
if(!n||!c.TrackChangesUtils.isTrackChangeElement(n)){a(l).wrap(m.cloneNode(true));
}}},_acceptAllTrackChanges:function(m){var l=this;
var j=a(m).find("*").filter(function(n,o){return g.isTrackChangeElement(o);
});
if(!j.length){return;
}var k=new c.TrackChangesCommands.AcceptTrackChanges(null,l,null);
j.each(function(n,o){var p=g.findTrackChangesParentElement(o);
if(p){k.acceptElementChange(p);
}});
},_createInsertTrackChangeNode:function(){var j=this;
var k=j.get_document().createElement("ins");
j.setTrackChangesAttributes(k,"Insert");
return k;
},_initEvents:function(){var j=this;
if(j.__original__initEvents){j.__original__initEvents();
}j.add_domChange(Function.createDelegate(j,j._domChangedHandler));
j.attachInternalHandler("keypress",Function.createDelegate(j,j._keyPressHandler));
j.attachInternalHandler("keydown",Function.createDelegate(j,j._keyDownHandlerEnableTrackChangesOverride));
j.attachInternalHandler("keydown",Function.createDelegate(j,j._keyDownHandler));
},_keyPressHandler:function(n){var o=this,q=null,m=null,l=null,j=o._shouldIgnoreKey(n)||!o.shouldTrackChanges();
if(j||o.get_mode()!=Telerik.Web.UI.EditModes.Design){return;
}q=o.getSelection().getRange(true);
l=q.parentElement?q.parentElement():q.commonAncestorContainer;
if(o._isElementInTrackedInsNode(l)){return;
}else{m=o.getDomRange();
var k;
var p=i.isZwspTextNode(m.commonAncestorContainer);
if(!m.isCollapsed()&&!p){o._deleteContentWhenTypingInSelection(m);
}if(p){k=m.cloneRange();
m.setStart(m.commonAncestorContainer,m.commonAncestorContainer.length);
m.collapse(true);
m.select();
}o._executeInsertCommand();
if(k){k.select();
}}},_deleteContentWhenTypingInSelection:function(j){var k=this,l=[],m=null;
k._deleteDirectionLeft=false;
k._deleteContentWithSelection(j);
j=k.getDomRange();
if(k._shouldCollapseSelection){k._collapseRange(j);
}if(k._elementsTrackedForDeletion&&k._elementsTrackedForDeletion.length>0){l=k._elementsTrackedForDeletion;
m=l[l.length-1].node;
if(k._isRangeCollapsedInNode(j,m)){return;
}if(m.nextSibling){if($telerik.isIE7||$telerik.isIE8||($telerik.isSafari&&!$telerik.isChrome)){k._insertZeroWidthCharacterAfterNode(m,1,1);
}else{j.setStartAfter(m);
j.setEndAfter(m);
j.collapse(true);
j.select();
}}else{if($telerik.isIE7||$telerik.isIE8||($telerik.isSafari&&!$telerik.isChrome)){k._insertZeroWidthCharacterAfterNode(m,1,1);
}else{k._insertZeroWidthCharacterAfterNode(m,0,0);
}}}},_isRangeCollapsedInNode:function(l,k){var j=l.commonAncestorContainer;
if(!l.collapsed||!c.Utils.isTextNode(j)){return false;
}return j.length>l.startOffset&&a.contains(k,j);
},_insertZeroWidthCharacterAfterNode:function(l,o,n){var k=this,j=null,m="\u200b";
j=k.getDomRange();
var p=k.get_document().createTextNode(m);
a(p).insertAfter(l);
c.Utils._setCursorInTextNode(j,p,o,n);
k.whitespaceTracker.trackNode(p);
},_shouldIgnoreKey:function(l){if(l.ctrlKey||l.altKey||l.metaKey){return true;
}else{var o=l.keyCode;
var n=Sys.UI.Key;
var m=45,j=46;
if("code" in l&&/^Digit/.test(l.code)){return false;
}if("key" in l&&/^(?:Digit|!|#|\$|%|&|\()/.test(l.key)){return false;
}if(f.ie&&o>=33&&o<=40){return false;
}switch(o){case n.enter:case n.backspace:case n.pageUp:case n.pageDown:case n.end:case n.home:case n.left:case n.up:case n.right:case n.down:case m:case j:return true;
}}return false;
},_isElementInTrackedInsNode:function(k){var j=this,l=j._getParentInsNode(k);
return c.TrackChangesUtils.isTrackChangeElement(l)&&j._isSameAuthor(l);
},_getParentInsNode:function(j){j=i.isTextNode(j)?j.parentNode:j;
return i.isTag(j,b.TagInsert)?j:i.getElementParentByTag(j,b.TagInsert.toUpperCase());
},_executeInsertCommand:function(){var j=this;
var l=new c.TrackChangesInsert(j);
if(l){var k={formattingChanged:j._trackChangesAttributesHandler};
l.on(k,j);
l.onExecute();
l.off(k,j);
}},_keyDownHandler:function(n){var o=this;
if(this.get_mode()!=Telerik.Web.UI.EditModes.Design){return;
}var j=new Date().getTime().toString();
j=parseInt(j,10);
o.set_keyDownEvent(n);
o.set_copyCommandHit(false);
var l=false;
var w=o._shortCutManager.isShortCutHit(n),q;
if(null!=w){var t=w.get_name();
if(t=="Cut"){return;
}switch(t){case"Copy":o.set_copyCommandHit(true);
break;
case"Enter":case"ShiftEnter":case"InsertParagraph":case"Bold":case"Italic":case"Underline":if(!o.get_enableCarriageReturn()||!o.get_enableInsertParagraphShortCut()||!o.get_enableShiftEnterShortCut()||!o.get_enableBoldShortCut()||!o.get_enableItalicShortCut()||!o.get_enableUnderlineShortCut()){l=true;
}break;
case"Paste":q=true;
}}if(l){return $telerik.cancelRawEvent(n);
}if(!o.get_enableTrackChanges()||o.get_enableTrackChangesOverride()){return true;
}var v=o.getSelection();
var u=new c.DomRange(v.getRange(true));
if(!u){return;
}var r=function(y){return i.isTag(y,"td");
};
var x=i.getElementParentByCondition(u.startContainer,r);
var p=u.isCollapsed?x:i.getElementParentByCondition(u.endContainer,r);
if((x||p)&&x!=p){return $telerik.cancelRawEvent(n);
}o.set_deletedElemName(j.toString());
if(!o.shouldTrackChanges()||q){return true;
}var s=n.keyCode,k=8,m=46;
if(s!=m&&s!=k){return true;
}o._deleteDirectionLeft=s==k;
o._shouldExecuteRawKeyDownEvent=false;
o._deleteContent(u);
o._executeRawKeyDownEvent(n);
return true;
},_keyDownHandlerEnableTrackChangesOverride:function(m){var n=this;
if(this.get_mode()!=Telerik.Web.UI.EditModes.Design){return;
}var k=n.get_document();
var s=(m.keyCode===32);
if(!n.get_enableTrackChangesOverride()||!i.isTypingKey(m)){return;
}var u=n.getSelection(),l=c.DomRange.toDomRange(u.getRange(true)),w=l.startContainer,o=l.endContainer,y=g.getTrackedParentNode(w),q=g.getTrackedParentNode(o),t=y&&!i.isBlockElement(y),r=q&&!i.isBlockElement(q);
if(!t&&!r){return;
}var x=i.getElementParentByTag((i.isTextNode(w)?w.parentNode:w),"TD"),p=(l.collapsed||w===o)?x:i.getElementParentByTag((i.isTextNode(o)?o.parentNode:o),"TD");
if(x||p){return;
}if((t&&!r)||(!t&&r)){k.execCommand("delete",false,null);
l=c.DomRange.toDomRange(u.getRange(true));
}var j=new c.TrackChangesRemoveFormat(n),z=j.getState(null,n,l);
if(z!=c.CommandStates.On){return;
}var A;
if(l.collapsed){A=k.createTextNode("a");
l.insertNode(A);
i._setCursorInTextNode(l,A,0,1);
}j.onExecute();
if(s&&A){var v=(A.length===1&&!A.nextSibling)?"\xA0":"\x20";
A.nodeValue=v+A.nodeValue.substring(1);
l.setStart(A,1);
l.setEnd(A,1);
l.select();
$telerik.preventDefault(m);
}},_executeRawKeyDownEvent:function(j){var k=this;
if(k._shouldExecuteRawKeyDownEvent){k._shouldExecuteRawKeyDownEvent=false;
}else{if(j.type.toLowerCase()==="keydown"){$telerik.cancelRawEvent(j);
}}},_isDeleteDirectionLeft:function(){return(this._deleteDirectionLeft===true);
},_deleteContent:function(l){var k=this;
if(l){if(l.isCollapsed()){k._deleteContentInCollapsedRange(l);
}else{k._deleteContentWithSelection(l);
if(k._shouldCollapseSelection){l=k.getDomRange();
try{k._collapseRange(l);
}catch(j){}}}}},_deleteContentInCollapsedRange:function(l){var j=this,m=new c.PlainTextSelector(j._isDeleteDirectionLeft(),j.get_contentArea()),k=j._getEmptyBlockElementToDelete(l.startContainer);
m.selectNext(l);
if(!l.isCollapsed()&&!k){if(j._isRangeInEditableNode(l)){j._executeDeleteCommand(true);
}else{j._collapseRange(l);
}}if(j._deleteEmptyBlockElement(k)){j._shouldExecuteRawKeyDownEvent=false;
j._deleteDirectionLeft=!j._deleteDirectionLeft;
j._collapseRange(l);
}},_getEmptyBlockElementToDelete:function(j){if(!i.isBlockElement(j)){j=i.getBlockParent(j);
}if(i.isEditorContentArea(j)){return;
}if(a.inArray(j.nodeName,e)==-1&&this._isEmptyBlock(j)){return j;
}},_isEmptyBlock:function(l){var k=l.lastChild;
var j;
if(i.isTag(k,"br")){j=l.removeChild(k);
}var m=i.isNodeEmptyRecursive(l);
if(j){l.appendChild(j);
}return m;
},_deleteEmptyBlockElement:function(j){if(j){var l=j.parentNode;
var k=i.isList(l)&&l.children.length==1?l:j;
k.parentNode.removeChild(k);
return true;
}},_deleteContentWithSelection:function(k){var j=this;
j._shouldCollapseSelection=true;
j._executeDeleteCommand(false);
},_collapseRange:function(l){var k=this;
if(k._isDeleteDirectionLeft()){if(k._shouldExecuteRawKeyDownEvent===true){l.collapse(false);
}else{l.collapse(true);
}}else{if(k._shouldExecuteRawKeyDownEvent===true){l.collapse(true);
}else{l.collapse(false);
}}try{l.select();
}catch(j){}},_isRangeInEditableNode:function(m){if(!m){return false;
}var j=this,k=m.commonAncestorContainer,l=null,p=m.startOffset,o=m.startContainer,n=null;
if(c.Utils.isTextNode(k)){l=g.getTrackedParentNode(k);
if(l){return j._isInEditableNode(l);
}}if(p===o.childNodes.length){n=o.childNodes[p-1];
}else{n=o.childNodes[p];
}l=g.getTrackedParentNode(n);
if(l){return j._isInEditableNode(l);
}return true;
},_isInEditableNode:function(k){var j=this;
if(!j.get_author()){return false;
}if(j._isInTrackedInsTag(k)){j._shouldExecuteRawKeyDownEvent=true;
j._shouldCollapseSelection=false;
return false;
}if(!j._isInTrackedDelete(k)){return true;
}return(j._isNodeEditableByAuthor(k));
},_isNodeEditableByAuthor:function(l){var j=a(l).attr(b.Attribute.Author);
var k=a(l).attr(b.Attribute.Cite);
if(j&&!k){return false;
}else{if(k&&!j){return false;
}else{if(!j&&!k){return true;
}}}},_isInTrackedDelete:function(j){var k=c.TrackChangesUtils.getParentTrackChangesDeleteNode(j);
return k&&this._isSameAuthor(k);
},_isInTrackedInsTag:function(k){var j=this;
var l=b.TagInsert;
return i.getElementParentByCondition(k,function(m){return i.isTag(m,l)&&g.isTrackChangeElement(m)&&j._isSameAuthor(m);
});
},_isSameAuthor:function(j){return this.get_author()==j.getAttribute("author");
},_setCollapseSelectionFlag:function(){var j=this;
j._shouldCollapseSelection=true;
},_isEmptyTextNode:function(j){return(c.Utils.isTextNode(j)&&c.Utils.isTextNodeEmpty(j));
},_executeDeleteCommand:function(j){var l=this;
var k=new c.TrackChangesDelete(l,{isDeleteLeft:l._isDeleteDirectionLeft(),collapsedRange:j});
if(!k){return;
}l._elementsTrackedForDeletion=[];
l._executeCommand(k);
var m=a.makeArray(k.elements);
l._updateRangeAfterDeleteCommand(m);
l._elementsTrackedForDeletion=m;
k.clearTrackedNodes();
},_selectAfter:function(j){var k=this.getDomRange();
k.setStartAfter(j);
k.collapse(true);
k.select();
},_executeCommand:function(k,j){var l=this;
j=j!==false;
var m={formattingChanged:l._trackChangesAttributesHandler};
k.on(m,l);
l._commandsManager.execute(k,j);
l._hasDeleteExecuted=null;
l._pendingTextTypeCmd=null;
k.off(m,l);
},_updateRangeAfterDeleteCommand:function(j){if(!j||!j.length){return;
}var k=this,n=k.getDomRange();
if(k._isDeleteDirectionLeft()){if(!c.Utils.isTextNode(n.startContainer)){var l=j[0].node;
k._setRangeStartBefore(n,l);
}n.collapse(true);
}else{var m=j[j.length-1].node;
if(!a.contains(k.get_contentArea(),m)){m=n.endContainer.childNodes[n.endOffset-1]||n.endContainer;
j[j.length-1].node=m;
}k._setRangeStartAfter(n,m);
n.collapse(false);
}n.select();
},_setRangeStartBefore:function(k,j){k.setStart(j,0);
},_setRangeStartAfter:function(k,j){k.setStart(j,1);
},setTrackChangesAttributes:function(m,k,n){var l=this,j=l.get_author(),o=l.get_userCssId();
c.TrackChangesUtils.setTrackChangesAttributes(m,k,j,o,n);
},_onTableDeleting:function(j){var k=this;
var n=j.get_target();
var l=g.getParentTrackChangesInsertNode(n,k.get_contentArea());
if(!k.shouldTrackChanges()||(l&&g.isTrackChangeElement(l))){k._deleteTable(n);
}else{var m=k.getDomRange();
k._deleteContent(m);
}},storeSelection:function(k){var j=c.DomRange.toDomRange(k);
this._rangeStorage=j.cloneRange();
},restoreSelection:function(m){var k=this;
var l=k.get_keyDownEvent();
if(l){if("keyCode" in l){try{if(l.shiftKey&&(l.keyCode==37||l.keyCode==38||l.keyCode==39||l.keyCode==40)){return;
}}catch(j){}}}if(this._rangeStorage){this._rangeStorage.select();
}},_onResizeEnd:function(j){var k=this.getSelection();
var l=k.getParentElement();
var m=l.attributes.tagid;
if(m){l.removeAttribute("width");
l.removeAttribute("height");
l.style.cssText="display: inline; background-color: lightgrey;";
}if((l.tagName=="SPAN"||l.tagName=="FONT")&&l.contentEditable=="false"){l.style.cssText="display: inline; background-color: lightgrey;";
}this.__original_onResizeEnd(j);
},getToolState:function(l,k){switch(l){case"AcceptAllTrackChanges":case"AcceptTrackChange":case"AcceptTrackChanges":case"RejectAllTrackChanges":case"RejectTrackChange":case"RejectTrackChanges":case"RemoveTrackChanges":case"RemoveAllComments":case"RemoveComment":case"AddComment":case"EnableTrackChanges":case"EnableTrackChangesOverride":var j=d.Editor.UpdateCommandsArray[l];
j.set_editor(this);
j._toolName=l;
if(j&&j.getState){return j.getState(this.get_contentWindow());
}break;
}return this.__original_getToolState(l,k);
},enableContentArea:function(k){if(this.isIE){if(!k){var j=c.TrackChangesUtils.getDomRange(this);
if(j.getHtml()==""){this.enableContentAreaRange=j;
}}this.get_contentArea().setAttribute("contentEditable",""+k);
if(k&&this.enableContentAreaRange){this.enableContentAreaRange.select();
this.enableContentAreaRange=null;
}}},getTrueParent:function(j){function k(l){if(l){if(l.parentElement){if($telerik.getOuterHtml(l)==l.parentElement.innerHTML){return k(l.parentElement);
}}}return l;
}return k(j);
},checkIfRangeHasTrackChange:function(m){var r=c.TrackChangesSelection;
var q=new c.DomRange(this.getSelection().getRange());
var k=r.locateElementInRange(q,"del");
var n=r.locateElementInRange(q,"ins");
var j=r.locateElementInRange(q,"comment");
var o=r.locateElementInRange(q,"placeholder");
var p=false;
if(o.fullySelected&&q.getText().length){var l=q.getParentElement().parentElement.parentElement;
if(l.tagName.toLowerCase()=="ins"||l.tagName.toLowerCase()=="del"){p=true;
}}if(n.inRange||k.inRange||j.inRange){p=true;
}return p;
},checkIfRangeIsInEndOfElement:function(l,p){p=c.DomRange.toDomRange(p);
var t=false;
function j(u){r.selectNodeContents(u);
s=r.getText().replace(/[\r\n]/mg,"");
if(s==n){t=true;
}if(n.length>s.length){if(u.parentElement){j(u.parentElement);
}}}if(p&&l){var m=c.Utils.getTextContent(l)||"";
var o=m.replace("\r","").length;
var s="";
var n="";
var q=p.cloneRange();
var r=p.cloneRange();
try{q.moveStart("character",-o);
n=q.getText().replace(/[\r\n]/mg,"");
j(l);
}catch(k){}p.select();
}return t;
},checkIfRangeIsInStartOfElement:function(l,p){p=c.DomRange.toDomRange(p);
var t=false;
function j(u){r.selectNodeContents(u);
s=r.getText().replace(/[\r\n]/mg,"");
if(s==n){t=true;
}if(n.length>s.length){if(u.parentElement){j(u.parentElement);
}}}if(p&&l){var m=c.Utils.getTextContent(l)||"";
var o=m.replace("\r","").length;
var s="";
var n="";
var q=p.cloneRange();
var r=p.cloneRange();
try{q.moveEnd("character",o);
n=q.getText().replace(/[\r\n]/mg,"");
j(l);
}catch(k){}p.select();
}return t;
},_insertTagAdjacentElement:function(o,s,n,l){if(null==o){o="afterEnd";
}if(null==n){n="&nbsp";
}if(null==s){s="font";
}var t=this._document.getElementById("vrtxInsertElement");
var j=o=="afterEnd"?false:true;
if(!t||t==h){var r=this.getSelectedElement();
var q=c.TrackChangesUtils.findTrackChangesParentElement(r);
if(q){q.HtmlElement.insertAdjacentHTML(o,"<"+s+' id="vrtxInsertElement">'+n+"</"+s+">");
}else{if(r.tagName.toLowerCase()=="td"){r=r.children[0];
}r.insertAdjacentHTML(o,"<"+s+' id="vrtxInsertElement">'+n+"</"+s+">");
}t=this._document.getElementById("vrtxInsertElement");
}if(t){try{t.removeAttribute("id");
this.selectElement(t);
if(l){if(j){var p=this.getSelection().getRange();
var m=p.findText(" ");
if(m){p.select();
p.collapse(false);
}}else{this.getSelection().collapse(j);
t.innerHTML="";
}}else{this.getSelection().collapse(j);
}}catch(k){return false;
}}return true;
},set_enableTrackChangesOverride:function(j){this._enableTrackChangesOverride=j?true:false;
},shouldTrackChanges:function(){return this.get_enableTrackChanges()&&!this.get_enableTrackChangesOverride();
},get_isAuthor:function(){return true;
},set_isAuthor:function(j){this._isAuthor=j?true:false;
},set_author:function(j){this._author=j;
},set_userCssId:function(j){this._userCssId=j;
},get_contextMenuItemsToDisable:function(){return this._contextMenuItems;
},set_contextMenuItemsToDisable:function(j){this._contextMenuItems=j;
},set_clipboardData:function(j){this._clipboardData=j;
},get_clipboardData:function(){return this._clipboardData;
},moveToParagraphInserted:function(t,j){function o(u){var v=c.Utils.getTextContent(u)||"";
return(u.nodeName=="P"&&v=="");
}if(t.get_paragraphInserted()){var s=t.getSelection();
if(!s.isControl()){var q=s.getParentElement();
var p=q.lastChild;
var l=j;
try{if(p&&p.nodeName!="P"){var k=p.children;
while(k.length>0){if(k.length==1){if(o(k[0])){p=k[0];
break;
}k=k[0].children;
}else{if(k.length>1){for(var n=0;
n<k.length;
n++){if(o(k[n])){p=k[n];
break;
}}break;
}}}}}catch(m){}if(p&&o(p)){p.innerText=p.textContent=l;
t.selectElement(p);
var r=s.getRange();
t.set_paragraphInserted(false);
return r;
}}}t.set_paragraphInserted(false);
return false;
},executeTrackChangesCommand:function(k,j,o,l){var m=this._localization[k]||k;
var n=null;
switch(k){case"AcceptTrackChange":case"AcceptTrackChanges":n=new c.TrackChangesCommands.AcceptTrackChanges(m,this,null);
break;
case"RejectTrackChange":case"RejectTrackChanges":n=new c.TrackChangesCommands.RejectTrackChanges(m,this,null);
break;
case"RemoveTrackChanges":case"RemoveComment":n=new c.TrackChangesCommands.RemoveTrackChanges(m,this,null);
break;
case"AddComment":n=new c.TrackChangesCommands.AddComment(m,this,null);
break;
default:alert(k+" track change command is not implemented yet.");
}this.executeCommand(n);
this.setActive();
this.setFocus();
this.raiseEvent("selectionChange",Sys.EventArgs.Empty);
},_canEditSelection:function(j){return true;
},get_paragraphs:function(){if(null==this._paragraphs){return[["<p>","Normal"],["<h1>","<h1>Heading 1</h1>"],["<h2>","<h2>Heading 2</h2>"],["<h3>","<h3>Heading 3</h3>"],["<h4>","<h4>Heading 4</h4>"],["<h5>","<h5>Heading 5</h5>"],["<h6>","<h6>Heading 6</h6>"],["<p class='MsoHeading7'>","<p class='MsoHeading7'>Heading 7</p>"],["<p class='MsoHeading8'>","<p class='MsoHeading8'>Heading 8</p>"],["<h5>","<dir>Directory List</dir>"],["<menu>","<menu>Menu List</menu>"],["<pre>","<pre>Formatted</pre>"],["<address>","<address>Address</address>"]];
}return this._paragraphs;
},addToStack:function(l){var j=Telerik.Web.UI;
var k=new j.Editor.GenericCommand(l,this._contentWindow);
var m=this.get_commandsManager();
m.execute(k,true);
},removeFromStack:function(k){var m=this.get_commandsManager();
var l=m.get_commands();
var j=l.length;
if(j>0){if(k==l[j-1]._title){m.removeCommandAt(j-1);
}}}});
})(Telerik.Web.UI,$telerik.$,Telerik.Web.UI.Editor,Telerik.Web.UI.Editor.TrackChangesConstants);
Type.registerNamespace("Telerik.Web.UI");
Type.registerNamespace("Telerik.Web.UI.Editor");
(function(d,a,c,b){c.TrackChanges=(function(){var l=null;
var m=null;
var A=null;
var z=null;
var B=null;
var i=null;
var E=null;
var N=false;
var R="Reject";
var e=$telerik.$;
var O="";
var x=function(S){l=S;
m=S._contentArea;
L();
K();
};
var L=function(){z=false;
B=false;
A=false;
i=0;
E=0;
};
var K=function(){if(!l){return;
}var S=l.get_skin();
O=l.get_renderMode()==d.RenderMode.Lite?"RadEditor RadEditor_"+S:S;
};
var I=function(){try{l.get_document().execCommand("SelectAll",false,null);
l.getSelection().collapse();
}catch(S){}return;
};
var J=function(S){l=S;
m=S.get_contentArea();
K();
};
var t=function(S){return s(S).concat(s("TABLE"));
};
var q=function(T){var S=b.CssClassNamePrefixComment;
return r(T,S).concat(r("TABLE",S));
};
var u=function(U){var T=[];
var V=m.getElementsByTagName(U);
if(V.length>0){for(var S=0;
S<V.length;
S++){if(Q(V[S])){T.push(V[S]);
}}}return T;
};
var s=function(S){return r(S,b.CssClassNamePrefixFormat);
};
var r=function(T,S){return e(m).find(T+"."+S).toArray();
};
var Q=function(S){return C(S);
};
var v=function(){var T=[];
if(A){var W=q("font");
if(W.length<1){W=q("span");
}T.push(W);
}else{var S=u("ins");
var V=u("del");
var U=t("");
T.push(S);
T.push(V);
T.push(U);
}return T;
};
var w=function(){e("#rade_tccomment_divEdit_id_"+l._clientStateFieldID).hide();
e("#rade_tccomment_divView_id_"+l._clientStateFieldID).hide();
e("#rade_tccomment_divInfo_id_"+l._clientStateFieldID).hide();
};
var p=function(T,U){try{if(c.Utils.isAncestorOf(m,T)){var V=c.TrackChangesUtils.getDomRange(l);
V.selectNodeContents(T);
V.select();
}if(U){w();
}return true;
}catch(S){return false;
}};
var h=function(){return l.get_isAuthor()?true:l._canEditSelection();
};
var o=function(){R=!l.get_canRejectTrackChange()?"Remove":"Reject";
try{window.setTimeout(function(){var T=A?"Remove All Comments":z?"Accept All Changes":R+" All Changes";
c.Dialogs.showConfirm("Do you want to proceed anyway?",T,O,function(U){if(U){c.Dialogs.showOverlay();
l.setFocus();
g();
}else{L();
}});
},1);
}catch(S){alert("Error encountered while executing the command...");
}};
var g=function(){var T=0;
var S=A?"RemoveTrackChanges,Remove All Comments":z?"AcceptTrackChanges,Accept All Changes":"RejectTrackChanges,"+R+" All Changes";
var W=v();
for(var X=0;
X<W.length;
X++){for(var Y=0;
Y<W[X].length;
Y++){var V=W[X][Y];
if(V.tagName){if(p(V,true)&&h()){try{l.executeTrackChangesCommand(S.split(",")[0],false,null,null);
i++;
T++;
}catch(U){continue;
}}}}}if(F(T)){n(S);
}};
var F=function(S){if(i>0&&S>0){E++;
if(A){if(E>10){return true;
}}else{if(E>5){return true;
}}P(10);
g();
return false;
}return true;
};
var n=function(S){if(E>2){i--;
var T=z;
window.setTimeout(function(){H(T);
},1000);
}var V=S.split(",")[1];
var U="Changes successfully executed.";
if(i<1){U="No changes has been made.";
}I();
L();
if(!N){c.Dialogs.showAlert(U,V,O);
}};
var H=function(X){var W=u("ins");
var T=u("del");
var S=q("font");
function Z(ab){if(ab){var ae=ab.parentElement;
var af=document.createElement("FONT");
if(Q(ab)&&(ab.tagName=="DEL"||ab.tagName=="INS")){if(p(ab,true)&&h()){try{var ad=c.Utils.getTextContent(ab);
var ac=ab.innerHTML;
if(ad.trim()!=""){if((ab.nodeName=="INS"&&X)||(ab.nodeName=="DEL"&&!X)){af.innerHTML=ac;
ae.replaceChild(af,ab);
}else{if(!(ab.nodeName=="DEL"&&X)){ae.removeChild(ab);
}}}else{ae.removeChild(ab);
}}catch(aa){return;
}}}if(Q(ab)&&ab.className.match(b.CommentsRegex)){if(p(ab,true)&&h()){af.innerHTML=ab.innerHTML;
ae.replaceChild(af,ab);
}}}}if(S.length>0){for(var U=0;
U<S.length;
U++){Z(S[U]);
}}if(W.length>0){for(var V=0;
V<W.length;
V++){Z(W[V]);
}}if(T.length>0){for(var Y=0;
Y<T.length;
Y++){Z(T[Y]);
}}};
var M=function(S){return;
};
var D=function(){return;
};
var C=function(S){return c.TrackChangesUtils.isTrackChangeElement(S);
};
var P=function(T){var S=new Date().getTime();
var U=1;
while(new Date().getTime()<S+T){U=1;
}};
var y=function(aa,ae,Y,W,V){var U=typeof(V)!="undefined"?V:l;
try{var Z=U.get_keyDownEvent();
var ab=String.fromCharCode(Z.keyCode).match(/^\w+([\s-_]\w+)*$/i);
if(!ab){return false;
}}catch(T){}if(null==aa){aa="afterEnd";
}if(null==Y){Y="&nbsp";
}if(null==ae){ae="font";
}var af=U._document.getElementById("vrtxInsertElement");
var S=aa=="afterEnd"?false:true;
if(!af||af==undefined){var ad=U.getSelectedElement();
ad.insertAdjacentHTML(aa,"<"+ae+' id="vrtxInsertElement">'+Y+"</"+ae+">");
af=U._document.getElementById("vrtxInsertElement");
}if(af){try{af.removeAttribute("id");
U.selectElement(af);
if(W){if(S){var ac=U.getSelection().getRange();
var X=ac.findText(" ");
if(X){ac.select();
ac.collapse(false);
}}else{U.getSelection().collapse(S);
af.innerHTML="";
}}else{U.getSelection().collapse(S);
}}catch(T){return false;
}}return true;
};
var j=function(T,S){var U=T;
var X={startOfElement:false,endOfElement:false,selectionStart:-1,selectionEnd:-1};
var W=c.TrackChangesUtils.getDomRange(S);
var Y=W.cloneRange();
Y.selectNodeContents(U);
Y.snapToRange(c.DomRange.END_TO_END,W);
U.selectionStart=Y.getText().length-W.getText().length;
U.selectionEnd=U.selectionStart+W.getText().length;
X.selectionStart=U.selectionStart;
X.selectionEnd=U.selectionEnd;
if(Y.getText().length==0){X.startOfElement=true;
}var V=d.Editor.Utils.getTextContent(U)||"";
if(Y.getText().length==V.length){X.endOfElement=true;
}return X;
};
var k=function(U,T){var S=typeof(T)!="undefined"?T:l;
if(typeof(U)=="undefined"||null==U){var W=document.selection?document.selection.createRange():S.getSelection().getRange();
if(!W||W.length==1){return false;
}U=W.parentElement?W.parentElement():W.commonAncestorContainer;
}if(U.nodeName.toLowerCase()=="font"&&U.className.match(b.CommentsRegex)){if(j(U,T).endOfElement){y("afterEnd","font","&nbsp;",true,T);
}}if(!S.getSelection().isControl()&&!S._canEditSelection()){if(U.nodeName.toLowerCase()=="ins"&&U.getAttribute(b.Attribute.Cite)){var V=j(U,T);
if(V.endOfElement){y("afterEnd","font","&nbsp;",true,T);
}else{if(V.startOfElement){y("beforeBegin","font","&nbsp;",true,T);
}}}}};
var f=function(U,X,S){var W=(typeof(X)!="undefined"&&X!=null)?X:l;
var T=new c.GenericCommand(U,W._contentWindow);
var V=W.get_commandsManager();
if(typeof(S)=="undefined"||S==null){S=true;
}V.execute(T,S);
};
var G=function(T,X){var W=(typeof(X)!="undefined"&&X!=null)?X:l;
var V=W.get_commandsManager();
var U=V.get_commands();
var S=U.length;
if(S>0){if(T==U[S-1]._title){V.removeCommandAt(S-1);
}}};
return{initialize:function(S){x(S);
},acceptAllChanges:function(){z=true;
o();
},acceptAllChangesSilently:function(){z=true;
l.setFocus();
try{N=true;
g();
}finally{N=false;
}},rejectAllChanges:function(){B=true;
o();
},rejectAllChangesSilently:function(){B=true;
l.setFocus();
try{N=true;
g();
}finally{N=false;
}},removeAllComments:function(){A=true;
o();
},moveToNextTrackChange:function(){D();
},setNextTrackChange:function(S){M(S);
},sleep:function(S){P(S);
},insertAdjacentElement:function(V,W,U,T,S){return y(V,W,U,T,S);
},checkElementEndPoint:function(T,S){return j(T,S);
},checkInsertionPoint:function(T,S){return k(T,S);
},addToStack:function(T,U,S){f(T,U,S);
},removeFromStack:function(S,T){G(S,T);
},setEditor:function(S){J(S);
}};
})();
})(Telerik.Web.UI,$telerik.$,Telerik.Web.UI.Editor,Telerik.Web.UI.Editor.TrackChangesConstants);
(function(a,b,f,d,c,e){b.TrackChangesDelete=function(g,h){h=h||{};
h.title="Delete";
b.TrackChangesDelete.initializeBase(this,[g,b.InlineCommandSettings.TrackChangesDelete,h]);
};
b.TrackChangesDelete.prototype={getState:function(i,g,h){return b.CommandStates.Off;
},removeNodeFormatting:function(i){var g=this;
if(g.isSameAuthorInsert(i)){var h=i;
while(i&&i.parentNode&&f.isSingleChild(i)&&!f.isEditorContentArea(i.parentNode)){i=i.parentNode;
}g.deleteNode(i);
g.cleanUpFragment.removeNode(h);
}else{f.removeNode(i);
}},deleteNode:function(j){var g=this;
var i=a.makeArray(a(j).find("."+g.getMarkersCssClass()));
var k=j.parentNode;
while(i.length){var h=i.pop();
k.insertBefore(h,j);
}k.removeChild(j);
},shouldRemoveNode:function(g){return !this.isSameAuthorInsert(g);
},isSameFormatNode:function(g){return(f.isTag(g,"ins")||f.isTag(g,"del"))&&d.isTrackChangeElement(g)&&d.getTrackChangesCommand(g)!="StrikeThrough";
},_isTrackedInsNode:function(g){return f.isTag(g,"ins")&&d.isTrackChangeElement(g);
},formatFragment:function(i){var g=this;
g.removeFormat_fragment(i);
if(f.isAncestorOrSelf(g.get_editor().get_contentArea(),i.getParent())){var h=g.formattedNode=g.createInlineNode();
i.insertBeforeFirst(h);
i.appendTo(h);
a(h).find("ins").each(function(j,k){if(g.isSameAuthorInsert(k)){g.deleteNode(k);
}});
g.trackChangedNode({node:h});
}},isSameAuthorInsert:function(g){return f.isTag(g,"ins")&&this.isSameAuthor(g);
},isSameAuthor:function(g){return this.get_editor()._isSameAuthor(g);
}};
b.TrackChangesDelete.registerClass("Telerik.Web.UI.Editor.TrackChangesDelete",b.InlineCommand);
})($telerik.$,Telerik.Web.UI.Editor,Telerik.Web.UI.Editor.Utils,Telerik.Web.UI.Editor.TrackChangesUtils,Telerik.Web.UI.Editor.TrackChangesConstants);
Type.registerNamespace("Telerik.Web.UI");
Type.registerNamespace("Telerik.Web.UI.Editor");
(function(d,a){var b=d.Editor;
var c=b.CommandList;
c.EnableTrackChanges=function(g,h,f){h.set_enableTrackChanges(!h.get_enableTrackChanges());
var i=h.getToolByName("EnableTrackChanges");
i.setState(h.get_enableTrackChanges()?1:0);
};
c.EnableTrackChangesOverride=function(g,h,f){var i=h.getToolByName(g);
if(i){var j=h.get_enableTrackChangesOverride();
h.set_enableTrackChangesOverride(!j);
i.setOn(j);
}return true;
};
c.AcceptAllTrackChanges=function(g,h,f){Telerik.Web.UI.Editor.TrackChanges.setEditor(h);
Telerik.Web.UI.Editor.TrackChanges.acceptAllChanges();
return true;
};
c.RejectAllTrackChanges=function(g,h,f){Telerik.Web.UI.Editor.TrackChanges.setEditor(h);
Telerik.Web.UI.Editor.TrackChanges.rejectAllChanges();
return true;
};
c.RemoveAllComments=function(g,h,f){Telerik.Web.UI.Editor.TrackChanges.setEditor(h);
Telerik.Web.UI.Editor.TrackChanges.removeAllComments();
return true;
};
c.AddComment=c.AcceptTrackChange=c.RejectTrackChange=c.RemoveTrackChanges=c.RemoveComment=function(f,g,h){g.setActive();
g.executeTrackChangesCommand(f,false,null,null);
return true;
};
c.ImageManagerToDeleteCoveredBy=function(h,i,k){var g=function(n,m){i.pasteHtml(b.Utils.getOuterHtml(m.Result),h);
};
var j=i.get_dialogOpener().get_additionalQueryString();
var l=i.getSelectedElement();
if(l&&l.tagName.toLowerCase()=="img"){i.get_dialogOpener().set_additionalQueryString("&PreselectedItemUrl="+encodeURIComponent(l.src));
}var f={editor:i};
i.showDialog("ImageManager",f,g);
i.get_dialogOpener().set_additionalQueryString(j);
return false;
};
b.CommandList._OriginalCut=b.CommandList.Cut;
b.CommandList.Cut=function(g,i,f){if(i.shouldTrackChanges()){var h=new b.TrackChangesCut(i,{isCutFromTool:!!f});
i._executeCommand(h,false);
}else{b.CommandList._OriginalCut(g,i,f);
}};
c.InsertTable=function(g,h,f){var k=f.value;
if(k){var i=b.Utils.createTable(k.rows,k.cols);
var j=Telerik.Web.UI.Editor.Utils.getOuterHtml(i);
h.pasteHtml(j,g);
}};
c.InsertRowAbove=c.InsertRowBelow=function(h,i,f){var g=new b.TableInsertRow(i.getLocalizedString(h),null,h=="InsertRowAbove"?"above":"below");
g._editor=i;
i.executeCommand(g);
};
c.DeleteRow=function(h,i,f){var g=new b.TableDeleteRow(i.getLocalizedString(h));
g._editor=i;
i.executeCommand(g);
};
c.InsertColumnLeft=c.InsertColumnRight=function(h,i,f){var g=new b.TableInsertColumn(i.getLocalizedString(h),null,h=="InsertColumnLeft"?"left":"right");
g._editor=i;
i.executeCommand(g);
};
function e(h,f,g){var i={title:f};
i.commandValue=g||null;
return new b[f+"TrackChangesCommand"](h,i);
}c.Bold=c.Italic=c.Underline=c.Subscript=c.Superscript=c.StrikeThrough=c.RealFontSize=c.FontName=c.BackColor=c.ForeColor=function(g,i,j){i.setActive();
i.setFocus();
var h=j?j.value:null;
var f=e(i,g,h);
i.executeCommand(f);
return true;
};
})(Telerik.Web.UI,$telerik.$);
Type.registerNamespace("Telerik.Web.UI.Editor");
Type.registerNamespace("Telerik.Web.UI.Editor.TrackChangesCommands");
(function(e,a,f,c){var d=e.Editor;
var b=d.CommandStates;
var h=d.TrackChangesUtils;
var i=d.Utils;
var g=function(j){return i.isTextNode(j)&&!i.isSignificantTextNode(j);
};
d.TrackChangesCommand=function(l,j){var k=j._contentWindow;
d.TrackChangesCommand.initializeBase(this,[(l||"Track Change Command"),k,true]);
this._editor=j;
};
d.TrackChangesCommand.prototype={getState:function(q){try{var k=this;
var m=k._editor;
var t=m.get_enableTrackChanges();
var j=m.get_canAcceptTrackChanges();
if(t&&!j){return b.Disabled;
}var p=new d.Selection(q||k.get_window());
var r=p.getParentElement();
if(i.isTextNode(r)){r=r.parentNode;
}var s=h.findTrackChangesParentElement(r);
var l=k._title;
if(s&&(s.User==m.get_author()||m.get_isAuthor())){var o=s.Type==d.TrackChangesElementType.Comment;
if(!o&&k._toolName&&k._toolName=="RemoveComment"){return b.Disabled;
}if(!t){if(l=="Reject Track Changes"||l=="Accept Track Changes"){return b.Disabled;
}else{return b.Off;
}}if(l=="Accept Track Changes"||l=="Reject Track Changes"){if(!j||o){return b.Disabled;
}}return b.Off;
}else{if(l.toLowerCase().indexOf(" all track changes")!=-1||l.toLowerCase().indexOf(" all comments")!=-1){return b.Off;
}else{if(k._getEdgeCommonChanges(m.getDomRange())){return b.Off;
}else{return b.Disabled;
}}}}catch(n){return b.Disabled;
}},_getEdgeCommonChanges:function(q){var r=q.startContainer;
var n=q.endContainer;
var m=this._editor.get_contentArea();
if((i.isTextNode(r)&&!i.isTextNodeEmpty(r)&&q.startOffset!=0)||(i.isTextNode(n)&&!i.isTextNodeEmpty(n)&&q.endOffset!=n.length)){return;
}r=Telerik.Web.UI.Editor.RangeEdges.startNode(q);
n=Telerik.Web.UI.Editor.RangeEdges.endNode(q);
if(m.firstChild==r){while(g(r)&&r.nextSibling){r=r.nextSibling;
}r=this._significantChildNode(r,"firstChild")||r;
}if(m.lastChild==n){n=i.isTag(n,"br")?(n.previousSibling||n):n;
while(g(n)&&n.previousSibling){n=n.previousSibling;
}n=this._significantChildNode(n,"lastChild")||n;
}var s=this._getStartChanges(r);
var o=this._getEndChanges(n);
var l;
var k;
for(var p=0;
p<s.length;
p++){var j=this._getSameChange(o,s[p]);
if(j){l=s[p];
k=j;
break;
}}if(l&&k){return[l,k];
}},_significantChildNode:function(m,j){var l=m;
if(!i.canHaveChildren(m)){return null;
}var k=i.getChildNodesBy(l,function(n){return i.isTextNode(n)?!i.isTextNodeEmpty(n)&&!i.isInlineSpace(n):d.FragmentsCondition.isInlineNode(n)&&!i._isContentAreaLastBr(n);
});
l=j=="firstChild"?k[0]:k[k.length-1];
return l&&l[j]?this._significantChildNode(l,j)||l:l;
},_getSelectedFragments:function(j){var k=new d.RangeFragmentsTraverser(j);
k.traverseFragments(function(l){return d.FragmentsCondition.isInlineNode(l)&&!i._isContentAreaLastBr(l)&&!(i.isTextNode(l)&&i.isTextNodeEmpty(l));
});
return k.traversedFragments;
},_getFragmentsEdges:function(k){var m=k[0].nodes[0];
var l=k[k.length-1];
var j=l.nodes[l.nodes.length-1];
while(m.firstChild){m=m.firstChild;
}while(j.lastChild){j=j.lastChild;
}return{start:m,end:j};
},_getSameChange:function(m,p){var j=c.Attribute;
var k=p.getAttribute(j.Author);
var n=p.getAttribute(j.BrowserCommand);
for(var o=0;
o<m.length;
o++){var l=m[o];
if(l.getAttribute(j.BrowserCommand)==n&&l.getAttribute(j.Author)==k){return m[o];
}}},_getStartChanges:function(j){return this._getEdgeChange(j,true);
},_getEndChanges:function(j){return this._getEdgeChange(j);
},_getEdgeChange:function(l,j){var m=j?"previousSibling":"nextSibling";
var k=[];
if(h.isTrackChangeElement(l)){k.push(l);
}while((!l[m]||(g(l[m])&&!l[m][m]))&&!i.isBlockElement(l.parentNode)){l=l.parentNode;
if(h.isTrackChangeElement(l)){k.push(l);
}}return k;
},_deleteTrackedNode:function(o){var j=this;
while(o&&o.parentNode&&i.isSingleChild(o)&&!i.isEditorContentArea(o.parentNode)){o=o.parentNode;
}var m=o.ownerDocument.createElement("span");
var p=o.parentNode;
p.insertBefore(m,o);
p.removeChild(o);
var k=new d.Consolidator();
if(!i.isBlockElement(m.previousSibling)&&!i.isBlockElement(m.nextSibling)){k.consolidateOverMarker(m);
}var r=j.get_editor().getDomRange();
if(k.normalizeTextEdge(m,r,true)){r.collapse(true);
try{r.select();
}catch(l){}}else{var q=m.previousSibling;
var n=m.nextSibling;
a(m).remove();
if(n){r.setStartBefore(n);
}else{if(q){r.setStartAfter(q);
}}if(q||n){r.collapse(true);
try{r.select();
}catch(l){}}}},_acceptRejectChanges:function(j){var o=this;
var r=o._editor;
var k=j?"acceptElementChange":"rejectElementChange";
if(o.getState(r.get_contentWindow())==b.Disabled){return;
}var v=r.getDomRange();
var x=r.getSelectedElement(v);
var u=h.findTrackChangesParentElement(x,{ignoreComments:true});
if(u){return o[k](u);
}var n=o._getEdgeCommonChanges(v);
if(!n){return false;
}var l=c.Attribute;
var m=n[0].getAttribute(l.Author);
var p=n[0].getAttribute(l.BrowserCommand);
var t=this._getSelectedFragments(v);
var q=this._getFragmentsEdges(t);
var y=q.start;
var s=q.end;
Array.forEach(t,function(z){Array.forEach(z.nodes,function(A){var B=a(A).find("*").addBack().filter(function(D,C){return h.isTrackChangeElement(C)&&C.getAttribute(l.Author)==m&&C.getAttribute(l.BrowserCommand)==p&&!Array.contains(n,C);
}).toArray();
Array.addRange(n,B);
});
});
var w=false;
Array.forEach(n,function(z){var A=h.findTrackChangesParentElement(z,{ignoreComments:true});
if(A){w=o[k](A);
}});
this._restoreSelection(v,y,s);
return w;
},_restoreSelection:function(k,l,j){k.setStartBefore(l);
k.setEndAfter(j);
if(this.get_editor().containsRange(k)){k.select();
}}};
d.TrackChangesCommand.registerClass("Telerik.Web.UI.Editor.TrackChangesCommand",d.CommandBase);
f.AcceptTrackChanges=function(l,k,j){f.AcceptTrackChanges.initializeBase(this,[(l||"Accept Track Changes"),k]);
};
f.AcceptTrackChanges.prototype={OnExecuteIE:function(){return this._acceptRejectChanges(true);
},acceptElementChange:function(n){var j=d.TrackChangesElementType;
var m=n.HtmlElement;
if(n.Type==j.Delete){this._deleteTrackedNode(m);
}else{if(n.Type==j.Comment||n.Type==j.Insert){i.removeNode(m);
}else{var k=n.BrowserCommand,l=d.TrackerFactory.getCommandTracker(k.replace(/^Remove\s/,""),this._editor);
if(l){l.acceptChanges(m,k);
}}}return true;
},OnExecuteMoz:function(){return this.OnExecuteIE();
}};
f.AcceptTrackChanges.registerClass("Telerik.Web.UI.Editor.TrackChangesCommands.AcceptTrackChanges",d.TrackChangesCommand);
f.RejectTrackChanges=function(l,k,j){f.RejectTrackChanges.initializeBase(this,[(l||"Reject Track Changes"),k]);
};
f.RejectTrackChanges.prototype={OnExecuteIE:function(){return this._acceptRejectChanges(false);
},rejectElementChange:function(q){var n=this.get_editor(),p=q.Type,o=q.HtmlElement,s=d.TrackChangesElementType,j=n.getSelection().getRange(true),r=j?new d.DomRange(j):undefined;
if(p==s.Insert){this._deleteTrackedNode(o);
return true;
}else{if(p==s.Delete||p==s.Comment){i.removeNode(o);
}else{var k=q.BrowserCommand,l=d.TrackerFactory.getCommandTracker(k.replace(/^Remove\s/,""),n);
if(l){l.rejectChanges(o,k);
if(l.ignoreRangeSelect){return true;
}}}}try{if(r&&n.containsRange(r)){r.select();
}}catch(m){}return true;
},OnExecuteMoz:function(){return this.OnExecuteIE();
}};
f.RejectTrackChanges.registerClass("Telerik.Web.UI.Editor.TrackChangesCommands.RejectTrackChanges",d.TrackChangesCommand);
f.RemoveTrackChanges=function(l,k,j){f.RemoveTrackChanges.initializeBase(this,[(l||"Remove Track Changes"),k]);
};
f.RemoveTrackChanges.prototype={onExecute:function(l,m,j){var k=this;
m=m||k._editor;
var q=m.getSelectedElement();
var o=h.findTrackChangesParentElement(q);
var n=o&&o.Type==d.TrackChangesElementType.Comment;
if(k.get_title()=="RemoveComment"&&!n){return false;
}if(n){i.removeNode(o.HtmlElement);
return true;
}else{var p=new d.TrackChangesCommands.RejectTrackChanges("RejectTrackChanges",m,"RejectTrackChanges");
return p.OnExecuteIE("RejectTrackChanges",m,null);
}return false;
}};
f.RemoveTrackChanges.registerClass("Telerik.Web.UI.Editor.TrackChangesCommands.RemoveTrackChanges",d.TrackChangesCommand);
f.AddComment=function(n,k,j){var m={};
var l={title:(n||"Add Comment")};
f.AddComment.initializeBase(this,[k,m,l]);
};
f.AddComment.prototype={getState:function(k){var l=d.DomRange.rangeFromWindow(k);
if(!l||l.collapsed){return b.Disabled;
}var j=this;
return i.someInRange(l,function(m){return j._isComment(m)||j._containsComment(m);
})?b.Disabled:b.Off;
},_isComment:function(j){return !!i.getElementParentByCondition(j,h.isCommentElement);
},_containsComment:function(j){return i.some(a.makeArray(a(j).find("*")),h.isCommentElement);
},createInlineNode:function(){var k=this._editor;
var l=a(k.get_document().createElement(c.TagComment));
var j=c.Attribute;
l.addClass(c.CssClassComment+" "+k.get_userCssId()).attr(j.Author,k.get_author()).attr(j.Comment,"").attr(j.Title,"#empty comment#").attr(j.Timestamp,new Date().getTime());
return l.get(0);
},shouldRemoveFormatting:function(j){return false;
},isSameFormat:function(j){return false;
},formatFragments:function(l){var j=this;
while(l.length){var k=l.shift();
if(!j.isEmptyInlineFragment(k)){j.formatFragment(k);
}}},isEmptyInlineFragment:function(o){var r=o.nodes;
var q=a(r);
var k=q.filter("br").add(q.find("br"));
if(k.length==0){return i.every(r,i.isNodeEmptyRecursive);
}else{if(k.length>1){return false;
}}var j=k.get(0);
var n=j.ownerDocument.createTextNode("");
if(o.indexOf(j)>-1){k.replaceWith(n);
}var l=o.indexOf(j);
var m;
if(l>-1){m=r.slice(0);
m[l]=n;
}var p=i.every(m||r,i.isNodeEmptyRecursive);
a(n).replaceWith(j);
return p;
}};
f.AddComment.registerClass("Telerik.Web.UI.Editor.TrackChangesCommands.AddComment",d.InlineCommand);
f.EnableTrackChanges=function(l,k,j){f.EnableTrackChanges.initializeBase(this,[(l||"Add Comment"),k]);
};
f.EnableTrackChanges.prototype={getState:function(k){try{if(this._editor.get_enableTrackChanges()){return b.On;
}else{return b.Off;
}}catch(j){return b.Disabled;
}},OnExecuteIE:function(){var j=this._editor;
j.set_enableTrackChanges(!j.get_enableTrackChanges());
j.raiseEvent("selectionChange",Sys.EventArgs.Empty);
return false;
}};
f.EnableTrackChanges.registerClass("Telerik.Web.UI.Editor.TrackChangesCommands.EnableTrackChanges",d.TrackChangesCommand);
f.EnableTrackChangesOverride=function(l,k,j){f.EnableTrackChangesOverride.initializeBase(this,[(l||"Enable Track Changes override"),k]);
};
f.EnableTrackChangesOverride.prototype={getState:function(k){try{if(this._editor.get_enableTrackChangesOverride()){return b.Off;
}else{return b.On;
}}catch(j){return b.Disabled;
}},OnExecuteIE:function(){var j=this._editor;
j.set_enableTrackChangesOverride(!j.get_enableTrackChangesOverride());
j.raiseEvent("selectionChange",Sys.EventArgs.Empty);
return false;
},OnExecuteMoz:function(){return this.OnExecuteIE();
}};
f.EnableTrackChangesOverride.registerClass("Telerik.Web.UI.Editor.TrackChangesCommands.EnableTrackChangesOverride",d.TrackChangesCommand);
})(Telerik.Web.UI,$telerik.$,Telerik.Web.UI.Editor.TrackChangesCommands,Telerik.Web.UI.Editor.TrackChangesConstants);
(function(a,b,d){var e=b.Utils;
var c=b.TrackChangesUtils;
b.TrackChangesCut=function(f,g){b.TrackChangesCut.initializeBase(this,[f,g]);
};
b.TrackChangesCut.prototype={onExecute:function(){var f=this;
var i=f.get_editor();
var p=f.getEditorRange();
var h=p.getHtml();
if(p.collapsed||!h){return;
}var l=f.getGenericCutCommand(i);
if(f.isInTrackedDeletion(p)){return f.handleCutInDeletion(l);
}f.onExecuteBase();
var g=f.getCutElementsContainer(h);
var j=g.firstChild;
var m=g.lastChild;
var k=f.getFirstDeletedNode();
var n=f.getLastDeletedNode();
if(e.isBlockElement(g.firstChild)){k=e.getFirstBlockElementUp(k);
var o=i.whitespaceTracker.createTrackedNode(i.get_document());
e.insertBefore(k,o,k.firstChild);
}if(j&&n){f.appendNodesToCut(g,k);
f.selectNodesToCut(p,j,m);
f.executeCut(l,n);
}},isInTrackedDeletion:function(f){return c.getParentTrackChangesDeleteNode(f.commonAncestorContainer);
},handleCutInDeletion:function(h){var f=this;
var g=f.get_editor();
if(f.options.isCutFromTool&&!f._tryCutProgrammatically(g)){f._alert(g.getLocalizedString("UseCtrlX"));
}else{g._pendingCutCommand=h;
}},_alert:function(f){window.alert(f);
},getGenericCutCommand:function(f){return new b.GenericCommand(f.getLocalizedString("Cut"),f.get_contentWindow(),f);
},onExecuteBase:function(){b.TrackChangesCut.callBaseMethod(this,"onExecute");
},consolidate:function(){},getCutElementsContainer:function(g){var f=this.get_editor().get_document().createElement("div");
f.innerHTML=g;
if(e.isTag(f.lastChild,"br")){f.removeChild(f.lastChild);
}a(f).children().each(function(h,i){if(e.isNodeEmptyRecursive(i,true)){f.removeChild(i);
}});
return f;
},getLastDeletedNode:function(){var f=this.elements;
var g=f&&f.length?f[f.length-1]:d;
return g?g.node:d;
},getFirstDeletedNode:function(){var f=this.elements&&this.elements[0];
return f&&f.node;
},appendNodesToCut:function(f,g){var i=g.parentNode;
var h=g;
while(f.firstChild){e.insertBefore(i,f.firstChild,h);
}},selectNodesToCut:function(g,h,f){g.setStartBefore(h);
g.setEndAfter(f);
g.select();
},executeCut:function(h,i){var f=this;
var g=f.get_editor();
if(f.options.isCutFromTool&&!f._tryCutProgrammatically(g)){g.executeCommand(h);
g.undo(1);
f._alert(g.getLocalizedString("UseCtrlX"));
}else{g._pendingCutCommand=h;
setTimeout(function(){var j=g.getDomRange();
j.setEndAfter(i);
j.collapse();
j.select();
},0);
}},_tryCutProgrammatically:function(f){return b.CommandList._tryCutProgrammatically(f);
}};
b.TrackChangesCut.registerClass("Telerik.Web.UI.Editor.TrackChangesCut",b.TrackChangesDelete);
})($telerik.$,Telerik.Web.UI.Editor);
(function(a){a.TrackChangesInlineCommand=function(c,b,d){a.TrackChangesInlineCommand.initializeBase(this,[c,b,d]);
};
a.TrackChangesInlineCommand.prototype={formatFragment:function(c){var b=this;
b.extractTrackedAncestor(c);
a.TrackChangesInlineCommand.callBaseMethod(b,"formatFragment",[c]);
}};
a.TrackChangesInlineCommand.registerClass("Telerik.Web.UI.Editor.TrackChangesInlineCommand",a.InlineCommand);
})(Telerik.Web.UI.Editor);
(function(a){a.TrackChangesInlineCommandWithValue=function(c,b,d){a.TrackChangesInlineCommandWithValue.initializeBase(this,[c,b,d]);
};
a.TrackChangesInlineCommandWithValue.prototype={formatFragment:function(c){var b=this;
b.extractTrackedAncestor(c);
a.TrackChangesInlineCommandWithValue.callBaseMethod(b,"formatFragment",[c]);
}};
a.TrackChangesInlineCommandWithValue.registerClass("Telerik.Web.UI.Editor.TrackChangesInlineCommandWithValue",a.InlineCommandWithValue);
})(Telerik.Web.UI.Editor);
(function(a,b,f,d,c,e){b.TrackChangesInsert=function(g,h){h=h||{};
h.title="Insert";
b.TrackChangesInsert.initializeBase(this,[g,b.InlineCommandSettings.TrackChangesInsert,h]);
};
b.TrackChangesInsert.prototype={getState:function(i,g,h){return b.CommandStates.Off;
},removeSameFormatChildren:function(g){},formatFragments:function(i){var g=this;
var k=g.getEditorRange();
var j=g.insertSingleFormatNode(k);
var m=d.getTrackedAncestor(j.parentNode);
if(m){var l=g.createMarker();
var h=l.cloneNode(true);
j.parentNode.insertBefore(l,j);
a(h).insertAfter(j);
g.extractFormatting(m,l,h);
a(m).find("*").addBack().filter(function(n,o){return d.isTrackChangeElement(o)&&o!==j;
}).each(function(n,o){if(f.isTag(o,"ins")||d.isChangeDelete(o)){f.removeNode(o);
}else{d.removeNodeTracking(o);
}});
j.parentNode.removeChild(l);
j.parentNode.removeChild(h);
}g.setCursorInInlineNode(j,k);
}};
b.TrackChangesInsert.registerClass("Telerik.Web.UI.Editor.TrackChangesInsert",b.InlineCommand);
})($telerik.$,Telerik.Web.UI.Editor,Telerik.Web.UI.Editor.Utils,Telerik.Web.UI.Editor.TrackChangesUtils,Telerik.Web.UI.Editor.TrackChangesConstants);
Type.registerNamespace("Telerik.Web.UI.Editor");
(function(a,b,e){function d(f){return b.InlineCommandSettings[f];
}function c(i){var f=i+"TrackChangesCommand",j="Telerik.Web.UI.Editor."+f,h=d(i);
h.commandName=i;
var g=b[f]=function(l,m){var k=b[h.commandName]?b[h.commandName]:h.hasValue?b.TrackChangesInlineCommandWithValue:b.TrackChangesInlineCommand;
return new k(l,h,m);
};
g.registerClass(j);
}c("Bold");
c("Italic");
c("Underline");
c("StrikeThrough");
c("Subscript");
c("Superscript");
c("ForeColor");
c("BackColor");
b.FontNameTrackChangesCommand=function(g,h){var f=d(h.title);
b.FontNameTrackChangesCommand.initializeBase(this,[g,f,h]);
};
b.FontNameTrackChangesCommand.registerClass("Telerik.Web.UI.Editor.FontNameTrackChangesCommand",b.TrackChangesInlineCommandWithValue);
b.RealFontSizeTrackChangesCommand=function(g,h){var f=d(h.title);
b.RealFontSizeTrackChangesCommand.initializeBase(this,[g,f,h]);
};
b.RealFontSizeTrackChangesCommand.registerClass("Telerik.Web.UI.Editor.RealFontSizeTrackChangesCommand",b.TrackChangesInlineCommandWithValue);
})($telerik.$,Telerik.Web.UI.Editor);
(function(a,b,e,c,d){b.TrackChangesRemoveFormat=function(f,g){b.TrackChangesRemoveFormat.initializeBase(this,[f,b.InlineCommandSettings.TrackChangesRemoveFormat,g]);
};
b.TrackChangesRemoveFormat.prototype={getState:function(k,f,i){var h=i||b.DomRange.rangeFromWindow(k),j=h.startContainer;
if(e.isBlockElement(j)||!a.contains(f.get_contentArea(),j)){return b.CommandStates.Off;
}var g=c.getTrackedParentNode(j);
return(g&&!e.isBlockElement(g))?b.CommandStates.On:b.CommandStates.Off;
},removeFormat:function(h){var f=this;
while(h.length){var g=h.shift();
if(!g.isEmpty()){f.removeFormat_fragment(g);
}}},findFormattedAncestor:function(f){return c.getTrackedAncestor(f);
},removeNodeFormatting:function(g){var f=this;
a(g).find("*").each(function(h,i){if(c.isTrackChangeElement(i)){f._removeNodeTracking(i);
}});
f._removeNodeTracking(g);
},_removeNodeTracking:function(f){if(this.options.removeTrackedNodes||e.isTag(f,"ins")||e.isTag(f,"del")){e.removeNode(f);
return;
}c.removeNodeTracking(f);
},isSameFormatNode:function(f){return c.isTrackChangeElement(f);
},removeSameFormatChildren:function(f){},cleanUpFormat:function(f){}};
b.TrackChangesRemoveFormat.registerClass("Telerik.Web.UI.Editor.TrackChangesRemoveFormat",b.InlineCommand);
})($telerik.$,Telerik.Web.UI.Editor,Telerik.Web.UI.Editor.Utils,Telerik.Web.UI.Editor.TrackChangesUtils);
Type.registerNamespace("Telerik.Web.UI.Editor");
(function(d,a,c,b){c.TrackChangesSelection=(function(){var t=function(y,D,x,z){y=c.DomRange.toDomRange(y);
var A={fullySelected:false,textSelected:false,partialStart:false,partialEnd:false,partialOverlapped:false,overlapped:false,inRange:false,rangeType:"",errorMsg:""};
if(y.range.length){return A;
}var w=(typeof(D)=="undefined"||null==D)?"":D;
var v=(typeof(z)=="undefined"||null==z)?k(D):z;
var u=(typeof(x)=="undefined"||null==x)?true:x;
if(w==""){A.errorMsg="Tag Name is required.";
}if(!y){A.errorMsg="No selection found.";
}if(A.errorMsg==""){var B=y.getParentElement();
var C=y.cloneRange();
if(C.range.length){if(D.match(/(placeholder|caption)/i)){if(new RegExp(v,"i").test($telerik.getOuterHtml(B))){B=B.parentElement;
}}if(new RegExp(v,"i").test($telerik.getOuterHtml(B))){A.fullySelected=true;
}if(!A.fullySelected){if(new RegExp(v,"i").test($telerik.getOuterHtml(B.parentElement))&&B.parentElement.nodeName.match(/(ins|del)/i)){A.fullySelected=true;
}}A.rangeType="Selectable";
}else{if(n(C,w,u,v)){A.fullySelected=true;
}else{if(s(C,w,u,v)){A.textSelected=true;
}else{if(r(C,w,u,v)){A.partialStart=true;
A.textSelected=true;
}else{if(p(C,w,u,v)){A.partialEnd=true;
A.textSelected=true;
}else{if(q(C,w,u,v)){A.partialOverlapped=true;
}else{if(o(C,w,u,v)){A.overlapped=true;
}}}}}}A.rangeType="Range";
}}if(A.fullySelected||A.overlapped||A.partialEnd||A.partialOverlapped||A.partialStart||(A.textSelected&&!D)){A.inRange=true;
}return A;
};
var k=function(v){var u="";
if(typeof(v)=="undefined"||!v){return"";
}switch(v.toLowerCase()){case"img":u="</?(IMG).*\n*src=.*[^>]*/?>";
break;
case"a":u="</?(a).*\n*href=.*[^>]*/?>";
break;
case"ins":u="(</?(ins)[^>]*("+b.Attribute.Author+"|"+b.Attribute.Cite+")=?)";
break;
case"del":u="(</?(del)[^>]*("+b.Attribute.Author+"|"+b.Attribute.Cite+")=?)";
break;
case"comment":u="</?(font).*\n*class=.*"+b.CssClassNamePrefixComment+".*\n*[^>]*/?>";
break;
case"trackchange_strong":u="(</?(strong)[^>]*("+b.Attribute.Author+"|"+b.Attribute.Cite+")=?)";
break;
case"trackchange_em":u="(</?(em)[^>]*("+b.Attribute.Author+"|"+b.Attribute.Cite+")=?)";
break;
case"trackchange_u":u="(</?(u)[^>]*("+b.Attribute.Author+"|"+b.Attribute.Cite+")=?)";
break;
case"trackchange_strike":u="(</?(strike)[^>]*("+b.Attribute.Author+"|"+b.Attribute.Cite+")=?)";
break;
case"trackchange_sup":u="(</?(sup)[^>]*("+b.Attribute.Author+"|"+b.Attribute.Cite+")=?)";
break;
case"trackchange_sub":u="(</?(sub)[^>]*("+b.Attribute.Author+"|"+b.Attribute.Cite+")=?)";
break;
case"trackchange_p":u="(</?(p)[^>]*("+b.Attribute.Author+"|"+b.Attribute.Cite+"=?)";
break;
case"table":u="</?(table)[^>]*/?>";
break;
case"bookmark":u='</?(a).*\n*class="?[^"]*?bookmarkDisplayTool[^"]*?"?[^>]*/?>';
break;
case"placeholder":u="(</?(span|font)[^>]*(name)\\s*=\\s*?('|\")+(_wp)+.*)";
break;
case"caption":u="(</?(span|font)[^>]*(name)\\s*=\\s*?('|\")+(forCaption)+.*?>)";
break;
default:break;
}return u;
};
var m=function(w){var u=w.toUpperCase();
var v=u;
switch(u){case"COMMENT":v="FONT";
break;
case"TRACKCHANGE_STRONG":v="STRONG";
break;
case"TRACKCHANGE_EM":v="EM";
break;
case"TRACKCHANGE_U":v="U";
break;
case"TRACKCHANGE_STRIKE":v="STRIKE";
break;
case"TRACKCHANGE_SUP":v="SUP";
break;
case"TRACKCHANGE_SUB":v="SUB";
break;
case"TRACKCHANGE_P":v="P";
break;
case"BOOKMARK":v="A";
break;
case"PLACEHOLDER":case"CAPTION":v="SPAN";
break;
default:break;
}return v;
};
var l=function(u,w){var v=u;
w=w.toUpperCase();
while(v&&v.nodeName!="BODY"){if(v.nodeName==w){break;
}v=v.parentNode;
}return v;
};
var j=function(z,C,u,A){z=c.DomRange.toDomRange(z);
var B={start:false,end:false,sameElement:false,startPartialRange:"",endPartialRange:""};
var v=z.cloneRange();
var x=z.cloneRange();
v.collapse(true);
if(v.range.move){v.range.move("character",1);
}x.collapse(false);
var w=v.getParentElement();
var y=x.getParentElement();
C=m(C);
if(w.nodeName!=C){if(u){w=l(w,C);
}}if(y.nodeName!=C){if(u){y=l(y,C);
}}if(A){B.start=(new RegExp(A,"i").test($telerik.getOuterHtml(w))&&w.nodeName==C);
B.end=(new RegExp(A,"i").test($telerik.getOuterHtml(y))&&y.nodeName==C);
}else{B.start=C==w.nodeName;
B.end=C==y.nodeName;
}B.sameElement=w==y;
v.moveEnd("character",1);
x.moveEnd("character",1);
B.startPartialRange=v;
B.endPartialRange=x;
z.select();
return B;
};
var n=function(A,D,y,B){A=c.DomRange.toDomRange(A);
var C=false;
var v=A.getParentElement();
var z=false;
if(D.match(/(placeholder|caption)/i)){D="A";
z=true;
}D=m(D);
if(v){if(v.nodeName!=D&&y){v=l(v,D);
}var w=A.cloneRange();
try{w.selectNodeContents(v);
}catch(x){}if(D==v.nodeName){if(new RegExp(B,"i").test(A.getHtml())){if(z){var u=$telerik.getOuterHtml(v).replace(/^\s+|\s+$/g,"");
if(A.getText()==u){C=true;
}}else{return A.inRange(w)||A.getText()==$telerik.getOuterHtml(v);
}}}}return C;
};
var s=function(x,A,v,y){x=c.DomRange.toDomRange(x);
var z=false;
var u=x.getParentElement();
A=m(A);
if(u.nodeName!=A.toUpperCase()){if(v){u=l(u,A);
}}if(u.nodeName==A){var w=(x.range&&x.range.moveEnd)||(!x.range&&x.moveEnd);
if(w){x.moveEnd("character",1);
}if(!new RegExp(y,"i").test(x.getHtml())&&new RegExp(y,"i").test($telerik.getOuterHtml(u))){z=true;
}if(w){x.moveEnd("character",-1);
}}return z;
};
var r=function(x,A,v,y){x=c.DomRange.toDomRange(x);
var z=false;
var u=x.getParentElement();
A=m(A);
if(u.nodeName!=A){if(v){u=l(u,A);
}}if(new RegExp(y,"i").test(x.getHtml())){var w=j(x,A,v,y);
if(w.start&&w.end&&w.sameElement){if($telerik.getOuterHtml(u)!=x.getText()){return true;
}}}return z;
};
var p=function(x,A,v,y){x=c.DomRange.toDomRange(x);
var z=false;
var u=x.getParentElement();
A=m(A);
if(u.nodeName!=A){if(v){u=l(u,A);
}}if(!new RegExp(y,"i").test(x.getHtml())){var w=j(x,A,v,y);
if(w.start&&w.end&&w.sameElement&&x.getText()!=$telerik.getOuterHtml(u)){return true;
}}return z;
};
var q=function(D,H,z,F){D=c.DomRange.toDomRange(D);
var G=false;
var v=H.toUpperCase();
H=m(H);
var E=D.getHtml();
if(new RegExp(F,"i").test(E)){var C=j(D,H,z,F);
if((C.start||C.end)&&(!C.sameElement)){G=true;
}else{if(v=="IMG"||v=="CAPTION"||v=="PLACEHOLDER"){var u=v=="IMG"?F:"(</?(A).*\n*contentEditable=.*[^>]*/?>)";
var B=E.match(new RegExp(u,"i"));
if(B){var A=B[0].length;
if(B.index==0&&A!=E.length){G=true;
}else{var w=D.cloneRange();
w.collapse(false);
if(w.range.moveStart){w.moveStart("character",-1);
}var x=w.getHtml();
if(x.match(new RegExp(u,"i"))){G=true;
}else{var y=w.getParentElement();
if(x==""&&y.nodeName=="A"&&y.contentEditable=="true"){G=true;
}}}}}}}return G;
};
var o=function(w,z,u,x){w=c.DomRange.toDomRange(w);
var y=false;
z=m(z);
if(new RegExp(x,"i").test(w.getHtml())){var v=j(w,z,u,x);
if(!v.start&&!v.end){return true;
}}return y;
};
var i=function(v,u){var w=v;
var x=w.parentElement;
if(x.nodeName=="FONT"){var z=c.Utils.getTextContent(w);
var y=x.outerText;
if(z==y){u.selectElement(x);
return;
}}var A=document.createElement("FONT");
w.parentElement.replaceChild(A,w);
A.appendChild(w);
u.selectElement(A);
};
var e=function(y,u){if(typeof(y)=="undefined"||y==null){return;
}var B=[];
var x=y;
var v=x.getAttribute(u);
var D=x.nodeName;
var C=x.ownerDocument.getElementsByTagName(D);
if(v==null){B=C;
}else{for(var A=0;
A<C.length;
A++){var z=C[A];
var w=z.getAttribute(u);
if(v==w){B.push(z);
}}}return B;
};
var h=function(u){var v=u;
var w=new RegExp("<(script)[^>]*?>(?:.|\n)*?</(script)>","ig");
v=v.replace(w,"");
v=v.replace(/<\s*ins(.|\n)*?>/gi,"");
v=v.replace(/<\s*\/\s*ins\s*.*?>/gi,"");
v=v.replace(/<\s*del(.|\n)*?>/gi,"");
v=v.replace(/<\s*\/\s*del\s*.*?>/gi,"");
var x="(</?(strong|em|u|sup|sub|font|p)[^>]*("+b.Attribute.Author+"|"+b.Attribute.Cite+")=?)";
if(new RegExp(x,"ig").test(v)){v=f(v,x);
}v=v.replace(/<FONT[^>]color=.*?>([\s\S]*?)<\/FONT[^>]*?>/ig,"$1");
return v;
};
var f=function(B,x){var y=document.createElement("DIV");
c.Utils.setElementInnerHtml(y,B);
var A=y.childNodes;
var w=x;
for(var v=0;
v<A.length;
v++){var z=A[v];
if(z.nodeName!="#text"){try{if(new RegExp(w,"ig").test($telerik.getOuterHtml(z))){z.removeAttribute("className");
z.removeAttribute(b.Attribute.Title);
z.removeAttribute(b.Attribute.Author);
z.removeAttribute(b.Attribute.Cite);
z.removeAttribute(b.Attribute.Timestamp);
c.TrackChangesUtils.removeTrackChangesCommand(z);
}}catch(u){continue;
}}}return y.innerHTML;
};
var g=function(v,x,z){function u(){var F=y;
var B=false;
F=F.replace(/<(p)[^>]*\/?><\/(?:\1)>/ig,"");
F=F.replace(/<(p)[^>]*\/?>&nbsp;<\/(?:\1)>/ig,"<BR/>");
F=F.replace(/<\s*p(.|\n)*?>/i,"");
F=F.replace(/<\s*\/\s*p\s*.*?>/ig,"");
F=F.replace(/<\s*p(.|\n)*?>/ig,"<BR/>");
var H=document.createElement("DIV");
c.Utils.setElementInnerHtml(H,F);
var E=true;
if(H.children.length==1&&H.childNodes.length==1){if(H.childNodes[0].nodeName=="SPAN"){F=c.Utils.getTextContent(H.childNodes[0]);
E=false;
}}if(E){var J=H.childNodes;
for(var C=0;
C<J.length;
C++){var I=J[C];
if(I.nodeName=="A"){var D=I.contentEditable.match(/(true|false)/i);
if(D){try{var K=x?document.createTextNode(""):document.createTextNode(I.outerText);
var G=I.parentElement;
G.replaceChild(K,I);
}catch(A){B=true;
}}}}if(!B){F=H.innerHTML;
}}return F;
}var y=v;
var w=y.match(new RegExp(k(z),"i"));
if(w){y=u();
}return y;
};
return{locateElementInRange:function(v,y,u,w){v=c.DomRange.toDomRange(v);
var x=t(v.cloneRange(),y,u,w);
v.select();
return x;
},wrapElement:function(v,u){i(v,u);
},getSimilarElements:function(v,u){return e(v,u);
},stripTrackChanges:function(u){return h(u);
},findOffsetParent:function(u,x){var v=l(u,x);
var w=false;
if(v){if(v.nodeName==x.toUpperCase()){w=v;
}}return w;
},stripPlaceHolders:function(u,v,w){return g(u,v,w);
}};
})();
})(Telerik.Web.UI,$telerik.$,Telerik.Web.UI.Editor,Telerik.Web.UI.Editor.TrackChangesConstants);
Type.registerNamespace("Telerik.Web.UI.Editor");
(function(a,b,d,c){b.BaseCommandsTracker=function(e){var f=this;
f.timestamp=new Date().getTime();
f.author=e.get_author();
f.userCssId=e.get_userCssId();
f._editor=e;
};
b.BaseCommandsTracker.prototype={trackFormattedNodes:function(g,e){var l=this;
for(var h=g.length-1;
h>=0;
h--){var f=g[h],k=f.node,j=l.isTextNode=d.isTextNode(k);
l.isTracked=!j&&c.isTrackChangeElement(k);
l.isListItem=!j&&d.isTag(k,"li");
l.trackNodeFormatting(f,f.commandName||e);
}},trackNodeFormatting:function(f,e){var h=this,g=f.node;
if(h.isTracked&&g.innerHTML==""){a(g).remove();
return;
}if(h.isTextNode){var i=g.ownerDocument.createElement("span");
a(g).wrap(i);
g=f.node=g.parentNode;
}h.trackFormatting(f,e);
},_savePreviousState:function(e){var f=e.node;
if(e.isWrapper&&!f.getAttribute("iswrapper")){f.setAttribute("iswrapper",e.isWrapper);
}else{if(e.originalValue&&!f.getAttribute("originalvalue")){f.setAttribute("originalvalue",e.originalValue);
}if(e.cssProperty&&!f.getAttribute("cssproperty")){f.setAttribute("cssproperty",e.cssProperty);
}}},acceptChanges:function(i,f){var h="",j=new b.DomRange.rangeFromWindow(i.ownerDocument.defaultView||window),l=b.TrackChangesSelection.locateElementInRange(j.getBrowserRange(),"table");
if(l.inRange){var k=i.className.split(" ");
if(k.length==2){h=k[1];
}}this.acceptNodeChanges(i,f);
if(h){i.className=h;
}if((d.isTag(i,"span")||d.isTag(i,"font"))&&!d.hasAttributes(i)){d.removeNode(i);
try{j.select();
}catch(g){}}},acceptNodeChanges:function(e){c.removeNodeTracking(e);
},rejectChanges:function(f,e){this.rejectNodeChanges(f,e);
},rejectNodeChanges:function(e){d.removeNode(e);
},_restoreFormatting:function(f){var e,g="";
if(f.getAttribute("originalvalue")){g=f.getAttribute("originalvalue");
}if(f.getAttribute("cssproperty")){e=f.getAttribute("cssproperty");
}if(e){f.style[e]=g;
}}};
b.BaseCommandsTracker.registerClass("Telerik.Web.UI.Editor.BaseCommandsTracker",null);
})($telerik.$,Telerik.Web.UI.Editor,Telerik.Web.UI.Editor.Utils,Telerik.Web.UI.Editor.TrackChangesUtils);
Type.registerNamespace("Telerik.Web.UI.Editor");
(function(a,b,d,c){b.AlignCommandTracker=function(e){b.AlignCommandTracker.initializeBase(this,[e]);
};
b.AlignCommandTracker.prototype={trackFormatting:function(f,e){var g=this;
g._savePreviousState(f);
c.setTrackChangesAttributes(f.node,e,g.author,g.userCssId,g.timestamp);
},rejectNodeChanges:function(e){if(e.getAttribute("iswrapper")){b.AlignCommandTracker.callBaseMethod(this,"rejectNodeChanges",[e]);
return;
}this._restoreFormatting(e);
c.removeNodeTracking(e);
}};
b.AlignCommandTracker.registerClass("Telerik.Web.UI.Editor.AlignCommandTracker",b.BaseCommandsTracker);
})($telerik.$,Telerik.Web.UI.Editor,Telerik.Web.UI.Editor.Utils,Telerik.Web.UI.Editor.TrackChangesUtils);
(function(a,b){Type.registerNamespace("Telerik.Web.UI.Editor");
var f=b.Utils;
var e=b.TrackChangesUtils;
var d=e.isTrackChangeElement;
var c=e.getTrackChangesCommand;
b.IndentationTracker=function(g){b.IndentationTracker.initializeBase(this,[g]);
};
b.IndentationTracker.prototype={trackFormatting:function(i,g){var o=this;
var k=i.node;
if(!o.isListItem&&!o.isTextNode&&!i.originalValue&&!k.style.marginLeft){if(i.isWrapper){f.removeNode(k);
}return;
}if(!o.isTracked){o._savePreviousState(i);
e.setTrackChangesAttributes(k,g,o.author,o.userCssId,o.timestamp);
return;
}var m=e.getTrackChangesCommand(k);
var h=k.getAttribute("cssproperty");
var j=k.getAttribute("iswrapper");
var l=k.getAttribute("originalvalue")||"";
if(((m=="Indent"&&g=="Outdent")||(m=="Outdent"&&g=="Indent"))){if(j&&!h&&k.style.marginLeft==l){var n=new b.DomRange.rangeFromWindow(k.ownerDocument.defaultView||window);
f.removeNode(k);
n.select();
}else{if(o.isListItem||(h&&k.style[h]==l)){e.removeNodeTracking(k);
}}}},acceptNodeChanges:function(i,g){var j=this;
if(/^insert(un)orderedList/i.test(i.getAttribute("innercommand")||"")){var h=new b.InsertListTracker(j._editor);
return h.acceptNodeChanges(i,i.getAttribute("innercommand"));
}if(f.isTag(i,"li")){j._acceptListItemChanges(i,g);
}else{b.IndentationTracker.callBaseMethod(j,"acceptNodeChanges",[i]);
}},_acceptListItemChanges:function(i,h){var j=i.getAttribute("previousoutdent"),k=i.getAttribute("timestamp").toString();
if(j){j=j.toString();
k=k+"|"+j.replace(/[,]/gm,"|");
i.removeAttribute("previousoutdent");
}if(h=="Indent"&&e.isTrackChangeElement(i.parentNode)&&e.getTrackChangesCommand(i.parentNode)==h){e.removeNodeTracking(i.parentNode);
}var g=e.getSameTrackingSiblings(i);
g.each(function(l,m){e.removeNodeTracking(m);
m.removeAttribute("previousoutdent");
});
},_executeOppositeCommand:function(k,g){var i=this._editor;
var h=i.get_contentArea();
var l=this.collectSameTrackNodes(k);
var j=function(n){return d(n)&&c(n)===g;
};
var m=f.findAncestorBy(h,k,j);
if(m&&m!==h){this._executeOppositeCommand(m,g);
}Array.forEach(l,e.removeNodeTracking);
this._runOppositeCommandOnNodes(l);
},restoreNode:function(g){this._restoreFormatting(g);
e.removeNodeTracking(g);
}};
b.IndentationTracker.registerClass("Telerik.Web.UI.Editor.IndentationTracker",b.BaseCommandsTracker);
})($telerik.$,Telerik.Web.UI.Editor);
Type.registerNamespace("Telerik.Web.UI.Editor");
(function(a,b,d,c){b.IndentTracker=function(e){b.IndentTracker.initializeBase(this,[e]);
};
b.IndentTracker.prototype={rejectNodeChanges:function(j,h){if(j.getAttribute("iswrapper")){if(d.isList(j)&&d.isTag(j.parentNode,"li")){a(j).insertAfter(j.parentNode);
}b.IndentTracker.callBaseMethod(this,"rejectNodeChanges",[j]);
return;
}var i=d.isTag(j,"li"),e,k;
if(d.isList(j)&&d.isTag(j.parentNode,"li")){e=a(j);
var f=e.children(),g=f.length==f.filter(function(m,n){return c.isTrackChangeElement(n)&&c.getTrackChangesCommand(n)==h;
}).length;
if(g){k=j.parentNode;
f.each(function(m,n){c.removeNodeTracking(n);
});
f.insertAfter(k);
e.remove();
return;
}}var l=j.parentNode;
if(i&&c.isTrackChangeElement(l)&&d.isTag(l.parentNode,"li")&&c.getTrackChangesCommand(l)=="Indent"){e=a(l);
k=l.parentNode;
e.children().each(function(m,n){c.removeNodeTracking(n);
});
e.children().insertAfter(k);
e.remove();
return;
}if(!i){return this.restoreNode(j);
}this._executeOppositeCommand(j,h);
},collectSameTrackNodes:function(e){return c.getSameTrackingSiblings(e).get();
},_runOppositeCommandOnNodes:function(f){var e=new b.OutdentCommand(this._editor,{title:"Outdent"});
e.nodes=f;
e.executeDomCommand(f);
}};
b.IndentTracker.registerClass("Telerik.Web.UI.Editor.IndentTracker",b.IndentationTracker);
})($telerik.$,Telerik.Web.UI.Editor,Telerik.Web.UI.Editor.Utils,Telerik.Web.UI.Editor.TrackChangesUtils);
Type.registerNamespace("Telerik.Web.UI.Editor");
(function(a,b,d,c){b.InlineCommandTracker=function(e){b.InlineCommandTracker.initializeBase(this,[e]);
};
b.InlineCommandTracker.prototype={trackFormatting:function(f,e){var i=this;
var g=f.node;
if(!i.isTracked||f.overrideTracking){c.setTrackChangesAttributes(g,e,i.author,i.userCssId,i.timestamp);
return;
}var h=c.getTrackChangesCommand(g);
if(e=="Remove "+h){c.removeNodeTracking(g);
if((d.isTag(g,"span")||d.isTag(g,"font"))&&!d.hasAttributes(g)){d.removeNode(g);
}}},rejectNodeChanges:function(j,f){if(!/^Remove\s/.test(f)){return b.InlineCommandTracker.callBaseMethod(this,"rejectNodeChanges",[j]);
}var i=f.replace("Remove ",""),e=new b[i+"Command"](null,{title:i}),k=e.settings.tag,g=e.settings.cssName,h=e.settings.cssValue||e.options.commandValue;
c.removeNodeTracking(j);
if(k&&k!=j.nodeName){j=d.replaceNode(j,k);
}else{if(g){j.style[g]=h;
}}}};
b.InlineCommandTracker.registerClass("Telerik.Web.UI.Editor.InlineCommandTracker",b.BaseCommandsTracker);
})($telerik.$,Telerik.Web.UI.Editor,Telerik.Web.UI.Editor.Utils,Telerik.Web.UI.Editor.TrackChangesUtils);
Type.registerNamespace("Telerik.Web.UI.Editor");
(function(a,b,d,c){b.InsertLinkTracker=function(e){b.InsertLinkTracker.initializeBase(this,[e]);
};
b.InsertLinkTracker.prototype={trackFormatting:function(f,e){if(d.isTag(f,"a")){var g=this;
c.setTrackChangesAttributes(f,e,g.author,g.userCssId);
}}};
b.InsertLinkTracker.registerClass("Telerik.Web.UI.Editor.InsertLinkTracker",Telerik.Web.UI.Editor.BaseCommandsTracker);
})($telerik.$,Telerik.Web.UI.Editor,Telerik.Web.UI.Editor.Utils,Telerik.Web.UI.Editor.TrackChangesUtils);
Type.registerNamespace("Telerik.Web.UI.Editor");
(function(a,b,d,c){b.InsertListTracker=function(e){b.InsertListTracker.initializeBase(this,[e]);
};
b.InsertListTracker.prototype={trackNodeFormatting:function(f,e){var h=f.node,j=this,g=f.isEmptyList;
j.originalNodeName=f.originalNodeName;
j.isWrapper=f.isWrapper;
j.itemIndex=f.itemIndex;
j.itemsCount=f.itemsCount;
j.parentNode=f.parentNode;
if(j.isTracked){var i=c.getTrackChangesCommand(h);
if(/Insert(:?Un)?OrderedList/i.test(i)){return j._trackTrackedNode(h,e,i);
}}if(g){h.setAttribute("isemptylist",true);
j._trackEmptyList(h,e);
}else{if(!j.isListItem&&d.isList(j.parentNode)&&c.isTrackChangeElement(j.parentNode)&&e==c.getTrackChangesCommand(j.parentNode)&&!h.getAttribute("listnodename")){j._cleanUpCommandAttributes(h);
}else{if(j.isListItem){j._trackListItem(h,e);
}else{if(d.isList(h)){j._trackList(h,e);
}else{c.setTrackChangesAttributes(h,e,j.author,j.userCssId,j.timestamp);
j._setAttribute(h,"itemindex",j.itemIndex);
j._setAttribute(h,"itemscount",j.itemsCount);
j._setAttribute(h,"innercommand",j._innerCommand);
}}}}},_trackEmptyList:function(f,e){var g=this;
c.setTrackChangesAttributes(f,e,g.author,g.userCssId,g.timestamp);
},_trackListItem:function(g,e){var h=this;
if(!h._setAttribute(g,"iswrapper",h.isWrapper)){h._setAttribute(g,"originalnodename",h.originalNodeName);
}var f=g.parentNode;
if(!c.isTrackChangeElement(f)){c.setTrackChangesAttributes(f,e,h.author,h.userCssId,h.timestamp);
}},_trackList:function(h,e){var j=this;
c.setTrackChangesAttributes(h,e,j.author,j.userCssId,j.timestamp);
var i=h.nodeName=="OL"?"UL":"OL",f=j.itemIndex,g=j.itemsCount;
j._setAttribute(h,"originalnodename",i);
if(typeof f!="undefined"&&typeof g!="undefined"){a(h).children().each(function(k,l){j._setAttribute(l,"itemindex",f++);
j._setAttribute(l,"itemscount",g);
j._setAttribute(l,"listnodename",i);
});
}},_trackTrackedNode:function(h,e,i){var k=this,j=e==i;
if(d.isList(h)){h=k._mergeNearLists(h);
k._cleanUpCommandAttributes(h);
c.removeNodeTracking(h);
if(!j){c.setTrackChangesAttributes(h,e,k.author,k.userCssId,k.timestamp);
}}else{if(k.isListItem){var g=h.getAttribute("listnodename");
if(g&&g!=h.parentNode.nodeName){return;
}if(!k.listMerged){var f=h.parentNode;
f=k._mergeNearLists(f);
k.listMerged=true;
}k._cleanUpCommandAttributes(h);
c.removeNodeTracking(h);
}}},_setAttribute:function(g,e,f){if(typeof f!="undefined"&&!g.getAttribute(e)){g.setAttribute(e,f.toString());
return true;
}},acceptNodeChanges:function(f,e){var g=this;
g._cleanUpCommandAttributes(f);
b.InsertListTracker.callBaseMethod(g,"acceptNodeChanges",[f,e]);
},_removeAttribute:function(f,e){if(f.getAttribute(e)){f.removeAttribute(e);
}},rejectNodeChanges:function(g,e){var h=g.getAttribute("originalnodename")||g.getAttribute("listnodename"),i=this;
if(g.getAttribute("isemptylist")){return i._rejectEmptyList(g);
}if(d.isList(g)){if(h){var f=g;
i._removeAttribute(f,"originalnodename");
i._removeAttribute(f,"listnodename");
c.removeNodeTracking(f);
f=d.replaceNode(f,h);
f=i._mergeNearLists(f);
i._cleanUpCommandAttributes(f);
}else{return i._rejectInsertedList(g,h);
}}else{return i._rejectRemovedList(g,e,h);
}i._cleanUpCommandAttributes(g);
},_rejectEmptyList:function(e){var f=this;
a(e).children().each(function(g,h){if(d.isNodeEmptyRecursive(h)){d.removeNode(h);
}else{var i=d.replaceNode(h,"p");
f._cleanUpCommandAttributes(i);
}});
if(d.isNodeEmptyRecursive(e)){d.removeNode(e);
}this.ignoreRangeSelect=true;
},_rejectInsertedList:function(f){var e=a(f);
e.children().each(function(g,i){var k=i.getAttribute("originalnodename"),h=i.getAttribute("iswrapper");
if(k){i.removeAttribute("originalnodename");
}var j=d.replaceNode(i,k||"P");
f.parentNode.insertBefore(j,f);
if(h){d.removeNode(j);
}});
e.remove();
},_rejectRemovedList:function(j,g,k){var i=k||(g=="InsertOrderedList"?"ol":"ul"),l=this,f=new b.InsertListCmd(l._editor,{title:g,listType:i}),e=c.getSameTrackingSiblings(j),h;
e.each(function(n,m){c.removeNodeTracking(m);
f.executeOnNode(m);
h=f.insertedList;
});
if(h){h=l._mergeNearLists(h);
l._cleanUpCommandAttributes(h);
}},_cleanUpCommandAttributes:function(f){var h=this;
var e=["itemindex","itemscount","listnodename","originalnodename","iswrapper","isemptylist"];
var g=function(k){for(var j=0;
j<e.length;
j++){h._removeAttribute(k,e[j]);
}};
if(d.isList(f)){a(f).children().each(function(i,j){g(j);
});
}g(f);
},_mergeNearLists:function(l){var f=a(l);
var e=f.children();
var m=e.length;
var r;
var p;
var s=this;
if(!m){return l;
}var i=e[0];
var j=i.getAttribute("itemindex"),k=i.getAttribute("itemscount");
var n=i.getAttribute("listnodename")||l.nodeName;
if(j){j=parseInt(j,10);
}if(k){k=parseInt(k,10);
}if(k==m){return l;
}if(j>0){var h=f.prev();
var q=h[0];
if(d.isList(q)&&q.nodeName==n){r=q;
m+=h.children().length;
}}if(k>m){var g=f.next();
var o=g[0];
if(d.isList(o)&&o.nodeName==n){p=o;
}}if(r){l=s._mergeLists(r,l);
}if(p){l=s._mergeLists(l,p);
}return l;
},_mergeLists:function(f,g){var e=a(g);
e.children().each(function(h,i){f.appendChild(i);
});
e.remove();
return f;
}};
b.InsertListTracker.registerClass("Telerik.Web.UI.Editor.InsertListTracker",Telerik.Web.UI.Editor.BaseCommandsTracker);
})($telerik.$,Telerik.Web.UI.Editor,Telerik.Web.UI.Editor.Utils,Telerik.Web.UI.Editor.TrackChangesUtils);
(function(a,b,f,e){Type.registerNamespace("Telerik.Web.UI.Editor");
var d=/^insert(un)?orderedList/i;
var c=Function.createDelegate;
b.OutdentTracker=function(g){b.OutdentTracker.initializeBase(this,[g]);
this.stateAttrName="trackingstate";
};
b.OutdentTracker.prototype={trackNodeFormatting:function(i,h){var l=this,k=i.node,g=l.author,n=l.userCssId,m=l.timestamp;
if(d.test(l._innerCommand||"")){var j=new b.InsertListTracker(l._editor);
j._innerCommand=l._innerCommand;
j.timestamp=l.timestamp;
return j.trackNodeFormatting(i,h);
}if(!i||(!i.parentNode&&!i.previousSibling&&!i.nextSibling)){b.OutdentTracker.callBaseMethod(l,"trackNodeFormatting",[i,h]);
return;
}if(f.isList(k)&&!a(k).children().length){return;
}if(l.isListItem){if(l.isTracked&&e.getTrackChangesCommand(k)=="Indent"){e.removeNodeTracking(k);
return;
}e.setTrackChangesAttributes(k,h,g,n,m);
return;
}e.setTrackChangesAttributes(k,h,g,n,m);
},rejectNodeChanges:function(j,g){var k=this;
if(d.test(j.getAttribute("innercommand")||"")){var h=new b.InsertListTracker(k._editor);
return h.rejectNodeChanges(j,j.getAttribute("innercommand"));
}if(j.getAttribute("iswrapper")){b.OutdentTracker.callBaseMethod(k,"rejectNodeChanges",[j]);
return;
}var i=f.isTag(j,"li");
if(!i){return k.restoreNode(j);
}k._executeOppositeCommand(j,g);
},_executeOppositeCommand:function(i,g){var j=parseInt(i.getAttribute("timestamp"),10);
b.OutdentTracker.callBaseMethod(this,"_executeOppositeCommand",[i,g]);
var h=f.isTag(i,"li");
if(!h){return this.restoreNode(i);
}this._rejectOutdentedList(i,g,j);
},collectSameTrackNodes:function(h){if(h.getAttribute("previousoutdent")){var g=this._editor.get_contentArea();
return e.getSameTrackNodes(g,h).get();
}else{return e.getSameTrackingSiblings(h).get();
}},_runOppositeCommandOnNodes:function(h){var g=new b.IndentCommand(this._editor,{title:"Indent"});
Array.forEach(h,c(g,g.executeOnNode));
},_rejectOutdentedList:function(k,h,p){var g=this;
var j=this._editor;
var i=j.get_contentArea();
var m=k.getAttribute("previousoutdent");
if(!m){return;
}m=m.toString();
var n=this._getLastTimestamp(m.split(","));
this._updateCommandAttributes(k,m);
var o=String.format("[previousoutdent$={0}]",n);
var l=a(i).find(o);
l.each(function(){g._updateCommandAttributes(this,this.getAttribute("previousoutdent"));
});
this._executeOppositeCommand(k,"Outdent");
},_getElementByAttribute:function(g,h,i){return g.filter(function(){var j=this.getAttribute(h);
return RegExp(i,"").test(j);
})[0];
},_updateCommandAttributes:function(g,i){i=i.toString();
var k=i.split(",");
var j=this._getLastTimestamp(k);
if(!j||!/^[0-9]{13}$/.test(j)){return;
}g.setAttribute("timestamp",j);
e.setTrackChangesCommand(g,"Outdent");
Array.remove(k,j);
var h=k.join(",");
if(h){g.setAttribute("previousoutdent",h);
}else{g.removeAttribute("previousoutdent");
}},_getLastTimestamp:function(k){if(!k||!k.length){return null;
}var j=parseInt(k[0],10);
for(var h=0;
h<k.length;
h++){var g=parseInt(k[h],10);
j=Math.max(j,g);
}return j.toString();
}};
b.OutdentTracker.registerClass("Telerik.Web.UI.Editor.OutdentTracker",b.IndentationTracker);
})($telerik.$,Telerik.Web.UI.Editor,Telerik.Web.UI.Editor.Utils,Telerik.Web.UI.Editor.TrackChangesUtils);
Type.registerNamespace("Telerik.Web.UI.Editor");
(function(a){a.TrackerFactory={getCommandTracker:function(b,c){if(/align|justify/i.test(b)){return new a.AlignCommandTracker(c);
}else{if(/LinkManager|InsertLink/i.test(b)){return new a.InsertLinkTracker(c);
}}switch(b){case"Bold":case"Italic":case"Underline":case"Subscript":case"Superscript":case"StrikeThrough":return new a.InlineCommandTracker(c);
case"Indent":case"Outdent":return new a[b+"Tracker"](c);
case"InsertOrderedList":case"InsertUnorderedList":return new a.InsertListTracker(c);
default:return null;
}}};
})(Telerik.Web.UI.Editor);
if(typeof(Sys)!=='undefined')Sys.Application.notifyScriptLoaded();