(function(b,a){a.fn.pinchZoom=function(){if(a(this).length>1){return new c(a(a(this).get(0)));
}return new c(a(this));
};
function c(d){this._$element=d;
this._wrapper=this._$element.parent().get(0);
this.settings=c.DefaultSettings;
this._initialize();
}c.DefaultSettings={initialPosition:{x:0,y:0},initialZoom:1,minZoom:1,maxZoom:3,respectBoundaries:true};
c.prototype={_initialize:function(){var d=this;
d._x=0;
d._y=0;
d._actionInProgress=Telerik.Web.UI.PinchZoomActionType.None;
d._direction={x:0,y:0};
d._distance={x:0,y:0};
d._currentScale=d._normalizedInitialScaleLevel();
d._setStyle(d._$element,"transformOrigin","0 0");
this._enabled=true;
d._gesturesInstance=null;
d._initialSetup();
},_initialSetup:function(){var d=this;
d._updateValuesAndPosition();
d._translateToPoint(d.settings.initialPosition.x,d.settings.initialPosition.y);
d._initializeEvents();
},_initializeEvents:function(){var e=this;
var d={touchStart:a.proxy(e._handleTouchStart,e),move:function(f){if(f.points.length>1){e._handleZoomInProgress(f);
}else{e._handleMoveInProgress(f);
}},touchEnd:a.proxy(e._handleTouchEnd,e),instanceData:{name:"PinchZoomUtility"}};
e._gesturesInstance=e._$element.gestures(d);
a(window).on("resize",a.proxy(e._handleResize,e));
},_validateActionType:function(d){return true;
},_handleTouchStart:function(d){var f=this;
d.domEvent.preventDefault();
if(!f._validateActionType(Telerik.Web.UI.PinchZoomActionType.TouchStart)){return;
}f._actionInProgress=Telerik.Web.UI.PinchZoomActionType.TouchStart;
f._hasMoved=false;
f._distance={x:0,y:0};
f._direction={x:0,y:0};
f._startTime=new Date().getTime();
f._startX=f._x;
f._startY=f._y;
f._pointX=d.points[0].start.x;
f._pointY=d.points[0].start.y;
if(d.points.length>1){f._handleZoomStart(d);
}},_handleZoomStart:function(g){var j=this;
var h=g.points[0].end;
var i=g.points[1].end;
var d=Math.abs(h.x-i.x);
var f=Math.abs(h.y-i.y);
j._touchesDistanceStart=Math.sqrt(d*d+f*f);
j._startScale=j._currentScale;
j._originX=Math.abs(h.x+i.x)/2+j._wrapperOffset.left-j._x;
j._originY=Math.abs(h.y+i.y)/2+j._wrapperOffset.top-j._y;
},_handleZoomInProgress:function(g){var l=this;
if(!l._validateActionType(Telerik.Web.UI.PinchZoomActionType.Move)){return;
}var i=g.points[0].end;
var j=g.points[1].end;
var d=Math.abs(i.x-j.x);
var f=Math.abs(i.y-j.y);
var o=Math.sqrt(d*d+f*f);
var k=1/l._touchesDistanceStart*o*l._startScale;
var h;
var m;
var n;
l._scaled=true;
if(k<l.settings.minZoom){k=0.5*l.settings.minZoom*Math.pow(2,k/l.settings.minZoom);
}else{if(k>l.settings.maxZoom){k=2*l.settings.maxZoom*Math.pow(0.5,l.settings.maxZoom/k);
}}h=k/l._startScale;
m=l._originX-l._originX*h+l._startX;
n=l._originY-l._originY*h+l._startY;
l._currentScale=k;
l._translateToPoint(m,n);
},_handleTouchEnd:function(d){var f=this;
if(!f._scaled){f._handleMoveEnd(d);
}else{f._handleZoomEnd(d);
}},_handleZoomEnd:function(d){var i=this;
if(!i._validateActionType(Telerik.Web.UI.PinchZoomActionType.Move)){return;
}var g;
var h;
var f;
i._actionInProgress=false;
if(i._currentScale>i.settings.maxZoom){i._currentScale=i.settings.maxZoom;
}else{if(i._currentScale<i.settings.minZoom){i._currentScale=i.settings.minZoom;
}}i._updateValuesAndPosition();
f=i._currentScale/i._startScale;
g=i._originX-i._originX*f+i._startX;
h=i._originY-i._originY*f+i._startY;
if(g>0){g=0;
}else{if(g<i._maxScrollX){g=i._maxScrollX;
}}if(h>0){h=0;
}else{if(h<i._maxScrollY){h=i._maxScrollY;
}}if(i._x!=g||i._y!=h){i._translateToPoint(g,h);
}i._scaled=false;
},_handleMoveEnd:function(d){var h=this;
if(!h._validateActionType(Telerik.Web.UI.PinchZoomActionType.Move)){return;
}var f=Math.round(h._x);
var g=Math.round(h._y);
h._actionInProgress=false;
h._endTime=new Date().getTime();
h._translateToPoint(f,g);
if(!h._hasMoved){return;
}if(f!=h._x||g!=h._y){h._translateToPoint(f,g);
return;
}},_handleMoveInProgress:function(i){var l=this;
if(!l._validateActionType(Telerik.Web.UI.PinchZoomActionType.Move)){return;
}var n=i.points[0].end;
var g=n.x-l._pointX;
var h=n.y-l._pointY;
var m=new Date().getTime();
var j,k;
var d,f;
l._pointX=n.x;
l._pointY=n.y;
l._distance.x+=g;
l._distance.y+=h;
d=Math.abs(l._distance.x);
f=Math.abs(l._distance.y);
if(m-l._endTime>300&&(d<10&&f<10)){return;
}g=l._hasHorizontalScroll?g:0;
h=l._hasVerticalScroll?h:0;
j=l._x+g;
k=l._y+h;
if(l.settings.respectBoundaries){if(j>0){j=0;
}else{if(j<l._maxScrollX){j=l._maxScrollX;
}}if(k>0){k=0;
}else{if(k<l._maxScrollY){k=l._maxScrollY;
}}}l._direction.x=g>0?-1:g<0?1:0;
l._direction.y=h>0?-1:h<0?1:0;
l._hasMoved=true;
l._translateToPoint(j,k);
if(m-l._startTime>300){l._startTime=m;
l._startX=l._x;
l._startY=l._y;
}},_handleResize:function(){var d=this;
clearTimeout(d._resizeTimeout);
d._resizeTimeout=setTimeout(function(){d._updateValuesAndPosition();
},50);
},_normalizedInitialScaleLevel:function(){var d=this;
if(d.settings.initialZoom<d.settings.minZoom){d.settings.initialZoom=d.settings.minZoom;
}if(d.settings.initialZoom>d.settings.maxZoom){d.settings.initialZoom=d.settings.maxZoom;
}return d.settings.initialZoom;
},_translateToPoint:function(f,g){var d=this;
var e=String.format("translate({0}px, {1}px) scale({2}) translateZ(0)",f,g,d._currentScale);
d._x=f;
d._y=g;
d._setStyle(d._$element,"transform",e);
},_updateValuesAndPosition:function(){var f=this;
var d=f._$element.get(0);
var e=f._wrapper.offsetHeight;
f._wrapperWidth=f._wrapper.clientWidth;
f._wrapperHeight=f._wrapper.clientHeight;
f._elementWidth=Math.round(d.offsetWidth*f._currentScale);
f._elementHeight=Math.round(d.offsetHeight*f._currentScale);
f._maxScrollX=f._wrapperWidth-f._elementWidth;
f._maxScrollY=f._wrapperHeight-f._elementHeight;
f._hasHorizontalScroll=f._maxScrollX<0;
f._hasVerticalScroll=f._maxScrollY<0;
if(!f._hasHorizontalScroll){f._maxScrollX=0;
f._elementWidth=f._wrapperWidth;
}if(!f._hasVerticalScroll){f._maxScrollY=0;
f._elementHeight=f._wrapperHeight;
}f._endTime=0;
f._direction.x=0;
f._direction.y=0;
f._wrapperOffset=f._offset(f._wrapper);
f._resetPosition();
},_offset:function(d){var e=-d.offsetLeft,f=-d.offsetTop;
while(d=d.offsetParent){e-=d.offsetLeft;
f-=d.offsetTop;
}return{left:e,top:f};
},_resetPosition:function(e){var d=this;
var f=d._x;
var g=d._y;
e=e||0;
if(!d._hasHorizontalScroll||d._x>0){f=0;
}else{if(d._x<d._maxScrollX){f=d._maxScrollX;
}}if(!d._hasVerticalScroll||d._y>0){g=0;
}else{if(d._y<d._maxScrollY){g=d._maxScrollY;
}}if(f==d._x&&g==d._y){return false;
}d._translateToPoint(f,g);
return true;
},_setStyle:function(g,e,f){var d={};
d["-webkit-"+e]=f;
d["-ms-"+e]=f;
d["-moz-"+e]=f;
d["-o-"+e]=f;
d[e]=f;
g.css(d);
},_detachEvents:function(){var d=this;
if(d._gesturesInstance){d._gesturesInstance.destroy();
d._gesturesInstance=null;
}a(window).off("resize");
},update:function(){this._updateValuesAndPosition();
},getScale:function(){return this._currentScale;
},resetImageStyles:function(){var d=this;
d._setStyle(d._$element,"transform","");
d._setStyle(d._$element,"transformOrigin","");
},enable:function(){this._enabled=true;
this._initializeEvents();
},disable:function(){this._enabled=false;
this._detachEvents();
},reattachEvents:function(){this.disable();
this.enable();
},setTargetElement:function(d){var e=this;
e.disable();
e._$element=d;
e._updateValuesAndPosition();
e.enable();
},destroy:function(){this._detachEvents();
}};
Telerik.Web.UI.PinchZoomActionType=function(){};
Telerik.Web.UI.PinchZoomActionType.prototype={None:0,TouchStart:1,Move:2,TouchEnd:3};
Telerik.Web.UI.PinchZoomActionType.registerEnum("Telerik.Web.UI.PinchZoomActionType",false);
})($telerik,$telerik.$);
if(typeof(Sys)!=='undefined')Sys.Application.notifyScriptLoaded();