Type.registerNamespace("Telerik.Web.UI");
(function(a,b){$telerik.toNotification=function(d){return d;
};
$telerik.findNotification=$find;
var c=Telerik.Web.Browser;
a.registerEnum(b,"NotificationLoad",{PageLoad:0,FirstShow:1,EveryShow:2,TimeInterval:3});
a.registerEnum(b,"NotificationPosition",{TopLeft:11,TopCenter:12,TopRight:13,MiddleLeft:21,Center:22,MiddleRight:23,BottomLeft:31,BottomCenter:32,BottomRight:33});
a.registerEnum(b,"NotificationHorizontalPosition",{Left:1,Center:2,Right:3});
a.registerEnum(b,"NotificationVerticalPosition",{Top:1,Middle:2,Bottom:3});
a.registerEnum(b,"NotificationScrolling",{Auto:0,None:1,X:2,Y:3,Both:4,Default:5});
a.registerEnum(b,"NotificationAnimation",{None:0,Resize:1,Fade:2,Slide:4,FlyIn:8});
b.RadNotification=function(d){b.RadNotification.initializeBase(this,[d]);
this._popupElement=$get(this.get_id()+"_popup");
this._titlebar=$get(this.get_id()+"_titlebar");
this._menuIcon=$get(this.get_id()+"_rnMenuIcon");
this._closeIcon=$get(this.get_id()+"_rnCloseIcon");
this._xmlPanel=$find(this.get_id()+"_XmlPanel");
this._titleMenu=$find(this.get_id()+"_TitleMenu");
this._position=b.NotificationPosition.BottomRight;
this._visibleTitlebar=true;
this._width="";
this._height="";
this._updateInterval=0;
this._showInterval=0;
this._loadContentOn=b.NotificationLoad.PageLoad;
this._keepOnMouseOver=true;
this._enabled=true;
this._text="";
this._title="";
this._audioUrl="";
this._audioMimeType="";
this._audioElement=null;
this._firstShow=true;
this._autoCloseRef=null;
this._horizontalPosition=b.NotificationHorizontalPosition.Right;
this._verticalPosition=b.NotificationVerticalPosition.Bottom;
this._cancelAutoClose=false;
this._popupTouchScroll=null;
this._canPlaySound=false;
};
b.RadNotification.prototype={initialize:function(){b.RadNotification.callBaseMethod(this,"initialize");
var d=this.get_element().style.zIndex||$telerik.getCurrentStyle(this.get_element(),"zIndex");
if(!parseInt(d,10)){d=10000;
}this.set_zIndex(d);
this._addToDocument();
this._attachXmlPanelHandlers();
this._registerPopupHandlers(true);
if(this.get_enableAriaSupport()){this._applyAriaSupport();
}if(this._shouldPlaySound()){this._renderAudioElement();
}if(this.get_visibleOnPageLoad()){setTimeout(Function.createDelegate(this,function(){this.show();
}),0);
}},dispose:function(){this._stopTimer("_updateTimer");
this._stopTimer("_showTimer");
this.cancelAutoCloseDelay();
this._registerPopupHandlers(false);
this._createTouchScrollExtender(false);
if(this._popupBehavior){this._popupBehavior.dispose();
}var d=this.get_popupElement();
if(Sys&&Sys.WebForms){var e=Sys.WebForms.PageRequestManager.getInstance();
if(e&&e.get_isInAsyncPostBack()){$telerik.disposeElement(d);
}}if(d&&d.parentNode){d.parentNode.removeChild(d);
}b.RadNotification.callBaseMethod(this,"dispose");
},_attachXmlPanelHandlers:function(){var d=this._xmlPanel;
d.add_responseEnding(Function.createDelegate(this,this._onResponseEnding));
d.add_responseEnded(Function.createDelegate(this,this._onResponseEnded));
d.add_responseError(Function.createDelegate(this,this._onResponseError));
},_registerPopupHandlers:function(d){this._registerMouseKeepHandlers(d);
this._registerTitlebarHandlers(d);
this._registerWindowResizeHandler(d);
},_registerMouseKeepHandlers:function(d){var e=this.get_popupElement();
if(true==d&&this.get_keepOnMouseOver()){this._mouseEnterHandler=Function.createDelegate(this,this._onMouseEnter);
$addHandler(e,"mouseover",this._mouseEnterHandler);
this._mouseLeaveHandler=Function.createDelegate(this,this._onMouseLeave);
$addHandler(e,"mouseout",this._mouseLeaveHandler);
}else{if(this._mouseEnterHandler||this._mouseLeaveHandler){$clearHandlers(e);
this._mouseEnterHandler=null;
this._mouseLeaveHandler=null;
}}},_registerTitlebarHandlers:function(d){if(true==d){if(this.get_showTitleMenu()&&this._menuIcon){this._showMenuHandler=Function.createDelegate(this,this._onMenuIconClick);
$addHandler(this._menuIcon,"click",this._showMenuHandler);
}if(this.get_showCloseButton()&&this._closeIcon){this._closeHandler=Function.createDelegate(this,this._close);
$addHandler(this._closeIcon,"click",this._closeHandler);
}}else{if(this._showMenuHandler&&this._menuIcon){$removeHandler(this._menuIcon,"click",this._showMenuHandler);
}if(this._closeHandler&&this._closeIcon){$removeHandler(this._closeIcon,"click",this._closeHandler);
}}},_registerWindowResizeHandler:function(d){if(d){this._onWindowResizeDelegate=Function.createDelegate(this,this._repositionOnResize);
$addHandler(window,"resize",this._onWindowResizeDelegate);
}else{if(this._onWindowResizeDelegate){$removeHandler(window,"resize",this._onWindowResizeDelegate);
this._onWindowResizeDelegate=null;
}}},_repositionOnResize:function(){if(this.isVisible()){var e=this.get_width();
var d=this.get_height();
if((e.toString().indexOf("%")>-1)||(d.toString().indexOf("%")>-1)){this.setSize(e,d);
}this._show();
if($telerik.isIE9Mode){this._show();
}this._popupBehavior.pin(this.get_pinned());
}},_createAudioElement:function(){var d=document.createElement("audio");
d.setAttribute("src",this._audioUrl);
d.setAttribute("preload","auto");
d.style.position="absolute";
d.style.left=0;
d.style.top=0;
this._soundPlayDelegate=Function.createDelegate(this,this._onSoundPlay);
$telerik.onEvent(d,"play",this._soundPlayDelegate);
this._audioElement=d;
},_createObjectElement:function(){var e=document.createElement("embed");
e.setAttribute("id",this.get_id()+"_playAudio");
e.setAttribute("src",this._audioUrl);
var d=(this.get_visibleOnPageLoad()&&this.get_animation()==b.NotificationAnimation.None);
e.setAttribute("autostart",d);
e.setAttribute("pluginspage","http://www.apple.com/quicktime/download/");
e.setAttribute("name","NotificationAudio");
e.setAttribute("enablejavascript","true");
e.setAttribute("type",this._audioMimeType);
e.setAttribute("class","rnEmbed");
if($telerik.isIE7){this._moveIE7EmbedTag(e);
}this._audioElement=e;
this._canPlaySound=true;
},_moveIE7EmbedTag:function(d){d.style.width="0px";
d.style.hegiht="0px";
d.style.position="absolute";
d.style.top="-99999px";
d.style.left="-99999px";
},_supportsAudio:function(){return this._audioElement&&this._audioElement.play&&this._audioElement.canPlayType&&this._audioElement.canPlayType(this._audioMimeType);
},_shouldPlaySound:function(){return this._audioUrl!=""&&this._audioUrl.toString().toLowerCase()!="none";
},_onSoundPlay:function(){this._canPlaySound=true;
$telerik.offEvent(this._audioElement,"play",this._soundPlayDelegate);
},_renderAudioElement:function(){this._createAudioElement();
if(!this._supportsAudio()||!this._audioElement){this._createObjectElement();
}if(this._audioElement){this._getDefaultParent().appendChild(this._audioElement);
}},_close:function(d){this._hide(true);
return $telerik.cancelRawEvent(d);
},_onMenuIconClick:function(d){if(this.get_titleMenu()){this.get_titleMenu().show(d);
}return $telerik.cancelRawEvent(d);
},_onMouseEnter:function(d){var g=$telerik.isMouseOverElementEx(this.get_popupElement(),d);
if(g){this._cancelAutoClose=true;
this.cancelAutoCloseDelay();
var f=this.get_popupElement();
if(this.get_animation()!=b.NotificationAnimation.None&&a){a(f).stop(true,true);
}this._stopTimer("_showTimer");
f.style.position=this.get_pinned()?"fixed":"absolute";
$telerik.setVisible(f,true);
}},_onMouseLeave:function(d){var f=$telerik.isMouseOverElementEx(this.get_popupElement(),d);
if(!f){this._cancelAutoClose=false;
this._resetAutoCloseDelay();
}},_onResponseEnding:function(e,d){this.raiseEvent("updating",d);
},_onResponseEnded:function(g,d){var f=$get(this.get_id()+"_hiddenState");
if(f&&f.value&&g._isCallbackPanel){this.set_value(f.value);
}var e=this.get_contentElement();
if(g._getWebServiceLoader()&&!g._isCallbackPanel&&e){e.innerHTML=d.get_content();
}this.raiseEvent("updated",d);
this.setSize(this.get_width(),this.get_height());
this._setOverflow();
if(this.isVisible()){this._popupBehavior.pin(false);
this._show();
this._popupBehavior.pin(this.get_pinned());
}},_onResponseError:function(e,d){this.raiseEvent("updateError",d);
},show:function(){if(!this.get_enabled()){return;
}if(this.isVisible()){if(this.get_animation()!=b.NotificationAnimation.None&&a){a(this.get_popupElement()).stop(true,true);
}}this.setSize(this.get_width(),this.get_height());
this._setOverflow();
var d=new Sys.CancelEventArgs();
this.raiseEvent("showing",d);
if(d.get_cancel()){return;
}if(!this._popupBehavior){this._popupBehavior=$create(Telerik.Web.PopupBehavior,{id:(new Date()-100)+"PopupBehavior",parentElement:null,overlay:this._overlay,keepInScreenBounds:false},null,null,this.get_popupElement());
}this._popupBehavior.pin(false);
var e=this.get_loadContentOn();
if(e==b.NotificationLoad.EveryShow||(e==b.NotificationLoad.FirstShow&&this._firstShow)){this.update();
}this._firstShow=false;
if(this.get_animation()==b.NotificationAnimation.None){this._show();
this._afterShow();
}else{this._playAnimation();
}},update:function(){if(!this.get_enabled()){return;
}this._xmlPanel.set_value(this.get_value());
},_show:function(){var d=this.getBounds();
this._setPopupVisible(d.x,d.y);
this.playSound();
var e=this.get_contentElement();
if(e){$telerik.repaintChildren(e);
}},playSound:function(){var d=this._audioElement;
if(this._shouldPlaySound()&&d){if(d.tagName.toLowerCase()=="embed"){setTimeout(function(){if(typeof(d.Play)!="undefined"){d.Play();
}},10);
}else{d.play();
}}},userInitSound:function(){var d=this._audioElement;
if(!this._shouldPlaySound()||!d){return;
}d.play();
d.pause();
},verifySound:function(){return this._shouldPlaySound()&&this._canPlaySound;
},moveTo:function(d,e){this._setPopupVisible(d,e);
},_afterShow:function(){var e=this.get_width();
var d=this.get_height();
if((e.toString().indexOf("%")>-1)||(d.toString().indexOf("%")>-1)){this.setSize(e,d);
}this._show();
this._popupBehavior.pin(this.get_pinned());
this._updateOpacity();
this._setOverflow();
this.raiseEvent("shown");
if(this.get_enableAriaSupport()){this.get_popupElement().setAttribute("aria-hidden","false");
}if(!this._cancelAutoClose){this._resetAutoCloseDelay();
}},_playAnimation:function(){var l=this.get_pinned();
this._popupBehavior.pin(l);
var g=this.getBounds();
if(!l&&($telerik.isMobileSafari||$telerik.isSafari||$telerik.isChrome)){var i=window.pageYOffset;
var h=window.pageXOffset;
if(document.documentElement.scrollTop==0&&document.body.scrollTop>0){g.y+=i;
}if(document.documentElement.scrollLeft==0&&document.body.scrollLeft>0){g.x+=h;
}}var j=Function.createDelegate(this,function(){this._popupBehavior.pin(false);
this._show();
this._afterShow();
});
var d=this.get_popupElement();
var m=this.get_position();
var f=this.get_animation();
if(this._verticalPosition!=2){var p=(this._verticalPosition==1?3:1);
m=parseInt(p+""+this._horizontalPosition,10);
}var n=f==b.NotificationAnimation.Resize;
var o=$telerik.getBounds(document.documentElement);
if(n){o.width=0;
o.height=0;
o.x=g.x;
o.y=g.y;
}else{o.width=g.width;
o.height=g.height;
}var e=this.get_animationDuration();
var k=this.get_opacity()/100;
window.setTimeout(function(){b.Animations.playJQueryAnimation(d,f,o,g,m,null,j,e,k);
},0);
},hide:function(){if(!this.isVisible()){return;
}this._hide();
},_hide:function(g){var h=this.get_popupElement();
var d=this.get_animation()!=b.NotificationAnimation.None;
if(d&&a){a(h).stop(true,true);
}var e=new Sys.CancelEventArgs();
e._manualClose=g?g:false;
e.get_manualClose=function(){return this._manualClose;
};
this.raiseEvent("hiding",e);
if(e.get_cancel()){return;
}if(d&&!g&&a){var f=Function.createDelegate(this,this._afterHide);
a(h).fadeOut(this.get_animationDuration(),f);
}else{this._afterHide();
}},_afterHide:function(){if(this.get_titleMenu()){this.get_titleMenu().hide();
}this._popupBehavior.hide();
this._popupBehavior.pin(false);
this.cancelAutoCloseDelay();
if(this.get_keepOnMouseOver()){this._resetTimer("_showTimer",this.show,this.get_showInterval());
}this.raiseEvent("hidden");
if(this.get_enableAriaSupport()&&!this.isVisible()){this.get_popupElement().setAttribute("aria-hidden","true");
}},_setPopupVisible:function(f,g){if($telerik.isMobileSafari||$telerik.isSafari||$telerik.isChrome){var e=window.pageYOffset;
var d=window.pageXOffset;
if(document.documentElement.scrollTop==0&&document.body.scrollTop>0){g+=e;
}if(document.documentElement.scrollLeft==0&&document.body.scrollLeft>0){f+=d;
}}this._popupBehavior.set_x(f);
this._popupBehavior.set_y(g);
this._popupBehavior.show();
if(!this.get_width()){this.get_popupElement().style.width="";
}},_addToDocument:function(){var e=this.get_popupElement();
var d=this._getDefaultParent();
d.appendChild(e);
if($telerik.isRightToLeft(d)){Sys.UI.DomElement.addCssClass(e,"rnRtl");
}},_getDefaultParent:function(){var d=this.get_formID();
var e=d?document.getElementById(d):null;
if(!e){if(document.forms&&document.forms.length>0){e=document.forms[0];
}else{e=document.body;
}}return e;
},getBounds:function(){var g=this.get_popupElement();
var h=(g.style.display=="none")?true:false;
if(h){g.style.visibility="hidden";
}g.style.display="";
var e=document.documentElement;
this._popupBehavior.set_parentElement(e);
var f=$telerik.getBounds(g);
var d=this._getBoundsRelativeToBrowser(f);
if(h){g.style.display="none";
g.style.visibility="";
}return d;
},_getBoundsRelativeToBrowser:function(e){var d=this._horizontalPosition;
var i=this._verticalPosition;
var j=0;
var k=0;
var f=$telerik.getClientBounds();
var h=document.compatMode&&document.compatMode!="BackCompat"&&!c.edge;
var g=$telerik.getScrollOffset(h?document.documentElement:document.body);
if("fixed"!=this.get_popupElement().style.position){j+=g.x;
k+=g.y;
}switch(d){case 2:j+=-parseInt(e.width/2-f.width/2,10);
break;
case 1:break;
case 3:default:j+=f.width;
j-=e.width;
break;
}switch(i){case 2:k+=-parseInt((e.height-f.height)/2,10);
break;
case 1:break;
case 3:default:k+=f.height;
k-=e.height;
break;
}j+=this.get_offsetX();
k+=this.get_offsetY();
return new Telerik.Web.UI.Bounds(j,k,e.width,e.height);
},get_popupElement:function(){return this._popupElement;
},get_contentElement:function(){return $get(this.get_id()+"_C");
},get_position:function(){return this._position;
},set_position:function(e){if(this._position!=e){this._position=e;
}var d=this.get_position();
this._horizontalPosition=this._getSide(d,true);
this._verticalPosition=this._getSide(d,false);
},get_visibleTitlebar:function(){return this._visibleTitlebar;
},set_visibleTitlebar:function(d){if(d!=this.get_visibleTitlebar()){this._visibleTitlebar=d;
this._titlebar.style.display=d?"":"none";
if(this.get_enableAriaSupport()){this._titlebar.setAttribute("aria-hidden",!d);
}this.set_height(this.get_height());
var e=this.get_popupElement();
if(d){Sys.UI.DomElement.removeCssClass(e,"rnNoTitleBar");
}else{Sys.UI.DomElement.addCssClass(e,"rnNoTitleBar");
}}},get_width:function(){return this._width;
},set_width:function(g){var f=this.get_popupElement();
var e=parseInt(g,10);
if(isNaN(e)||e<=0){return;
}if(g.toString().indexOf("%")>-1){this._width=g;
f.style.width=g;
e=f.offsetWidth;
}else{this._width=e;
f.style.width=e+"px";
}var d=this.get_contentElement();
if(!d){return;
}e-=$telerik.getPaddingBox(d).horizontal;
d.style.width=(isNaN(e)||e<=0)?"":e+"px";
},get_height:function(){return this._height;
},set_height:function(h){var f=this.get_popupElement();
var e=parseInt(h,10);
if(isNaN(e)||e<=0){return;
}if(h.toString().indexOf("%")>-1){this._height=h;
f.style.height=h;
e=f.offsetHeight;
}else{this._height=e;
f.style.height=e+"px";
}var d=this.get_contentElement();
if(!d){return;
}e-=$telerik.getPaddingBox(d).vertical+$telerik.getBorderBox(f).vertical;
var g=a(this._titlebar).height();
if(this.get_visibleTitlebar()&&this._titlebar&&!isNaN(e)&&e>g){e-=(g!=0?g+2:parseInt($telerik.getCurrentStyle(this._titlebar,"height"),10));
}d.style.height=(isNaN(e)||e<=0)?"":e+"px";
},get_showInterval:function(){return this._showInterval;
},set_showInterval:function(d){if(d!=this.get_showInterval()&&!isNaN(parseInt(d,10))){this._showInterval=d;
this._resetTimer("_showTimer",this.show,d);
}},get_updateInterval:function(){return this._updateInterval;
},set_updateInterval:function(d){if(d!=this.get_updateInterval()&&this.get_loadContentOn()==b.NotificationLoad.TimeInterval&&!isNaN(parseInt(d,10))){this._updateInterval=d;
this._resetTimer("_updateTimer",this.update,this.get_updateInterval());
}},get_loadContentOn:function(){return this._loadContentOn;
},set_loadContentOn:function(d){if(d!=this.get_loadContentOn()){if(this.get_loadContentOn()==b.NotificationLoad.TimeInterval){this._stopTimer("_updateTimer");
}this._loadContentOn=d;
}},_stopTimer:function(d){if(this[d]){clearInterval(this[d]);
this[d]=null;
}},_resetTimer:function(f,d,e){this._stopTimer(f);
if(e!=0){this[f]=setInterval(Function.createDelegate(this,d),e);
}},get_keepOnMouseOver:function(){return this._keepOnMouseOver;
},set_keepOnMouseOver:function(d){if(d!=this.get_keepOnMouseOver()){this._keepOnMouseOver=d;
this._registerMouseKeepHandlers(d);
}},get_enabled:function(){return this._enabled;
},set_enabled:function(d){if(d!=this.get_enabled()){this._enabled=d;
if(!d){this._stopTimer("_showTimer");
this._stopTimer("_updateTimer");
}else{this._resetTimer("_showTimer",this.show,this.get_showInterval());
this._resetTimer("_updateTimer",this.update,this.get_updateInterval());
}}},get_opacity:function(){return this._opacity;
},set_opacity:function(d){if(this.get_opacity()!=d){this._opacity=d>100?100:d;
this._opacity=d<0?0:d;
this._updateOpacity();
}},_updateOpacity:function(){var e=this.get_popupElement();
var d=this.get_opacity();
if(d<100){var f=e.style;
f.filter="alpha(opacity="+d+")";
f.opacity=(d/100);
}else{if($telerik.isIE){e.style.removeAttribute("filter");
e.style.removeAttribute("opacity");
}else{e.style.filter="";
e.style.opacity="";
}}},get_title:function(){return this._title;
},set_title:function(e){if(this._title!=e){this._title=e;
var d=$telerik.getChildByClassName(this._titlebar,"rnTitleBarTitle",1);
if(d){d.innerHTML=e;
}}},get_text:function(){return this._text;
},set_text:function(e){var d=$get(this.get_id()+"_simpleContentDiv");
if(this.get_text()!=e&&d){this._text=e;
d.innerHTML=e;
}},_getSide:function(f,e){var d=e?1:0;
return parseInt((f+"").charAt(d),10);
},_setOverflow:function(){var f=this.get_contentScrolling();
if(f==b.NotificationScrolling.Default){return;
}var d=this.get_contentElement();
if(!d){return;
}var g="";
var e=true;
var h=b.NotificationScrolling;
switch(f){case h.Auto:g="auto";
break;
case h.None:g="hidden";
e=false;
break;
case h.X:g="";
d.style.overflowX="scroll";
d.style.overflowY="hidden";
break;
case h.Y:g="";
d.style.overflowY="scroll";
d.style.overflowX="hidden";
break;
case h.Both:g="scroll";
}if(g!=""){d.style.overflow=g;
}if(e&&b.TouchScrollExtender._getNeedsScrollExtender()&&!this._popupTouchScroll){this._createTouchScrollExtender(true);
}},_createTouchScrollExtender:function(f){var d=this.get_contentElement();
if(d){var e=this._popupTouchScroll;
if(e){if(!f){e.dispose();
this._popupTouchScroll=null;
}}else{if(f){this._popupTouchScroll=new b.TouchScrollExtender(d);
this._popupTouchScroll.initialize();
}}}},_setDocumentOverflow:function(d){if(d){this._documentOverflowX=document.documentElement.style.overflowX;
this._scrollY=document.documentElement.scrollTop;
document.documentElement.style.overflowX="hidden";
}else{if(null!=this._documentOverflowX){document.documentElement.style.overflowX=this._documentOverflowX;
this._documentOverflowX=null;
if(this._scrollY){document.documentElement.scrollTop=this._scrollY;
}this._scrollY=null;
}}},_applyAriaSupport:function(){var d=this.get_popupElement();
d.setAttribute("role","alert");
d.setAttribute("aria-live","polite");
d.setAttribute("aria-atomic","true");
d.setAttribute("aria-hidden","true");
d.setAttribute("aria-relevant","additions text");
if(!this.get_visibleTitlebar()){this._titlebar.setAttribute("aria-hidden","true");
}else{this._titlebar.setAttribute("role","toolbar");
if(this._closeIcon){this._closeIcon.removeAttribute("href");
this._closeIcon.setAttribute("role","button");
}if(this._menuIcon){this._menuIcon.removeAttribute("href");
this._menuIcon.setAttribute("role","button");
}var e=$telerik.getChildByClassName(this._titlebar,"rnTitleBarTitle",1);
if(e){e.setAttribute("id",this.get_id()+"_title");
d.setAttribute("aria-labelledby",e.id);
}var f=$telerik.getChildByClassName(this._titlebar," rnCommands",1);
if(f){f.setAttribute("role","presentation");
}}if(this._xmlPanel){d.setAttribute("aria-describedby",this._xmlPanel.get_id());
}},isVisible:function(){var d=this.get_popupElement();
return(d&&d.style.display!="none");
},setSize:function(e,d){this.set_width(e);
this.set_height(d);
},_resetAutoCloseDelay:function(){this.cancelAutoCloseDelay();
if(this.get_autoCloseDelay()!=0){this._autoCloseRef=window.setTimeout(Function.createDelegate(this,function(){this.hide();
}),this.get_autoCloseDelay());
}},cancelAutoCloseDelay:function(){if(this._autoCloseRef){window.clearTimeout(this._autoCloseRef);
this._autoCloseRef=0;
}},get_titleMenu:function(){return this._titleMenu;
},get_zIndex:function(){return this._zIndex;
},get_rippleZonesConfiguration:function(){return[{element:this._titlebar,initializeRipples:true,rippleConfigurations:[{containerSelector:".rnCloseIcon > a",rippleType:b.MaterialRippleType.Icon,iconRippleSizeFactor:0.54}]}];
},set_zIndex:function(e){var f=parseInt(e,10);
if(isNaN(f)){return;
}if(this._zIndex!=e){this._zIndex=f;
this.get_popupElement().style.zIndex=f;
var d=this.get_titleMenu();
if(d){d._getContextMenuElement().style.zIndex=d._originalZIndex=d._defaultZIndex=f+100;
}}}};
a.registerControlProperties(b.RadNotification,{animation:b.NotificationAnimation.None,animationDuration:500,formID:null,offsetX:0,offsetY:0,pinned:true,overlay:false,contentScrolling:b.NotificationScrolling.Default,value:"",autoCloseDelay:3000,visibleOnPageLoad:false,showCloseButton:true,showTitleMenu:false,enableAriaSupport:false});
a.registerControlEvents(b.RadNotification,["hidden","hiding","shown","showing","updated","updateError","updating"]);
Telerik.Web.UI.RadNotification.registerClass("Telerik.Web.UI.RadNotification",b.RadWebControl);
})($telerik.$,Telerik.Web.UI);
if(typeof(Sys)!=='undefined')Sys.Application.notifyScriptLoaded();