Type.registerNamespace("Telerik.Web.UI");
(function(a){a.PivotGridField=function(b){a.PivotGridField.initializeBase(this,[b]);
this._owner=null;
this._uniqueName=null;
this._zoneIndex=null;
this._aggregate=null;
this._isHidden=null;
this._zoneType=null;
this._previousField=null;
this._nextField=null;
};
a.PivotGridField.prototype={initialize:function(){a.PivotGridField.callBaseMethod(this,"initialize");
},dispose:function(){a.PivotGridField.callBaseMethod(this,"dispose");
},get_owner:function(){return this._owner;
},set__owner:function(b){this._owner=b;
},get_uniqueName:function(){return this._uniqueName;
},get_zoneIndex:function(){return this._zoneIndex;
},get_zoneType:function(){return this._zoneType;
},get_aggregate:function(){return this._aggregate;
},get_isHidden:function(){return this._isHidden;
},get_previousField:function(){return this._getNextField(-1);
},get_nextField:function(){return this._getNextField(1);
},show:function(){if(!this._isHidden){return;
}this._owner.fireCommand("ShowHideField",this.get_uniqueName()+" Show");
},hide:function(){if(this._isHidden){return;
}this._owner.fireCommand("ShowHideField",this.get_uniqueName()+" Hide");
},tryReorder:function(e,d){if(!this._canReorder(e,d,true)){return false;
}var c="FieldReorder";
var b=String.format("{0};{1};{2}",this.get_uniqueName(),e,d);
return this.get_owner().fireCommand(c,b);
},_canReorder:function(e,d,c){var b=this.get_zoneIndex();
if(e==this.get_zoneType()&&!this.get_isHidden()&&(d==b||(!c&&b<=d&&this.get_previousField()!=null&&this.get_previousField().get_zoneIndex()==d))){return false;
}return true;
},_getNextField:function(b){var g=this;
if(g._isHidden){return null;
}var c=g._element;
var f=c.parentNode.className;
var e=false;
if(f&&f=="rpgRowsZone"){e=true;
}var d=null;
while(!d){if(e){c=c.parentNode;
}if(b>0){c=c.nextSibling;
}else{c=c.previousSibling;
}if(!c){break;
}if(e){c=$telerik.getChildByClassName(c,"rpgFieldItem");
if(!c){break;
}}if(c.style&&c.style.display==""){d=$find(c.id);
if(!a.PivotGridField.isInstanceOfType(d)){d=null;
}}}return d;
}};
a.PivotGridField.registerClass("Telerik.Web.UI.PivotGridField",Sys.UI.Control);
})(Telerik.Web.UI);
Type.registerNamespace("Telerik.Web.UI");
(function(a,b){a.PivotGridFiltering=function(){a.PivotGridFiltering.initializeBase(this);
this._owner={};
this._clientData={};
this._filterWindow=null;
this._filterWindowID;
this._filterDialog=null;
this._filterDialogID=null;
this._filterSetBox=null;
this._setOptionsIncludes=null;
this._setOptionsExcludes=null;
this._filterMenu=null;
this._filterDialogOKButton=null;
this._filterDialogCancelButton=null;
this._filterWindowOKButton=null;
this._sortedListSelectionCombo=null;
this._sortedListFilterValueBox=null;
this._sortedListAggregateOperatorCombo=null;
this._byLabel=null;
this._andLabel=null;
this._aggregatesCombo=null;
this._aggregateOperatorsCombo=null;
this._value1TextBox=null;
this._value2TextBox=null;
this._setBoxItemCheckDelegate=null;
this._filterMenuItemClickDelegate=null;
this._filterFunctionInProgress=null;
this._filterDialogOKButtonClickDelegate=null;
this._filterDialogCancelButtonClickDelegate=null;
this._filterWindowOKButtonClickDelegate=null;
this._filterWindowCancelButtonClickDelegate=null;
this._filterDialogDragStartDelegate=null;
this._filterDialogCloseDelegate=null;
this._setOptionsIncludesClickDelegate=null;
this._setOptionsExcludesClickDelegate=null;
this._operatorsComboItemSelectedDelegate=null;
};
a.PivotGridFiltering.prototype={initialize:function(){a.PivotGridFiltering.callBaseMethod(this,"initialize");
this._setBoxItemCheckDelegate=Function.createDelegate(this,this._setBoxItemCheck);
this.get_filterSetBox().add_itemChecked(this._setBoxItemCheckDelegate);
if(!this._clientData.isReportFilter){this._filterMenuItemClickDelegate=Function.createDelegate(this,this._filterMenuItemClick);
this.get_filterMenu().add_itemClicked(this._filterMenuItemClickDelegate);
this._filterDialogOKButtonClickDelegate=Function.createDelegate(this,this._filterDialogOKButtonClick);
window.$addHandler(this.get_filterDialogOKButton(),"click",this._filterDialogOKButtonClickDelegate);
this._filterDialogDragStartDelegate=Function.createDelegate(this,this._filterDialogDragStart);
this.get_filterDialog().add_dragStart(this._filterDialogDragStartDelegate);
this._filterDialogCloseDelegate=Function.createDelegate(this,this._filterDialogClose);
this.get_filterDialog().add_close(this._filterDialogCloseDelegate);
this._filterDialogCancelButtonClickDelegate=Function.createDelegate(this,this._filterDialogCancelButtonClick);
window.$addHandler(this.get_filterDialogCancelButton(),"click",this._filterDialogCancelButtonClickDelegate);
this._operatorsComboItemSelectedDelegate=Function.createDelegate(this,this._operatorsComboItemSelected);
this.get_aggregateOperatorsCombo().add_selectedIndexChanged(this._operatorsComboItemSelectedDelegate);
}this._filterWindowOKButtonClickDelegate=Function.createDelegate(this,this._filterWindowOKButtonClick);
window.$addHandler(this.get_filterWindowOKButton(),"click",this._filterWindowOKButtonClickDelegate);
this._filterWindowCancelButtonClickDelegate=Function.createDelegate(this,this._filterWindowCancelButtonClick);
window.$addHandler(this.get_filterWindowCancelButton(),"click",this._filterWindowCancelButtonClickDelegate);
this._setOptionsIncludesClickDelegate=Function.createDelegate(this,this._setOptionsIncludesClick);
window.$addHandler(this.get_setOptionsIncludes(),"click",this._setOptionsIncludesClickDelegate);
this._setOptionsExcludesClickDelegate=Function.createDelegate(this,this._setOptionsExcludesClick);
window.$addHandler(this.get_setOptionsExcludes(),"click",this._setOptionsExcludesClickDelegate);
},dispose:function(){if(this._setBoxItemCheckDelegate){this.get_filterSetBox().remove_itemChecked(this._setBoxItemCheckDelegate);
this._setBoxItemCheckDelegate=null;
}if(this._filterMenuItemClickDelegate){this.get_filterMenu().remove_itemClicked(this._filterMenuItemClickDelegate);
this._filterMenuItemClickDelegate=null;
}if(this._filterDialogOKButtonClickDelegate){window.$removeHandler(this.get_filterDialogOKButton(),"click",this._filterDialogOKButtonClickDelegate);
this._filterDialogOKButtonClickDelegate=null;
}if(this._filterDialogCancelButtonClickDelegate){window.$removeHandler(this.get_filterDialogCancelButton(),"click",this._filterDialogCancelButtonClickDelegate);
this._filterDialogCancelButtonClickDelegate=null;
}if(this._operatorsComboItemSelectedDelegate){this.get_aggregateOperatorsCombo().remove_selectedIndexChanged(this._operatorsComboItemSelectedDelegate);
this._operatorsComboItemSelectedDelegate=null;
}if(this._filterWindowOKButtonClickDelegate){window.$removeHandler(this.get_filterWindowOKButton(),"click",this._filterWindowOKButtonClickDelegate);
this._filterWindowOKButtonClickDelegate=null;
}if(this._filterWindowCancelButtonClickDelegate){window.$removeHandler(this.get_filterWindowCancelButton(),"click",this._filterWindowCancelButtonClickDelegate);
this._filterWindowCancelButtonClickDelegate=null;
}if(this._setOptionsIncludesClickDelegate){window.$removeHandler(this.get_setOptionsIncludes(),"click",this._setOptionsIncludesClickDelegate);
this._setOptionsIncludesClickDelegate=null;
}if(this._setOptionsExcludesClickDelegate){window.$removeHandler(this.get_setOptionsExcludes(),"click",this._setOptionsExcludesClickDelegate);
this._setOptionsExcludesClickDelegate=null;
}if(this._filterDialogDragStartDelegate){this.get_filterDialog().remove_dragStart(this._filterDialogDragStartDelegate);
this._filterDialogDragStartDelegate=null;
}if(this._filterDialogCloseDelegate){this.get_filterDialog().remove_close(this._filterDialogCloseDelegate);
this._filterDialogCloseDelegate=null;
}},_scrollZoneContainerToField:function(c,d){d.scrollTop(d.scrollTop()-d.offset().top+c.offset().top);
},_getPanelFieldBounds:function(g){var h=this;
var c=$telerik.$;
var f=h._clientData;
var e=f.isInAllFieldsZone?c(g.get_element()).find(".rpgAllFieldsContainer .rpgFieldsContainer"):c(g._getFieldsContainerByZoneType(f.zoneType));
var d=e.find("[title='"+f.fieldUniqueName+"'].rpgFieldItem");
if(d&&d.length>0){h._scrollZoneContainerToField(d,e);
return a.PivotGrid.GetBounds(d.get(0));
}return new a.Bounds(0,0,0,0);
},_getAutohideFieldBounds:function(){var d;
var c=this._owner;
switch(this._clientData.zoneType){case a.PivotGridFieldZoneType.Row:d=c.get_rowZone();
break;
case a.PivotGridFieldZoneType.Aggregate:d=c.get_aggregateZone();
break;
case a.PivotGridFieldZoneType.Column:d=c.get_columnZone();
break;
case a.PivotGridFieldZoneType.Filter:d=c.get_filterZone();
break;
default:return new a.Bounds(0,0,0,0);
}return a.PivotGrid.GetBounds(d);
},displayWindowOverField:function(){var j=this;
var e=j._owner._getField(j._clientData.fieldUniqueName).get_element();
var c=j._clientData;
var d=j._owner.get_configurationPanel();
var f=a.PivotGrid.GetBounds(e);
var g=f.x+f.y+f.width+f.height;
if(!e.parentNode||(d&&!d.get_element().contains(e))){f=j._getPanelFieldBounds(d);
}else{if(g===0&&c.zoneType){f=j._getAutohideFieldBounds();
}}var h=a.PivotGrid.GetBounds(j._owner.get_element());
this.get_filterWindow().show();
this.get_filterWindow().setActive(true);
var i=j._owner.get_element().style.position;
if(i=="relative"||i=="absolute"){j.get_filterWindow().moveTo(f.x-h.x,f.y-h.y+f.height);
}else{j.get_filterWindow().moveTo(f.x,f.y+f.height);
}if(j._owner._materialRippleManager){j._owner._materialRippleManager.initializeRippleZone({element:j.get_filterWindow().get_contentElement(),rippleConfigurations:[{containerSelector:".rpgFilterWindowContainer button.rpgFilterButtonOk, .rpgFilterWindowContainer button.rpgFilterButtonCancel"}]});
}},displayWindowOverFieldNoPostBack:function(c){var d;
c=c?c:window.event;
c.returnValue=false;
c.cancelBubble=true;
if(c.preventDefault){c.preventDefault();
c.stopPropagation();
}d=c.target||c.srcElement;
this._clientData.isInAllFieldsZone=d.parentNode.id.endsWith("_Hidden");
this.displayWindowOverField();
return false;
},_filterMenuItemClick:function(g,c){var e=c.get_item().get_value();
if(e=="ClearFiltersFrom"){this.get_filterWindow().close();
this.get_aggregateOperatorsCombo().get_items().getItem(0).select();
this._owner.fireCommand("Filter",a.PivotGridFilterCommandType.ClearFilters+"|?"+this._clientData.fieldUniqueName);
}else{if(c.get_item().get_parent()!=b&&c.get_item().get_parent().get_value!=b){var f=c.get_item().get_parent().get_value();
var d=e*1;
if(d==a.PivotGridFilterFunction.ClearFilters){this.get_filterWindow().close();
this.get_aggregateOperatorsCombo().get_items().getItem(0).select();
this._owner.fireCommand("Filter",a.PivotGridFilterCommandType.ClearFilters+"|?"+this._clientData.fieldUniqueName);
}else{if(f=="LabelFilters"){this.get_filterDialog()._getDefaultParent=Function.createDelegate(this,function(){return this._owner.get_element();
});
this.get_filterDialog().set_title(this._clientData.labelFilterString+" ("+this._clientData.fieldUniqueName+")");
if(d==a.PivotGridFilterFunction.IsBetween||d==a.PivotGridFilterFunction.IsNotBetween){this._showRangeLabelFilterDialog(d);
}else{this._showSimpleLabelFilterDialog(d);
}}else{if(f=="ValueFilters"){this.get_filterDialog()._getDefaultParent=Function.createDelegate(this,function(){return this._owner.get_element();
});
this.get_filterDialog().set_title(this._clientData.valueFilterString+" ("+this._clientData.fieldUniqueName+")");
if(d==a.PivotGridFilterFunction.IsBetween||d==a.PivotGridFilterFunction.IsNotBetween){this._showRangeValueFilterDialog(d);
}else{if(d==a.PivotGridFilterFunction.Top){this._showTopValueFilterDialog(d);
}else{this._showSimpleValueFilterDialog(d);
}}}}}if(this._owner._materialRippleManager){this._owner._materialRippleManager.initializeRippleZone({element:this.get_filterDialog().get_contentElement(),rippleConfigurations:[{containerSelector:".rpgFilterWindowContainer button.rpgFilterButtonOk, .rpgFilterWindowContainer button.rpgFilterButtonCancel"}]});
}}}},_operatorsComboItemSelected:function(e,c){var d=c.get_item().get_value();
if(d<13){this.get_andLabel().style.display="none";
this.get_value2TextBox().style.display="none";
}else{if(d==13||d==14){this.get_andLabel().style.display="";
this.get_value2TextBox().style.display="";
}}},_filterDialogClose:function(c){this.get_sortedListSelectionCombo().hideDropDown();
this.get_aggregateOperatorsCombo().hideDropDown();
this.get_aggregatesCombo().hideDropDown();
this.get_sortedListAggregateOperatorCombo().hideDropDown();
},_filterDialogDragStart:function(c){this.get_sortedListSelectionCombo().hideDropDown();
this.get_aggregateOperatorsCombo().hideDropDown();
this.get_aggregatesCombo().hideDropDown();
this.get_sortedListAggregateOperatorCombo().hideDropDown();
},_filterDialogCancelButtonClick:function(c){this.get_filterDialog().close();
this.get_value1TextBox().value=this.get_value1TextBox().defaultValue;
this.get_value2TextBox().value=this.get_value2TextBox().defaultValue;
this.get_ignoreCaseCheckBox().checked=this.get_ignoreCaseCheckBox().defaultChecked;
$telerik.cancelRawEvent();
return false;
},_filterDialogOKButtonClick:function(c){c=c?c:window.event;
this.get_filterDialog().close();
c.rawEvent.returnValue=false;
c.rawEvent.cancelBubble=true;
if(c.preventDefault){c.preventDefault();
c.stopPropagation();
}this._owner.fireCommand("Filter",this._filterFunctionInProgress+"|?"+this._clientData.fieldUniqueName);
return false;
},_filterWindowOKButtonClick:function(c){this._closeFilterWindowCancel(c);
this._owner.fireCommand("Filter",a.PivotGridFilterCommandType.Set+"|?"+this._clientData.fieldUniqueName);
return false;
},_filterWindowCancelButtonClick:function(c){this._closeFilterWindowCancel(c);
},_closeFilterWindowCancel:function(c){var f=this.get_filterWindow();
var d=c?c:window.event;
d.rawEvent.returnValue=false;
d.rawEvent.cancelBubble=true;
if(d.preventDefault){d.preventDefault();
d.stopPropagation();
}f.close();
return false;
},_setOptionsIncludesClick:function(d){var c=this.get_filterSetBox().get_checkedItems().length;
this.get_filterWindowOKButton().disabled=(c==0);
},_setOptionsExcludesClick:function(d){var c=this.get_filterSetBox().get_checkedItems().length;
var f=this.get_filterSetBox().get_items().get_count();
if(c==f){this.get_filterWindowOKButton().disabled=true;
}else{this.get_filterWindowOKButton().disabled=false;
}},_setBoxItemCheck:function(i,c){var g=this.get_setOptionsIncludes().checked;
if(c.get_item().get_value()=="SelectAll"){if(c.get_item().get_checked()){i.checkItems(i.get_items());
if(!g){this.get_filterWindowOKButton().disabled=true;
}else{this.get_filterWindowOKButton().disabled=false;
}}else{i.uncheckItems(i.get_items());
if(!g){this.get_filterWindowOKButton().disabled=false;
}else{this.get_filterWindowOKButton().disabled=true;
}}}else{var h=i.get_items().getItem(0).get_checked();
var d=i.get_checkedItems().length;
var f=i.get_items().get_count()-1;
var e=h?d-1:d;
if(e==f){if(!i.get_items().getItem(0).get_checked()){i.get_items().getItem(0).check();
}if(!g){this.get_filterWindowOKButton().disabled=true;
}else{this.get_filterWindowOKButton().disabled=false;
}}else{i.get_items().getItem(0).uncheck();
if(d==0){if(!g){this.get_filterWindowOKButton().disabled=false;
}else{this.get_filterWindowOKButton().disabled=true;
}}else{this.get_filterWindowOKButton().disabled=false;
}}}},_showSimpleLabelFilterDialog:function(c){this._filterFunctionInProgress=a.PivotGridFilterCommandType.Label;
this.get_filterDialog().show();
this.get_sortedListSelectionCombo().set_visible(false);
this.get_sortedListFilterValueBox().set_visible(false);
this.get_sortedListAggregateOperatorCombo().set_visible(false);
this.get_byLabel().style.display="none";
this.get_aggregatesCombo().set_visible(false);
this.get_aggregateOperatorsCombo().set_visible(true);
this.get_aggregateOperatorsCombo().get_items().getItem(c).select();
this.get_value1TextBox().style.display="";
this.get_andLabel().style.display="none";
this.get_value2TextBox().style.display="none";
this._showLabelFilterOperators();
},_showRangeLabelFilterDialog:function(c){this._filterFunctionInProgress=a.PivotGridFilterCommandType.Label;
this.get_filterDialog().show();
this.get_sortedListSelectionCombo().set_visible(false);
this.get_sortedListFilterValueBox().set_visible(false);
this.get_sortedListAggregateOperatorCombo().set_visible(false);
this.get_byLabel().style.display="none";
this.get_aggregatesCombo().set_visible(false);
this.get_aggregateOperatorsCombo().set_visible(true);
this.get_aggregateOperatorsCombo().get_items().getItem(c).select();
this.get_value1TextBox().style.display="";
this.get_andLabel().style.display="";
this.get_value2TextBox().style.display="";
this._showLabelFilterOperators();
},_showSimpleValueFilterDialog:function(c){this._filterFunctionInProgress=a.PivotGridFilterCommandType.Value;
this.get_filterDialog().show();
this.get_sortedListSelectionCombo().set_visible(false);
this.get_sortedListFilterValueBox().set_visible(false);
this.get_sortedListAggregateOperatorCombo().set_visible(false);
this.get_byLabel().style.display="none";
this.get_aggregatesCombo().set_visible(true);
this.get_aggregateOperatorsCombo().set_visible(true);
this.get_aggregateOperatorsCombo().get_items().getItem(c).select();
this.get_value1TextBox().style.display="";
this.get_andLabel().style.display="none";
this.get_value2TextBox().style.display="none";
this._showValueFilterOperators();
},_showRangeValueFilterDialog:function(c){this._filterFunctionInProgress=a.PivotGridFilterCommandType.Value;
this.get_filterDialog().show();
this.get_sortedListSelectionCombo().set_visible(false);
this.get_sortedListFilterValueBox().set_visible(false);
this.get_sortedListAggregateOperatorCombo().set_visible(false);
this.get_byLabel().style.display="none";
this.get_aggregatesCombo().set_visible(true);
this.get_aggregateOperatorsCombo().set_visible(true);
this.get_aggregateOperatorsCombo().get_items().getItem(c).select();
this.get_value1TextBox().style.display="";
this.get_andLabel().style.display="";
this.get_value2TextBox().style.display="";
this._showValueFilterOperators();
},_showTopValueFilterDialog:function(c){this._filterFunctionInProgress=a.PivotGridFilterCommandType.Top;
this.get_filterDialog().show();
this.get_sortedListSelectionCombo().set_visible(true);
this.get_sortedListFilterValueBox().set_visible(true);
this.get_sortedListAggregateOperatorCombo().set_visible(true);
this.get_byLabel().style.display="";
this.get_aggregatesCombo().set_visible(true);
this.get_aggregateOperatorsCombo().set_visible(false);
this.get_aggregateOperatorsCombo().get_items().getItem(c).select();
this.get_value1TextBox().style.display="none";
this.get_andLabel().style.display="none";
this.get_value2TextBox().style.display="none";
},_showValueFilterOperators:function(){var d=this.get_aggregateOperatorsCombo();
d.get_items().getItem(0).hide();
d.get_items().getItem(1).show();
d.get_items().getItem(2).show();
var c;
for(c=3;
c<9;
c++){d.get_items().getItem(c).hide();
}for(c=9;
c<15;
c++){d.get_items().getItem(c).show();
}for(c=15;
c<19;
c++){d.get_items().getItem(c).hide();
}},_showLabelFilterOperators:function(){var d=this.get_aggregateOperatorsCombo();
d.get_items().getItem(0).hide();
var c;
for(c=1;
c<15;
c++){d.get_items().getItem(c).show();
}for(c=15;
c<19;
c++){d.get_items().getItem(c).hide();
}},get_filterSetBox:function(){if(this._filterSetBox==b){this._filterSetBox=$find(String.format("{0}_{1}",this.get_filterWindow().get_id(),"C_rlbFilterSet"));
}return this._filterSetBox;
},get_setOptionsIncludes:function(){if(this._setOptionsIncludes==b){this._setOptionsIncludes=$get(String.format("{0}_{1}",this.get_filterWindow().get_id(),"C_rblIncludes_0"));
}return this._setOptionsIncludes;
},get_setOptionsExcludes:function(){if(this._setOptionsExcludes==b){this._setOptionsExcludes=$get(String.format("{0}_{1}",this.get_filterWindow().get_id(),"C_rblIncludes_1"));
}return this._setOptionsExcludes;
},get_filterMenu:function(){if(this._filterMenu==b){this._filterMenu=$find(String.format("{0}_{1}",this.get_filterWindow().get_id(),"C_FilterMenu"));
}return this._filterMenu;
},get_filterWindow:function(){if(this._filterWindow==null){this._filterWindow=$find(this._filterWindowID);
}return this._filterWindow;
},set_filterWindow:function(c){this._filterWindow=c;
},get_filterDialog:function(){if(this._filterDialog==null){this._filterDialog=$find(this.get_filterDialogID());
}return this._filterDialog;
},get_sortedListSelectionCombo:function(){if(this._sortedListSelectionCombo==b){this._sortedListSelectionCombo=$find(this.get_filterDialog().get_id()+"_C_rcmbSortedListSelection");
}return this._sortedListSelectionCombo;
},get_sortedListFilterValueBox:function(){if(this._sortedListFilterValueBox==b){this._sortedListFilterValueBox=$find(this.get_filterDialog().get_id()+"_C_rntbslFilterValueBox");
}return this._sortedListFilterValueBox;
},get_sortedListAggregateOperatorCombo:function(){if(this._sortedListAggregateOperatorCombo==b){this._sortedListAggregateOperatorCombo=$find(this.get_filterDialog().get_id()+"_C_rcmbslAggregateOperator");
}return this._sortedListAggregateOperatorCombo;
},get_byLabel:function(){if(this._byLabel==b){this._byLabel=$get(this.get_filterDialog().get_id()+"_C_lblBy");
}return this._byLabel;
},get_aggregatesCombo:function(){if(this._aggregatesCombo==b){this._aggregatesCombo=$find(this.get_filterDialog().get_id()+"_C_rcmbAggregates");
}return this._aggregatesCombo;
},get_aggregateOperatorsCombo:function(){if(this._aggregateOperatorsCombo==b){this._aggregateOperatorsCombo=$find(this.get_filterDialog().get_id()+"_C_rcmbOperators");
}return this._aggregateOperatorsCombo;
},get_value1TextBox:function(){if(this._value1TextBox==b){this._value1TextBox=$get(this.get_filterDialog().get_id()+"_C_rtbValue1");
}return this._value1TextBox;
},get_value2TextBox:function(){if(this._value2TextBox==b){this._value2TextBox=$get(this.get_filterDialog().get_id()+"_C_rtbValue2");
}return this._value2TextBox;
},get_ignoreCaseCheckBox:function(){if(this._ignoreCaseCheckBox==b){this._ignoreCaseCheckBox=$get(this.get_filterDialog().get_id()+"_C_cbIgnoreCase");
}return this._ignoreCaseCheckBox;
},get_filterDialogOKButton:function(){if(this._filterDialogOKButton==b){this._filterDialogOKButton=$get(this.get_filterDialog().get_id()+"_C_btnOK");
}return this._filterDialogOKButton;
},get_filterDialogCancelButton:function(){if(this._filterDialogCancelButton==b){this._filterDialogCancelButton=$get(this.get_filterDialog().get_id()+"_C_btnCancel");
}return this._filterDialogCancelButton;
},get_filterWindowOKButton:function(){if(this._filterWindowOKButton==b){this._filterWindowOKButton=$get(this.get_filterWindow().get_id()+"_C_btnOK");
}return this._filterWindowOKButton;
},get_filterWindowCancelButton:function(){if(this._filterWindowCancelButton==b){this._filterWindowCancelButton=$get(this.get_filterWindow().get_id()+"_C_btnCancel");
}return this._filterWindowCancelButton;
},get_andLabel:function(){if(this._andLabel==b){this._andLabel=$get(this.get_filterDialog().get_id()+"_C_lblAnd");
}return this._andLabel;
},get_filterWindowID:function(){return this._filterWindowID;
},set_filterWindowID:function(c){this._filterWindowID=c;
},get_filterDialogID:function(){return this._filterDialogID;
},set_filterDialogID:function(c){this._filterDialogID=c;
}};
a.PivotGridFiltering.registerClass("Telerik.Web.UI.PivotGridFiltering",Sys.Component);
a.PivotGridFilterCommandType=function(){};
a.PivotGridFilterCommandType.prototype={Set:0,Label:1,Value:2,Top:3,ClearFilters:4};
a.PivotGridFilterCommandType.registerEnum("Telerik.Web.UI.PivotGridFilterCommandType",false);
a.PivotGridFilterFunction=function(){};
a.PivotGridFilterFunction.prototype={ClearFilters:0,Equals:1,DoesNotEqual:2,BeginsWith:3,DoesNotBeginWith:4,EndsWith:5,DoesNotEndWith:6,Contains:7,DoesNotContain:8,IsGreaterThan:9,IsGreaterThanOrEqualTo:10,IsLessThan:11,IsLessThanOrEqualTo:12,IsBetween:13,IsNotBetween:14,Top:15,Bottom:16,Includes:17,DoesNotInclude:18};
a.PivotGridFilterFunction.registerEnum("Telerik.Web.UI.PivotGridFilterFunction",false);
})(Telerik.Web.UI);
Type.registerNamespace("Telerik.Web.UI");
Type.registerNamespace("Telerik.Web.UI.PivotGrid");
(function(a,b){a.PivotGrid.GetScrollBarWidth=function(){try{if(typeof(this.scrollbarWidth)=="undefined"){var g,c=0;
var d=document.createElement("div");
d.style.position="absolute";
d.style.top="-1000px";
d.style.left="-1000px";
d.style.width="100px";
d.style.height="100px";
d.style.overflow="auto";
var e=document.createElement("div");
e.style.width="1000px";
e.style.height="1000px";
d.appendChild(e);
document.body.appendChild(d);
g=d.offsetWidth;
c=d.clientWidth;
document.body.removeChild(document.body.lastChild);
this.scrollbarWidth=g-c;
if(this.scrollbarWidth<=0||c==0){this.scrollbarWidth=16;
}d=null;
e=null;
}return this.scrollbarWidth;
}catch(f){return false;
}};
a.PivotGrid.GetCurrentElement=function(d){if(!d){d=window.event;
}var c;
if(d.srcElement){c=d.srcElement;
}else{c=d.target;
}return c;
};
a.PivotGrid.GetTouchCurrentElement=function(d){var c=null;
if($telerik.isTouchDevice){c=$telerik.getTouchTarget(d);
}else{c=a.PivotGrid.GetCurrentElement(d);
}return c;
};
a.PivotGrid.FindPosX=function(c){return a.PivotGrid.GetLocation(c).x;
};
a.PivotGrid.FindPosY=function(c){return a.PivotGrid.GetLocation(c).y;
};
a.PivotGrid.GetLocation=function(c){if($telerik.isOpera){return $telerik.originalGetLocation(c);
}return $telerik.getLocation(c);
};
a.PivotGrid.ClearDocumentEvents=function(){if(document.onmousedown!=this.mouseDownHandler){this.documentOnMouseDown=document.onmousedown;
}if(document.onselectstart!=this.selectStartHandler){this.documentOnSelectStart=document.onselectstart;
}if(document.ondragstart!=this.dragStartHandler){this.documentOnDragStart=document.ondragstart;
}this.mouseDownHandler=function(c){return false;
};
this.selectStartHandler=function(){return false;
};
this.dragStartHandler=function(){return false;
};
document.onmousedown=this.mouseDownHandler;
document.onselectstart=this.selectStartHandler;
document.ondragstart=this.dragStartHandler;
};
a.PivotGrid.RestoreDocumentEvents=function(){if((typeof(this.documentOnMouseDown)=="function")&&(document.onmousedown!=this.mouseDownHandler)){document.onmousedown=this.documentOnMouseDown;
}else{document.onmousedown="";
}if((typeof(this.documentOnSelectStart)=="function")&&(document.onselectstart!=this.selectStartHandler)){document.onselectstart=this.documentOnSelectStart;
}else{document.onselectstart="";
}if((typeof(this.documentOnDragStart)=="function")&&(document.ondragstart!=this.dragStartHandler)){document.ondragstart=this.documentOnDragStart;
}else{document.ondragstart="";
}};
a.PivotGrid.IsDomElement=function(c){var d=typeof HTMLElement==="object";
if(d){return c instanceof HTMLElement;
}else{return c&&typeof c==="object"&&c.nodeType===1&&typeof c.nodeName==="string";
}return false;
};
a.PivotGrid.GetZoneType=function(d){if(!d){return -1;
}var c=d.className;
if(!c){if(d.id&&d.id.endsWith("_DropFieldHereCell")){return a.PivotGridFieldZoneType.Row;
}return -1;
}if(c.indexOf("rpgFilterZone")!=-1){return a.PivotGridFieldZoneType.Filter;
}else{if(c.indexOf("rpgDataZone")!=-1){return a.PivotGridFieldZoneType.Aggregate;
}else{if(c.indexOf("rpgColumnsZone")!=-1){return a.PivotGridFieldZoneType.Column;
}else{if(c.indexOf("rpgRowsZone")!=-1){return a.PivotGridFieldZoneType.Row;
}else{if(d.id&&d.id.endsWith("_DropFieldHereCell")){return a.PivotGridFieldZoneType.Row;
}}}}}return -1;
};
a.PivotGrid.BuildEventArgs=function(c,d){for(var f in d){var e=f;
var g=d[f];
if(e.indexOf("et_")>0){c[e]=g;
continue;
}c["_"+e]=g;
c["get_"+e]=(function(h){return function(){return this["_"+h];
};
}(e));
}return c;
};
a.PivotGrid.GetBounds=function(c){var d=!$telerik.isTouchDevice?$telerik.getLocation(c):$telerik.originalGetLocation(c);
return new Telerik.Web.UI.Bounds(d.x,d.y,c.offsetWidth||0,c.offsetHeight||0);
};
a.PivotGrid.OnWindowShow=function(d,c){setTimeout(function(){d.setSize(d.get_width(),d.get_height());
},100);
};
})(Telerik.Web.UI);
Type.registerNamespace("Telerik.Web.UI");
(function(a,b){a.PivotGridScrolling=function(){a.PivotGridScrolling.initializeBase(this);
this._owner={};
this._scrolling=null;
this._onHorizontalScrollDelegate=null;
this._onVerticalScrollDelegate=null;
this._verticalScrollDiv=null;
this._horizontalScrollDiv=null;
this._scrolled=false;
this._onColumnHeaderScrollDelegate=null;
this._onRowHeaderScrollDelegate=null;
};
a.PivotGridScrolling.prototype={initialize:function(){a.PivotGridScrolling.callBaseMethod(this,"initialize");
if(this._owner._clientSettings&&this._owner._clientSettings._scrolling){this._scrolling=this._owner._clientSettings._scrolling;
this._initializeScrolls();
}},dispose:function(){if(this._onHorizontalScrollDelegate){if(this._horizontalScrollDiv){window.$removeHandler(this._horizontalScrollDiv,"scroll",this._onHorizontalScrollDelegate);
}var d=this._owner.get_dataTable();
if($telerik.isTouchDevice&&d&&this._owner.get_dataDiv()){window.$removeHandler(this._owner.get_dataDiv(),"scroll",this._onHorizontalScrollDelegate);
}this._onHorizontalScrollDelegate=null;
}if(this._onVerticalScrollDelegate){if(this._verticalScrollDiv){window.$removeHandler(this._verticalScrollDiv,"scroll",this._onVerticalScrollDelegate);
if($telerik.isFirefox){window.$removeHandler(this._owner.get_dataDiv(),"DOMMouseScroll",this._onVerticalScrollWithMiddleButtonDelegate);
window.$removeHandler(this._owner.get_rowHeaderDiv(),"DOMMouseScroll",this._onVerticalScrollWithMiddleButtonDelegate);
}else{window.$removeHandler(this._owner.get_dataDiv(),"mousewheel",this._onVerticalScrollWithMiddleButtonDelegate);
window.$removeHandler(this._owner.get_rowHeaderDiv(),"mousewheel",this._onVerticalScrollWithMiddleButtonDelegate);
}}this._onVerticalScrollDelegate=null;
this._onVerticalScrollWithMiddleButtonDelegate=null;
}if($telerik.isTouchDevice){if(this._onColumnHeaderScrollDelegate){var c=this._owner.get_columnHeaderTable();
if(c&&this._owner.get_columnHeaderDiv()){window.$removeHandler(this._owner.get_columnHeaderDiv(),"scroll",this._onColumnHeaderScrollDelegate);
}this._onColumnHeaderScrollDelegate=null;
}if(this._onRowHeaderScrollDelegate){var e=this._owner.get_rowHeaderTable();
if(e&&this._owner.get_rowHeaderDiv()){window.$removeHandler(this._owner.get_rowHeaderDiv(),"scroll",this._onRowHeaderScrollDelegate);
}this._onRowHeaderScrollDelegate=null;
}}},set_owner:function(c){this._owner=c;
},get_owner:function(){return this._owner;
},_initializeScrolls:function(){this._initializeHorizontalScroll();
var c=this._scrolling._allowVerticalScroll;
if(c){this._intializeVerticalScroll();
}var e=this;
var d=function(){e.initializeSaveScrollPosition();
};
window.setTimeout(d,0);
},_initializeHorizontalScroll:function(){this._horizontalScrollDiv=this._owner.get_hzScrollDiv();
if(this._horizontalScrollDiv){this._onHorizontalScrollDelegate=Function.createDelegate(this,this._onHorizontalScroll);
window.$addHandlers(this._horizontalScrollDiv,{scroll:this._onHorizontalScrollDelegate});
if($telerik.isTouchDevice){window.$addHandlers(this._owner.get_dataDiv(),{scroll:this._onHorizontalScrollDelegate});
}}},_intializeVerticalScroll:function(){this._verticalScrollDiv=this._owner.get_verticalScrollDiv();
if(this._verticalScrollDiv){this._onVerticalScrollDelegate=Function.createDelegate(this,this._onVerticalScroll);
this._onVerticalScrollWithMiddleButtonDelegate=Function.createDelegate(this,this._onVerticalScrollWithMiddleButton);
window.$addHandlers(this._verticalScrollDiv,{scroll:this._onVerticalScrollDelegate});
if($telerik.isTouchDevice){window.$addHandlers(this._owner.get_dataDiv(),{scroll:this._onVerticalScrollDelegate});
this._onColumnHeaderScrollDelegate=Function.createDelegate(this,this._onColumnHeaderScroll);
this._onRowHeaderScrollDelegate=Function.createDelegate(this,this._onRowHeaderScroll);
window.$addHandlers(this._owner.get_columnHeaderDiv(),{scroll:this._onColumnHeaderScrollDelegate});
window.$addHandlers(this._owner.get_rowHeaderDiv(),{scroll:this._onRowHeaderScrollDelegate});
}if($telerik.isFirefox){window.$addHandlers(this._owner.get_dataDiv(),{DOMMouseScroll:this._onVerticalScrollWithMiddleButtonDelegate});
window.$addHandlers(this._owner.get_rowHeaderDiv(),{DOMMouseScroll:this._onVerticalScrollWithMiddleButtonDelegate});
}else{window.$addHandlers(this._owner.get_dataDiv(),{mousewheel:this._onVerticalScrollWithMiddleButtonDelegate});
window.$addHandlers(this._owner.get_rowHeaderDiv(),{mousewheel:this._onVerticalScrollWithMiddleButtonDelegate});
}}},_onVerticalScrollWithMiddleButton:function(d){var c=0;
this._scrolled=true;
if(!d){d=window.event;
}else{d=d.rawEvent||d;
}if(d.wheelDelta){c=d.wheelDelta/60;
}else{if(d.detail){c=-d.detail/2;
}}d.cancelBubble=true;
d.returnValue=false;
if(d.stopPropagation){d.stopPropagation();
d.preventDefault();
}var e=this._owner;
var g=e._verticalScrollCoefficient;
var f=this._verticalScrollDiv.scrollTop*g;
f=parseInt(f,10)-(c*10);
e.get_dataDiv().scrollTop=f;
this._verticalScrollDiv.scrollTop=f/g;
e.get_rowHeaderDiv().scrollTop=f;
this._scrolling._scrollTop=this._verticalScrollDiv.scrollTop;
this._owner.updateClientState();
},initializeSaveScrollPosition:function(){if(this._scrolling._saveScrollPosition){return;
}if(this._scrolling&&this._scrolling._scrollTop!=""&&this._scrolling._allowVerticalScroll){this._verticalScrollDiv.scrollTop=this._scrolling._scrollTop;
this._owner.get_rowHeaderDiv().scrollTop=this._scrolling._scrollTop;
}if(this._scrolling._scrollLeft&&this._scrolling._scrollLeft!=""){this._horizontalScrollDiv.scrollLeft=this._scrolling._scrollLeft;
}},_onHorizontalScroll:function(){var d=this._owner;
if($telerik.isTouchDevice){if(this._scrolling._allowVerticalScroll){d.get_columnHeaderDiv().scrollLeft=d.get_dataDiv().scrollLeft;
}d.updateClientState();
return;
}var c=d._hzScrollCoefficient;
var e=this._horizontalScrollDiv.scrollLeft*c;
d.get_dataDiv().scrollLeft=e;
if(this._scrolling._allowVerticalScroll){d.get_columnHeaderDiv().scrollLeft=e;
}this._scrolling._scrollLeft=this._horizontalScrollDiv.scrollLeft;
d.updateClientState();
},_onVerticalScroll:function(){if(this._scrolled){this._scrolled=false;
return;
}var c=this._owner;
if($telerik.isTouchDevice){c.get_rowHeaderDiv().scrollTop=c.get_dataDiv().scrollTop;
c.updateClientState();
return;
}var e=c._verticalScrollCoefficient;
var d=this._verticalScrollDiv.scrollTop*e;
c.get_dataDiv().scrollTop=d;
c.get_rowHeaderDiv().scrollTop=d;
this._scrolling._scrollTop=this._verticalScrollDiv.scrollTop;
c.updateClientState();
},_onColumnHeaderScroll:function(){var c=this._owner;
c.get_dataDiv().scrollLeft=c.get_columnHeaderDiv().scrollLeft;
this._owner.updateClientState();
},_onRowHeaderScroll:function(){var c=this._owner;
c.get_dataDiv().scrollTop=c.get_rowHeaderDiv().scrollTop;
this._owner.updateClientState();
}};
a.PivotGridScrolling.registerClass("Telerik.Web.UI.PivotGridScrolling",Sys.Component);
})(Telerik.Web.UI,undefined);
Type.registerNamespace("Telerik.Web.UI");
(function(a,b){a.RadPivotGrid=function(c){var d=["pivotGridCreating","pivotGridCreated","pivotGridDestroying","command","toolTipShow","cellClick","cellMouseOver","cellMouseOut","cellDoubleClick","cellContextMenu","menuShowing","menuShown","fieldCreated","columnResizing","columnResized"];
this._initializeEvents(d);
a.RadPivotGrid.initializeBase(this,[c]);
this.UniqueID=null;
this.ClientID=c.id;
this.Skin="Default";
this._rhtData={};
this._chtData={};
this._dtData={};
this._scrolling=null;
this._filtering=null;
this._clientSettings={};
this._rowHeaderTable=null;
this._columnHeaderTable=null;
this._dataTable=null;
this._hzScrollClientID=null;
this._hzScrollDiv=null;
this._verticalScrollClientID=null;
this._verticalScrollDiv=null;
this._rhTableClientID=null;
this._hzScrollCoefficient=null;
this._verticalScrollCoefficient=null;
this._columnGroupDescriptionsCount=null;
this._shouldAdjustColumnsLayout=false;
this._hideHorizontalScroll=false;
this._dragging=null;
this._resizing=null;
this._fields=null;
this._fieldsData={};
this._hiddenFieldsData=[];
this._contextMenuComponent=null;
this._fieldsWindowClientData=null;
this._configurationPanel=null;
this._configurationPanelEnableDragDrop=true;
this._configurationPanelEnableFieldsContextMenu=true;
this._configurationPanelFieldsData={};
this._aggregatesPosition=null;
this._aggregatesLevel=null;
this._filterWindowClientData={};
this._fieldSettingsData={};
this._filterMenu=null;
this._enableToolTips=false;
this._currentToolTip=null;
this._currentToolTipTarget=null;
this._tooltipTimeout=null;
this._documentMouseMoveDelegate=null;
this._shouldHideToolTip=false;
this._onResizeDelegate=null;
this._enableFieldsDragDrop=false;
this._enableZoneContextMenu=false;
this._pageCount=1;
this._pageSize=10;
this._currentPageIndex=0;
this._emptyValue="&nbsp";
this._errorValue="&nbsp";
this._enableAriaSupport=false;
this._olapExtension=null;
this._touchScrollExtenders=[];
this._showFieldsWindowText=null;
this._hideFieldsWindowText=null;
this._enableFieldSettings=false;
this._hiddenZones={};
this._adjustedColumnsLayout=false;
this._adjustedRowsLayout=false;
this._resizedColumns="";
this._resizedTableWidth=null;
this._columnHeaderCells=[];
};
a.RadPivotGrid.prototype={initialize:function(){a.RadPivotGrid.callBaseMethod(this,"initialize");
if(this._isDataEmpty()){return;
}this.raise_pivotGridCreating(Sys.EventArgs.Empty);
var c=this.get_clientSettings()._scrolling._allowVerticalScroll;
if(c){this._rowHeaderTable=$get(this._rhtData.ClientID);
this._columnHeaderTable=$get(this._chtData.ClientID);
}this._dataTable=$get(this._dtData.ClientID);
if(this._shouldAdjustColumnsLayout&&this.canRepaint()){this._adjustColumnsLayout();
}var e=$get(this.get_id()+"_ConfigurationPanel");
if(!e){e=$telerik.getElementsByClassName(this._element,"rpgConfigurationPanel","div")[0];
}var d=null;
if(e){d=this._configurationPanel=$create(a.PivotGridConfigurationPanel,null,null,{_owner:this.ClientID},e);
d._enableDragDrop=this._configurationPanelEnableDragDrop;
d._enableFieldsContextMenu=this._configurationPanelEnableFieldsContextMenu;
d._fieldsData=this._configurationPanelFieldsData;
var i=$telerik.findControl(d.get_element(),"RadTreeViewOLAP");
if(i){this._olapExtension=new a.PivotGridOlapExtension(d,i);
}this._setOuterTableWidth();
}if(this.canRepaint()){this._adjustRowsLayout();
}else{this.add_parentShown(this.get_element());
}var h=this;
this._initializeScrollBars();
var g=0;
this._onResizeDelegate=Function.createDelegate(this._owner,function(){clearTimeout(g);
g=setTimeout(function(){clearTimeout(g);
if(h.get_element()){h.repaint();
}},100);
});
window.$addHandler(window,"resize",this._onResizeDelegate);
this._fields=this._createFields();
if(this._enableFieldsDragDrop){this._dragging=$create(a.PivotGridDragDrop,null,null,{_owner:this.ClientID});
}if(this._enableZoneContextMenu||(d&&d._enableFieldsContextMenu)){this._contextMenuComponent=$create(a.PivotGridContextMenu,null,null,{_owner:this.ClientID});
}if(this.get_clientSettings()._resizing._allowColumnResize){this._resizing=$create(a.PivotGridColumnResizer,null,null,{_owner:this.ClientID});
}if(this._enableToolTips){this._attachEvents();
}this.raise_pivotGridCreated(Sys.EventArgs.Empty);
if(this._filterWindowClientData.isVisible){this._filtering=$create(a.PivotGridFiltering,{_owner:this,filterWindowID:String.format("{0}_{1}",this.get_id(),"FilterWindow"),filterDialogID:String.format("{0}_{1}",this.get_id(),"FilterDialog"),_clientData:this._filterWindowClientData},null,null);
this._filtering.displayWindowOverField();
}if(this._enableFieldSettings){var f=$get(this._fieldSettingsData.ContainerID);
this._fieldSettings=$create(a.PivotGridFieldSettings,{_clientData:this._fieldSettingsData},null,{owner:this.ClientID},f);
}if(this.get_enableAriaSupport()){this._initializeAriaSupport();
}if($telerik.isMobileIE10){this._initializeIE10MobileSupport();
}this._attachCellEvents();
},dispose:function(){var f=this;
f.raise_pivotGridDestroying(Sys.EventArgs.Empty);
if(f._scrolling){f._scrolling.dispose();
}if(f._dragging){f._dragging.dispose();
}if(f._resizing){f._resizing.dispose();
}if(f._configurationPanel){f._configurationPanel.dispose();
}if(f._contextMenuComponent){f._contextMenuComponent.dispose();
}if(f._enableToolTips){window.$clearHandlers(f.get_element());
if(f._documentMouseMoveDelegate){$telerik.removeExternalHandler(document,"mousemove",f._documentMouseMoveDelegate);
f._documentMouseMoveDelegate=null;
}if(f._currentToolTip){f._currentToolTip.dispose();
}}if(f._olapExtension){f._olapExtension.dispose();
}if(f._onResizeDelegate!=null){$telerik.removeHandler(window,"resize",f._onResizeDelegate);
f._onResizeDelegate=null;
}if($telerik.isTouchDevice&&f._touchScrollExtenders){var e=f._touchScrollExtenders;
for(var c=0,d=e.length;
c<d;
c++){e[c].dispose();
}}a.RadPivotGrid.callBaseMethod(f,"dispose");
},get_uniqueID:function(){return this.UniqueID;
},get_clientSettings:function(){return this._clientSettings;
},get_rowHeaderTable:function(){return this._rowHeaderTable;
},get_rowHeaderDiv:function(){return this.get_rowHeaderTable()?this.get_rowHeaderTable().parentNode:null;
},get_columnHeaderTable:function(){return this._columnHeaderTable;
},get_columnHeaderDiv:function(){return this.get_columnHeaderTable()?this.get_columnHeaderTable().parentNode:null;
},get_dataTable:function(){return this._dataTable;
},get_dataDiv:function(){return this.get_dataTable()?this.get_dataTable().parentNode:null;
},get_hzScrollDiv:function(){if(this._hzScrollDiv==null&&!!this._hzScrollClientID){this._hzScrollDiv=$get(this._hzScrollClientID);
}return this._hzScrollDiv;
},get_verticalScrollDiv:function(){if(this._verticalScrollDiv==null&&!!this._verticalScrollClientID){this._verticalScrollDiv=$get(this._verticalScrollClientID);
}return this._verticalScrollDiv;
},get_scrollHeight:function(){return this._calculateScrollHeight();
},get_columnGroupDescriptionsCount:function(){return this._columnGroupDescriptionsCount;
},get__columnHeaderCells:function(){return this._columnHeaderCells;
},get_fields:function(){return this._fields;
},get_fieldsWindow:function(){return $find(String.format("{0}_{1}",this.get_id(),"FieldsWindow"));
},get_filterWindow:function(){return $find(String.format("{0}_{1}",this.get_id(),"FilterWindow"));
},get_filterDialog:function(){return $find(String.format("{0}_{1}",this.get_id(),"FilterDialog"));
},get_fieldSettingsWindow:function(){return $find(String.format("{0}_{1}",this.get_id(),"FieldSettingsWindow"));
},get_fieldSettings:function(){return this._fieldSettings;
},get_contextMenu:function(){return $find(String.format("{0}_{1}",this.get_id(),"ContextMenu"));
},get_configurationPanel:function(){return this._configurationPanel;
},get_toolTipManager:function(){return $find(String.format("{0}_{1}",this.get_id(),"PivotGridToolTipManager"));
},get_enableToolTips:function(){return this._enableToolTips;
},get_enableAriaSupport:function(){return this._enableAriaSupport;
},set_hiddenFieldsData:function(c){this._hiddenFieldsData=c;
},get_hiddenFieldsData:function(){return this._hiddenFieldsData;
},get_currentPageIndex:function(){return this._currentPageIndex;
},set_currentPageIndex:function(c){this.fireCommand("Page",c);
},get_pageCount:function(){return this._pageCount;
},get_pageSize:function(){return this._pageSize;
},set_pageSize:function(c){this.fireCommand("PageSizeChanged",c);
},get_filterZone:function(){return $telerik.getElementByClassName(this._element,"rpgFilterZone");
},get_columnZone:function(){return $telerik.getElementByClassName(this._element,"rpgColumnsZone");
},get_rowZone:function(){return $telerik.getElementByClassName(this._element,"rpgRowsZone");
},get_aggregateZone:function(){return $telerik.getElementByClassName(this._element,"rpgDataZone");
},get_rippleZonesConfiguration:function(){var k=".rpgPager .rpgActionButton, .rpgRowHeader .rpgIcon, .rpgColumnHeader .rpgIcon";
var c=$telerik.$(k)[0];
var l=this;
var d=".rpgUpdate button.rpgUpdateButton, .rpgPagerButton";
var e=null;
var f=l.get_id()+"_OT";
var h=$telerik.$("#"+f).find("[id*='SortLinkButton']").length>0;
var g=$telerik.$("#"+f).find(".rpgFilterIcon").length>0;
if(l._enableFieldsDragDrop){d+=", #"+f+" .rpgFieldItem";
}else{if(h||g){d+=", #"+f+" .rpgFieldItem:not(.rpgDataZone .rpgFieldItem)";
}}var j=60;
if(c){j=c.offsetWidth/0.6;
}var i={element:this.get_element(),rippleConfigurations:[{containerSelector:k+", .rpgConfigurationPanel a.rpgChangeLayoutIcon",rippleType:Telerik.Web.UI.MaterialRippleType.Icon,maxRippleSize:j},{containerSelector:".rpgPager .rpgNumPart a:not('.rpgCurrentPage')",rippleType:Telerik.Web.UI.MaterialRippleType.Icon,maxRippleSize:j,boundToElementSize:true},{containerSelector:d}]};
if(l.get_configurationPanel()&&(l.get_configurationPanel()._enableDragDrop||h||g)){if(l.get_configurationPanel()._enableDragDrop){e=".rpgConfigurationPanel .rpgFieldItem";
}else{if(h||g){e=".rpgConfigurationPanel .rpgRowFieldsContainer .rpgFieldItem, .rpgConfigurationPanel .rpgColumnFieldsContainer .rpgFieldItem";
if(g){e+=", .rpgConfigurationPanel .rpgAllFieldsContainer .rpgFieldItem";
}}}i.rippleConfigurations.push({containerSelector:e});
}return[i];
},page:function(c){this.fireCommand("Page",c);
},sort:function(c,d){if(Telerik.Web.UI.PivotGridField.isInstanceOfType(c)){c=c.get_uniqueName();
}var e=c;
if(d&&e.indexOf(" ")===-1){e+=" "+d;
}this.fireCommand("Sort",e);
},expandAllRowGroups:function(){this.expandRowGroupsAtLevel(-1);
},expandAllColumnGroups:function(){this.expandColumnGroupsAtLevel(-1);
},collapseAllRowGroups:function(){this.collapseRowGroupsAtLevel(-1);
},collapseAllColumnGroups:function(){this.collapseColumnGroupsAtLevel(-1);
},expandRowGroupsAtLevel:function(c){this.fireCommand("ExpandCollapseLevel","Expand;Rows;"+c);
},expandColumnGroupsAtLevel:function(c){this.fireCommand("ExpandCollapseLevel","Expand;Columns;"+c);
},collapseRowGroupsAtLevel:function(c){this.fireCommand("ExpandCollapseLevel","Collapse;Rows;"+c);
},collapseColumnGroupsAtLevel:function(c){this.fireCommand("ExpandCollapseLevel","Collapse;Columns;"+c);
},rebind:function(){this.fireCommand("RebindPivotGrid","");
},repaint:function(){if(!this.canRepaint()){return;
}if(!this._adjustedColumnsLayout&&!this._adjustedRowsLayout){this._adjustColumnsLayout();
this._adjustRowsLayout();
}this._setOuterTableWidth();
this._initializeHzScrollDiv();
if(this._clientSettings._scrolling._allowVerticalScroll){this._initializeVerticalScrollDiv();
}},hideField:function(d){var c=this._getField(d);
if(c!=null){c.hide();
}},showField:function(d){var c=this._getField(d);
if(c!=null){c.show();
}},tryReorderField:function(d,f,e){var c=this._getField(d);
if(c==null){return false;
}else{return c.tryReorder(f,e);
}return false;
},getFieldByUniqueName:function(e){var d=this.get_fields();
var c=null;
for(var f=0;
f<d.length;
f++){c=d[f];
if(c.get_uniqueName()==e){return c;
}}return null;
},fireCommand:function(e,d){var c=new Sys.CancelEventArgs();
c.get_commandName=function(){return e;
};
c.get_commandArgument=function(){return d;
};
this.raise_command(c);
if(c.get_cancel()){return false;
}this._executePostBackEvent(this._constructPostBackData(e,d));
return true;
},saveClientState:function(){var k={};
if(this._clientSettings&&this._clientSettings._scrolling&&!this._clientSettings._scrolling._saveScrollPosition){var j=this._clientSettings._scrolling;
k.scrolledPosition=j._scrollTop+","+j._scrollLeft;
}var e=this.get_fieldsWindow();
var i,c;
if(e){var f={};
f.isVisible=e.isVisible();
if(e.isVisible()){i=a.PivotGrid.GetBounds(this._element);
c=e.getWindowBounds();
f.x=c.x-i.x;
f.y=c.y-i.y;
f.width=c.width;
f.height=c.height;
}k.fieldsWindowClientData=f;
}var d=this.get_configurationPanel();
if(d){k.configurationPanelLayoutType=d.get_layoutType();
}if(true){var g=this.get_filterWindow();
if(g){var h={};
if(k.filterWindowClientData==b){k.filterWindowClientData={};
}h.isVisible=g.isVisible();
if(g.isVisible()){i=a.PivotGrid.GetBounds(this._element);
c=g.getWindowBounds();
h.x=c.x-i.x;
h.y=c.y-i.y;
h.width=c.width;
h.height=c.height;
k.filterWindowClientData=h;
}}}if(this._clientSettings&&this._clientSettings._resizing._allowColumnResize){if(this._resizedColumns){k.resizedColumns=this._resizedColumns;
}if(this._resizedTableWidth){k.resizedTableWidth=this._resizedTableWidth;
}}return Sys.Serialization.JavaScriptSerializer.serialize(k);
},resizeColumn:function(c,d){if(this.get_clientSettings()._resizing._allowColumnResize&&this._resizing){this._resizing._resize(c,d);
}},_attachCellEvents:function(){var e=this.get_events(),d=this._element,c={cellClick:"click",cellMouseOver:"mouseover",cellMouseOut:"mouseout",cellDoubleClick:"dblclick",cellContextMenu:"contextmenu"};
for(var f in c){if(e.getHandler(f)){$telerik.addMobileHandler(this,d,c[f],this._cellHandler);
}}},_cellHandler:function(d){var h=this,g=a.PivotGrid.GetTouchCurrentElement(d),c=h._getCellEventArguments(g,d);
if(c===null){return;
}var f={click:"cellClick",mouseover:"cellMouseOver",mouseout:"cellMouseOut",dblclick:"cellDoubleClick",contextmenu:"cellContextMenu"};
h["raise_"+f[d.type]](c);
},_getCellEventArguments:function(c,f){if(!c){return null;
}var j=this,g={},e=c.className?c.className.split(" "):[],d={};
for(var h=0;
h<e.length;
h++){d[e[h]]=true;
}g.cellType=d.rpgDataCell?a.PivotGridCellType.DataCell:d.rpgRowHeader||d.rpgRowHeaderTotal||d.rpgRowHeaderGrandTotal?a.PivotGridCellType.RowHeaderCell:d.rpgColumnHeader||d.rpgColumnHeaderTotal||d.rpgColumnHeaderGrandTotal?a.PivotGridCellType.ColumHeaderCell:null;
if(g.cellType===null){if(c.children.length===0&&$telerik.getElementByClassName(c.parentNode,"rpgRowHeader")){g.cellType=a.PivotGridCellType.RowHeaderCell;
}else{return null;
}}g.isTotalCell=d.rpgColumnTotalDataCell||d.rpgRowTotalDataCell||d.rpgRowHeaderTotal||d.rpgColumnHeaderTotal||false;
g.isGrandTotalCell=d.rpgRowGrandTotalDataCell||d.rpgRowGrandTotalDataCell||d.rpgColumnHeaderGrandTotal||d.rpgRowHeaderGrandTotal||false;
g.text=c.textContent;
g.isEmptyCell=g.cellType===a.PivotGridCellType.DataCell&&c.innerHTML===j._emptyValue;
g.isErrorCell=g.cellType===a.PivotGridCellType.DataCell&&c.innerHTML===j._errorValue;
g.cell=c;
g.expandCollapseButton=$telerik.getElementByClassName(c,"rpgCollapse","input")||$telerik.getElementByClassName(c,"rpgExpand","input");
g.domEvent=f;
return a.PivotGrid.BuildEventArgs(new Sys.EventArgs(),g);
},_showFilterDialog:function(c,f){var d=c?c:window.event;
d.returnValue=false;
d.cancelBubble=true;
if(d.preventDefault){d.preventDefault();
d.stropPropagation();
}return false;
},_getField:function(d){var c;
if(Telerik.Web.UI.PivotGridField.isInstanceOfType(d)){return d;
}else{if(a.PivotGrid.IsDomElement(d)){c=$find(d.id);
if(c!=null&&Telerik.Web.UI.PivotGridField.isInstanceOfType(c)){return c;
}}else{c=this.getFieldByUniqueName(d);
return c;
}}return null;
},_searchForFieldFromElement:function(c){var e=this;
var d=e._getField(c);
if(d==null){d=e._getField(c.parentNode);
}if(d==null){d=$find(c.id);
}if(d==null&&c.parentNode){d=$find(c.parentNode.id);
}if(d==null){return null;
}if(!a.PivotGridField.isInstanceOfType(d)&&a.PivotGridAggregateLabel&&!a.PivotGridAggregateLabel.isInstanceOfType(d)){return null;
}return d;
},_getFilterMenu:function(){if(Telerik.Web.UI.RadContextMenu&&!this._filterMenu){this._filterMenu=$find(this.ClientID+"_rfltMenu");
}return this._filterMenu;
},_showFilterMenu:function(h,d){var f=this.getFieldByUniqueName(h);
var g=this._getFilterMenu();
if(g){g.hide();
var c=new Sys.CancelEventArgs();
c.get_menu=function(){return g;
};
c.get_field=function(){return f;
};
c.get_domEvent=function(){return d;
};
this.raise_filterMenuShowing(c);
if(c.get_cancel()){return;
}g.show(d);
}},_constructPostBackData:function(d,c){return String.format("FireCommand:{0}|;{1}|;",d,c);
},_executePostBackEvent:function(c){var d="__doPostBack('{0}','{1}')";
d=d.replace("{0}",this.get_uniqueID());
d=d.replace("{1}",c);
eval(d);
},_initializeScrollBars:function(){var c=this.get_clientSettings()._scrolling._allowVerticalScroll;
this._initializeHzScrollDiv();
if(c){this._initializeVerticalScrollDiv();
}if($telerik.isTouchDevice){this._initializeTouchScrollExtenders(c);
}this._scrolling=$create(a.PivotGridScrolling,null,null,{owner:this.ClientID});
},_hideScrollRow:function(){var d=this.get_hzScrollDiv();
var c=d.parentNode;
if(c){var e=d.parentNode.parentNode;
if(e){e.style.display="none";
}}},_showScrollRow:function(){var d=this.get_hzScrollDiv();
var c=d.parentNode;
if(c){var e=d.parentNode.parentNode;
if(e){e.style.display="";
}}},_setOuterTableWidth:function(){var c=this.get_configurationPanel();
if(c){var d=c.get_element();
var e=this.get_element();
if(e.className.indexOf("rpgLeftConfigurationPanel")!=-1||e.className.indexOf("rpgRightConfigurationPanel")!=-1){var f=e.clientWidth-d.offsetWidth;
if(f>=0){$get(this.get_id()+"_OT").parentNode.style.width=e.clientWidth-d.offsetWidth+"px";
}}}},_initializeHzScrollDiv:function(){var c=this._clientSettings._scrolling._allowVerticalScroll,r=this._getPivotWrapperElement();
var p=0;
if(r){p=r.clientWidth;
}var l=this.get_hzScrollDiv();
var q=$telerik.isIE?a.PivotGrid.GetScrollBarWidth()+1:a.PivotGrid.GetScrollBarWidth();
l.style.width=r.clientWidth+"px";
l.style.height=q+"px";
l.style.overflowX="scroll";
l.style.overflowY="hidden";
var n=l.children[0],j,g=this.get_dataDiv(),h,i=g.scrollLeft,f=this.get_columnHeaderDiv();
g.style.width="";
if(c){f.style.width="";
}var k=this._getRowHeadersContainerWidth();
var e=p-k;
if(c&&!this._shouldHideVerticalScroll()){e=e-a.PivotGrid.GetScrollBarWidth();
}var d=k+g.clientWidth;
if(e>0){e--;
}if(r.clientWidth<d){g.style.width=Math.abs(e)+"px";
g.scrollLeft=i;
if(c){f.style.width=Math.abs(e)+"px";
f.scrollLeft=i;
}}h=g.style.width;
if(e>=0){g.style.width=e+"px";
}j=this.get_dataTable().clientWidth;
if(h>=0){g.style.width=h;
}if(e>0){var m=this._getPivotWrapperElement().clientWidth;
n.style.width=(j/e)*m+"px";
n.style.height=l.style.height;
var o=parseInt(n.style.width,10);
if(o<=m||(o-m)>0&&(o-m)<4){this._hideScrollRow();
this._hideHorizontalScroll=true;
}else{this._showScrollRow();
this._hideHorizontalScroll=false;
}this._hzScrollCoefficient=e/m;
}},_initializeVerticalScrollDiv:function(){var n=0;
var p=this.get_element().style.height;
if(p){var o=$get(this.get_id()+"_OT").getElementsByTagName("caption");
for(var l=0;
l<o.length;
l++){if(o[l].className=="rpgOuterTableCaption"){n=o[l].offsetHeight;
break;
}}}var h=this.get_dataTable();
var g=this.get_dataDiv();
var e=this.get_columnHeaderDiv();
var f=this.get_rowHeaderDiv();
var r=this.get_scrollHeight()-n;
var k=this._isHeightSet()?r:r-e.offsetHeight-n;
f.style.height=k>0?k+"px":r+"px";
g.style.height=k>0?k+"px":r+"px";
var c=[];
var d=0;
var m=null;
var s=this.get_verticalScrollDiv();
if(this._shouldHideVerticalScroll()){s.parentNode.style.display="none";
s.style.width="0px";
c=$get(this.get_id()+"_OT").getElementsByTagName("colgroup")[0].getElementsByTagName("col");
d=c.length;
if(d>0){m=c[d-1];
m.style.width="1px";
}}else{s.parentNode.style.display="";
var q=$telerik.isIE?a.PivotGrid.GetScrollBarWidth()+1:a.PivotGrid.GetScrollBarWidth();
var u=s.parentNode;
var t;
if(this._isHeightSet()||r<=10||k<=0){t=r+e.offsetHeight;
}else{t=r;
}s.style.height=t+"px";
s.style.width=q+"px";
s.style.overflowY="scroll";
s.style.overflowX="hidden";
u.style.width=q+"px";
c=$get(this.get_id()+"_OT").getElementsByTagName("colgroup")[0].getElementsByTagName("col");
d=c.length;
m=c[d-1];
m.style.width=q+"px";
var v=s.children[0];
var j=h.offsetHeight;
v.style.height=(j/g.offsetHeight)*t+"px";
v.style.width=q+"px";
this._verticalScrollCoefficient=g.offsetHeight/t;
}},_adjustRowsLayout:function(){var c=this.get_clientSettings()._scrolling._allowVerticalScroll,t=this._getRowHeaders(),m=this.get_dataTable(),l=m.rows,r;
var n=0;
var v;
this._adjustedRowsLayout=true;
if(!c){var o=m.getElementsByTagName("thead")[0];
if(o!=b){n=o.rows.length;
}var w=0;
for(v=0;
v<n;
v++){if(l[v]&&l[v].cells.length>0){w+=l[v].cells[0].offsetHeight;
if(l[v].cells[0].rowSpan>1){v+=l[v].cells[0].rowSpan-1;
}}}if(t[0]){var u=t[0].previousSibling;
if($telerik.isIE7){var q=u.cells[0];
w-=parseInt($telerik.getComputedStyle(q,"paddingTop"),10);
w-=parseInt($telerik.getComputedStyle(q,"paddingBottom"),10);
w--;
}var p=u.cells[0].offsetHeight;
if(w>p){if(u&&u&&u.cells.length>0){u.style.height=w+"px";
}}else{if(u&&w<p){if(n==1){u.style.height=p+"px";
o.rows[0].style.height=p+"px";
}else{u.style.height=w+"px";
}}}}}else{var d=$telerik.getElementByClassName(this.get_element(),"rpgColumnHeaderDiv","div");
var g=d.parentNode;
var e=d.getElementsByTagName("table")[0];
var h=g.offsetHeight;
var f=e.offsetHeight;
if(h>f){e.style.height=h+"px";
}}for(v=0;
v<t.length;
n++,v++){r=t[v].cells[t[v].cells.length-1];
var j=l[n].cells[0];
if(!j||!r){return;
}var s=r.offsetHeight;
var k=j.offsetHeight;
if(s>k){l[n].style.height=s+"px";
t[v].style.height=s+"px";
}else{t[v].style.height=k+"px";
l[n].style.height=k+"px";
}}},_getPivotWrapperElement:function(){var c=this.get_element();
if(c.className.indexOf("ConfigurationPanel")!=-1){return $get(this.get_id()+"_OT").parentNode;
}return c;
},_adjustColumnsLayout:function(){var c=this.get_clientSettings()._scrolling._allowVerticalScroll,E=this._getPivotWrapperElement();
var w;
var y;
var q;
var k;
this._adjustedColumnsLayout=true;
if(c){var r=$telerik.getElementByClassName(this.get_element(),"rpgDimensionRow","tr");
if(!r){return;
}var s=r.cells;
var j=this.get_columnHeaderTable(),o=this.get_dataTable(),m=o.getElementsByTagName("colgroup")[0].getElementsByTagName("col"),p=null;
q=o.style.width;
k=j.style.width;
o.style.width="auto";
j.style.width="auto";
if($telerik.isIE7){w=j.getElementsByTagName("tr");
w=j.getElementsByTagName("tr")[w.length-1].getElementsByTagName("td");
}else{w=j.getElementsByTagName("colgroup")[0].getElementsByTagName("col");
}if(o.tBodies.length==0||o.tBodies[0].rows.length==0){return;
}p=o.tBodies[0].rows[0].cells;
var g=0;
var d=[];
if(p.length===m.length){for(y=0;
y<m.length;
y++){var A=Math.max(s[y].offsetWidth,p[y].offsetWidth);
d[y]=A;
g+=A;
}}else{if(!Sys.UI.DomElement.containsCssClass(o.tBodies[0].rows[0],"rpgNoRecords")){return;
}}if(E.clientWidth<this._getRowHeadersContainerWidth()+o.clientWidth){j.style.width=g+"px";
o.style.width=g+"px";
}j.style.tableLayout="fixed";
o.style.tableLayout="fixed";
var n=0;
if($telerik.isIE7){var l=o.getElementsByTagName("tr")[0].getElementsByTagName("td")[0];
n=parseInt($telerik.getComputedStyle(l,"padding-left",null),10)+parseInt($telerik.getComputedStyle(l,"padding-right",null),10)+1;
if(!n){n=16;
}}for(y=0;
y<m.length;
y++){if(!m[y].style.width){w[y].style.width=d[y]+"px";
if($telerik.isIE7){m[y].style.width=d[y]-n+"px";
}else{m[y].style.width=d[y]+"px";
}}}if($telerik.isIE7){o.style.tableLayout="auto";
j.style.tableLayout="auto";
}o.style.width=q;
j.style.width=k;
}else{var B=$get(this.ClientID+"_OT");
var u=$get(this.ClientID+"_OT__fhRow");
if(!u){u=$get(this.ClientID+"_OT__lhRow");
}var v=B.tBodies[0].rows[u.rowIndex-1],h=v.cells[0],C=this.get_dataTable().getElementsByTagName("thead")[0];
var t;
var z;
if(C){t=C.rows[0];
z=t.cells[t.cells.length-1];
}else{return;
}if(h.offsetHeight<C.offsetHeight){if($telerik.isIE||$telerik.isChrome){v.style.height=C.offsetHeight+"px";
}else{h.style.height=C.offsetHeight+"px";
}}else{if($telerik.isIE||$telerik.isChrome||$telerik.isSafari){var x=0;
var D=$telerik.isChrome||$telerik.isSafari?$telerik.getComputedStyle(z,"padding-top"):$telerik.getComputedStyle(z,"paddingTop");
var f=$telerik.isChrome||$telerik.isSafari?$telerik.getComputedStyle(z,"padding-bottom"):$telerik.getComputedStyle(z,"paddingBottom");
var e=$telerik.isChrome||$telerik.isSafari?$telerik.getComputedStyle(z,"border-bottom-width"):$telerik.getComputedStyle(z,"borderBottomWidth");
if(D!=b){x+=f.replace("px","")*1;
}if(f){x+=f.replace("px","")*1;
}if(e){x+=e.replace("px","")*1;
}z.style.height=h.offsetHeight-x+"px";
}else{z.style.height=h.offsetHeight+"px";
}}}},_getRowHeaders:function(){var f=$get(this.ClientID+"_OT").rows;
var g=[];
if(!this._clientSettings._scrolling._allowVerticalScroll){var c=$get(this.ClientID+"_OT__fhRow");
var e=$get(this.ClientID+"_OT__lhRow");
if(!c){c=e;
}if(c){for(var d=c.rowIndex;
d<e.rowIndex+1;
d++){Array.add(g,f[d]);
}}return g;
}else{return this.get_rowHeaderTable().rows;
}},_getRowHeadersContainerWidth:function(){if(!this._clientSettings._scrolling._allowVerticalScroll){var d=$get(this.ClientID+"_OT__fhRow");
if(!d){d=$get(this.ClientID+"_OT__lhRow");
}var f=0;
if(d){var c=d.cells;
for(var e=0;
e<c.length;
e++){f+=c[e].offsetWidth;
}}return f;
}else{return this.get_rowHeaderDiv().offsetWidth;
}},_isDataEmpty:function(){var c=false;
var d=$get(this._dtData.ClientID);
if(d==b){c=true;
}return c;
},_calculateScrollHeight:function(){var g=this._clientSettings._scrolling._scrollHeight.Value;
if(this._isHeightSet()){var c=0;
var e=$get(this.ClientID+"_OT");
var h=e.tBodies[0].rows;
for(var d=0;
d<h.length;
d++){if(h[d].cells.length>0){if(h[d].cells[0].className!="rpgRowHeaderZone"){c+=h[d].cells[0].offsetHeight;
}}}var f=this.get_element().style.height.indexOf("px")>-1?parseInt(this.get_element().style.height,10):this.get_element().offsetHeight;
if(this._configurationPanel&&(this._configurationPanel.get_element().className.indexOf("rpgTopConfigurationPanel")!=-1||this._configurationPanel.get_element().className.indexOf("rpgBottomConfigurationPanel")!=-1)){f-=parseInt(this._configurationPanel.get_element().offsetHeight,10);
}g=f- ++c;
if(g<0){g=50;
}}return g;
},_initializeTouchScrollExtenders:function(d){var h=this,c=$telerik.$;
var f=this.get_dataDiv();
var e=null,g=null,i=h._touchScrollExtenders;
if(d){e=h.get_columnHeaderDiv();
g=h.get_rowHeaderDiv();
}i.push(new a.TouchScrollExtender(f));
if(d){i.push(new a.TouchScrollExtender([g,e]));
}c(i).each(function(){this.initialize();
});
if(d){i[1]._addScrollHints=function(){if(this._showScrollHints){var q=0;
var r=0;
var o=this._lastAnimator;
var k=o.element[0];
var j=this._getBorderBox(k);
var m=c(k).position();
if(k==g){this._hasHorizontalScrollHint=false;
}else{this._hasVerticalScrollHint=false;
}if(this._hasHorizontalScrollHint){var n=o.element.innerWidth();
var s=~~((n/k.scrollWidth)*n)-2;
this._widthConstant=(s/n);
setTimeout(function(){q=Math.abs(k.scrollLeft)*(s/n)+m.left+j.left;
r=k.offsetHeight+m.top+j.top-7+c(f).innerHeight();
o.horizontalScrollHint.width(s).css({left:q,top:r});
},0);
o.horizontalScrollHint.fadeTo(200,0.5);
}if(this._hasVerticalScrollHint){var l=o.element.innerHeight();
var p=~~((l/k.scrollHeight)*l)-2;
this._heightConstant=(p/l);
setTimeout(function(){r=Math.abs(k.scrollTop)*(p/l)+m.top+j.top;
q=k.offsetWidth+m.left+j.left-7+c(f).innerWidth();
o.verticalScrollHint.height(p).css({left:q,top:r});
},0);
o.verticalScrollHint.fadeTo(200,0.5);
}}};
}this._hideScrollRow();
},_shouldHideVerticalScroll:function(){if($telerik.isTouchDevice){return true;
}return this.get_scrollHeight()-this.get_columnHeaderDiv().offsetHeight>=this.get_dataTable().offsetHeight?true:false;
},_isHeightSet:function(){return this.get_element().style.height==""?false:true;
},_initializeEvents:function(c){if(c){var d,e;
for(d=0,e=c.length;
d<e;
d++){var f=c[d];
this["add_"+f]=((function(g){return function(h){this.get_events().addHandler(g,h);
};
}(f)));
this["remove_"+f]=((function(g){return function(h){this.get_events().removeHandler(g,h);
};
}(f)));
this["raise_"+f]=((function(g){return function(h){this.raiseEvent(g,h);
};
}(f)));
}}},_createFields:function(){var g=[];
var l=this.get_element();
var f=$telerik.getElementsByClassName(l,"rpgFieldItem","span");
var d=null;
var h=this._fieldsData;
var k;
var c;
var e;
if(h){for(k=0;
k<f.length;
k++){e=f[k];
if(e.id.indexOf("_ConfigurationPanel_")!=-1){continue;
}d=$create(a.PivotGridField,null,null,{_owner:this.ClientID},e);
c=h[e.id];
if(c){d._uniqueName=c.uniqueName;
d._zoneIndex=parseInt(c.zoneIndex,10);
d._zoneType=parseInt(c.zoneType,10);
if(c.aggregate!=b){d._aggregate=parseInt(c.aggregate,10);
}d._isHidden=c.isHidden.toLowerCase()=="true"?true:false;
g.push(d);
}}}var j=this._hiddenFieldsData;
if(j){for(k=0;
k<j.length;
k++){c=j[k];
e=document.createElement("span");
e.className="rpgFieldItem";
e.innerHTML=c.uniqueName;
d=$create(a.PivotGridField,null,null,{_owner:this.ClientID},e);
d._uniqueName=c.uniqueName;
d._zoneIndex=parseInt(c.zoneIndex,10);
d._zoneType=parseInt(c.zoneType,10);
if(c.aggregate!=b){d._aggregate=parseInt(c.aggregate,10);
}d._isHidden=c.isHidden.toLowerCase()=="true"?true:false;
g.push(d);
}}return g;
},_attachEvents:function(){window.$addHandlers(this.get_element(),{mousemove:this._mousemove},this);
if($telerik.isOpera){window.$addHandlers(this.get_element(),{mouseover:this._mouseover},this);
}this._documentMouseMoveDelegate=Function.createDelegate(this,this._documentMouseMove);
$telerik.addExternalHandler(document,"mousemove",this._documentMouseMoveDelegate);
},_documentMouseMove:function(c){this._shouldHideToolTip=false;
if(this._currentToolTip){c=c?c:window.event;
var d=c.target?c.target:c.srcElement;
if(!$telerik.isDescendantOrSelf(this.get_element(),d)){this._currentToolTip.hide();
this._shouldHideToolTip=true;
}}},_mouseover:function(c){c=c?c:window.event;
var f=c.target?c.target:c.srcElement;
var d=f.tagName.toLowerCase();
if((d=="td"||d=="th")&&(f.title||f.tooltip)){$telerik.cancelRawEvent(c);
}},_mousemove:function(c){c=c?c:window.event;
var g=c.target?c.target:c.srcElement;
var i=this;
clearTimeout(i._tooltipTimeout);
if(i._currentToolTip){i._currentToolTip.add_beforeShow(function(n,e){var l=i._currentToolTipTarget;
var m=l&&l.tagName.toLowerCase()=="input"&&l.id&&l.id.indexOf("ExpandCollapseButton")>-1;
if(m){e.set_cancel(true);
}});
if(i._currentToolTipTarget!=g){i._currentToolTip.hide();
i._currentToolTipTarget=g;
}}var f=g.tagName.toLowerCase();
if(f=="td"||f=="th"){if(i._enableToolTips&&(g.title||g.tooltip)){var h=g.tooltip||g.title;
if(g.title){g.tooltip=g.title;
g.title="";
}var j=i._getCurrentToolTip(g);
j.set_targetControl(g);
var k=i._getToolTipContent(h);
j.set_text(k);
var d=i._getEventData(h,j);
if(!i._shouldHideToolTip){i.raise_toolTipShow(a.PivotGrid.BuildEventArgs(new Sys.EventArgs(),d));
}i._tooltipTimeout=setTimeout(function(){if(i._shouldHideToolTip){return;
}j.show();
},j.get_showDelay());
}}},_getToolTipContent:function(g){var f=g.split(";");
var c="";
for(var d=0;
d<f.length;
d++){var e=f[d];
if(d==0){c+="<strong>"+e+"</strong>";
}else{c+=e;
}if(d<f.length-1){c+="<br>";
}}return c;
},_getEventData:function(i,j){if(this._events._list.toolTipShow){var d,c,h;
var g=i.split(";");
if(g.length==2){var f=g[0].trim();
d=f.substring(f.indexOf("(")+1,f.length-1);
if(g[1].indexOf("Row")>-1){h=g[1];
}if(g[1].indexOf("Column")>-1){c=g[1];
}}else{if(g.length==4){d=g[1];
h=g[2];
c=g[3];
}}var e={toolTip:j,originalText:i,dataValue:d,columnsData:c,rowsData:h};
return e;
}},_getCurrentToolTip:function(c){if(!this._currentToolTip){this._currentToolTip=this.get_toolTipManager().createToolTip(c);
}return this._currentToolTip;
},_initializeIE10MobileSupport:function(){var e=this.get_filterZone();
var c=this.get_aggregateZone();
var g=this.get_rowZone();
var d=this.get_columnZone();
if(e){e.style.msTouchAction="none";
e.style.touchAction="none";
}if(c){c.style.msTouchAction="none";
c.style.touchAction="none";
}if(g&&g.parentNode){var j=g.parentNode;
var h=$telerik.getElementsByClassName(j,"rpgRowsZone");
for(var f=0;
f<h.length;
f++){h[f].style.msTouchAction="none";
h[f].style.touchAction="none";
}}if(d){d.style.msTouchAction="none";
d.style.touchAction="none";
}},_initializeAriaSupport:function(){var C=this.get_element();
C.setAttribute("aria-readonly","true");
C.setAttribute("aria-atomic","true");
C.setAttribute("aria-label",this.get_id());
C.setAttribute("role","grid");
var e=function(i){if(i){i.setAttribute("role","presentation");
}};
var y=document.getElementById(this.get_id()+"_OT");
var B=$telerik.getElementsByClassName(y,"rpgPager","tr");
var u;
for(var D=0;
D<B.length;
D++){var A=B[D];
A.setAttribute("role","presentation");
var h=A.getElementsByTagName("div");
for(var z=0;
z<h.length;
z++){var g=h[z];
if(g.className&&g.className.indexOf("rpgWrap")>-1){u=g.getElementsByTagName("input");
for(var w=0;
w<u.length;
w++){var q=u[w];
if(q.type=="submit"&&q.id&&(q.id.indexOf("PrevButton")>-1||q.id.indexOf("FirstButton")>-1||q.id.indexOf("NextButton")>-1||q.id.indexOf("LastButton")>-1||q.id.indexOf("ChangePageSizeLinkButton")>-1||q.id.indexOf("GoToPageLinkButton")>-1)){q.setAttribute("role","button");
}}}}}e(y);
e(this.get_filterZone());
e(this.get_columnZone());
e(this.get_aggregateZone());
var F=this.get_rowZone();
if(F){var H=F.parentNode;
var G=$telerik.getElementsByClassName(H,"rpgRowsZone");
for(var o=0;
o<G.length;
o++){G[o].setAttribute("role","presentation");
}}var n=this.get_hzScrollDiv();
if(n){n.setAttribute("role","scrollbar");
}var J=this.get_verticalScrollDiv();
if(J){J.setAttribute("role","scrollbar");
}var c=function(N){if(N){var L=N.tBodies[0].rows;
for(var M=0,r=L.length;
M<r;
M++){var K=L[M];
if(!K.id){K.setAttribute("role","row");
var k=K.cells;
for(var p=0;
p<k.length;
p++){var i=k[p];
if(i.tagName.toLowerCase()=="td"){if(i.className.indexOf("RowHeader")>-1){i.setAttribute("role","rowheader");
}else{i.setAttribute("role","gridcell");
}}if(i.tagName.toLowerCase()=="th"){i.setAttribute("role","columnheader");
}}}}}};
var f=this.get_columnHeaderTable();
var E=this.get_rowHeaderTable();
c(f);
c(E);
c(this.get_dataTable());
var d=function(r){if(r){var p=r.getElementsByTagName("input");
for(var j=0;
j<p.length;
j++){var k=p[j];
if(k.type=="submit"&&(k.title=="Expand"||k.title=="Collapse")){k.setAttribute("aria-expanded",k.title=="Expand");
}}}};
d(f);
d(E);
var m=this.get_fields();
for(var v=0,x=m.length;
v<x;
v++){var l=m[v].get_element();
if(this._enableFieldsDragDrop){l.setAttribute("aria-dropeffect","move");
}u=l.getElementsByTagName("input");
for(var I=0;
I<u.length;
I++){var s=u[I];
if(s.id&&s.id.indexOf("SortIconButton")>-1){l.setAttribute("aria-sort",s.className=="rpgSortAsc"?"ascending":"descending");
}if(s.id&&s.id.indexOf("FilterPictButton")>-1){s.setAttribute("role","button");
}}}}};
a.RadPivotGrid.registerClass("Telerik.Web.UI.RadPivotGrid",a.RadWebControl);
a.PivotGridCellType=function(){};
a.PivotGridCellType.prototype={DataCell:1,RowHeaderCell:2,ColumHeaderCell:4};
a.PivotGridCellType.registerEnum("Telerik.Web.UI.PivotGridCellType",false);
a.PivotGridFieldZoneType=function(){};
a.PivotGridFieldZoneType.prototype={Filter:1,Aggregate:2,Column:4,Row:8};
a.PivotGridFieldZoneType.registerEnum("Telerik.Web.UI.PivotGridFieldZoneType",false);
a.PivotGridAggregate=function(){};
a.PivotGridAggregate.prototype={Sum:0,Count:1,Average:2,Max:3,Min:4,Product:5,StdDev:6,StdDevP:7,Var:8,VarP:9};
a.PivotGridAggregate.registerEnum("Telerik.Web.UI.PivotGridAggregate",false);
})(Telerik.Web.UI,undefined);
if(typeof(Sys)!=='undefined')Sys.Application.notifyScriptLoaded();