Type.registerNamespace("Telerik.Web.UI.Scheduler.Views.Timeline");
(function(a,b,c,d){var i=60000,h=i*60,g=h*24,e=3,f=1;
d.ModelBase=function(j){this._owner=j;
this._settings=this._owner.get_timelineViewSettings()||{};
this._defaultHeaderDateFormat="d";
this._contentTable=null;
};
d.ModelBase.prototype={get_visibleRangeStart:function(){return b.add(this._owner.get_selectedDate(),this._getStartTime());
},get_visibleRangeEnd:function(){var j=new b(this.get_visibleRangeStart());
return j.add(this._getTimeViewDuration()).toDate();
},get_headerDateFormat:function(){if(!this._settings){return this._defaultHeaderDateFormat;
}return this._settings.headerDateFormat||this._defaultHeaderDateFormat;
},get_columnHeaderDateFormat:function(){return this._settings.columnHeaderDateFormat||"d";
},get_nextPeriodDate:function(){return b.add(this._owner.get_selectedDate(),this._getTimeViewDuration().get_ticks());
},get_previousPeriodDate:function(){return b.add(this._owner.get_selectedDate(),-this._getTimeViewDuration().get_ticks());
},get_isAllDayAppointment:function(j){return((b.getTimeOfDay(j.get_start())==0)&&(j._isAllDay()));
},get_startOfMovedAppointment:function(j,m,l){var k=b.subtract(j.get_start(),l.get_startTime());
return b.add(m.get_startTime(),k);
},getDurationOfMovedAppointment:function(j){return b.subtract(j.get_end(),j.get_start());
},_getContentTable:function(){if(!this._contentTable){this._contentTable=a("div.rsTopWrap table.rsAllDayTable",this._owner.get_element())[0];
}return this._contentTable;
},_getSourceCellOffsetOfMovedAppointment:function(k,l){var j=Math.floor(parseInt(k.style.left,10)/100)||0;
return l.cellIndex-j;
},_getSourceRowOffsetOfMovedAppointment:function(j,k){return 0;
},updateDraggingAppointmentSize:function(j,q,l){var p=this._owner,r=q.parentNode,m=r.cells[r.cells.length-1],n=m.offsetLeft+m.offsetWidth,o=Math.min(n-q.offsetLeft-j.offsetLeft,p._draggingAppointmentWidth),k=Math.max(0,p._draggingSourceCellOffset-l.cellIndex);
if(k>0){o-=k*q.offsetWidth;
}j.style.width=o+"px";
},updateResizingAppointmentSize:function(v,u){var k=u.resizingElement,s=k.parentNode.parentNode,p=v.offsetLeft+v.offsetWidth,l=k.offsetLeft,t=u.resizeFromStart,w,n=0,j=a(v);
while(!j.hasClass("rsFirstCell")){j=j.prev();
n++;
}if(s!=j.get(0)){return;
}if(t){var o=j.get(0).offsetLeft,m=l+k.offsetWidth+o,q=k.style.left,r=k.style.marginLeft;
k.style.left=n+"00%";
k.style.marginLeft=n+"px";
w=m-k.offsetLeft-o;
if(w<=1){k.style.left=q;
k.style.marginLeft=r;
return;
}}else{w=Math.max(p-s.offsetLeft-l,s.offsetWidth-l);
}if(w<=1){return;
}k.style.width=w+"px";
},_getResizingAppointmentOriginalSize:function(l,k){var j=a(l);
return{width:j.width(),left:j.get(0).style.left,marginLeft:j.get(0).style.marginLeft};
},restoreResizingAppointmentSize:function(o){var m=o.originalSize,n=m.width,k=m.left,l=m.marginLeft;
var j=a(o.resizingElement);
j.width(n);
j.get(0).style.left=k;
j.get(0).style.marginLeft=l;
},_getMaxAppointmentGrowth:function(){return this._getNumberOfSlots();
},_getNumberOfSlots:function(){return this._settings.numberOfSlots||e;
},_getTimeLabelSpan:function(){return this._settings.timeLabelSpan||f;
},_getSlotDuration:function(){return this._settings.slotDuration||g;
},_getStartTime:function(){return this._settings.startTime||0;
},isVisible:function(j){return j._isInRange(this.get_visibleRangeStart(),this.get_visibleRangeEnd());
},_getTimeViewDuration:function(){return new c(this._getNumberOfSlots()*this._getSlotDuration());
},get_supportsSlotSelection:function(){return false;
},get_supportsFullTime:function(){return false;
},_getFirstTimeSlot:function(){var j=this._getContentTable().rows[0].cells[0];
return this.getTimeSlotFromDomElement(j);
},_getResizingPlaneDelta:function(){return 0;
}};
d.ModelBase.registerClass("Telerik.Web.UI.Scheduler.Views.Timeline.ModelBase",null,Telerik.Web.UI.ISchedulerModel);
d.Model=function(j){d.Model.initializeBase(this,[j]);
this._slotDurationInMinutes=this._getSlotDuration()/i;
if(Telerik.Web.UI.Scheduler.Rendering.HorizontalBlockCollection){this._allDayBlocks=new Telerik.Web.UI.Scheduler.Rendering.HorizontalBlockCollection();
}};
d.Model.prototype={initialize:function(){},addToBlocks:function(j){this._allDayBlocks.add(j);
},removeFromBlock:function(j){this._allDayBlocks.remove(j);
},resetBlocks:function(){if(Telerik.Web.UI.Scheduler.Rendering.HorizontalBlockCollection){this._allDayBlocks=new Telerik.Web.UI.Scheduler.Rendering.HorizontalBlockCollection();
}},getTimeSlotFromDomElement:function(j){var k=this._getRawIndexFromDomElement(j),l=this._getTimeFromIndex(k);
return new d.TimeSlot(k,l,this._slotDurationInMinutes,j);
},_getTimeFromDomElement:function(j){var k=this._getRawIndexFromDomElement(j);
return this._getTimeFromIndex(k);
},_getTimeFromIndex:function(k){var j=this.get_visibleRangeStart();
Telerik.Web.UI.RadScheduler._incrementTime(j,0,this._slotDurationInMinutes*k.intervalIndex);
return j;
},_getRawIndexFromDomElement:function(j){while(j&&(j.tagName.toUpperCase()!="TD")){j=j.parentNode;
}if(j){return{intervalIndex:j.cellIndex};
}return null;
},_getRawIndexFromStartTime:function(k){var j=b.subtract(new Date(k),this.get_visibleRangeStart());
return{intervalIndex:Math.max(0,Math.floor(j/this._getSlotDuration()))};
},_getAllDayTimeSlotForAppointmentPart:function(j){return this._getTimeSlotFromStartTime(j.start);
},_getTimeSlotFromStartTime:function(l){var k=this._getRawIndexFromStartTime(l),j=this._getDomElementFromRawIndex(k.intervalIndex);
return this.getTimeSlotFromDomElement(j);
},getTimeSlotForAppointment:function(j){return this._getTimeSlotFromStartTime(j.get_start());
},_getDomElementFromRawIndex:function(j){return a(".rsTimelineView .rsAllDayRow",this._owner.get_element()).children()[j];
},_getRenderer:function(){if(!this._renderer){this._renderer=new Telerik.Web.UI.Scheduler.Rendering.TimelineViewRenderer(this);
}return this._renderer;
}};
d.Model.registerClass("Telerik.Web.UI.Scheduler.Views.Timeline.Model",d.ModelBase);
d.TimeSlot=function(l,m,k,j){this._rawIndex=l;
this._startTime=m;
this._durationInMinutes=k;
this._domElement=j;
};
d.TimeSlot.prototype={get_index:function(){var j=this.get_rawIndex();
return String.format("{0}",j.intervalIndex);
},get_rawIndex:function(){return this._rawIndex;
},get_startTime:function(){return this._startTime;
},get_endTime:function(){return b.add(this.get_startTime(),this.get_duration());
},get_duration:function(){return this.get_durationInMinutes()*i;
},get_durationInMinutes:function(){return this._durationInMinutes;
},get_isAllDay:function(){return true;
},get_domElement:function(){return this._domElement;
}};
d.TimeSlot.registerClass("Telerik.Web.UI.Scheduler.Views.Timeline.TimeSlot",null,Telerik.Web.UI.ISchedulerTimeSlot);
})($telerik.$,Telerik.Web.UI.Scheduler.DateTime,Telerik.Web.UI.Scheduler.TimeSpan,Telerik.Web.UI.Scheduler.Views.Timeline);
if(typeof(Sys)!=='undefined')Sys.Application.notifyScriptLoaded();