Type.registerNamespace("Telerik.Web.UI");
Type.registerNamespace("Telerik.Web.UI.Scheduler");
(function(g){var a=$telerik.$;
var b=Telerik.Web.UI;
var c=Telerik.Web.UI.Scheduler;
var f=60000;
var e=f*60;
var d=e*24;
c.ResourceGroupedWeekModel=function(j,h,i){c.ResourceGroupedWeekModel.initializeBase(this,[j]);
this._weekModels=[];
this._resources=new b.SchedulerResourceCollection();
this._groupingResource=h;
this._isVertical=i;
if(c.Rendering.BlockCollection){this._blockCollection=new c.Rendering.BlockCollection();
}if(c.Rendering.HorizontalBlockCollection){this._allDayBlocks=new c.Rendering.HorizontalBlockCollection();
}};
c.ResourceGroupedWeekModel.prototype={initialize:function(){this._resources=this._owner.get_resources().getResourcesByType(this._groupingResource);
for(var h=0;
h<this._resources.get_count();
h++){this._weekModels[h]=this._createNestedModel();
}},getTimeSlotFromDomElement:function(h){var j=60*24;
var k=this._getRawIndexFromDomElement(h);
var m=this._getTimeFromDomElement(h);
var l=this._resources.getResource(k.modelIndex);
var i=(k.viewPartIndex==0)?j:this._owner.get_minutesPerRow();
return new c.ResourceGroupedWeekTimeSlot(k,m,i,l,h);
},getTimeSlotForAppointment:function(h){var m=this._getAppointmentModelIndex(h);
if(m==-1){return null;
}var k=h.get_duration()%d==0;
var p=k?0:1;
var j;
if(k){j=this._weekModels[0]._getAllDayTimeSlotIndices(h.get_start());
}else{j=this._weekModels[0]._getRegularTimeSlotIndices(h.get_start());
}j.viewPartIndex=p;
j.modelIndex=m;
var n=this._weekModels[0]._getTimeFromIndex(j);
var l=60*24;
var i=(j.viewPartIndex==0)?l:this._owner.get_minutesPerRow();
var o=this._getTimeSlotDomElement(p,j.rowIndex,j.cellIndex,m);
return new c.ResourceGroupedWeekTimeSlot(j,n,i,this._resources.getResource(m),o);
},isVisible:function(h){var j=c.ResourceGroupedWeekModel.callBaseMethod(this,"isVisible",[h]);
var i=this._getAppointmentModelIndex(h)!=-1;
return j&&i;
},resetBlocks:function(){var k=this._weekModels;
for(var h=0,j=k.length;
h<j;
h++){k[h].resetBlocks();
}},_getAppointmentModelIndex:function(h){var j=-1;
var i=this;
h.get_resources().forEach(function(k){var l=i._resources.getResourceByTypeAndKey(k.get_type(),k.get_key());
if(l){j=Array.indexOf(i._resources._array,l);
}});
return j;
},_getTimeSlotForAppointmentPart:function(h){var j=this._getRegularTimeSlotIndices(h.start);
var i=this._getTimeSlotDomElement(1,j.rowIndex,j.cellIndex,h.modelIndex);
var k=this._resources[h.modelIndex];
var l=this._weekModels[0]._getTimeFromIndex(j);
return this._createTimeSlot(j,l,i,k);
},_createTimeSlot:function(k,m,i,l){var j=60*24;
var h=(k.viewPartIndex==0)?j:this._owner.get_minutesPerRow();
return new c.ResourceGroupedWeekTimeSlot(k,m,h,l,i);
},_getTimeSlotDomElement:function(m,k,h,j){if(j===g){return this._weekModels[0]._getTimeSlotDomElement(m,k,h);
}if(this._isVertical){var l=this._weekModels[0].get_slotsPerDay();
if(m==0){k+=j;
}if(this._owner.get_showAllDayRow()&&m>0){k+=j+1;
}k+=l*j;
var i=this._owner.get_element();
return a("div.rsTopWrap table.rsContentTable",i)[0].tBodies[0].rows[k].cells[h];
}h+=this.get_numberOfDays()*j;
return this._weekModels[0]._getTimeSlotDomElement(m,k,h);
},_getRegularTimeSlotIndices:function(h){return this._weekModels[0]._getRegularTimeSlotIndices(h);
},_getAllDayTimeSlotIndices:function(h){return this._weekModels[0]._getAllDayTimeSlotIndices(h);
},_getMaxAppointmentGrowth:function(h){if(this._isVertical){var i=this.getTimeSlotFromDomElement(h);
if(this._owner._resizingState.resizeFromStart){return i.get_rawIndex().rowIndex;
}return(this.get_slotsPerDay()-i.get_rawIndex().rowIndex-1);
}else{return c.ResourceGroupedWeekModel.callBaseMethod(this,"_getMaxAppointmentGrowth",[h]);
}},_createNestedModel:function(){return new c.WeekModel(this._owner);
},_getRawIndexFromDomElement:function(i){while(i&&(i.tagName.toUpperCase()!="TD")){i=i.parentNode;
}var l=i.parentNode;
var n=l.parentNode;
var k=this._weekModels[0]._getRawIndexFromDomElement(i);
var j;
if(this._isVertical){var m=n.rows.length/this._resources.get_count();
j=Math.floor(k.rowIndex/m);
k.rowIndex=k.rowIndex-(j*m);
if(this._owner.get_showAllDayRow()&&k.viewPartIndex>0){k.rowIndex--;
}k.modelIndex=j;
}else{var h=l.cells.length/this._resources.get_count();
j=Math.floor(k.cellIndex/h);
k.cellIndex=k.cellIndex-(j*h);
k.modelIndex=j;
}return k;
},_getAllDayTimeSlotForAppointmentPart:function(h){var j=this._getAllDayTimeSlotIndices(h.start);
j.viewPartIndex=0;
var i=this._getTimeSlotDomElement(j.viewPartIndex,j.rowIndex,j.cellIndex,h.modelIndex);
var k=this._resources[h.modelIndex];
return this._createTimeSlot(j,h.start,i,k);
},_getAllDayTimeSlotFromStartTime:function(n,h){var l=this._getAllDayTimeSlotIndices(n);
l.viewPartIndex=0;
var k=this._getAppointmentModelIndex(h);
var i=this._getTimeSlotDomElement(l.viewPartIndex,l.rowIndex,l.cellIndex,k);
var m=null;
var j=this;
h.get_resources().forEach(function(o){if(!m){m=j._resources.getResourceByTypeAndKey(o.get_type(),o.get_key());
}});
return this._createTimeSlot(l,n,i,m);
},_getTimeFromDomElement:function(h){var i=this._getRawIndexFromDomElement(h);
return this._weekModels[0]._getTimeFromIndex(i);
},removeFromBlock:function(h){this._weekModels[h.modelIndex].removeFromBlock(h);
},addToBlocks:function(h){this._weekModels[h.modelIndex].addToBlocks(h);
},_getRenderer:function(){if(!this._renderer){this._renderer=new c.Rendering.ResourceGroupedWeekViewRenderer(this);
}return this._renderer;
},get_supportsSlotSelection:function(){return true;
},_areTimeSlotsInAscendingOrder:function(h,j){if(!(h&&j)){return null;
}var i=h.get_rawIndex();
var k=j.get_rawIndex();
return !((k.cellIndex<i.cellIndex)||(k.cellIndex==i.cellIndex&&k.rowIndex<i.rowIndex));
},getTimeSlotsBetween:function(h,i){if(!(h&&i)){return[];
}if(h.get_rawIndex().modelIndex!=i.get_rawIndex().modelIndex){return[];
}return c.ResourceGroupedWeekModel.callBaseMethod(this,"getTimeSlotsBetween",[h,i]);
},_getResizingPlaneDelta:function(k,h){var l=a(k).index(),i=a(h).index(),j=this.get_numberOfDays();
if(parseInt(l/j,10)==parseInt(i/j,10)){return l-i;
}return 0;
},_getFirstModelRowIndex:function(h){if(this._isVertical){return this.getTimeSlotFromDomElement(h).get_rawIndex().modelIndex;
}return 0;
},_getNextTimeSlot:function(m){var j=this.get_slotsPerDay()-1,i=this.get_numberOfDays()-1,h=m.get_rawIndex(),k={},n,l;
if(h.viewPartIndex==0){j=0;
}if(h.rowIndex==j){if(h.cellIndex==i){return null;
}k.rowIndex=0;
k.cellIndex=h.cellIndex+1;
}else{k.rowIndex=h.rowIndex+1;
k.cellIndex=h.cellIndex;
}k.modelIndex=h.modelIndex;
k.viewPartIndex=h.viewPartIndex;
n=this._getTimeSlotDomElement(k.viewPartIndex,k.rowIndex,k.cellIndex,h.modelIndex);
l=this._weekModels[0]._getTimeFromIndex(k);
return this._createTimeSlot(k,l,n);
}};
c.ResourceGroupedWeekModel.registerClass("Telerik.Web.UI.Scheduler.ResourceGroupedWeekModel",c.WeekModelBase);
c.ResourceGroupedWeekTimeSlot=function(j,l,i,k,h){this._resource=k;
c.ResourceGroupedWeekTimeSlot.initializeBase(this,[j,l,i,h]);
};
c.ResourceGroupedWeekTimeSlot.prototype={get_index:function(){var h=this.get_rawIndex();
var i=c.ResourceGroupedWeekTimeSlot.callBaseMethod(this,"get_index");
return String.format("{0}:{1}",h.modelIndex,i);
},get_resource:function(){return this._resource;
}};
c.ResourceGroupedWeekTimeSlot.registerClass("Telerik.Web.UI.Scheduler.ResourceGroupedWeekTimeSlot",c.WeekTimeSlot);
})();
if(typeof(Sys)!=='undefined')Sys.Application.notifyScriptLoaded();