(function(a,c){Type.registerNamespace("Telerik.Web.UI");
var b=Telerik.Web.UI;
a.registerEnum(b,"TileBadgeType",{None:0,Activity:1,Alert:2,Attention:3,Available:4,Away:5,Busy:6,Error:7,NewMessage:8,Paused:9,Playing:10,Unavailable:11});
a.registerEnum(b,"TileShape",{Square:0,Wide:1});
a.registerEnum(b,"TileCommand",{TileClicked:1});
})($telerik.$);
(function(a,e){Type.registerNamespace("Telerik.Web.UI");
$telerik.toBaseTile=function(f){return f;
};
$telerik.findBaseTile=$find;
var c=Telerik.Web.UI,b=Sys.Serialization.JavaScriptSerializer,d="rtileRtl";
c.RadBaseTile=function(f){c.RadBaseTile.initializeBase(this,[f]);
this._selected=false;
this.$contentWrapper=null;
this.$peekWrapper=null;
this._peekAnimationManager=null;
this._peekShowTimeOut=null;
this._peekHideTimeOut=null;
this._showPeekTemplateOnMouseOver=false;
this._hidePeekTemplateOnMouseOut=false;
this._postBackReference=null;
this._visible=true;
};
c.RadBaseTile.prototype={initialize:function(){var f=this;
c.RadBaseTile.callBaseMethod(this,"initialize");
f.raiseEvent("init",Sys.EventArgs.Empty);
f._setRightToLeft();
f._attachEvents(true);
f._initializePeekTemplate();
f._initializeTileDragAndDrop();
f.updateClientState();
f._initialized=true;
f.raiseEvent("load",Sys.EventArgs.Empty);
},_setRightToLeft:function(){var g=this,f=g.get_element();
if($telerik.isRightToLeft(f)){g._isRightToLeft=true;
a(f).addClass(d);
}},_attachEvents:function(h){var g=this,f=this.get_element();
if(null===f){return;
}if(h!==false){g._onTileContextMenuDelegate=Function.createDelegate(this,this._contextMenuHandler);
g._clickDelegate=Function.createDelegate(this,this._mouseClickHandler);
g._mouseOverDelegate=Function.createDelegate(this,this._mouseOver);
g._mouseOutDelegate=Function.createDelegate(this,this._mouseOut);
$telerik.addHandler(f,"contextmenu",this._onTileContextMenuDelegate);
$telerik.addHandler(f,"click",this._clickDelegate);
$telerik.addHandler(f,"mouseover",this._mouseOverDelegate);
$telerik.addHandler(f,"mouseout",this._mouseOutDelegate);
}else{$telerik.removeHandler(f,"contextmenu",this._onTileContextMenuDelegate);
$telerik.removeHandler(f,"click",this._clickDelegate);
$telerik.removeHandler(f,"mouseover",this._mouseOverDelegate);
$telerik.removeHandler(f,"mouseout",this._mouseOutDelegate);
g._onTileContextMenuDelegate=null;
g._clickDelegate=null;
g._mouseOverDelegate=null;
g._mouseOutDelegate=null;
}},_contextMenuHandler:function(f){$telerik.cancelRawEvent(f);
if(!$telerik.isAndroid){this.toggleSelection();
}return false;
},toggleSelection:function(){this.set_selected(!this.get_selected());
},_mouseClickHandler:function(f){var h=this;
if(!h.get_enabled()){return false;
}var g=new c.TileCancelEventArgs(h.get_navigateUrl());
h.raiseEvent("clicking",g);
if(g.get_cancel()!==true){h._onClick(g);
}return true;
},_onClick:function(f){var i=this;
if(i._dragStarted!==true){var h=f.get_value();
if(!i.get_autoPostBack()){i._navigateToUrl(h,i.get_target());
}var g=new c.TileEventArgs(h,i.get_navigateUrl());
i.raiseEvent("clicked",g);
if(g.get_cancel()!==true){i._onClicked(g.get_newValue());
}}else{i._dragStarted=false;
}},_onClicked:function(f){if(this.get_autoPostBack()){this.postback({type:c.TileCommand.TileClicked});
}},_navigateToUrl:function(h,f){if(h){if(f&&f=="_blank"){window.open(h);
}if(f&&f=="_parent"){window.parent.location.href=h;
}if(f&&f=="_top"){window.top.location.href=h;
}else{if(!f||f=="_self"){window.location.href=h;
}else{var g=a("iframe[name='"+f+"']").get(0)||a("frame[name='"+f+"']").get(0)||a("#"+f).get(0);
if(g&&g.tagName.toLowerCase().indexOf("frame")>-1){g.setAttribute("src",h);
}}}}},_mouseOver:function(f){var g=this.get_element();
if(g&&this.get_enabled()){$telerik.addCssClasses(g,["rtileHovered"]);
}},_mouseOut:function(f){var g=this.get_element();
if(g){$telerik.removeCssClasses(g,["rtileHovered"]);
}},_initializePeekTemplate:function(){var g=this,f=g.get_element();
g.$contentWrapper=a(f).children(".rtileContent");
g.$peekWrapper=a(f).children(".rtilePeekContent");
if(g.$peekWrapper.length>0){g._peekAnimationManager=new c.Tile.PeekAnimationManager(g.$peekWrapper,g.$contentWrapper,g._getAnimationOptions());
g._addPeekTemplateAnimationHandlers();
g._initializeShowHidePeekIntervals();
g._initializePeekMouseHover();
g.startPeekShowInterval();
}},_getAnimationOptions:function(){var f=this.get_peekTemplateSettingsData()||{};
return{animationType:(f.animation===0)?0:f.animation||2,duration:f.animationDuration||500,easing:f.easing||"easeOutExpo"};
},_addPeekTemplateAnimationHandlers:function(){var f=this;
f._peekShowAnimationStartHandler=Function.createDelegate(f,f._onPeekShowAnimationStart);
f._peekShowAnimationEndHandler=Function.createDelegate(f,f._onPeekShowAnimationEnd);
f._peekHideAnimationStartHandler=Function.createDelegate(f,f._onPeekHideAnimationStart);
f._peekHideAnimationEndHandler=Function.createDelegate(f,f._onPeekHideAnimationEnd);
f._peekAnimationManager.add_showAnimationStart(f._peekShowAnimationStartHandler);
f._peekAnimationManager.add_showAnimationEnd(f._peekShowAnimationEndHandler);
f._peekAnimationManager.add_hideAnimationStart(f._peekHideAnimationStartHandler);
f._peekAnimationManager.add_hideAnimationEnd(f._peekHideAnimationEndHandler);
},_initializeShowHidePeekIntervals:function(){var i=this,g=i.get_peekTemplateSettingsData(),h=parseInt(g.showInterval,10),f=parseInt(g.closeDelay,10);
i.set_peekShowInterval(0==h?0:h||10000);
i.set_peekCloseDelay(0===f?0:f||7000);
},_initializePeekMouseHover:function(){var g=this,f=g.get_peekTemplateSettingsData();
g.set_showPeekTemplateOnMouseOver(f.showPeekTemplateOnMouseOver||false);
g.set_hidePeekTemplateOnMouseOut(f.hidePeekTemplateOnMouseOut||false);
},startPeekShowInterval:function(){var g=this,f=this.get_peekShowInterval();
if(f>0&&!this._peekTemplateIsVisible){this._peekShowTimeOut=window.setTimeout(function(){g.showPeekTemplate();
},f);
}},clearPeekShowInterval:function(){clearTimeout(this._peekShowTimeOut);
this._peekShowTimeOut=null;
},startPeekHideInterval:function(){var g=this,f=g.get_peekCloseDelay();
if(f>0){g._peekHideTimeOut=window.setTimeout(function(){g.hidePeekTemplate();
},f);
}},clearPeekHideInterval:function(){clearTimeout(this._peekHideTimeOut);
this._peekHideTimeOut=null;
},clearShowHideIntervals:function(){this.clearPeekShowInterval();
this.clearPeekHideInterval();
},showPeekTemplate:function(){this.get_peekAnimationManager().show();
},hidePeekTemplate:function(){this.get_peekAnimationManager().hide();
},_onPeekShowAnimationStart:function(){this._peekTemplateIsVisible=true;
this.clearShowHideIntervals();
},_onPeekShowAnimationEnd:function(){var f=this;
if(!f._mouseEntered||!f.get_hidePeekTemplateOnMouseOut()){f.startPeekHideInterval();
}},_onPeekHideAnimationStart:function(){this._peekTemplateIsVisible=false;
this.clearShowHideIntervals();
},_onPeekHideAnimationEnd:function(){this.startPeekShowInterval();
},get_showPeekTemplateOnMouseOver:function(){return this._showPeekTemplateOnMouseOver;
},set_showPeekTemplateOnMouseOver:function(g){var f=this;
f._showPeekTemplateOnMouseOver=g;
if(g){f._attachPeekMouseOverHandler();
}else{f._detachPeekMouseOverHandler();
}},_attachPeekMouseOverHandler:function(){var f=this;
f._mouseOverPeekHandler=Function.createDelegate(f,f._onMouseOverPeekHandler);
a(f.get_element()).on("mouseenter",f._mouseOverPeekHandler);
},_detachPeekMouseOverHandler:function(){var f=this;
if(f._mouseOverPeekHandler){a(f.get_element()).off("mouseenter",f._mouseOverPeekHandler);
f._mouseOverPeekHandler=null;
}},_onMouseOverPeekHandler:function(f){var g=this;
g._mouseEntered=true;
g.clearShowHideIntervals();
if(!g.get_hidePeekTemplateOnMouseOut()){g.startPeekHideInterval();
}if(!g._peekTemplateIsVisible){g.showPeekTemplate();
}},get_hidePeekTemplateOnMouseOut:function(){return this._hidePeekTemplateOnMouseOut;
},set_hidePeekTemplateOnMouseOut:function(g){var f=this;
f._hidePeekTemplateOnMouseOut=g;
if(g){f._attachPeekMouseOutHandler();
}else{f._detachPeekMouseOutHandler();
}},_attachPeekMouseOutHandler:function(){var f=this;
f._mouseOutPeekHandler=Function.createDelegate(f,f._onMouseOutPeekHandler);
a(f.get_element()).on("mouseleave",f._mouseOutPeekHandler);
},_onMouseOutPeekHandler:function(f){this._mouseEntered=false;
this.hidePeekTemplate();
},_detachPeekMouseOutHandler:function(){var f=this;
if(f._mouseOutPeekHandler){a(f.get_element()).off("mouseleave",f._mouseOutPeekHandler);
f._mouseOutPeekHandler=null;
}},_initializeTileDragAndDrop:function(){var f=this;
f._removeDraggableWidget();
if(f.get_enableSelection()){f._initializeDraggableWidget();
}},_initializeDraggableWidget:function(){var j=this,f=j.get_element(),g=a(f).offset(),h=g.left,i=g.top;
j._cssStartingCssText=f.style.cssText;
j._removeDraggableWidget();
j._draggableWidget=new c.Widgets.Draggable(f,{shouldPreventDefault:false,enableDelay:true,cursorType:"default",constraints:{minX:h,maxX:h+parseInt(f.clientWidth,10),minY:i-45,maxY:i+195}});
j._attachDraggableEvents();
},_attachDraggableEvents:function(){var f=this;
f._dragStartingDelegate=Function.createDelegate(f,f._onDragStarting);
f._dragStartDelegate=Function.createDelegate(f,f._onDragStart);
f._draggingDelegate=Function.createDelegate(f,f._onDragging);
f._dragEndtDelegate=Function.createDelegate(f,f._onDragEnd);
var g=f._draggableWidget;
if(g){g.add_dragStart(f._dragStartingDelegate);
g.add_dragStart(f._dragStartDelegate);
g.add_dragging(f._draggingDelegate);
g.add_dragEnd(f._dragEndtDelegate);
}},_onDragStarting:function(g,f){var h=this;
if(!g._isTouchEvent(f._domEvent)){f.set_cancel(true);
return false;
}h._dragStarted=false;
h._setIntentionSelectionUI(true);
},_onDragStart:function(g,f){var i=this;
if(!g._isTouchEvent(f._domEvent)&&!$telerik.isAndroid){f.set_cancel(true);
return false;
}else{i._dragStarted=true;
var h=g._element;
h.style.zIndex=999999;
i._preventDefaultDelegate=function(j){$telerik.cancelRawEvent(j);
};
a(h).on($telerik.getMobileEventCounterpart("mousedown"),i._preventDefaultDelegate);
}},_onDragging:function(g,f){if(!g._isTouchEvent(f._domEvent)&&!$telerik.isAndroid){f.set_cancel(true);
return false;
}$telerik.cancelRawEvent(f._domEvent);
this._setIntentionSelectionUI(Math.abs(f._delta.y)<40);
},_onDragEnd:function(g,f){if(!g._isTouchEvent(f._domEvent)&&!$telerik.isAndroid){f.set_cancel(true);
return false;
}var j=this,h=j.get_element(),i=a(h).hasClass("rtileSelectIntention");
a(g._element).off($telerik.getMobileEventCounterpart("mousedown"),j._preventDefaultDelegate);
h.style.cssText=j._cssStartingCssText;
j._setIntentionSelectionUI(false);
if(j._dragStarted){j.set_selected(i);
}else{j._setSelectionUI(j.get_selected());
}j.clearDragStarted();
},_removeDraggableWidget:function(f){var g=this._draggableWidget;
if(g){this._removeDraggableEvents();
g.dispose();
g=null;
}},_removeDraggableEvents:function(){var f=this,g=f._draggableWidget;
if(g){g.remove_dragStart(f._dragStartingDelegate);
g.remove_dragStart(f._dragStartDelegate);
g.remove_dragging(f._draggingDelegate);
g.remove_dragEnd(f._dragEndtDelegate);
}},set_dragStarted:function(f){this._dragStarted=f;
},clearDragStarted:function(){var f=this;
window.setTimeout(function(){f._dragStarted=false;
},100);
},setTitleText:function(g){var h=this,f=h.get_element(),i=h.get_titleData()||{};
i.text=g||"";
h.set_titleData(i);
a(f).children(".rtileTitle").remove();
a('<h6 class="rtileTitle">'+g+"</h6>").appendTo(f);
},setTitleImageUrl:function(g){var h=this,f=h.get_element(),i=h.get_titleData()||{};
i.imageUrl=g;
h.set_titleData(i);
a(f).children(".rtileTitle").remove();
a('<img alt="" class="rtileTitle" />').attr("src",g).appendTo(f);
},setBadgeValue:function(i){var h=this,g=h.get_element(),f=h.get_badgeData()||{};
f.value=i;
h.set_badgeData(f);
a(g).children(".rtileBadge").remove();
a('<div class="rtileBadge">'+i+"</div>").appendTo(g);
},setBadgeImageUrl:function(h){var i=this,g=i.get_element(),f=i.get_badgeData()||{};
f.imageUrl=h;
i.set_badgeData(f);
a(g).children(".rtileBadge").remove();
a('<img alt="" class="rtileBadge" />').attr("src",h).appendTo(g);
},setBadgePredefinedType:function(i){var l=this,g=l.get_element(),f=l.get_badgeData()||{},k,j;
if(i!=e){for(var h in c.TileBadgeType){if(i===c.TileBadgeType[h]||h===i){k=c.TileBadgeType[h];
j="rtile"+h+"Badge";
break;
}}}f.predefinedType=k;
l.set_badgeData(f);
a(g).children(".rtileBadge").remove();
if(j){a('<div  class="rtileBadge rtileBadgeIcon '+j+'" > </div>').appendTo(g);
}},saveClientState:function(){var f='{"selected":'+this.get_selected()+(!this._visible?',"visible": false':"")+"}";
return f;
},dispose:function(){var f=this;
f._attachEvents(false);
f._detachPeekMouseOverHandler();
f._detachPeekMouseOutHandler();
f._disposePeekTemplate();
c.RadBaseTile.callBaseMethod(f,"dispose");
},_disposePeekTemplate:function(){if(this._peekAnimationManager){this._peekAnimationManager.dispose();
}},_clearDomHandlers:function(){$telerik.clearHandlers(this.get_element());
},_setSelectionUI:function(g){var f=this.get_element();
if(g){a(f).addClass("rtileSelected");
if(a(".rtileSelectedIcon",f).length===0){a(f).prepend(a('<div class="rtileSelectedIcon"> </div>'));
}else{a(".rtileSelectedIcon",f).css("display","");
}}else{a(f).removeClass("rtileSelected");
a(".rtileSelectedIcon",f).css("display","none");
}},_setIntentionSelectionUI:function(f){var g=this;
g._setSelectionUI(f);
if(f){a(g.get_element()).addClass("rtileSelectIntention");
}else{a(g.get_element()).removeClass("rtileSelectIntention");
}},get_peekAnimationManager:function(){return this._peekAnimationManager;
},get_selected:function(){return(!this.get_enableSelection())?false:this._selected;
},set_selected:function(h,f){var g=this;
if(!g._initialized){g._selected=h;
}else{g._setSelected(h,f);
}},_setSelected:function(h,f){var g=this;
if(g.get_enabled()&&g.get_enableSelection()){if(f===false){g._selected=h;
g._setSelectionUI(h);
g.updateClientState();
}else{g._riseSelecting(h);
}}},_riseSelecting:function(g){var f=new c.TileCancelEventArgs(g);
this.raiseEvent("selecting",f);
if(f.get_cancel()!==true){this._onSelecting(f);
}},_onSelecting:function(f){var h=this,g=h._selected,i=f.get_value();
h.set_selected(i,false);
h._riseSelected(i,g);
},_riseSelected:function(g,h){var f=new c.TileEventArgs(g,h);
this.raiseEvent("selected",f);
if(f.get_cancel()!==true){this._onSelected(g,h);
}},_onSelected:function(h,f){var g=this;
if(g._initialized&&g.get_autoPostBack()&&h!=f){g.postback();
}},set_visible:function(f){this._visible=f;
c.RadBaseTile.callBaseMethod(this,"set_visible",[f]);
this.updateClientState();
},get_enabled:function(){return this.get_element().getAttribute("disabled")!="disabled";
},postback:function(f){var g=this;
window.setTimeout(function(){g.updateClientState();
eval(g._postBackReference.replace("arguments",b.serialize(f)));
g._postedBack=true;
},50);
}};
a.registerControlProperties(c.RadBaseTile,{originalGroupIndex:null,originalGroupId:null,originalAllTilesIndex:null,groupIndex:null,shape:c.TileShape.Square,autoPostBack:false,enableSelection:false,badgeData:null,titleData:null,tileType:"",navigateUrl:"",target:"",name:"",peekTemplateSettingsData:{},peekShowInterval:10000,peekCloseDelay:7000});
a.registerControlEvents(c.RadBaseTile,["load","init","selecting","selected","clicking","clicked"]);
c.RadBaseTile.registerClass("Telerik.Web.UI.RadBaseTile",c.RadWebControl);
c.TileCancelEventArgs=function(f){c.TileCancelEventArgs.initializeBase(this);
this._value=f;
};
c.TileCancelEventArgs.prototype={get_value:function(){return this._value;
},set_value:function(f){this._value=f;
}};
c.TileCancelEventArgs.registerClass("Telerik.Web.UI.TileCancelEventArgs",Sys.CancelEventArgs);
c.TileEventArgs=function(f,g){c.TileEventArgs.initializeBase(this);
this._newValue=f;
this._oldValue=g;
};
c.TileEventArgs.prototype={get_oldValue:function(){return this._oldValue;
},get_newValue:function(){return this._newValue;
}};
c.TileEventArgs.registerClass("Telerik.Web.UI.TileEventArgs",Sys.CancelEventArgs);
})($telerik.$);
(function(a,c){Type.registerNamespace("Telerik.Web.UI");
$telerik.toTextTile=function(d){return d;
};
$telerik.findTextTile=$find;
var b=Telerik.Web.UI;
b.RadTextTile=function(d){b.RadTextTile.initializeBase(this,[d]);
this._text="";
};
b.RadTextTile.prototype={initialize:function(){b.RadTextTile.callBaseMethod(this,"initialize");
},dispose:function(){b.RadTextTile.callBaseMethod(this,"dispose");
},get_text:function(){return this._text;
},set_text:function(d){this._text=d;
this.setTextUI();
},setTextUI:function(){var d=this._text,e=a(".rtileTopContent",this.get_element());
if(e.text()!=d){e.text(d);
}}};
b.RadTextTile.registerClass("Telerik.Web.UI.RadTextTile",b.RadBaseTile);
})($telerik.$);
(function(a,c){Type.registerNamespace("Telerik.Web.UI");
$telerik.toImageTile=function(d){return d;
};
$telerik.findImageTile=$find;
var b=Telerik.Web.UI;
b.RadImageTile=function(d){b.RadImageTile.initializeBase(this,[d]);
this._imageUrl="";
};
b.RadImageTile.prototype={initialize:function(){b.RadImageTile.callBaseMethod(this,"initialize");
},dispose:function(){b.RadImageTile.callBaseMethod(this,"dispose");
},get_imageUrl:function(){return this._imageUrl;
},set_imageUrl:function(d){this._imageUrl=d;
this.setImageUrl();
},setImageUrl:function(){var f=this._imageUrl,e=this.get_element(),d=a(".rtileIconImage",e);
if(d.length==0&&f){a('<img  class="rtileIconImage" alt="" src="'+f+'" />').appendTo(a(".rtileContent:first",e).get(0));
}else{if(d.attr("src")!=f){d.attr("src",f);
}}}};
b.RadImageTile.registerClass("Telerik.Web.UI.RadImageTile",b.RadBaseTile);
})($telerik.$);
(function(a,c){Type.registerNamespace("Telerik.Web.UI");
$telerik.toIconTile=function(d){return d;
};
$telerik.findIconTile=$find;
var b=Telerik.Web.UI;
b.RadIconTile=function(d){b.RadIconTile.initializeBase(this,[d]);
this._imageUrl="";
};
b.RadIconTile.prototype={initialize:function(){b.RadIconTile.callBaseMethod(this,"initialize");
},setImageUrl:function(){var f=this._imageUrl,e=this.get_element(),d=a(".rtileIconImage",e);
if(d.length==0&&f){a('<img  class="rtileIconImage" alt="" src="'+f+'" />').appendTo(a(".rtileTopContent:first",e).get(0));
}else{if(d.attr("src")!=f){d.attr("src",f);
}}},dispose:function(){b.RadIconTile.callBaseMethod(this,"dispose");
}};
b.RadIconTile.registerClass("Telerik.Web.UI.RadIconTile",b.RadImageTile);
})($telerik.$);
(function(a,c){Type.registerNamespace("Telerik.Web.UI");
$telerik.toImageAndTextTile=function(d){return d;
};
$telerik.findImageAndTextTile=$find;
var b=Telerik.Web.UI;
b.RadImageAndTextTile=function(d){b.RadImageAndTextTile.initializeBase(this,[d]);
this._imageUrl="";
this._text="";
};
b.RadImageAndTextTile.prototype={initialize:function(){b.RadImageAndTextTile.callBaseMethod(this,"initialize");
},dispose:function(){b.RadImageAndTextTile.callBaseMethod(this,"dispose");
},get_imageUrl:function(){return this._imageUrl;
},set_imageUrl:function(d){this._imageUrl=d;
this.setImageUrl();
},setImageUrl:function(){var f=this._imageUrl,e=this.get_element(),d=a(".rtileContentImage",e);
if(d.length==0&&f){a('<img  class="rtileContentImage" alt="" src="'+f+'" />').appendTo(a(".rtileTopContent:first",e).get(0));
}else{if(d.attr("src")!=f){d.attr("src",f);
}}},get_text:function(){return this._text;
},set_text:function(d){this._text=d;
this.setTextUI();
},setTextUI:function(){var d=this._text,e=a(".rtileBottomContent",this.get_element());
if(e.text()!=d){e.text(d);
}}};
b.RadImageAndTextTile.registerClass("Telerik.Web.UI.RadImageAndTextTile",b.RadBaseTile);
})($telerik.$);
(function(a,c){Type.registerNamespace("Telerik.Web.UI");
$telerik.toContentTemplateTile=function(d){return d;
};
$telerik.findContentTemplateTile=$find;
var b=Telerik.Web.UI;
b.RadContentTemplateTile=function(d){b.RadContentTemplateTile.initializeBase(this,[d]);
};
b.RadContentTemplateTile.prototype={initialize:function(){b.RadContentTemplateTile.callBaseMethod(this,"initialize");
},dispose:function(){b.RadContentTemplateTile.callBaseMethod(this,"dispose");
}};
b.RadContentTemplateTile.registerClass("Telerik.Web.UI.RadContentTemplateTile",b.RadBaseTile);
})($telerik.$);
(function(a,l){Type.registerNamespace("Telerik.Web.UI.Tile");
$telerik.toLiveTile=function(m){return m;
};
$telerik.findLiveTile=$find;
var b=Telerik.Web.UI,g=".",c="rtileClientTemplateContainer",e=500,f="easeOutExpo",k="templateDataBound",i="dataLoading",h="dataLoaded",j="dataLoadingError";
b.RadLiveTile=function(m){b.RadLiveTile.initializeBase(this,[m]);
this._webServiceSettings=new b.WebServiceSettings({});
this._clientTemplate="";
this._animationManager=null;
};
b.RadLiveTile.prototype={initialize:function(){var m=this;
b.RadLiveTile.callBaseMethod(m,"initialize");
m._showLoadingSign(true);
if(m.get_odataClientSettings()){m._initializeODataSourceBinder();
}m._execWebServiceCall();
m._initializeUpdateInterval();
},_showLoadingSign:function(n){var m=this.get_element();
if(n===true){Sys.UI.DomElement.addCssClass(m,"rtileLoading");
}else{Sys.UI.DomElement.removeCssClass(m,"rtileLoading");
}},_initializeUpdateInterval:function(){var m=this,n=m.get_updateInterval();
if(n>0){window.setInterval(a.proxy(m._execWebServiceCall,m),n);
}},get_clientTemplate:function(){return this._clientTemplate;
},set_clientTemplate:function(m){this._clearTemplateCache(m);
this._clientTemplate=m;
},_clearTemplateCache:function(m){if(this._templateCache&&this._templateCache[m]){this._templateCache[m]=null;
}},_renderTemplate:function(m){var p=this._getTemplateFunction(),o=this._dataBindClientTemplate(p,m),n=this._riseTemplateDataBoundEvent(m,p,o);
return n.get_html();
},_getTemplateFunction:function(){var o=this.get_clientTemplate(),p;
if(!o){return null;
}if(!this._templateCache){this._templateCache={};
}var m=this._templateCache[o];
if(m){return m;
}try{p=b.Template.compile(o);
}catch(n){throw Error.invalidOperation(String.format("Error creating template: {0}",n.message));
}this._templateCache[o]=p;
return p;
},_dataBindClientTemplate:function(o,m){if(o){try{return o(m||{});
}catch(n){throw Error.invalidOperation(String.format("Error rendering template: {0}",n.message));
}}return"";
},_riseTemplateDataBoundEvent:function(m,p,o){var n=new b.RadTemplateBoundEventArgs(m,p,o);
this.raiseEvent(k,n);
return n;
},_execWebServiceCall:function(){var q=this,r=q.get_webServiceLoader(),n=q.get_odataClientSettings(),p;
if(n!=null){q._requestODataSourceData();
}else{p={Value:q.get_value()};
var m=new b.LiveTileCancelEventArgs(p||null);
q.raiseEvent(i,m);
if(m.get_cancel()){return;
}var o={context:m.get_value()};
if(q.get_webServiceSettings().get_isWcf()){o.context=r._serializeDictionaryAsKeyValuePairs(o.context);
}r.loadData(o);
}},_initializeWebServiceLoader:function(){var m=this;
m._webServiceLoader=new b.WebServiceLoader(m.get_webServiceSettings());
m._webServiceLoader.add_loadingStarted(a.proxy(m._onDataLoadingStarted,m));
m._webServiceLoader.add_loadingSuccess(a.proxy(m._onDataLoadingSuccess,m));
m._webServiceLoader.add_loadingError(a.proxy(m._onDataLoadingError,m));
},_onDataLoadingStarted:function(n,m){},_onDataLoadingSuccess:function(p,o){var q=this,s=q.get_webServiceSettings(),n=o.get_data(),r=s.get_method()+"Result",m;
q._showLoadingSign(false);
if(s.get_isWcf()&&n[r]){n=a.parseJSON(n[r]);
}m=new b.LiveTileDataEventArgs(n);
q.raiseEvent(h,m);
q._loadData(m.get_data());
},_onDataLoadingError:function(o,n){this._showLoadingSign(false);
var m=n.get_message();
this._riseDataRequestError(m);
},_riseDataRequestError:function(n){if(!n){n="No error data available";
}var m=new Telerik.Web.UI.LiveTileErrorEventArgs(n);
this.raiseEvent(j,m);
if(!m.get_cancelErrorAlert()){alert("RadLiveTile data request failed :\n Exception="+n);
}},get_webServiceLoader:function(){var m=this;
if(!m._webServiceLoader){m._initializeWebServiceLoader();
}return m._webServiceLoader;
},get_webServiceSettings:function(){return this._webServiceSettings;
},set_webServiceSettings:function(n){var m=Sys.Serialization.JavaScriptSerializer.deserialize(n);
this._webServiceSettings=new b.WebServiceSettings(m);
},_loadData:function(n){var o=this,m=o.get_animationManager();
m.setContentTemplateHtml(o._renderTemplate(n));
m.animate();
},_initializeODataSourceBinder:function(){var o=this,n=o.get_odataClientSettings().ODataSourceID,m=$find(n);
if(!m){window.setTimeout(function(){m=$find(n);
if(!m){var p=String.format("DataSource with id {0} was not found on the page",n);
alert(p);
}else{o._initializeFlatBinder(m);
o._execWebServiceCall();
}},200);
}else{o._initializeFlatBinder(m);
}},_initializeFlatBinder:function(m){var n=this;
if(m){n._flatBinder=new b.RadODataDataSource.Binder.Flat(m,n);
n._flatBinder.initialize();
}},_disposeODataSourceBinder:function(){if(this._flatBinder){this._flatBinder.dispose();
}},_requestODataSourceData:function(){var n=this,m={events:{requesting:a.proxy(n._onRequestingODataSourceData,n),success:a.proxy(n._onODataSourceDataRequestSuccess,n),fail:a.proxy(n._onODataSourceDataRequestFail,n)}};
if(n._flatBinder){n._flatBinder.fetch(m);
}},_onRequestingODataSourceData:function(m){var n=new b.LiveTileCancelEventArgs(m.get_options().data);
this.raiseEvent(i,n);
m.get_options().data=n.get_value();
},_onODataSourceDataRequestSuccess:function(m){var p=this,n=m[0];
p._showLoadingSign(false);
if(n){var o=new b.LiveTileDataEventArgs(n);
p.raiseEvent(h,o);
p._loadData(o.get_data());
}},_onODataSourceDataRequestFail:function(m){this._showLoadingSign(false);
var n=m.get_message();
this._riseDataRequestError(n);
},get_flatModel:function(){var n=this,m=n.get_odataClientSettings();
n._flatBinder=b.RadODataDataSource.Binder.Flat.Model(m);
n._flatBinder.parse=function(o){return o;
};
return this._flatBinder;
},get_animationManager:function(){var m=this;
if(!m._animationManager){m._animationManager=m._createAnimationManager();
}return m._animationManager;
},_createAnimationManager:function(){var n=this,m;
m=new b.Tile.ClientTemplateAnimationManager(a(g+c+":eq(0)",n._element).get(0),n._getClientTempalteAnimationOptions());
m.add_animationEnd(a.proxy(n._onAnimationEnd,n));
return m;
},_onAnimationEnd:function(){},_getClientTempalteAnimationOptions:function(){var o=this,m=o.get_templateAnimation(),n=b.Tile.PeekTemplateAnimation;
return{animationType:(m===n.None)?n.None:m||n.Fade,duration:o.get_templateAnimationDuration()||e,easing:o.get_templateAnimationEasing()||f};
}};
a.registerControlProperties(b.RadLiveTile,{updateInterval:0,templateAnimation:b.Tile.None,templateAnimationDuration:e,templateAnimationEasing:f,odataClientSettings:null,value:""});
a.registerControlEvents(b.RadLiveTile,[k,i,h,j]);
b.RadLiveTile.registerClass("Telerik.Web.UI.RadLiveTile",b.RadBaseTile);
var d=function(n,m){b[n]=function(){var o=Array.prototype.slice.call(arguments);
b[n].initializeBase(this,o);
};
b[n].registerClass("Telerik.Web.UI."+n,m);
};
b.LiveTileErrorEventArgs=function(m){b.LiveTileErrorEventArgs.initializeBase(this);
this._cancelErrorAlert=false;
this._errorMessage=m;
};
b.LiveTileErrorEventArgs.prototype={get_errorMessage:function(){return this._errorMessage;
},get_cancelErrorAlert:function(){return this._cancelErrorAlert;
},set_cancelErrorAlert:function(m){this._cancelErrorAlert=m;
}};
b.LiveTileErrorEventArgs.registerClass("Telerik.Web.UI.LiveTileErrorEventArgs",Sys.EventArgs);
d("RadLiveTileErrorEventArgs",Telerik.Web.UI.LiveTileErrorEventArgs);
b.LiveTileDataEventArgs=function(m){this._data=m;
};
b.LiveTileDataEventArgs.prototype={get_data:function(){return this._data;
},set_data:function(m){this._data=m;
}};
b.LiveTileDataEventArgs.registerClass("Telerik.Web.UI.LiveTileDataEventArgs",Sys.EventArgs);
d("RadLiveTileDataEventArgs",Telerik.Web.UI.LiveTileDataEventArgs);
b.LiveTileCancelEventArgs=function(m){b.LiveTileCancelEventArgs.initializeBase(this);
this._value=m;
};
b.LiveTileCancelEventArgs.prototype={get_value:function(){return this._value;
},set_value:function(m){this._value=m;
}};
b.LiveTileCancelEventArgs.registerClass("Telerik.Web.UI.LiveTileCancelEventArgs",Sys.CancelEventArgs);
d("RadLiveTileCancelEventArgs",Telerik.Web.UI.LiveTileCancelEventArgs);
})($telerik.$);
(function(a,c){Type.registerNamespace("Telerik.Web.UI.Tile");
var b=Telerik.Web.UI;
b.Tile.IAnimationStrategy=function(d,f,e){};
b.Tile.IAnimationStrategy.prototype={initializeDom:function(){},resetDomInitialization:function(){},show:function(){},hide:function(){}};
b.Tile.IAnimationStrategy.registerInterface("Telerik.Web.UI.Tile.IAnimationStrategy");
})($telerik.$);
(function(a,c){Type.registerNamespace("Telerik.Web.UI.Tile");
var b=Telerik.Web.UI;
b.Tile.IClientTemplateAnimationStrategy=function(d,f,e){};
b.Tile.IClientTemplateAnimationStrategy.prototype={initializeDom:function(){},animate:function(){}};
b.Tile.IClientTemplateAnimationStrategy.registerInterface("Telerik.Web.UI.Tile.IClientTemplateAnimationStrategy");
})($telerik.$);
(function(a,c){Type.registerNamespace("Telerik.Web.UI.Tile");
var b=Telerik.Web.UI;
b.Tile.FadeAnimationStrategy=function(d,e){this.$element=a(d);
this.options=a.extend({duration:500,easing:null},e);
this._showAnimationEndHnadler=e.showAnimationEndHnadler||null;
this._hideAnimationEndHnadler=e.hideAnimationEndHnadler||null;
this.initializeDom();
};
b.Tile.FadeAnimationStrategy.prototype={initializeDom:function(){this.$element.css({display:"none",position:"absolute",top:"0px",left:"0px"});
},resetDomInitialization:function(){this.$element.css({display:"none",position:"",top:"",left:""});
},show:function(){this.$element.stop(true).css("display","none").fadeIn(this.options.duration,this.options.easing,this._showAnimationEndHnadler);
},hide:function(){this.$element.stop(true).fadeOut(this.options.duration,this.options.easing,this._hideAnimationEndHnadler);
}};
b.Tile.FadeAnimationStrategy.registerClass("Telerik.Web.UI.Tile.FadeAnimationStrategy",null,b.Tile.IAnimationStrategy);
})($telerik.$);
(function(a,c){Type.registerNamespace("Telerik.Web.UI.Tile");
var b=Telerik.Web.UI;
b.Tile.NoneAnimationStrategy=function(d,e){this.$element=a(d);
this._showAnimationEndHnadler=e?e.showAnimationEndHnadler:null;
this._hideAnimationEndHnadler=e?e.hideAnimationEndHnadler:null;
this.initializeDom();
};
b.Tile.NoneAnimationStrategy.prototype={initializeDom:function(){this.$element.css({display:"none",position:"absolute",top:"0px",left:"0px"});
},resetDomInitialization:function(){this.$element.css({display:"none",position:"",top:"",left:""});
},show:function(){this.$element.show();
if(typeof this._showAnimationEndHnadler=="function"){this._showAnimationEndHnadler();
}},hide:function(){this.$element.hide();
if(typeof this._hideAnimationEndHnadler=="function"){this._hideAnimationEndHnadler();
}}};
b.Tile.NoneAnimationStrategy.registerClass("Telerik.Web.UI.Tile.NoneAnimationStrategy",null,b.Tile.IAnimationStrategy);
})($telerik.$);
(function(a,c){Type.registerNamespace("Telerik.Web.UI.Tile");
var b=Telerik.Web.UI;
b.Tile.ResizeAnimationStrategy=function(d,e){this.element=d;
this.$element=a(d);
this.options=a.extend({duration:500,easing:"easeOutExpo"},e);
this._showAnimationEndHnadler=e.showAnimationEndHnadler||null;
this._hideAnimationEndHnadler=e.hideAnimationEndHnadler||null;
this.initializeDom();
};
b.Tile.ResizeAnimationStrategy.prototype={initializeDom:function(){this.originalWidth=this.element.style.width;
this.originalHeight=this.element.style.height;
this.originalOverflow=this.element.style.overflow;
this.width=this.$element.css("width");
this.height=this.$element.css("height");
this.$element.css({display:"",position:"absolute",top:"0px",left:"0px",width:"0px",height:"0px",overflow:"hidden"});
},resetDomInitialization:function(){this.$element.css({display:"none",position:"",top:"",left:"",width:this.originalWidth,height:this.originalHeight,overflow:this.originalOverflow});
},show:function(){this.$element.stopTransition(true).transition({width:this.width,height:this.height},this.options.duration,this.options.easing,this._showAnimationEndHnadler);
},hide:function(){this.$element.stopTransition(true).transition({width:"0px",height:"0px"},this.options.duration,this.options.easing,this._hideAnimationEndHnadler);
}};
b.Tile.ResizeAnimationStrategy.registerClass("Telerik.Web.UI.Tile.ResizeAnimationStrategy",null,b.Tile.IAnimationStrategy);
})($telerik.$);
(function(a,c){Type.registerNamespace("Telerik.Web.UI.Tile");
var b=Telerik.Web.UI;
b.Tile.SlideAnimationStrategy=function(d,f,e){this.$element=null;
this.parentNode=d.parentNode;
this.contentElement=d;
this.peekElement=f;
this.options=a.extend({duration:500,easing:"easeOutExpo"},e);
this._showAnimationEndHnadler=e.showAnimationEndHnadler||null;
this._hideAnimationEndHnadler=e.hideAnimationEndHnadler||null;
this.initializeDom();
};
b.Tile.SlideAnimationStrategy.prototype={initializeDom:function(){var d=this.parentNode;
a(d).prepend('<div style="postion: relative;">');
this.$element=a("div",d).first();
this.$element.css({position:"absolute",top:"0px",left:"0px"}).append(this.contentElement).append(this.peekElement);
a(this.contentElement).css({position:"relative",display:"","min-height":a(this.parentNode).css("height"),"min-width":a(this.parentNode).css("width"),overflow:"hidden"});
a(this.peekElement).css({position:"",display:""});
},resetDomInitialization:function(){a(this.contentElement).css({position:"","min-height":"auto","min-width":"auto",display:"",overflow:""});
a(this.peekElement).css({position:"absolute",display:"none"});
a(this.parentNode).prepend(this.contentElement).prepend(this.peekElement);
this.$element.remove();
},show:function(){var d=this;
this.$element.stopTransition(true).transition({top:-d.contentElement.offsetHeight+"px"},d.options.duration,d.options.easing,d._showAnimationEndHnadler);
},hide:function(){var d=this.get_hideTopPostion();
this.$element.stopTransition(true).transition({top:d},this.options.duration,this.options.easing,this._hideAnimationEndHnadler);
},get_hideTopPostion:function(){return(this.options.easing=="easeInBack")?"0.01px":"0px";
}};
b.Tile.SlideAnimationStrategy.registerClass("Telerik.Web.UI.Tile.SlideAnimationStrategy",null,b.Tile.IAnimationStrategy);
})($telerik.$);
(function(a,c){Type.registerNamespace("Telerik.Web.UI.Tile");
var b=Telerik.Web.UI;
b.Tile.ClientTemplateFadeAnimationStrategy=function(d,e){this.$element=a(d);
this.options=a.extend({duration:500,easing:null},e);
this._showAnimationEndHnadler=e.showAnimationEndHnadler||null;
this.initializeDom();
};
b.Tile.ClientTemplateFadeAnimationStrategy.prototype={initializeDom:function(){this.$element.css({display:"none",position:"absolute",top:"0px",left:"0px"});
},animate:function(){this.$element.stop(true).css("display","none").fadeIn(this.options.duration,this.options.easing,this._showAnimationEndHnadler);
}};
b.Tile.ClientTemplateFadeAnimationStrategy.registerClass("Telerik.Web.UI.Tile.ClientTemplateFadeAnimationStrategy",null,b.Tile.IAnimationStrategy);
})($telerik.$);
(function(a,d){Type.registerNamespace("Telerik.Web.UI.Tile");
var b=Telerik.Web.UI,c=b.Tile;
c.ClientTemplateNoneAnimationStrategy=function(e,f){this.$element=a(e);
this._showAnimationEndHnadler=f?f.showAnimationEndHnadler:null;
this.initializeDom();
};
c.ClientTemplateNoneAnimationStrategy.prototype={initializeDom:function(){this.$element.css({display:"none",position:"absolute",top:"0px",left:"0px"});
},animate:function(){this.$element.show();
if(typeof this._showAnimationEndHnadler=="function"){this._showAnimationEndHnadler();
}}};
c.ClientTemplateNoneAnimationStrategy.registerClass("Telerik.Web.UI.Tile.ClientTemplateNoneAnimationStrategy",null,c.IClientTemplateAnimationStrategy);
})($telerik.$);
(function(a,c){Type.registerNamespace("Telerik.Web.UI.Tile");
var b=Telerik.Web.UI;
b.Tile.ClientTemplateResizeAnimationStrategy=function(d,e){var f=this;
f.element=d;
f.$element=a(d);
f.options=a.extend({duration:500,easing:"easeOutExpo"},e);
f._showAnimationEndHnadler=e.showAnimationEndHnadler||null;
};
b.Tile.ClientTemplateResizeAnimationStrategy.prototype={initializeDom:function(){var d=this;
d.width=this.$element.css("width");
d.height=this.$element.css("height");
d.$element.css({display:"",position:"absolute",top:"0px",left:"0px",width:"0px",height:"0px",overflow:"hidden"});
},animate:function(){var d=this;
d.initializeDom();
d.$element.stopTransition(true).transition({width:d.width,height:d.height},d.options.duration,d.options.easing,d._showAnimationEndHnadler);
}};
b.Tile.ClientTemplateResizeAnimationStrategy.registerClass("Telerik.Web.UI.Tile.ClientTemplateResizeAnimationStrategy",null,b.Tile.IAnimationStrategy);
})($telerik.$);
(function(a,c){Type.registerNamespace("Telerik.Web.UI.Tile");
var b=Telerik.Web.UI;
b.Tile.ClientTemplateSlideAnimationStrategy=function(d,f,e){var g=this;
g.$element=null;
g.parentNode=d.parentNode;
g.contentElement=d;
g.peekElement=f;
g.options=a.extend({duration:500,easing:"easeOutExpo"},e);
g._showAnimationEndHnadler=e.showAnimationEndHnadler||null;
};
b.Tile.ClientTemplateSlideAnimationStrategy.prototype={initializeDom:function(){var f=this,e=f.parentNode,d=f.contentElement;
a(e).prepend('<div style="postion: relative;">');
f.$element=a("div",e).first();
f.$element.css({position:"absolute",top:"0px",left:"0px"}).append(d).append(f.peekElement);
a(d).css({position:"relative",display:"","min-height":a(f.parentNode).css("height"),"min-width":a(f.parentNode).css("width"),overflow:"hidden"});
a(f.peekElement).css({position:"",display:""});
},animate:function(){var d=this;
d.initializeDom();
d.$element.stopTransition(true).transition({top:-d.contentElement.offsetHeight+"px"},d.options.duration,d.options.easing,d._showAnimationEndHnadler);
},get_hideTopPostion:function(){return(this.options.easing=="easeInBack")?"0.01px":"0px";
}};
b.Tile.ClientTemplateSlideAnimationStrategy.registerClass("Telerik.Web.UI.Tile.ClientTemplateSlideAnimationStrategy",null,b.Tile.IAnimationStrategy);
})($telerik.$);
(function(a,c){Type.registerNamespace("Telerik.Web.UI.Tile");
var b=Telerik.Web.UI;
b.Tile.AnimationStrategyFactory=function(f,d,e){this.contentElement=d;
this.peekElement=f;
this.options=a.extend({animationType:b.Tile.None,duration:500,easing:null,showAnimationEndHnadler:null,hideAnimationEndHnadler:null},e);
};
b.Tile.AnimationStrategyFactory.prototype={createAnimationStrategy:function(){switch(parseInt(this.options.animationType,10)){case b.Tile.PeekTemplateAnimation.Resize:return new b.Tile.ResizeAnimationStrategy(this.peekElement,this.options);
case b.Tile.PeekTemplateAnimation.Fade:return new b.Tile.FadeAnimationStrategy(this.peekElement,this.options);
case b.Tile.PeekTemplateAnimation.Slide:return new b.Tile.SlideAnimationStrategy(this.contentElement,this.peekElement,this.options);
default:return new b.Tile.NoneAnimationStrategy(this.peekElement,this.options);
}},createClientTempalteAnimationStrategy:function(){switch(parseInt(this.options.animationType,10)){case b.Tile.ClientTemplateAnimation.Resize:return new b.Tile.ClientTemplateResizeAnimationStrategy(this.peekElement,this.options);
case b.Tile.ClientTemplateAnimation.Fade:return new b.Tile.ClientTemplateFadeAnimationStrategy(this.peekElement,this.options);
case b.Tile.ClientTemplateAnimation.Slide:return new b.Tile.ClientTemplateSlideAnimationStrategy(this.contentElement,this.peekElement,this.options);
default:return new b.Tile.ClientTemplateNoneAnimationStrategy(this.peekElement,this.options);
}}};
})($telerik.$);
(function(a,d){Type.registerNamespace("Telerik.Web.UI.Tile");
var b=Telerik.Web.UI;
var c=function(e){(function(){var g={};
a.extend(e,{trigger:function(k){var l=g[k];
if(!l){return;
}for(var m=0;
m<l.length;
m++){var j=Array.prototype.slice.call(arguments);
j.shift();
j.unshift(this);
l[m].handler.apply(l[m].context,j);
}},_bind:function(j,i){a.each(j,function(k,l){f(k,l,i);
});
},_unbind:function(j,i){a.each(j,function(k,l){h(k,l,i);
});
},_disposeEvents:function(){g={};
}});
function f(j,k,i){var l=g[j]||[];
l.push({handler:k,context:i});
g[j]=l;
}function h(k,l,j){var m=g[k];
if(!m){return;
}var o=-1;
for(var n=0;
n<m.length;
n++){if(m[n].func==l&&m[n].context==j){o=n;
break;
}}if(o>-1){m=m.splice(o,1);
}g[k]=m;
}})();
};
Telerik.Web.UI.Tile.ClientTemplateAnimationManager=function(f,e){var g=this;
c(g);
g._contentTemplateHtml="";
g._substitudeElement=null;
g._contentElement=f;
g._initializeDelegates();
g.options=a.extend({animationType:0,duration:500,easing:null,showAnimationEndHnadler:g._onAnimationEndDelegate},e);
};
a.registerEnum(b.Tile,"ClientTemplateAnimation",{None:0,Resize:1,Fade:2,Slide:4});
Telerik.Web.UI.Tile.ClientTemplateAnimationManager.prototype={_initializeDelegates:function(){var e=this;
e._onAnimationEndDelegate=a.proxy(e._onAnimationEnd,e);
},_createAnimationStrategy:function(){var f=this;
var e=new b.Tile.AnimationStrategyFactory(f._substitudeElement,f._contentElement,f.options);
return e.createClientTempalteAnimationStrategy();
},animate:function(){var f=this;
var e=f._createAnimationStrategy();
f._onAnimationStart();
e.animate();
},setContentTemplateHtml:function(e){a(this.get_substitudeElement()).html(e);
},set_animationType:function(e){this.options.animationType=e;
},get_substitudeElement:function(){var e=this;
if(!e._substitudeElement){e._substitudeElement=e._createSubstitudeElement();
}return this._substitudeElement;
},_createSubstitudeElement:function(){var g=this,e=g.get_contentElement(),f=a(e).clone().removeAttr("style").css({display:"none"}).insertAfter(e).get(0);
return f;
},set_substitudeElement:function(e){this._substitudeElement=e;
},get_contentElement:function(){return this._contentElement;
},set_contentElement:function(e){this._contentElement=e;
},get_contentTemplateHtml:function(e){return this._contentTemplateHtml;
},_onAnimationStart:function(){this.trigger("animationStart");
},add_animationStart:function(e){this._bind({animationStart:e});
},remove_animationStart:function(e){this._unbind({animationStart:e});
},_onAnimationEnd:function(){this._resetContentElement();
this.trigger("animationEnd");
},_resetContentElement:function(){var f=this,e=f.get_substitudeElement();
if(f.options.animationType==b.Tile.ClientTemplateAnimation.Slide){a(e.parentNode).replaceWith(e);
}else{a(f.get_contentElement()).remove();
}f.set_contentElement(e);
f.set_substitudeElement(null);
},add_animationEnd:function(e){this._bind({animationEnd:e});
},remove_animationEnd:function(e){this._unbind({animationEnd:e});
},dispose:function(){this._disposeEvents();
}};
})($telerik.$);
(function(a,d){Type.registerNamespace("Telerik.Web.UI.Tile");
var b=Telerik.Web.UI;
var c=function(e){(function(){var g={};
a.extend(e,{trigger:function(k){var l=g[k];
if(!l){return;
}for(var m=0;
m<l.length;
m++){var j=Array.prototype.slice.call(arguments);
j.shift();
j.unshift(this);
l[m].handler.apply(l[m].context,j);
}},_bind:function(j,i){a.each(j,function(k,l){f(k,l,i);
});
},_unbind:function(j,i){a.each(j,function(k,l){h(k,l,i);
});
},_disposeEvents:function(){g={};
}});
function f(j,k,i){var l=g[j]||[];
l.push({handler:k,context:i});
g[j]=l;
}function h(k,l,j){var m=g[k];
if(!m){return;
}var o=-1;
for(var n=0;
n<m.length;
n++){if(m[n].func==l&&m[n].context==j){o=n;
break;
}}if(o>-1){m=m.splice(o,1);
}g[k]=m;
}})();
};
a.registerEnum(b.Tile,"PeekTemplateAnimation",{None:0,Resize:1,Fade:2,Slide:4});
Telerik.Web.UI.Tile.PeekAnimationManager=function(f,e,g){c(this);
this._peekElement=f.get(0);
this._contentElement=e.get(0);
this._initializeDelegates();
this.options=a.extend({animationType:0,duration:500,easing:null,showAnimationEndHnadler:this._onShowAnimationEndDelegate,hideAnimationEndHnadler:this._onHideAnimationEndDelegate},g);
this._animationStrategy=this.get_animationStrategy();
};
Telerik.Web.UI.Tile.PeekAnimationManager.prototype={_initializeDelegates:function(){this._onShowAnimationEndDelegate=a.proxy(this._onShowAnimationEnd,this);
this._onHideAnimationEndDelegate=a.proxy(this._onHideAnimationEnd,this);
},get_animationStrategy:function(){if(!this._animationStrategy){this._animationStrategy=this._createAnimationStrategy();
}return this._animationStrategy;
},_createAnimationStrategy:function(){var e=new b.Tile.AnimationStrategyFactory(this._peekElement,this._contentElement,this.options);
return e.createAnimationStrategy();
},set_animationStrategy:function(e){this._animationStrategy=e;
},set_animationType:function(e){this.options.animationType=e;
this._onAnimationTypeChangedHndler=a.proxy(this._onAnimationTypeChanged,this);
this.add_hideAnimationEnd(this._onAnimationTypeChangedHndler);
this.hide();
},_onAnimationTypeChanged:function(){this._animationStrategy.resetDomInitialization();
this.set_animationStrategy(this._createAnimationStrategy());
this.remove_hideAnimationEnd(this._onAnimationTypeChangedHndler);
this._onAnimationTypeChangedHndler=null;
},show:function(){this._onShowAnimationStart();
this._animationStrategy.show();
},hide:function(){this._onHideAnimationStart();
this._animationStrategy.hide();
},get_peekElement:function(){return this._peekElement;
},set_peekElement:function(e){this._peekElement=e;
},get_contentElement:function(){return this._contentElement;
},set_contentElement:function(e){this._contentElement=e;
},_onShowAnimationStart:function(){this.trigger("showAnimationStart");
},_onShowAnimationEnd:function(){this.trigger("showAnimationEnd");
},_onHideAnimationStart:function(){this.trigger("hideAnimationStart");
},_onHideAnimationEnd:function(){this.trigger("hideAnimationEnd");
},add_showAnimationStart:function(e){this._bind({showAnimationStart:e});
},remove_showAnimationStart:function(e){this._unbind({showAnimationStart:e});
},add_showAnimationEnd:function(e){this._bind({showAnimationEnd:e});
},remove_showAnimationEnd:function(e){this._unbind({showAnimationEnd:e});
},add_hideAnimationStart:function(e){this._bind({hideAnimationStart:e});
},remove_hideAnimationStart:function(e){this._unbind({hideAnimationStart:e});
},add_hideAnimationEnd:function(e){this._bind({hideAnimationEnd:e});
},remove_hideAnimationEnd:function(e){this._unbind({hideAnimationEnd:e});
},dispose:function(){this._disposeEvents();
}};
})($telerik.$);
if(typeof(Sys)!=='undefined')Sys.Application.notifyScriptLoaded();