Type.registerNamespace("Telerik.Web.UI");
(function(b,a){b.FileExplorerHelper={extractExtensionFromDataItem:function(c){return this.parseExtension(c.Extension,c.Name);
},parseExtension:function(d,e){var c=d;
if(!c){c=(e&&e.indexOf(".")>0)?e:"";
}return c.substr(c.lastIndexOf(".")+1).toLowerCase();
},stripExtension:function(d){var c=new RegExp(String.format("\\.{0}$",d.get_extension()),"i");
return d.get_name().replace(c,"");
},extractPathFromDataItem:function(c,d){return c.Path||this.buildPathFromName(c.Name,d);
},extractPathFromExplorerItem:function(d,c){return d.get_path()||this.buildPathFromName(d.get_name(),c);
},buildPathFromName:function(d,c){var f=c.get_pathSeparator();
var e=c.get_currentDirectory();
if(e&&e.charAt(e.length-1)!=f.charAt(0)){e+=f;
}e+=d;
return e;
},webImageRegExp:/^png$|^gif$|^bmp$|^jpg$|^jpeg$|^tiff$|^ico$|^webp$/i,isWebImage:function(c){return c&&this.webImageRegExp.test(c.replace(".",""));
},getThumbnailCSSExtension:function(c){var e=this.isFolderItem(c);
var d=e?"folder":this.extractExtensionFromDataItem(c);
return this.isWebImage(d)?"rfeImageView":d;
},hideContextMenu:function(c){if(c&&c._shown){c.hide();
}},isFolderItem:function(c){return(typeof(c.Length)==="undefined"||c.Length==null);
},canDelete:function(c){return(c&b.FileExplorerItemPermissions.Delete)!=0;
},canUpload:function(c){return(c&b.FileExplorerItemPermissions.Upload)!=0;
},unsetPermission:function(c,d){return c&(~d);
}};
a.extend({registerjQueryEvents:function(c,d){a.each(d,function(f,e){c.prototype["add_"+e]=function(g){a(this).on(e,g);
};
c.prototype["remove_"+e]=function(g){a(this).off(e,g);
};
});
}});
})(Telerik.Web.UI,$telerik.$);
Type.registerNamespace("Telerik.Web.UI.FileExplorer");
(function(b,a){b.FileExplorer.IFileListView=function(c){};
b.FileExplorer.IFileListView.prototype={bindToServerData:function(d,c){},dataBind:function(){},get_id:function(){},get_dataSource:function(){},set_dataSource:function(c){},get_pageIndex:function(){},set_pageIndex:function(d,c){},get_pageSize:function(){},set_pageSize:function(c){},get_pageCount:function(){},get_itemsCount:function(){},get_items:function(){},get_name:function(){},selectItemsByName_Fast:function(c){},selectItemByName:function(c){},get_selectedItems:function(){},selectDefaultItem:function(){},clearSelection:function(){},getItemByName:function(c){},getItemByPath:function(c){},get_element:function(){},get_container:function(){},focusPagerControl:function(){},attachEventHandlers:function(c){},filter:function(c){},show:function(){},hide:function(){},getScroll:function(){},scrollTo:function(){},set_height:function(){},add_sort:function(c){},remove_sort:function(c){},add_page:function(c){},remove_page:function(c){},add_open:function(c){},remove_open:function(c){},add_itemSelect:function(c){},remove_itemSelect:function(c){},add_contextMenu:function(c){},remove_contextMenu:function(c){},add_hideContextMenu:function(c){},remove_hideContextMenu:function(c){},add_itemDragStart:function(c){},remove_itemDragStart:function(c){},add_itemDragging:function(c){},remove_itemDragging:function(c){},add_itemDrop:function(c){},remove_itemDrop:function(c){},add_itemDropComplete:function(c){},remove_itemDropComplete:function(c){}};
b.FileExplorer.IFileListView.registerInterface("Telerik.Web.UI.FileExplorer.IFileListView");
b.FileExplorer.ClientBindableFileListView=function(c){this.control=c;
this._name="";
};
b.FileExplorer.ClientBindableFileListView.prototype={bindToServerData:function(d,c){if(!d||!d.data){return;
}this._isBindingFlag=true;
this.control.set_virtualItemCount(d.count);
this.control.set_dataSource(d.data);
if(!isNaN(c)){this.set_currentPageIndex(c,true);
}this.dataBind();
this._updatePageControl(d.count);
this._isBindingFlag=false;
},dataBind:function(){return this.control.dataBind();
},get_dataSource:function(){return this.control.get_dataSource();
},set_dataSource:function(c){this.control.set_dataSource(c);
},get_pageSize:function(){return this.control.get_pageSize();
},set_pageSize:function(c){this.control.set_pageSize(c);
},get_pageCount:function(){return this.control.get_pageCount();
},get_itemsCount:function(){return this.control.get_virtualItemCount();
},get_currentPageIndex:function(){return this.control.get_currentPageIndex();
},set_currentPageIndex:function(d,c){this.control.set_currentPageIndex(d,c);
},get_name:function(){return this._name;
},selectItemByName:function(d){var c=this.getItemIndexByName(d);
if(c!=-1){this._selectIndex(c);
}},clearSelection:function(){this.control.clearSelectedItems();
},getItemByName:function(c){return this.getItemBy(c,"Name");
},getItemByPath:function(c){return this.getItemBy(c,"Path");
},getItemBy:function(h,g){var c=this.get_dataSource();
if(c){for(var e=0,f=c.length;
e<f;
e++){var d=c[e];
if(d[g]==h){return d;
}}}return null;
},getItemIndexByName:function(f){var c=this.get_dataSource();
if(c){for(var d=0,e=c.length;
d<e;
d++){if(c[d].Name==f){return d;
}}}return -1;
},show:function(){this.get_element().style.display="";
},hide:function(){this.get_element().style.display="none";
},raiseEvent:function(d,c){a(this).trigger(d,[c]);
},_focus:function(c){b.FileExplorer.FileList.prototype._focus(c);
},_filterItem:function(e,d){var f=e.Name.toLowerCase();
var c=e.Extension?e.Extension.toLowerCase():false;
return(f==".."&&!c)||f.indexOf(this.filterKeyWord)!=-1||(c&&c.indexOf(this.filterKeyWord)!=-1);
},_storeUnfilteredData:function(c){this._dataCache=Array.clone(c);
},_updatePageControl:function(c){},_selectIndex:function(c){this.control.selectItem(c);
}};
a.registerjQueryEvents(b.FileExplorer.ClientBindableFileListView,["sort","page","open","itemSelect","contextMenu","hideContextMenu","itemDragStart","itemDragging","itemDrop","itemDropComplete"]);
b.FileExplorer.ClientBindableFileListView.registerClass("Telerik.Web.UI.FileExplorer.ClientBindableFileListView");
})(Telerik.Web.UI,$telerik.$);
Type.registerNamespace("Telerik.Web.UI.FileExplorer");
(function(c,a,b){b.FileList=function(d){b.FileList.initializeBase(this);
this.options=a.extend({grid:null,listView:null,contextMenu:null,container:null,fileExplorer:null},d||{});
this._folderCache={};
this._selectedFiles=[];
this._forceServerFilteringFlags={};
this.fileListViewsMap={};
this.fileListViews=[];
this.activeFileListView=null;
this._sortExpression="";
this._attachEventHandlers();
this.helpers=Telerik.Web.UI.FileExplorerHelper;
};
b.FileList.prototype={dataBind:function(){if(a.isArray(this.get_dataSource())){this._listControl.dataBind();
}},bindToServerData:function(e,d){this._currentServerData=e;
if(e&&e.data&&!isNaN(e.count)){this._listControl.bindToServerData(e,d);
}},bindToData:function(d){this.set_dataSource(d);
this.dataBind();
},get_dataSource:function(){return this._listControl.get_dataSource();
},set_dataSource:function(d){this._listControl.set_dataSource(d);
},get_pageSize:function(){return this._listControl.get_pageSize();
},set_pageSize:function(d){this._listControl.set_pageSize(d);
},get_control:function(){return this._listControl;
},get_allowMultiSelect:function(){return this._listControl.get_allowMultiSelect();
},get_view:function(){return this._listControl;
},get_contextMenu:function(){return this.options.contextMenu;
},get_fileExplorer:function(){return this.options.fileExplorer;
},get_element:function(){return this._listControl.get_element();
},get_items:function(){return this._listControl.get_items();
},get_selectedItems:function(){return this._listControl.get_selectedItems();
},get_selectedItemsDataAndElement:function(){return this._listControl.get_selectedItemsDataAndElement();
},getSelectedFiles:function(){return this.get_selectedItems();
},get_selectedItem:function(){var d=this.get_selectedItems();
return d.length>0?d[0]:null;
},get_filterTextBox:function(d){return a("input.rfeFilterTxt",(d||this.get_view()).get_container()).get(0);
},registerFileListView:function(d){if(!d||!d.get_name){return;
}if(!this.fileListViewsMap[d.get_name()]){this.fileListViews.push(d);
}this.fileListViewsMap[d.get_name()]=d;
this._attachViewEvents(d);
d.hide();
},chooseFileListView:function(e){var d=this.getFileListViewByName(e);
if(d&&d!=this._listControl){d.show();
if(this._listControl){this._listControl.hide();
d.bindToServerData(this._currentServerData,this._listControl.get_pageIndex());
a(this.get_filterTextBox(d)).val(this._filterKeyWord||"");
}this._listControl=d;
}},getFileListViewByName:function(d){return this.fileListViewsMap[d];
},selectFile:function(d){var e=d.Name||(d.get_name()?d.get_name():null);
if(e){this.selectFileByName(e);
}},selectFileByName:function(d){this._clearStoredSelection();
this._listControl.selectItemByName(d);
},selectFileList:function(d){this._listControl.selectItemsByName_Fast(d);
},selectDefaultFile:function(){this._clearStoredSelection();
return this._listControl.selectDefaultItem();
},clearSelection:function(){this._listControl.clearSelection();
},findFileByName:function(d){return this._listControl.getItemByName(d);
},findFileByPath:function(d){return this._listControl.getItemByPath(d);
},get_grid:function(){return this.options.grid;
},get_listView:function(){return this.options.listView;
},open:function(e){var d=c.FileExplorerItem.isInstanceOfType(e)?e:this._toFileItem(e);
this.options.fileExplorer.open(d);
},focus:function(){this._focus(this._listControl.get_element());
},focusPagerControl:function(){this._listControl.focusPagerControl();
},attachEventHandlers:function(d){if(d){this._attachEventHandlers();
}else{this._detachEventHandlers();
}},raiseCommand:function(d){this.raiseEvent("command",d);
},raiseEvent:function(f,d){var e=this.get_events().getHandler(f);
if(e){e(this,d||Sys.EventArgs.Empty);
}},showFolderFileList:function(e){if(this._currentFolder!=e){var d=this._retrieveFromCache(e);
if(d){this.clearFilter();
this._clearPageState();
this._currentFolder=e;
this._applyServerData(d,e);
}else{this.refreshFileList(e);
}}},refreshFileList:function(d){this._storeSelectedFiles(d);
this.clearFilter();
this._clearPageState();
this._currentFolder=d;
this._getServerDataCallback();
},sort:function(d){this._storeSelectedFiles(this._currentFolder);
this.clearFilter();
this._sortExpression=d||"";
this._getServerDataCallback();
},showPageContent:function(e,d){this._storeSelectedFiles(this._currentFolder);
this._startIndex=e||0;
this._pageSize=d||this.get_pageSize();
this._getServerDataCallback();
},filterList:function(d){this._filterListWithEvent(d);
},doFiltering:function(d){if(this._shouldForceServerFiltering()){this._forceServerFiltering();
this.serverFilter(d);
}else{this.clientFilter(d);
}},serverFilter:function(d){this._setFilterKeyword(d);
this._clearPageState();
this._getServerDataCallback();
},clientFilter:function(f){this._setFilterKeyword(f);
var d=this._retrieveOriginalFilterData();
if(d){var e=this._filterItems(d.data);
this.bindToServerData(this._toServerDataFormat(e));
}},clearFilter:function(){this._filterKeyWord="";
a(this.get_filterTextBox()).val("");
},clearFolderCache:function(d){this._clearFolderCache(d);
},set_height:function(d){this.eachView(function(e){e.set_height(d);
});
},eachView:function(d){Array.forEach(this.fileListViews,d);
},dispose:function(){this.attachEventHandlers(false);
},_chooseListControl:function(){if(this.options.grid){return new b.GridFileList(this.options.grid);
}else{if(this.options.listView){return new b.ListViewFileList(this.options.listView);
}else{return null;
}}},_focus:function(d){Telerik.Web.UI.RadFileExplorer.prototype._focus(d);
},_toFileItem:function(d){if(!d){return null;
}var e=d.Name;
var f=d.Length;
return $create(Telerik.Web.UI.FileExplorerItem,{type:(this.helpers.isFolderItem(d)?Telerik.Web.UI.FileExplorerItemType.Directory:Telerik.Web.UI.FileExplorerItemType.File),permissions:d.Permissions,name:e,path:this.helpers.extractPathFromDataItem(d,this.options.fileExplorer),extension:this.helpers.extractExtensionFromDataItem(d),size:f,url:d.Url});
},_storeSelectedFiles:function(f){if(this._currentFolder==f){var g=this.get_selectedItems();
if(g.length>=this._selectedFiles.length){this._clearStoredSelection();
for(var d=0,e=g.length;
d<e;
d++){this._selectedFiles.push(g[d].Name);
}}this._viewScroll=this.get_view().getScroll();
}else{this._clearStoredSelection();
this._viewScroll=0;
}},_restoreSelectedFiles:function(){if(this._selectedFiles===null){this._selectedFiles=[];
return;
}this.clearSelection();
this.selectFileList(this._selectedFiles);
this.get_view().scrollTo(this._viewScroll);
},_clearStoredSelection:function(){this._selectedFiles=[];
},_setFilterKeyword:function(d){this._filterKeyWord=d.toLowerCase();
},_retrieveOriginalFilterData:function(){var d=this._retrieveFromCache();
if(!d){d=this._toServerDataFormat(this.get_items());
this._cacheFilesData(d);
}return d;
},_clearPageState:function(){this._pageSize=this._startIndex=null;
this._listControl.set_pageIndex(0,true);
},_getServerDataCallback:function(){this.raiseEvent("callback");
var g=this._currentFolder;
var f=Sys.Serialization.JavaScriptSerializer.serialize({path:g||this.options.fileExplorer.get_currentDirectory(),sortExpression:this._sortExpression||"",startIndex:this._startIndex||0,maxRowNumber:this._pageSize||this.get_pageSize(),filterKeyWord:this._filterKeyWord||""});
var d=Function.createDelegate(this,this._onCallbackResponse);
var e=Function.createDelegate(this,this._onErrorCallback);
WebForm_DoCallback(this.options.fileExplorer._uniqueId,f,d,g,e,true);
},_onCallbackResponse:function(e,d){this.raiseEvent("callbackComplete");
if(!e){return;
}var f=Sys.Serialization.JavaScriptSerializer.deserialize(e);
if(f&&f.data){this._fixMissingPath(f.data);
}if(!this._filterKeyWord){this._cacheFilesData(f,d);
}this.clearSelection();
this._applyServerData(f,d);
this._restoreSelectedFiles();
},_applyServerData:function(e,d){if(this._currentFolder===d){this.bindToServerData(e);
}this.raiseEvent("folderLoaded",new b.FilePathEventArgs(d));
},_onErrorCallback:function(){alert("Callback has failed");
},_toServerDataFormat:function(d){return{count:d.length,data:d};
},_fixMissingPath:function(d){for(var e=0,f=d.length;
e<f;
e++){if(!d.Path){d.Path=this.helpers.buildPathFromName(d.Name,this.options.fileExplorer);
}}},_filterItems:function(d){return a.grep(d,a.proxy(this._filterItem,this));
},_filterItem:function(e,d){var f=e.Name.toLowerCase();
return(f==".."&&!e.Extension)||f.indexOf(this._filterKeyWord)!=-1;
},_raiseFilterEvent:function(d){this.raiseEvent("filter",d);
return d;
},_cacheFilesData:function(d,e){this._folderCache[this._buildCacheKey(e)]=d;
},_retrieveFromCache:function(d){return this._folderCache[this._buildCacheKey(d)];
},_clearFoldersCache:function(d){for(var e=0;
e<d.length;
e++){this._clearFolderCache(d[e].Path);
}},_clearFolderCache:function(d){this._cacheFilesData(null,d);
},_buildCacheKey:function(d){return(d||this._currentFolder)+"***"+this._sortExpression;
},_shouldForceServerFiltering:function(){return this._listControl.get_pageCount()>1||this._forceServerFilteringFlags[this._currentFolder];
},_forceServerFiltering:function(){this._forceServerFilteringFlags[this._currentFolder]=true;
},_filterListWithEvent:function(f,d){var e=this._raiseFilterEvent(new c.FileExplorerFilterEventArgs(f,d||null));
f=e.get_text();
if(!e.get_cancel()){this.doFiltering(f);
}},_attachEventHandlers:function(){this._emptySpaceContextHandler=Function.createDelegate(this,this._emptySpaceContextMenu);
$addHandler(this.options.fileExplorer.get_gridPane().getContentElement(),"contextmenu",this._emptySpaceContextHandler);
if(this.options.contextMenu){this.options.contextMenu.add_itemClicking(Function.createDelegate(this,this._onMenuItemClick));
this.options.contextMenu.add_hidden(Function.createDelegate(this,this._onMenuClose));
}},_detachEventHandlers:function(){this._listControl.attachEventHandlers(false);
},_attachViewEvents:function(e){var d=this.get_filterTextBox(e);
if(d){$telerik.addHandler(d,"keydown",function(f){if(f.keyCode==13){$telerik.cancelRawEvent(f.rawEvent);
}},true);
$telerik.addHandler(d,"keyup",Function.createDelegate(this,this._keyUpFilterTextBox),true);
}e.attachEventHandlers(true);
e.add_sort(Function.createDelegate(this,this._onSort));
e.add_page(Function.createDelegate(this,this._onPaging));
e.add_open(Function.createDelegate(this,this._onOpen));
e.add_itemSelect(Function.createDelegate(this,this._onSelectItem));
e.add_contextMenu(Function.createDelegate(this,this._onItemContextMenu));
e.add_hideContextMenu(Function.createDelegate(this,this._onHideContextMenu));
e.add_itemDragStart(Function.createDelegate(this,this._onItemDragStart));
e.add_itemDragging(Function.createDelegate(this,this._onItemDragging));
e.add_itemDrop(Function.createDelegate(this,this._onItemDrop));
e.add_itemDropComplete(Function.createDelegate(this,this._onItemDropComplete));
},_onSort:function(e,d){this.sort(d.get_sortExpression());
},_onPaging:function(e,d){this.showPageContent(d.get_startIndex(),d.get_pageSize());
},_onOpen:function(e,d){this.open(d||this.get_selectedItem());
},_onSelectItem:function(e,d){this.raiseEvent("itemSelect",new b.FileListItemEventArgs(this._toFileItem(d)));
},_onItemDragStart:function(e,d){var f=d.get_item();
d.set_cancel(!!f&&f.Name==="..");
if(this.options.contextMenu){this.options.contextMenu.hide();
}},_onItemDragging:function(f,d){var g=this.options.fileExplorer;
if(g._enableCopy){var e=d.get_domEvent().ctrlKey;
var h=Sys.UI.DomElement.containsCssClass(g.get_element(),g._copyCursorClassName);
if(e!=h){g._updateCopyCursor(e);
}}g._scrollTreeViewOnDrag(d.get_domEvent());
},_onItemDrop:function(g,d){var h=this.options.fileExplorer;
if(h._enableCopy){h._updateCopyCursor(false);
}var e=h._currentTreeNode||this._tryExtractNodeFromDomElement(d.get_targetElement());
if(e){if(!h._isNodeADirectory(e)){e=e.get_parent();
}var n=h._enableCopy&&d.get_domEvent().ctrlKey;
var l={isCopying:n,srcFolder:h.get_currentDirectory(),dstFolder:e.get_value()};
if(l.srcFolder==l.dstFolder){d.set_cancel(true);
}else{l.items=[];
var k=n?"copy":"move";
var f=d.get_items();
for(var m=0,r=f.length;
m<r;
m++){var p=f[m];
var j=this._toFileItem(p);
var o=j.isDirectory()?"D":"F";
var q=new Telerik.Web.UI.FileExplorerEventArgs(j,l.dstFolder);
h.raiseEvent(k,q);
if(!q.get_cancel()){Array.add(l.items,o+j.get_path());
}}h._gridRowDroppedParams=l;
}this._clearFolderCache(l.srcFolder);
this._clearFolderCache(l.dstFolder);
}else{d.set_cancel(true);
}},_onItemDropComplete:function(f,e){var g=this.options.fileExplorer;
var i=g._gridRowDroppedParams;
if(i){var d=i.isCopying?"CallbackFnCopy_":"GridDrag_";
d+=i.dstFolder+"***"+i.items.join("***");
var h=i.dstFolder+"***"+this._sortExpression;
g._folderCache[h]=null;
g._gridRowDroppedParams=null;
setTimeout(function(){g._postbackTreeAjaxPanel(d);
});
}},_keyUpFilterTextBox:function(d){$telerik.cancelRawEvent(d.rawEvent);
var e=this.get_filterTextBox().value;
if(!this.options.fileExplorer.get_enableFilteringOnEnter()||d.keyCode==13||e==""){$telerik.cancelRawEvent(d.rawEvent);
this._filterListWithEvent(e,d.rawEvent);
return false;
}},_tryExtractNodeFromDomElement:function(d){var e=a(d).parents(".rtLI:first").get(0);
if(e){return e._item;
}return null;
},_emptySpaceContextMenu:function(d){var g=this.options.contextMenu;
var e=this.options.fileExplorer;
if(!g||!e._enabled){return;
}var i=this._lastContextMenuItem||this.get_selectedItem();
var h=this._toFileItem(i);
if(!h||h.get_name()===".."){h=e._getCurrentFolderItem();
}var f=this._getItemPermissions(i);
var j=e._setContextMenuItemsState(g,f);
if(j){g.show(d);
}return $telerik.cancelRawEvent(d);
},_getItemPermissions:function(g){var f=c.FileExplorerHelper;
var e=this.options.fileExplorer.get_currentPermissions();
var d=f.canUpload(e);
var h;
if(g){h=(g.get_permissions)?g.get_permissions():g.Permissions;
if(!d){h=f.unsetPermission(h,c.FileExplorerItemPermissions.Upload);
}}else{if(d){h=c.FileExplorerItemPermissions.Upload;
}}return h;
},_onMenuItemClick:function(i,d){var f=this.options.fileExplorer;
var j=d.get_item().get_value();
var e=this._getContextMenuSelectedItem();
var h=Function.createCallback(f._onFileRenameDelegate,e);
switch(j){case"Rename":if(e&&e.get_name()===".."){return;
}var g=f._allowFileExtensionRename?e.get_name():c.FileExplorerHelper.stripExtension(e);
f._showPromptDialog(h,{title:"Rename",value:g,inputValidator:f._validateFileNameInputDelegate,timeout:10});
break;
case"Delete":this._deleteSelectedItems();
break;
case"Open":this.open(e);
break;
case"NewFolder":f.createNewDirectory(this._currentFolder);
break;
case"Upload":f._showUploadWindow();
break;
case"Copy":f._copy("grid");
break;
case"Paste":var k=e;
if(k==null||!k.isDirectory()){k=f._getCurrentFolderItem();
}f._paste(k);
break;
}},_deleteSelectedItems:function(){this.options.fileExplorer.deleteSelectedItems();
},_onItemContextMenu:function(e,d){this._lastContextMenuItem=d;
},_onHideContextMenu:function(e,d){this.options.fileExplorer._hideContextMenus(new Sys.UI.DomEvent(d),false,"");
},_onMenuClose:function(){this._lastContextMenuItem=null;
},_getContextMenuSelectedItem:function(){var d=this._toFileItem(this._getContextMenuSelectedDataItem());
if(!d||d.get_name()===".."){d=this.options.fileExplorer._getCurrentFolderItem();
}return d;
},_getContextMenuSelectedDataItem:function(){return this._lastContextMenuItem||this.get_selectedItem();
}};
a.registerControlProperties(b.FileList,{allowPaging:false});
a.registerControlEvents(b.FileList,["command","filter","folderLoaded","itemSelect","callback","callbackComplete"]);
b.FileList.registerClass("Telerik.Web.UI.FileExplorer.FileList",Sys.Component);
})(Telerik.Web.UI,$telerik.$,Telerik.Web.UI.FileExplorer);
Type.registerNamespace("Telerik.Web.UI.FileExplorer");
(function(c,a,b){b.FileListSortEventArgs=function(d){b.FileListSortEventArgs.initializeBase(this);
this.set_sortExpression(d);
};
a.registerControlProperties(b.FileListSortEventArgs,{sortExpression:""});
b.FileListSortEventArgs.registerClass("Telerik.Web.UI.FileExplorer.FileListSortEventArgs",Sys.EventArgs);
b.FileListPageEventArgs=function(e,d){b.FileListPageEventArgs.initializeBase(this);
this.set_startIndex(e);
this.set_pageSize(d);
};
a.registerControlProperties(b.FileListPageEventArgs,{startIndex:0,pageSize:0});
b.FileListPageEventArgs.registerClass("Telerik.Web.UI.FileExplorer.FileListPageEventArgs",Sys.EventArgs);
b.FileListItemEventArgs=function(d){b.FileListItemEventArgs.initializeBase(this);
this.set_item(d);
};
a.registerControlProperties(b.FileListItemEventArgs,{item:""});
b.FileListItemEventArgs.registerClass("Telerik.Web.UI.FileExplorer.FileListItemEventArgs",Sys.EventArgs);
b.FileListItemCancelableEventArgs=function(d){b.FileListItemCancelableEventArgs.initializeBase(this);
this.set_item(d);
};
a.registerControlProperties(b.FileListItemCancelableEventArgs,{item:""});
b.FileListItemCancelableEventArgs.registerClass("Telerik.Web.UI.FileExplorer.FileListItemCancelableEventArgs",Sys.CancelEventArgs);
b.FileListItemsCancelableEventArgs=function(f,e,d){b.FileListItemsCancelableEventArgs.initializeBase(this);
this.set_items(f);
this.set_domEvent(e);
this.set_targetElement(d);
};
a.registerControlProperties(b.FileListItemsCancelableEventArgs,{items:[],domEvent:null,targetElement:null});
b.FileListItemsCancelableEventArgs.registerClass("Telerik.Web.UI.FileExplorer.FileListItemsCancelableEventArgs",Sys.CancelEventArgs);
b.FilePathEventArgs=function(d){b.FilePathEventArgs.initializeBase(this);
this.set_path(d);
};
a.registerControlProperties(b.FilePathEventArgs,{path:""});
b.FilePathEventArgs.registerClass("Telerik.Web.UI.FileExplorer.FilePathEventArgs",Sys.EventArgs);
})(Telerik.Web.UI,$telerik.$,Telerik.Web.UI.FileExplorer);
Type.registerNamespace("Telerik.Web.UI.FileExplorer");
(function(c,a,b){b.GridFileList=function(d,e){this.options=a.extend({contextMenu:null},e||{});
b.GridFileList.initializeBase(this,[d.get_masterTableView()]);
this.grid=d;
this.helpers=Telerik.Web.UI.FileExplorerHelper;
};
b.GridFileList.prototype={get_id:function(){return this.grid.get_id();
},get_name:function(){return"grid";
},get_items:function(){return this._extractDataItemFromItemsArray(this.grid.get_masterTableView().get_dataItems());
},get_selectedItems:function(){return this._extractDataItemFromItemsArray(this.grid.get_selectedItems());
},get_selectedItemsDataAndElement:function(){var d=this.grid.get_selectedItems();
return a.map(d,function(e){var f={get_element:function(){return e.get_element();
}};
return a.extend(e.get_dataItem(),f);
});
},get_element:function(){return this.grid.get_element();
},get_container:function(){return this.get_element();
},set_pageIndex:function(e,g){var d=this.suppressPageEvent;
this.suppressPageEvent=!!g;
var f=e+1;
this.grid.get_masterTableView().page(f);
this.suppressPageEvent=d;
},get_pageIndex:function(){return this.grid.get_masterTableView().get_currentPageIndex();
},get_allowMultiSelect:function(){return this.grid.get_allowMultiRowSelection();
},set_height:function(d){this.get_element().style.height=d;
this.grid.repaint();
},focusPagerControl:function(){var d=$get("RadSliderDrag_"+this.grid.get_masterTableView()._data.sliderClientID,this.grid.get_element());
this._focus(d);
},selectDefaultItem:function(){var j=this.grid.MasterTableView;
var e=j.get_dataItems();
var k=e[0];
var d=j.get_selectedItems()[0];
var g=j.get_selectedItems().length>0;
if(g&&d._owner.CurrentPageIndex!=j.CurrentPageIndex){g=false;
var h=e.length;
for(var f=0;
f<h;
f++){if(e[f].get_selected()){g=true;
break;
}}}if(!g&&k){this.grid.MasterTableView.selectItem(k.get_element());
}return k;
},selectItemsByName_Fast:function(j){if(!j){return;
}var d=this.grid.get_masterTableView().get_dataItems();
var e=this._createHashTableFromDataItems(d,"Name");
var l=this.grid.get_masterTableView();
for(var f=0,k=j.length;
f<k;
f++){var h=j[f];
var g=e[h];
if(g){l.selectItem(g.get_element(),true);
}}},getScroll:function(){var d=this.control.get_element().parentNode;
return d?d.scrollTop:0;
},scrollTo:function(d){var e=this.control.get_element().parentNode;
if(e){e.scrollTop=d;
}},attachEventHandlers:function(d){if(!d){return;
}this.grid.add_rowContextMenu(Function.createDelegate(this,this._onGridRowContextMenu));
this.grid.add_command(Function.createDelegate(this,this._onGridCommand));
this.grid.add_rowDblClick(Function.createDelegate(this,this._onRowDblClick));
this.grid.add_rowDataBound(Function.createDelegate(this,this._onRowDataBound));
this.grid.add_rowSelected(Function.createDelegate(this,this._onSelectItem));
this.grid.add_rowDragStarted(Function.createDelegate(this,this._onItemDragStart));
this.grid.add_rowDragging(Function.createDelegate(this,this._onItemDragging));
this.grid.add_rowDropping(Function.createDelegate(this,this._onItemDrop));
this.grid.add_keyPress(Function.createDelegate(this,this._onGridKeyPress));
},_selectIndex:function(e,g){this.control.selectItem(e);
if(!g){var d=this.control.get_dataItems()[e],f=d.get_element();
Telerik.Web.UI.Grid.ScrollIntoView(f);
}},_updatePageControl:function(d){this.grid.repaint();
},_extractDataItemFromItemsArray:function(d){return a.map(d,function(e){return e.get_dataItem();
});
},_createHashTableFromDataItems:function(d,j){var e={};
for(var f=0,k=d.length;
f<k;
f++){var g=d[f];
var h=g.get_dataItem();
if(h){e[h[j]]=g;
}}return e;
},_onGridRowContextMenu:function(e,d){var f=d.get_itemIndexHierarchical();
var h=e.get_masterTableView();
var g=h.get_dataItems()[f];
this.raiseEvent("contextMenu",g.get_dataItem());
},_onGridCommand:function(e,d){d.set_cancel(true);
switch(d.get_commandName()){case"Sort":this.raiseEvent("sort",new b.FileListSortEventArgs(e.get_masterTableView().get_sortExpressions().toString()));
break;
case"RowDroppedHtml":this.raiseEvent("itemDropComplete");
break;
case"Page":if(this._isBindingFlag){break;
}var h=e.get_masterTableView();
var f=h.get_pageSize();
var g=e.get_masterTableView().get_currentPageIndex()*f;
if(!this.suppressPageEvent){this.raiseEvent("page",new b.FileListPageEventArgs(g,f));
}break;
}},_onRowDblClick:function(e,d){this._raiseOpen(this._getEventArgsItem(d));
},_onRowDataBound:function(m,d){var k=d.get_dataItem();
var o=this.helpers.isFolderItem(k);
var p=k.Name;
var r=o?"&nbsp;":k.Length;
var j="rfeFileExtension "+(o?"folder":this.helpers.extractExtensionFromDataItem(k));
var s=d.get_item("Name").get_element();
var h=m.get_masterTableView().get_columns();
for(var n=0,q=s.cells.length;
n<q;
n++){var g=h[n].get_uniqueName();
var f=s.cells[n];
f.setAttribute("unselectable","on");
switch(g){case"Name":var l=document.createElement("div");
l.className=j;
l.innerHTML=p.replace(/&/g,"&amp;");
l.setAttribute("unselectable","on");
f.innerHTML="";
f.appendChild(l);
break;
case"Size":f.innerHTML=r;
break;
default:var e=k.Attributes[g];
f.innerHTML=e?e:"&nbsp;";
break;
}}},_onSelectItem:function(g,d){var f=d.get_domEvent();
if(f.type=="mousedown"&&f.button==Sys.UI.MouseButton.leftButton&&!f.shiftKey){return;
}var e=this._getEventArgsItem(d);
if(e){this.raiseEvent("itemSelect",e);
}},_onItemDragStart:function(e,d){var f=this._getEventArgsItem(d);
var g=new b.FileListItemCancelableEventArgs(f);
this.raiseEvent("itemDragStart",g);
d.set_cancel(g.get_cancel());
a("#"+this.grid.get_id()+"_DraggedRows").remove();
},_onItemDragging:function(e,d){this.raiseEvent("itemDragging",d);
},_onItemDrop:function(f,d){var g=this._extractDataItemFromItemsArray(d.get_draggedItems());
var e=d.get_domEvent();
var h=d.get_destinationHtmlElement();
this.raiseEvent("itemDrop",new b.FileListItemsCancelableEventArgs(g,e,h));
},_onGridKeyPress:function(f,e){var g=e.get_keyCode();
var d=e.get_domEvent();
var h=d.target?d.target.className:d.srcElement.className;
if(g==13){if(h!="rfeFilterTxt"){this._raiseOpen();
}return $telerik.cancelRawEvent(d.rawEvent);
}},_raiseOpen:function(d){this.raiseEvent("open",d);
},_getEventArgsItem:function(d){return d.get_gridDataItem().get_dataItem();
}};
b.GridFileList.registerClass("Telerik.Web.UI.FileExplorer.GridFileList",b.ClientBindableFileListView,b.IFileListView);
})(Telerik.Web.UI,$telerik.$,Telerik.Web.UI.FileExplorer);
Type.registerNamespace("Telerik.Web.UI.FileExplorer");
(function(c,a,b,g){var d=$telerik.getComputedStyle;
b.ListViewFileList=function(h){b.ListViewFileList.initializeBase(this,[h]);
this.listViewContainer=this.control.get_element().parentNode;
this.container=this.listViewContainer.parentNode;
this.paneElement=this._getContainingPaneElement();
this.pageSlider=this._findPageSlider();
this.applyPageInfoTemplate("Page <span class='rfeCurrentPage'>#= page #</span>/<span class='rfeTotalPages'>#= pages #</span>; Items <span class='rfeStartItem'>#= start #</span>-<span class='rfeEndItem'>#= end #</span>/<span class='rfeTotalItems'>#= itemsCount #</span>");
if(this.pageSlider){var i=this._getPageInfoContainer();
if(i.length==0){this._getPageControlContainer().append("<div class='rfePageControl rfePageInfo'>");
}}this.listViewContainer.setAttribute("tabIndex",0);
this.specialKeys={};
this.itemsElements=this.control.get_element().parentNode.getElementsByTagName("li");
};
b.ListViewFileList.prototype={get_id:function(){return this.control.get_id();
},get_name:function(){return"thumbnails";
},get_items:function(){return this.get_dataSource();
},get_selectedItems:function(){var h=this.control.get_dataSource();
return a.map(this.control.get_selectedIndexes(),function(i){return h[i];
});
},get_selectedItemsDataAndElement:function(){var i=this.itemsElements;
var h=this.control.get_dataSource();
return a.map(this.control.get_selectedIndexes(),function(j){var k={get_element:function(){return i[j];
}};
return a.extend(h[j],k);
});
},dataBind:function(){var h=this.getScroll();
b.ListViewFileList.callBaseMethod(this,"dataBind");
this._calculateListViewHeight();
this.scrollTo(h);
},selectItemsByName_Fast:function(m){var o=[];
var h=this._createHashTableFromItems(this.get_items(),"Name");
for(var j=0,n=m.length;
j<n;
j++){var l=m[j];
var k=h[l];
if(k){o.push(k.__itemIndex);
}}this.control.set_selectedIndexes(o);
this.dataBind();
},get_element:function(){return this.listViewContainer;
},get_container:function(){return this.container;
},get_boundContainer:function(){return $get(this.control.get_clientSettings().DataBinding.ItemPlaceHolderID);
},set_pageIndex:function(i,j){if(!this.pageSlider){return;
}var h=this.suppressPageEvent;
this.suppressPageEvent=!!j;
this.pageSlider.set_value(i);
this.suppressPageEvent=h;
},get_pageIndex:function(){return this.pageSlider?this.pageSlider.get_value():0;
},get_allowMultiSelect:function(){return this.control.get_allowMultiItemSelection();
},get_pageInfo:function(){var j=this.control.get_pageSize();
var i=this.get_pageIndex();
var k=i*j;
var h=this.get_itemsCount();
return{page:i+1,pages:this.get_pageCount(),start:h==0?0:k+1,end:Math.min(k+j,h),itemsCount:h};
},compilePageInfo:function(){return this.pageInfoTemplate(this.get_pageInfo());
},set_currentPageIndex:function(h,i){this.control.set_currentPageIndex(h,i);
this.set_pageIndex(h,i);
},selectDefaultItem:function(){this._selectSingleIndex(0);
},selectRange:function(i,h){this._selectRange(i,h);
this.control.set_selectedIndexes(this.control.get_selectedIndexes().sort());
},getScroll:function(){var h=this._getListElement();
return h?h.scrollTop:0;
},scrollTo:function(i){var h=this._getListElement();
if(h){h.scrollTop=i;
}},navigate:function(h){var i=this._getNewItemIndexByDirection(h);
if(i!=-1){this._selectSingleIndex(i);
}},show:function(){this.container.style.display="";
},hide:function(){this.container.style.display="none";
},set_height:function(h){this.container.style.height=h;
this._calculateListViewHeight();
this.control.repaint();
},attachEventHandlers:function(i){if(!i){return this.detachEventHandlers();
}var h="#"+this.control.get_clientSettings().DataBinding.ItemPlaceHolderID+" li a";
a(this.listViewContainer).on("dblclick",h,a.proxy(this._onDblClick,this)).on("mousedown",h,a.proxy(this._onDragPrepare,this)).on("click",h,a.proxy(this._handleMultiSelect,this));
if($telerik.isTouchDevice&&a.fn.nodoubletapzoom){a(this.listViewContainer).nodoubletapzoom();
}a(this.listViewContainer).on("mousedown",a.proxy(this._onContainerClick,this)).on("keydown",a.proxy(this._onKeyDown,this)).on("keyup",a.proxy(this._onKeyUp,this)).on("focus",a.proxy(function(){this._isFocused=true;
},this)).on("blur",a.proxy(function(){this._isFocused=false;
},this));
this.control.add_command(Function.createDelegate(this,this._onCommand));
this.control.add_itemDragStarted(Function.createDelegate(this,this._onDragStart));
this.control.add_itemDragging(Function.createDelegate(this,this._onDragging));
this.control.add_itemDropping(Function.createDelegate(this,this._onDrop));
this.control.add_itemSelected(Function.createDelegate(this,this._onItemSelect));
if(this.pageSlider){this.pageSlider.add_valueChanged(Function.createDelegate(this,this._onPageChanged));
}},detachEventHandlers:function(){},focusPagerControl:function(){if(!this.pageSlider){return;
}var h=this.pageSlider.get_dragHandles()[0];
this._focus(h);
},updatePageInfo:function(){this._getPageInfoContainer().html(this.compilePageInfo());
},applyPageInfoTemplate:function(h){this.pageInfoTemplate=Telerik.Web.UI.Template.compile(h);
},_hoveredCssClass:"rfeHoveredLink",_createHashTableFromItems:function(h,m){var j={};
for(var k=0,n=h.length;
k<n;
k++){var l=h[k];
l.__itemIndex=k;
if(l){j[l[m]]=l;
}}return j;
},_findPageSlider:function(){var h=a(this.container).find(".RadSlider.rfePageControl").prop("id");
if(h){return $find(h);
}},_hasFilter:function(){return a(this.container).find(".rfeFilterContainer").length>0;
},_selectIndex:function(h,j){this.control.selectItem(h);
if(!j){var i=this._findNodeByIndex(h).parent()[0];
$telerik.scrollIntoView(i);
}},_selectSingleIndex:function(h,i){this.control.clearSelectedItems();
this._selectIndex(h,i);
},_updatePageControl:function(h){if(this.pageSlider){this.pageSlider.set_maximumValue(Math.max(this.get_pageCount()-1,0));
this.updatePageInfo();
}this._calculateListViewHeight();
this._resetKeyboardFlags();
},_calculateListViewHeight:function(){var i=this._getListElement();
if(i){i.style.height="";
var j=i.offsetHeight;
var h=parseInt(this.paneElement.style.height,10)-a(this.container).find(".rfePageControlContainer").outerHeight()-a(this.container).find(".rfeFilterContainer").outerHeight()-$telerik.getPaddingBox(i).vertical-$telerik.getMarginBox(i).vertical;
i.style.height=h+"px";
i.style.overflowY=h<j?"scroll":"auto";
}},_getContainingPaneElement:function(){return this.container.parentNode;
},_getListElement:function(){return $get(this.control.get_clientSettings().DataBinding.ItemPlaceHolderID);
},_getSelectedItemElements:function(){var h=this.control.get_selectedIndexes();
return a(this._getListElement()).find("li").filter(function(j,k){return Array.contains(h,j);
});
},_getPageControlContainer:function(){return a(this.container).find(".rfePageControlContainer");
},_getPageInfoContainer:function(){return this._getPageControlContainer().find(".rfePageInfo");
},_createDraggableElement:function(){this._dragContainer&&this._dragContainer.remove();
this._dragContainer=a(this.control._itemDrag._draggedItem).addClass("RadFileExplorer").css({visibility:"hidden"});
this._dragContainer.find("ul").css({height:"auto"});
this._dragContainer.find("li.rlvI").addClass("rfeFileDrag").append(this._createFileCountElement());
},_createFileCountElement:function(){var i=this.get_selectedItems().length;
if(i>1){var h=a("<span>").text(i).css({width:this._calculateFileCountWidth(i)+"px"});
return a("<span>").addClass("rfeFileCount").append(h);
}else{return a();
}},_calculateFileCountWidth:function(h){return(h+"").length*6;
},_calculateItemsPerRow:function(){var j=this._getItemWidth();
var i=this.get_boundContainer();
var h=e(f(d(i,"width")),i.clientWidth,i.offsetWidth);
return Math.floor(h/j);
},_getItemWidth:function(){return $telerik.getOuterSize(this.get_boundContainer().getElementsByTagName("li")[0]).width;
},_attachWaitForDraggingEvent:function(h){this._waitForDraggingDelegate=a.proxy(this._waitForDragging,this);
a(document).on("mousemove",{startPos:{x:h.pageX,y:h.pageY}},this._waitForDraggingDelegate);
},_showDraggableElement:function(){this._dragContainer.css({visibility:""});
},_getItemByIndex:function(h){return this.get_items()[h];
},_getNewItemIndexByDirection:function(h){var n=this.get_items().length;
if(n<=0){return -1;
}var j=n-1;
var m=this.control.get_selectedIndexes();
var i=isNaN(this._currentSelectPosition)?(m.length?m[0]:-1):this._currentSelectPosition;
var k=isNaN(this._currentSelectPosition)?(m.length?m[m.length-1]:-1):this._currentSelectPosition;
var l=h=="home"?0:h=="end"?j:h=="left"?i-1:h=="right"?k+1:h=="up"?i-this._calculateItemsPerRow():h=="down"?k+this._calculateItemsPerRow():i;
return Math.max(Math.min(l,j),0);
},_resetKeyboardFlags:function(){delete this._currentSelectPosition;
delete this._shiftSelectWaypoint;
},_onCommand:function(i,h){h.set_cancel(true);
},_handleMultiSelect:function(h){var i=$telerik.$(h.currentTarget).data("index");
var j=this.control.get_selectedIndexes();
h.preventDefault();
if(h.shiftKey&&j.length){if(h.ctrlKey){return this._handleShiftSelect(Math.min(j[0],i),Math.max(j[j.length-1],i));
}else{return this._handleShiftSelect(this._lastSelectedIndex,i);
}}else{if(!h.ctrlKey&&(j.length>1||j[0]!==i)){this.control.clearSelectedItems();
}if(!Array.contains(j,i)){this._lastSelectedIndex=i;
}if(h.ctrlKey){this.control.toggleSelection(i);
}else{this.control.selectItem(i);
}}this._focus(this.get_element());
},_handleShiftSelect:function(i,h){this.control.clearSelectedItems();
this._selectRange(h,i);
},_selectRange:function(j,h){var i=Math.min(j,h);
var k=Math.max(j,h);
do{this.control.selectItem(i);
}while(i++<k);
},_onPageChanged:function(k,h){var i=h.get_newValue();
var j=this.control.get_pageSize();
this.updatePageInfo();
this.control.set_currentPageIndex(i,true);
if(!this.suppressPageEvent){this.raiseEvent("page",new b.FileListPageEventArgs(i*j,j));
}},_onItemSelect:function(j,h){var i=this._getItemByIndex(h.get_itemIndex());
if(i){this.raiseEvent("itemSelect",i);
}},_onDragPrepare:function(h){h.stopImmediatePropagation();
var i=a(h.currentTarget).data("index");
if(h.which==3){this._onContextMenu(h);
}else{this._onHideContextMenu(h);
Telerik.Web.UI.RadListView.HandleDrag(h.originalEvent,this.control.get_id(),i);
}if(!Array.contains(this.control.get_selectedIndexes(),i)){this._handleMultiSelect(h);
}},_onDragStart:function(j,h){var i=new b.FileListItemCancelableEventArgs(this._getItemByIndex(h.get_itemIndex()));
this.raiseEvent("itemDragStart",i);
h.set_cancel(i.get_cancel());
if(!i.get_cancel()){a(document).one("mousemove",a.proxy(this._onCreateDraggable,this));
}},_onCreateDraggable:function(h){this._createDraggableElement();
this._attachWaitForDraggingEvent(h);
},_onDragging:function(i,h){this.raiseEvent("itemDragging",h);
},_waitForDragging:function(h){var j=h.data.startPos;
var i={x:h.pageX,y:h.pageY};
if(i.x!=j.x||i.y!=j.y){this._showDraggableElement();
this._offWaiting();
}},_offWaiting:function(){this._draggedItems=this.get_selectedItems();
a(document).off("mousemove",this._waitForDraggingDelegate);
delete this._waitForDragging;
},_onDrop:function(j,h){var i=new b.FileListItemsCancelableEventArgs(this._draggedItems,h.get_domEvent());
this.raiseEvent("itemDrop",i);
if(!i.get_cancel()){this.raiseEvent("itemDropComplete");
}delete this._draggedItems;
},_onContextMenu:function(h){var i=this._getItemFromjEvent(h);
this.raiseEvent("contextMenu",i);
},_onHideContextMenu:function(h){this.raiseEvent("hideContextMenu",h.originalEvent);
},_onDblClick:function(h){this._raiseOpen(this._getItemFromjEvent(h));
},_onKeyDown:function(i){if(i.shiftKey){this._handleShiftKeySelect(i);
}else{if(i.ctrlKey){this._handleCtrlKeySelect(i);
}else{if(i.keyCode==Sys.UI.Key.enter){var j=this.get_selectedItems();
if(j.length){this._raiseOpen(j[0]);
}}else{var h=this._getDirectionByKeyCode(i.keyCode);
if(h){this.navigate(h);
}}}}i.preventDefault();
},_onKeyUp:function(h){if(!(h.shiftKey||h.ctrlKey)&&(this._shiftSelectWaypoint||this._currentSelectPosition)){this._resetKeyboardFlags();
}},_ctrlSelectWaypoint:g,_handleCtrlKeySelect:function(i){var j=i.keyCode;
if(j==Sys.UI.Key.space){var k=this._getMarkedPosition();
this.control.toggleSelection(k);
if(Array.contains(this.control.get_selectedIndexes(),k)){this._shiftSelectWaypoint=k;
}this._currentSelectPosition=k;
}else{var h=this._getDirectionByKeyCode(j);
if(h){var l=this._getNewItemIndexByDirection(h);
this._currentSelectPosition=l;
}}this._markCurrentSelectPosition();
},_markCurrentSelectPosition:function(){var h=a(this._getListElement());
h.find("li a."+this._hoveredCssClass).removeClass(this._hoveredCssClass);
this._findNodeByIndex(this._currentSelectPosition).addClass(this._hoveredCssClass);
},_findNodeByIndex:function(h,i){i=i||a(this._getListElement());
return i.find("li a[data-index='"+h+"']");
},_getMarkedPosition:function(){return a(this._getListElement()).find("li a."+this._hoveredCssClass).data("index");
},_currentSelectPosition:g,_shiftSelectWaypoint:g,_handleShiftKeySelect:function(i){var j=i.keyCode;
this._ensureWaypoint();
var h=this._getDirectionByKeyCode(j);
if(h){var k=this._getNewItemIndexByDirection(h);
this._currentSelectPosition=k;
if(i.ctrlKey){this.selectRange(this._shiftSelectWaypoint,this._currentSelectPosition);
}else{this._handleShiftSelect(this._shiftSelectWaypoint,this._currentSelectPosition);
}}},_ensureWaypoint:function(){if(!this._shiftSelectWaypoint){this._shiftSelectWaypoint=this.control.get_selectedIndexes()[0];
}},_onContainerClick:function(h){if(this._isFocused&&this.control.get_selectedIndexes().length>0){this.clearSelection();
}},_raiseOpen:function(h){this.raiseEvent("open",h);
},_getItemFromjEvent:function(h){var i=a(h.currentTarget).data("index");
return this._getItemByIndex(i);
},_getDirectionByKeyCode:function(h){var i=Sys.UI.Key;
return i.up==h?"up":i.down==h?"down":i.left==h?"left":i.right==h?"right":i.home==h?"home":i.end==h?"end":"";
}};
b.ListViewFileList.registerClass("Telerik.Web.UI.FileExplorer.ListViewFileList",b.ClientBindableFileListView,b.IFileListView);
a.fn.nodoubletapzoom=function(){a(this).bind("touchstart",function h(j){var m=j.timeStamp;
var l=a(this).data("lastTouch")||m;
var i=m-l;
var k=j.originalEvent.touches.length;
a(this).data("lastTouch",m);
if(!i||i>500||k>1){return;
}j.preventDefault();
a(j.target).trigger("dblclick");
});
};
function f(h){return parseInt(h,10);
}function e(){var j=Number.MAX_VALUE;
for(var h=0;
h<arguments.length;
h++){var k=arguments[h];
if(!isNaN(k)&&k<j){j=k;
}}return j;
}})(Telerik.Web.UI,$telerik.$,Telerik.Web.UI.FileExplorer);
Type.registerNamespace("Telerik.Web.UI.FileExplorer");
(function(a,l){$telerik.toFileExplorer=function(m){return m;
};
$telerik.findFileExplorer=$find;
var c=window.alert;
var k=a.proxy;
var b=Telerik.Web.UI;
var h=b.FileExplorerHelper;
var d=h.canDelete;
var e=h.canUpload;
var j="px";
var g={FILE_RENAME_FAILED:"Illegal characters in path."};
Telerik.Web.UI.RadFileExplorer=function(m){var n=this;
Telerik.Web.UI.RadFileExplorer.initializeBase(this,[m]);
this._localization={};
this._initialGridData={};
this._uniqueId="";
this._selectedFile=null;
this._pathSeparator="/";
this._gridPageSize=10;
this._enableCopy=false;
this._explorerMode=Telerik.Web.UI.FileExplorerMode.Default;
this._allowFileExtensionRename=true;
this._initialGridPageIndex=0;
this._overwriteExistingFiles=false;
this._selectedFileListItem=null;
this._folderCache=[];
this._gridContextHandler=null;
this._actionsManager=null;
this._currentDirectoryInputID="";
this._postbackArgumentInputID="";
this._treeId="";
this._commandArgumentInputID="";
this._copiedPaths=[];
this._copyCursorClassName="rfeCopyCursor";
this._bindingGridFlag=false;
this._isPaging=false;
this._filterKeyWord=null;
this._btnUpload=null;
this._enabled=true;
this._droppedFilesCount=0;
this._dropEventTarget=null;
this._dropZoneOverlayElement=null;
this._droppedFilesTotalCount=0;
this._uploadedFilesCount=0;
this._btnCancelUpload=null;
this._btnCancelUploadID="btnCancelUpload";
this._uploadProgressLabel=null;
this._uploadProgressLabelID="lblDropUploadProgress";
this._dropUploadInfoPanel=null;
this._dropUploadInfoPanelID="dropUploadInfoPanel";
this._currentUploadRow=null;
this._isDropUploadCancelled=false;
this._shortCutManager=null;
this._keyDownDelegate=null;
this._htmlElKeyDownDelegate=null;
this._lastFocusedElement=null;
this._shouldShowGridContextMenu=true;
this._fileList=null;
this._fileNameInvalidCharacters=[92,47,58,42,63,34,60,62,124];
this.fileNameInvalidText="File names cannot contain any of the following characters";
n._onFileRenameDelegate=k(n._onFileRename,n);
};
Telerik.Web.UI.RadFileExplorer.prototype={initialize:function(){Telerik.Web.UI.RadFileExplorer.callBaseMethod(this,"initialize");
var p=this.get_grid();
var q=this.get_listView();
if((p&&this._explorerMode==b.FileExplorerMode.Default)||(q&&this._explorerMode==b.FileExplorerMode.Thumbnails)){var o=this._fileList=new b.FileExplorer.FileList({grid:p,listView:q,contextMenu:this.get_gridContextMenu(),container:this.get_gridPane().getContentElement(),fileExplorer:this});
p&&o.registerFileListView(new b.FileExplorer.GridFileList(p));
q&&o.registerFileListView(new b.FileExplorer.ListViewFileList(q));
o.chooseFileListView(this._getFileListViewNameByExplorerMode());
}if(this.get_asyncUpload()){var m=this._getControlClientID(this._btnCancelUploadID);
this._btnCancelUpload=$find(m);
var r=this._getControlClientID(this._uploadProgressLabelID);
this._uploadProgressLabel=$get(r);
var n=this._getControlClientID(this._dropUploadInfoPanelID);
this._dropUploadInfoPanel=$get(n);
}this.add_parentShown(this.get_element());
this.raiseEvent("init",Sys.EventArgs.Empty);
this.attachEventHandlers();
this.initializeControl();
this.raiseEvent("load",Sys.EventArgs.Empty);
},_getControlClientID:function(m){return this.get_id()+"_"+m;
},initializeControl:function(){if(this._fileList){var o=parseInt(this._initialGridPageIndex,10);
this._fileList.bindToServerData(this._initialGridData,o);
this._fileList._currentFolder=this.get_currentDirectory();
}if(this._selectedFile){this._selectInitialFile();
var q=this.get_tree();
if(q){this._scrollFolderIntoView(q.get_selectedNode());
}}var p=this.get_toolbar();
if(p!=null){var n={redoAction:Function.createDelegate(this,this._executeBackForward),undoAction:Function.createDelegate(this,this._executeBackForward)};
this._actionsManager=$create(Telerik.Web.UI.ActionsManager,null,n);
this._updateToolbar();
this._updateBackForward(this.get_currentDirectory());
}if($telerik.isFirefox){this._addFirefoxFormAutoComplete();
}if(!$telerik.isIE&&!$telerik.isOpera){this._copyCursorClassName+="CSS3";
}if(this._currentDirectoryInputID){var m=$get(this._currentDirectoryInputID);
if(m){m.setAttribute("autocomplete","off");
}}this._fixWindowLocalization();
this.set_commandArgument("");
this._disableTreeMultiSelectInTouch();
this._setRightToLeft();
if(this._renderMode===Telerik.Web.UI.RenderMode.Lite){this._updateSplitterHeight();
}},_updateSplitterHeight:function(){var o=$telerik.getContentSize(this.get_element()).height;
var r=0;
if(this._toolbar){var t=this._toolbar.get_element();
var s=function(v){return parseFloat(a(t).css(v));
};
var q=$telerik.getComputedStyle(t,"box-sizing")==="border-box";
var u=q?0:s("paddingTop")+s("paddingBottom");
r=s("height")+u;
}var m=$get(this.get_addressBox());
var n=0;
if(m){n=parseFloat(a(m).css("height"));
}var p=o-r-n;
if(p!==o){if(p>=0){this.get_tree().get_element().style.height=p+"px";
}this._resizeSplitterDelegate=Function.createDelegate(this,this._resizeSplitter);
this.get_splitter().add_load(this._resizeSplitterDelegate);
this._splitterHeight=p;
}},_resizeSplitter:function(){var m=this;
var n=m.get_fileList();
this.get_splitter().set_height(this._splitterHeight);
if(n){n.set_height(m._splitterHeight+j);
}},attachEventHandlers:function(){this._attachAjaxPanelHandlers();
if(this.get_tree()){this._attachTreeHandlers();
}if(this._fileList){this._attachFileListHandlers();
}if(this.get_toolbar()){this.get_toolbar().add_buttonClicked(Function.createDelegate(this,this.toolbarClicked));
}var m=this.get_asyncUpload();
this._btnUpload=$get(this.get_id()+"_btnUpload");
if(m!=null){this._attachAsyncUploadHandlers();
if(this._btnUpload!=null){this._onBtnUploadClickDelegate=Function.createDelegate(this,this._onBtnUploadClick);
$telerik.$(this._btnUpload).click(this._onBtnUploadClickDelegate);
}if(this._fileExplorerHasFileList()){this._dropZoneOverlayElement=this._getDropZoneOverlayElement();
this._attachDragAndDropZoneHandlers();
}this._btnCancelUpload.add_clicked(Function.createDelegate(this,this._onCancelUploadButtonClicked));
}this._validateFileNameInputDelegate=Function.createDelegate(this,this._validateFileNameInput);
this._registerShortcuts();
this.raiseEvent("eventHandlersAttached",Sys.EventArgs.Empty);
},_fileExplorerHasFileList:function(){return this._explorerMode!==b.FileExplorerMode.FileTree&&this.get_fileList();
},_getDropZoneOverlayElement:function(){var n=this.get_gridPane().get_element();
var m=n.getElementsByTagName("div");
var o=m[m.length-1];
return o;
},_attachDragAndDropZoneHandlers:function(){var o=this,m=o.get_grid(),p=a(".rfeThumbnailsContainer",o.get_element()).get(0),n=this._dropZoneOverlayElement;
o._onDropZoneDragEnterDelegate=Function.createDelegate(o,o._onDropZoneDragEnter);
if(m){this._gridElement=m.get_element();
$telerik.addHandler(this._gridElement,"dragenter",o._onDropZoneDragEnterDelegate);
}if(p){o._thumbnailsContainer=p;
$telerik.addHandler(p,"dragenter",o._onDropZoneDragEnterDelegate);
}this._onDropZoneDragLeaveDelegate=Function.createDelegate(this,this._onDropZoneDragLeave);
$telerik.addHandler(n,"dragleave",this._onDropZoneDragLeaveDelegate);
this._onDropZoneDropDelegate=Function.createDelegate(this,this._onDropZoneDrop);
$telerik.addHandler(n,"drop",this._onDropZoneDropDelegate);
},_detachDragAndDropZoneHandlers:function(){var o=this,m=o._grdiElement,p=o._thumbnailsContainer,n=this._dropZoneOverlayElement;
if(m){$telerik.removeHandler(m,"dragenter",o._onDropZoneDragEnterDelegate);
}if(p){$telerik.removeHandler(p,"dragenter",o._onDropZoneDragEnterDelegate);
}if(n){$telerik.removeHandler(n,"dragleave",this._onDropZoneDragLeaveDelegate);
$telerik.removeHandler(n,"drop",this._onDropZoneDropDelegate);
}},_onDropZoneDragEnter:function(){this._dropZoneOverlayElement.style.display="block";
},_onDropZoneDragLeave:function(){this._dropZoneOverlayElement.style.display="none";
},_onDropZoneDrop:function(){this._dropZoneOverlayElement.style.display="none";
},repaint:function(){var m=this.get_splitter();
m&&m.repaint();
},dispose:function(){if(this.get_asyncUpload()!==null&&this._fileExplorerHasFileList()){this._detachDragAndDropZoneHandlers();
this._dropZoneOverlayElement=null;
}this._folderCache=null;
if(this._btnUpload!=null){$telerik.$(this._btnUpload).unbind("click");
this._btnUpload=null;
}var m=this.get_gridPane();
var n=m&&m.getContentElement();
if(this._gridContextHandler&&n&&n._events){$removeHandler(n,"contextmenu",this._gridContextHandler);
this._gridContextHandler=null;
}this._attachShortcutHandlers(false);
Telerik.Web.UI.RadFileExplorer.callBaseMethod(this,"dispose");
},get_tree:function(){return $find(this._treeId==null?"":this._treeId);
},set_tree:function(m){if(m&&m.get_id){this._treeId=m.get_id();
}},get_fileList:function(){return this._fileList;
},set_fileList:function(m){this._fileList=m;
},clearFolderCache:function(){this._folderCache=[];
},filter:function(m){if(this._fileList){this._fileList.filterList(m);
}},copy:function(o){var n=b.FileExplorerControls;
var m=o==n.Tree?"tree":o==n.FileList?"grid":null;
if(m){this._copy(m);
}},paste:function(m){if(m&&m.isDirectory()&&this._copiedPaths.length>0){this._paste(m);
}},rename:function(m,n){if(m&&n){this._renameItem(m,n);
}},copyItems:function(m){this.clearCopyItems();
this.copyMoreItems(m);
},copyMoreItems:function(n){for(var m=0,o=n.length;
m<o;
m++){this._addItemToCopiedPaths(n[m]);
}},clearCopyItems:function(){this._copiedPaths=[];
},createItemFromPath:function(m){return this._createItemFromPath(m);
},addFileNameInvalidChar:function(n){var m=n.charCodeAt();
this._fileNameInvalidCharacters.push(m);
},removeFileNameInvalidChar:function(o){var m=o.charCodeAt();
var n=a.inArray(m,this._fileNameInvalidCharacters);
if(n!=-1){this._fileNameInvalidCharacters.splice(n,1);
}},get_overwriteExistingFiles:function(){return this._overwriteExistingFiles;
},set_overwriteExistingFiles:function(m){this._overwriteExistingFiles=m;
this._getChildElement("chkOverwrite").checked=m;
},_fixWindowLocalization:function(){if(Telerik.Web.UI.RadWindowUtils&&Telerik.Web.UI.RadWindowUtils.Localization){var m=this.get_localization();
Telerik.Web.UI.RadWindowUtils.Localization.OK=m.OK;
Telerik.Web.UI.RadWindowUtils.Localization.Cancel=m.Cancel;
}},_addFirefoxFormAutoComplete:function(){var m=this.get_element();
while(m!=null&&m.tagName.toLowerCase()!="form"){m=m.parentNode;
}if(m!=null){m.setAttribute("autocomplete","off");
}},_setRightToLeft:function(){var m=null;
var n=this.get_element();
if(n){m=$telerik.isRightToLeft(n);
}this._isRightToLeft=m;
if(m){Sys.UI.DomElement.addCssClass(n,"rfeRtl");
}},_postbackTreeAjaxPanel:function(m){if(this._postbackArgumentInputID){var o=$get(this._postbackArgumentInputID);
o.value=m;
}var p=this.get_postbackButton();
if(p){var n=$get(p);
n.click();
}},_onAjaxRequestStart:function(o,m){var n=m.get_postBackElement();
if(n&&(n.id==this.get_postbackButton()||(this.get_tree()&&n.id==this.get_tree().get_id()))){this._showLoadingPanel(this.get_treePane().get_id());
this.raiseEvent("ajaxRequestStart",Sys.EventArgs.Empty);
var p=this.get_tree();
this._treeId=p!=null?p.get_id():null;
m.get_request().isRFE=this.get_id();
}},_onAjaxResponseEnd:function(t,m){var r=m.get_response();
if(!r){return;
}var w=r.get_webRequest();
if(w&&w.isRFE&&w.isRFE==this.get_id()){this._hideLoadingPanel(this.get_treePane().get_id());
m.get_response().get_webRequest().isRFE=null;
if(this._treeId!=null){this._attachTreeHandlers();
this._disableTreeMultiSelectInTouch();
}var n=this.get_currentDirectory();
if(this._currentDirectory&&this._currentDirectory!=n){this._currentDirectory=null;
var p=this._createItemFromPath(n);
var o=new Telerik.Web.UI.FileExplorerEventArgs(p,"");
this.raiseEvent("folderChange",o);
}this._refreshFileList(n);
var u=this.get_tree();
if(u){var v=u.get_element();
v.setAttribute("tabindex","0");
if($telerik.isIE7||$telerik.isIE6){v.setAttribute("tabIndex","0");
}v.style.outlineStyle="none";
}this._attachFocusHandlers(false);
var q=this._lastFocusedElement;
if(q){q=this._lastFocusedElement=$get(q.id);
var s=this;
window.setTimeout(function(){s._focus(q);
},0);
}this.raiseEvent("ajaxRequestEnd",Sys.EventArgs.Empty);
}},_attachAjaxPanelHandlers:function(){Sys.WebForms.PageRequestManager.getInstance().add_beginRequest(Function.createDelegate(this,this._onAjaxRequestStart));
Sys.WebForms.PageRequestManager.getInstance().add_endRequest(Function.createDelegate(this,this._onAjaxResponseEnd));
},_attachFileListHandlers:function(){this._fileList.add_filter(Function.createDelegate(this,function(n,m){this.raiseEvent("filter",m);
}));
this._fileList.add_itemSelect(Function.createDelegate(this,function(n,m){var o=m.get_item();
this._updateToolbar(null,null,n._getItemPermissions(o));
this.raise_itemSelected(o);
}));
this._fileList.add_callback(Function.createDelegate(this,function(n,m){var o=this.get_gridPane().get_id();
this._hideLoadingPanel(o);
this._showLoadingPanel(o);
}));
this._fileList.add_callbackComplete(Function.createDelegate(this,function(n,m){var o=this.get_gridPane().get_id();
this._hideLoadingPanel(o);
}));
this._fileList.add_folderLoaded(Function.createDelegate(this,function(n,m){var o=this._getCurrentFolderItem();
this.raiseEvent("folderLoaded",new Telerik.Web.UI.FileExplorerEventArgs(o,""));
}));
},_showFolderFileList:function(m){if(this.get_currentDirectory()==m){return;
}this.set_currentDirectory(m);
if(this._fileList){this._fileList.showFolderFileList(m);
}},_refreshFileList:function(m){this.set_currentDirectory(m);
if(this._fileList){this._fileList.refreshFileList(m);
}},loadFolder:function(p,m){if(!p){return;
}if(m==null){m=true;
}if(this.get_currentDirectory()==p&&m){return;
}var o=this._createItemFromPath(p);
var n=new Telerik.Web.UI.FileExplorerEventArgs(o,"");
this.raiseEvent("folderChange",n);
if(n.get_cancel()){return;
}this.set_currentDirectory(p,m);
this._postbackTreeAjaxPanel("LoadFolder_"+p);
},toolbarClicked:function(o,m){var n=m.get_item().get_value();
this._fireCommand(n);
},_fireCommand:function(m){switch(m){case"Back":this._back();
break;
case"Forward":this._forward();
break;
case"Refresh":this.refresh();
break;
case"NewFolder":this.createNewDirectory();
break;
case"Delete":this.deleteSelectedItems();
break;
case"Upload":this._showUploadWindow();
break;
case"Open":this.open();
break;
case"GridView":this._fileList.chooseFileListView("grid");
this._selectedFileListItem=null;
break;
case"ThumbnailsView":this._fileList.chooseFileListView("thumbnails");
this._selectedFileListItem=null;
break;
}},_addItemToCopiedPaths:function(m){Array.add(this._copiedPaths,m);
},_copy:function(m,q){var t=this.get_tree();
if(t){this._focus(t.get_element());
}this._copiedPaths=[];
if(q){this._addItemToCopiedPaths(q);
}else{if(m=="grid"){if(this._fileList){this._fileList.focus();
var r=this.get_selectedItems();
for(var n=0;
n<r.length;
n++){this._addItemToCopiedPaths(r[n]);
}}}else{if(m=="tree"){if(t){var s=t.get_selectedNodes();
for(var p=0;
p<s.length;
p++){var o=this._createItemFromTreeViewNode(s[p]);
this._addItemToCopiedPaths(o);
}}}}}},_paste:function(p){if(this._copiedPaths.length==0||!p.isDirectory()){return;
}var n=new Telerik.Web.UI.FileExplorerCopyEventArgs(this._copiedPaths,p.get_path());
this.raiseEvent("copy",n);
if(!n.get_cancel()&&n._items.length>0){var m=p.get_path();
for(var o=0;
o<n._items.length;
o++){var q=n._items[o].isDirectory()?"D":"F";
m+="***"+q+n._items[o].get_path();
}if(this._fileList){this._fileList.clearFolderCache(p.get_path());
}this._postbackTreeAjaxPanel("CallbackFnCopy_"+m);
}},_gridOpenFolder:function(n){var o=this.get_tree();
if(o!=null){var m=o.findNodeByValue(n);
if(m){m.select();
m.expand();
this._showFolderFileList(n);
this.set_currentDirectory(n);
this._focusFileListAfterCallback();
}}},_isOpenExtension:function(m){return(m=="docx"||m=="doc"||m=="xlsx"||m=="xls"||m=="zip");
},open:function(m){if(!this._enabled){return;
}if(!m){m=this.get_selectedItem();
}if(m){if(!m.isDirectory()||(m.isDirectory()&&m.get_path()!=this.get_currentDirectory())){if(this.raiseFileItemCancelEvent(m,"fileOpen")){return false;
}}if(m.isDirectory()){if(this.raiseFileItemCancelEvent(m,"folderChange")){return false;
}this._gridOpenFolder(m.get_path());
}else{if(this.get_enableOpenFile()){var o=m.get_url();
if(this._isOpenExtension(m.get_extension())){window.location.href=o;
}else{var n=this.get_windowManager();
window.setTimeout(function(){var p=n.open(o,null);
p.set_title(m.get_name());
p.set_modal(false);
},10);
}}}}},deleteSelectedItems:function(n){var m=this.get_selectedItems();
if(m&&m.length>0){this.deleteItem(m,n);
}},deleteItem:function(p,u){if((typeof(u)=="undefined")||(u!=false)){var n=function(w){if(w){this._deleteItem(p);
}};
var s=this.get_windowManager();
var o=this._getDialogDimentions();
var q=this.get_localization()["ConfirmDelete"];
var r=this.get_localization()["Delete"];
var m=Function.createDelegate(this,n);
var v=s.radconfirm(q,m,o.width,o.height,null,r);
if(this._renderMode===b.RenderMode.Lite){var t=a(v.get_popupElement());
t.addClass("rfeDeleteDialog").height("");
t.find(".rwExternalContent").height("");
}}else{this._deleteItem(p);
}},_deleteItem:function(q){if(!Array.isInstanceOfType(q)){q=[q];
}var m="";
for(var o=0,r=q.length;
o<r;
o++){var p=q[o];
if(!p.get_path){p=this._createItemFromPath(p);
}if(p&&p.get_name()===".."){continue;
}if(p&&p.get_path){var n=new Telerik.Web.UI.FileExplorerEventArgs(p,"");
this.raiseEvent("delete",n);
if(n.get_cancel()){continue;
}m+=p.get_path()+"***";
if(p.isDirectory()&&this._fileList){this._fileList.clearFolderCache(p.get_path());
}}}if(m.length>0){this._currentDirectory=this.get_currentDirectory();
this._postbackTreeAjaxPanel("CallbackFnDelete_"+m);
}},_createFolder:function(q,p){var o=this._createItemFromPath(q);
var m=new Telerik.Web.UI.FileExplorerEventArgs(o,p);
this.raiseEvent("createNewFolder",m);
if(m.get_cancel()){return false;
}var n=q+"***"+p;
this._postbackTreeAjaxPanel("CallbackFnCreate_"+n);
},createNewDirectory:function(o,n){if(!o){o=this.get_currentDirectory();
}if(!n){var m=Function.createCallback(Function.createDelegate(this,function(p,q){if(p){this._createFolder(q,p);
}}),o);
this._showPromptDialog(m,{title:"CreateNewFolder",value:this.get_newFolderDefaultValue(),inputValidator:this._validateFileNameInputDelegate,timeout:10});
}else{this._createFolder(o,n);
}},refresh:function(n){var m=this._fileList;
if(n&&m){this._fileList.selectFileList(a.makeArray(n));
}this.loadFolder(this.get_currentDirectory(),false);
},_showUploadWindow:function(){var m=this._getChildElement("uploadContainer");
var o=this.get_windowManager();
var n=this._renderMode;
window.setTimeout(function(){var u=o.open(null,o.get_id()+"fileExplorerUpload",m);
var r=0;
if(n===Telerik.Web.UI.RenderMode.Lite){r=$telerik.getComputedStyle(u.get_contentElement(),"height");
}m.style.overflow="";
m.style.height="auto";
m.style.width="auto";
m.style.position="";
if(n===Telerik.Web.UI.RenderMode.Lite){var p=$telerik.getComputedStyle(u.get_contentElement(),"height");
var q=parseFloat(p)-parseFloat(r);
var s=m.getElementsByTagName("ul")[0];
var t=$telerik.getComputedStyle(m.getElementsByTagName("ul")[0],"height");
s.style.height=parseFloat(t)-q+"px";
}},10);
},_updateToolbar:function(o,m,n){if(!this._enabled||this.get_toolbar()==null){return;
}if(typeof(n)=="undefined"||n==null){n=this.get_currentPermissions();
}this._setToolbarButtonEnabledState("Back",this._actionsManager&&this._actionsManager.canUndo());
this._setToolbarButtonEnabledState("Forward",this._actionsManager&&this._actionsManager.canRedo());
this._setToolbarButtonEnabledState("Open",true);
this._setToolbarButtonEnabledState("Refresh",true);
this._setToolbarButtonEnabledState("NewFolder",e(n));
this._setToolbarButtonEnabledState("Upload",e(n));
this._setToolbarButtonEnabledState("Delete",d(n));
if(this._fileList){this._setToolbarButtonEnabledState("GridView",!!this._fileList.getFileListViewByName("grid"));
this._setToolbarButtonEnabledState("ThumbnailsView",!!this._fileList.getFileListViewByName("thumbnails"));
}},_setToolbarButtonEnabledState:function(m,n){var o=this.get_toolbar();
if(o!=null){o.get_items().forEach(function(p){if(p.get_value()==m||m=="all"){p.set_enabled(n);
}});
}},_attachTreeHandlers:function(){var m=this.get_tree();
if(m!=null){m.add_nodeClicked(Function.createDelegate(this,this._onTreeNodeClicked));
m.add_nodeDoubleClick(Function.createDelegate(this,this._onTreeNodeDoubleClick));
m.add_contextMenuShowing(Function.createDelegate(this,this._onTreeContextMenuShowing));
m.add_contextMenuItemClicked(Function.createDelegate(this,this._onTreeContextMenuItemClicked));
m.add_nodeDropping(Function.createDelegate(this,this._onTreeNodeDropping));
m.add_nodeDragging(Function.createDelegate(this,this._onTreeNodeDragging));
m.add_mouseOver(Function.createDelegate(this,this._onTreeMouseOver));
m.add_mouseOut(Function.createDelegate(this,this._onTreeMouseOut));
m.add_nodeEditing(Function.createDelegate(this,this._onTreeNodeEditing));
m.add_keyPressing(Function.createDelegate(this,this._onTreeKeyPressing));
m.add_nodePopulated(Function.createDelegate(this,this._onTreeNodePopulated));
}},_isOverElement:function(m,n){while(m){if(m.id==n){return m;
}m=m.parentNode;
}return null;
},_onTreeNodePopulated:function(o,m){if(this._explorerMode==Telerik.Web.UI.FileExplorerMode.FileTree){var n=this._createItemFromTreeViewNode(m.get_node());
this.raiseEvent("folderLoaded",new Telerik.Web.UI.FileExplorerEventArgs(n,""));
}},_onTreeKeyPressing:function(o,m){var n=m.get_domEvent();
if(n&&n.keyCode==13){m.set_cancel(true);
$telerik.cancelRawEvent(n);
this._onTreeNodeDoubleClick(o,m);
}},_onTreeNodeDragging:function(o,m){this._checkCopyCursor(o,m);
var n=m.get_domEvent();
this._scrollTreeViewOnDrag(n);
},_onTreeNodeEditing:function(s,m){this._treeKeyDownDelegate=null;
var q=m.get_node();
if(q){var p=m.get_newText(),n=this._createItemFromTreeViewNode(q),o=new Telerik.Web.UI.FileExplorerEventArgs(n,p);
this.raiseEvent("move",o,true);
if(o.get_cancel()){m.set_cancel(o.get_cancel());
}else{var r=q.get_parent();
if(r&&r.get_value){if(this._fileList){this._fileList.clearFolderCache(r.get_value());
}}}}},_onTreeMouseOver:function(n,m){this._currentTreeNode=m.get_node();
},_onTreeMouseOut:function(n,m){this._currentTreeNode=null;
},_onTreeNodeDropping:function(z,m){if(this._enableCopy){this._updateCopyCursor(false);
}var v=this._enableCopy&&m.get_domEvent().ctrlKey;
var r=v?"copy":"move";
var B=m.get_sourceNodes();
var q=m.get_destNode();
if(!q){var p=m.get_htmlElement();
if(!p){return;
}var t=this.get_grid();
var s=t!=null?this._isOverElement(p,t.get_id()):null;
if(s){m.set_htmlElement(s);
}else{m.set_cancel(true);
}}else{if(this._isNodeADirectory(q)){var x=q.get_value();
for(var u=0;
u<B.length;
u++){var w=this._createItemFromTreeViewNode(B[u]);
var n=new Telerik.Web.UI.FileExplorerEventArgs(w,x);
this.raiseEvent(r,n);
if(n.get_cancel()){m.set_cancel(true);
}}}else{m.set_cancel(true);
}}if(!m.get_cancel()){if(!v){for(var o=0;
o<B.length;
o++){var A=B[o];
var y=A.get_parent();
if(y&&y.get_value){if(this._fileList){this._fileList.clearFolderCache(y.get_value());
}}if(this._fileList&&this._isNodeADirectory(q)){this._fileList.clearFolderCache(A.get_value());
}}}this.set_commandArgument(r);
}},_onTreeContextMenuShowing:function(p,m){var o=m.get_node();
var n=this._createItemFromTreeViewNode(o);
var q=this._setContextMenuItemsState(m.get_menu(),n.get_permissions());
if(!q){m.set_cancel(true);
$telerik.cancelRawEvent(m.get_domEvent());
}},_onTreeContextMenuItemClicked:function(u,m){var v=m.get_node();
var p=m.get_menuItem().get_value();
switch(p){case"Rename":v.startEdit();
var q=v.get_inputElement();
if(!this._allowFileExtensionRename){var o=this._createItemFromTreeViewNode(v);
if(!o.isDirectory()){q.value=b.FileExplorerHelper.stripExtension(o);
}}this._attachFileNameValidator(q);
var w=u.get_childListElement();
this._treeKeyDownDelegate=Function.createDelegate(this,this._treeKeyDown);
if(w){$telerik.addHandler(w,"keydown",this._treeKeyDownDelegate,true);
}break;
case"NewFolder":if(!this._isNodeADirectory(v)){v=v.get_parent();
}var r=v.get_value();
this.createNewDirectory(r);
break;
case"Delete":var n=this._createItemFromTreeViewNode(v);
this.deleteItem(n);
break;
case"Upload":this._showUploadWindow();
break;
case"Copy":var t=null;
if(!v.get_selected()){t=this._createItemFromTreeViewNode(v);
}this._copy("tree",t);
break;
case"Paste":var s=this._createItemFromTreeViewNode(v);
this._paste(s);
break;
}},_onTreeNodeDoubleClick:function(p,m){var o=m.get_node();
var n=this._createItemFromTreeViewNode(o);
this.open(n);
},_onTreeNodeClicked:function(r,m){if(!this._enabled){return;
}var q=m.get_node();
var p=this._createItemFromTreeViewNode(q);
var o=r.get_multipleSelect()&&m.get_domEvent()&&(m.get_domEvent().ctrlKey||m.get_domEvent().shiftKey);
if(p.isDirectory()&&!o){var n=new Telerik.Web.UI.FileExplorerEventArgs(p,"");
this.raiseEvent("folderChange",n);
if(n.get_cancel()){return;
}q.expand();
this._showFolderFileList(p.get_path());
return true;
}return this.raise_itemSelected(p);
},_attachAsyncUploadHandlers:function(){var m=this.get_asyncUpload();
if(m!=null){m.add_filesUploaded(Function.createDelegate(this,this._onAsyncUploadFilesUploaded));
m.add_fileUploading(Function.createDelegate(this,this._onAsyncUploadFilesUploading));
m.add_fileUploaded(Function.createDelegate(this,this._onAsyncUploadFileUploaded));
m.add_validationFailed(Function.createDelegate(this,this._onAsyncUploadValidationFailed));
m.add_fileDropped(Function.createDelegate(this,this._onAsyncUploadFileDropped));
m.add_filesSelected(Function.createDelegate(this,this._onAsyncFilesSelected));
}},_onBtnUploadClick:function(){if(!this._btnUpload.control.get_enabled()){return false;
}var o=this.get_windowManager();
if(o){var m=o.getActiveWindow();
var n=m&&a.contains(m.get_popupElement(),this._btnUpload);
if(n){m.close("SenderIsBtnUpload");
this._uploadFilesViaAsyncUpload();
}}return false;
},_uploadFilesViaAsyncUpload:function(){var m=this.get_asyncUpload();
if(m!=null){var p=m.getUploadedFiles();
if(p.length>0){var n=this._fileList;
if(n){if(p.length==1||!n.get_allowMultiSelect()){var o=function(q){q.selectFileByName(p[p.length-1]);
q._selectedFiles=null;
q.remove_folderLoaded(o);
};
n.add_folderLoaded(o);
}}this.refresh(p);
}m.deleteAllFileInputs();
}},_onAsyncUploadFilesUploaded:function(){if(this._droppedFilesCanBeUploadedInFileExplorer()){this._uploadFilesViaAsyncUpload();
this._finalizeFileDrop();
}if(this._btnUpload!=null){this._btnUpload.control.set_enabled(true);
}},_droppedFilesCanBeUploadedInFileExplorer:function(){return this._isFileDroppedInFileExplorerDropZone(this._dropEventTarget)&&this._isDropUploadCancelled===false;
},_finalizeFileDrop:function(){this._hideFilesDroppedLoadingPanel();
this._clearDragAndDropHelperFields();
this._displayUploadedFileCountAndTotalFileCount();
},_isFileDroppedInFileExplorerDropZone:function(m){var n=this.get_gridPane().get_element();
return n===m||$telerik.isDescendant(n,m);
},_hideFilesDroppedLoadingPanel:function(){this._hideLoadingPanel(this.get_id());
this._dropUploadInfoPanel.style.display="none";
},_clearDragAndDropHelperFields:function(){this._droppedFilesTotalCount=0;
this._uploadedFilesCount=0;
this._dropEventTarget=null;
this._droppedFilesCount=0;
},_displayUploadedFileCountAndTotalFileCount:function(p,o){var n="";
p=typeof p!=="undefined"?p:0;
o=typeof o!=="undefined"?o:0;
if(o>0){var m=Math.round(p/o*1000)/10;
n="Total Progress "+m+"% ("+p+") Total "+o;
}this._uploadProgressLabel.innerHTML=n;
},_onAsyncUploadFilesUploading:function(n,m){this._decreaseDroppedFileCount();
if(this._isDropUploadCancelled===true){m.set_cancel(true);
if(this._isThisLastUploadingFile()){this._finalizeFileDrop();
}}this._currentUploadRow=m.get_row();
if(this._btnUpload!=null){this._btnUpload.control.set_enabled(false);
}},_decreaseDroppedFileCount:function i(){this._droppedFilesCount--;
},_isThisLastUploadingFile:function(){return this._droppedFilesCount===0&&this._isDropUploadCancelled===false;
},_onAsyncUploadValidationFailed:function(n,m){this._showUploadValidationFailedAlert(m.get_fileName());
this._decreaseDroppedFileCount();
if(this._allDroppedFilesAreInvalid()){this._removeDroppedFiles();
this._finalizeFileDrop();
}},_showUploadValidationFailedAlert:function(m){var n=this.get_localization();
c(m+"\n\n"+n.InvalidFileSize+"\n"+n.InvalidFileExtension);
},_allDroppedFilesAreInvalid:function(){var m=this.get_asyncUpload();
return m.getInvalidFiles().length+1===this._droppedFilesTotalCount;
},_onAsyncUploadFileDropped:function(n,m){this._droppedFilesCount++;
this._dropEventTarget=m.get_originalDropEvent().currentTarget;
},_onAsyncFilesSelected:function(o,m){var n=m.get_dropArgs();
if(n&&this._isFileDroppedInFileExplorerDropZone(n.target)){this._raiseFilesDroppingEvent(m);
if(!m.get_cancel()){this._showFilesDroppedLoadingPanel();
this._droppedFilesTotalCount=m.get_count();
this._displayUploadedFileCountAndTotalFileCount(0,m.get_count());
}this._isDropUploadCancelled=false;
}},_raiseFilesDroppingEvent:function(m){var n=this._createFileDroppingEventArgs(m);
this.raiseEvent("filesDropping",n);
m.set_cancel(n.get_cancel());
},_showFilesDroppedLoadingPanel:function(){this._showLoadingPanel(this.get_id());
this._dropUploadInfoPanel.style.display="block";
},_createFileDroppingEventArgs:function(m){return a.extend({get_count:function(){return m.get_count();
},get_dropArgs:function(){return m.get_dropArgs();
}},new Sys.CancelEventArgs());
},_onCancelUploadButtonClicked:function(){if(this._droppedFilesTotalCount>0){this._cancelFilesUpload();
}},_cancelFilesUpload:function(){this._isDropUploadCancelled=true;
try{this._cancelCurrentFileUpload();
}catch(m){}this._removeDroppedFiles();
this._finalizeFileDrop();
},_cancelCurrentFileUpload:function(){var m=this.get_asyncUpload();
var n=this._currentUploadRow;
if(n){m._uploadModule.cancel(n);
}},_removeDroppedFiles:function(){this.get_asyncUpload().deleteAllFileInputs();
},_onAsyncUploadFileUploaded:function(){var m=++this._uploadedFilesCount;
this._displayUploadedFileCountAndTotalFileCount(m,this._droppedFilesTotalCount);
},_getGridDataItemPath:function(m){if(!m){return null;
}var n=m.Path;
if(!n){n=this.get_currentDirectory();
if(n&&n.charAt(n.length-1)!=this.get_pathSeparator().charAt(0)){n+=this.get_pathSeparator();
}n+=m.Name;
}return n;
},_setContextMenuItemsState:function(q,r,o){if(q==null||q.get_items().get_count()==0){return false;
}var m=0;
var p=q.get_items();
var n=this._copiedPaths.length>0;
p.forEach(function(s){var t=true;
switch(s.get_value()){case"Upload":case"NewFolder":t=e(r);
break;
case"Delete":t=d(r);
t=t&&(o!=true);
break;
case"Rename":t=e(r)&&d(r);
t=t&&(o!=true);
break;
case"Copy":t=(o!=true);
break;
case"Paste":t=e(r);
t=t&&n;
break;
}if(!t){m++;
}s.set_enabled(t);
});
return true;
},_renameItem:function(n,o){var m=new Telerik.Web.UI.FileExplorerEventArgs(n,o,true);
this.raiseEvent("move",m);
if(m.get_cancel()){return false;
}var p=b.FileExplorerHelper.extractPathFromExplorerItem(n,this);
this._postbackTreeAjaxPanel("CallbackFnRenameItem_"+p+"***"+o);
},_onFileRename:function(o,m){var n=this;
if(o){if(n._isValidFileName(o)){n._renameItem(m,o);
}else{n._alertFileRenameFailed();
}}},_isValidFileName:function(n){var m=this;
var q=m._fileNameInvalidCharacters;
var r=q&&q.length?q.length:0;
var p;
for(var o=0;
o<r;
o++){p=String.fromCharCode(q[o]);
if(n.indexOf(p)>-1){return false;
}}return true;
},_alertFileRenameFailed:function(){c(g.FILE_RENAME_FAILED);
},_isNodeADirectory:function(n){if(this._explorerMode==Telerik.Web.UI.FileExplorerMode.Default){return true;
}else{var m=n.get_attributes();
return !m.getAttribute("Length");
}},_updateCopyCursor:function(m){if(m){Sys.UI.DomElement.addCssClass(this.get_element(),this._copyCursorClassName);
}else{Sys.UI.DomElement.removeCssClass(this.get_element(),this._copyCursorClassName);
}},_checkCopyCursor:function(p,m){if(this._enableCopy){var n=m.get_domEvent().ctrlKey;
var o=Sys.UI.DomElement.containsCssClass(this.get_element(),this._copyCursorClassName);
if(n!=o){this._updateCopyCursor(n);
}}},_probeTreeForScrolling:function(m){var p={x:0,y:0};
var n=$telerik.isTouchDevice?$telerik.getTouchEventLocation(m):{x:m.clientX,y:m.clientY};
var q=this.get_treePane();
var o=$telerik.getBounds(q.getContentElement());
if(n.y<o.y+20){p.y=-1;
}else{if(n.y>o.y+o.height-20){p.y=1;
}}if(n.x<o.x+20){p.x=-1;
}else{if(n.x>o.x+o.width-20){p.x=1;
}}return p;
},_scrollTreeViewOnDrag:function(m){var o=this.get_treePane();
var n=this._probeTreeForScrolling(m);
if(n!=0){o.setScrollPos(o.getScrollPos().left+n.x*5,o.getScrollPos().top+n.y*5);
}},_lightweightDialogDimentions:{height:155,heightSilk:155,heightGlow:155,heightBootstrap:215,heightBlackMetroTouch:215,heightMetroTouch:215},_classicDialogDimentions:{height:330,heightSilk:195,heightGlow:195,heightBootstrap:195,heightBlackMetroTouch:215,heightMetroTouch:215},_getDialogDimensions:function(){if(this._renderMode===Telerik.Web.UI.RenderMode.Lite){return this._lightweightDialogDimentions;
}else{return this._classicDialogDimentions;
}},_getDialogDimentions:function(o){var n=this._getDialogDimensions();
var p={width:330,height:n.height,uploadItemHeight:29};
var m=this.get_windowManager().get_skin();
switch(m){case"Bootstrap":case"Glow":case"Material":case"Silk":p.height=n["height"+m];
break;
case"BlackMetroTouch":case"MetroTouch":p.width=400;
p.height=n["height"+m];
p.uploadItemHeight=41;
break;
default:break;
}return p;
},_showPromptDialog:function(m,s){var p=this.get_localization();
var n=this._getDialogDimentions();
var r=a.extend({width:n.width,height:n.height,title:"",message:"",value:"",timeout:false,inputValidator:null},s||{});
r.title=p[r.title]||r.title;
r.message=p[r.message]||r.message||r.title;
var q=this.get_windowManager();
if(r.timeout===false){var t=q.radprompt(r.message,m,r.width,r.height,null,r.title,r.value);
return this._attachPromptDialogValidator(t,r.inputValidator);
}else{setTimeout(Function.createDelegate(this,function(){var o=q.radprompt(r.message,m,r.width,r.height,null,r.title,r.value);
this._attachPromptDialogValidator(o,r.inputValidator);
}),r.timeout);
}},_attachPromptDialogValidator:function(o,n){if(n){var m=o.get_popupElement().getElementsByTagName("input")[0];
$telerik.addHandler(m,"keypress",n,true);
}return o;
},_attachFileNameValidator:function(m){$telerik.addHandler(m,"keypress",this._validateFileNameInputDelegate,true);
},_getCurrentFolderItem:function(){var m=this._createItemFromPath(this.get_currentDirectory());
return m;
},_createItemFromPath:function(o){var m=null;
var p=this.get_tree();
if(p!=null){var n=p.findNodeByValue(o);
m=this._createItemFromTreeViewNode(n);
}if(m==null&&this._fileList){m=this._findItemByPath(o);
}return m;
},_validateFileNameInput:function(m){if(this._shouldPreventFileNameInput(m)){$telerik.cancelRawEvent(m);
this._alertWrongFileNameInput(m.target);
}},_shouldPreventFileNameInput:function(m){var o=this._fileNameInvalidCharacters;
var n=m.charCode||m.keyCode;
return a.inArray(n,o)>-1;
},_shouldPreventRename:function(o){var n=this._getInvalidCharsToString().trim();
for(var m=0;
m<n.length;
m++){if(a.inArray(n[m],o)>-1){return true;
}}return false;
},_alertWrongFileNameInput:function(m){var n=this.get_tooltipControl();
n.set_showEvent(Telerik.Web.UI.ToolTipShowEvent.FromCode);
n.set_targetControl(m);
n.set_text(this.fileNameInvalidText+":<br />"+this._getInvalidCharsToString());
setTimeout(function(){n.show();
},100);
},_getInvalidCharsToString:function(){var n=this._fileNameInvalidCharacters;
var m=[];
for(var o=0;
o<n.length;
o++){m.push(String.fromCharCode(n[o]));
}return m.join(" ");
},getFileExplorerItemFromGridDataItem:function(o){var m=o.get_dataItem();
var p=this._getGridDataItemPath(m);
var n=this._findItemByPath(p);
return n;
},getFileExplorerItemFromNode:function(m){return this._createItemFromTreeViewNode(m);
},_createItemFromTreeViewNode:function(r){if(!r){return null;
}var m=r.get_attributes();
var q=m.getAttribute("Name");
var v=m.getAttribute("Length");
if(v){v=parseInt(v,10);
}var t=m.getAttribute("Path");
var u=parseInt(m.getAttribute("Permissions"),10);
var x=m.getAttribute("Url");
var n=b.FileExplorerHelper.parseExtension(m.getAttribute("Extension"),q);
var w=v==null?Telerik.Web.UI.FileExplorerItemType.Directory:Telerik.Web.UI.FileExplorerItemType.File;
if(w==Telerik.Web.UI.FileExplorerItemType.File&&!t){var s=r.get_parent();
if(s){t=s.get_value();
if(t&&t.charAt(t.length-1)!=this.get_pathSeparator().charAt(0)){t+=this.get_pathSeparator();
}t+=q;
}}var p={type:w,permissions:u,name:q,path:t,size:v,url:x,extension:n};
var o=$create(Telerik.Web.UI.FileExplorerItem,p,null,null,null);
return o;
},_hideLoadingPanel:function(m){if(m==null){return;
}var n=this.get_ajaxLoadingPanel();
if(n){n.hide(m);
}},_showLoadingPanel:function(m){if(m==null){return;
}var n=this.get_ajaxLoadingPanel();
if(n){n.show(m);
}},_scrollFolderIntoView:function(m){if(!m){return;
}var p=this.get_treePane();
var o=p.getScrollPos();
var n=this._getNodeOffset(m);
if(this._shouldScrollTreePaneVertical(n)){o.top=this._calculateNewScrollValue(n,"top");
}if(this._shouldScrollTreePaneHorizontal(n)){o.left=this._calculateNewScrollValue(n,"left");
}if(o!=p.getScrollPos()){p.setScrollPos(o.left,o.top);
}},_calculateNewScrollValue:function(o,m){var n=m=="top"?"Height":"Width";
var q=this.get_treePane().getContentElement();
var p=q["scroll"+n]-q["client"+n];
var r=m=="top"?Math.ceil(q["client"+n]/2):0;
return Math.max(Math.min(o[m]-r,p),0);
},_shouldScrollTreePaneVertical:function(m){var n=this.get_treePane();
return(m.top>n.getContentElement().clientHeight)||(m.top<0);
},_shouldScrollTreePaneHorizontal:function(o){var p=this.get_treePane();
var m=p.getContentElement();
var n=0.45;
if(o.left>0){return o.left>n*m.clientWidth;
}return true;
},_getNodeOffset:function(m){var p=this.get_treePane();
var o=a(p.getContentElement()).position();
var n=a(m.get_element()).position();
return{top:n.top-o.top,left:n.left-o.left};
},_disableTreeMultiSelectInTouch:function(){if($telerik.isTouchDevice&&this._explorerMode==Telerik.Web.UI.FileExplorerMode.FileTree&&this.get_tree()){this.get_tree().set_multipleSelect(false);
}},_findItemByPath:function(n){var m=this._fileList.findFileByPath(n);
return m?this._fileList._toFileItem(m):null;
},get_selectedItems:function(){var o=[];
var p=this._fileList;
var v=this.get_tree();
if(p!=null){var s=p.get_selectedItems();
if(s&&s.length>0){for(var q=0,u=s.length;
q<u;
q++){var m=s[q];
var n=p._toFileItem(m);
if(n){Array.add(o,n);
}}}}if(v!=null&&o.length==0){var w=v.get_selectedNodes();
for(var t=0;
t<w.length;
t++){var r=this._createItemFromTreeViewNode(w[t]);
Array.add(o,r);
}}return o;
},get_selectedItem:function(){return this.get_selectedItems()[0];
},_selectInitialFile:function(){if(this._selectedFile){if(this._fileList){this._fileList.selectFileByName(this._selectedFile);
}else{if(this.get_tree()){var m=this.get_tree().findNodeByValue(b.FileExplorerHelper.buildPathFromName(this._selectedFile,this));
if(m){m.set_selected(true);
}}}}this._selectedFile=null;
},_getFileListViewNameByExplorerMode:function(){switch(this._explorerMode){case b.FileExplorerMode.Default:return"grid";
case b.FileExplorerMode.Thumbnails:return"thumbnails";
default:return null;
}},_back:function(){var m=this._actionsManager.get_currentAction();
if(m==this.get_currentDirectory()){this._actionsManager.shiftPointerLeft();
}this._actionsManager.undo();
},_forward:function(){var m=this._actionsManager.get_nextAction();
if(m==this.get_currentDirectory()){this._actionsManager.shiftPointerRight();
}this._actionsManager.redo();
},_updateBackForward:function(m){this._actionsManager.addAction(m);
},_executeBackForward:function(o,m){var n=m.get_action();
this.loadFolder(n,false);
},_getCurrentDirectoryElement:function(){var n=this._currentDirectoryInputID;
var m=n?$get(n):null;
return m;
},get_currentDirectory:function(){var m=this._getCurrentDirectoryElement();
return m?m.value:"";
},set_currentDirectory:function(s,m){if((null!=this._actionsManager)&&(s!=this.get_currentDirectory())&&(false!=m)){this._updateBackForward(s);
}var n=this._getCurrentDirectoryElement();
if(n){n.value=s;
}var r=this.get_tree();
var o=r.findNodeByValue(s);
if(o){o.select();
this._scrollFolderIntoView(o);
}var q=this.get_addressBox();
if(q){var p=$get(q);
if(p){p.value=s;
}}this._updateToolbar();
},get_currentPermissions:function(n){var m=this._createItemFromPath(n||this.get_currentDirectory());
return m?m.get_permissions():null;
},raise_itemSelected:function(m){var n=new Telerik.Web.UI.FileExplorerEventArgs(m,"");
this.raiseEvent("itemSelected",n);
return !n.get_cancel();
},raiseFileItemCancelEvent:function(o,n){var m=new b.FileExplorerEventArgs(o,"");
this.raiseEvent(n,m);
return m.get_cancel();
},get_localization:function(){return this._localization;
},get_pathSeparator:function(){return this._pathSeparator;
},_getCommandArgumentInput:function(){var n=this._commandArgumentInputID;
var m=n?$get(n):null;
return m;
},set_commandArgument:function(n){var m=this._getCommandArgumentInput();
if(m){m.value=n;
}},get_commandArgument:function(){var m=this._getCommandArgumentInput();
return m?m.value:null;
},_registerShortcuts:function(){if(this.get_shortcuts()){this._attachShortcutHandlers(true);
}var m=this;
m._shortcutDelay=setTimeout(function(){var n=m.get_element();
var p=false;
n.setAttribute("tabindex","0");
if($telerik.isIE7||$telerik.isIE6){n.setAttribute("tabIndex","0");
p=true;
}var s=m.get_tree();
if(s){var t=s.get_element();
t.setAttribute("tabindex","0");
if(p){t.setAttribute("tabIndex","0");
}t.style.outlineStyle="none";
}var r=m.get_toolbar();
if(r){r.get_element().setAttribute("tabindex","0");
if(p){r.get_element().setAttribute("tabIndex","0");
}}var o=m.get_gridPane();
if(o){o.getContentElement().setAttribute("tabindex","-1");
var q=m.get_splitter().getSplitBarByIndex(0);
if(q){a("input.rspCollapseBarCollapse",q.get_element()).attr(p?"tabIndex":"tabindex","-1");
}}},0);
},_focusFileListAfterCallback:function(){if(this._fileList){var m=this._fileList.get_element();
if(this._lastFocusedElement.id==m.id){this._lastFocusedElement=m;
this._fileList.focus();
}}},_focus:function(m){try{if(m.setActive){m.setActive();
}else{if(m.focus){m.focus();
}}return true;
}catch(n){return false;
}},_attachShortcutHandlers:function(m){if(m){this._keyDownDelegate=Function.createDelegate(this,this._keyDown);
$addHandler(this.get_element(),"keydown",this._keyDownDelegate);
this._htmlElKeyDownDelegate=Function.createDelegate(this,this._htmlElKeyDown);
$addHandler(document.documentElement,"keydown",this._htmlElKeyDownDelegate);
this._attachFocusHandlers(true);
this._windowCloseDelegate=Function.createDelegate(this,this._onWindowClose);
this.get_windowManager().add_close(this._windowCloseDelegate);
}else{if(this._keyDownDelegate){$removeHandler(this.get_element(),"keydown",this._keyDownDelegate);
this._keyDownDelegate=null;
}if(this._htmlElKeyDownDelegate){$removeHandler(document.documentElement,"keydown",this._htmlElKeyDownDelegate);
this._htmlElKeyDownDelegate=null;
}this._shortcutDelay&&clearTimeout(this._shortcutDelay);
}},_attachFocusHandlers:function(o){var p=this.get_tree();
var m=this._fileList;
if(p){this._treeElement=p.get_element();
$addHandler(this._treeElement,"focus",Function.createDelegate(this,function(q){this._lastFocusedElement=this._treeElement;
}));
this._treeClickDelegate=Function.createDelegate(this,this._treeClick);
p.add_nodeClicked(this._treeClickDelegate);
}if(m){var n=m.get_element();
if(o){this._lastFocusedElement=n;
}if(this._onFocusDelegate){$telerik.removeHandler(this._lastFocusedElement||n,"focus",this._onFocusDelegate);
}this._onFocusDelegate=Function.createDelegate(this,function(q){this._lastFocusedElement=this._fileList.get_element();
});
$telerik.addHandler(n,"focus",this._onFocusDelegate);
}},_keyDown:function(n){if(!this._enabled){return;
}var p=this.get_shortcuts();
if(!this._shortCutManager){this._shortCutManager=new b.ShortCutManager(p);
}var s=n.target?n.target.className:n.srcElement.className;
if(n.rawEvent.keyCode==46&&s=="rfeFilterTxt"){return;
}var q=this._shortCutManager.isShortCutHit(n.rawEvent);
if(!q){return;
}var u=this.get_tree();
var r=q.get_name();
if(u&&r=="FocusTreeView"){var v=u.get_element();
this._focus(v);
this._lastFocusedElement=v;
}else{if(this._fileList&&r=="FocusGrid"){this._fileList.focus();
this._lastFocusedElement=this._fileList.get_control().get_element();
}else{if(this.get_addressBox()&&r=="FocusAddressBar"){var t=$get(this.get_addressBox());
if(this._focus(t)){t.select();
}}else{if(this._fileList&&r=="FocusGridPagingSlider"){this._fileList.focusPagerControl();
}else{if(this.get_toolbar()&&r=="FocusToolBar"){this._focus(this.get_toolbar().get_element());
}else{if(r=="ContextMenu"){var o=n.target?n.target:n.srcElement;
if(this._isFileListAnEventTarget(o)){this._showFileListContextMenu();
}if(o.className.indexOf("RadTreeView")!=-1){this._showTreeContextMenu(u);
}}else{var m=r.indexOf("UploadFile")!=-1?"Upload":r;
if((m=="Upload"&&!e(this.get_currentPermissions()))||(m=="Delete"&&!d(this._getSelectedItemPermissions()))){return;
}this._fireCommand(m);
}}}}}}if(r!="FocusFileExplorer"&&p.indexOf(r)!=-1){$telerik.cancelRawEvent(n.rawEvent);
return false;
}},_isFileListAnEventTarget:function(m){var n=m.className;
return n.indexOf("RadGrid")!==-1||n.indexOf("rfeListViewContainer")!==-1;
},_htmlElKeyDown:function(m){if(!this._shortCutManager){this._shortCutManager=new b.ShortCutManager(this.get_shortcuts());
}if(m.keyCode==27){this._hideContextMenus(m,true,"e");
}var o=this._shortCutManager.isShortCutHit(m);
if(!o){return;
}var p=o.get_name();
if(p=="FocusFileExplorer"){var n=this.get_element();
this._focus(n);
this._lastFocusedElement=n;
}else{if(p=="ContextMenu"){this._hideContextMenus(m,false,o.get_shortCutString().toLowerCase());
}}},_hideContextMenus:function(m,o,p){var q=false;
var n=this.get_gridContextMenu();
if(n&&n._shown){n.hide();
q=true;
p=p.replace(/\s*/gi,"");
this._shouldShowGridContextMenu=(p=="context"||p=="shift+f10")?o:true;
}var r=this.get_tree();
if(r){var s=r.get_contextMenus()[0];
if(s&&s._shown){s.hide();
this._lastFocusedElement=r.get_element();
q=true;
}}if(q){this._focus(this._lastFocusedElement);
$telerik.cancelRawEvent(m.rawEvent);
return false;
}},_treeKeyDown:function(m){if(m.keyCode==27){var o=this.get_tree();
this._lastFocusedElement=o.get_element();
if($telerik.isIE){var n=this;
window.setTimeout(function(){n._focus(n._lastFocusedElement);
},100);
}else{this._focus(this._lastFocusedElement);
}if(this._treeKeyDownDelegate){var p=o.get_childListElement();
if(p){$removeHandler(p,"keydown",this._treeKeyDownDelegate);
this._treeKeyDownDelegate=null;
}}}},_onWindowClose:function(n,m){if(m.get_argument()!="SenderIsBtnUpload"&&this.get_asyncUpload()!=null){this.get_asyncUpload().deleteAllFileInputs();
}var o=this;
window.setTimeout(function(){if(o._lastFocusedElement){o._focus(o._lastFocusedElement);
}},0);
},_treeClick:function(n,m){this._lastFocusedElement=n.get_element();
this._focus(this._lastFocusedElement);
},_showFileListContextMenu:function(){var m=this._fileList;
if(m.get_items().length===0){return;
}this._selectedFileListItem=this._getSelectedFileListItem();
var n=m.get_contextMenu();
var o=this._setContextMenuItemsState(n,this.get_currentPermissions());
if(o&&n){this._showContextMenuAtItem(n,this._selectedFileListItem);
}},_getSelectedFileListItem:function(){var m=this._fileList;
if(m.get_selectedItemsDataAndElement().length===0){m.selectDefaultFile();
}return m.get_selectedItemsDataAndElement()[0];
},_showContextMenuAtItem:function(n,o){var m=$telerik.getBounds(o.get_element());
n.showAt(m.x+60,m.y+m.height,null);
n.get_items().getItem(0).focus();
},_showTreeContextMenu:function(q){var r=q.get_contextMenus()[0];
var o=q.get_selectedNode();
q._contextMenuNode=o;
var n=this._createItemFromTreeViewNode(o);
var p=this._setContextMenuItemsState(r,n.get_permissions());
if(p&&r){var m=$telerik.getBounds(o.get_element());
r.showAt(m.x+60,m.y+20,null);
r.get_items().getItem(0).focus();
}},_getSelectedItemPermissions:function(){return this.get_currentPermissions(this.get_selectedItem().get_path());
}};
a.registerControlProperties(b.RadFileExplorer,{allowPaging:false,enableOpenFile:true,enableFilteringOnEnter:false,addressBox:"",postbackButton:null,windowManager:null,gridPane:null,treePane:null,ajaxLoadingPanel:null,gridContextMenu:null,grid:null,listView:null,splitter:null,toolbar:null,tooltipControl:null,asyncUpload:null,newFolderDefaultValue:"NewFolder",shortcuts:null});
a.registerControlEvents(b.RadFileExplorer,["itemSelected","folderLoaded","fileOpen","folderChange","init","load","eventHandlersAttached","createNewFolder","delete","move","copy","ajaxRequestStart","ajaxRequestEnd","filter","filesDropping"]);
Telerik.Web.UI.RadFileExplorer.registerClass("Telerik.Web.UI.RadFileExplorer",Telerik.Web.UI.RadWebControl);
var f=function(n,m){b[n]=function(){var o=Array.prototype.slice.call(arguments);
b[n].initializeBase(this,o);
};
b[n].registerClass("Telerik.Web.UI."+n,m);
};
Telerik.Web.UI.FileExplorerEventArgs=function(n,o,m){Telerik.Web.UI.FileExplorerEventArgs.initializeBase(this);
this._item=n;
this._newPath=o;
this._isRename=!!m;
};
Telerik.Web.UI.FileExplorerEventArgs.prototype={get_path:function(){return this._item.get_path();
},get_newPath:function(){return this._newPath;
},get_item:function(){return this._item;
},get_isRename:function(){return this._isRename;
}};
Telerik.Web.UI.FileExplorerEventArgs.registerClass("Telerik.Web.UI.FileExplorerEventArgs",Sys.CancelEventArgs);
f("RadFileExplorerEventArgs",Telerik.Web.UI.FileExplorerEventArgs);
Telerik.Web.UI.FileExplorerCopyEventArgs=function(m,n){Telerik.Web.UI.FileExplorerCopyEventArgs.initializeBase(this);
this._items=m;
this._newPath=n;
};
Telerik.Web.UI.FileExplorerCopyEventArgs.prototype={get_newPath:function(){return this._newPath;
},get_items:function(){return this._items;
},get_item:function(){return this._items.length>0?this._items[0]:null;
},get_path:function(){return this._items.length>0?this._items[0].get_path():null;
}};
Telerik.Web.UI.FileExplorerCopyEventArgs.registerClass("Telerik.Web.UI.FileExplorerCopyEventArgs",Sys.CancelEventArgs);
f("RadFileExplorerCopyEventArgs",Telerik.Web.UI.FileExplorerCopyEventArgs);
Telerik.Web.UI.FileExplorerFilterEventArgs=function(n,m){Telerik.Web.UI.FileExplorerFilterEventArgs.initializeBase(this);
this._text=n;
this._domEvent=m;
};
Telerik.Web.UI.FileExplorerFilterEventArgs.prototype={get_text:function(){return this._text;
},set_text:function(m){this._text=m;
},get_domEvent:function(){return this._domEvent;
}};
Telerik.Web.UI.FileExplorerFilterEventArgs.registerClass("Telerik.Web.UI.FileExplorerFilterEventArgs",Sys.CancelEventArgs);
f("RadFileExplorerFilterEventArgs",Telerik.Web.UI.FileExplorerFilterEventArgs);
a.registerEnum(b,"FileExplorerItemType",{File:0,Directory:1});
a.registerEnum(b,"FileExplorerItemPermissions",{Read:1,Upload:2,Delete:4});
a.registerEnum(b,"FileExplorerMode",{Default:1,FileTree:2,Thumbnails:3});
a.registerEnum(b,"FileExplorerControls",{Tree:1,FileList:2});
Telerik.Web.UI.FileExplorerItem=function(){Telerik.Web.UI.FileExplorerItem.initializeBase(this);
this._url="";
};
Telerik.Web.UI.FileExplorerItem.prototype={get_url:function(){return this._url?this._url:this._path;
},set_url:function(m){this._url=m;
},isDirectory:function(){return this._type==Telerik.Web.UI.FileExplorerItemType.Directory;
}};
a.registerControlProperties(b.FileExplorerItem,{size:"",extension:"",path:"",name:"",permissions:Telerik.Web.UI.FileExplorerItemPermissions.Read,type:Telerik.Web.UI.FileExplorerItemType.File});
Telerik.Web.UI.FileExplorerItem.registerClass("Telerik.Web.UI.FileExplorerItem",Sys.Component);
})($telerik.$);
if(typeof(Sys)!=='undefined')Sys.Application.notifyScriptLoaded();