Type.registerNamespace("Telerik.Web.UI");
Telerik.Web.UI.RadMaskPart=function(){this.value="";
this.index=-1;
this.type=-1;
this.PromptChar="_";
};
Telerik.Web.UI.RadMaskPart.prototype={HandleKey:function(a){return false;
},HandleWheel:function(a){return true;
},SetController:function(a){this.controller=a;
},GetValue:function(){return this.value.toString();
},GetVisValue:function(){return"";
},SetValue:function(b,a){return true;
},CanHandle:function(b,a){return true;
},IsCaseSensitive:function(){return false;
},GetLength:function(){return 1;
},IsAlpha:function(a){return a.match(/[^\u005D\u005B\t\n\r\f\s\v\\!-@|^_`{-\u00BF]{1}/)!=null;
}};
Telerik.Web.UI.RadMaskPart.registerClass("Telerik.Web.UI.RadMaskPart");
Type.registerNamespace("Telerik.Web.UI");
Telerik.Web.UI.RadDigitMaskPart=function(){Telerik.Web.UI.RadDigitMaskPart.initializeBase(this);
};
Telerik.Web.UI.RadDigitMaskPart.prototype={GetValue:function(){return this.value.toString();
},IsCaseSensitive:function(){return true;
},GetVisValue:function(){if(this.value.toString()==""){return this.PromptChar;
}return this.value.toString();
},CanHandle:function(b,a){if(isNaN(parseInt(b,10))){if(this.controller._OnChunkError){this.controller._OnChunkError(this,this.GetValue(),b);
}return false;
}return true;
},SetValue:function(b,a){if(b==""||b==this.PromptChar||b==" "){this.value="";
return true;
}if(this.CanHandle(b,a)){this.value=parseInt(b,10);
}return true;
}};
Telerik.Web.UI.RadDigitMaskPart.registerClass("Telerik.Web.UI.RadDigitMaskPart",Telerik.Web.UI.RadMaskPart);
Type.registerNamespace("Telerik.Web.UI");
Telerik.Web.UI.RadEnumerationMaskPart=function(a){Telerik.Web.UI.RadEnumerationMaskPart.initializeBase(this);
this.SetOptions(a);
this.lastOffsetPunched=-1;
this.selectedForCompletion=0;
this.FlipDirection=0;
this.RebuildKeyBuff();
};
Telerik.Web.UI.RadEnumerationMaskPart.prototype={SetOptions:function(b){this.length=0;
this.Options=b;
this.optionsIndex=[];
for(var a=0;
a<this.Options.length;
a++){this.length=Math.max(this.length,this.Options[a].length);
this.optionsIndex[this.Options[a]]=a;
}},CanHandle:function(f,d){if(f==""){return true;
}d=Math.max(d-this.offset,0);
var e=[];
for(var c=0;
c<this.keyBuff.length;
c++){e[c]=this.keyBuff[c];
}e[d]=f;
var a=new Telerik.Web.UI.CompletionList(this.Options,this.PromptChar);
var b=a.GetCompletions(e,d);
if(b.length>0){return true;
}else{if(this.controller._OnChunkError){this.controller._OnChunkError(this,this.GetValue(),f);
}return false;
}},SetController:function(a){this.controller=a;
this.InitializeSelection(a.get_allowEmptyEnumerations());
},InitializeSelection:function(a){if(a){this.value="";
this.selectedIndex=-1;
}else{this.value=this.Options[0];
this.selectedIndex=0;
}},BuildKeyBuff:function(e,c){var d=this.offset;
var b=d+c+1;
this.keyBuff=[];
for(var a=d;
a<b;
a++){this.keyBuff[a-d]=e.charAt(a);
}this.keyBuffRebuilt=true;
},RebuildKeyBuff:function(){this.keyBuff=[];
for(var a=0;
a<this.length;
a++){this.keyBuff[a]="";
}this.keyBuffRebuilt=true;
},IsCaseSensitive:function(){return true;
},ResetCompletion:function(){this.selectedForCompletion=0;
},SelectNextCompletion:function(){this.selectedForCompletion++;
},Store:function(b,a){if(this.lastOffsetPunched-1==a){if(this.keyBuff[a]==b){this.SelectNextCompletion();
}else{this.RebuildKeyBuff();
}}else{this.ResetCompletion();
}this.lastOffsetPunched=a;
this.keyBuff[a]=b;
},SetNoCompletionValue:function(){if(this.controller.get_allowEmptyEnumerations()){this.SetOption(-1);
}},SetValue:function(e,c){if(e==""&&this.controller._clearing){this.value="";
this.SetNoCompletionValue();
return true;
}c=Math.max(0,c-this.offset);
this.Store(e,c);
var a=new Telerik.Web.UI.CompletionList(this.Options,this.PromptChar);
var b=a.GetCompletions(this.keyBuff,c);
if(b.length>0){var d=this.optionsIndex[b[this.selectedForCompletion%b.length]];
this.SetOption(d);
}else{this.SetNoCompletionValue();
if(e!==""&&e!==this.controller.get_promptChar()&&e!==this.controller.get_displayPromptChar()){if(this.controller._OnChunkError){this.controller._OnChunkError(this,this.GetValue(),e);
}}}return true;
},GetVisValue:function(){var a=this.value;
while(a.length<this.length){a+=this.PromptChar;
}return a;
},GetLength:function(){return this.length;
},GetSelectedIndex:function(){return this.selectedIndex;
},SetOption:function(a,c){var b=this.value;
if(this.controller.get_allowEmptyEnumerations()){if(a<-1){a=this.Options.length+a+1;
this.FlipDirection=-1;
}else{if(a>=this.Options.length){a=a-this.Options.length-1;
this.FlipDirection=1;
}}}else{if(a<0){a=this.Options.length+a;
this.FlipDirection=-1;
}else{if(a>=this.Options.length){a=a-this.Options.length;
this.FlipDirection=1;
}}}this.selectedIndex=a;
this.value=a==-1?"":this.Options[a];
if(typeof(c)!="undefined"){if(c){this.controller._OnMoveUp(this,b,this.value);
}else{this.controller._OnMoveDown(this,b,this.value);
}}if(b!=this.value&&this.controller._OnEnumChanged){this.controller._OnEnumChanged(this,b,this.value);
}this.FlipDirection=0;
},HandleKey:function(a){this.controller._calculateSelection();
var b=new Telerik.Web.UI.MaskedEventWrap(a,this.controller._textBoxElement);
if(b.IsDownArrow()){this.SetOption(this.selectedIndex+1,false);
this.controller._Visualise();
this.controller._FixSelection(b);
return true;
}else{if(b.IsUpArrow()){this.SetOption(this.selectedIndex-1,true);
this.controller._Visualise();
this.controller._FixSelection(b);
return true;
}}},HandleWheel:function(a){this.controller._calculateSelection();
var b=new Telerik.Web.UI.MaskedEventWrap(a,this.controller._textBoxElement);
this.SetOption(this.selectedIndex-a.rawEvent.wheelDelta/120);
this.controller._Visualise();
this.controller._FixSelection(b);
return false;
}};
Telerik.Web.UI.RadEnumerationMaskPart.registerClass("Telerik.Web.UI.RadEnumerationMaskPart",Telerik.Web.UI.RadMaskPart);
Telerik.Web.UI.CompletionList=function(b,a){this.options=b;
this.blankChar=a;
};
Telerik.Web.UI.CompletionList.prototype={GetCompletions:function(d,e){var a=this.options;
for(var c=0;
c<=e;
c++){var b=d[c].toLowerCase();
a=this.FilterCompletions(a,c,b);
}return a;
},FilterCompletions:function(b,g,d){var e=[];
for(var a=0;
a<b.length;
a++){var c=b[a];
var f=c.charAt(g).toLowerCase();
if(this.CharacterMatchesCompletion(d,f)){e[e.length]=c;
}}return e;
},CharacterMatchesCompletion:function(a,b){return a==this.blankChar||a==" "||a==b;
}};
Telerik.Web.UI.CompletionList.registerClass("Telerik.Web.UI.CompletionList");
Type.registerNamespace("Telerik.Web.UI");
Telerik.Web.UI.RadFreeMaskPart=function(){Telerik.Web.UI.RadFreeMaskPart.initializeBase(this);
};
Telerik.Web.UI.RadFreeMaskPart.prototype={IsCaseSensitive:function(){return true;
},GetVisValue:function(){if(this.value.toString()==""){return this.PromptChar;
}return this.value;
},SetValue:function(b,a){this.value=b;
return true;
}};
Telerik.Web.UI.RadFreeMaskPart.registerClass("Telerik.Web.UI.RadFreeMaskPart",Telerik.Web.UI.RadMaskPart);
Type.registerNamespace("Telerik.Web.UI");
Telerik.Web.UI.RadLiteralMaskPart=function(a){Telerik.Web.UI.RadLiteralMaskPart.initializeBase(this);
if((Sys.Browser.agent===Sys.Browser.InternetExplorer&&(!document.documentMode||document.documentMode<9))||Sys.Browser.agent===Sys.Browser.Opera){this.ch=a;
}else{this.ch=a.replace(/\r\n|\r|\n/g,"\n");
}};
Telerik.Web.UI.RadLiteralMaskPart.prototype={GetVisValue:function(){return this.ch;
},GetLength:function(){return this.ch.length;
},GetValue:function(){return"";
},IsCaseSensitive:function(){if(this.NextChunk!=null){return this.NextChunk.IsCaseSensitive();
}},SetValue:function(b,a){a-=this.offset;
if(this.ch.charAt(a)=="*"){return true;
}return b==this.ch.charAt(a)||!b;
},CanHandle:function(b,a){a-=this.offset;
if(b==this.ch.charAt(a)){return true;
}if(!b){return true;
}if(this.NextChunk!=null){return this.NextChunk.CanHandle(b,a+this.GetLength());
}}};
Telerik.Web.UI.RadLiteralMaskPart.registerClass("Telerik.Web.UI.RadLiteralMaskPart",Telerik.Web.UI.RadMaskPart);
Type.registerNamespace("Telerik.Web.UI");
Telerik.Web.UI.RadLowerMaskPart=function(){Telerik.Web.UI.RadLowerMaskPart.initializeBase(this);
};
Telerik.Web.UI.RadLowerMaskPart.prototype={CanHandle:function(b,a){if(!this.IsAlpha(b)){if(this.controller._OnChunkError){this.controller._OnChunkError(this,this.GetValue(),b);
}return false;
}return true;
},GetVisValue:function(){if(this.value.toString()==""){return this.PromptChar;
}return this.value.toString();
},SetValue:function(b,a){if(b==""){this.value="";
return true;
}if(this.IsAlpha(b)){this.value=b.toLowerCase();
}else{if(this.controller._OnChunkError){this.controller._OnChunkError(this,this.GetValue(),b);
}}return true;
}};
Telerik.Web.UI.RadLowerMaskPart.registerClass("Telerik.Web.UI.RadLowerMaskPart",Telerik.Web.UI.RadMaskPart);
Type.registerNamespace("Telerik.Web.UI");
Telerik.Web.UI.RadNumericRangeMaskPart=function(b,c,a,d){Telerik.Web.UI.RadNumericRangeMaskPart.initializeBase(this);
this.upperLimit=c;
this.lowerLimit=b;
this.length=Math.max(this.lowerLimit.toString().length,this.upperLimit.toString().length);
this.leftAlign=a;
this.zeroFill=d;
this.minusIncluded=this.lowerLimit<0||this.upperLimit<0;
this.value=b;
this.FlipDirection=0;
};
Telerik.Web.UI.RadNumericRangeMaskPart.prototype={SetController:function(a){this.controller=a;
this.GetVisValue();
},IsCaseSensitive:function(){return true;
},CanHandle:function(b,a){if((b=="-"||b=="+")&&this.lowerLimit<0){return true;
}if(isNaN(parseInt(b,10))){if(this.controller._OnChunkError){this.controller._OnChunkError(this,this.GetValue(),b);
}return false;
}return true;
},InsertAt:function(b,a){return this.visValue.substr(0,a)+b.toString()+this.visValue.substr(a+1,this.visValue.length);
},ReplacePromptChar:function(b){var a=this.leftAlign?"":"0";
while(b.indexOf(this.PromptChar)>-1){b=b.replace(this.PromptChar,a);
}return b;
},SetValue:function(c,b){if(c==""){c=0;
}if(isNaN(parseInt(c,10))&&c!="+"&&c!="-"){return true;
}b-=this.offset;
var a=this.InsertAt(c,b);
a=this.ReplacePromptChar(a);
if(a.indexOf("-")!=-1&&a.indexOf("-")>0){a=a.replace("-","0");
}a=parseInt(a,10);
if(!a){a=0;
}if(this.controller.get_roundNumericRanges()){a=Math.min(this.upperLimit,a);
a=Math.max(this.lowerLimit,a);
this.setInternalValue(a);
}else{if(a<=this.upperLimit&&a>=this.lowerLimit){this.setInternalValue(a);
this.GetVisValue();
}else{return false;
}}this.GetVisValue();
return true;
},setInternalValue:function(b){var a=this.value;
this.value=b;
if(a!=b&&this.controller._OnEnumChanged){this.controller._OnEnumChanged(this,a,b);
}if(a>b&&this.controller._OnMoveDown){this.controller._OnMoveDown(this,a,b);
}else{if(a<b&&this.controller._OnMoveUp){this.controller._OnMoveUp(this,a,b);
}}this.FlipDirection=0;
},GetVisValue:function(){var b="";
var c=Math.abs(this.value).toString();
if(this.leftAlign){if(this.value<0){b+=this.PromptChar;
}b+=c;
while(b.length<this.length){b+=this.controller.get_promptChar();
}}else{var a=this.zeroFill?"0":this.controller.get_promptChar();
if(this.value<0){c="-"+c;
}while(b.length<this.length-c.length){b+=a;
}b+=c;
}this.visValue=b;
return b;
},GetLength:function(){return this.length;
},HandleKey:function(a){this.controller._calculateSelection();
var b=new Telerik.Web.UI.MaskedEventWrap(a,this.controller._textBoxElement);
if(b.IsDownArrow()){this.MoveDown();
this.controller._FixSelection(b);
return true;
}else{if(b.IsUpArrow()){this.MoveUp();
this.controller._FixSelection(b);
return true;
}}},MoveUp:function(){var a=this.value;
a++;
if(a>this.upperLimit){a=this.lowerLimit;
this.FlipDirection=1;
}this.setInternalValue(a);
this.controller._Visualise();
},MoveDown:function(){var a=this.value;
a--;
if(a<this.lowerLimit){a=this.upperLimit;
this.FlipDirection=-1;
}this.setInternalValue(a);
this.controller._Visualise();
},HandleWheel:function(c){var a=this.value;
var b;
if(c.rawEvent.wheelDelta){b=c.rawEvent.wheelDelta/120;
if(window.opera){b=-b;
}}else{if(c.rawEvent.detail){b=-c.rawEvent.detail/3;
}}a=parseInt(a,10)+b;
var d=new Telerik.Web.UI.MaskedEventWrap(c,this.controller._textBoxElement);
if(a<this.lowerLimit){a=this.upperLimit-(this.lowerLimit-a-1);
this.FlipDirection=-1;
}if(a>this.upperLimit){a=this.lowerLimit+(a-this.upperLimit-1);
this.FlipDirection=1;
}this.setInternalValue(a);
this.controller._Visualise();
this.controller._FixSelection(d);
return false;
}};
Telerik.Web.UI.RadNumericRangeMaskPart.registerClass("Telerik.Web.UI.RadNumericRangeMaskPart",Telerik.Web.UI.RadMaskPart);
Type.registerNamespace("Telerik.Web.UI");
Telerik.Web.UI.RadLongRangeMaskPart=function(b,c,a,d){Telerik.Web.UI.RadLongRangeMaskPart.initializeBase(this);
this.length=Math.max(c.length,b.length);
this.upperLimit=this._createLong(c);
this.lowerLimit=this._createLong(b);
this.leftAlign=a;
this.zeroFill=d;
this.minusIncluded=(this.lowerLimit[0]==0);
this.value=this.lowerLimit.slice();
};
Telerik.Web.UI.RadLongRangeMaskPart.prototype={SetController:function(a){this.controller=a;
this.GetVisValue();
},IsCaseSensitive:function(){return true;
},_createLong:function(a){return[a.indexOf("-")==-1,a.replace(/^(0|\+|\-)+/g,"")||"0"];
},_compareNumberAsString:function(c,d){if(c.length==d.length){if(c==d){return 0;
}else{return(c>d)?1:-1;
}}else{return(c.length>d.length)?1:-1;
}},_compare:function(c,d){if(c[0]!=d[0]){return(c[0]>d[0])?1:-1;
}if(c[0]){return this._compareNumberAsString(c[1],d[1]);
}else{return this._compareNumberAsString(d[1],c[1]);
}},CanHandle:function(b,a){if((b=="-"||b=="+")&&this.minusIncluded){return true;
}if(isNaN(parseInt(b,10))){if(this.controller._OnChunkError){this.controller._OnChunkError(this,this.GetValue(),b);
}return false;
}return true;
},InsertAt:function(b,a){return this.visValue.substr(0,a)+b.toString()+this.visValue.substr(a+1,this.visValue.length);
},ReplacePromptChar:function(b){var a=this.leftAlign?"":"0";
while(b.indexOf(this.PromptChar)>-1){b=b.replace(this.PromptChar,a);
}return b;
},SetValue:function(c,b){if(c==""){c=0;
}if(isNaN(parseInt(c,10))&&c!="+"&&c!="-"){return true;
}b-=this.offset;
var a=this.InsertAt(c,b);
a=this.ReplacePromptChar(a);
if(a.indexOf("-")!=-1&&a.indexOf("-")>0){a=a.replace("-","0");
}a=this._createLong(a);
if(this.controller.get_roundNumericRanges()){if(this._compare(a,this.upperLimit)>0){a=this.upperLimit.slice();
}if(this._compare(a,this.lowerLimit)<0){a=this.lowerLimit.slice();
}this.setInternalValue(a);
}else{if(this._compare(a,this.upperLimit)<=0&&this._compare(a,this.lowerLimit)>=0){this.setInternalValue(a);
this.GetVisValue();
}else{return false;
}}this.GetVisValue();
return true;
},setInternalValue:function(c){var b=this.value.slice();
this.value=c;
var a=this._compare(b,this.value);
if(a==0&&this.controller._OnEnumChanged){this.controller._OnEnumChanged(this,b,this.value);
}if(a==-1&&this.controller._OnMoveDown){this.controller._OnMoveDown(this,b,this.value);
}else{if(a==1&&this.controller._OnMoveUp){this.controller._OnMoveUp(this,b,this.value);
}}},GetVisValue:function(){var c=this.value[1];
var b=this.value[0]?"":"-";
if(this.leftAlign){b+=c;
while(b.length<this.length){b+=this.controller.get_promptChar();
}}else{var a=this.zeroFill?"0":this.controller.get_promptChar();
while(b.length+c.length<this.length){b+=a;
}b+=c;
}this.visValue=b;
return b;
},GetLength:function(){return this.length;
},HandleKey:function(a){this.controller._calculateSelection();
var b=new Telerik.Web.UI.MaskedEventWrap(a,this.controller._textBoxElement);
if(b.IsDownArrow()){this.MoveDown();
this.controller._FixSelection(b);
return true;
}else{if(b.IsUpArrow()){this.MoveUp();
this.controller._FixSelection(b);
return true;
}}},_increase:function(c){var e;
var b;
var d;
var a;
if(c[0]){e="";
b=c[1].length-1;
d=1;
while(d>0||b>=0){a=d+((b>=0)?parseInt(c[1][b],10):0);
e=a%10+e;
d=(a/10)>>0;
b--;
}return[true,e];
}else{if(c[1]==1){return[true,"0"];
}e="";
b=c[1].length-1;
d=1;
while(d>0||b>=0){a=parseInt(c[1][b],10)-d;
if(a>=0){d=0;
e=a+e;
}else{e=(a+10)+e;
}b--;
}return[false,e];
}},_decrease:function(a){if(a[0]&&a[1]==1){return[true,"0"];
}if(a[0]&&a[1]==0){return[false,"1"];
}var c=a.slice();
c[0]=!c[0];
var b=this._increase(c);
b[0]=!b[0];
return b;
},MoveUp:function(){var a=this._increase(this.value);
if(this._compare(a,this.upperLimit)>0){a=this.lowerLimit;
}this.setInternalValue(a);
this.controller._Visualise();
},MoveDown:function(){var a=this._decrease(this.value);
if(this._compare(a,this.lowerLimit)<0){a=this.upperLimit;
}this.setInternalValue(a);
this.controller._Visualise();
},HandleWheel:function(b){var a;
if(b.rawEvent.wheelDelta){a=b.rawEvent.wheelDelta;
if(window.opera){a=-a;
}}else{if(b.rawEvent.detail){a=-b.rawEvent.detail;
}}var c=new Telerik.Web.UI.MaskedEventWrap(b,this.controller._textBoxElement);
if(a>0){this.MoveUp();
}else{this.MoveDown();
}this.controller._FixSelection(c);
return false;
}};
Telerik.Web.UI.RadLongRangeMaskPart.registerClass("Telerik.Web.UI.RadLongRangeMaskPart",Telerik.Web.UI.RadMaskPart);
Type.registerNamespace("Telerik.Web.UI");
Telerik.Web.UI.RadUpperMaskPart=function(){Telerik.Web.UI.RadUpperMaskPart.initializeBase(this);
};
Telerik.Web.UI.RadUpperMaskPart.prototype={CanHandle:function(b,a){if(!this.IsAlpha(b)){if(this.controller._OnChunkError){this.controller._OnChunkError(this,this.GetValue(),b);
}return false;
}return true;
},GetVisValue:function(){if(this.value.toString()==""){return this.PromptChar;
}return this.value.toString();
},SetValue:function(b,a){if(b==""){this.value="";
return true;
}if(this.IsAlpha(b)){this.value=b.toUpperCase();
}else{if(this.controller._OnChunkError){this.controller._OnChunkError(this,this.GetValue(),b);
}}return true;
}};
Telerik.Web.UI.RadUpperMaskPart.registerClass("Telerik.Web.UI.RadUpperMaskPart",Telerik.Web.UI.RadMaskPart);
Type.registerNamespace("Telerik.Web.UI");
Telerik.Web.UI.MaskedEventWrap=function(a,b){if(a){this.event=a.rawEvent;
}this._selectionStart=b.selectionStart;
this._selectionEnd=b.selectionEnd;
this.fieldValue=b.value;
};
Telerik.Web.UI.MaskedEventWrap.prototype={IsUpArrow:function(){return this.event.keyCode==38;
},IsDownArrow:function(){return this.event.keyCode==40;
}};
Telerik.Web.UI.MaskedEventWrap.registerClass("Telerik.Web.UI.MaskedEventWrap");
Type.registerNamespace("Telerik.Web.UI");
$telerik.findMaskedTextBox=$find;
$telerik.toMaskedTextBox=function(a){return a;
};
Telerik.Web.UI.RadMaskedTextBox=function(a){Telerik.Web.UI.RadMaskedTextBox.initializeBase(this,[a]);
this._parts=[];
this._partIndex=[];
this._displayPartIndex=[];
this._value="";
this._lastState=null;
this._length=0;
this._displayLength=0;
this._internalValueUpdate=false;
this._projectedValue="";
this._isTextarea=false;
this._initialMasks=[];
this._initialDisplayMasks=[];
this._requireCompleteText=false;
this._promptChar="_";
this._displayPromptChar="_";
this._displayFormatPosition=Telerik.Web.UI.DisplayFormatPosition.Left;
this._hideOnBlur=false;
this._resetCaretOnFocus=false;
this._roundNumericRanges=true;
this._allowEmptyEnumerations=false;
this._readOnly=false;
this._focusOnStartup=false;
this._selectionOnFocus=Telerik.Web.UI.SelectionOnFocus.SelectAll;
this._onTextBoxMouseUpDelegate=null;
this._onTextBoxMouseDownDelegate=null;
this._onTextBoxPasteDelegate=null;
this._onTextBoxPropertyChangeDelegate=null;
this._onTextBoxInputDelegate=null;
this._isInitialized=false;
this.preventPostBackAfterBlur=false;
};
Telerik.Web.UI.RadMaskedTextBox.prototype={initialize:function(){Telerik.Web.UI.RadMaskedTextBox.callBaseMethod(this,"initialize");
if(this._focused){this._focusOnStartup=true;
}this._fixAbsolutePositioning();
this._setMask(this.get__initialMasks());
if(this.get__initialDisplayMasks().length){this._setDisplayMask(this.get__initialDisplayMasks());
}this._SetValue(this._textBoxElement.value);
this.updateClientState();
this._textBoxElement._oldValue=this._textBoxElement.value;
this._isTextarea=this._textBoxElement.tagName.toLowerCase()=="textarea";
this.initialFieldValue=this._textBoxElement.value;
this._isInitialized=true;
if(this._focusOnStartup){this._calculateSelection();
this._lastState=new Telerik.Web.UI.MaskedEventWrap(null,this._textBoxElement);
}},dispose:function(){var a=window.$removeHandler;
if(this._onTextBoxMouseUpDelegate){a(this._textBoxElement,"mouseup",this._onTextBoxMouseUpDelegate);
this._onTextBoxMouseUpDelegate=null;
}if(this._onTextBoxMouseDownDelegate){a(this._textBoxElement,"mousedown",this._onTextBoxMouseDownDelegate);
this._onTextBoxMouseDownDelegate=null;
}if(this._onTextBoxPasteDelegate){a(this._textBoxElement,"paste",this._onTextBoxPasteDelegate);
this._onTextBoxPasteDelegate=null;
}if(this._onTextBoxPropertyChangeDelegate){a(this._textBoxElement,"propertychange",this._onTextBoxPropertyChangeDelegate);
this._onTextBoxPropertyChangeDelegate=null;
}if(this._onTextBoxInputDelegate){a(this._textBoxElement,"input",this._onTextBoxInputDelegate);
this._onTextBoxInputDelegate=null;
}Telerik.Web.UI.RadMaskedTextBox.callBaseMethod(this,"dispose");
},resetCursor:function(){this.set_cursorPosition(0);
},inSelection:function(a){this._calculateSelection();
if(this._textBoxElement.selectionStart!=this._textBoxElement.selectionEnd){this._OnActivity(a);
return true;
}if(a.ctrlKey||a.altKey||Sys.Browser.agent==Sys.Browser.Safari){this._OnActivity(a);
return true;
}return false;
},insertText:function(d,c){var b=c;
var a=0;
while(a<d.length){if(b>=0&&b<this._partIndex.length){if(this._partIndex[b].CanHandle(d[a],b)){if(this._partIndex[b].SetValue(d[a],b)){a++;
}b++;
}else{a++;
}}else{break;
}}this._Visualise();
return b;
},removeText:function(b,a){this._internalValueUpdate=true;
this._UpdatePartsInRange("",b,b+a);
this._internalValueUpdate=false;
this._Visualise();
},updateDisplayValue:function(){if(this._isInitialized){if(this._focused){if((this.get_hideOnBlur()&&this.isEmpty())||this._displayParts){this._Visualise();
this._textBoxElement.select();
}if(this.get_resetCaretOnFocus()){this.resetCursor();
}}else{this._Visualise();
}}},updateHiddenValue:function(){var a=this._setHiddenValue(this.get_valueWithPromptAndLiterals());
this.updateClientState();
return a;
},get_valueWithLiterals:function(){var b=[];
for(var a=0;
a<this._parts.length;
a++){b[a]=this._parts[a].ch||this._parts[a].GetValue();
}return b.join("");
},get_valueWithPromptAndLiterals:function(){return this._GetVisibleValues(this._parts);
},get_editValue:function(){return this._GetVisibleValues(this._parts);
},get_valueWithPrompt:function(){var c=[];
for(var a=0;
a<this._parts.length;
a++){var b=this._parts[a];
if(!b.ch){c.push(b.GetVisValue());
}}return c.join("");
},get_prompt:function(){var c=new RegExp(".","g");
var b=[];
for(var a=0;
a<this._parts.length;
a++){b[a]=this._parts[a].ch||this._parts[a].GetVisValue().replace(c,this.get_promptChar());
}return b.join("");
},get_displayValue:function(){var a="";
if(this._displayParts){this._UpdateDisplayPartsInRange();
a=this._GetVisibleValues(this._displayParts);
}else{a=this._GetVisibleValues(this._parts);
}return a;
},set_cursorPosition:function(a){if(!this._focused){return;
}this._calculateSelection();
if(Sys.Browser.agent==Sys.Browser.InternetExplorer&&(!document.documentMode||document.documentMode<9)){this._textBoxElement.select();
var c=document.selection.createRange();
var b=this._textBoxElement.value.substr(0,a).split("\r\n").length-1;
c.move("character",a-b);
c.select();
}else{this._textBoxElement.selectionStart=a;
this._textBoxElement.selectionEnd=a;
}},isEmpty:function(){return this.get_value()=="";
},get_value:function(){var b=[];
for(var a=0;
a<this._parts.length;
a++){b[a]=this._parts[a].GetValue();
}return b.join("");
},set_value:function(a){if(a===""){this._clearing=true;
}this._SetValue(a);
this._clearing=false;
if(this._ValueHasChanged()){this.raise_valueChanged();
if(this.get_autoPostBack()&&this._canAutoPostBackAfterValidation()){this.raisePostBackEvent();
}}this.updateCssClass();
},get_promptChar:function(){return this._promptChar;
},set_promptChar:function(a){if(this._promptChar!=a){this._promptChar=a;
this.raisePropertyChanged("PromptChar");
}},get_displayPromptChar:function(){return this._displayPromptChar;
},set_displayPromptChar:function(a){if(this._displayPromptChar!=a){this._displayPromptChar=a;
this.raisePropertyChanged("DisplayPromptChar");
}},get_displayFormatPosition:function(){return this._displayFormatPosition;
},set_displayFormatPosition:function(a){if(this._displayFormatPosition!=a){this._displayFormatPosition=a;
this.raisePropertyChanged("DisplayFormatPosition");
}},get_hideOnBlur:function(){return this._hideOnBlur;
},set_hideOnBlur:function(a){if(this._hideOnBlur!=a){this._hideOnBlur=a;
this.raisePropertyChanged("HideOnBlur");
}},get_resetCaretOnFocus:function(){return this._resetCaretOnFocus;
},set_resetCaretOnFocus:function(a){if(this._resetCaretOnFocus!=a){this._resetCaretOnFocus=a;
this.raisePropertyChanged("ResetCaretOnFocus");
}},get_roundNumericRanges:function(){return this._roundNumericRanges;
},set_roundNumericRanges:function(a){if(this._roundNumericRanges!=a){this._roundNumericRanges=a;
this.raisePropertyChanged("RoundNumericRanges");
}},get_allowEmptyEnumerations:function(){return this._allowEmptyEnumerations;
},set_allowEmptyEnumerations:function(a){if(this._allowEmptyEnumerations!=a){this._allowEmptyEnumerations=a;
this.raisePropertyChanged("AllowEmptyEnumerations");
}},get_readOnly:function(){return this._readOnly;
},set_readOnly:function(a){if(this._readOnly!=a){this._readOnly=a;
this.raisePropertyChanged("ReadOnly");
}},saveClientState:function(){var a=[];
a[a.length]="valueWithPromptAndLiterals";
return Telerik.Web.UI.RadMaskedTextBox.callBaseMethod(this,"saveClientState",[a]);
},_attachMouseEventHandlers:function(){Telerik.Web.UI.RadMaskedTextBox.callBaseMethod(this,"_attachMouseEventHandlers");
this._onTextBoxMouseDownDelegate=Function.createDelegate(this,this._onTextBoxMouseDownHandler);
if(!$telerik.isSafari){this._onTextBoxMouseUpDelegate=Function.createDelegate(this,this._onTextBoxMouseUpHandler);
window.$addHandler(this._textBoxElement,"mouseup",this._onTextBoxMouseUpDelegate);
}window.$addHandler(this._textBoxElement,"mousedown",this._onTextBoxMouseDownDelegate);
},_attachEventHandlers:function(){Telerik.Web.UI.RadMaskedTextBox.callBaseMethod(this,"_attachEventHandlers");
if(Sys.Browser.agent==Sys.Browser.InternetExplorer&&(!document.documentMode||document.documentMode<9)){this._onTextBoxPasteDelegate=Function.createDelegate(this,this._onTextBoxPasteHandler);
this._onTextBoxPropertyChangeDelegate=Function.createDelegate(this,this._onTextBoxPropertyChangeHandler);
window.$addHandler(this._textBoxElement,"paste",this._onTextBoxPasteDelegate);
window.$addHandler(this._textBoxElement,"propertychange",this._onTextBoxPropertyChangeDelegate);
}else{this._onTextBoxInputDelegate=Function.createDelegate(this,this._onTextBoxInputHandler);
window.$addHandler(this._textBoxElement,"input",this._onTextBoxInputDelegate);
}if(Sys.Browser.agent==Sys.Browser.Opera){var a=this;
var b=function(){return a._ValueHandler({});
};
setInterval(b,10);
}},_SetValue:function(a){this._internalValueUpdate=true;
this._UpdatePartsInRange(a,0,this._length);
this._internalValueUpdate=false;
this._Visualise();
},_onFormResetHandler:function(a){var b=this._constructValueFromInitialText(this._originalInitialValueAsText);
this._setHiddenValue(b);
this._SetValue(b);
this._initialValueAsText=this._text;
this.updateClientState();
},_onTextBoxInputHandler:function(a){this._ValueHandler(a);
},_onMouseWheel:function(a){return this._OnMouseWheel(event);
},_onTextBoxPropertyChangeHandler:function(a){this._OnPropertyChange();
},_onTextBoxPasteHandler:function(a){if(this.get_readOnly()){return false;
}if($telerik.isIE&&document.documentMode>8&&this._textBoxElement.selectionStart!==this._textBoxElement.selectionEnd){this._textBoxElement.selectionEnd=this._textBoxElement.selectionStart;
}var b=this;
setTimeout(function(){b._FakeOnPropertyChange(a);
},1);
},_onTextBoxBlurHandler:function(a){this._focused=false;
this._hovered=false;
if(this._ValueHasChanged()){this.raise_valueChanged();
if(this.get_autoPostBack()&&this._canAutoPostBackAfterValidation()){this.raisePostBackEvent();
}}this.set_validationText(this._constructValidationText(""));
this.raise_blur(Sys.EventArgs.Empty);
this.updateDisplayValue();
this.updateCssClass();
},_constructValidationText:function(a){if(this.get_value()&&!(this._requireCompleteText&&this.get_valueWithPromptAndLiterals()!=this.get_valueWithLiterals())){return this.get_valueWithLiterals();
}else{return"";
}},_onTextBoxMouseUpHandler:function(a){this._FakeOnPropertyChange(a);
this._ValueHandler(a);
this._ActivityHandler(a);
},_onTextBoxMouseDownHandler:function(a){this._FakeOnPropertyChange(a);
this._ActivityHandler(a);
},_onTextBoxFocusHandler:function(a){this._focused=true;
this.updateDisplayValue();
this.updateCssClass();
this._updateSelectionOnFocus();
this._FakeOnPropertyChange(a);
this._ActivityHandler(a);
this.raise_focus(Sys.EventArgs.Empty);
if(($telerik.isSafari||$telerik.isFirefox)&&this.get_selectionOnFocus()!=Telerik.Web.UI.SelectionOnFocus.None&&this.get_selectionOnFocus()!=Telerik.Web.UI.SelectionOnFocus.SelectAll){var b=this;
window.setTimeout(function(){b._updateSelectionOnFocus();
},0);
}},_onTextBoxKeyUpHandler:function(a){this._FakeOnPropertyChange(a);
},_OnActivity:function(a){this._calculateSelection();
this._lastState=new Telerik.Web.UI.MaskedEventWrap(a,this._textBoxElement);
},_OnPropertyChange:function(){if(this._internalValueUpdate){return;
}if(event.propertyName=="value"){var a=event;
var b=this;
var c=function(){b._ValueHandler(a);
};
this._calculateSelection();
if(this._textBoxElement.selectionStart>0||this._textBoxElement.selectionEnd>0){c();
}else{setTimeout(c,1);
}}},_onTextBoxMouseWheelHandler:function(b){if(this.get_readOnly()){return false;
}this._calculateSelection();
var a=this._partIndex[this._textBoxElement.selectionStart];
if(a==null){return true;
}return a.HandleWheel(b);
},_updateSelectionOnFocus:function(){switch(this.get_selectionOnFocus()){case 0:break;
case 1:var b=0;
var a;
for(a=0;
a<this._partIndex.length;
a++){if(!this._partIndex[a].ch){b=a;
break;
}}this.set_caretPosition(b);
break;
case 2:if(this._textBoxElement.value.length>0){this.set_caretPosition(this._textBoxElement.value.length);
}break;
case 3:this.selectAllText();
break;
default:this.set_caretPosition(0);
break;
}},_onTextBoxKeyDownHandler:function(b){if(!this._focused){this._focused=true;
}if(b.keyCode==27&&!$telerik.isIE){var f=this;
window.setTimeout(function(){f.set_textBoxValue(f.get_editValue());
},0);
}this._FakeOnPropertyChange(b);
if(this.inSelection(b)){return true;
}var a=this._partIndex[this._textBoxElement.selectionStart];
if(this.get_readOnly()&&(b.keyCode==46||b.keyCode==8||b.keyCode==38||b.keyCode==40||b.keyCode==127)){b.preventDefault();
return false;
}else{if(b.keyCode==13){return true;
}else{if(a==null&&b.keyCode!=8){return true;
}else{if(a!=null){if(a.HandleKey(b)){b.preventDefault();
return false;
}}}}}var d=this._textBoxElement.selectionEnd;
var c=false;
if((b.keyCode==46||b.keyCode==127)&&d<this._textBoxElement.value.length){a.SetValue("",this._textBoxElement.selectionStart);
d++;
c=true;
b.preventDefault();
}else{if(b.keyCode==8&&d){this._partIndex[this._textBoxElement.selectionStart-1].SetValue("",this._textBoxElement.selectionStart-1);
d--;
c=true;
b.preventDefault();
}}if(c){return this._UpdateAfterKeyHandled(b,d);
}this._OnActivity(b);
return true;
},_onTextBoxKeyPressHandler:function(c){var i=true;
for(var f in Sys.UI.Key.prototype){if(c.charCode===Sys.UI.Key[f]){i=false;
break;
}}if(this.get_readOnly()&&i){c.preventDefault();
c.stopPropagation();
return false;
}var d=new Telerik.Web.UI.InputKeyPressEventArgs(c,c.charCode,String.fromCharCode(c.charCode));
this.raise_keyPress(d);
if(d.get_cancel()){c.stopPropagation();
c.preventDefault();
return false;
}if(this.inSelection(c)){return true;
}var b=this._partIndex[this._textBoxElement.selectionStart];
if(b==null){if(c.charCode==13){if(this._ValueHasChanged()){this.raise_valueChanged();
this.updateDisplayValue();
this.updateCssClass();
}if(this.get_autoPostBack()){if(this._canAutoPostBackAfterValidation()){this.raisePostBackEvent();
}c.stopPropagation();
c.preventDefault();
return false;
}return true;
}else{if(c.charCode>47){c.stopPropagation();
c.preventDefault();
}return false;
}}if(Sys.Browser.agent==Sys.Browser.Firefox||Sys.Browser.agent==Sys.Browser.Opera){if(c.charCode==8){c.preventDefault();
c.stopPropagation();
return false;
}if(c.charCode==9){return true;
}if(!c.rawEvent.which){this._OnActivity(c);
c.stopPropagation();
return true;
}}var h=this._textBoxElement.selectionEnd;
if(c.charCode==13){if(this._ValueHasChanged()){this.raise_valueChanged();
this.updateDisplayValue();
this.updateCssClass();
}if(this.get_autoPostBack()){if(this._canAutoPostBackAfterValidation()){this.raisePostBackEvent();
}c.stopPropagation();
c.preventDefault();
return false;
}return true;
}var a=String.fromCharCode(c.charCode);
if(b&&b.BuildKeyBuff){b.BuildKeyBuff(this._textBoxElement.value,h);
}if(b.CanHandle(a,h)){while(h<this._textBoxElement.value.length){if(this._partIndex[h].SetValue(a,h)){h++;
break;
}h++;
}}var g=this._UpdateAfterKeyHandled(c,h);
if(!g){c.preventDefault();
}c.stopPropagation();
return g;
},raisePostBackEvent:function(){if(this._holdsValidValue){eval(this._postBackEventReferenceScript);
}},_OnEnumChanged:function(a,d,c){var b=new Telerik.Web.UI.MaskedTextBoxEventArgs(c,d,a);
this.raise_enumerationChanged(b);
},_OnMoveUp:function(a,d,c){var b=new Telerik.Web.UI.MaskedTextBoxEventArgs(c,d,a);
this.raise_moveUp(b);
},_OnMoveDown:function(a,d,c){var b=new Telerik.Web.UI.MaskedTextBoxEventArgs(c,d,a);
this.raise_moveDown(b);
},_OnValueChange:function(a,d,c){var b=new Telerik.Web.UI.MaskedTextBoxEventArgs(c,d,a);
this.raiseEvent("valueChanged",b);
},_OnChunkError:function(a,d,c){var b=new Telerik.Web.UI.MaskedTextBoxEventArgs(c,d,a);
this.raise_error(b);
},_fixAbsolutePositioning:function(){var a=this._textBoxElement;
if(a.previousSibling&&a.previousSibling.tagName&&a.previousSibling.tagName.toLowerCase()=="label"&&a.style.position=="absolute"){a.style.position="static";
var b=a.parentNode;
b.style.position="absolute";
b.style.top=a.style.top;
b.style.left=a.style.left;
}},_PartAt:function(a){return this._partIndex[a];
},_CreatePartCollection:function(f,g){var a;
var c=[];
var e=0;
for(var d=0;
d<f.length;
d++){a=f[d];
a.PromptChar=g;
a.SetController(this);
a.index=this._parts.length;
c[c.length]=a;
if(c.length>1){c[c.length-2].NextChunk=a;
}a.NextChunk=null;
var b=a.GetLength();
a.offset=e;
e+=b;
}return c;
},_setMask:function(d){this._parts=this._CreatePartCollection(d,this.get_promptChar());
for(var b=0;
b<this._parts.length;
b++){var a=this._parts[b].GetLength();
for(var c=this._length;
c<this._length+a;
c++){this._partIndex[c]=this._parts[b];
}this._length+=a;
}},_setDisplayMask:function(d){this._displayParts=this._CreatePartCollection(d,this.get_displayPromptChar());
for(var b=0;
b<this._displayParts.length;
b++){var e=this._displayParts[b];
var a=e.GetLength();
for(var c=this._displayLength;
c<this._displayLength+a;
c++){this._displayPartIndex[c]=this._displayParts[b];
}this._displayLength+=a;
}},_SafariSelectionFix:function(a){var b=this._StrCompare(this._lastState.fieldValue,a.fieldValue);
a._selectionStart=b[0];
a._selectionEnd=b[0];
this._lastState._selectionStart=b[1];
this._lastState._selectionEnd=b[2];
},_HandleValueChange:function(b){if(this.get_readOnly()){this._Visualise();
return false;
}if(this._lastState==null){return;
}var f;
if($telerik.isSafari){this._SafariSelectionFix(b);
}var g=this._lastState.fieldValue.length>b.fieldValue.length;
if(g){if(b._selectionStart==this._textBoxElement.value.length){this._partIndex[this._partIndex.length-1].SetValue("",this._partIndex.length-1);
}if(this._lastState._selectionEnd>b._selectionStart){f=this._lastState._selectionEnd;
while(f-->b._selectionStart){var h=this._partIndex[f];
if(h){h.SetValue("",f);
}}}else{f=Math.min(this._lastState._selectionEnd+1,this._partIndex.length);
while(f-->b._selectionStart){this._partIndex[f].SetValue("",f);
b._selectionEnd++;
}}}var n=this._lastState._selectionStart;
var m=Math.min(b._selectionStart,this._length);
var l=b.fieldValue.substr(n,m-n);
var j=this._UpdatePartsInRange(l,n,m);
this._Visualise();
if(g&&this._element.value===this._lastState.fieldValue&&this._element.value.substr(n,m-n)!==l){var c=this._element;
var k=this._lastState._selectionStart;
var d=this._lastState._selectionEnd;
c.selectionStart=k;
c.selectionEnd=d;
setTimeout(function(){c.selectionStart=k;
c.selectionEnd=d;
},0);
return;
}b._selectionEnd+=j;
if($telerik.isIE){this._FixSelection(b);
}else{var a=this;
setTimeout(function(){a._FixSelection(b);
},0);
}},_SetPartValues:function(g,f,k,c,h){var b;
var d=0;
var e=c;
var a=0;
k=k.toString();
while(d<h-c&&e<f){b=k.charAt(d);
if(b==this.get_promptChar()){b="";
}if(g[e].SetValue(b,e)){d++;
}else{a++;
}e++;
}return a;
},_UpdateDisplayPartsInRange:function(){var c=0;
var a=0;
var e="";
var b="";
for(var d=0;
d<this._parts.length;
d++){if(!this._parts[d].ch){e+=this._parts[d].GetVisValue();
}}while(c<this._displayPartIndex.length){if(this._displayPartIndex[c].ch){a+=(this._displayPartIndex[c].ch.match(new RegExp(/\*/g))||[]).length;
c+=this._displayPartIndex[c].ch.length;
}else{b=e.charAt(a);
this._displayPartIndex[c].SetValue(b,c);
a++;
c++;
}}},_UpdatePartsInRange:function(d,a,c){var b=this._SetPartValues(this._partIndex,this._length,d,a,c);
return b;
},_FixSelection:function(a){this.set_cursorPosition(a._selectionEnd);
},_GetVisibleValues:function(b){var c=[];
for(var a=0;
a<b.length;
a++){c[a]=b[a].GetVisValue();
}return c.join("");
},_Visualise:function(){var a=this.get_valueWithPromptAndLiterals();
this._internalValueUpdate=true;
this._Render(a);
this.updateCssClass();
this.updateHiddenValue();
this._internalValueUpdate=false;
this._projectedValue=this._textBoxElement.value;
},_isEmptyMessage:function(){return this.__isEmptyMessage;
},_Render:function(a){this.__isEmptyMessage=false;
if(!this._focused){if(this.get_hideOnBlur()&&this.isEmpty()){this.__isEmptyMessage=true;
this.set_textBoxValue(this.get_emptyMessage());
}else{if(this._displayParts&&this._displayParts.length){this.set_textBoxValue(this.get_displayValue());
}else{this.set_textBoxValue(a);
}}}else{this.set_textBoxValue(a);
}},_getResetValue:function(){var b="";
var a=this._parts[0];
while(a.NextChunk){if(a.GetVisValue()==a.GetValue()){b+=a.PromptChar;
}else{b+=a.GetVisValue();
}a=a.NextChunk;
}return b;
},_ValueHasChanged:function(){return this._textBoxElement.value!=this._textBoxElement._oldValue;
},_FakeOnPropertyChange:function(a){if($telerik.isIE&&document.documentMode>8){this._calculateSelection();
this._ValueHandler(a||{});
}else{if(document.createEventObject){var b;
if(event){b=document.createEventObject(event);
}else{b=document.createEventObject();
}b.propertyName="value";
this._textBoxElement.fireEvent("onpropertychange",b);
}}},_UpdateAfterKeyHandled:function(a,c){this._Visualise();
var b=new Telerik.Web.UI.MaskedEventWrap(a,this._textBoxElement);
b._selectionEnd=c;
this._FixSelection(b);
return false;
},_ValueHandler:function(a){if(this._internalValueUpdate){return true;
}if(!a){a=window.event;
}this._calculateSelection();
var b=new Telerik.Web.UI.MaskedEventWrap(a,this._textBoxElement);
if(b.fieldValue!=this._projectedValue){this._HandleValueChange(b);
}return true;
},_ActivityHandler:function(a){if(this._internalValueUpdate){return true;
}if(!a){a=window.event;
}this._OnActivity(a);
return true;
},_calculateSelection:function(){if((document.selection&&Sys.Browser.agent!=Sys.Browser.Opera)&&(typeof window.getSelection=="undefined")){var c;
try{c=document.selection.createRange();
}catch(a){return;
}if(c.parentElement()!=this._textBoxElement){return;
}var b=c.duplicate();
if(this._isTextarea){b.moveToElementText(this._textBoxElement);
}else{b.move("character",-this._textBoxElement.value.length);
}b.setEndPoint("EndToStart",c);
this._textBoxElement.selectionStart=b.text.length;
this._textBoxElement.selectionEnd=this._textBoxElement.selectionStart+c.text.length;
}},_StrCompare:function(e,f){var a;
var d,c,b;
a=0;
while(e.charAt(a)==f.charAt(a)&&a<e.length){a++;
}c=a;
e=e.substr(c).split("").reverse().join("");
f=f.substr(c).split("").reverse().join("");
a=0;
while(e.charAt(a)==f.charAt(a)&&a<e.length){a++;
}d=c+f.length-a;
b=e.length-a+c;
return[d,c,b];
},get__initialMasks:function(){return this._initialMasks;
},set__initialMasks:function(a){this._initialMasks=a;
},get__initialDisplayMasks:function(){return this._initialDisplayMasks;
},set__initialDisplayMasks:function(a){this._initialDisplayMasks=a;
},raise_valueChanged:function(){this._triggerDomEvent("change",this._textBoxElement);
this._holdsValidValue=true;
if(this._requireCompleteText){if(this.get_valueWithPromptAndLiterals()!=this.get_valueWithLiterals()){return this._invalidate();
}}var a=this._textBoxElement._oldValue;
this._textBoxElement._oldValue=this._textBoxElement.value;
this._OnValueChange(null,a,this._textBoxElement.value);
}};
Telerik.Web.UI.RadMaskedTextBox.registerClass("Telerik.Web.UI.RadMaskedTextBox",Telerik.Web.UI.RadInputControl);
if(typeof(Sys)!=='undefined')Sys.Application.notifyScriptLoaded();