Type.registerNamespace("Telerik.Web.UI");
(function(a){a.PivotGridConfigurationPanel=function(b){a.PivotGridConfigurationPanel.initializeBase(this,[b]);
this._owner=null;
this._enableDragDrop=true;
this._enableFieldsContextMenu=true;
this._layoutType=null;
this._fieldsData=null;
this._fields=null;
this._aggregate=null;
this._containers=null;
this._updateButton=null;
this._checkBox=null;
this._treeView=null;
this._menuButton=null;
this._dragElement=null;
this._fieldReference=null;
this._isDeferedLayoutUpdate=false;
this._scrollExtender=null;
this._touchHoldTimeout=0;
this._touchScrollInProgress=false;
this._touchDragStarted=false;
this._orderIndicatorPair=null;
this._updateCommandsString="";
this._onMouseDownDelegate=null;
this._onMouseUpDelegate=null;
this._onMouseMoveDelegate=null;
this._onClickDelegate=null;
this._onFieldsWindowMouseDownDelegate=null;
};
a.PivotGridConfigurationPanel.prototype={initialize:function(){var e=this,d=e.get_id();
a.PivotGridConfigurationPanel.callBaseMethod(e,"initialize");
e._setFields();
e._checkBox=$get(d+"_DeferLayoutUpdateCheckBox");
e._updateButton=$get(d+"_UpdateButton");
var c=e.get_element();
if(e._enableDragDrop){e._onMouseDownDelegate=$telerik.addMobileHandler(e,c,"mousedown",e._onMouseDownHandler);
}e._onClickDelegate=$telerik.addMobileHandler(e,c,"click",e._onClickHandler);
e._tryEnableDifferedLayoutUpdate();
e._enableMobileSupport(e._enableDragDrop);
var b=e.get_element().className;
if(b.indexOf("rpgStackedConfigurationPanel")!=-1){e._layoutType=a.PivotGridConfigurationPanelLayoutType.Stacked;
}else{if(b.indexOf("rpgSideBySideConfigurationPanel")!=-1){e._layoutType=a.PivotGridConfigurationPanelLayoutType.SideBySide;
}else{if(b.indexOf("rpgTwoByTwoConfigurationPanel")!=-1){e._layoutType=a.PivotGridConfigurationPanelLayoutType.TwoByTwo;
}else{if(b.indexOf("rpgOneByFourConfigurationPanel")!=-1){e._layoutType=a.PivotGridConfigurationPanelLayoutType.OneByFour;
}}}}e._treeView=$telerik.findControl(c,"RadTreeViewOLAP");
},dispose:function(){if(this._onMouseDownDelegate){$telerik.removeMobileHandler(document,"mousedown",this._onMouseDownDelegate,null,true);
}if(this._onMouseUpDelegate){$telerik.removeMobileHandler(document,"mouseup",this._onMouseUpDelegate,null,true);
}if(this._onMouseMoveDelegate){$telerik.removeMobileHandler(document,"mousemove",this._onMouseMoveDelegate,null,true);
}if(this._onFieldsWindowMouseDownDelegate){$telerik.removeMobileHandler(document,"mousemove",this._onFieldsWindowMouseDownDelegate,null,true);
}a.PivotGridConfigurationPanel.callBaseMethod(this,"dispose");
},get_owner:function(){return this._owner;
},set__owner:function(b){this._owner=b;
},get_layoutType:function(){return this._layoutType;
},set_layoutType:function(b){this._layoutType=b;
this._updateLayout(this.get_owner().get_element());
this._updateLayout(this.get_element());
this._owner.repaint();
this._owner.updateClientState();
},get_fields:function(){return this._fields;
},get_updateButton:function(){return this._updateButton;
},get_deferLayoutUpdateCheckBox:function(){return this._checkBox;
},get_isDeferedLayoutUpdate:function(){if(this._checkBox.checked){return true;
}return false;
},get_treeView:function(){return this._treeView;
},update:function(b){if(!b&&(!this.get_isDeferedLayoutUpdate()||this._updateCommandsString=="")){return;
}this._owner.fireCommand("UpdateLayout",this._updateCommandsString);
},_moveUp:function(b){var d=b.get_previousField();
var c=false;
if(d){if(d.get_previousField()){d=d.get_previousField();
}else{c=true;
}}this._moveField(b,function(){return d;
},null,c);
},_moveDown:function(b){this._moveField(b,function(){return b.get_nextField();
});
},_moveToBeginning:function(b){this._moveField(b,function(){var c=b;
while(c.get_previousField()){c=c.get_previousField();
}return c;
},null,true);
},_moveToEnd:function(b){this._moveField(b,function(){var c=b;
while(c.get_nextField()){c=c.get_nextField();
}return c;
});
},_moveToFilterFields:function(b){var c=this;
c._moveField(b,function(){return c._getLastFieldFromZone(a.PivotGridFieldZoneType.Filter);
},a.PivotGridFieldZoneType.Filter);
},_moveToRowFields:function(b){var c=this;
c._moveField(b,function(){return c._getLastFieldFromZone(a.PivotGridFieldZoneType.Row);
},a.PivotGridFieldZoneType.Row);
},_moveToColumnFields:function(b){var c=this;
c._moveField(b,function(){return c._getLastFieldFromZone(a.PivotGridFieldZoneType.Column);
},a.PivotGridFieldZoneType.Column);
},_moveToAggregateFields:function(b){var c=this;
c._moveField(b,function(){return c._getLastFieldFromZone(a.PivotGridFieldZoneType.Aggregate);
},a.PivotGridFieldZoneType.Aggregate);
},_moveField:function(b,d,h,e){var i=this,f=i._tryShowHiddenField(b),g=d();
if(!h){h=b.get_zoneType();
}if(!e){e=false;
}var j=a.PivotGridDragDropBase.GetZoneIndex(h,f,g,e);
var c=i._getFieldsContainerByZoneType(h);
i._reorderField(f,g,h,j,c);
},_getLastFieldFromZone:function(e){var b=this.get_fields();
var d=null;
for(var c=0;
c<b.length;
c++){if(b[c].get_zoneType()==e&&(d==null||b[c].get_zoneIndex()>=d.get_zoneIndex())){d=b[c];
}}return d;
},_setFields:function(){var c=this._fieldsData;
var m=this.get_owner();
var k=this._internalFields=[];
var h=this._fields=[];
var d=this.get_element();
var g=$telerik.getElementsByClassName(d,"rpgFieldItem","span");
var f=null;
for(var j=0;
j<g.length;
j++){f=g[j];
if(this._enableDragDrop&&m._renderMode!=Telerik.Web.UI.RenderMode.Lite){f.style.cursor="move";
}var n=c[f.id];
if(n){var l=m.getFieldByUniqueName(n);
if(l){var e=$create(a.PivotGridField,null,null,{_owner:m.ClientID},f);
e._isConfigurationPanelField=true;
e._owner=m;
e._uniqueName=l._uniqueName;
e._zoneIndex=l._zoneIndex;
e._isHidden=l._isHidden;
e._zoneType=l._zoneType;
if(!f.id.endsWith("_Hidden")){h.push(e);
}k.push(e);
}}else{if(f.className&&f.className.indexOf("rpgValues")!=-1){var b=this._aggregate=$create(a.PivotGridAggregateLabel,null,null,{_owner:m},f);
b._owner=m;
b._position=m._aggregatesPosition;
b._level=m._aggregatesLevel;
}}}},_tryEnableDifferedLayoutUpdate:function(){if(!this.get_isDeferedLayoutUpdate()){return;
}var k=this.get_updateButton();
k.removeAttribute("disabled");
if(k.parentNode.className.indexOf("rfdSkinnedButton")!=-1){Sys.UI.DomElement.removeCssClass(k.parentNode,"rfdInputDisabled");
}var e=this._internalFields;
for(var f=0;
f<e.length;
f++){var d=e[f].get_element().getElementsByTagName("*");
if(d.length==0){continue;
}var b=null;
var c=null;
for(var g=0;
g<d.length;
g++){b=d[g];
c=b.tagName.toLowerCase();
if(c=="a"){if(this._owner._renderMode!=Telerik.Web.UI.RenderMode.Lite){b.href="#";
}}else{if(c=="input"&&b.id&&b.id.endsWith("_ShowHide")){var h=this;
b.onclick=function(i){h._showHideField(this,i);
};
}}}}},_enableMobileSupport:function(d){var f,c=$telerik.isMobileIE10&&d;
var j=this,b=$telerik.$;
if($telerik.isTouchDevice||c){f=$telerik.getElementsByClassName(this.get_element(),"rpgFieldsContainer","div");
}if(c){for(var g=0,h=f.length;
g<h;
g++){var e=f[g];
if(e){e.style.msTouchAction="none";
e.style.touchAction="none";
}}}if($telerik.isTouchDevice){j._scrollExtender=new a.TouchScrollExtender(f);
j._scrollExtender._simpleDragger=function(i){if(this._dragCanceled){return;
}var k=$telerik.getTouchEventLocation(i);
if(this._lastAnimator.element.length){this._throttleScroll(k);
this._alignScrollHints();
}this._storeLastLocation(k);
};
j._scrollExtender._compositeDragger=function(i){if(this._dragCanceled){return;
}var m=$telerik.getTouchEventLocation(i);
var k=this._lastAnimator;
var l=k.element[0];
if(Math.abs(k.kX-m.x)>10||Math.abs(k.kY-m.y)>10){k.hasDragged=true;
this._addScrollHints();
if(a.TouchScrollExtender._getNeedsScrollExtender()){b(document.body).unbind("touchmove",this._compositeDragger).bind("touchmove",b.proxy(this._simpleDragger,this));
}else{b(document.body).unbind("mousemove",this._compositeDragger).bind("mousemove",b.proxy(this._simpleDragger,this));
}if($telerik.isIE){k.element.bind("click",this._cancelEvents);
l.setCapture(true);
}else{l.addEventListener("click",this._cancelEvents,true);
}}};
j._scrollExtender._endDrag=function(i){if(this._dragCanceled){return;
}this._detachEvents();
if(a.TouchScrollExtender._getNeedsScrollExtender()){if(this._lastAnimator.originalEvent.touches.length==1&&!this._lastAnimator.hasDragged){var n=this._lastAnimator.originalEvent;
var k=document.createEvent("MouseEvents");
k.initMouseEvent("click",n.bubbles,n.cancelable,n.view,n.detail,n.screenX,n.screenY,n.clientX,n.clientY,false,false,false,false,n.button,n.relatedTarget);
n.target.dispatchEvent(k);
}}var o=this;
var m=$telerik.getTouchEventLocation(i);
var l=this._lastAnimator;
if($telerik.isIE){setTimeout(function(){l.element.unbind("click",o._cancelEvents);
document.releaseCapture();
},10);
}else{setTimeout(function(){l.element[0].removeEventListener("click",o._cancelEvents,true);
},0);
}if(l.hasDragged){if(l.element.length){l.endX=m.x;
l.endY=m.y;
}this._finishDrag(l);
}};
j._scrollExtender.initialize();
}},_onClickHandler:function(f){var d=a.PivotGrid.GetTouchCurrentElement(f);
if(!a.PivotGrid.IsDomElement(d)){return;
}var c=this.get_deferLayoutUpdateCheckBox().id;
var i=this._owner;
var h=i._renderMode==Telerik.Web.UI.RenderMode.Lite?"Icon":"";
if(d.id==c){var b=this._updateButton;
if(!b.disabled){this.update(true);
}else{this._tryEnableDifferedLayoutUpdate();
}}else{if(this.get_isDeferedLayoutUpdate()&&(d.className.indexOf("rpgSortAsc"+h)!=-1||d.className.indexOf("rpgSortDesc"+h)!=-1)){var g=i._getField(d.parentNode);
if(g){if(d.className.indexOf("rpgSortAsc"+h)!=-1){Sys.UI.DomElement.removeCssClass(d,"rpgSortAsc"+h);
Sys.UI.DomElement.addCssClass(d,"rpgSortDesc"+h);
}else{Sys.UI.DomElement.removeCssClass(d,"rpgSortDesc"+h);
Sys.UI.DomElement.addCssClass(d,"rpgSortAsc"+h);
}this._sortField(g);
f.stopPropagation();
f.preventDefault();
return false;
}}}},_onMouseDownHandler:function(c){if(!$telerik.isTouchDevice&&c.button!=Sys.UI.MouseButton.leftButton){return false;
}var b=a.PivotGrid.GetTouchCurrentElement(c);
if(!a.PivotGrid.IsDomElement(b)){return false;
}var d=this;
d._fieldReference=d._owner._searchForFieldFromElement(b);
if(d._fieldReference==null){return $telerik.isTouchDevice;
}if($telerik.isTouchDevice){$telerik.cancelRawEvent(c);
d._touchHoldTimeout=setTimeout(function(){if(!d._touchScrollInProgress){d._touchDragStarted=true;
d._scrollExtender.disable();
}},500);
}d._onMouseUpDelegate=$telerik.addMobileHandler(d,document,"mouseup",d._onMouseUpHandler,null,true);
d._onMouseMoveDelegate=$telerik.addMobileHandler(d,document,"mousemove",d._onMouseMoveHandler,null,true);
a.PivotGrid.ClearDocumentEvents();
},_onMouseMoveHandler:function(f){if($telerik.isTouchDevice){f.preventDefault();
if(!this._touchDragStarted){this._touchScrollInProgress=true;
return false;
}}var b=a.PivotGrid.GetTouchCurrentElement(f);
if(!a.PivotGrid.IsDomElement(b)){return;
}var l=this._fieldReference;
if(this._orderIndicatorPair==null){var n=2000;
var j=this._owner;
var k=j.Skin;
if(j.get_element().className.indexOf("rpgFieldsWindowConfigurationPanel")!=-1){n=4000;
}if(!this._customDragDrop){this._dragElement=a.PivotGridDragDropBase.CreateDragElement(l.get_element(),k);
}this._orderIndicatorPair=a.PivotGridDragDropBase.CreateOrderIndicatorPair(["&rarr;","&larr;"],["PivotGridReorderLeft","PivotGridReorderRight"],k,n);
}if(!this._customDragDrop){var d=this._dragElement;
a.PivotGridDragDropBase.PositionDragElement(d,f);
}var i=this._orderIndicatorPair;
var h=this._getFieldsContainerWrapper(b);
if(!h){a.PivotGridDragDropBase.HideOrderIndicatorPair(i);
return;
}var g=h.getElementsByTagName("div")[0];
if(!g){a.PivotGridDragDropBase.HideOrderIndicatorPair(i);
return;
}var o=this._getZoneTypeByFieldsContainerWrapper(h);
var c=a.PivotGridDragDropBase.GetFieldPlacementData(this._owner,g,f,true);
var m=$find(c.element.id);
this._moveOrderIndicatorPair(g,l,m,o,c);
},_moveOrderIndicatorPair:function(c,g,h,j,b){var d=null;
var e=a.PivotGridAggregateLabel.isInstanceOfType(g);
if(e){d=b.index;
}else{d=a.PivotGridDragDropBase.GetZoneIndex(j,g,h,b.isFirstElement);
}var i=this;
var f=i._orderIndicatorPair;
if(i._shouldMoveOrderIndicatorPair(e,j,g,b,d)){if(j==-1){a.PivotGridDragDropBase.MoveOrderIndicatorPair(c,f,true,true);
}else{a.PivotGridDragDropBase.MoveOrderIndicatorPair(b.element,f,true,b.isFirstElement);
}}else{a.PivotGridDragDropBase.HideOrderIndicatorPair(f);
}},_shouldMoveOrderIndicatorPair:function(d,h,e,b,c){var f=this;
if(h==-1){var g=f._getFieldsContainerWrapper(e.get_element());
if(f._getZoneTypeByFieldsContainerWrapper(g)==-1||d){return false;
}return true;
}else{if(!d&&e.get_isHidden()&&e.get_id().endsWith(String.format("_{0}_Hidden",e.get_uniqueName()))){return true;
}else{if(!d&&e._canReorder(h,c,b.isFirstElement)){return true;
}else{if(d&&(h==a.PivotGridFieldZoneType.Column||h==a.PivotGridFieldZoneType.Row)&&((e._getPositionAsZoneType()==h&&(e.get_level()!=c+1&&!b.isFirstElement)||(e.get_level()!=0&&b.isFirstElement))||e._getPositionAsZoneType()!=h)){return true;
}}}}return false;
},_onMouseUpHandler:function(c){if($telerik.isTouchDevice){this._touchDragStarted=this._touchScrollInProgress=false;
if(this._touchHoldTimeout!=0){clearTimeout(this._touchHoldTimeout);
}this._scrollExtender.enable();
}$telerik.removeMobileHandler(document,"mouseup",this._onMouseUpDelegate,null,true);
$telerik.removeMobileHandler(document,"mousemove",this._onMouseMoveDelegate,null,true);
a.PivotGrid.RestoreDocumentEvents();
if(!this._orderIndicatorPair){return;
}var d=this._orderIndicatorPair;
var f=false;
if(d[0].style.display=="none"){f=true;
}a.PivotGridDragDropBase.DestroyOrderIndicatorPair(this._orderIndicatorPair);
this._orderIndicatorPair=null;
var b=this._dragElement;
if(b){b.parentNode.removeChild(b);
this._dragElement=null;
}if(f){return;
}this._handleDropAction(c);
this._customDragDrop=false;
},_handleDropAction:function(d){var b=a.PivotGrid.GetTouchCurrentElement(d);
if(!a.PivotGrid.IsDomElement(b)){return;
}var g=this._getFieldsContainerWrapper(b);
var f=g.getElementsByTagName("div")[0];
var l=this._getZoneTypeByFieldsContainerWrapper(g);
var c=a.PivotGridDragDropBase.GetFieldPlacementData(this._owner,f,d,true);
var i=this._fieldReference;
if(l==-1){this._hideField(i);
}else{if(a.PivotGridField.isInstanceOfType(i)){i=this._tryShowHiddenField(i);
var j=$find(c.element.id);
var k=a.PivotGridDragDropBase.GetZoneIndex(l,i,j,c.isFirstElement);
this._reorderField(i,j,l,k,f);
}else{var h=i._zoneTypeToPivotAxis(l);
this._changeAggregate(h,c,f);
}}},_getFieldsContainerWrapper:function(b){while(b){if(b.className&&b.className.indexOf("rpgFieldsContainer")!=-1){return b.parentNode;
}b=b.parentNode;
}return null;
},_getFieldsContainerByZoneType:function(d){var b=this._element;
var c=null;
switch(d){case a.PivotGridFieldZoneType.Filter:c=$telerik.getElementsByClassName(b,"rpgFilterFieldsContainer","div")[0];
break;
case a.PivotGridFieldZoneType.Column:c=$telerik.getElementsByClassName(b,"rpgColumnFieldsContainer","div")[0];
break;
case a.PivotGridFieldZoneType.Row:c=$telerik.getElementsByClassName(b,"rpgRowFieldsContainer","div")[0];
break;
case a.PivotGridFieldZoneType.Aggregate:c=$telerik.getElementsByClassName(b,"rpgAggregateFieldsContainer","div")[0];
break;
}if(c){return c.getElementsByTagName("div")[0];
}return null;
},_getZoneTypeByFieldsContainerWrapper:function(c){var b=c.className;
if(b.indexOf("rpgFilterFieldsContainer")!=-1){return a.PivotGridFieldZoneType.Filter;
}else{if(b.indexOf("rpgColumnFieldsContainer")!=-1){return a.PivotGridFieldZoneType.Column;
}else{if(b.indexOf("rpgRowFieldsContainer")!=-1){return a.PivotGridFieldZoneType.Row;
}else{if(b.indexOf("rpgAggregateFieldsContainer")!=-1){return a.PivotGridFieldZoneType.Aggregate;
}}}}return -1;
},_hideField:function(b){var c=this;
if(c.get_isDeferedLayoutUpdate()){c._changeCheckedStateOfHiddenField(b);
c._hideFieldClientSide(b);
}else{b.hide();
}},_changeCheckedStateOfHiddenField:function(b){var f=this,e,d;
if(!b.get_id().endsWith(String.format("_{0}_Hidden",b.get_uniqueName()))){b=f._getCorrespondingOppositeField(b);
if(!b){return;
}}e=b.get_element().getElementsByTagName("input");
for(var c=0;
c<e.length;
c++){d=e[c];
if(d.id&&d.id.endsWith("_ShowHide")){d.checked=!d.checked;
}else{if(d.className&&Sys.UI.DomElement.containsCssClass(d,"rtChk")){d.checked=!d.checked;
f._owner._olapExtension.updateNodeHighlightState(f._owner._olapExtension.treeView._extractNodeFromDomElement(d));
}}}},_showHideField:function(h,c){var i=this;
var d=$find(h.parentNode.id);
var e=i.get_fields();
var b=i._getCorrespondingOppositeField(d);
if(h.checked){i._showFieldClientSide(b);
var g=0;
for(var f=0;
f<e.length;
f++){if(e[f].get_zoneType()==d.get_zoneType()&&e[f].get_zoneIndex()>g){g=e[f].get_zoneIndex();
}}b._zoneIndex=g+1;
}else{i._hideFieldClientSide(b);
}},_getCorrespondingOppositeField:function(e){var g=this,c=g._owner._olapExtension,d=this._internalFields,b=null;
for(var f=0;
f<d.length;
f++){b=d[f];
if(b.get_id()!=e.get_id()&&e.get_uniqueName()==b.get_uniqueName()){return b;
}}if(c){return c.treeView.findNodeByAttribute("field",e.get_uniqueName());
}return null;
},_showFieldClientSide:function(c){var d=this;
var b=d._getCorrespondingOppositeField(c);
b._isHidden=false;
c._isHidden=false;
d._tryShowHideAggregate();
d._showFieldElement(c);
d._updateCommandsString+=String.format("sh({0});",c.get_uniqueName());
},_hideFieldClientSide:function(c){var d=this;
var b=d._getCorrespondingOppositeField(c);
if(b){b._isHidden=true;
}c._isHidden=true;
c.get_element().style.display="none";
d._updateCommandsString+=String.format("h({0});",c.get_uniqueName());
d._tryShowHideAggregate();
},_showFieldElement:function(d){var c=d.get_element();
if(c.style.display=="none"){c.style.display="";
var b=c.parentNode;
b.removeChild(c);
b.appendChild(c);
}},_tryShowHiddenField:function(b){var f=this,e;
if(f.get_isDeferedLayoutUpdate()){var c=f._getFieldsContainerWrapper(b.get_element()),d=f._getZoneTypeByFieldsContainerWrapper(c);
if(d==-1||b._isTreeViewFieldTarget){if(b.get_isHidden()){f._changeCheckedStateOfHiddenField(b);
b._isHidden=false;
}if(!b._isTreeViewFieldTarget){e=f._getCorrespondingOppositeField(b);
e._isHidden=false;
}f._showFieldElement(e||b);
}}return b._isTreeViewFieldTarget?b:e||b;
},_reorderField:function(j,k,n,m,f){if(this.get_isDeferedLayoutUpdate()){var l=this;
l._updateCommandsString+=String.format("r({0},{1},{2});",j.get_uniqueName(),n,m);
var d=f.getElementsByTagName("span");
var e=[];
for(var g=0;
g<d.length;
g++){var b=$find(d[g].id);
if(b&&a.PivotGridField.isInstanceOfType(b)&&!b.get_isHidden()){e.push(b);
}}e.sort(function(i,o){return i.get_zoneIndex()-o.get_zoneIndex();
});
if(j.get_zoneType()==n){l._reorderInSameZone(j,n,m,e);
}else{var c=j.get_element();
c.parentNode.removeChild(c);
f.appendChild(c);
l._reorderInDifferentZone(j,n,m,e);
}j._zoneIndex=m;
j._zoneType=n;
var h=l._getCorrespondingOppositeField(j);
if(h){h._zoneIndex=m;
h._zoneType=n;
}if(k){if(k.get_zoneIndex()>j.get_zoneIndex()){f.insertBefore(j.get_element(),k.get_element());
}else{f.insertBefore(j.get_element(),k.get_element().nextSibling);
}}l._tryShowHideAggregate();
j._isTreeViewFieldTarget=false;
}else{j.tryReorder(n,m);
}},_reorderInSameZone:function(c,j,h,d){var e=[];
var f;
for(f=0;
f<d.length;
f++){var b=d[f];
if(c.get_zoneIndex()<=h&&c.get_zoneIndex()<=b.get_zoneIndex()&&b.get_zoneIndex()<=h){e.unshift(b);
}else{if(c.get_zoneIndex()>h&&c.get_zoneIndex()>=b.get_zoneIndex()&&b.get_zoneIndex()>=h){e.push(b);
}}}for(f=0;
f<e.length-1;
f++){h=e[f+1]._zoneIndex;
e[f]._zoneIndex=h;
var g=this._getCorrespondingOppositeField(e[f]);
if(g){g._zoneIndex=h;
}}},_reorderInDifferentZone:function(c,h,g,d){for(var e=0;
e<d.length;
e++){var b=d[e];
if(b.get_uniqueName()!=c.get_uniqueName()){if(b.get_zoneIndex()==g||(b.get_previousField()&&b.get_previousField().get_zoneIndex()==b.get_zoneIndex())){b._zoneIndex++;
var f=this._getCorrespondingOppositeField(b);
if(f){f._zoneIndex++;
}}}}},_changeAggregate:function(d,f,b){var g=this;
var c=0;
if(!f.isFirstElement){c=f.index+1;
}if(this.get_isDeferedLayoutUpdate()){g._updateCommandsString+=String.format("a({0},{1});",d,c);
g._aggregate._position=d;
g._aggregate._level=c;
b.appendChild(g._aggregate._element);
var e=f.element;
if(e.className.indexOf("rpgFieldItem")!=-1){if(f.isFirstElement){b.insertBefore(g._aggregate._element,e);
}else{b.insertBefore(g._aggregate._element,e.nextSibling);
}}}else{g._aggregate.change(d,c);
}},_sortField:function(b){if(!this.get_isDeferedLayoutUpdate()){return;
}this._updateCommandsString+=String.format("s({0});",b.get_uniqueName());
},_tryShowHideAggregate:function(){var f=this;
var d=f.get_fields();
var c=0;
var b=f._aggregate.get_element().style;
for(var e=0;
e<d.length;
e++){if(d[e].get_zoneType()==a.PivotGridFieldZoneType.Aggregate&&!d[e].get_isHidden()){c++;
if(c>=2){f._showFieldElement(f._aggregate);
return;
}}}if(c<2){b.display="none";
}},_updateLayout:function(c){var b=this.get_layoutType();
Sys.UI.DomElement.removeCssClass(c,"rpgStackedConfigurationPanel");
Sys.UI.DomElement.removeCssClass(c,"rpgSideBySideConfigurationPanel");
Sys.UI.DomElement.removeCssClass(c,"rpgTwoByTwoConfigurationPanel");
Sys.UI.DomElement.removeCssClass(c,"rpgOneByFourConfigurationPanel");
switch(b){case a.PivotGridConfigurationPanelLayoutType.Stacked:Sys.UI.DomElement.addCssClass(c,"rpgStackedConfigurationPanel");
break;
case a.PivotGridConfigurationPanelLayoutType.SideBySide:Sys.UI.DomElement.addCssClass(c,"rpgSideBySideConfigurationPanel");
break;
case a.PivotGridConfigurationPanelLayoutType.TwoByTwo:Sys.UI.DomElement.addCssClass(c,"rpgTwoByTwoConfigurationPanel");
break;
case a.PivotGridConfigurationPanelLayoutType.OneByFour:Sys.UI.DomElement.addCssClass(c,"rpgOneByFourConfigurationPanel");
break;
}}};
a.PivotGridConfigurationPanel.registerClass("Telerik.Web.UI.PivotGridConfigurationPanel",Sys.UI.Control);
a.PivotGridConfigurationPanelLayoutType=function(){};
a.PivotGridConfigurationPanelLayoutType.prototype={Stacked:1,SideBySide:2,TwoByTwo:4,OneByFour:8};
a.PivotGridConfigurationPanelLayoutType.registerEnum("Telerik.Web.UI.PivotGridConfigurationPanelLayoutType",false);
})(Telerik.Web.UI);
if(typeof(Sys)!=='undefined')Sys.Application.notifyScriptLoaded();