Type.registerNamespace("Telerik.Web.UI.Scheduler.Views.Agenda");
(function(a,c,d,b,e){var i=60000,h=i*60,g=h*24,f=7;
e.ModelBase=function(k,j){this._owner=k;
this._settings=this._owner.get_agendaViewSettings();
this._defaultHeaderDateFormat="d";
this._isVertical=j;
};
e.ModelBase.prototype={get_visibleRangeStart:function(){return this._owner.get_selectedDate();
},get_visibleRangeEnd:function(){var j=new b(this.get_visibleRangeStart()).get_date().add(this.get_numberOfDays()*g).toDate();
return j;
},get_numberOfDays:function(){return this._settings.numberOfDays||f;
},get_nextPeriodDate:function(){return b.add(this._owner.get_selectedDate(),(this.get_numberOfDays()*g));
},get_previousPeriodDate:function(){return b.add(this._owner.get_selectedDate(),-(this.get_numberOfDays()*g));
},isVisible:function(j){return j._isInRange(this.get_visibleRangeStart(),this.get_visibleRangeEnd());
},get_headerDateFormat:function(){if(!this._settings){return this._defaultHeaderDateFormat;
}return this._settings.headerDateFormat||this._defaultHeaderDateFormat;
},updateColGroups:function(){var j=a(this._owner.get_element()).find(".rsAgendaView .rsHorizontalHeaderTable, .rsAgendaView .rsAgendaTable");
if(j.length>0){var k=document.createElement("colgroup");
this._addColGroups(k);
j.find("colgroup").remove();
j.prepend(k);
}},_getShowDateHeaders:function(){return(this._settings.showDateHeaders!==false);
},_getShowDateHeadersResolved:function(){return this._getShowDateHeaders();
},_addColGroups:function(j){this._addDateCol(j);
this._addTimeCol(j);
this._addAppointmentCol(j);
},_addDateCol:function(j){var l=this._settings.dateColumnWidth,k=document.createElement("col");
if(this._getShowDateHeadersResolved()){if(l!==undefined){k.width=l;
}j.appendChild(k);
}},_addTimeCol:function(j){var l=this._settings.timeColumnWidth,k=document.createElement("col");
if(l!==undefined){k.width=l;
}j.appendChild(k);
},_addAppointmentCol:function(l){var k=this._settings.appointmentColumnWidth,j=document.createElement("col");
if(k!==undefined){j.width=k;
}l.appendChild(j);
},resetBlocks:function(){}};
e.ModelBase.registerClass("Telerik.Web.UI.Scheduler.Views.Agenda.ModelBase",null,Telerik.Web.UI.ISchedulerModel);
e.Model=function(k,j){e.Model.initializeBase(this,[k,j]);
this._timeSlots=[];
};
e.Model.prototype={initialize:function(){this.initializeTimeSlots();
this.updateColGroups();
},initializeTimeSlots:function(){var j,k;
this._timeSlots=[];
for(var l=0,m=this.get_numberOfDays();
l<m;
l++){k=b.add(this.get_visibleRangeStart(),(l*g));
j=new e.TimeSlot(l,k);
Array.add(this._timeSlots,j);
}},_addToSlots:function(j,k){var l=j.slot._domElements;
Array.add(l,k);
if(this._getShowDateHeadersResolved()){a(l[0]).find("th.rsAgendaDateHeader")[0].rowSpan=l.length;
}},_getPrevRowForAppointmentPart:function(j){var l=j.slot.get_index(),k;
do{k=this._timeSlots[l]._domElements;
if(k.length>0){return k[k.length-1];
}}while(l--&&!this._isVertical);
return null;
},getAppointmentFromDomElement:function(k){var j=a(k).parents("tr.rsAgendaRow")[0]||k;
if(j){return this._owner.getAppointmentFromDomElement(j);
}return null;
},_getContentTable:function(){if(!this._contentTable){this._contentTable=a(this._owner.get_element()).find("div.rsTopWrap table.rsAgendaTable")[0];
}return this._contentTable;
},_getShowDateHeadersResolved:function(){return(this._getShowDateHeaders()&&this._settings.isVertical!==true);
},_getRenderer:function(){if(!this._renderer){this._renderer=new d.Rendering.AgendaViewRenderer(this);
}return this._renderer;
}};
e.Model.registerClass("Telerik.Web.UI.Scheduler.Views.Agenda.Model",e.ModelBase);
e.TimeSlot=function(j,k){this._index=j;
this._startTime=k;
this._domElements=[];
};
e.TimeSlot.prototype={get_index:function(){return this._index;
},get_startTime:function(){return this._startTime;
},get_endTime:function(){return b.add(this.get_startTime(),this.get_duration());
},get_duration:function(){return this.get_durationInMinutes()*i;
},get_durationInMinutes:function(){return 24*60;
},get_isAllDay:function(){return true;
},get_domElement:function(){return this._domElements[0];
},get_domElements:function(){return this._domElements;
}};
e.TimeSlot.registerClass("Telerik.Web.UI.Scheduler.Views.Agenda.TimeSlot",null,c.ISchedulerTimeSlot);
})($telerik.$,Telerik.Web.UI,Telerik.Web.UI.Scheduler,Telerik.Web.UI.Scheduler.DateTime,Telerik.Web.UI.Scheduler.Views.Agenda);
if(typeof(Sys)!=='undefined')Sys.Application.notifyScriptLoaded();