Type.registerNamespace("Telerik.Web.UI.Scheduler.Views.Month");
(function(a,c,d,e){var h=60000,g=h*60,f=g*24,i=f*7,b=d.DateTime;
e.ModelBase=function(j){this._owner=j;
this._settings=this._owner.get_monthViewSettings();
};
e.ModelBase.prototype={get_visibleRangeStart:function(){var m=this._owner.get_selectedDate(),j=d.DateHelper.getFirstDayOfMonth(m),l=d.DateHelper.getStartOfWeek(j,this._owner.get_firstDayOfWeek()),k=d.DateHelper.getEndOfWeek(l,this._owner.get_firstDayOfWeek(),this.get_weekLength()),n;
if(k.getMonth()==m.getMonth()){n=l;
}else{n=d.DateTime.add(l,7*f);
}return n;
},get_visibleRangeEnd:function(){var j=d.DateHelper.getLastDayOfMonth(this._owner.get_selectedDate());
return d.DateHelper.getEndOfWeek(j,this._owner.get_firstDayOfWeek(),this.get_weekLength());
},get_nextPeriodDate:function(){var j=this._owner.get_selectedDate();
return new Date(j.getFullYear(),j.getMonth(),32);
},get_previousPeriodDate:function(){var j=this._owner.get_selectedDate();
return new Date(j.getFullYear(),j.getMonth(),0);
},get_weekLength:function(){return d.DateHelper.getWeekLength(this._owner.get_selectedDate(),this._owner.get_firstDayOfWeek(),this._owner.get_lastDayOfWeek());
},get_headerDateFormat:function(){return this._settings.headerDateFormat||"MMM, yyyy";
},get_dayHeaderDateFormat:function(){return this._settings.dayHeaderDateFormat||"dd";
},get_firstDayHeaderDateFormat:function(){return this._settings.firstDayHeaderDateFormat||"d MMM";
},get_visibleAppointmentsPerDay:function(){return this._settings.visibleAppointmentsPerDay||2;
},updateDraggingAppointmentSize:function(j,r,m){var q=this._owner,s=r.parentNode,n=s.cells[s.cells.length-1],k=j.offsetLeft,o=n.offsetLeft+n.offsetWidth,p=Math.min(o-r.offsetLeft-k,q._draggingAppointmentWidth),l=Math.max(0,q._draggingSourceCellOffset-m.cellIndex);
if(l>0){p-=l*r.offsetWidth;
}j.style.width=p+"px";
},updateResizingAppointmentSize:function(s,q){var j=q.resizingElement,o=j.parentNode.parentNode,p=o.offsetLeft,t=s.offsetLeft,u=t+s.offsetWidth,w;
if(q.resizeFromStart){var k=q.resizingAppointment._domElements,r=o.parentNode.cells,m=r[r.length-1],n=m.offsetLeft+m.offsetWidth,l=p-t,v=l*-1;
if(a.inArray(j,k)==k.length-1){w=q.originalSize.width+l;
}else{w=n-t;
}if(w<=1){return;
}j.style.left=v+"px";
}else{w=u-p;
}if(w<=1){return;
}j.style.width=w+"px";
},_getResizingPlaneDelta:function(l,j){var m=l.parentNode.rowIndex,k=j.parentNode.rowIndex;
return m-k;
},get_startOfMovedAppointment:function(j,m,l){var k=b.subtract(j.get_start(),l.get_startTime());
return b.add(m.get_startTime(),k);
},getDurationOfMovedAppointment:function(j){return b.subtract(j.get_end(),j.get_start());
},_getSourceCellOffsetOfMovedAppointment:function(j,k){return k.cellIndex-a(j).parents("td")[0].cellIndex;
},_getSourceRowOffsetOfMovedAppointment:function(j,k){return 0;
},_getResizingAppointmentOriginalSize:function(l,k){var j=k._domElements;
var m={width:j[j.length-1].offsetWidth};
if(!this._owner._renderingManager){m.elements=this._owner._resizeHelper._getAppointmentOriginalElements(k);
}return m;
},restoreResizingAppointmentSize:function(j){var k=this._owner;
if(k._renderingManager){k._repaintAppointment(j.resizingAppointment);
}else{k._resizeHelper._restoreAppointmentOriginalElements(j);
}j.resizingElement=null;
j.resizingAppointment=null;
j.originalSize=null;
},_areTimeSlotsInAscendingOrder:function(j,k){return j.get_rawIndex().dayIndex<k.get_rawIndex().dayIndex;
},_getTimeSlotIndices:function(m){var j=d.DateTime.subtract(m,this.get_visibleRangeStart()),l=Math.floor(j/i),n=j-(l*i),k=Math.floor(n/f);
return{dayIndex:(this.get_weekLength()*l)+k};
},_getContentTable:function(){if(!this._contentTable){this._contentTable=a("div.rsTopWrap table.rsContentTable",this._owner.get_element())[0];
}return this._contentTable;
},isVisible:function(j){return j._isInRange(this.get_visibleRangeStart(),this.get_visibleRangeEnd());
},get_supportsSlotSelection:function(){return true;
},getTimeSlotsBetween:function(j,m){if(!(j&&m)){return[];
}var k=j.get_rawIndex(),n=m.get_rawIndex();
if(k.modelIndex!=n.modelIndex){return[];
}if(k.dayIndex==n.dayIndex){return[j];
}if(!this._areTimeSlotsInAscendingOrder(j,m)){var r=j;
j=m;
m=r;
k=j.get_rawIndex();
n=m.get_rawIndex();
}var p=[j],q=n.dayIndex-k.dayIndex,o=j;
for(var l=0;
l<q;
l++){o=this._getNextTimeSlot(o);
if(o){p.push(o);
}}return p;
},_getNextTimeSlot:function(m){var k=m.get_rawIndex(),j={dayIndex:m.get_rawIndex().dayIndex+1,modelIndex:k.modelIndex},n=this._getTimeSlotDomElement(j),l=this._getTimeFromIndex(j);
return this._createTimeSlot(j,l,n);
},_createTimeSlot:function(k,l,j){return new e.TimeSlot(k,l,j);
},_processRowSelection:function(r,s){var q=this._owner._rowSelectionState,j=q.rowSelectionEndSlot,m=this.getTimeSlotFromDomElement(r),p=q.rowSelectionStartSlot.get_rawIndex(),n=m.get_rawIndex();
if((n.viewPartIndex!=p.viewPartIndex)||(n.modelIndex!=p.modelIndex)){return;
}var k=(j)?true:false,o=true;
if(k){var l=j.get_rawIndex();
o=n.dayIndex==l.dayIndex;
}if(!(k&&o)){q.rowSelectionEndSlot=m;
s.apply(this._owner);
}},_getFirstTimeSlot:function(){var j=this._getContentTable().rows[0].cells[0];
return this.getTimeSlotFromDomElement(j);
},get_supportsFullTime:function(){return false;
}};
e.ModelBase.registerClass("Telerik.Web.UI.Scheduler.Views.Month.ModelBase");
e.Model=function(j){if(d.Rendering.HorizontalBlockCollection){this._allDayBlocks=new d.Rendering.HorizontalBlockCollection();
}e.Model.initializeBase(this,[j]);
};
e.Model.prototype={initialize:function(){},addToBlocks:function(j){this._allDayBlocks.add(j);
},removeFromBlock:function(j){this._allDayBlocks.remove(j);
},resetBlocks:function(){if(d.Rendering.HorizontalBlockCollection){this._allDayBlocks=new d.Rendering.HorizontalBlockCollection();
}},getTimeSlotFromDomElement:function(j){var k=this._getRawIndexFromDomElement(j),l=this._getTimeFromDomElement(j);
return new e.TimeSlot(k,l,j);
},_addTodayCellClass:function(){var j=d.DateTime.getDate(new Date()),k;
if(j<this.get_visibleRangeStart()||j>=this.get_visibleRangeEnd()){return;
}k=this._getAllDayTimeSlotFromStartTime(j);
if(k){a(k.get_domElement()).addClass("rsTodayCell");
}},_getTimeFromDomElement:function(j){var k=this._getRawIndexFromDomElement(j);
return this._getTimeFromIndex(k);
},_getTimeFromIndex:function(k){var j=this.get_visibleRangeStart(),n=this.get_weekLength(),o=Math.floor(k.dayIndex/n),m=k.dayIndex%n,l=(o*7)+m;
c.RadScheduler._incrementTime(j,24*l,0);
return j;
},_getRawIndexFromDomElement:function(l){while(l&&(l.tagName.toUpperCase()!="TD")){l=l.parentNode;
}if(l){var m=l.parentNode,k=m.cells.length,j=l.cellIndex,n=m.rowIndex;
return{dayIndex:(k*n)+j};
}return null;
},getTimeSlotForAppointment:function(j){return this._getAllDayTimeSlotFromStartTime(j.get_start());
},_getAllDayTimeSlotForAppointmentPart:function(j){return this._getAllDayTimeSlotFromStartTime(j.start);
},_getAllDayTimeSlotFromStartTime:function(l){var k=this._getTimeSlotIndices(l),j=this._getTimeSlotDomElement(k);
return this.getTimeSlotFromDomElement(j);
},_getTimeSlotDomElement:function(k){var l=Math.floor(k.dayIndex/this.get_weekLength()),j=Math.floor(k.dayIndex%this.get_weekLength());
return this._getContentTable().tBodies[0].rows[l].cells[j];
},_getRenderer:function(){if(!this._renderer){this._renderer=new c.Scheduler.Rendering.MonthViewRenderer(this);
}return this._renderer;
}};
e.Model.registerClass("Telerik.Web.UI.Scheduler.Views.Month.Model",e.ModelBase);
e.TimeSlot=function(k,l,j){this._rawIndex=k;
this._startTime=l;
this._domElement=j;
};
e.TimeSlot.prototype={set_selected:function(k){var j=this.get_domElement();
if(j){a(j).toggleClass("rsSelectedSlot",k);
}this._selected=k;
},get_index:function(){var j=this.get_rawIndex();
return String.format("{0}",j.dayIndex);
},get_rawIndex:function(){return this._rawIndex;
},get_startTime:function(){return this._startTime;
},get_endTime:function(){return d.DateTime.add(this.get_startTime(),this.get_duration());
},get_duration:function(){return this.get_durationInMinutes()*h;
},get_durationInMinutes:function(){return 1440;
},get_isAllDay:function(){return true;
},get_domElement:function(){if(a(this._domElement).is("td")){return this._domElement;
}return a(this._domElement).parents("td:first")[0];
}};
e.TimeSlot.registerClass("Telerik.Web.UI.Scheduler.Views.Month.TimeSlot",null,c.ISchedulerTimeSlot);
})($telerik.$,Telerik.Web.UI,Telerik.Web.UI.Scheduler,Telerik.Web.UI.Scheduler.Views.Month);
if(typeof(Sys)!=='undefined')Sys.Application.notifyScriptLoaded();