(function(b,a){a("kendo.data",["kendo.core","kendo.data.odata","kendo.data.xml"],b);
}(function(){var a={id:"data",name:"Data source",category:"framework",description:"Powerful component for using local and remote data.Fully supports CRUD, Sorting, Paging, Filtering, Grouping, and Aggregates.",depends:["core"],features:[{id:"data-odata",name:"OData",description:"Support for accessing Open Data Protocol (OData) services.",depends:["data.odata"]},{id:"data-signalr",name:"SignalR",description:"Support for binding to SignalR hubs.",depends:["data.signalr"]},{id:"data-XML",name:"XML",description:"Support for binding to XML.",depends:["data.xml"]}]};
(function(b,aY){var D=b.extend,aB=b.proxy,ab=b.isPlainObject,Y=b.isEmptyObject,W=b.isArray,M=b.grep,c=b.ajax,ag,y=b.each,al=b.noop,ad=window.kendo,Z=ad.isFunction,at=ad.Observable,i=ad.Class,aS="string",H="function",q="create",aE="read",a0="update",x="destroy",h="change",aU="sync",J="get",B="error",aL="requestStart",aA="progress",aK="requestEnd",r=[q,aE,a0,x],P=function(a3){return a3;
},L=ad.getter,aT=ad.stringify,ah=Math,aC=[].push,ac=[].join,az=[].pop,aP=[].splice,aN=[].shift,aO=[].slice,aZ=[].unshift,aW={}.toString,aR=ad.support.stableSort,v=/^\/Date\((.*?)\)\/$/;
var au=at.extend({init:function(a3,a5){var a4=this;
a4.type=a5||av;
at.fn.init.call(a4);
a4.length=a3.length;
a4.wrapAll(a3,a4);
},at:function(a3){return this[a3];
},toJSON:function(){var a3,a5=this.length,a6,a4=new Array(a5);
for(a3=0;
a3<a5;
a3++){a6=this[a3];
if(a6 instanceof av){a6=a6.toJSON();
}a4[a3]=a6;
}return a4;
},parent:al,wrapAll:function(a6,a7){var a8=this,a3,a4,a5=function(){return a8;
};
a7=a7||[];
for(a3=0,a4=a6.length;
a3<a4;
a3++){a7[a3]=a8.wrap(a6[a3],a5);
}return a7;
},wrap:function(a3,a5){var a6=this,a4;
if(a3!==null&&aW.call(a3)==="[object Object]"){a4=a3 instanceof a6.type||a3 instanceof aj;
if(!a4){a3=a3 instanceof av?a3.toJSON():a3;
a3=new a6.type(a3);
}a3.parent=a5;
a3.bind(h,function(a7){a6.trigger(h,{field:a7.field,node:a7.node,index:a7.index,items:a7.items||[this],action:a7.node?a7.action||"itemloaded":"itemchange"});
});
}return a3;
},push:function(){var a3=this.length,a4=this.wrapAll(arguments),a5;
a5=aC.apply(this,a4);
this.trigger(h,{action:"add",index:a3,items:a4});
return a5;
},slice:aO,sort:[].sort,join:ac,pop:function(){var a3=this.length,a4=az.apply(this);
if(a3){this.trigger(h,{action:"remove",index:a3-1,items:[a4]});
}return a4;
},splice:function(a5,a3,a6){var a7=this.wrapAll(aO.call(arguments,2)),a9,a4,a8;
a9=aP.apply(this,[a5,a3].concat(a7));
if(a9.length){this.trigger(h,{action:"remove",index:a5,items:a9});
for(a4=0,a8=a9.length;
a4<a8;
a4++){if(a9[a4]&&a9[a4].children){a9[a4].unbind(h);
}}}if(a6){this.trigger(h,{action:"add",index:a5,items:a7});
}return a9;
},shift:function(){var a3=this.length,a4=aN.apply(this);
if(a3){this.trigger(h,{action:"remove",index:0,items:[a4]});
}return a4;
},unshift:function(){var a3=this.wrapAll(arguments),a4;
a4=aZ.apply(this,a3);
this.trigger(h,{action:"add",index:0,items:a3});
return a4;
},indexOf:function(a4){var a6=this,a3,a5;
for(a3=0,a5=a6.length;
a3<a5;
a3++){if(a6[a3]===a4){return a3;
}}return -1;
},forEach:function(a3){var a4=0,a5=this.length;
for(;
a4<a5;
a4++){a3(this[a4],a4,this);
}},map:function(a3){var a4=0,a6=[],a5=this.length;
for(;
a4<a5;
a4++){a6[a4]=a3(this[a4],a4,this);
}return a6;
},reduce:function(a3){var a4=0,a6,a5=this.length;
if(arguments.length==2){a6=arguments[1];
}else{if(a4<a5){a6=this[a4++];
}}for(;
a4<a5;
a4++){a6=a3(a6,this[a4],a4,this);
}return a6;
},reduceRight:function(a3){var a4=this.length-1,a5;
if(arguments.length==2){a5=arguments[1];
}else{if(a4>0){a5=this[a4--];
}}for(;
a4>=0;
a4--){a5=a3(a5,this[a4],a4,this);
}return a5;
},filter:function(a3){var a4=0,a7=[],a5,a6=this.length;
for(;
a4<a6;
a4++){a5=this[a4];
if(a3(a5,a4,this)){a7[a7.length]=a5;
}}return a7;
},find:function(a3){var a4=0,a5,a6=this.length;
for(;
a4<a6;
a4++){a5=this[a4];
if(a3(a5,a4,this)){return a5;
}}},every:function(a3){var a4=0,a5,a6=this.length;
for(;
a4<a6;
a4++){a5=this[a4];
if(!a3(a5,a4,this)){return false;
}}return true;
},some:function(a3){var a4=0,a5,a6=this.length;
for(;
a4<a6;
a4++){a5=this[a4];
if(a3(a5,a4,this)){return true;
}}return false;
},remove:function(a4){var a3=this.indexOf(a4);
if(a3!==-1){this.splice(a3,1);
}},empty:function(){this.splice(0,this.length);
}});
if(typeof Symbol!=="undefined"&&Symbol.iterator&&!au.prototype[Symbol.iterator]){au.prototype[Symbol.iterator]=[][Symbol.iterator];
}var ae=au.extend({init:function(a3,a5){at.fn.init.call(this);
this.type=a5||av;
for(var a4=0;
a4<a3.length;
a4++){this[a4]=a3[a4];
}this.length=a4;
this._parent=aB(function(){return this;
},this);
},at:function(a3){var a4=this[a3];
if(!(a4 instanceof this.type)){a4=this[a3]=this.wrap(a4,this._parent);
}else{a4.parent=this._parent;
}return a4;
}});
function C(a3,a6,a4,a5){return function(a7){var a8={},a9;
for(a9 in a7){a8[a9]=a7[a9];
}if(a5){a8.field=a4+"."+a7.field;
}else{a8.field=a4;
}if(a6==h&&a3._notifyChange){a3._notifyChange(a8);
}a3.trigger(a6,a8);
};
}var av=at.extend({init:function(a7){var a6=this,a4,a3,a5=function(){return a6;
};
at.fn.init.call(this);
this._handlers={};
for(a3 in a7){a4=a7[a3];
if(typeof a4==="object"&&a4&&!a4.getTime&&a3.charAt(0)!="_"){a4=a6.wrap(a4,a3,a5);
}a6[a3]=a4;
}a6.uid=ad.guid();
},shouldSerialize:function(a3){return this.hasOwnProperty(a3)&&a3!=="_handlers"&&a3!=="_events"&&typeof this[a3]!==H&&a3!=="uid";
},forEach:function(a3){for(var a4 in this){if(this.shouldSerialize(a4)){a3(this[a4],a4);
}}},toJSON:function(){var a4={},a5,a3;
for(a3 in this){if(this.shouldSerialize(a3)){a5=this[a3];
if(a5 instanceof av||a5 instanceof au){a5=a5.toJSON();
}a4[a3]=a5;
}}return a4;
},get:function(a3){var a5=this,a4;
a5.trigger(J,{field:a3});
if(a3==="this"){a4=a5;
}else{a4=ad.getter(a3,true)(a5);
}return a4;
},_set:function(a4,a9){var a8=this;
var a3=a4.indexOf(".")>=0;
if(a3){var a7=a4.split("."),a6="";
while(a7.length>1){a6+=a7.shift();
var a5=ad.getter(a6,true)(a8);
if(a5 instanceof av){a5.set(a7.join("."),a9);
return a3;
}a6+=".";
}}ad.setter(a4)(a8,a9);
return a3;
},set:function(a5,a8){var a7=this,a6=false,a3=a5.indexOf(".")>=0,a4=ad.getter(a5,true)(a7);
if(a4!==a8){if(a4 instanceof at&&this._handlers[a5]){if(this._handlers[a5].get){a4.unbind(J,this._handlers[a5].get);
}a4.unbind(h,this._handlers[a5].change);
}a6=a7.trigger("set",{field:a5,value:a8});
if(!a6){if(!a3){a8=a7.wrap(a8,a5,function(){return a7;
});
}if(!a7._set(a5,a8)||a5.indexOf("(")>=0||a5.indexOf("[")>=0){a7.trigger(h,{field:a5});
}}}return a6;
},parent:al,wrap:function(a8,a4,a9){var ba=this;
var a5;
var a3;
var bb=aW.call(a8);
if(a8!=null&&(bb==="[object Object]"||bb==="[object Array]")){var a7=a8 instanceof au;
var a6=a8 instanceof u;
if(bb==="[object Object]"&&!a6&&!a7){if(!(a8 instanceof av)){a8=new av(a8);
}a5=C(ba,J,a4,true);
a8.bind(J,a5);
a3=C(ba,h,a4,true);
a8.bind(h,a3);
ba._handlers[a4]={get:a5,change:a3};
}else{if(bb==="[object Array]"||a7||a6){if(!a7&&!a6){a8=new au(a8);
}a3=C(ba,h,a4,false);
a8.bind(h,a3);
ba._handlers[a4]={change:a3};
}}a8.parent=a9;
}return a8;
}});
function A(a4,a6){if(a4===a6){return true;
}var a5=b.type(a4),a7=b.type(a6),a3;
if(a5!==a7){return false;
}if(a5==="date"){return a4.getTime()===a6.getTime();
}if(a5!=="object"&&a5!=="array"){return false;
}for(a3 in a4){if(!A(a4[a3],a6[a3])){return false;
}}return true;
}var ay={number:function(a3){return ad.parseFloat(a3);
},date:function(a3){return ad.parseDate(a3);
},"boolean":function(a3){if(typeof a3===aS){return a3.toLowerCase()==="true";
}return a3!=null?!!a3:a3;
},string:function(a3){return a3!=null?a3+"":a3;
},"default":function(a3){return a3;
}};
var w={string:"",number:0,date:new Date(),"boolean":false,"default":""};
function K(a6,a5){var a3,a4;
for(a4 in a6){a3=a6[a4];
if(ab(a3)&&a3.field&&a3.field===a5){return a3;
}else{if(a3===a5){return a3;
}}}return null;
}var aj=av.extend({init:function(a3){var a6=this;
if(!a3||b.isEmptyObject(a3)){a3=b.extend({},a6.defaults,a3);
if(a6._initializers){for(var a4=0;
a4<a6._initializers.length;
a4++){var a5=a6._initializers[a4];
a3[a5]=a6.defaults[a5]();
}}}av.fn.init.call(a6,a3);
a6.dirty=false;
if(a6.idField){a6.id=a6.get(a6.idField);
if(a6.id===aY){a6.id=a6._defaultId;
}}},shouldSerialize:function(a3){return av.fn.shouldSerialize.call(this,a3)&&a3!=="uid"&&!(this.idField!=="id"&&a3==="id")&&a3!=="dirty"&&a3!=="_accessors";
},_parse:function(a3,a8){var a7=this,a4=a3,a5=a7.fields||{},a6;
a3=a5[a3];
if(!a3){a3=K(a5,a4);
}if(a3){a6=a3.parse;
if(!a6&&a3.type){a6=ay[a3.type.toLowerCase()];
}}return a6?a6(a8):a8;
},_notifyChange:function(a4){var a3=a4.action;
if(a3=="add"||a3=="remove"){this.dirty=true;
}},editable:function(a3){a3=(this.fields||{})[a3];
return a3?a3.editable!==false:true;
},set:function(a4,a7,a5){var a6=this;
var a3=a6.dirty;
if(a6.editable(a4)){a7=a6._parse(a4,a7);
if(!A(a7,a6.get(a4))){a6.dirty=true;
if(av.fn.set.call(a6,a4,a7,a5)&&!a3){a6.dirty=a3;
}}}},accept:function(a3){var a6=this,a5=function(){return a6;
},a4;
for(a4 in a3){var a7=a3[a4];
if(a4.charAt(0)!="_"){a7=a6.wrap(a3[a4],a4,a5);
}a6._set(a4,a7);
}if(a6.idField){a6.id=a6.get(a6.idField);
}a6.dirty=false;
},isNew:function(){return this.id===this._defaultId;
}});
aj.define=function(a3,bc){if(bc===aY){bc=a3;
a3=aj;
}var ba,be=D({defaults:{}},bc),bb,a4,bf,bg,a8,a9,a5={},bd,a7=be.id,a6=[];
if(a7){be.idField=a7;
}if(be.id){delete be.id;
}if(a7){be.defaults[a7]=be._defaultId="";
}if(aW.call(be.fields)==="[object Array]"){for(a8=0,a9=be.fields.length;
a8<a9;
a8++){a4=be.fields[a8];
if(typeof a4===aS){a5[a4]={};
}else{if(a4.field){a5[a4.field]=a4;
}}}be.fields=a5;
}for(bb in be.fields){a4=be.fields[bb];
bf=a4.type||"default";
bg=null;
bd=bb;
bb=typeof a4.field===aS?a4.field:bb;
if(!a4.nullable){bg=be.defaults[bd!==bb?bd:bb]=a4.defaultValue!==aY?a4.defaultValue:w[bf.toLowerCase()];
if(typeof bg==="function"){a6.push(bb);
}}if(bc.id===bb){be._defaultId=bg;
}be.defaults[bd!==bb?bd:bb]=bg;
a4.parse=a4.parse||ay[bf];
}if(a6.length>0){be._initializers=a6;
}ba=a3.extend(be);
ba.define=function(bh){return aj.define(ba,bh);
};
if(be.fields){ba.fields=be.fields;
ba.idField=be.idField;
}return ba;
};
var l={selector:function(a3){return Z(a3)?a3:L(a3);
},compare:function(a3){var a4=this.selector(a3);
return function(a5,a6){a5=a4(a5);
a6=a4(a6);
if(a5==null&&a6==null){return 0;
}if(a5==null){return -1;
}if(a6==null){return 1;
}if(a5.localeCompare){return a5.localeCompare(a6);
}return a5>a6?1:a5<a6?-1:0;
};
},create:function(a4){var a3=a4.compare||this.compare(a4.field);
if(a4.dir=="desc"){return function(a5,a6){return a3(a6,a5,true);
};
}return a3;
},combine:function(a3){return function(a4,a5){var a8=a3[0](a4,a5),a6,a7;
for(a6=1,a7=a3.length;
a6<a7;
a6++){a8=a8||a3[a6](a4,a5);
}return a8;
};
}};
var aQ=D({},l,{asc:function(a3){var a4=this.selector(a3);
return function(a5,a6){var a7=a4(a5);
var a8=a4(a6);
if(a7&&a7.getTime&&a8&&a8.getTime){a7=a7.getTime();
a8=a8.getTime();
}if(a7===a8){return a5.__position-a6.__position;
}if(a7==null){return -1;
}if(a8==null){return 1;
}if(a7.localeCompare){return a7.localeCompare(a8);
}return a7>a8?1:-1;
};
},desc:function(a3){var a4=this.selector(a3);
return function(a5,a6){var a7=a4(a5);
var a8=a4(a6);
if(a7&&a7.getTime&&a8&&a8.getTime){a7=a7.getTime();
a8=a8.getTime();
}if(a7===a8){return a5.__position-a6.__position;
}if(a7==null){return 1;
}if(a8==null){return -1;
}if(a8.localeCompare){return a8.localeCompare(a7);
}return a7<a8?1:-1;
};
},create:function(a3){return this[a3.dir](a3.field);
}});
ag=function(a3,a4){var a5,a6=a3.length,a7=new Array(a6);
for(a5=0;
a5<a6;
a5++){a7[a5]=a4(a3[a5],a5,a3);
}return a7;
};
var ax=function(){function a5(a7){if(typeof a7=="string"){a7=a7.replace(/[\r\n]+/g,"");
}return JSON.stringify(a7);
}function a6(a7){return function(a8,a9,ba){a9+="";
if(ba){a8="("+a8+" || '').toLowerCase()";
a9=a9.toLowerCase();
}return a7(a8,a5(a9),ba);
};
}function a4(bb,a7,a8,ba){if(a8!=null){if(typeof a8===aS){var a9=v.exec(a8);
if(a9){a8=new Date(+a9[1]);
}else{if(ba){a8=a5(a8.toLowerCase());
a7="(("+a7+" || '')+'').toLowerCase()";
}else{a8=a5(a8);
}}}if(a8.getTime){a7="("+a7+"&&"+a7+".getTime?"+a7+".getTime():"+a7+")";
a8=a8.getTime();
}}return a7+" "+bb+" "+a8;
}function a3(ba){for(var bb="/^",a8=false,a9=0;
a9<ba.length;
++a9){var a7=ba.charAt(a9);
if(a8){bb+="\\"+a7;
}else{if(a7=="~"){a8=true;
continue;
}else{if(a7=="*"){bb+=".*";
}else{if(a7=="?"){bb+=".";
}else{if(".+^$()[]{}|\\/\n\r\u2028\u2029\xA0".indexOf(a7)>=0){bb+="\\"+a7;
}else{bb+=a7;
}}}}}a8=false;
}return bb+"$/";
}return{quote:function(a7){if(a7&&a7.getTime){return"new Date("+a7.getTime()+")";
}return a5(a7);
},eq:function(a7,a8,a9){return a4("==",a7,a8,a9);
},neq:function(a7,a8,a9){return a4("!=",a7,a8,a9);
},gt:function(a7,a8,a9){return a4(">",a7,a8,a9);
},gte:function(a7,a8,a9){return a4(">=",a7,a8,a9);
},lt:function(a7,a8,a9){return a4("<",a7,a8,a9);
},lte:function(a7,a8,a9){return a4("<=",a7,a8,a9);
},startswith:a6(function(a7,a8){return a7+".lastIndexOf("+a8+", 0) == 0";
}),doesnotstartwith:a6(function(a7,a8){return a7+".lastIndexOf("+a8+", 0) == -1";
}),endswith:a6(function(a7,a8){var a9=a8?a8.length-2:0;
return a7+".indexOf("+a8+", "+a7+".length - "+a9+") >= 0";
}),doesnotendwith:a6(function(a7,a8){var a9=a8?a8.length-2:0;
return a7+".indexOf("+a8+", "+a7+".length - "+a9+") < 0";
}),contains:a6(function(a7,a8){return a7+".indexOf("+a8+") >= 0";
}),doesnotcontain:a6(function(a7,a8){return a7+".indexOf("+a8+") == -1";
}),matches:a6(function(a7,a8){a8=a8.substring(1,a8.length-1);
return a3(a8)+".test("+a7+")";
}),doesnotmatch:a6(function(a7,a8){a8=a8.substring(1,a8.length-1);
return"!"+a3(a8)+".test("+a7+")";
}),isempty:function(a7){return a7+" === ''";
},isnotempty:function(a7){return a7+" !== ''";
},isnull:function(a7){return"("+a7+" == null)";
},isnotnull:function(a7){return"("+a7+" != null)";
}};
}();
function aD(a3){this.data=a3||[];
}aD.filterExpr=function(a4){var a5=[],bc={and:" && ",or:" || "},ba,bb,a8,a3,a7=[],be=[],a6,bd,a9=a4.filters;
for(ba=0,bb=a9.length;
ba<bb;
ba++){a8=a9[ba];
a6=a8.field;
bd=a8.operator;
if(a8.filters){a3=aD.filterExpr(a8);
a8=a3.expression.replace(/__o\[(\d+)\]/g,function(bg,bf){bf=+bf;
return"__o["+(be.length+bf)+"]";
}).replace(/__f\[(\d+)\]/g,function(bg,bf){bf=+bf;
return"__f["+(a7.length+bf)+"]";
});
be.push.apply(be,a3.operators);
a7.push.apply(a7,a3.fields);
}else{if(typeof a6===H){a3="__f["+a7.length+"](d)";
a7.push(a6);
}else{a3=ad.expr(a6);
}if(typeof bd===H){a8="__o["+be.length+"]("+a3+", "+ax.quote(a8.value)+")";
be.push(bd);
}else{a8=ax[(bd||"eq").toLowerCase()](a3,a8.value,a8.ignoreCase!==aY?a8.ignoreCase:true);
}}a5.push(a8);
}return{expression:"("+a5.join(bc[a4.logic])+")",fields:a7,operators:be};
};
function ar(a6,a5){if(a6){var a3=typeof a6===aS?{field:a6,dir:a5}:a6,a4=W(a3)?a3:a3!==aY?[a3]:[];
return M(a4,function(a7){return !!a7.dir;
});
}}var aw={"==":"eq",equals:"eq",isequalto:"eq",equalto:"eq",equal:"eq","!=":"neq",ne:"neq",notequals:"neq",isnotequalto:"neq",notequalto:"neq",notequal:"neq","<":"lt",islessthan:"lt",lessthan:"lt",less:"lt","<=":"lte",le:"lte",islessthanorequalto:"lte",lessthanequal:"lte",">":"gt",isgreaterthan:"gt",greaterthan:"gt",greater:"gt",">=":"gte",isgreaterthanorequalto:"gte",greaterthanequal:"gte",ge:"gte",notsubstringof:"doesnotcontain",isnull:"isnull",isempty:"isempty",isnotempty:"isnotempty"};
function aq(a3){var a6,a7,a4,a8,a5=a3.filters;
if(a5){for(a6=0,a7=a5.length;
a6<a7;
a6++){a4=a5[a6];
a8=a4.operator;
if(a8&&typeof a8===aS){a4.operator=aw[a8.toLowerCase()]||a8;
}aq(a4);
}}}function ao(a3){if(a3&&!Y(a3)){if(W(a3)||!a3.filters){a3={logic:"and",filters:W(a3)?a3:[a3]};
}aq(a3);
return a3;
}}aD.normalizeFilter=ao;
function j(a3,a4){if(a3.logic||a4.logic){return false;
}return a3.field===a4.field&&a3.value===a4.value&&a3.operator===a4.operator;
}function an(a3){a3=a3||{};
if(Y(a3)){return{logic:"and",filters:[]};
}return ao(a3);
}function E(a3,a4){if(a4.logic||a3.field>a4.field){return 1;
}else{if(a3.field<a4.field){return -1;
}else{return 0;
}}}function k(a3,a4){a3=an(a3);
a4=an(a4);
if(a3.logic!==a4.logic){return false;
}var a5,a6;
var a7=(a3.filters||[]).slice();
var a8=(a4.filters||[]).slice();
if(a7.length!==a8.length){return false;
}a7=a7.sort(E);
a8=a8.sort(E);
for(var a9=0;
a9<a7.length;
a9++){a5=a7[a9];
a6=a8[a9];
if(a5.logic&&a6.logic){if(!k(a5,a6)){return false;
}}else{if(!j(a5,a6)){return false;
}}}return true;
}aD.compareFilters=k;
function am(a3){return W(a3)?a3:[a3];
}function ap(a6,a5){var a3=typeof a6===aS?{field:a6,dir:a5}:a6,a4=W(a3)?a3:a3!==aY?[a3]:[];
return ag(a4,function(a7){return{field:a7.field,dir:a7.dir||"asc",aggregates:a7.aggregates};
});
}aD.prototype={toArray:function(){return this.data;
},range:function(a4,a3){return new aD(this.data.slice(a4,a4+a3));
},skip:function(a3){return new aD(this.data.slice(a3));
},take:function(a3){return new aD(this.data.slice(0,a3));
},select:function(a3){return new aD(ag(this.data,a3));
},order:function(a4,a3){var a5={dir:a3};
if(a4){if(a4.compare){a5.compare=a4.compare;
}else{a5.field=a4;
}}return new aD(this.data.slice(0).sort(l.create(a5)));
},orderBy:function(a3){return this.order(a3,"asc");
},orderByDescending:function(a3){return this.order(a3,"desc");
},sort:function(a7,a6,a3){var a8,a9,a5=ar(a7,a6),a4=[];
a3=a3||l;
if(a5.length){for(a8=0,a9=a5.length;
a8<a9;
a8++){a4.push(a3.create(a5[a8]));
}return this.orderBy({compare:a3.combine(a4)});
}return this;
},filter:function(a6){var a9,a4,ba,a3,bc,a5=this.data,a7,bb,bd=[],a8;
a6=ao(a6);
if(!a6||a6.filters.length===0){return this;
}a3=aD.filterExpr(a6);
a7=a3.fields;
bb=a3.operators;
bc=a8=new Function("d, __f, __o","return "+a3.expression);
if(a7.length||bb.length){a8=function(be){return bc(be,a7,bb);
};
}for(a9=0,ba=a5.length;
a9<ba;
a9++){a4=a5[a9];
if(a8(a4)){bd.push(a4);
}}return new aD(bd);
},group:function(a5,a3){a5=ap(a5||[]);
a3=a3||this.data;
var a7=this,a6=new aD(a7.data),a4;
if(a5.length>0){a4=a5[0];
a6=a6.groupBy(a4).select(function(a9){var a8=new aD(a3).filter([{field:a9.field,operator:"eq",value:a9.value,ignoreCase:false}]);
return{field:a9.field,value:a9.value,items:a5.length>1?new aD(a9.items).group(a5.slice(1),a8.toArray()).toArray():a9.items,hasSubgroups:a5.length>1,aggregates:a8.aggregate(a4.aggregates)};
});
}return a6;
},groupBy:function(a5){if(Y(a5)||!this.data.length){return new aD([]);
}var a6=a5.field,bd=this._sortForGrouping(a6,a5.dir||"asc"),a3=ad.accessor(a6),ba,a8=a3.get(bd[0],a6),a7={field:a6,value:a8,items:[]},a4,a9,bb,bc=[a7];
for(a9=0,bb=bd.length;
a9<bb;
a9++){ba=bd[a9];
a4=a3.get(ba,a6);
if(!N(a8,a4)){a8=a4;
a7={field:a6,value:a8,items:[]};
bc.push(a7);
}a7.items.push(ba);
}return new aD(bc);
},_sortForGrouping:function(a5,a4){var a6,a7,a3=this.data;
if(!aR){for(a6=0,a7=a3.length;
a6<a7;
a6++){a3[a6].__position=a6;
}a3=new aD(a3).sort(a5,a4,aQ).toArray();
for(a6=0,a7=a3.length;
a6<a7;
a6++){delete a3[a6].__position;
}return a3;
}return this.sort(a5,a4).toArray();
},aggregate:function(a3){var a4,a5,a6={},a7={};
if(a3&&a3.length){for(a4=0,a5=this.data.length;
a4<a5;
a4++){g(a6,a3,this.data[a4],a4,a5,a7);
}}return a6;
}};
function N(a3,a4){if(a3&&a3.getTime&&a4&&a4.getTime){return a3.getTime()===a4.getTime();
}return a3===a4;
}function g(a3,a5,ba,a9,bc,bd){a5=a5||[];
var a8,a4,a7,bb=a5.length;
for(a8=0;
a8<bb;
a8++){a4=a5[a8];
a7=a4.aggregate;
var a6=a4.field;
a3[a6]=a3[a6]||{};
bd[a6]=bd[a6]||{};
bd[a6][a7]=bd[a6][a7]||{};
a3[a6][a7]=I[a7.toLowerCase()](a3[a6][a7],ba,ad.accessor(a6),a9,bc,bd[a6][a7]);
}}var I={sum:function(a4,a5,a3){var a6=a3.get(a5);
if(!aa(a4)){a4=a6;
}else{if(aa(a6)){a4+=a6;
}}return a4;
},count:function(a3){return(a3||0)+1;
},average:function(a4,a6,a3,a5,a7,a8){var a9=a3.get(a6);
if(a8.count===aY){a8.count=0;
}if(!aa(a4)){a4=a9;
}else{if(aa(a9)){a4+=a9;
}}if(aa(a9)){a8.count++;
}if(a5==a7-1&&aa(a4)){a4=a4/a8.count;
}return a4;
},max:function(a4,a5,a3){var a6=a3.get(a5);
if(!aa(a4)&&!X(a4)){a4=a6;
}if(a4<a6&&(aa(a6)||X(a6))){a4=a6;
}return a4;
},min:function(a4,a5,a3){var a6=a3.get(a5);
if(!aa(a4)&&!X(a4)){a4=a6;
}if(a4>a6&&(aa(a6)||X(a6))){a4=a6;
}return a4;
}};
function aa(a3){return typeof a3==="number"&&!isNaN(a3);
}function X(a3){return a3&&a3.getTime;
}function aV(a3){var a4,a5=a3.length,a6=new Array(a5);
for(a4=0;
a4<a5;
a4++){a6[a4]=a3[a4].toJSON();
}return a6;
}aD.process=function(a3,a7){a7=a7||{};
var a8=new aD(a3),a6=a7.group,ba=ap(a6||[]).concat(ar(a7.sort||[])),bc,a5=a7.filterCallback,a4=a7.filter,a9=a7.skip,bb=a7.take;
if(a4){a8=a8.filter(a4);
if(a5){a8=a5(a8);
}bc=a8.toArray().length;
}if(ba){a8=a8.sort(ba);
if(a6){a3=a8.toArray();
}}if(a9!==aY&&bb!==aY){a8=a8.range(a9,bb);
}if(a6){a8=a8.group(a6,a3);
}return{total:bc,data:a8.toArray()};
};
var af=i.extend({init:function(a3){this.data=a3.data;
},read:function(a3){a3.success(this.data);
},update:function(a3){a3.success(a3.data);
},create:function(a3){a3.success(a3.data);
},destroy:function(a3){a3.success(a3.data);
}});
var aF=i.extend({init:function(a3){var a5=this,a4;
a3=a5.options=D({},a5.options,a3);
y(r,function(a6,a7){if(typeof a3[a7]===aS){a3[a7]={url:a3[a7]};
}});
a5.cache=a3.cache?f.create(a3.cache):{find:al,add:al};
a4=a3.parameterMap;
if(Z(a3.push)){a5.push=a3.push;
}if(!a5.push){a5.push=P;
}a5.parameterMap=Z(a4)?a4:function(a6){var a7={};
y(a6,function(a8,a9){if(a8 in a4){a8=a4[a8];
if(ab(a8)){a9=a8.value(a9);
a8=a8.key;
}}a7[a8]=a9;
});
return a7;
};
},options:{parameterMap:P},create:function(a3){return c(this.setup(a3,q));
},read:function(a5){var a8=this,a7,a4,a6,a3=a8.cache;
a5=a8.setup(a5,aE);
a7=a5.success||al;
a4=a5.error||al;
a6=a3.find(a5.data);
if(a6!==aY){a7(a6);
}else{a5.success=function(a9){a3.add(a5.data,a9);
a7(a9);
};
b.ajax(a5);
}},update:function(a3){return c(this.setup(a3,a0));
},destroy:function(a3){return c(this.setup(a3,x));
},setup:function(a5,a8){a5=a5||{};
var a7=this,a6,a4=a7.options[a8],a3=Z(a4.data)?a4.data(a5.data):a4.data;
a5=D(true,{},a4,a5);
a6=D(true,{},a3,a5.data);
a5.data=a7.parameterMap(a6,a8);
if(Z(a5.url)){a5.url=a5.url(a6);
}return a5;
}});
var f=i.extend({init:function(){this._store={};
},add:function(a4,a3){if(a4!==aY){this._store[aT(a4)]=a3;
}},find:function(a3){return this._store[aT(a3)];
},clear:function(){this._store={};
},remove:function(a3){delete this._store[aT(a3)];
}});
f.create=function(a3){var a4={inmemory:function(){return new f();
}};
if(ab(a3)&&Z(a3.find)){return a3;
}if(a3===true){return new f();
}return a4[a3]();
};
function aM(a3,a6,a9,ba,a4){var bc,a5,bb,a7,bd={},a8;
for(a7=0,a8=a3.length;
a7<a8;
a7++){bc=a3[a7];
for(a5 in a6){bb=a4[a5];
if(bb&&bb!==a5){if(!bd[bb]){bd[bb]=ad.setter(bb);
}bd[bb](bc,a6[a5](bc));
delete bc[a5];
}}}}function p(a3,a6,a9,ba,a4){var bc,a5,bb,a7,a8;
for(a7=0,a8=a3.length;
a7<a8;
a7++){bc=a3[a7];
for(a5 in a6){bc[a5]=a9._parse(a5,a6[a5](bc));
bb=a4[a5];
if(bb&&bb!==a5){delete bc[bb];
}}}}function o(a3,a6,a9,ba,a5){var bb,a7,a4,a8;
for(a7=0,a8=a3.length;
a7<a8;
a7++){bb=a3[a7];
a4=ba[bb.field];
if(a4&&a4!=bb.field){bb.field=a4;
}bb.value=a9._parse(bb.field,bb.value);
if(bb.hasSubgroups){o(bb.items,a6,a9,ba,a5);
}else{p(bb.items,a6,a9,ba,a5);
}}}function a1(a8,a6,a3,a5,a7,a4){return function(a9){a9=a8(a9);
if(a9&&!Y(a5)){if(aW.call(a9)!=="[object Array]"&&!(a9 instanceof au)){a9=[a9];
}a3(a9,a5,new a6(),a7,a4);
}return a9||[];
};
}var t=i.extend({init:function(bd){var bh=this,ba,a7,bb,a3;
bd=bd||{};
for(ba in bd){a7=bd[ba];
bh[ba]=typeof a7===aS?L(a7):a7;
}a3=bd.modelBase||aj;
if(ab(bh.model)){bh.model=bb=a3.define(bh.model);
}var a4=aB(bh.data,bh);
bh._dataAccessFunction=a4;
if(bh.model){var a9=aB(bh.groups,bh),be=aB(bh.serialize,bh),bc={},a8={},bf={},a6={},bg=false,a5;
bb=bh.model;
if(bb.fields){y(bb.fields,function(bi,bk){var bj;
a5=bi;
if(ab(bk)&&bk.field){a5=bk.field;
}else{if(typeof bk===aS){a5=bk;
}}if(ab(bk)&&bk.from){bj=bk.from;
}bg=bg||bj&&bj!==bi||a5!==bi;
a8[bi]=L(bj||a5);
bf[bi]=L(bi);
bc[bj||a5]=bi;
a6[bi]=bj||a5;
});
if(!bd.serialize&&bg){bh.serialize=a1(be,bb,aM,bf,bc,a6);
}}bh._dataAccessFunction=a4;
bh.data=a1(a4,bb,p,a8,bc,a6);
bh.groups=a1(a9,bb,o,a8,bc,a6);
}},errors:function(a3){return a3?a3.errors:null;
},parse:P,data:P,total:function(a3){return a3.length;
},groups:P,aggregates:function(){return{};
},serialize:function(a3){return a3;
}});
function ai(ba,a3,a8,a9){var a4,a5=0,a6;
while(a3.length&&a9){a4=a3[a5];
a6=a4.items;
var a7=a6.length;
if(ba&&ba.field===a4.field&&ba.value===a4.value){if(ba.hasSubgroups&&ba.items.length){ai(ba.items[ba.items.length-1],a4.items,a8,a9);
}else{a6=a6.slice(a8,a8+a9);
ba.items=ba.items.concat(a6);
}a3.splice(a5--,1);
}else{if(a4.hasSubgroups&&a6.length){ai(a4,a6,a8,a9);
if(!a4.items.length){a3.splice(a5--,1);
}}else{a6=a6.slice(a8,a8+a9);
a4.items=a6;
if(!a4.items.length){a3.splice(a5--,1);
}}}if(a6.length===0){a8-=a7;
}else{a8=0;
a9-=a6.length;
}if(++a5>=a3.length){break;
}}if(a5<a3.length){a3.splice(a5,a3.length-a5);
}}function G(a3){var a5,a9=[],a8,a7,a6;
for(a5=0,a8=a3.length;
a5<a8;
a5++){var a4=a3.at(a5);
if(a4.hasSubgroups){a9=a9.concat(G(a4.items));
}else{a7=a4.items;
for(a6=0;
a6<a7.length;
a6++){a9.push(a7.at(a6));
}}}return a9;
}function a2(a3,a7){var a5,a6,a4;
if(a7){for(a5=0,a6=a3.length;
a5<a6;
a5++){a4=a3.at(a5);
if(a4.hasSubgroups){a2(a4.items,a7);
}else{a4.items=new ae(a4.items,a7);
}}}}function z(a3,a4){for(var a5=0,a6=a3.length;
a5<a6;
a5++){if(a3[a5].hasSubgroups){if(z(a3[a5].items,a4)){return true;
}}else{if(a4(a3[a5].items,a3[a5])){return true;
}}}}function aI(a7,a3,a5,a6){for(var a4=0;
a4<a7.length;
a4++){if(a7[a4].data===a3){break;
}if(aH(a7[a4].data,a5,a6)){break;
}}}function aH(a5,a4,a7){for(var a3=0,a6=a5.length;
a3<a6;
a3++){if(a5[a3]&&a5[a3].hasSubgroups){return aH(a5[a3].items,a4,a7);
}else{if(a5[a3]===a4||a5[a3]===a7){a5[a3]=a7;
return true;
}}}}function aJ(ba,a3,a7,a9,a8){for(var bb=0,a6=ba.length;
bb<a6;
bb++){var a5=ba[bb];
if(!a5||a5 instanceof a9){continue;
}if(a5.hasSubgroups!==aY&&!a8){aJ(a5.items,a3,a7,a9,a8);
}else{for(var a4=0;
a4<a3.length;
a4++){if(a3[a4]===a5){ba[bb]=a3.at(a4);
aI(a7,a3,a5,ba[bb]);
break;
}}}}}function aG(a3,a7){var a5,a6;
for(a5=0,a6=a3.length;
a5<a6;
a5++){var a4=a3.at(a5);
if(a4.uid==a7.uid){a3.splice(a5,1);
return a4;
}}}function S(a3,a4){if(a4){return Q(a3,function(a5){return a5.uid&&a5.uid==a4.uid||a5[a4.idField]===a4.id&&a4.id!==a4._defaultId;
});
}return -1;
}function R(a3,a4){if(a4){return Q(a3,function(a5){return a5.uid==a4.uid;
});
}return -1;
}function Q(a4,a3){var a5,a6;
for(a5=0,a6=a4.length;
a5<a6;
a5++){if(a3(a4[a5])){return a5;
}}return -1;
}function F(a5,a6){if(a5&&!Y(a5)){var a3=a5[a6];
var a4;
if(ab(a3)){a4=a3.from||a3.field||a6;
}else{a4=a5[a6]||a6;
}if(Z(a4)){return a6;
}return a4;
}return a6;
}function n(a3,a7){var a5,a6,a8={};
for(var a4 in a3){if(a4!=="filters"){a8[a4]=a3[a4];
}}if(a3.filters){a8.filters=[];
for(a5=0,a6=a3.filters.length;
a5<a6;
a5++){a8.filters[a5]=n(a3.filters[a5],a7);
}}else{a8.field=F(a7.fields,a8.field);
}return a8;
}function m(a4,a8){var a6,a7,a9=[],ba,a3;
for(a6=0,a7=a4.length;
a6<a7;
a6++){ba={};
a3=a4[a6];
for(var a5 in a3){ba[a5]=a3[a5];
}ba.field=F(a8.fields,ba.field);
if(ba.aggregates&&W(ba.aggregates)){ba.aggregates=m(ba.aggregates,a8);
}a9.push(ba);
}return a9;
}var u=at.extend({init:function(a6){var a7=this,a5,a3;
if(a6){a3=a6.data;
}a6=a7.options=D({},a7.options,a6);
a7._map={};
a7._prefetch={};
a7._data=[];
a7._pristineData=[];
a7._ranges=[];
a7._view=[];
a7._pristineTotal=0;
a7._destroyed=[];
a7._pageSize=a6.pageSize;
a7._page=a6.page||(a6.pageSize?1:aY);
a7._sort=ar(a6.sort);
a7._filter=ao(a6.filter);
a7._group=ap(a6.group);
a7._aggregate=a6.aggregate;
a7._total=a6.total;
a7._shouldDetachObservableParents=true;
at.fn.init.call(a7);
a7.transport=aX.create(a6,a3,a7);
if(Z(a7.transport.push)){a7.transport.push({pushCreate:aB(a7._pushCreate,a7),pushUpdate:aB(a7._pushUpdate,a7),pushDestroy:aB(a7._pushDestroy,a7)});
}if(a6.offlineStorage!=null){if(typeof a6.offlineStorage=="string"){var a4=a6.offlineStorage;
a7._storage={getItem:function(){return JSON.parse(localStorage.getItem(a4));
},setItem:function(a8){localStorage.setItem(a4,aT(a7.reader.serialize(a8)));
}};
}else{a7._storage=a6.offlineStorage;
}}a7.reader=new ad.data.readers[a6.schema.type||"json"](a6.schema);
a5=a7.reader.model||{};
a7._detachObservableParents();
a7._data=a7._observe(a7._data);
a7._online=true;
a7.bind(["push",B,h,aL,aU,aK,aA],a6);
},options:{data:null,schema:{modelBase:aj},offlineStorage:null,serverSorting:false,serverPaging:false,serverFiltering:false,serverGrouping:false,serverAggregates:false,batch:false},clone:function(){return this;
},online:function(a3){if(a3!==aY){if(this._online!=a3){this._online=a3;
if(a3){return this.sync();
}}return b.Deferred().resolve().promise();
}else{return this._online;
}},offlineData:function(a3){if(this.options.offlineStorage==null){return null;
}if(a3!==aY){return this._storage.setItem(a3);
}return this._storage.getItem()||[];
},_isServerGrouped:function(){var a3=this.group()||[];
return this.options.serverGrouping&&a3.length;
},_pushCreate:function(a3){this._push(a3,"pushCreate");
},_pushUpdate:function(a3){this._push(a3,"pushUpdate");
},_pushDestroy:function(a3){this._push(a3,"pushDestroy");
},_push:function(a5,a4){var a3=this._readData(a5);
if(!a3){a3=a5;
}this[a4](a3);
},_flatData:function(a3,a5){if(a3){if(this._isServerGrouped()){return G(a3);
}if(!a5){for(var a4=0;
a4<a3.length;
a4++){a3.at(a4);
}}}return a3;
},parent:al,get:function(a4){var a5,a6,a3=this._flatData(this._data);
for(a5=0,a6=a3.length;
a5<a6;
a5++){if(a3[a5].id==a4){return a3[a5];
}}},getByUid:function(a4){var a5,a6,a3=this._flatData(this._data);
if(!a3){return;
}for(a5=0,a6=a3.length;
a5<a6;
a5++){if(a3[a5].uid==a4){return a3[a5];
}}},indexOf:function(a3){return R(this._data,a3);
},at:function(a3){return this._data.at(a3);
},data:function(a5){var a4=this;
if(a5!==aY){a4._detachObservableParents();
a4._data=this._observe(a5);
a4._pristineData=a5.slice(0);
a4._storeData();
a4._ranges=[];
a4.trigger("reset");
a4._addRange(a4._data);
a4._total=a4._data.length;
a4._pristineTotal=a4._total;
a4._process(a4._data);
}else{if(a4._data){for(var a3=0;
a3<a4._data.length;
a3++){a4._data.at(a3);
}}return a4._data;
}},view:function(a3){if(a3===aY){return this._view;
}else{this._view=this._observeView(a3);
}},_observeView:function(a3){var a4=this;
aJ(a3,a4._data,a4._ranges,a4.reader.model||av,a4._isServerGrouped());
var a5=new ae(a3,a4.reader.model);
a5.parent=function(){return a4.parent();
};
return a5;
},flatView:function(){var a3=this.group()||[];
if(a3.length){return G(this._view);
}else{return this._view;
}},add:function(a3){return this.insert(this._data.length,a3);
},_createNewModel:function(a3){if(this.reader.model){return new this.reader.model(a3);
}if(a3 instanceof av){return a3;
}return new av(a3);
},insert:function(a3,a4){if(!a4){a4=a3;
a3=0;
}if(!(a4 instanceof aj)){a4=this._createNewModel(a4);
}if(this._isServerGrouped()){this._data.splice(a3,0,this._wrapInEmptyGroup(a4));
}else{this._data.splice(a3,0,a4);
}return a4;
},pushCreate:function(a6){if(!W(a6)){a6=[a6];
}var a8=[];
var a3=this.options.autoSync;
this.options.autoSync=false;
try{for(var a4=0;
a4<a6.length;
a4++){var a5=a6[a4];
var a9=this.add(a5);
a8.push(a9);
var a7=a9.toJSON();
if(this._isServerGrouped()){a7=this._wrapInEmptyGroup(a7);
}this._pristineData.push(a7);
}}finally{this.options.autoSync=a3;
}if(a8.length){this.trigger("push",{type:"create",items:a8});
}},pushUpdate:function(a5){if(!W(a5)){a5=[a5];
}var a7=[];
for(var a3=0;
a3<a5.length;
a3++){var a4=a5[a3];
var a6=this._createNewModel(a4);
var a8=this.get(a6.id);
if(a8){a7.push(a8);
a8.accept(a4);
a8.trigger(h);
this._updatePristineForModel(a8,a4);
}else{this.pushCreate(a4);
}}if(a7.length){this.trigger("push",{type:"update",items:a7});
}},pushDestroy:function(a3){var a4=this._removeItems(a3);
if(a4.length){this.trigger("push",{type:"destroy",items:a4});
}},_removeItems:function(a8){if(!W(a8)){a8=[a8];
}var a4=[];
var a3=this.options.autoSync;
this.options.autoSync=false;
try{for(var a6=0;
a6<a8.length;
a6++){var a7=a8[a6];
var a9=this._createNewModel(a7);
var a5=false;
this._eachItem(this._data,function(bc){for(var ba=0;
ba<bc.length;
ba++){var bb=bc.at(ba);
if(bb.id===a9.id){a4.push(bb);
bc.splice(ba,1);
a5=true;
break;
}}});
if(a5){this._removePristineForModel(a9);
this._destroyed.pop();
}}}finally{this.options.autoSync=a3;
}return a4;
},remove:function(a4){var a5,a6=this,a3=a6._isServerGrouped();
this._eachItem(a6._data,function(a7){a5=aG(a7,a4);
if(a5&&a3){if(!a5.isNew||!a5.isNew()){a6._destroyed.push(a5);
}return true;
}});
this._removeModelFromRanges(a4);
this._updateRangesLength();
return a4;
},destroyed:function(){return this._destroyed;
},created:function(){var a4,a5,a6=[],a3=this._flatData(this._data);
for(a4=0,a5=a3.length;
a4<a5;
a4++){if(a3[a4].isNew&&a3[a4].isNew()){a6.push(a3[a4]);
}}return a6;
},updated:function(){var a4,a5,a6=[],a3=this._flatData(this._data);
for(a4=0,a5=a3.length;
a4<a5;
a4++){if(a3[a4].isNew&&!a3[a4].isNew()&&a3[a4].dirty){a6.push(a3[a4]);
}}return a6;
},sync:function(){var a7=this,a3=[],a8=[],a4=a7._destroyed;
var a5=b.Deferred().resolve().promise();
if(a7.online()){if(!a7.reader.model){return a5;
}a3=a7.created();
a8=a7.updated();
var a6=[];
if(a7.options.batch&&a7.transport.submit){a6=a7._sendSubmit(a3,a8,a4);
}else{a6.push.apply(a6,a7._send("create",a3));
a6.push.apply(a6,a7._send("update",a8));
a6.push.apply(a6,a7._send("destroy",a4));
}a5=b.when.apply(null,a6).then(function(){var a9,ba;
for(a9=0,ba=arguments.length;
a9<ba;
a9++){if(arguments[a9]){a7._accept(arguments[a9]);
}}a7._storeData(true);
a7._change({action:"sync"});
a7.trigger(aU);
});
}else{a7._storeData(true);
a7._change({action:"sync"});
}return a5;
},cancelChanges:function(a3){var a4=this;
if(a3 instanceof ad.data.Model){a4._cancelModel(a3);
}else{a4._destroyed=[];
a4._detachObservableParents();
a4._data=a4._observe(a4._pristineData);
if(a4.options.serverPaging){a4._total=a4._pristineTotal;
}a4._ranges=[];
a4._addRange(a4._data);
a4._change();
a4._markOfflineUpdatesAsDirty();
}},_markOfflineUpdatesAsDirty:function(){var a3=this;
if(a3.options.offlineStorage!=null){a3._eachItem(a3._data,function(a6){for(var a4=0;
a4<a6.length;
a4++){var a5=a6.at(a4);
if(a5.__state__=="update"||a5.__state__=="create"){a5.dirty=true;
}}});
}},hasChanges:function(){var a4,a5,a3=this._flatData(this._data);
if(this._destroyed.length){return true;
}for(a4=0,a5=a3.length;
a4<a5;
a4++){if(a3[a4].isNew&&a3[a4].isNew()||a3[a4].dirty){return true;
}}return false;
},_accept:function(a8){var ba=this,a5=a8.models,a7=a8.response,a3=0,a9=ba._isServerGrouped(),a6=ba._pristineData,bb=a8.type,a4;
ba.trigger(aK,{response:a7,type:bb});
if(a7&&!Y(a7)){a7=ba.reader.parse(a7);
if(ba._handleCustomErrors(a7)){return;
}a7=ba.reader.data(a7);
if(!W(a7)){a7=[a7];
}}else{a7=b.map(a5,function(bc){return bc.toJSON();
});
}if(bb==="destroy"){ba._destroyed=[];
}for(a3=0,a4=a5.length;
a3<a4;
a3++){if(bb!=="destroy"){a5[a3].accept(a7[a3]);
if(bb==="create"){a6.push(a9?ba._wrapInEmptyGroup(a5[a3]):a7[a3]);
}else{if(bb==="update"){ba._updatePristineForModel(a5[a3],a7[a3]);
}}}else{ba._removePristineForModel(a5[a3]);
}}},_updatePristineForModel:function(a3,a4){this._executeOnPristineForModel(a3,function(a5,a6){ad.deepExtend(a6[a5],a4);
});
},_executeOnPristineForModel:function(a4,a3){this._eachPristineItem(function(a6){var a5=S(a6,a4);
if(a5>-1){a3(a5,a6);
return true;
}});
},_removePristineForModel:function(a3){this._executeOnPristineForModel(a3,function(a4,a5){a5.splice(a4,1);
});
},_readData:function(a3){var a4=!this._isServerGrouped()?this.reader.data:this.reader.groups;
return a4.call(this.reader,a3);
},_eachPristineItem:function(a3){this._eachItem(this._pristineData,a3);
},_eachItem:function(a4,a3){if(a4&&a4.length){if(this._isServerGrouped()){z(a4,a3);
}else{a3(a4);
}}},_pristineForModel:function(a5){var a6,a4,a3=function(a7){a4=S(a7,a5);
if(a4>-1){a6=a7[a4];
return true;
}};
this._eachPristineItem(a3);
return a6;
},_cancelModel:function(a3){var a4=this._pristineForModel(a3);
this._eachItem(this._data,function(a6){var a5=R(a6,a3);
if(a5>=0){if(a4&&(!a3.isNew()||a4.__state__)){a6[a5].accept(a4);
if(a4.__state__=="update"){a6[a5].dirty=true;
}}else{a6.splice(a5,1);
}}});
},_submit:function(a4,a3){var a5=this;
a5.trigger(aL,{type:"submit"});
a5.transport.submit(D({success:function(a7,a8){var a6=b.grep(a4,function(a9){return a9.type==a8;
})[0];
if(a6){a6.resolve({response:a7,models:a6.models,type:a8});
}},error:function(a8,a9,a6){for(var a7=0;
a7<a4.length;
a7++){a4[a7].reject(a8);
}a5.error(a8,a9,a6);
}},a3));
},_sendSubmit:function(a3,a7,a4){var a6=this,a5=[];
if(a6.options.batch){if(a3.length){a5.push(b.Deferred(function(a8){a8.type="create";
a8.models=a3;
}));
}if(a7.length){a5.push(b.Deferred(function(a8){a8.type="update";
a8.models=a7;
}));
}if(a4.length){a5.push(b.Deferred(function(a8){a8.type="destroy";
a8.models=a4;
}));
}a6._submit(a5,{data:{created:a6.reader.serialize(aV(a3)),updated:a6.reader.serialize(aV(a7)),destroyed:a6.reader.serialize(aV(a4))}});
}return a5;
},_promise:function(a3,a4,a6){var a5=this;
return b.Deferred(function(a7){a5.trigger(aL,{type:a6});
a5.transport[a6].call(a5.transport,D({success:function(a8){a7.resolve({response:a8,models:a4,type:a6});
},error:function(a9,ba,a8){a7.reject(a9);
a5.error(a9,ba,a8);
}},a3));
}).promise();
},_send:function(a7,a4){var a9=this,a5,a6,a8=[],a3=a9.reader.serialize(aV(a4));
if(a9.options.batch){if(a4.length){a8.push(a9._promise({data:{models:a3}},a4,a7));
}}else{for(a5=0,a6=a4.length;
a5<a6;
a5++){a8.push(a9._promise({data:a3[a5]},[a4[a5]],a7));
}}return a8;
},read:function(a3){var a6=this,a5=a6._params(a3);
var a4=b.Deferred();
a6._queueRequest(a5,function(){var a7=a6.trigger(aL,{type:"read"});
if(!a7){a6.trigger(aA);
a6._ranges=[];
a6.trigger("reset");
if(a6.online()){a6.transport.read({data:a5,success:function(a8){a6._ranges=[];
a6.success(a8,a5);
a4.resolve();
},error:function(){var a8=aO.call(arguments);
a6.error.apply(a6,a8);
a4.reject.apply(a4,a8);
}});
}else{if(a6.options.offlineStorage!=null){a6.success(a6.offlineData(),a5);
a4.resolve();
}}}else{a6._dequeueRequest();
a4.resolve(a7);
}});
return a4.promise();
},_readAggregates:function(a3){return this.reader.aggregates(a3);
},success:function(a3){var bd=this,bb=bd.options;
bd.trigger(aK,{response:a3,type:"read"});
if(bd.online()){a3=bd.reader.parse(a3);
if(bd._handleCustomErrors(a3)){bd._dequeueRequest();
return;
}bd._total=bd.reader.total(a3);
if(bd._aggregate&&bb.serverAggregates){bd._aggregateResult=bd._readAggregates(a3);
}a3=bd._readData(a3);
bd._destroyed=[];
}else{a3=bd._readData(a3);
var a9=[];
var a8={};
var ba=bd.reader.model;
var a5=ba?ba.idField:"id";
var a6;
for(a6=0;
a6<this._destroyed.length;
a6++){var a4=this._destroyed[a6][a5];
a8[a4]=a4;
}for(a6=0;
a6<a3.length;
a6++){var a7=a3[a6];
var bc=a7.__state__;
if(bc=="destroy"){if(!a8[a7[a5]]){this._destroyed.push(this._createNewModel(a7));
}}else{a9.push(a7);
}}a3=a9;
bd._total=a3.length;
}bd._pristineTotal=bd._total;
bd._pristineData=a3.slice(0);
bd._detachObservableParents();
bd._data=bd._observe(a3);
bd._markOfflineUpdatesAsDirty();
bd._storeData();
bd._addRange(bd._data);
bd._process(bd._data);
bd._dequeueRequest();
},_detachObservableParents:function(){if(this._data&&this._shouldDetachObservableParents){for(var a3=0;
a3<this._data.length;
a3++){if(this._data[a3].parent){this._data[a3].parent=al;
}}}},_storeData:function(ba){var a8=this._isServerGrouped();
var a7=this.reader.model;
function a6(bb){var bf=[];
for(var bd=0;
bd<bb.length;
bd++){var bc=bb.at(bd);
var be=bc.toJSON();
if(a8&&bc.items){be.items=a6(bc.items);
}else{be.uid=bc.uid;
if(a7){if(bc.isNew()){be.__state__="create";
}else{if(bc.dirty){be.__state__="update";
}}}}bf.push(be);
}return bf;
}if(this.options.offlineStorage!=null){var a9=a6(this._data);
var a3=[];
for(var a4=0;
a4<this._destroyed.length;
a4++){var a5=this._destroyed[a4].toJSON();
a5.__state__="destroy";
a3.push(a5);
}this.offlineData(a9.concat(a3));
if(ba){this._pristineData=this._readData(a9);
}}},_addRange:function(a3){var a6=this,a5=a6._skip||0,a4=a5+a6._flatData(a3,true).length;
a6._ranges.push({start:a5,end:a4,data:a3,timestamp:new Date().getTime()});
a6._ranges.sort(function(a7,a8){return a7.start-a8.start;
});
},error:function(a5,a4,a3){this._dequeueRequest();
this.trigger(aK,{});
this.trigger(B,{xhr:a5,status:a4,errorThrown:a3});
},_params:function(a3){var a5=this,a4=D({take:a5.take(),skip:a5.skip(),page:a5.page(),pageSize:a5.pageSize(),sort:a5._sort,filter:a5._filter,group:a5._group,aggregate:a5._aggregate},a3);
if(!a5.options.serverPaging){delete a4.take;
delete a4.skip;
delete a4.page;
delete a4.pageSize;
}if(!a5.options.serverGrouping){delete a4.group;
}else{if(a5.reader.model&&a4.group){a4.group=m(a4.group,a5.reader.model);
}}if(!a5.options.serverFiltering){delete a4.filter;
}else{if(a5.reader.model&&a4.filter){a4.filter=n(a4.filter,a5.reader.model);
}}if(!a5.options.serverSorting){delete a4.sort;
}else{if(a5.reader.model&&a4.sort){a4.sort=m(a4.sort,a5.reader.model);
}}if(!a5.options.serverAggregates){delete a4.aggregate;
}else{if(a5.reader.model&&a4.aggregate){a4.aggregate=m(a4.aggregate,a5.reader.model);
}}return a4;
},_queueRequest:function(a4,a3){var a5=this;
if(!a5._requestInProgress){a5._requestInProgress=true;
a5._pending=aY;
a3();
}else{a5._pending={callback:aB(a3,a5),options:a4};
}},_dequeueRequest:function(){var a3=this;
a3._requestInProgress=false;
if(a3._pending){a3._queueRequest(a3._pending.options,a3._pending.callback);
}},_handleCustomErrors:function(a4){if(this.reader.errors){var a3=this.reader.errors(a4);
if(a3){this.trigger(B,{xhr:null,status:"customerror",errorThrown:"custom error",errors:a3});
return true;
}}return false;
},_shouldWrap:function(a3){var a4=this.reader.model;
if(a4&&a3.length){return !(a3[0] instanceof a4);
}return false;
},_observe:function(a4){var a6=this,a5=a6.reader.model;
a6._shouldDetachObservableParents=true;
if(a4 instanceof au){a6._shouldDetachObservableParents=false;
if(a6._shouldWrap(a4)){a4.type=a6.reader.model;
a4.wrapAll(a4,a4);
}}else{var a3=a6.pageSize()&&!a6.options.serverPaging?ae:au;
a4=new a3(a4,a6.reader.model);
a4.parent=function(){return a6.parent();
};
}if(a6._isServerGrouped()){a2(a4,a5);
}if(a6._changeHandler&&a6._data&&a6._data instanceof au){a6._data.unbind(h,a6._changeHandler);
}else{a6._changeHandler=aB(a6._change,a6);
}return a4.bind(h,a6._changeHandler);
},_updateTotalForAction:function(a3,a4){var a5=this;
var a6=parseInt(a5._total,10);
if(!aa(a5._total)){a6=parseInt(a5._pristineTotal,10);
}if(a3==="add"){a6+=a4.length;
}else{if(a3==="remove"){a6-=a4.length;
}else{if(a3!=="itemchange"&&a3!=="sync"&&!a5.options.serverPaging){a6=a5._pristineTotal;
}else{if(a3==="sync"){a6=a5._pristineTotal=parseInt(a5._total,10);
}}}}a5._total=a6;
},_change:function(a4){var a8=this,a6,a7,a3=a4?a4.action:"";
if(a3==="remove"){for(a6=0,a7=a4.items.length;
a6<a7;
a6++){if(!a4.items[a6].isNew||!a4.items[a6].isNew()){a8._destroyed.push(a4.items[a6]);
}}}if(a8.options.autoSync&&(a3==="add"||a3==="remove"||a3==="itemchange")){var a5=function(a9){if(a9.action==="sync"){a8.unbind("change",a5);
a8._updateTotalForAction(a3,a4.items);
}};
a8.first("change",a5);
a8.sync();
}else{a8._updateTotalForAction(a3,a4?a4.items:[]);
a8._process(a8._data,a4);
}},_calculateAggregates:function(a4,a6){a6=a6||{};
var a7=new aD(a4),a3=a6.aggregate,a5=a6.filter;
if(a5){a7=a7.filter(a5);
}return a7.aggregate(a3);
},_process:function(a3,a4){var a7=this,a5={},a6;
if(a7.options.serverPaging!==true){a5.skip=a7._skip;
a5.take=a7._take||a7._pageSize;
if(a5.skip===aY&&a7._page!==aY&&a7._pageSize!==aY){a5.skip=(a7._page-1)*a7._pageSize;
}}if(a7.options.serverSorting!==true){a5.sort=a7._sort;
}if(a7.options.serverFiltering!==true){a5.filter=a7._filter;
}if(a7.options.serverGrouping!==true){a5.group=a7._group;
}if(a7.options.serverAggregates!==true){a5.aggregate=a7._aggregate;
a7._aggregateResult=a7._calculateAggregates(a3,a5);
}a6=a7._queryProcess(a3,a5);
a7.view(a6.data);
if(a6.total!==aY&&!a7.options.serverFiltering){a7._total=a6.total;
}a4=a4||{};
a4.items=a4.items||a7._view;
a7.trigger(h,a4);
},_queryProcess:function(a3,a4){return aD.process(a3,a4);
},_mergeState:function(a3){var a4=this;
if(a3!==aY){a4._pageSize=a3.pageSize;
a4._page=a3.page;
a4._sort=a3.sort;
a4._filter=a3.filter;
a4._group=a3.group;
a4._aggregate=a3.aggregate;
a4._skip=a4._currentRangeStart=a3.skip;
a4._take=a3.take;
if(a4._skip===aY){a4._skip=a4._currentRangeStart=a4.skip();
a3.skip=a4.skip();
}if(a4._take===aY&&a4._pageSize!==aY){a4._take=a4._pageSize;
a3.take=a4._take;
}if(a3.sort){a4._sort=a3.sort=ar(a3.sort);
}if(a3.filter){a4._filter=a3.filter=ao(a3.filter);
}if(a3.group){a4._group=a3.group=ap(a3.group);
}if(a3.aggregate){a4._aggregate=a3.aggregate=am(a3.aggregate);
}}return a3;
},query:function(a4){var a6;
var a5=this.options.serverSorting||this.options.serverPaging||this.options.serverFiltering||this.options.serverGrouping||this.options.serverAggregates;
if(a5||(this._data===aY||this._data.length===0)&&!this._destroyed.length){return this.read(this._mergeState(a4));
}var a3=this.trigger(aL,{type:"read"});
if(!a3){this.trigger(aA);
a6=this._queryProcess(this._data,this._mergeState(a4));
if(!this.options.serverFiltering){if(a6.total!==aY){this._total=a6.total;
}else{this._total=this._data.length;
}}this._aggregateResult=this._calculateAggregates(this._data,a4);
this.view(a6.data);
this.trigger(aK,{type:"read"});
this.trigger(h,{items:a6.data});
}return b.Deferred().resolve(a3).promise();
},fetch:function(a3){var a5=this;
var a4=function(a6){if(a6!==true&&Z(a3)){a3.call(a5);
}};
return this._query().then(a4);
},_query:function(a3){var a4=this;
return a4.query(D({},{page:a4.page(),pageSize:a4.pageSize(),sort:a4.sort(),filter:a4.filter(),group:a4.group(),aggregate:a4.aggregate()},a3));
},next:function(a3){var a5=this,a4=a5.page(),a6=a5.total();
a3=a3||{};
if(!a4||a6&&a4+1>a5.totalPages()){return;
}a5._skip=a5._currentRangeStart=a4*a5.take();
a4+=1;
a3.page=a4;
a5._query(a3);
return a4;
},prev:function(a3){var a5=this,a4=a5.page();
a3=a3||{};
if(!a4||a4===1){return;
}a5._skip=a5._currentRangeStart=a5._skip-a5.take();
a4-=1;
a3.page=a4;
a5._query(a3);
return a4;
},page:function(a5){var a4=this,a3;
if(a5!==aY){a5=ah.max(ah.min(ah.max(a5,1),a4.totalPages()),1);
a4._query({page:a5});
return;
}a3=a4.skip();
return a3!==aY?ah.round((a3||0)/(a4.take()||1))+1:aY;
},pageSize:function(a4){var a3=this;
if(a4!==aY){a3._query({pageSize:a4,page:1});
return;
}return a3.take();
},sort:function(a4){var a3=this;
if(a4!==aY){a3._query({sort:a4});
return;
}return a3._sort;
},filter:function(a4){var a3=this;
if(a4===aY){return a3._filter;
}a3.trigger("reset");
a3._query({filter:a4,page:1});
},group:function(a4){var a3=this;
if(a4!==aY){a3._query({group:a4});
return;
}return a3._group;
},total:function(){return parseInt(this._total||0,10);
},aggregate:function(a4){var a3=this;
if(a4!==aY){a3._query({aggregate:a4});
return;
}return a3._aggregate;
},aggregates:function(){var a3=this._aggregateResult;
if(Y(a3)){a3=this._emptyAggregates(this.aggregate());
}return a3;
},_emptyAggregates:function(a4){var a6={};
if(!Y(a4)){var a3={};
if(!W(a4)){a4=[a4];
}for(var a5=0;
a5<a4.length;
a5++){a3[a4[a5].aggregate]=0;
a6[a4[a5].field]=a3;
}}return a6;
},_wrapInEmptyGroup:function(a7){var a4=this.group(),a8,a3,a5,a6;
for(a5=a4.length-1,a6=0;
a5>=a6;
a5--){a3=a4[a5];
a8={value:a7.get(a3.field),field:a3.field,items:a8?[a8]:[a7],hasSubgroups:!!a8,aggregates:this._emptyAggregates(a3.aggregates)};
}return a8;
},totalPages:function(){var a4=this,a3=a4.pageSize()||a4.total();
return ah.ceil((a4.total()||0)/a3);
},inRange:function(a4,a5){var a6=this,a3=ah.min(a4+a5,a6.total());
if(!a6.options.serverPaging&&a6._data.length>0){return true;
}return a6._findRange(a4,a3).length>0;
},lastRange:function(){var a3=this._ranges;
return a3[a3.length-1]||{start:0,end:0,data:[]};
},firstItemUid:function(){var a3=this._ranges;
return a3.length&&a3[0].data.length&&a3[0].data[0].uid;
},enableRequestsInProgress:function(){this._skipRequestsInProgress=false;
},_timeStamp:function(){return new Date().getTime();
},range:function(a9,bb){this._currentRequestTimeStamp=this._timeStamp();
this._skipRequestsInProgress=true;
a9=ah.min(a9||0,this.total());
var bc=this,a6=ah.max(ah.floor(a9/bb),0)*bb,a8=ah.min(a6+bb,bc.total()),a4;
a4=bc._findRange(a9,ah.min(a9+bb,bc.total()));
if(a4.length){bc._pending=aY;
bc._skip=a9>bc.skip()?ah.min(a8,(bc.totalPages()-1)*bc.take()):a6;
bc._currentRangeStart=a9;
bc._take=bb;
var a7=bc.options.serverPaging;
var ba=bc.options.serverSorting;
var a5=bc.options.serverFiltering;
var a3=bc.options.serverAggregates;
try{bc.options.serverPaging=true;
if(!bc._isServerGrouped()&&!(bc.group()&&bc.group().length)){bc.options.serverSorting=true;
}bc.options.serverFiltering=true;
bc.options.serverPaging=true;
bc.options.serverAggregates=true;
if(a7){bc._detachObservableParents();
bc._data=a4=bc._observe(a4);
}bc._process(a4);
}finally{bc.options.serverPaging=a7;
bc.options.serverSorting=ba;
bc.options.serverFiltering=a5;
bc.options.serverAggregates=a3;
}return;
}if(bb!==aY){if(!bc._rangeExists(a6,a8)){bc.prefetch(a6,bb,function(){if(a9>a6&&a8<bc.total()&&!bc._rangeExists(a8,ah.min(a8+bb,bc.total()))){bc.prefetch(a8,bb,function(){bc.range(a9,bb);
});
}else{bc.range(a9,bb);
}});
}else{if(a6<a9){bc.prefetch(a8,bb,function(){bc.range(a9,bb);
});
}}}},_findRange:function(bi,a5){var bl=this,be=bl._ranges,bb,a4=[],bg,bk,bj,a6,bc,bd,ba,a9=bl.options,bf=a9.serverSorting||a9.serverPaging||a9.serverFiltering||a9.serverGrouping||a9.serverAggregates,a7,a3,a8;
for(bg=0,a8=be.length;
bg<a8;
bg++){bb=be[bg];
if(bi>=bb.start&&bi<=bb.end){a3=0;
for(bk=bg;
bk<a8;
bk++){bb=be[bk];
a7=bl._flatData(bb.data,true);
if(a7.length&&bi+a3>=bb.start){bc=bb.data;
bd=bb.end;
if(!bf){var bh=ap(bl.group()||[]).concat(ar(bl.sort()||[]));
ba=bl._queryProcess(bb.data,{sort:bh,filter:bl.filter()});
a7=bc=ba.data;
if(ba.total!==aY){bd=ba.total;
}}bj=0;
if(bi+a3>bb.start){bj=bi+a3-bb.start;
}a6=a7.length;
if(bd>a5){a6=a6-(bd-a5);
}a3+=a6-bj;
a4=bl._mergeGroups(a4,bc,bj,a6);
if(a5<=bb.end&&a3==a5-bi){return a4;
}}}break;
}}return[];
},_mergeGroups:function(a3,a5,a6,a7){if(this._isServerGrouped()){var a8=a5.toJSON(),a4;
if(a3.length){a4=a3[a3.length-1];
}ai(a4,a8,a6,a7);
return a3.concat(a8);
}return a3.concat(a5.slice(a6,a7));
},skip:function(){var a3=this;
if(a3._skip===aY){return a3._page!==aY?(a3._page-1)*(a3.take()||1):aY;
}return a3._skip;
},currentRangeStart:function(){return this._currentRangeStart||0;
},take:function(){return this._take||this._pageSize;
},_prefetchSuccessHandler:function(a6,a5,a3,a4){var a7=this;
var a8=a7._timeStamp();
return function(a9){var ba=false,bd={start:a6,end:a5,data:[],timestamp:a7._timeStamp()},bb,bc,be;
a7._dequeueRequest();
a7.trigger(aK,{response:a9,type:"read"});
a9=a7.reader.parse(a9);
be=a7._readData(a9);
if(be.length){for(bb=0,bc=a7._ranges.length;
bb<bc;
bb++){if(a7._ranges[bb].start===a6){ba=true;
bd=a7._ranges[bb];
break;
}}if(!ba){a7._ranges.push(bd);
}}bd.data=a7._observe(be);
bd.end=bd.start+a7._flatData(bd.data,true).length;
a7._ranges.sort(function(bf,bg){return bf.start-bg.start;
});
a7._total=a7.reader.total(a9);
if(a4||(a8>=a7._currentRequestTimeStamp||!a7._skipRequestsInProgress)){if(a3&&be.length){a3();
}else{a7.trigger(h,{});
}}};
},prefetch:function(a6,a7,a3){var a8=this,a5=ah.min(a6+a7,a8.total()),a4={take:a7,skip:a6,page:a6/a7+1,pageSize:a7,sort:a8._sort,filter:a8._filter,group:a8._group,aggregate:a8._aggregate};
if(!a8._rangeExists(a6,a5)){clearTimeout(a8._timeout);
a8._timeout=setTimeout(function(){a8._queueRequest(a4,function(){if(!a8.trigger(aL,{type:"read"})){a8.transport.read({data:a8._params(a4),success:a8._prefetchSuccessHandler(a6,a5,a3),error:function(){var a9=aO.call(arguments);
a8.error.apply(a8,a9);
}});
}else{a8._dequeueRequest();
}});
},100);
}else{if(a3){a3();
}}},_multiplePrefetch:function(a6,a7,a3){var a8=this,a5=ah.min(a6+a7,a8.total()),a4={take:a7,skip:a6,page:a6/a7+1,pageSize:a7,sort:a8._sort,filter:a8._filter,group:a8._group,aggregate:a8._aggregate};
if(!a8._rangeExists(a6,a5)){if(!a8.trigger(aL,{type:"read"})){a8.transport.read({data:a8._params(a4),success:a8._prefetchSuccessHandler(a6,a5,a3,true)});
}}else{if(a3){a3();
}}},_rangeExists:function(a7,a3){var a8=this,a6=a8._ranges,a4,a5;
for(a4=0,a5=a6.length;
a4<a5;
a4++){if(a6[a4].start<=a7&&a6[a4].end>=a3){return true;
}}return false;
},_removeModelFromRanges:function(a6){var a8,a3,a7;
for(var a4=0,a5=this._ranges.length;
a4<a5;
a4++){a7=this._ranges[a4];
this._eachItem(a7.data,function(a9){a8=aG(a9,a6);
if(a8){a3=true;
}});
if(a3){break;
}}},_updateRangesLength:function(){var a7=0,a5,a6;
for(var a3=0,a4=this._ranges.length;
a3<a4;
a3++){a5=this._ranges[a3];
a5.start=a5.start-a7;
a6=this._flatData(a5.data,true).length;
a7=a5.end-a6;
a5.end=a5.start+a6;
}}});
var aX={};
aX.create=function(a5,a3,a4){var a6,a7=a5.transport?b.extend({},a5.transport):null;
if(a7){a7.read=typeof a7.read===aS?{url:a7.read}:a7.read;
if(a5.type==="jsdo"){a7.dataSource=a4;
}if(a5.type){ad.data.transports=ad.data.transports||{};
ad.data.schemas=ad.data.schemas||{};
if(!ad.data.transports[a5.type]){ad.logToConsole("Unknown DataSource transport type '"+a5.type+"'.\nVerify that registration scripts for this type are included after Kendo UI on the page.","warn");
}else{if(!ab(ad.data.transports[a5.type])){a6=new ad.data.transports[a5.type](D(a7,{data:a3}));
}else{a7=D(true,{},ad.data.transports[a5.type],a7);
}}a5.schema=D(true,{},ad.data.schemas[a5.type],a5.schema);
}if(!a6){a6=Z(a7.read)?a7:new aF(a7);
}}else{a6=new af({data:a5.data||[]});
}return a6;
};
u.create=function(ba){if(W(ba)||ba instanceof au){ba={data:ba};
}var a4=ba||{},a3=a4.data,a6=a4.fields,bc=a4.table,bb=a4.select,a7,a8,a9={},a5;
if(!a3&&a6&&!a4.transport){if(bc){a3=V(bc,a6);
}else{if(bb){a3=U(bb,a6);
if(a4.group===aY&&a3[0]&&a3[0].optgroup!==aY){a4.group="optgroup";
}}}}if(ad.data.Model&&a6&&(!a4.schema||!a4.schema.model)){for(a7=0,a8=a6.length;
a7<a8;
a7++){a5=a6[a7];
if(a5.type){a9[a5.field]=a5;
}}if(!Y(a9)){a4.schema=D(true,a4.schema,{model:{fields:a9}});
}}a4.data=a3;
bb=null;
a4.select=null;
bc=null;
a4.table=null;
return a4 instanceof u?a4:new u(a4);
};
function U(bd,a4){bd=b(bd)[0];
var ba=bd.options;
var a5=a4[0];
var bc=a4[1];
var a3=[];
var a6,a7;
var a8;
var a9;
var bb;
var be;
for(a6=0,a7=ba.length;
a6<a7;
a6++){bb={};
a9=ba[a6];
a8=a9.parentNode;
if(a8===bd){a8=null;
}if(a9.disabled||a8&&a8.disabled){continue;
}if(a8){bb.optgroup=a8.label;
}bb[a5.field]=a9.text;
be=a9.attributes.value;
if(be&&be.specified){be=a9.value;
}else{be=a9.text;
}bb[bc.field]=be;
a3.push(bb);
}return a3;
}function V(be,a9){var bf=b(be)[0].tBodies[0],bd=bf?bf.rows:[],ba,bb,a8,a7=a9.length,a5=[],a4,bc,a3,a6;
for(ba=0,bb=bd.length;
ba<bb;
ba++){bc={};
a6=true;
a4=bd[ba].cells;
for(a8=0;
a8<a7;
a8++){a3=a4[a8];
if(a3.nodeName.toLowerCase()!=="th"){a6=false;
bc[a9[a8].field]=a3.innerHTML;
}}if(!a6){a5.push(bc);
}}return a5;
}var ak=aj.define({idField:"id",init:function(a7){var a6=this,a5=a6.hasChildren||a7&&a7.hasChildren,a3="items",a4={};
ad.data.Model.fn.init.call(a6,a7);
if(typeof a6.children===aS){a3=a6.children;
}a4={schema:{data:a3,model:{hasChildren:a5,id:a6.idField,fields:a6.fields}}};
if(typeof a6.children!==aS){D(a4,a6.children);
}a4.data=a7;
if(!a5){a5=a4.schema.data;
}if(typeof a5===aS){a5=ad.getter(a5);
}if(Z(a5)){a6.hasChildren=!!a5.call(a6,a6);
}a6._childrenOptions=a4;
if(a6.hasChildren){a6._initChildren();
}a6._loaded=!!(a7&&a7._loaded);
},_initChildren:function(){var a5=this;
var a3,a6,a4;
if(!(a5.children instanceof O)){a3=a5.children=new O(a5._childrenOptions);
a6=a3.transport;
a4=a6.parameterMap;
a6.parameterMap=function(a7,a8){a7[a5.idField||"id"]=a5.id;
if(a4){a7=a4(a7,a8);
}return a7;
};
a3.parent=function(){return a5;
};
a3.bind(h,function(a7){a7.node=a7.node||a5;
a5.trigger(h,a7);
});
a3.bind(B,function(a8){var a7=a5.parent();
if(a7){a8.node=a8.node||a5;
a7.trigger(B,a8);
}});
a5._updateChildrenField();
}},append:function(a3){this._initChildren();
this.loaded(true);
this.children.add(a3);
},hasChildren:false,level:function(){var a4=this.parentNode(),a3=0;
while(a4&&a4.parentNode){a3++;
a4=a4.parentNode?a4.parentNode():null;
}return a3;
},_updateChildrenField:function(){var a3=this._childrenOptions.schema.data;
this[a3||"items"]=this.children.data();
},_childrenLoaded:function(){this._loaded=true;
this._updateChildrenField();
},load:function(){var a5={};
var a4="_query";
var a3,a6;
if(this.hasChildren){this._initChildren();
a3=this.children;
a5[this.idField||"id"]=this.id;
if(!this._loaded){a3._data=aY;
a4="read";
}a3.one(h,aB(this._childrenLoaded,this));
a6=a3[a4](a5);
}else{this.loaded(true);
}return a6||b.Deferred().resolve().promise();
},parentNode:function(){var a3=this.parent();
return a3.parent();
},loaded:function(a3){if(a3!==aY){this._loaded=a3;
}else{return this._loaded;
}},shouldSerialize:function(a3){return aj.fn.shouldSerialize.call(this,a3)&&a3!=="children"&&a3!=="_loaded"&&a3!=="hasChildren"&&a3!=="_childrenOptions";
}});
function s(a3){return function(){var a4=this._data,a5=u.fn[a3].apply(this,aO.call(arguments));
if(this._data!=a4){this._attachBubbleHandlers();
}return a5;
};
}var O=u.extend({init:function(a4){var a3=ak.define({children:a4});
u.fn.init.call(this,D(true,{},{schema:{modelBase:a3,model:a3}},a4));
this._attachBubbleHandlers();
},_attachBubbleHandlers:function(){var a3=this;
a3._data.bind(B,function(a4){a3.trigger(B,a4);
});
},remove:function(a4){var a5=a4.parentNode(),a3=this,a6;
if(a5&&a5._initChildren){a3=a5.children;
}a6=u.fn.remove.call(a3,a4);
if(a5&&!a3.data().length){a5.hasChildren=false;
}return a6;
},success:s("success"),data:s("data"),insert:function(a3,a4){var a5=this.parent();
if(a5&&a5._initChildren){a5.hasChildren=true;
a5._initChildren();
}return u.fn.insert.call(this,a3,a4);
},_find:function(a7,a9){var a5,a6,a8,a3;
var a4=this._data;
if(!a4){return;
}a8=u.fn[a7].call(this,a9);
if(a8){return a8;
}a4=this._flatData(this._data);
for(a5=0,a6=a4.length;
a5<a6;
a5++){a3=a4[a5].children;
if(!(a3 instanceof O)){continue;
}a8=a3[a7](a9);
if(a8){return a8;
}}},get:function(a3){return this._find("get",a3);
},getByUid:function(a3){return this._find("getByUid",a3);
}});
function T(be,a7){var bc=b(be).children(),a9,bd,a5=[],bf,bi=a7[0].field,bj=a7[1]&&a7[1].field,bg=a7[2]&&a7[2].field,ba=a7[3]&&a7[3].field,bb,a8,bh,a4,a3;
function a6(bk,bl){return bk.filter(bl).add(bk.find(bl));
}for(a9=0,bd=bc.length;
a9<bd;
a9++){bf={_loaded:true};
bb=bc.eq(a9);
bh=bb[0].firstChild;
a3=bb.children();
be=a3.filter("ul");
a3=a3.filter(":not(ul)");
a8=bb.attr("data-id");
if(a8){bf.id=a8;
}if(bh){bf[bi]=bh.nodeType==3?bh.nodeValue:a3.text();
}if(bj){bf[bj]=a6(a3,"a").attr("href");
}if(ba){bf[ba]=a6(a3,"img").attr("src");
}if(bg){a4=a6(a3,".k-sprite").prop("className");
bf[bg]=a4&&b.trim(a4.replace("k-sprite",""));
}if(be.length){bf.items=T(be.eq(0),a7);
}if(bb.attr("data-hasChildren")=="true"){bf.hasChildren=true;
}a5.push(bf);
}return a5;
}O.create=function(a7){a7=a7&&a7.push?{data:a7}:a7;
var a4=a7||{},a3=a4.data,a5=a4.fields,a6=a4.list;
if(a3&&a3._dataSource){return a3._dataSource;
}if(!a3&&a5&&!a4.transport){if(a6){a3=T(a6,a5);
}}a4.data=a3;
return a4 instanceof O?a4:new O(a4);
};
var e=ad.Observable.extend({init:function(a4,a6,a5){ad.Observable.fn.init.call(this);
this._prefetching=false;
this.dataSource=a4;
this.prefetch=!a5;
var a3=this;
a4.bind("change",function(){a3._change();
});
a4.bind("reset",function(){a3._reset();
});
this._syncWithDataSource();
this.setViewSize(a6);
},setViewSize:function(a3){this.viewSize=a3;
this._recalculate();
},at:function(a3){var a5=this.pageSize,a4=true;
if(a3>=this.total()){this.trigger("endreached",{index:a3});
return null;
}if(!this.useRanges){return this.dataSource.view()[a3];
}if(this.useRanges){if(a3<this.dataOffset||a3>=this.skip+a5){a4=this.range(Math.floor(a3/a5)*a5);
}if(a3===this.prefetchThreshold){this._prefetch();
}if(a3===this.midPageThreshold){this.range(this.nextMidRange,true);
}else{if(a3===this.nextPageThreshold){this.range(this.nextFullRange);
}else{if(a3===this.pullBackThreshold){if(this.offset===this.skip){this.range(this.previousMidRange);
}else{this.range(this.previousFullRange);
}}}}if(a4){return this.dataSource.at(a3-this.dataOffset);
}else{this.trigger("endreached",{index:a3});
return null;
}}},indexOf:function(a3){return this.dataSource.data().indexOf(a3)+this.dataOffset;
},total:function(){return parseInt(this.dataSource.total(),10);
},next:function(){var a3=this,a5=a3.pageSize,a4=a3.skip-a3.viewSize+a5,a6=ah.max(ah.floor(a4/a5),0)*a5;
this.offset=a4;
this.dataSource.prefetch(a6,a5,function(){a3._goToRange(a4,true);
});
},range:function(a6,a5){if(this.offset===a6){return true;
}var a3=this,a7=this.pageSize,a8=ah.max(ah.floor(a6/a7),0)*a7,a4=this.dataSource;
if(a5){a8+=a7;
}if(a4.inRange(a6,a7)){this.offset=a6;
this._recalculate();
this._goToRange(a6);
return true;
}else{if(this.prefetch){a4.prefetch(a8,a7,function(){a3.offset=a6;
a3._recalculate();
a3._goToRange(a6,true);
});
return false;
}}return true;
},syncDataSource:function(){var a3=this.offset;
this.offset=null;
this.range(a3);
},destroy:function(){this.unbind();
},_prefetch:function(){var a3=this,a5=this.pageSize,a6=this.skip+a5,a4=this.dataSource;
if(!a4.inRange(a6,a5)&&!this._prefetching&&this.prefetch){this._prefetching=true;
this.trigger("prefetching",{skip:a6,take:a5});
a4.prefetch(a6,a5,function(){a3._prefetching=false;
a3.trigger("prefetched",{skip:a6,take:a5});
});
}},_goToRange:function(a4,a3){if(this.offset!==a4){return;
}this.dataOffset=a4;
this._expanding=a3;
this.dataSource.range(a4,this.pageSize);
this.dataSource.enableRequestsInProgress();
},_reset:function(){this._syncPending=true;
},_change:function(){var a3=this.dataSource;
this.length=this.useRanges?a3.lastRange().end:a3.view().length;
if(this._syncPending){this._syncWithDataSource();
this._recalculate();
this._syncPending=false;
this.trigger("reset",{offset:this.offset});
}this.trigger("resize");
if(this._expanding){this.trigger("expand");
}delete this._expanding;
},_syncWithDataSource:function(){var a3=this.dataSource;
this._firstItemUid=a3.firstItemUid();
this.dataOffset=this.offset=a3.skip()||0;
this.pageSize=a3.pageSize();
this.useRanges=a3.options.serverPaging;
},_recalculate:function(){var a4=this.pageSize,a3=this.offset,a6=this.viewSize,a5=Math.ceil(a3/a4)*a4;
this.skip=a5;
this.midPageThreshold=a5+a4-1;
this.nextPageThreshold=a5+a6-1;
this.prefetchThreshold=a5+Math.floor(a4/3*2);
this.pullBackThreshold=this.offset-1;
this.nextMidRange=a5+a4-a6;
this.nextFullRange=a5;
this.previousMidRange=a3-a6;
this.previousFullRange=a5-a4;
}});
var d=ad.Observable.extend({init:function(a5,a4){var a3=this;
ad.Observable.fn.init.call(a3);
this.dataSource=a5;
this.batchSize=a4;
this._total=0;
this.buffer=new e(a5,a4*3);
this.buffer.bind({endreached:function(a6){a3.trigger("endreached",{index:a6.index});
},prefetching:function(a6){a3.trigger("prefetching",{skip:a6.skip,take:a6.take});
},prefetched:function(a6){a3.trigger("prefetched",{skip:a6.skip,take:a6.take});
},reset:function(){a3._total=0;
a3.trigger("reset");
},resize:function(){a3._total=Math.ceil(this.length/a3.batchSize);
a3.trigger("resize",{total:a3.total(),offset:this.offset});
}});
},syncDataSource:function(){this.buffer.syncDataSource();
},at:function(a5){var a3=this.buffer,a7=a5*this.batchSize,a8=this.batchSize,a9=[],a6;
if(a3.offset>a7){a3.at(a3.offset-1);
}for(var a4=0;
a4<a8;
a4++){a6=a3.at(a7+a4);
if(a6===null){break;
}a9.push(a6);
}return a9;
},total:function(){return this._total;
},destroy:function(){this.buffer.destroy();
this.unbind();
}});
D(true,ad.data,{readers:{json:t},Query:aD,DataSource:u,HierarchicalDataSource:O,Node:ak,ObservableObject:av,ObservableArray:au,LazyObservableArray:ae,LocalTransport:af,RemoteTransport:aF,Cache:f,DataReader:t,Model:aj,Buffer:e,BatchBuffer:d});
}(window.kendo.jQuery));
return window.kendo;
},typeof define=="function"&&define.amd?define:function(a,b,c){(c||b)();
}));
if(typeof(Sys)!=='undefined')Sys.Application.notifyScriptLoaded();