(function(b,a){a("kendo.tooltip",["kendo.core","kendo.popup"],b);
}(function(){var a={id:"tooltip",name:"Tooltip",category:"web",description:"The Tooltip widget displays a popup hint for a given html element.",depends:["core","popup"],features:[{id:"tooltip-fx",name:"Animation",description:"Support for animation",depends:["fx"]}]};
(function(b,F){var r=window.kendo,G=r.ui.Widget,t=r.ui.Popup,n=r.isFunction,p=b.isPlainObject,k=b.extend,v=b.proxy,i=b(document),o=r.isLocalUrl,c="_tt_active",f="aria-describedby",C="show",l="hide",j="error",d="contentLoad",w="requestStart",q="k-content-frame",D='<div role="tooltip" class="k-widget k-tooltip#if (!autoHide) {# k-tooltip-closable#}#">#if (!autoHide) {# <div class="k-tooltip-button"><a href="\\#" class="k-icon k-i-close" title="Close"></a></div> #}#<div class="k-tooltip-content"></div>#if (callout){ #<div class="k-callout k-callout-#=dir#"></div>#}#</div>',m=r.template("<iframe frameborder='0' class='"+q+"' src='#= content.url #'>This page requires frames in order to show content</iframe>"),s=".kendoTooltip",u={bottom:{origin:"bottom center",position:"top center"},top:{origin:"top center",position:"bottom center"},left:{origin:"center left",position:"center right",collision:"fit flip"},right:{origin:"center right",position:"center left",collision:"fit flip"},center:{position:"center center",origin:"center center"}},z={top:"bottom",bottom:"top",left:"right",right:"left",center:"center"},h={bottom:"n",top:"s",left:"e",right:"w",center:"n"},g={horizontal:{offset:"top",size:"outerHeight"},vertical:{offset:"left",size:"outerWidth"}},e=function(H){return H.target.data(r.ns+"title");
};
function x(H){while(H.length){y(H);
H=H.parent();
}}function y(H){var I=H.data(r.ns+"title");
if(I){H.attr("title",I);
H.removeData(r.ns+"title");
}}function A(H){var I=H.attr("title");
if(I){H.data(r.ns+"title",I);
H.attr("title","");
}}function B(H){while(H.length&&!H.is("body")){A(H);
H=H.parent();
}}var E=G.extend({init:function(I,J){var K=this,H;
G.fn.init.call(K,I,J);
H=K.options.position.match(/left|right/)?"horizontal":"vertical";
K.dimensions=g[H];
K._documentKeyDownHandler=v(K._documentKeyDown,K);
K.element.on(K.options.showOn+s,K.options.filter,v(K._showOn,K)).on("mouseenter"+s,K.options.filter,v(K._mouseenter,K));
if(this.options.autoHide){K.element.on("mouseleave"+s,K.options.filter,v(K._mouseleave,K));
}},options:{name:"Tooltip",filter:"",content:e,showAfter:100,callout:true,position:"bottom",showOn:"mouseenter",autoHide:true,width:null,height:null,animation:{open:{effects:"fade:in",duration:0},close:{effects:"fade:out",duration:40,hide:true}}},events:[C,l,d,j,w],_mouseenter:function(H){B(b(H.currentTarget));
},_showOn:function(I){var J=this;
var H=b(I.currentTarget);
if(J.options.showOn&&J.options.showOn.match(/click|focus/)){J._show(H);
}else{clearTimeout(J.timeout);
J.timeout=setTimeout(function(){J._show(H);
},J.options.showAfter);
}},_appendContent:function(L){var M=this,H=M.options.content,I=M.content,K=M.options.iframe,J;
if(p(H)&&H.url){if(!("iframe" in M.options)){K=!o(H.url);
}M.trigger(w,{options:H,target:L});
if(!K){I.empty();
r.ui.progress(I,true);
M._ajaxRequest(H);
}else{I.hide();
J=I.find("."+q)[0];
if(J){J.src=H.url||J.src;
}else{I.html(m({content:H}));
}I.find("."+q).off("load"+s).on("load"+s,function(){M.trigger(d);
I.show();
});
}}else{if(H&&n(H)){H=H({sender:this,target:L});
I.html(H||"");
}else{I.html(H);
}}M.angular("compile",function(){return{elements:I};
});
},_ajaxRequest:function(H){var I=this;
jQuery.ajax(k({type:"GET",dataType:"html",cache:false,error:function(K,J){r.ui.progress(I.content,false);
I.trigger(j,{status:J,xhr:K});
},success:v(function(J){r.ui.progress(I.content,false);
I.content.html(J);
I.trigger(d);
},I)},H));
},_documentKeyDown:function(H){if(H.keyCode===r.keys.ESC){this.hide();
}},refresh:function(){var I=this,H=I.popup;
if(H&&H.options.anchor){I._appendContent(H.options.anchor);
}},hide:function(){if(this.popup){this.popup.close();
}},show:function(H){H=H||this.element;
B(H);
this._show(H);
},_show:function(I){var J=this,H=J.target();
if(!J.popup){J._initPopup();
}if(H&&H[0]!=I[0]){J.popup.close();
J.popup.element.kendoStop(true,true);
}if(!H||H[0]!=I[0]){J._appendContent(I);
J.popup.options.anchor=I;
}J.popup.one("deactivate",function(){x(I);
I.removeAttr(f);
this.element.removeAttr("id").attr("aria-hidden",true);
i.off("keydown"+s,J._documentKeyDownHandler);
});
J.popup.open();
},_initPopup:function(){var I=this,H=I.options,J=b(r.template(D)({callout:H.callout&&H.position!=="center",dir:h[H.position],autoHide:H.autoHide}));
I.popup=new t(J,k({activate:function(){var K=this.options.anchor,L=K[0].id||I.element[0].id;
if(L){K.attr(f,L+c);
this.element.attr("id",L+c);
}if(H.callout){I._positionCallout();
}this.element.removeAttr("aria-hidden");
i.on("keydown"+s,I._documentKeyDownHandler);
I.trigger(C);
},close:function(){I.trigger(l);
},copyAnchorStyles:false,animation:H.animation},u[H.position]));
J.css({width:H.width,height:H.height});
I.content=J.find(".k-tooltip-content");
I.arrow=J.find(".k-callout");
if(H.autoHide){J.on("mouseleave"+s,v(I._mouseleave,I));
}else{J.on("click"+s,".k-tooltip-button",v(I._closeButtonClick,I));
}},_closeButtonClick:function(H){H.preventDefault();
this.hide();
},_mouseleave:function(H){if(this.popup){var I=b(H.currentTarget),J=I.offset(),K=H.pageX,L=H.pageY;
J.right=J.left+r._outerWidth(I);
J.bottom=J.top+r._outerHeight(I);
if(K>J.left&&K<J.right&&L>J.top&&L<J.bottom){return;
}this.popup.close();
}else{x(b(H.currentTarget));
}clearTimeout(this.timeout);
},_positionCallout:function(){var R=this,Q=R.options.position,L=R.dimensions,N=L.offset,P=R.popup,H=P.options.anchor,I=b(H).offset(),J=parseInt(R.arrow.css("border-top-width"),10),M=b(P.element).offset(),K=h[P.flipped?z[Q]:Q],O=I[N]-M[N]+b(H)[L.size]()/2-J;
R.arrow.removeClass("k-callout-n k-callout-s k-callout-w k-callout-e").addClass("k-callout-"+K).css(N,O);
},target:function(){if(this.popup){return this.popup.options.anchor;
}return null;
},destroy:function(){var H=this.popup;
if(H){H.element.off(s);
H.destroy();
}clearTimeout(this.timeout);
this.element.off(s);
i.off("keydown"+s,this._documentKeyDownHandler);
G.fn.destroy.call(this);
}});
r.ui.plugin(E);
}(window.kendo.jQuery));
return window.kendo;
},typeof define=="function"&&define.amd?define:function(a,b,c){(c||b)();
}));
if(typeof(Sys)!=='undefined')Sys.Application.notifyScriptLoaded();