Type.registerNamespace("Telerik.Web.UI.Dock");
(function(a,b,l){var h=window;
var i=h.parseInt;
var k=["Transform","webkitTransform","OTransform","MozTransform","msTransform"];
var c=["BackfaceVisibility","webkitBackfaceVisibility","OBackfaceVisibility","MozBackfaceVisibility","msBackfaceVisibility"];
var d=Telerik.Web.Browser;
var f=".";
var j=" ";
var e="class";
var g="";
a.registerEnum(b,"DockMode",{Floating:1,Docked:2,Default:3});
$telerik.toDock=function(m){return m;
};
$telerik.findDock=$find;
Telerik.Web.UI.RadDock=function(m){Telerik.Web.UI.RadDock.initializeBase(this,[m]);
this._initialized=false;
this._enableDrag=true;
this._top=0;
this._left=0;
this._dockZoneID=null;
this._title=null;
this._commands=null;
this._closed=false;
this._collapsed=false;
this._pinned=false;
this._handle=null;
this._resizable=false;
this._width="300px";
this._height=null;
this._expandedHeight=0;
this._handle=null;
this._form=null;
this._isDragged=false;
this._accessKey="";
this._tabIndex=0;
this._draggedCssClass="rdDragHelper";
this._dropDownTouchScroll=null;
this.set_handle=this.set_handle;
this._isCustomHandle=false;
this._draggableWidget=null;
this._resizableWidget=null;
};
Telerik.Web.UI.RadDock.DragDataType="RadDock";
Telerik.Web.UI.RadDock.prototype={_isDockRightToLeft:function(){var m=this._isRightToLeft;
if(m==null){var n=this.get_element();
if(n){m=this._isRightToLeft=$telerik.isRightToLeft(n);
}}return m;
},_setResizeLimit:function(){var t=this.get_dockZoneID(),o=null,n=null,q=this._renderingView.get_minWidth(),p=this._renderingView.get_minHeight();
if(t){var r=$find(t);
var s=r.get_element();
var m=this._getBounds();
if(r.get_isHorizontal()){o=m.width+this._caluclateZoneFreeSpace(r).width;
n=s.offsetHeight;
}else{n=m.height+this._caluclateZoneFreeSpace(r).height;
o=s.offsetWidth;
}}this._resizableWidget.set_constraints({minWidth:this._renderingView.get_minWidth(),minHeight:this._renderingView.get_minHeight(),maxWidth:o?Math.max(q,o):null,maxHeight:n?Math.max(this.get_height()?this._element.offsetHeight:p,n):null});
},_updateSizeValues:function(){var m=this._getBounds();
this._width=m.width;
this._height=m.height;
},_moveElements:function(n,o){while(n.childNodes&&n.childNodes.length>0){var m=n.childNodes[0];
n.removeChild(m);
o.appendChild(m);
}},_initResizableWidget:function(){if(this._resizableWidget&&this._resizableWidget.dispose){this._resizableWidget.dispose();
}if(!this._resizable){return;
}if(d.webkit){this._kickStartCssTransform();
}this._resizableWidget=new Telerik.Web.UI.Widgets.Resizable(this._element,{handles:this._getAvailableHandles(),appendHandleToElement:true});
if(this._renderingView){this._setResizeLimit();
}if(this._collapsed){this._resizableWidget.hideHandles();
}this._resizableWidget.add_resizeStart(a.proxy(this._resizeStartHandler,this));
this._resizableWidget.add_resizing(a.proxy(this._resizingHandler,this));
this._resizableWidget.add_resizeEnd(a.proxy(this._resizeEndHandler,this));
},_getAvailableHandles:function(){var m;
var o=this.get_dockZoneID();
if(o){var n=$find(o);
m=n.get_isHorizontal()?[{direction:this._isDockRightToLeft()?"W":"E",element:null}]:[{direction:"S",element:null}];
}return m;
},_resizeStartHandler:function(n,m){if(this._collapsed){m.set_cancel(true);
}this.resizeHelper={width:this.get_width(),height:this.get_height()||this._element.clientHeight,offset:{top:this.get_top(),left:this.get_left()}};
this.raise_resizeStart(new Sys.EventArgs());
},_resizingHandler:function(p,m){var n=m.get_direction(),o=1,q=1;
if(n.indexOf("W")>-1){q=-1;
this.set_left(i(this.resizeHelper.offset.left,10)+m.get_delta().x);
}if(n.indexOf("N")>-1){o=-1;
this.set_top(i(this.resizeHelper.offset.top,10)+m.get_delta().y);
}if(n.indexOf("W")>-1||n.indexOf("E")>-1){this.set_width(i(this.resizeHelper.width,10)+q*m.get_delta().x);
}if(n.indexOf("N")>-1||n.indexOf("S")>-1){this.set_height(i(this.resizeHelper.height,10)+o*m.get_delta().y);
}},_resizeEndHandler:function(n,m){this.raise_resizeEnd(new Sys.EventArgs());
var p=this.get_dockZoneID();
if(p){var o=$find(p);
o._resetDocksResizeHandles();
}},_makeResizable:function(){this._enableMoveResize();
},_caluclateZoneFreeSpace:function(o){var q=$telerik.getContentSize(o.get_element());
var n=o.get_isHorizontal()?this._getDocksFromCurrentRow(o):o.get_docks();
for(var p=0;
p<n.length;
p++){var m=n[p]._getBounds();
q.height-=m.height;
q.width-=m.width;
}return q;
},_getDocksFromCurrentRow:function(o){var q=[],n=o.get_docks(),m=this._getLocation().y;
for(var p=0;
p<n.length;
p++){if(n[p]._getLocation().y==m){q.push(n[p]);
}}return q;
},_initializeDrag:function(){if(this._handle){this._disposeDrag();
if(this.get_enableDrag()&&!this.get_pinned()){if(this._draggableWidget&&this._draggableWidget.dispose){this._draggableWidget.dispose();
}this._draggableWidget=new Telerik.Web.UI.Widgets.Draggable(this._element,{handle:this._handle,shouldPreventDefault:false,validateNestedElementsAsTriggers:true});
this._draggableWidget.add_dragStarting(a.proxy(this._dragStartHandler,this));
this._draggableWidget.add_dragging(a.proxy(this._draggingHandler,this));
this._draggableWidget.add_dragEnd(a.proxy(this._dragEndHandler,this));
}}},_draggingHandler:function(n,m){this._hitZone=this.dockingZoneHitTest(m._domEvent);
this.raise_drag(new Sys.EventArgs());
$telerik.cancelRawEvent(m.get_domEvent());
},_dragStartHandler:function(o,m){if(!this.get_enableDrag()||this.get_pinned()){return false;
}this.set_isDragged(true);
var n=new Sys.CancelEventArgs();
n.ownerEvent=m.get_domEvent();
this.raiseEvent("dragStart",n);
m.set_cancel(n.get_cancel());
if(n.get_cancel()){return false;
}this._renderingView.get_contentContainer().style.overflow="hidden";
this.addCssClass(this._draggedCssClass);
this._startDragDrop();
},_dragEndHandler:function(n,m){var o=this._hitZone;
if(!o){o=this._hitZone=this.dockingZoneHitTest(m._domEvent);
}if(o){if(o.canDrop(this)){o.drop(this);
this._hideZonesPlaceholders();
}else{this._restorePosition();
}}else{if(this.canDrop()){this.drop();
}else{this._restorePosition();
}}this._renderingView.get_contentContainer().style.overflow="auto";
this.removeCssClass(this._draggedCssClass);
if(this._resizableWidget){this._resizableWidget.repaint();
}this.raise_dragEnd(new Sys.EventArgs());
},_disposeDrag:function(){if(this._handle&&this._draggableWidget){this._draggableWidget.dispose();
this._draggableWidget=null;
}},_startDragDrop:function(){var o=this.get_element();
this.originalZIndex=o.style.zIndex;
var m=this._getBounds(o);
var n=this._getBorderBox(o);
m.width-=n.horizontal;
m.height-=n.vertical;
o.style.width=m.width+"px";
o.style.zIndex="9999999";
var p=this._getLocation(o);
if(o.parentNode!=this._form){this._form.appendChild(o);
}var q=$find(this.get_dockZoneID());
if(q){q._showPlaceholder(this,p);
}this._setLocation(p);
},get_isDragged:function(){return this._isDragged;
},set_isDragged:function(m){this._isDragged=m;
},get_dockZones:function(){if(typeof(Telerik.Web.UI.RadDockZonesGlobalArray)=="undefined"){return[];
}return Telerik.Web.UI.RadDockZonesGlobalArray;
},_hideZonesPlaceholders:function(){Array.forEach(this.get_dockZones(),function(m){m.hidePlaceholder();
});
},dockingZoneHitTest:function(p){var s=null,u;
var o=this.get_dockZones();
var n=this.get_element();
var r=[];
var q=[];
for(u=0;
u<o.length;
u++){if(o[u].hitTest(this,p,false)){r[r.length]=o[u].get_element();
q[q.length]=o[u];
}}if(r.length>0){if(r.length==1){s=$find(r[0].id);
}else{if(r.length>1){n.style.display="none";
var t=document.elementFromPoint(p.clientX,p.clientY);
n.style.display="";
if(t){var m=document.body;
while(t!=m){for(u=0;
u<r.length;
u++){if(t==r[u]){if(t.id){s=$find(t.id);
}break;
}}if(s!=null){break;
}t=t.parentNode;
}}}}if(s){s.hitTest(this,p,true);
}}return s;
},canDrop:function(){return this.get_dockMode()!=Telerik.Web.UI.DockMode.Docked;
},drop:function(){var m=new Sys.CancelEventArgs();
this.raise_dockPositionChanging(m);
this.get_element().style.zIndex=this.originalZIndex;
if(m.get_cancel()){this._restorePosition();
}else{if(this.get_dockZoneID()){this.get_dockZone()._resetDocksResizeHandles();
}this.undock();
if(this._resizable){this._initResizableWidget();
this._setResizeLimit();
}this.raise_dockPositionChanged(new Sys.EventArgs());
}},clone:function(w){var s=this;
var t=s.get_handle();
var m;
var u=a(t).attr(e);
if(!w){w="RadDockClone_"+(new Date()-100);
}this._setHandle(null);
var A=this._grip==t?"_G":"_H";
var B=false;
if(t&&!t.id){t.id=this.get_id()+A;
B=true;
}var q=this.get_commands();
for(var x in q){q[x].detachCommandHandlers();
}var y=this._renderingView.clone(w);
this._removeClonedHandles(y);
var z=$telerik.cloneControl(this,Telerik.Web.UI.RadDock,y);
this._setHandle(t);
if(t&&(t.className.indexOf("rdTitleBar")==-1)){if(u){m=a.map(u.split(j),function(D,C){return(f+D);
}).join(g);
z.set_handle(a(y).find(m)[0]);
}if(B){t.removeAttribute("id");
}}var r=z.get_commandsContainer();
if(r){var p=z.get_commandsContainer().getElementsByTagName("a");
for(var v=0;
v<p.length;
v++){var o=p[v];
o.removeAttribute("control");
}}if(this._originalCommandsObject){z.set_commands(Array.clone(this._originalCommandsObject));
}z._initializeCommands();
for(var n in q){q[n].attachCommandHandlers();
}z.set_uniqueID(w);
if(z.get_dockZone()){z.get_dockZone()._resetDockIndices();
}return z;
},_removeClonedHandles:function(m){a(m).find(".rrHandle").remove();
},getCommand:function(m){return this._commands?this._commands[m]:null;
},get_handle:function(){return this._handle;
},set_handle:function(m){this._isCustomHandle=true;
this._setHandle(m);
},_setHandle:function(m){this._disposeDrag();
this._handle=m;
this._initializeDrag();
},subtractPoints:function(m,n){return{x:m.x-n.x,y:m.y-n.y};
},addPoints:function(m,n){return{x:m.x+n.x,y:m.y+n.y};
},_getRenderingView:function(){if(this._renderMode==Telerik.Web.UI.RenderMode.Classic){return new Telerik.Web.UI.Dock.ClassicView(this);
}else{if(this._renderMode==Telerik.Web.UI.RenderMode.Lite){return new Telerik.Web.UI.Dock.LightweightView(this);
}else{throw Error("RadDock with ID: "+this.get_id()+" has not defined RenderMode");
}}},initialize:function(){Telerik.Web.UI.RadDock.callBaseMethod(this,"initialize");
this._renderingView=this._getRenderingView();
if(this._isDockRightToLeft()){var m=this.get_element();
Sys.UI.DomElement.addCssClass(m,"rdRtl");
Sys.UI.DomElement.addCssClass(m,"RadDock_"+this.get_skin()+"_rtl");
}if(!$telerik.isTouchDevice){this._resetCSS3Rules();
}this._renderingView.initialize();
this._initializeCommands();
this._updateToggleCommandsState();
this._setPinUnpinVisibility();
var q=this.get_element();
var o=q.parentNode;
var p=$telerik.getInvisibleParent(this.get_element().parentNode);
var n=(p!=null);
if(n&&!this.get_dockZoneID()){var r={position:q.style.position,top:q.style.top,left:q.style.left};
q.parentNode.removeChild(q);
q.style.position="absolute";
q.style.top="-5000px";
q.style.left="-5000px";
document.body.appendChild(q);
q.style.position=r.position;
q.style.top=r.top;
q.style.left=r.left;
o.appendChild(q);
}if(Telerik.Web.UI.TouchScrollExtender._getNeedsScrollExtender()&&!this._dropDownTouchScroll){this._createTouchScrollExtender(true);
}if(!n&&this.get_dockZoneID()==""){var s=window.theForm;
o.removeChild(q);
s.appendChild(q);
}q.style.visibility="";
this._registerShortcuts();
this._initResizableWidget();
this.updateClientState();
this.raise_initialize();
this.raise_load();
this.add_dockPositionChanged(Function.createDelegate(this,function(){this.conditionalPostback("dockPositionChanged");
}));
},dispose:function(){this._createTouchScrollExtender(false);
this._renderingView.dispose();
Telerik.Web.UI.RadDock.callBaseMethod(this,"dispose");
},_resetCSS3Rules:function(){this._setCss3Rules("none","visible");
},_kickStartCssTransform:function(){this._setCss3Rules("","visible");
},_setCss3Rules:function(o,m){var n=this._element.style;
Array.forEach(k,function(p){n[p]=o;
});
Array.forEach(c,function(p){n[p]=m;
});
},_createTouchScrollExtender:function(o){var m=$get(this.get_id()+"_C");
if(m){var n=this._dropDownTouchScroll;
if(n){if(!o){n.dispose();
this._dropDownTouchScroll=null;
}}else{if(o){this._dropDownTouchScroll=new Telerik.Web.UI.TouchScrollExtender(m);
this._dropDownTouchScroll.initialize();
}}}},undock:function(){var m=this.get_element();
if(m.parentNode!=this._form){this._form.appendChild(m);
m.style.position="absolute";
}var n=this._getLocation(m);
this.set_left(n.x);
this.set_top(n.y);
var o=$find(this.get_dockZoneID());
if(o){this.set_dockZoneID("");
o._resetDockIndices();
this._unfitWidth();
}this._setPinUnpinVisibility();
this.updateClientState();
},_fitWidth:function(){this._renderingView.fitWidth();
},_unfitWidth:function(){this._renderingView.unfitWidth();
},_initializeCommands:function(){if(!this.get_commandsContainer()){this._commands={};
return;
}var p=this._renderingView.getCommandsElements();
var r=this._commands;
if(r){this._commands={};
for(var s=0;
s<r.length;
s++){var o=r[s];
var m=eval(o.clientTypeName);
if(m==Telerik.Web.UI.DockCommand||m.inheritsFrom(Telerik.Web.UI.DockCommand)){o.radDock=this;
var q=null;
if(o.command){q={command:eval(o.command)};
delete o.command;
}var n=$create(m,o,q,null,p[s]);
this._commands[n.get_name()]=n;
}else{throw Error.invalidOperation(o.clientTypeName+" does not inherit from Telerik.Web.UI.DockCommand.");
}}}},_updateToggleCommandsState:function(){var m=this.getCommand("ExpandCollapse");
if(m){m.set_state(this.get_collapsed()?2:1);
}var n=this.getCommand("PinUnpin");
if(n){n.set_state(this.get_pinned()?2:1);
}},_setPinUnpinVisibility:function(){var m=this.getCommand("PinUnpin");
if(m){m.get_element().style.display=this.get_dockZoneID()?"none":"";
}},_getBounds:function(m){if(!m){m=this.get_element();
}return $telerik.getBounds(m);
},_getMarginBox:function(m){if(!m){m=this.get_element();
}return $telerik.getMarginBox(m);
},_getBorderBox:function(m){if(!m){m=this.get_element();
}return $telerik.getBorderBox(m);
},_resetPosition:function(){var m=this.get_element();
m.style.top="";
m.style.left="";
m.style.position="";
if(typeof(this.originalZIndex)=="undefined"){this.originalZIndex="";
}m.style.zIndex=this.originalZIndex;
},_restorePosition:function(){var m=$find(this.get_dockZoneID());
if(m){m.dock(this,this.get_index());
}else{this.undock();
}},_getLocation:function(m){if(!m){m=this.get_element();
}return $telerik.getLocation(m);
},_setLocation:function(m){$telerik.setLocation(this.get_element(),m);
},_setSize:function(o,n){var m=this._getBounds();
this._setHeight(n);
if(!o){o=m.width;
}this._setWidthHtmlEl(o);
},get_contentContainer:function(){this._ensureRenderingView();
return this._renderingView.get_contentContainer();
},get_titleBar:function(){this._ensureRenderingView();
return this._renderingView.get_titleBar();
},get_commandsContainer:function(){this._ensureRenderingView();
return this._renderingView.get_commandsContainer();
},get_titleElement:function(){this._ensureRenderingView();
return this._renderingView.get_titleElement();
},_ensureRenderingView:function(){if(!this._renderingView){this._renderingView=this._getRenderingView();
this._renderingView.initialize();
}},executeCommand:function(n){var m=this.getCommand(n);
if(!m){return false;
}if(b.DockToggleCommand.isInstanceOfType(m)){m.set_state(m.get_state()==1?2:1);
}m.onCommand();
return true;
},addShortCut:function(m,n){if(this._shortCutManager){this._shortCutManager.addShortCut(m,n);
}},removeShortCut:function(m){if(this._shortCutManager){this._shortCutManager.removeShortCut(m);
}},setShortCut:function(m,n){if(this._shortCutManager){this._shortCutManager.setShortCut(m,n);
}},_getDefaultShortCuts:function(){var m=[["Close","ESC"],["PinUnpin","Ctrl+F12"],["ExpandCollapse","Ctrl+F11"]];
return m;
},_registerShortcuts:function(n){this._attachShortcutHandlers(n!==false);
if(!this._shortCutManager){this._shortCutManager=new b.ShortCutManager(this._getDefaultShortCuts());
this._shortCutManager.addShortCuts(this.get_shortcuts());
}var m=this.get_element();
m.setAttribute("tabIndex",this._tabIndex.toString());
if(this._accessKey){m.setAttribute("accessKey",this._accessKey);
}},_attachShortcutHandlers:function(m){if(m){this._keyDownDelegate=Function.createDelegate(this,this._keyDown);
$addHandler(this.get_element(),"keydown",this._keyDownDelegate);
}else{$removeHandler(this.get_element(),"keydown",this._keyDownDelegate);
this._keyDownDelegate=null;
}},_keyDown:function(n){var p=this._shortCutManager.isShortCutHit(n.rawEvent);
if(!p){return;
}var m=p.get_name();
var o=new b.Dock.ShortCutCancelEventArgs(n.rawEvent,p);
this.raiseEvent("shortCutHit",o);
if(!o.get_cancel()&&this.executeCommand(m)){return $telerik.cancelRawEvent(n.rawEvent);
}},saveClientState:function(){var m=this;
var n={Top:m.get_top(),Left:m.get_left(),DockZoneID:this.get_dockZoneID(),Collapsed:this.get_collapsed(),Pinned:this.get_pinned(),Resizable:this.get_resizable(),Closed:this.get_closed(),Width:m.get_width(),Height:m.get_height(),ExpandedHeight:m._expandedHeight,Index:this.get_index(),IsDragged:this.get_isDragged()};
return Sys.Serialization.JavaScriptSerializer.serialize(n);
},conditionalPostback:function(m){if(this.get_autoPostBack()){this.doPostBack(m);
}},doPostBack:function(m){__doPostBack(this.get_uniqueID(),m);
},get_top:function(){return this._top;
},set_top:function(m){if(m!=""){m=i(m,10);
if(this._initialized){this.get_element().style.top=m+"px";
}}this._top=m;
this.updateClientState();
},get_left:function(){return this._left;
},set_left:function(m){if(m!=""){m=i(m,10);
if(this._initialized){this.get_element().style.left=m+"px";
}}this._left=m;
this.updateClientState();
},_onCloseAnimationEnd:function(){var n=this.get_element();
var m=this.getCommand("Close");
var o=this.get_titleElement();
if(o!=null){o.style.display="block";
}if(this._resizable){if(this.get_dockZoneID()){this.get_dockZone()._resetDocksResizeHandles();
}if(this._closed){this._resizableWidget.hideHandles();
}else{this._resizableWidget.showHandles();
}}if(this._closed){n.style.display="none";
if(this._resizable){if(this.get_dockZoneID()){this.get_dockZone()._resetDocksResizeHandles();
}this._resizableWidget.hideHandles();
}this.updateClientState();
if(m){Telerik.Web.UI.DockCloseCommand.callBaseMethod(m,"onCommand");
}}else{n.style.display="block";
this._renderingView.repaint();
if(!this._collapsed){this.set_height(this.get_height());
}$telerik.repaintChildren(this);
if(this._resizable){if(this.get_dockZoneID()){this.get_dockZone()._resetDocksResizeHandles();
}this._resizableWidget.hideHandles();
}this.updateClientState();
if(m){Telerik.Web.UI.DockCloseCommand.callBaseMethod(m,"onCommand");
}}},get_visible:function(){return !this.get_closed();
},set_visible:function(m){this.set_closed(!m);
},get_closed:function(){return this._closed;
},set_closed:function(r,q){if(!this._initialized){return;
}this._closed=r;
q=q?q:false;
var n=this.get_enableAnimation()?this.get_animationDuration():0;
var o=this.get_element();
if(!q||n==0){o.style.opacity=1;
this._onCloseAnimationEnd();
return;
}var m=Function.createDelegate(this,this._onCloseAnimationEnd);
var p=this.get_titleElement();
if(p!=null){p.style.display="none";
}if(r){$telerik.stopTransition(o,false,true);
$telerik.transition(o,{opacity:0},n,"easeIn",m);
}else{$telerik.stopTransition(o,false,true);
$telerik.transition(o,{opacity:1},n,"easeIn",m);
}},get_collapsed:function(){return this._collapsed;
},set_collapsed:function(n,m){m=m?m:false;
if(this._resizable&&this._resizableWidget){if(n){this._resizableWidget.hideHandles();
}else{this._resizableWidget.showHandles();
}}this._collapsed=n;
this.updateClientState();
if(this._initialized&&this._renderingView){this._renderingView.collapse(n,m);
}},get_commands:function(){return this._commands;
},set_commands:function(m){this._commands=m;
this._originalCommandsObject=m;
},get_dockZoneID:function(){return this._dockZoneID;
},set_dockZoneID:function(m){this._dockZoneID=m;
},get_height:function(){return this._height;
},set_height:function(m){this._height=m;
this.updateClientState();
if(this._initialized){this._renderingView.set_height(m);
}},get_enableDrag:function(){return this._enableDrag;
},set_enableDrag:function(m){this._enableDrag=m;
this._initializeDrag();
},get_pinned:function(){return this._pinned;
},set_pinned:function(n){if(this.get_dockZoneID()){return;
}this._pinned=n;
var m=this.getCommand("PinUnpin");
if(m){m.set_state(n?2:1);
}if(this._renderingView&&this._initialized){this._renderingView.pin(n);
}},get_title:function(){return this._title;
},set_title:function(m){this._title=m;
if(this._renderingView){this._renderingView.set_title(m);
}},set_visibleTitlebar:function(n){if(n==null){n=true;
}var m=this._topBar;
if(n){this.get_titleBar().style.display="";
Sys.UI.DomElement.removeCssClass(m,"rdNone");
}else{Sys.UI.DomElement.addCssClass(m,"rdNone");
this.get_titleBar().style.display="none";
}},get_width:function(){return this._width;
},set_width:function(m){this._width=m;
this.updateClientState();
if(this._initialized&&this._renderingView){this._renderingView.set_width(m);
}},get_resizable:function(){return this._resizable;
},set_resizable:function(m){this._resizable=m;
this._initResizableWidget();
},get_rippleZonesConfiguration:function(){return[{element:this.get_commandsContainer(),initializeRipples:true,rippleConfigurations:[{containerSelector:".rdCommandButton",rippleType:b.MaterialRippleType.Icon,iconRippleSizeFactor:0.54}]}];
},get_renderMode:function(){return this._renderMode;
},set_renderMode:function(m){this._renderMode=m;
}};
$telerik.$.registerControlProperties(Telerik.Web.UI.RadDock,{allowedZones:[],animationDuration:300,autoPostBack:false,dockMode:Telerik.Web.UI.DockMode.Default,dockZone:null,enableAnimation:false,forbiddenZones:[],index:0,layoutID:null,skin:"Default",tag:"",uniqueID:null,uniqueName:null,shortcuts:[]});
$telerik.$.extend({registerControlEventsDock:function(m,n){$telerik.$.registerControlEvents(m,n);
$telerik.$.each(n,function(p,o){m.prototype["raise_"+o]=function(q){this.raiseEvent(o,q);
};
});
}});
$telerik.$.registerControlEventsDock(Telerik.Web.UI.RadDock,["command","dockPositionChanged","dockPositionChanging","drag","dragEnd","dragStart","enterZone","initialize","leaveZone","resizeEnd","resizeStart","load"]);
Telerik.Web.UI.RadDock.registerClass("Telerik.Web.UI.RadDock",Telerik.Web.UI.RadWebControl);
Telerik.Web.UI.RadDock.prototype.repaint=function(){this._renderingView.repaint();
if(this._resizableWidget){this._resizableWidget.repaint();
}};
Telerik.Web.UI.Dock.ShortCutCancelEventArgs=function(m,n){b.Dock.ShortCutCancelEventArgs.initializeBase(this);
this._domEvent=m;
this._shortCut=n;
};
Telerik.Web.UI.Dock.ShortCutCancelEventArgs.prototype={get_shortCut:function(){return this._shortCut;
},get_domEvent:function(){return this._domEvent;
}};
Telerik.Web.UI.Dock.ShortCutCancelEventArgs.registerClass("Telerik.Web.UI.Dock.ShortCutCancelEventArgs",Sys.CancelEventArgs);
Telerik.Web.UI.DockCommand=function(m){Telerik.Web.UI.DockCommand.initializeBase(this,[m]);
};
Telerik.Web.UI.DockCommand.prototype={add_command:function(m){this.get_events().addHandler("command",m);
},remove_command:function(m){this.get_events().removeHandler("command",m);
},raise_command:function(m){var n=this.get_events().getHandler("command");
if(n){n(this.get_radDock(),m);
}},onCommand:function(n){var m=new Sys.CancelEventArgs();
m.command=this;
m.event=n;
m.Command=this;
this.raise_command(m);
if(m.get_cancel()){return;
}this.get_radDock().raise_command(m);
if(m.get_cancel()){return;
}this.get_radDock().updateClientState();
this.conditionalPostback();
},onMouseDown:function(m){return $telerik.cancelRawEvent(m.rawEvent);
},_stopPropagation:function(m){m.stopPropagation();
},conditionalPostback:function(){if(this.get_autoPostBack()){this.get_radDock().doPostBack(this.get_name());
}},initialize:function(){Telerik.Web.UI.DockCommand.callBaseMethod(this,"initialize");
this.attachCommandHandlers();
},dispose:function(){this.detachCommandHandlers();
Telerik.Web.UI.DockCommand.callBaseMethod(this,"dispose");
},attachCommandHandlers:function(){var m=this.get_element();
var n=this._touchStartEvent=this._getSupportedTouchEvent();
$addHandlers(m,{click:this.onCommand,mousedown:this.onMouseDown},this);
if(n){a(m).on(n,this._stopPropagation);
}},detachCommandHandlers:function(){var m=this.get_element();
$clearHandlers(m);
if(this._touchStartEvent){a(m).off(this._touchStartEvent,this._stopPropagation);
}},_getSupportedTouchEvent:function(){var m=window;
return"ontouchstart" in m?"touchstart":"PointerEvent" in m?"pointerdown":"MSPointerEvent" in m?"MSPointerDown":l;
}};
$telerik.$.registerControlProperties(Telerik.Web.UI.DockCommand,{autoPostBack:false,clientTypeName:null,cssClass:"rdCustom",name:"Custom",radDock:null,shortCut:"",text:"Custom"});
Telerik.Web.UI.DockCommand.registerClass("Telerik.Web.UI.DockCommand",Sys.UI.Control);
Telerik.Web.UI.DockToggleCommand=function(m){Telerik.Web.UI.DockToggleCommand.initializeBase(this,[m]);
this._state=1;
this._alternateCssClass="rdCustom";
this._alternateText="Custom";
this._initialSetState=false;
};
Telerik.Web.UI.DockToggleCommand.prototype={updateState:function(){var m=this.get_element();
var n=this.get_radDock()._renderMode==Telerik.Web.UI.RenderMode.Classic?m.getElementsByTagName("span")[0]:m;
if(this.get_state()==1){m.title=this.get_text();
Sys.UI.DomElement.addCssClass(n,this.get_cssClass());
Sys.UI.DomElement.removeCssClass(n,this.get_alternateCssClass());
}else{m.title=this.get_alternateText();
Sys.UI.DomElement.addCssClass(n,this.get_alternateCssClass());
Sys.UI.DomElement.removeCssClass(n,this.get_cssClass());
}},get_state:function(){return this._state;
},set_state:function(m){this._state=m;
if(this._initialSetState){this.updateState();
}},get_alternateCssClass:function(){return this._alternateCssClass;
},set_alternateCssClass:function(m){this._alternateCssClass=m;
},get_alternateText:function(){return this._alternateText;
},set_alternateText:function(m){this._alternateText=m;
},initialize:function(){Telerik.Web.UI.DockToggleCommand.callBaseMethod(this,"initialize");
this._initialSetState=true;
this.updateState();
},dispose:function(){b.DockToggleCommand.callBaseMethod(this,"dispose");
}};
b.DockToggleCommand.registerClass("Telerik.Web.UI.DockToggleCommand",Telerik.Web.UI.DockCommand);
b.DockCloseCommand=function(m){Telerik.Web.UI.DockCloseCommand.initializeBase(this,[m]);
this._cssClass="rdClose";
this._name="Close";
this._text="Close";
};
b.DockCloseCommand.prototype={onCommand:function(m){this.get_radDock().set_closed(true,true);
}};
b.DockCloseCommand.registerClass("Telerik.Web.UI.DockCloseCommand",Telerik.Web.UI.DockCommand);
b.DockExpandCollapseCommand=function(m){b.DockExpandCollapseCommand.initializeBase(this,[m]);
this._cssClass="rdCollapse";
this._alternateCssClass="rdExpand";
this._name="ExpandCollapse";
this._text="Collapse";
this._alternateText="Expand";
};
b.DockExpandCollapseCommand.prototype={onCommand:function(m){this.get_radDock().set_collapsed(!this.get_radDock().get_collapsed(),true);
}};
b.DockExpandCollapseCommand.registerClass("Telerik.Web.UI.DockExpandCollapseCommand",Telerik.Web.UI.DockToggleCommand);
b.DockPinUnpinCommand=function(m){Telerik.Web.UI.DockPinUnpinCommand.initializeBase(this,[m]);
this._cssClass="rdUnpin";
this._alternateCssClass="rdPin";
this._name="PinUnpin";
this._text="Pin";
this._alternateText="Unpin";
};
b.DockPinUnpinCommand.prototype={onCommand:function(m){if(this.get_radDock().get_dockZoneID()){return;
}this.get_radDock().set_pinned(!this.get_radDock().get_pinned());
Telerik.Web.UI.DockPinUnpinCommand.callBaseMethod(this,"onCommand");
}};
b.DockPinUnpinCommand.registerClass("Telerik.Web.UI.DockPinUnpinCommand",Telerik.Web.UI.DockToggleCommand);
})($telerik.$,Telerik.Web.UI);
Type.registerNamespace("Telerik.Web.UI.Dock");
(function(b,a){b.Dock.IView=function(c){};
b.Dock.IView.prototype={initialize:function(){},dispose:function(){},repaint:function(){},clone:function(){},get_width:function(){},set_width:function(c){},get_height:function(){},set_height:function(c){},get_title:function(){},set_title:function(c){},isPinned:function(){},pin:function(c){},isCollapsed:function(){},collapse:function(d,c){},isClosed:function(){},get_minWidth:function(){},get_minHeight:function(){},get_titleElement:function(){},get_titleBar:function(){},get_commandsContainer:function(){},get_contentContainer:function(){},getCommandsElements:function(){},fitWidth:function(){},unfitWidth:function(){}};
b.Dock.IView.registerInterface("Telerik.Web.UI.Dock.IView");
})(Telerik.Web.UI,$telerik.$);
Type.registerNamespace("Telerik.Web.UI.Dock");
(function(b,a){b.Dock.BaseView=function(c){this.control=c;
this.initialize();
};
b.Dock.BaseView.prototype={initialize:function(){this.initializeFormElement();
},isPinned:function(){return this.control._pinned;
},isCollapsed:function(){return this.control._collapsed;
},isClosed:function(){return this.control._closed;
},get_width:function(){return this.control.get_width();
},get_height:function(){return this.control.get_height();
},get_title:function(){return this.control._title;
},set_title:function(d){var c=this.get_titleElement();
if(c){c.innerHTML=d;
}},get_contentContainer:function(){if(!this._contentContainer){this._contentContainer=$get(this.control.get_id()+"_C");
}return this._contentContainer;
},get_titleBar:function(){if(!this._titleBar){this._titleBar=$get(this.control.get_id()+"_T");
}return this._titleBar;
},get_commandsContainer:function(){if(!this._commandsContainer){var c=this.get_titleBar();
if(c){this._commandsContainer=$telerik.getElementByClassName(c,"rdCommands","UL");
}else{this._commandsContainer=null;
}}return this._commandsContainer;
},initializeFormElement:function(){var c=this.control.get_element().parentNode;
while(c){if(c.tagName.toLowerCase()==="form"){this._form=this.control._form=c;
break;
}c=c.parentNode;
}}};
b.Dock.BaseView.registerClass("Telerik.Web.UI.Dock.BaseView");
})(Telerik.Web.UI,$telerik.$);
Type.registerNamespace("Telerik.Web.UI.Dock");
(function(b,a){b.Dock.ClassicView=function(c){b.Dock.ClassicView.initializeBase(this,[c]);
this.control=c;
};
b.Dock.ClassicView.prototype={initialize:function(){Telerik.Web.UI.Dock.ClassicView.callBaseMethod(this,"initialize");
this._initializeHtmlElementVariables();
this._setUnselectableOn();
this.control._setHandle(this._titleBar||this._grip);
if(this.get_height()){this._setContentContainerHeight(this._height);
}this._middleMiddleCell.style.height="auto";
if(this.get_height()!=null){this._setHeightHtmlEl(this.get_height());
}this._fixEmWidth();
},repaint:function(){if(this.isClosed()||$telerik.getInvisibleParent(this.control.get_element())!=null){return;
}this._fixEmWidth();
this._setContentContainerHeight();
},clone:function(f){var e=this.control.get_element();
var g=e.cloneNode(true);
g.removeAttribute("control");
var h=$telerik.getElementByClassName(g,"rdTable","TABLE").rows;
var i=$telerik.getElementByClassName(h[0].cells[1],"rdTitleBar","DIV");
var d=$telerik.getElementByClassName(h[1].cells[1],"rdContent","DIV");
var c=g.getElementsByTagName("input")[0];
if(i){i.setAttribute("id",f+"_T");
}d.setAttribute("id",f+"_C");
g.setAttribute("id",f);
c.setAttribute("id",f+"_ClientState");
c.setAttribute("name",f+"_ClientState");
e.parentNode.insertBefore(g,e.nextSibling);
return g;
},get_minWidth:function(){var d=0;
for(var c=0;
c<this.getCommandsElements().length;
c++){d+=this.getCommandsElements()[c].clientWidth;
}if(this._topLeftBar){d+=this._topLeftBar.clientWidth;
}if(this._topRightBar){d+=this._topLeftBar.clientWidth;
}return d;
},get_minHeight:function(){var c=0;
if(this._topBar){c+=this._topBar.clientHeight||this._topBar.offsetHeight;
}if(this._bottomBar){c+=this._bottomBar.clientHeight||this._bottomBar.offsetHeight;
}return c;
},getCommandsElements:function(){return this.get_commandsContainer()?this.get_commandsContainer().getElementsByTagName("a"):[];
},get_titleElement:function(){var c=this.get_titleBar();
return c?c.getElementsByTagName("em")[0]:null;
},set_width:function(c){this._setWidthHtmlEl(c);
this._fixEmWidth();
},set_height:function(c){if(this._tableElement){this._tableElement.style.height="auto";
}this._setHeight(c);
},pin:function(f){if($telerik.isIE6){if(f){this.control.set_enableDrag(false);
}else{this.control.set_enableDrag(true);
}return;
}var c=this.control.get_element();
c.style.position="absolute";
var e=$telerik.getScrollOffset(c,true);
var d=this.control._getLocation(c);
if(f){d=this.control.subtractPoints(d,e);
this.control._setLocation(d);
c.style.position="fixed";
this.control.set_enableDrag(false);
}else{d=this.control.addPoints(d,e);
this.control._setLocation(d);
this.control.set_enableDrag(true);
}},collapse:function(p,m){var n=this,g=this.control,i=g.get_element(),j=this._tableElement,h=this.get_contentContainer(),f=h.style.overflow;
$telerik.stopTransition(h,false,true);
var d=g.get_enableAnimation()?g.get_animationDuration():0;
if(!m){d=0;
}var c={};
var k=g.getCommand("ExpandCollapse");
i.style.height="auto";
if(g._resizable){j.style.height="auto";
}h.style.overflow="hidden";
if(p){g._expandedHeight=g._height?parseInt(g._height,10):parseInt(g._getBounds().height,10);
if(!h.style.height){n._forceContentContainerHeight(g._expandedHeight);
}c.height="0px";
$telerik.transition(h,c,d,"easeIn",function(){n._setContentContainerHeight();
g.addCssClass("rdCollapsed");
if(k){k.set_state(2);
Telerik.Web.UI.DockExpandCollapseCommand.callBaseMethod(k,"onCommand");
}if(g._resizable){if(g.get_dockZoneID()){$find(g.get_dockZoneID())._resetDocksResizeHandles();
}else{g._resizableWidget.repaint();
}}h.style.overflow=f;
});
}else{if(g._collapsed&&!p&&!g._expandedHeight){if(g._height){g._expandedHeight=parseInt(g._height,10);
}else{h.style.height="auto";
g.removeCssClass("rdCollapsed");
g._expandedHeight=parseInt(g._getBounds().height,10);
g.addCssClass("rdCollapsed");
}}g.removeCssClass("rdCollapsed");
var o=this._getBounds(this._topBar).height,e=this._getBounds(this._bottomMiddleBar).height,l=parseInt(g._expandedHeight,10)-o-e;
c.height=l+"px";
h.style.height="0px";
$telerik.transition(h,c,d,"easeIn",function(){h.style.display="";
j.style.height="";
if(g.get_height()!=null){n._setHeightHtmlEl(g._expandedHeight);
}if(g._resizable){if(g.get_dockZoneID()){$find(g.get_dockZoneID())._resetDocksResizeHandles();
}else{g._resizableWidget.repaint();
}}if(g.get_height()==null){i.style.height="";
}g._renderingView._setContentContainerHeight();
if(k){k.set_state(1);
}$telerik.repaintChildren(g);
if(g._resizable){g.set_height($telerik.getBounds(i).height+"px");
}if(k){Telerik.Web.UI.DockExpandCollapseCommand.callBaseMethod(k,"onCommand");
}h.style.overflow=f;
});
}if(!m&&g._resizable){g._resizableWidget.repaint();
}},fitWidth:function(){this.control.get_element().style.width="100%";
this.get_contentContainer().style.width="100%";
this._fixEmWidth();
},unfitWidth:function(){this.set_width(this.get_width());
},dispose:function(){this._disposeHtmlVariables();
},_initializeHtmlElementVariables:function(){this._grip=$get(this.control.get_id()+"_G");
this._titleBar=$get(this.control.get_id()+"_T");
this.get_commandsContainer();
var c=this.control.get_element();
this._tableElement=c.getElementsByTagName("table")[0];
var d=this._tableElement.rows;
this._topBar=d[0];
this._topLeftBar=d[0].cells[0];
this._topRightBar=d[0].cells[2];
this._middleLeftBar=d[1].cells[0];
this._middleMiddleCell=d[1].cells[1];
this._middleRightBar=d[1].cells[2];
this._bottomBar=d[2];
this._bottomLeftBar=d[2].cells[0];
this._bottomMiddleBar=d[2].cells[1];
this._bottomRightBar=d[2].cells[2];
},_disposeHtmlVariables:function(){this._grip=this._titleBar=this._commandsContainer=this._tableElement=this._topBar=this._topLeftBar=this._topRightBar=this._middleLeftBar=this._middleMiddleCell=this._middleRightBar=this._bottomBar=this._bottomLeftBar=this._bottomMiddleBar=this._bottomRightBar=this._form=null;
},_setUnselectableOn:function(){this._topLeftBar.setAttribute("unselectable","on");
this._topRightBar.setAttribute("unselectable","on");
this._middleLeftBar.setAttribute("unselectable","on");
this._middleRightBar.setAttribute("unselectable","on");
this._bottomLeftBar.setAttribute("unselectable","on");
this._bottomMiddleBar.setAttribute("unselectable","on");
this._bottomRightBar.setAttribute("unselectable","on");
},_setHeight:function(c){this._setContentContainerHeight(c);
this._setHeightHtmlEl(c);
},_setContentContainerHeight:function(d){var e=this,c=this.get_contentContainer();
if(!c){return;
}if(e.get_height()!=null||e._resizable){e._forceContentContainerHeight(d);
}else{c.style.height="";
}},_forceContentContainerHeight:function(g){var j=this,f=j.get_contentContainer(),c=j._getBounds();
var h=g!=null?parseInt(g,10):c.height,e=j._getBounds(j._topBar),d=j._getBounds(j._bottomBar),i=h-e.height-d.height;
f.style.height=(i<0?0:i)+"px";
},_setHeightHtmlEl:function(d,c){if(!c){c=this.control.get_element();
}if(!d){c.style.height="";
return;
}if(d.toString().indexOf("%")>-1){c.style.height=parseInt(d,10)+"%";
}else{c.style.height=parseInt(d,10)+"px";
}},_setWidthHtmlEl:function(d,c){if(!d){return;
}if(!c){c=this.control.get_element();
}if(d.toString().indexOf("%")>-1){c.style.width=parseInt(d,10)+"%";
}else{c.style.width=parseInt(d,10)+"px";
}},_fixEmWidth:function(){var f=this.get_titleBar();
if(f==null){return;
}var e=this.control.get_element();
var h=this.get_titleElement();
if(!h){return;
}var c=this.get_commandsContainer();
var d=c?$telerik.getOuterBounds(c).width:0;
h.style.display="block";
h.style.width="";
if(h.offsetWidth+30+d<e.offsetWidth){return;
}var g=$telerik.getBounds(f).width;
if(g>0){if($telerik.isIE6){h.style.display="none";
g=$telerik.getBounds(f).width;
h.style.display="block";
}var j=g-d-30;
var i=j>0?j:0;
h.style.width=i+"px";
}},_getBounds:function(c){if(!c){c=this.control.get_element();
}return $telerik.getBounds(c);
}};
b.Dock.ClassicView.registerClass("Telerik.Web.UI.Dock.ClassicView",Telerik.Web.UI.Dock.BaseView,Telerik.Web.UI.Dock.IView);
})(Telerik.Web.UI,$telerik.$);
Type.registerNamespace("Telerik.Web.UI.Dock");
(function(b,a){b.Dock.LightweightView=function(c){b.Dock.LightweightView.initializeBase(this,[c]);
this.control=c;
};
b.Dock.LightweightView.prototype={initialize:function(){var d=this;
var c=d.control;
b.Dock.LightweightView.callBaseMethod(d,"initialize");
c._setHandle(d._getHandle());
if(c.get_collapsed()){d._setCollapsedDockHeight();
}else{if(c.get_height()){d.set_height(c.get_height());
}}},dispose:function(){},repaint:function(){},clone:function(d){var e=this.control._element;
var c=e.cloneNode(true);
this._fixCloneIds(c,d);
e.parentNode.insertBefore(c,e.nextSibling);
return c;
},get_minWidth:function(){var c=0;
if(this.get_commandsContainer()){c+=this.get_commandsContainer().clientWidth;
}if(this._getTitleWrapper()){c+=parseInt($telerik.getComputedStyle(this._getTitleWrapper(),"padding-left",0),10);
c+=parseInt($telerik.getComputedStyle(this._getTitleWrapper(),"padding-right",0),10);
}return c;
},get_minHeight:function(){return this._getTitleWrapperHeight();
},set_width:function(d){var c=d.indexOf&&d.indexOf("%")>-1?"%":"px";
this.control.get_element().style.width=parseInt(d,10)+c;
if(this.get_titleElement()){this._sizeTitleElement();
}},set_height:function(c){if(c){this.control.get_element().style.height=parseInt(c,10)+"px";
this._setContentWrapperHeight(c);
}},pin:function(d){var c=d?"fixed":"absolute";
this.control.set_enableDrag(!d);
this.control.get_element().style.position=c;
},collapse:function(k,i){var c=this.control.getCommand("ExpandCollapse");
var j=this,h={},d=this.control,f=d.get_element(),e=d.get_contentContainer().parentNode,g=this.control.get_enableAnimation()?this.control.get_animationDuration():0;
f.style.overflow="hidden";
if(k){h.height=this._getTitleWrapperHeight();
d._expandedHeight=this._calcExpandedHeight();
if(!j.get_height()){j.set_height(d._expandedHeight);
}}else{d.removeCssClass("rdCollapsed");
this.set_height(this._getTitleWrapperHeight());
if(!d._expandedHeight){d._expandedHeight=this._calcExpandedHeight();
}h.height=parseInt(d._expandedHeight,10);
e.style.height=parseInt(h.height,10)-this._getTitleWrapperHeight()+"px";
}$telerik.stopTransition(this.control._element,false,true);
$telerik.transition(this.control._element,h,g,"easeIn",function(){if(k){j.set_height(j._getTitleWrapperHeight());
d.addCssClass("rdCollapsed");
e.style.overflow="hidden";
}else{j.set_height(d._expandedHeight);
e.style.overflow=j.get_height()?"auto":"";
if(!j.control.get_height()){j._clearHeight();
}}f.style.overflow="";
if(d._resizable&&d._resizableWidget){if(d.get_dockZoneID()){$find(d.get_dockZoneID())._resetDocksResizeHandles();
}else{d._resizableWidget.repaint();
}}if(c){c.set_state(k?2:1);
Telerik.Web.UI.DockExpandCollapseCommand.callBaseMethod(c,"onCommand");
}});
},close:function(d,c){},get_titleElement:function(){return this.get_titleBar()?this.get_titleBar().getElementsByTagName("h6")[0]:null;
},getCommandsElements:function(){return a(".rdCommandButton",this.get_commandsContainer()).toArray();
},fitWidth:function(){this.originalWidth=this.get_width();
this.control.get_element().style.width="100%";
if(this.get_titleElement()){this._sizeTitleElement();
}},unfitWidth:function(){var c=this.originalWidth||this.get_width();
this.set_width(c);
this.originalWidth=null;
},_getHandle:function(){return $get(this.control.get_id()+"_T")||$get(this.control.get_id()+"_G");
},_sizeTitleElement:function(){var f=this.get_titleElement(),e=this.get_titleBar(),c=this.get_commandsContainer(),d=c?parseInt(c.clientWidth,10):0;
f.style.width=Math.max(0,parseInt(e.clientWidth,10)-d)+"px";
f.style.display="";
},_setContentWrapperHeight:function(d){var e=this;
var c=this.get_contentContainer().parentNode;
if(e.control.get_height()){c.style.overflow="auto";
}c.style.height=parseInt(d,10)-this._getTitleWrapperHeight()+"px";
},_getBounds:function(c){if(!c){c=this.control.get_element();
}return $telerik.getBounds(c);
},_getTitleWrapperHeight:function(){var c=a(this.control._element).find(".rdTitleWrapper");
var d=$telerik.isIE6||$telerik.isIE7?c.get(0).clientHeight:c.get(0).offsetHeight;
return parseInt(d,10);
},_fixCloneIds:function(c,d){a(c).attr("id",d);
a(".rdTitleBar",c).attr("id",d+"_T");
a(".rdContent",c).attr("id",d+"_C");
a("input[id$='ClientState']").attr("id",d+"_ClientState");
},_getTitleWrapper:function(){return a(".rdTitleWrapper",this.control._element).get(0);
},_calcExpandedHeight:function(){var c=this.control;
var d=0;
if(c._expandedHeight&&!isNaN(parseInt(c._expandedHeight,10))&&!this._isExpandedHeightChanged()){d=parseInt(c._expandedHeight,10);
}else{if(c._height){d=parseInt(c._height,10);
}else{d=parseInt(c._element.clientHeight,10);
}}return d;
},_isExpandedHeightChanged:function(){var d=this.control;
var c=parseInt(d._element.clientHeight,10);
var e=parseInt(d._expandedHeight,10);
return c!==e;
},_setCollapsedDockHeight:function(){var d=this;
var c=d.control;
c._expandedHeight=d._calcExpandedHeight();
d.set_height(d._getTitleWrapperHeight());
a(c.get_element()).css("overflow","");
},_clearHeight:function(){var c=this.control;
c.get_contentContainer().parentNode.style.height="";
c.get_element().style.height="";
}};
b.Dock.LightweightView.registerClass("Telerik.Web.UI.Dock.LightweightView",Telerik.Web.UI.Dock.BaseView,Telerik.Web.UI.Dock.IView);
})(Telerik.Web.UI,$telerik.$);
if(typeof(Sys)!=='undefined')Sys.Application.notifyScriptLoaded();