Type.registerNamespace("Telerik.Web.UI.Editor");
Telerik.Web.UI.Editor.AjaxSpellCheck=function(a){Telerik.Web.UI.Editor.AjaxSpellCheck.initializeBase(this,[a]);
this._language="";
this._editor=null;
this._originalHtml=null;
this._protectedData=[];
this._ignoreTags=new RegExp("<(!--)([\\s\\S]*?)(--)>","gi");
this._ignoreOtherTags=new RegExp("<(object|style|textarea)([\\s\\S]*?)(\\/\\1)>","gi");
this._ignoreOtherTagsIE=new RegExp("<(marquee)([\\s\\S]*?)(\\/\\1)>","gi");
this._view=null;
};
Telerik.Web.UI.Editor.AjaxSpellCheck.prototype={initialize:function(){var a=this.get_editor();
this._finalCheckMessage=a.getLocalizedString("SpellCheckEnd","Finish Spellchecking");
this._completeMessage=a.getLocalizedString("SpellCheckComplete","Spellchecking Complete!");
this._cancelMessage=a.getLocalizedString("CancelButton","Cancel");
this._addWordSuccessMessage=a.getLocalizedString("AddCustomWordSuccess");
this._spellingInProgressMessage=a.getLocalizedString("SpellingInProgress");
this._spellingModeMessage=a.getLocalizedString("SpellingMode");
this._noSpellingMistakesMessage=a.getLocalizedString("NoSpellingMistakes","No Mistakes Found.");
this._loadingIconCss="reLoading";
this._view=Telerik.Web.UI.Editor.SpellCheck.ViewFactory.getView(this);
this.get_element().appendChild(this._view.get_wrapper());
},get_editor:function(){return this._editor;
},set_editor:function(a){this._editor=a;
},get_language:function(){return this._language;
},set_language:function(a){this._language=a;
},getSpellService:function(){var b=this.get_editor().get_spellCheckService();
var a=this.get_language();
if(a){b.set_language(a);
}return b;
},dispose:function(){if(this._view&&this._view.dispose){this._view.dispose();
this._view=null;
delete this._view;
}if(this._spellEngine){this._spellEngine.dispose();
}this._editor=null;
this._topElement=null;
this._protectedData=null;
},raiseEvent:function(b,a){var c=this.get_events().getHandler(b);
if(c){if(!a){a=Sys.EventArgs.Empty;
}c(this,a);
}},add_spellCheckStart:function(a){this.get_events().addHandler("spellCheckStart",a);
},remove_spellCheckStart:function(a){this.get_events().removeHandler("spellCheckStart",a);
},add_spellCheckEnd:function(a){this.get_events().addHandler("spellCheckEnd",a);
},remove_spellCheckEnd:function(a){this.get_events().removeHandler("spellCheckEnd",a);
},spellCheck:function(){if(!this._spellEngine){this._spellEngine=Telerik.Web.UI.Editor.SpellEngineUIFactory.getUI(this.get_editor(),this);
this._spellEngine.onSpellCheckComplete=Function.createDelegate(this,function(){this.finishSpellCheck();
alert(this._completeMessage);
});
this._spellEngine.onAddCustomWord=Function.createDelegate(this,function(c){this.addCustomWord(c);
});
}if(this._spellEngine._spellcheckComplete){this.finishSpellCheck(false);
}this._setVisible(true);
this.get_editor().repaint();
this._setLoadingIconVisible(true);
this._enableButtons(false);
this._originalHtml=this.get_editor().get_contentArea().innerHTML;
var a=this.getSpellService();
var b=Function.createDelegate(this,function(d,c){a.remove_complete(b);
this.beginSpellCheck(c);
});
a.add_complete(b);
this._saveSpecialContent();
a.spellCheck(this._spellEngine._escapeNewLines(this._originalHtml));
},beginSpellCheck:function(a){this._setLoadingIconVisible(false);
this._enableButtons(true);
this.raiseEvent("spellCheckStart");
if(a.badWords.length==0){alert(this._noSpellingMistakesMessage);
this.finishSpellCheck();
}else{this._spellEngine.initialize(a,this._originalHtml);
}},finishSpellCheck:function(a){this._setVisible(false);
this._spellEngine.finalize();
this.restoreSavedContent();
this._originalHtml=null;
if(false!=a){this.raiseEvent("spellCheckEnd");
}},cancelSpellCheck:function(){this._setVisible(false);
this._spellEngine.finalize(false);
if(null!=this._originalHtml){Telerik.Web.UI.Editor.Utils.setElementInnerHtml(this.get_editor().get_contentArea(),this._originalHtml);
this._originalHtml=null;
}this.restoreSavedContent();
var b=this.get_editor().get_commandsManager();
var a=b.get_commands();
b.removeCommandAt(a.length-1);
this.raiseEvent("spellCheckEnd");
this.get_editor().raiseEvent("selectionChange",Sys.EventArgs.Empty);
},_saveSpecialContent:function(){this._protectedData=[];
var a=Function.createDelegate(this,function(f,b,c,d,g,e){Array.add(this._protectedData,"<"+b+c+d+">");
return"<radeditorformatted_"+this._protectedData.length+"></radeditorformatted_"+this._protectedData.length+">";
});
this._originalHtml=this._originalHtml.replace(this._ignoreTags,a);
this._originalHtml=this._originalHtml.replace(this._ignoreOtherTags,a);
if($telerik.isIE){this._originalHtml=this._originalHtml.replace(this._ignoreOtherTagsIE,a);
}},restoreSavedContent:function(){if(this._protectedData&&this._protectedData.length>0){var b=this.get_editor().get_contentArea().innerHTML;
for(var a=0;
a<this._protectedData.length;
a++){var d=new RegExp("<radeditorformatted_"+(a+1)+"\\s*>","i");
b=b.replace(d,this._protectedData[a]);
}var c=new RegExp("<\\/radeditorformatted_[^>]+>","i");
b=b.replace(c,"");
Telerik.Web.UI.Editor.Utils.setElementInnerHtml(this.get_editor().get_contentArea(),b);
}},addCustomWord:function(d){var e=this.getSpellService();
var b=this._spellEngine;
var c=this._addWordSuccessMessage;
var a=function(){e.remove_complete(a);
alert(d+" "+c);
b.clearWrongWords(d,d);
var f=b.isHighlightedRemaining();
if(!f){b._suggestionDropdown.hide();
b.onSpellCheckComplete();
return;
}b.moveToNextWrongWord();
};
e.add_complete(a);
e.addCustomWord(d);
},_setVisible:function(a){if(this._view){this._view.toggleVisiblity(a);
}},_enableButtons:function(a){if(this._view){this._view.toggleButtons(a);
}},_setLoadingIconVisible:function(a){if(this._view){this._view.renderInfoBox();
}}};
Telerik.Web.UI.Editor.AjaxSpellCheck.registerClass("Telerik.Web.UI.Editor.AjaxSpellCheck",Sys.UI.Control);
Telerik.Web.UI.Editor.SpellEngineUIFactory=function(){};
Telerik.Web.UI.Editor.SpellEngineUIFactory.getUI=function(a,c){var e=null,b=Telerik.Web.UI.RenderMode,d=a.get_renderMode();
if(d==b.Lite){e=new Telerik.Web.UI.Editor.SpellEngineUILightweight(a,c);
}else{if(d==b.Classic){e=new Telerik.Web.UI.Editor.SpellEngineUIClassic(a,c);
}}return e;
};
Telerik.Web.UI.Editor.SpellEngineUIBase=function(a,b){this._editor=a;
this._parentControl=b;
this._suggestionDropdown=null;
this._suggestionBox=null;
this._wrongWordCounter=0;
this._wrongWordsArray=null;
this._spanId="RadESpellError_";
this._selectedEditorElement=null;
this._spellcheckComplete=true;
this._automaticAdvance=true;
this._localizedCommandName=this._editor.getLocalizedString("spellCheck","Check spelling");
this._localizedName=this._editor.getLocalizedString("SpellingChange","Spelling Change");
this._noSuggestionsString=this._editor.getLocalizedString("NoSuggestions","(no suggestions)");
this._changeWordString=this._editor.getLocalizedString("ChangeWordString","Change");
this._ignoreAllString=this._editor.getLocalizedString("IgnoreAllString","Ignore All");
this._ignoreString=this._editor.getLocalizedString("IgnoreString","Ignore");
this._moreThanOnceMessage=this._editor.getLocalizedString("MoreThanOnceMessage","This word occurs more than once in the text. Would you like to replace all instances?");
this._undoDisabledMessage=this._editor.getLocalizedString("UndoDisabledMessage","You cannot undo further while in spellcheck mode. Please finish spellchecking first.");
this._addToDictionaryString=this._editor.getLocalizedString("AddToDictionary","Add to dictionary");
this._addIconCss="";
this._okIconCss="";
this._ignoreIconCss="";
};
Telerik.Web.UI.Editor.SpellEngineUIBase.prototype={onAddCustomWord:function(a){},onSpellCheckComplete:function(){},dispose:function(){this._editor=null;
this.onSpellCheckComplete=null;
},_configureUndo:function(d){if(d){this._editor.enableEditing(true);
var c=this._editor.get_commandsManager();
var a=c.get_commands();
var e=this._currentUndoIndex;
while(e<a.length){c.removeCommandAt(a.length-1);
}this._editor.executeCommand(this.SaveStateCmd);
if(this._onCommandExecutingDelegate){this._editor.remove_commandExecuting(this._onCommandExecutingDelegate);
}this._onCommandExecutingDelegate=null;
}else{var b=this._editor.get_commandsManager();
this._currentUndoIndex=b.getCommandsToUndo().length;
this._onCommandExecutingDelegate=Function.createDelegate(this,function(h,f){var g=f.get_commandName();
if(g=="Undo"&&this._currentUndoIndex>=b.getCommandsToUndo().length){alert(this._undoDisabledMessage);
f.set_cancel(true);
}});
this._editor.add_commandExecuting(this._onCommandExecutingDelegate);
this._editor.enableEditing(false,Telerik.Web.UI.EditingOptions.All,{Undo:true,Redo:true,AjaxSpellCheck:true});
}},finalize:function(b){if(true!=this._initialized){return;
}if(false!=b){this.clearWrongWords();
}if(this._parentControl){this._parentControl.restoreSavedContent();
this._parentControl=null;
}var a=this._editor;
if(this.OnMouseHandler){a.detachEventHandler("click",this.OnMouseHandler);
}if(this.OnKeyDownHandler){a.detachEventHandler("keydown",this.OnKeyDownHandler);
}if(this.OnContextMenu){a.detachEventHandler("contextmenu",this.OnContextMenu);
}if(this.OnEditorSubmit){a.remove_submit(this.OnEditorSubmit);
}this._configureUndo(true);
a.setFocus();
a.raiseEvent("selectionChange",Sys.EventArgs.Empty);
this._wrongWordsArray=null;
this._spellcheckComplete=true;
this._initialized=false;
},initialize:function(d,b){this._initialized=true;
this._wrongWordsArray=d.badWords;
this._wordOffsets=d.wordOffsets;
var a=this._editor;
this.SaveStateCmd=new Telerik.Web.UI.Editor.GenericCommand(this._localizedCommandName,a.get_contentWindow(),this._editor);
this.markWrongWords(b);
this._spellcheckComplete=false;
this._wrongWordCounter=0;
var c=this;
this.OnEditorSubmit=function(){c.finalize();
};
this._editor.add_submit(this.OnEditorSubmit);
this.OnMouseHandler=function(f){c._showSuggestionDropdown();
return $telerik.cancelRawEvent(f);
};
this.OnKeyDownHandler=function(g){if(g.keyCode==9){c.moveToNextWrongWord();
return $telerik.cancelRawEvent(g);
}var f=false;
if(c._suggestionDropdown){var k=c._suggestionDropdown;
var i=(k.isExpanded());
var j=g.keyCode;
if(i){if(38==j){k.selectPreviousItem();
f=true;
}else{if(40==j){k.selectNextItem();
f=true;
}else{if(13==j){k.hide();
if(k.get_activeIndex){k.set_selectedIndex(k.get_activeIndex());
}c._onDropDownValueSelected(k);
try{g.keyCode=123;
}catch(h){}f=true;
}else{if(27==j){k.hide();
}}}}f=true;
}}if(f){return $telerik.cancelRawEvent(g);
}};
this.OnContextMenu=function(f){if(this._editor.isIE){c.OnMouseHandler(f);
}f.cancelBubble=true;
if(this._editor.isIE){return false;
}};
window.setTimeout(function(){var g=c._editor;
g.attachInternalHandler("click",c.OnMouseHandler);
g.attachInternalHandler("keydown",c.OnKeyDownHandler);
g.attachInternalHandler("contextmenu",Function.createDelegate(c,c.OnContextMenu));
if(c._automaticAdvance){g.setFocus();
if(g.isIE){try{var h=g.getSelection().getRange();
if(h){h.moveToElementText(g.get_contentArea());
h.collapse();
h.select();
}}catch(f){}}c.moveToNextWrongWord();
}},50);
this._configureUndo(false);
},moveToNextWrongWord:function(){var a=-1;
var l=this._editor.getSelection();
var i=l.getParentElement();
var j=null;
if(this.isHighlightedWord(i)&&!this._editor.getSelectionHtml()){j=i;
}else{l.collapse();
var h=this._editor;
var m=this;
var k=null;
var d=function(){var e=h.get_contentArea();
var q=e.getElementsByTagName("SPAN");
var o=0;
var p=q[o];
k=h.getSelection().getRange();
var t=h.isIE&&!!document.selection;
while(p!=null){if(m.isHighlightedWord(p)){var r=null;
var s;
if(t){if(k.duplicate){s=k.duplicate();
}else{s=e.createTextRange();
}if(s.moveToElementText){s.moveToElementText(p);
}if(!k.compareEndPoints){break;
}r=k.compareEndPoints("EndToStart",s);
if(0==r){j=p;
break;
}}else{if(k){s=k.cloneRange();
s.selectNodeContents(p);
r=k.compareBoundaryPoints(window.Range.END_TO_START,s);
}}if(a==r){j=p;
break;
}}o++;
p=q[o];
}return p;
};
j=d();
if(!j){var g=h.get_contentArea();
if(g&&g.createTextRange){var f=g.createTextRange();
f.moveToElementText(g);
f.collapse(true);
f.select();
}else{var c=h.get_contentArea().getElementsByTagName("SPAN")[0];
if(c){h.selectElement(c);
}}try{var n=h.getSelection().getRange();
if(n&&n.moveStart){n.moveStart("character",-1);
n.select();
}}catch(b){}h.getSelection().collapse(true);
j=d();
}}if(j){this._editor.selectElement(j);
$telerik.scrollIntoView(j);
this._showSuggestionDropdown();
}},clearWrongWords:function(e,a){var d=this._editor.get_contentArea().getElementsByTagName("SPAN");
for(var b=0;
b<d.length;
b++){var c=d[b];
if(this.isHighlightedWord(c)){if(e){if(c.innerHTML==e){this.clearHighlightedElement(c,a);
b--;
}continue;
}else{this.clearHighlightedElement(c);
}b--;
}}},isHighlightedRemaining:function(){var c=this._editor.get_contentArea().getElementsByTagName("SPAN");
for(var a=0;
a<c.length;
a++){var b=c[a];
if(this.isHighlightedWord(b)){return true;
}}return false;
},getCurrentWrongWord:function(){var b=this._selectedEditorElement;
var a=b.innerHTML.replace(/<\/?[^>]*>/ig,"");
return a;
},isHighlightedWord:function(b){if(!b||!b.getAttribute){return false;
}var a=b.getAttribute("id");
if(a&&a.indexOf(this._spanId)>-1){return true;
}return false;
},clearHighlightedElement:function(g,f,d){var b=true;
if(g!=this._selectedEditorElement){b=false;
}var i=f?f:g.innerHTML.replace(/<\/?[^>]*>/ig,"");
var a=f?true:false;
this._editor.selectElement(g,false);
var c=new Telerik.Web.UI.Editor.GenericCommand(this._localizedName,this._editor.get_contentWindow(),this._editor);
var j=this._editor.get_document().createTextNode(i);
g.parentNode.replaceChild(j,g);
var h=this._consolidateText(j);
var e=this._editor.isIE;
if(e&&!i&&!f&&!d){return;
}h.collapse();
h.select();
if(a){this._editor.executeCommand(c);
}if(b){this._selectedEditorElement=null;
}},_consolidateText:function(g){var h=Telerik.Web.UI.Editor.Utils;
var e=this._editor.getDomRange();
var f=g.length;
var c=g.previousSibling;
var b=g.nextSibling;
var a=function(i,j){i.nodeValue+=j.nodeValue;
j.parentNode.removeChild(j);
};
e.selectNodeContents(g);
if(b&&h.isTextNode(b)){a(g,b);
}if(c&&h.isTextNode(c)){var d=c.length;
a(c,g);
e.setStart(c,d);
e.setEnd(c,d+f);
}return e;
},markWrongWords:function(a){var c=function(e,d,g,f){this.badWords=e;
this._wordOffsets=d;
this._spanId=g;
this.Content=f;
this.CurrentWordIndex=0;
this.Result=null;
};
c.prototype={GetSplitContent:function(){var e=new Array(this.badWords.length*2+1);
for(var d=0;
d<this.badWords.length;
d++){var f=d*2;
e[f]=this.GetBeforeText(d);
e[f+1]=this.badWords[d].wordString;
}e[e.length-1]=this.GetLastText();
return e;
},GetMarkedSplitContent:function(e){for(var d=1;
d<e.length;
d+=2){e[d]=this.GetMarkedWord(e[d]);
this.CurrentWordIndex++;
}return e;
},GetBeforeText:function(e){var g=0;
var f=this.GetWordStartIndex(this.badWords[e]);
if(e!=0){var d=this.badWords[e-1];
g=this.GetWordEndCharIndex(d);
}return this.Content.substring(g,f);
},GetLastText:function(){var e=this.badWords[this.badWords.length-1];
var f=this.GetWordEndCharIndex(e);
var d=this.Content.length;
return this.GetSubContent(f,d);
},GetWordEndCharIndex:function(d){return this.GetWordStartIndex(d)+d.wordString.length;
},GetSubContent:function(e,d){return this.Content.substring(e,d);
},GetWordStartIndex:function(d){return this._wordOffsets[d.textOffset];
},GetMarkedWord:function(d){return"<span class='RadEWrongWord' id='"+this._spanId+this.CurrentWordIndex+"'>"+d+"</span>";
},GetResult:function(){if(this.Result==null){this.Result=this.GetMarkedSplitContent(this.GetSplitContent()).join("");
}return this.Result;
}};
var b=new c(this._wrongWordsArray,this._wordOffsets,this._spanId,this._escapeNewLines(a));
Telerik.Web.UI.Editor.Utils.setElementInnerHtml(this._editor.get_contentArea(),this._unescapeNewLines(b.GetResult()));
},_escapeNewLines:function(b){var a=b.replace(/\n/gi,"<telerikcr />");
a=a.replace(/\r/gi,"<teleriklf />");
return a;
},_unescapeNewLines:function(b){var a=b.replace(/<telerikcr\s*\/\>/gi,"\n");
a=a.replace(/<teleriklf\s*\/\>/gi,"\r");
return a;
},_getSuggestionsForWord:function(f){var a=this._wrongWordsArray;
for(var b=0;
b<a.length;
b++){var e=a[b].wordString;
if(e==f){var d=a[b].suggestionsString;
if(d.length==0){return[["",this._noSuggestionsString]];
}else{d=d.concat([]);
for(var c=0;
c<d.length;
c++){d[c]=[d[c],d[c]];
}}return d;
}}return[];
},_get_footerItems:function(b){var a=[];
if(this._editor.get_spellAllowAddCustom()){a.splice(0,0,["reAdd_to_dictionary",this._addToDictionaryString,this._addIconCss]);
}a.splice(0,0,["reChange",this._changeWordString,this._okIconCss]);
if(this._occursMoreThanOnce(b)){a.splice(0,0,["reIgnore_all",this._ignoreAllString,this._ignoreIconCss]);
}a.splice(0,0,["",this._ignoreString,this._ignoreIconCss]);
return a;
},_occursMoreThanOnce:function(d){var a=this._editor.get_text();
var b=new RegExp("(\\b)"+d+"(\\b)","g");
var c=a.match(b);
return(c&&c.length>1);
},fire:function(e,b){var h=b.SelectedValue;
var g=this._selectedEditorElement&&this._selectedEditorElement.innerHTML?this._selectedEditorElement.innerHTML:"";
if(h=="reAdd_to_dictionary"){if(g.length>0){this.onAddCustomWord(this.getCurrentWrongWord());
}}else{if(h=="reIgnore_all"){this.clearWrongWords(g,"");
}else{if(h=="reChange"){this._showSuggestionBox(this._selectedEditorElement);
return;
}else{var c=false;
if(h){var d=this._occursMoreThanOnce(g);
if(d){var a=window.confirm(this._moreThanOnceMessage);
if(a){this.clearWrongWords(g,h);
c=true;
}}}if(!c){this.clearHighlightedElement(this._selectedEditorElement,h,true);
}}}}var f=this.isHighlightedRemaining();
if(!f){this.onSpellCheckComplete();
return;
}this._editor.raiseEvent("selectionChange",Sys.EventArgs.Empty);
if(this._automaticAdvance){this.moveToNextWrongWord();
}},_onDropDownValueSelected:function(b,a){var c=b.get_selectedItem();
this.fire("",{SelectedValue:c});
},_onDropDownBeforeShow:function(c,a){var d=this.getCurrentWrongWord();
var b=this._getSuggestionsForWord(d);
c.set_items(b);
},_showSuggestionDropdown:function(){var d=this._editor;
var e=d.getSelection().getParentElement();
if(!this.isHighlightedWord(e)){return;
}this._selectedEditorElement=e;
var g=this.getCurrentWrongWord();
if(!this._suggestionDropdown){this._onDropDownValueSelectedDelegate=Function.createDelegate(this,this._onDropDownValueSelected);
this._onDropDownBeforeShowDelegate=Function.createDelegate(this,this._onDropDownBeforeShow);
var b={valueSelected:this._onDropDownValueSelectedDelegate,show:this._onDropDownBeforeShowDelegate};
var a={_rendermode:Telerik.Web.UI.RenderMode.toString(d.get_renderMode())=="Lite"?"Lightweight":Telerik.Web.UI.RenderMode.toString(d.get_renderMode())};
a.popupwidth="160px";
a.parentElement=d.get_contentAreaElement();
a.skin=d.get_skin();
a.sizetofit=true;
var c=$create(Telerik.Web.UI.EditorSpellSuggestionBox,a,b,null,document.createElement("span"));
this._suggestionDropdown=c;
}var f=this._suggestionDropdown;
f.hide();
f.set_footerItems(this._get_footerItems(g));
f.set_wrongWordWrapper(e);
f.show();
f.selectNextItem();
if(d.isIE){d.setFocus();
}},_onTextboxValueSelected:function(b,a){var c=b.get_selectedItem();
this._editor.setFocus();
this.fire("",{SelectedValue:c});
},_showSuggestionBox:function(f){var e=this._editor;
if(!this._suggestionBox){this._onTextboxValueSelectedDelegate=Function.createDelegate(this,this._onTextboxValueSelected);
var b={valueSelected:this._onTextboxValueSelectedDelegate};
var a={_rendermode:Telerik.Web.UI.RenderMode.toString(e.get_renderMode())=="Lite"?"Lightweight":Telerik.Web.UI.RenderMode.toString(e.get_renderMode())};
a.parentElement=e.get_contentAreaElement();
a.skin=e.get_skin();
a.sizetofit=true;
var c=$create(Telerik.Web.UI.EditorAjaxSpellTextbox,a,b,null,document.createElement("span"));
this._suggestionBox=c;
}var d=this._suggestionBox;
var g=this.getCurrentWrongWord();
window.setTimeout(function(){d.set_wrongWordWrapper(f);
d.show();
d.setValue(g);
},10);
}};
Telerik.Web.UI.Editor.SpellEngineUIBase.registerClass("Telerik.Web.UI.Editor.SpellEngineUIBase");
Telerik.Web.UI.Editor.SpellEngineUIClassic=function(a,b){Telerik.Web.UI.Editor.SpellEngineUIClassic.initializeBase(this,[a,b]);
this._addIconCss="reAjaxspell_addicon";
this._okIconCss="reAjaxspell_okicon";
this._ignoreIconCss="reAjaxspell_ignoreicon";
};
Telerik.Web.UI.Editor.SpellEngineUIClassic.prototype={};
Telerik.Web.UI.Editor.SpellEngineUIClassic.registerClass("Telerik.Web.UI.Editor.SpellEngineUIClassic",Telerik.Web.UI.Editor.SpellEngineUIBase);
Telerik.Web.UI.Editor.SpellEngineUILightweight=function(a,b){Telerik.Web.UI.Editor.SpellEngineUILightweight.initializeBase(this,[a,b]);
this._addIconCss="AddIcon";
this._okIconCss="OkIcon";
this._ignoreIconCss="IgnoreIcon";
};
Telerik.Web.UI.Editor.SpellEngineUILightweight.prototype={};
Telerik.Web.UI.Editor.SpellEngineUILightweight.registerClass("Telerik.Web.UI.Editor.SpellEngineUILightweight",Telerik.Web.UI.Editor.SpellEngineUIBase);
Telerik.Web.UI.EditorSpellSuggestionBox=function(a){Telerik.Web.UI.EditorSpellSuggestionBox.initializeBase(this,[a]);
this._parentElement=null;
this._wrongWordWrapper=null;
this._maxItemSize=5;
this._rendermode=null;
};
Telerik.Web.UI.EditorSpellSuggestionBox.prototype={dispose:function(){this._wrongWordWrapper=null;
Telerik.Web.UI.EditorSpellSuggestionBox.callBaseMethod(this,"dispose");
},initialize:function(){this.set_popupclassname("reAjaxSpellCheck");
this._view=Telerik.Web.UI.Editor.UI.ToolsViewFactory.getView(this,"EditorSpellSuggestionBox");
},set_footerItems:function(a){this._footerItems=a;
},renderChildren:function(){Telerik.Web.UI.EditorSpellSuggestionBox.callBaseMethod(this,"renderChildren");
var e=20;
var h=this._items.length>this._maxItemSize?this._maxItemSize:this._items.length;
var a=h>1?(h*e):25;
var d=document.createElement("div");
d.style.overflow="auto";
d.style.height=a+"px";
d.className="reAjaxSpellCheckSuggestions";
var c=this._itemRootElement;
c.cellSpacing="0";
var k=c.parentNode;
k.removeChild(c);
d.appendChild(c);
d.style.overflowX="hidden";
d.style.width="100%";
var j=this.renderItemRoot();
j.cellSpacing="0";
k.appendChild(j);
this.renderNewRow();
var b=this.renderItemContainer();
b.appendChild(d);
var l=document.createElement("div");
l.className="reAjaxSpellCheckSeparator";
b.appendChild(l);
var m=this._items.length;
for(var f=0;
f<this._footerItems.length;
f++){this.renderNewRow();
var g=this.renderItemContainer();
this.markItemContainer(g,m);
this.renderChild(g,this._footerItems[f],m);
m++;
}this._items=this._items.concat(this._footerItems);
},configurePopupPropertiesBeforeShow:function(){var c=this._popupBehavior;
c.set_positioningMode(Telerik.Web.PositioningMode.Absolute);
var b=this.get_parentElement();
if(b){if(b.tagName&&b.tagName.toLowerCase()!="iframe"){b=b.ownerDocument.body;
}c.set_parentElement(b);
}var d=this.get_wrongWordWrapper();
if(d){var a=$telerik.getBounds(d);
c.set_x(a.x);
var e=a.y+a.height;
if($telerik.isIE&&$telerik.quirksMode){e-=document.body.scrollTop;
}else{if(b.contentDocument){if($telerik.isIE){e-=b.contentDocument.getElementsByTagName("HTML")[0].scrollTop;
}else{if($telerik.isSafari){e-=b.contentDocument.body.scrollTop;
}}}else{if($telerik.isSafari||$telerik.isOpera){e+=this.get_parentElement().scrollTop;
c.set_parentElement(null);
}}}c.set_y(e);
}},get_parentElement:function(){return this._parentElement;
},set_parentElement:function(a){this._parentElement=a;
},get_maxItemSize:function(){return this._maxItemSize;
},set_maxItemSize:function(a){this._maxItemSize=a;
},get_wrongWordWrapper:function(){return this._wrongWordWrapper;
},set_wrongWordWrapper:function(a){this._wrongWordWrapper=a;
}};
Telerik.Web.UI.EditorSpellSuggestionBox.registerClass("Telerik.Web.UI.EditorSpellSuggestionBox",Telerik.Web.UI.EditorSplitButton);
Telerik.Web.UI.EditorAjaxSpellTextbox=function(a){Telerik.Web.UI.EditorAjaxSpellTextbox.initializeBase(this,[a]);
};
Telerik.Web.UI.EditorAjaxSpellTextbox.prototype={dispose:function(){if(null!=this._element){this._element.onchange=null;
this._element.onkeypress=null;
this._element.onclick=null;
this._element.Parent=null;
}this._element=null;
Telerik.Web.UI.EditorAjaxSpellTextbox.callBaseMethod(this,"dispose");
},setValue:function(d){if(this._textElement){this._textElement.value=d;
}var b=this._textElement;
try{if(b){b.focus();
}if(b&&b.setActive&&document.selection){b.setActive();
var c=document.selection.createRange();
c.moveStart("word",1);
c.select();
c.collapse();
}}catch(a){}},get_selectedItem:function(){return this._textElement.value;
},fire:function(){this.hide();
this.raiseEvent("valueSelected");
},attachEventHandlers:function(){},show:function(){if(!this._rendered){this.render();
}this._show();
},configurePopupPropertiesBeforeShow:function(){Telerik.Web.UI.EditorAjaxSpellTextbox.callBaseMethod(this,"configurePopupPropertiesBeforeShow");
var b=this._popupBehavior;
var c=this.get_wrongWordWrapper();
if(c){var a=$telerik.getBounds(c);
b.set_y(a.y);
}},renderChildren:function(){},renderItemRoot:function(){this._createBox();
this._itemRootElement=this._element;
return this._itemRootElement;
},_createBox:function(){var b=document.createElement("input");
b.setAttribute("type","text");
b.setAttribute("size","20");
b.Parent=this;
var a=function(f,g,h){if(h){if(g.Executed){g.Executed=false;
return $telerik.cancelRawEvent(f);
}}g.Executed=true;
g.Parent.fire();
return $telerik.cancelRawEvent(f);
};
b.onclick=function(){b.focus();
};
b.onkeypress=function(f){if(!f){f=window.event;
}if(f&&f.keyCode==13){return a(f,this);
}};
this._textElement=b;
var d=document.createElement("div");
var c=document.createElement("button");
c.onmousedown=function(){return false;
};
c.onclick=function(f){c.parentNode.getElementsByTagName("input")[0].Parent.fire();
return false;
};
c.className=this._rendermode=="Classic"?"reAjaxspell_okicon":"reAjaxSpellButton";
d.appendChild(b);
d.appendChild(c);
this._element=d;
return this._element;
}};
Telerik.Web.UI.EditorAjaxSpellTextbox.registerClass("Telerik.Web.UI.EditorAjaxSpellTextbox",Telerik.Web.UI.EditorSpellSuggestionBox);
(function(a,d,b,h){var f=a.proxy;
var e="click";
var g="Telerik.Web.UI.Editor.SpellCheck";
Type.registerNamespace(g);
var c=b.SpellCheck;
c.ViewFactory=function(){};
c.ViewFactory.getView=function(k){var l=null;
var i=k.get_editor();
var j=i.get_renderMode();
if(j==Telerik.Web.UI.RenderMode.Classic){l=new Telerik.Web.UI.Editor.SpellCheck.ClassicView(k);
}else{if(j==Telerik.Web.UI.RenderMode.Lite){l=new Telerik.Web.UI.Editor.SpellCheck.LightweightView(k);
}}return l;
};
c.IView=function(i){};
c.IView.prototype={initialize:function(){},dispose:function(){},toggleVisiblity:function(i){},toggleButtons:function(i){},renderInfoBox:function(i){},get_finishButton:function(){},get_cancelButton:function(){},get_wrapper:function(){}};
c.IView.registerInterface(g+".IView");
c.ViewBase=function(i){var j=this;
j._owner=null;
j._btnFinish=null;
j._btnCancel=null;
j._root=null;
j.initialize(i);
};
c.ViewBase.prototype={initialize:function(i){var j=this;
j._owner=i;
j._initUI();
j._attachHandlers();
},dispose:function(){var i=this;
i._detachHandlers();
i._owner=null;
i._btnFinish=null;
i._btnCancel=null;
i._root=null;
delete i._owner;
delete i._btnFinish;
delete i._btnCancel;
delete i._root;
},toggleVisiblity:function(j){var k=this;
var i=!!j?"":"none";
a(k._root).css("display",i);
},toggleButtons:function(i){var j=this;
a(j._btnCancel).attr("disabled",!i);
a(j._btnFinish).attr("disabled",!i);
},renderInfoBox:function(i){},get_finishButton:function(){return this._btnFinish;
},get_cancelButton:function(){return this._btnCancel;
},get_wrapper:function(){return this._root;
},_attachHandlers:function(){var i=this;
i._finishHandlerProxy=f(i._finishHandler,i);
i._cancelHandlerProxy=f(i._cancelHandler,i);
a(i._btnFinish).on(e,i._finishHandlerProxy);
a(i._btnCancel).on(e,i._cancelHandlerProxy);
},_detachHandlers:function(){var i=this;
a(i._btnFinish).off(e,i._finishHandlerProxy);
a(i._btnCancel).off(e,i._cancelHandlerProxy);
i._finishHandlerProxy=null;
i._cancelHandlerProxy=null;
delete i._finishHandlerProxy;
delete i._cancelHandlerProxy;
},_finishHandler:function(i){var k=this;
var j=k._owner;
i.preventDefault();
j.finishSpellCheck();
},_cancelHandler:function(i){var k=this;
var j=k._owner;
i.preventDefault();
j.cancelSpellCheck();
}};
c.ViewBase.registerClass(g+".ViewBase",null,c.IView);
c.ClassicView=function(i){c.ClassicView.initializeBase(this,[i]);
};
c.ClassicView.prototype={initialize:function(i){c.ClassicView.callBaseMethod(this,"initialize",[i]);
},dispose:function(){c.ClassicView.callBaseMethod(this,"dispose");
},renderInfoBox:function(i){var m=this;
var k=m._owner;
var j=m._root.rows[0].cells[0];
j.innerHTML="";
if(i){var l=document.createElement("span");
l.className=k._loadingIconCss;
j.appendChild(l);
j.innerHTML+="<label>"+k._spellingInProgressMessage+"</label>";
}else{j.innerHTML="<label>"+k._spellingModeMessage+"</label>";
}},_initUI:function(){var n=this;
var m=n._owner;
var k=document;
var l=k.createElement("table");
l.cellSpacing=2;
l.cellPadding=0;
l.className="reAjaxspell_wrapper";
l.style.width="100%";
l.style.backgroundColor="#ffffcc";
l.style.clear="both";
l.style.borderBottom="1px solid #adadad";
l.insertRow(-1);
var j=l.rows[0].insertCell(-1);
j.style.width="100%";
var i=k.createElement("button");
i.className="reAjaxspell_button";
j=l.rows[0].insertCell(-1);
n._btnFinish=i.cloneNode(true);
n._btnFinish.Parent=this;
n._btnFinish.innerHTML=m._finalCheckMessage;
j.appendChild(n._btnFinish);
j=l.rows[0].insertCell(-1);
n._btnCancel=i.cloneNode(true);
n._btnCancel.Parent=this;
n._btnCancel.innerHTML=m._cancelMessage;
j.appendChild(n._btnCancel);
n._root=l;
}};
c.ClassicView.registerClass(g+".ClassicView",c.ViewBase,c.IView);
c.LightweightView=function(i){var j=this;
j._uiCreated=false;
c.LightweightView.initializeBase(j,[i]);
};
c.LightweightView.prototype={initialize:function(i){c.LightweightView.callBaseMethod(this,"initialize",[i]);
},dispose:function(){var i=this;
c.LightweightView.callBaseMethod(i,"dispose");
delete i._uiCreated;
},renderInfoBox:function(i){var l=this;
var k=l._owner;
var j=a(l._root).find(".reAjaxSpellInfoContainer");
j.html("").append("<label>"+k._spellingModeMessage+"</label>");
if(i){j.prepend("<span class='"+k._loadingIconCss+"'></span>");
}},_initUI:function(){var n=this;
var m=n._owner;
var o="<div class='reAjaxSpellWrapper'><div class='reAjaxSpellInfoContainer'></div></div>";
var k="<button class='reAjaxSpellButton'></button>";
var l="<div class='reAjaxSpellButtonsContainer'></div>";
var i="<br class='reClear' />";
if(n._uiCreated){return;
}n._btnFinish=a(k).html(m._finalCheckMessage).get(0);
n._btnCancel=a(k).html(m._cancelMessage).get(0);
var j=a(l).append(n._btnFinish).append(n._btnCancel);
n._root=a(o).append(j).append(a(i)).get(0);
n._uiCreated=true;
}};
c.LightweightView.registerClass(g+".LightweightView",c.ViewBase,c.IView);
})($telerik.$,Telerik.Web.UI,Telerik.Web.UI.Editor);
if(typeof(Sys)!=='undefined')Sys.Application.notifyScriptLoaded();