Type.registerNamespace("Telerik.Web.UI");
Telerik.Web.UI.LightBoxItem=function(){Telerik.Web.UI.LightBoxItem.initializeBase(this);
this._description=null;
this._title=null;
this._targetControlID=null;
this._navigateUrl=null;
this._imageUrl=null;
this._width=null;
this._height=null;
this._hasItemTemplate=null;
this._hasDescriptionTemplate=null;
this._isRendered=null;
};
Telerik.Web.UI.LightBoxItem.prototype={_get_isEmpty:function(){return(!this._imageUrl&&!this._navigateUrl&&!this._get_hasTemplate());
},_get_hasTemplate:function(){return this._hasItemTemplate||this._hasDescriptionTemplate;
},get_description:function(){return this._description;
},get_title:function(){return this._title;
},get_targetControlID:function(){return this._targetControlID;
},get_navigateUrl:function(){return this._navigateUrl;
},get_imageUrl:function(){return this._imageUrl;
},get_width:function(){return this._width;
},get_height:function(){return this._height;
},set_description:function(a){this._description=a;
},set_title:function(a){this._title=a;
},set_targetControlID:function(a){this._targetControlID=a;
},set_navigateUrl:function(a){this._navigateUrl=a;
},set_imageUrl:function(a){this._imageUrl=a;
},set_width:function(a){this._width=a.toString();
},set_height:function(a){this._height=a;
},initialize:function(){Telerik.Web.UI.LightBoxItem.callBaseMethod(this,"initialize");
},dispose:function(){Telerik.Web.UI.LightBoxItem.callBaseMethod(this,"dispose");
}};
Telerik.Web.UI.LightBoxItem.registerClass("Telerik.Web.UI.LightBoxItem");
Type.registerNamespace("Telerik.Web.UI");
(function(){var c=".";
var a=$telerik.$;
var b=$telerik.isTouchDevice?"touchend":"click";
Telerik.Web.UI.LightBoxItemCollection=function(d){this._array=[];
this._ownerID=d;
};
Telerik.Web.UI.LightBoxItemCollection.prototype={add:function(e){var d=this._array.length;
this.insert(d,e);
},insert:function(d,e){var f=$find(this._ownerID);
var g=e&&e._targetControlID?e._targetControlID:"";
Array.insert(this._array,d,e);
if(g){a("#"+g).on(b+c+this._ownerID,{index:d},function(h){f.set_currentItemIndex(d);
f.show();
return false;
});
}},remove:function(d){var e=d&&d._targetControlID?d._targetControlID:"";
if(e){a("#"+e).off(b+c+this._ownerID);
}Array.remove(this._array,d);
},removeAt:function(d){var e=this.getItem(d);
if(e){this.remove(e);
}},clear:function(){for(var d=this.count()-1;
d>=0;
d--){this.removeAt(d);
}},get_count:function(){return this._array.length;
},getItem:function(d){return this._array[d];
},indexOf:function(e){for(var d=0,f=this._array.length;
d<f;
d++){if(this._array[d]===e){return d;
}}return -1;
},forEach:function(f){for(var e=0,d=this.get_count();
e<d;
e++){f(this._array[e]);
}},toArray:function(){return this._array.slice(0);
},count:function(){return this._array.length;
}};
Telerik.Web.UI.LightBoxItemCollection.registerClass("Telerik.Web.UI.LightBoxItemCollection");
})();
$telerik.findLightBox=$find;
$telerik.toLightBox=function(a){return a;
};
Type.registerNamespace("Telerik.Web.UI");
(function(c,b,a,g){var f=".",e=$telerik.isTouchDevice?"touchend":"click";
Telerik.Web.UI.RadLightBox=function(h){c.RadLightBox.initializeBase(this,[h]);
this._clientSettings={};
this._data={};
this._modal=false;
this._items={};
this._loadingPanelID=null;
this._zIndex=3500;
this._width=null;
this._height=null;
this._itemsCounterFormatString="Image {0} of {1}";
this._currentItemIndex=0;
this._currentAction=c.LightBoxAction.Show;
this._loopItems=false;
this._loadingPanel=null;
this._tabIndex=101;
this._preserveTemplates=false;
this._visibleOnLoad=false;
this._clientID=h.id;
this._uniqueID=null;
this._element=h;
this._$element=a(h);
this._paddingLR=0;
this._paddingTB=0;
this._isWaiting=false;
this._loading=false;
this._completeCount=0;
this._clientDataSourceID="";
this._clientDataSource=null;
this._dataSource=null;
this._descriptionField=null;
this._imageUrlField=null;
this._navigateUrlField=null;
this._targetControlIDField=null;
this._titleField=null;
this._descriptionCollapsed=false;
this._maximizeMode=c.LightBoxMaximizeMode.None;
this._renderMode=c.RenderMode.Classic;
this._lastMousePosition=c.LightBoxMousePosition.Outside;
this._descriptionPosition=c.LightBoxDescriptionPosition.Bottom;
this._animationInProgress=false;
this._removeCloseButton=false;
this._removePrevButton=false;
this._removeNextButton=false;
this._enableAriaSupport=false;
this._removeMaximizeButton=false;
this._removeRestoreButton=false;
this._isInNativeFullscreenMode=false;
this._userExitFullscreen=false;
this._wrapper=this._$element.find(".rltbWrapper").get(0);
this._imageAnimations=new Telerik.Web.UI.RadImageAnimations();
this._$imageElement=this._$element.find(".rltbItemBox .rltbActiveImage");
this._$contentFrame=this._$element.find(".rltbItemBox .rltbActiveFrame");
this._$descriptionBox=this._$element.find(".rltbDescriptionBox");
this._$description=this._$element.find(".rltbDescriptionBox div.rltbDescription"),this._$title=this._$element.find(".rltbDescriptionBox h4.rltbTitle");
this._$itemBox=this._$element.find(".rltbItemBox");
this._$prevButton=this._$element.find(".rltbButtonWrapper.rltbPrevButtonWrapper");
this._$nextButton=this._$element.find(".rltbButtonWrapper.rltbNextButtonWrapper");
if(!this._$prevButton.length){this._$prevButton=this._$element.find(".rltbPrevButton");
this._$nextButton=this._$element.find(".rltbNextButton");
}this._$closeButton=this._$element.find(".rltbClose");
if(this._$closeButton.length===0){this._$closeButton=this._$element.find(".rltbCloseButton");
}this._$maximizeButton=this._$element.find(".rltbActionButton.rltbMaximizeButton");
this._$restoreButton=this._$element.find(".rltbActionButton.rltbRestoreButton");
this._$itemTemplate=this._$element.find(".rltbItemTemplate");
this._$descriptionTemplate=this._$element.find(".rltbDescriptionTemplate");
this._$itemsCounter=this._$element.find(".rltbDescriptionBox .rltbPager");
this._$overlay=this._$element.prev(".rltbOverlay");
};
c.RadLightBox.prototype={initialize:function(){c.RadLightBox.callBaseMethod(this,"initialize");
var h=this;
h._initializeEvents();
if(!h._data){h._data={};
}if(!h._data._itemsData){h._data._itemsData=[];
}h._createItems();
h._$imageElement.hide();
h._$contentFrame.hide();
h.set_navigationMode(h._clientSettings._navigationMode||c.LightBoxNavigationMode.Button);
if(h._visibleOnLoad){setTimeout(a.proxy(h.show,h));
}h._paddingLR=parseInt(h._$element.css("padding-left"),10)+parseInt(h._$element.css("padding-right"),10);
h._paddingTB=parseInt(h._$element.css("padding-top"),10)+parseInt(h._$element.css("padding-bottom"),10);
if(h._removeNextButton){h._$nextButton.hide();
}if(h._removePrevButton){h._$prevButton.hide();
}if(h._removeMaximizeButton){h._$maximizeButton.hide();
h._$maximizeButton=a();
}if(h._removeRestoreButton){h._$restoreButton.hide();
h._$restoreButton=a();
}if($telerik.isTouchDevice){d(h._$element,{swipeLeft:function(i){h.next();
},swipeRight:function(i){h.prev();
},tap:function(i){h._imageTap();
}});
}Sys.Application.add_load(a.proxy(h._initializeAutoDataBind,h));
if(h._enableAriaSupport){h._initializeAriaSupport();
}if(h._renderMode===c.RenderMode.Mobile&&$telerik.isIE){h._$itemBox.on("click",a.proxy(h._focusControl,h));
}a.raiseControlEvent(h,"load",{});
},dispose:function(){var h=this;
a.raiseControlEvent(h,"destroying",{});
if(h._renderMode===c.RenderMode.Mobile&&$telerik.isIE){h._$itemBox.off("click",h._focusControl);
}h._hideLoadingPanel();
c.RadLightBox.callBaseMethod(h,"dispose");
h._loadingPanel=null;
h.get_items().clear();
h._$contentFrame.attr("src","");
h._$itemTemplate.children().remove();
h._imageAnimations.remove_animationStart(h._imageAnimationStart);
h._imageAnimations.remove_animationEnd(h._imageAnimationEnd);
a(document).off("keydown"+f+h._clientID);
a(window).off("resize"+f+h._clientID);
h._$element.off("mousemove").off("mouseout").off("mouseenter");
h._$prevButton.off(e);
h._$nextButton.off(e);
},_initializeEvents:function(){var h=this;
h._$imageElement.on("load",a.proxy(h._loaded,h));
h._$contentFrame.on("load",a.proxy(h._loaded,h));
h._$element.on("mouseout",a.proxy(h._handleMouseOut,h)).on("mouseenter",a.proxy(h._handleMouseMove,h));
a(document).on("keydown"+f+h._clientID,{sender:h},h._handleKeyDown);
if(h._clientSettings._autoResize||true){a(window).on("resize"+f+h._clientID,{sender:h},a.proxy(h._handleAutoResize,h));
}h._imageAnimations.add_animationStart(a.proxy(h._imageAnimationStart,h));
h._imageAnimations.add_animationEnd(a.proxy(h._imageAnimationEnd,h));
h._$maximizeButton.on(e,a.proxy(h._maximizeButtonClick,h));
h._$restoreButton.on(e,a.proxy(h._restoreButtonClick,h));
h._$closeButton.on(e,a.proxy(h._closeButtonClick,h));
a(document).on("mozfullscreenchange webkitfullscreenchange fullscreenchange MSFullscreenChange",a.proxy(h._handleFullscreenChange,h));
if(h._modal&&!h._clientSettings._preventOverlayClose){h._$overlay.on(e,function(i){i.stopPropagation();
h._focusControl();
h.hide();
return false;
});
}},_initializeAriaSupport:function(){var i=this;
var h=a(i._wrapper);
i._$element.attr("role","dialog");
h.attr("aria-live","assertive");
h.attr("aria-atomic","true");
h.attr("aria-relevant","text");
h.attr("aria-busy","false");
},_forceExitFullscreen:function(){var i=this;
var h=i._clientSettings._hideAnimation;
i._clientSettings._hideAnimation=c.LightBoxAnimationType.None;
i.hide();
i.restore();
i._clientSettings._hideAnimation=h;
},_handleFullscreenChange:function(h){var i=this;
if(i._isInNativeFullscreenMode&&!i._userExitFullscreen){i._isInNativeFullscreenMode=false;
i._forceExitFullscreen();
}else{i._isInNativeFullscreenMode=!i._isInNativeFullscreenMode;
}i._userExitFullscreen=false;
},_handleMouseMove:function(h){this._determineNavigationButtonsVisibility(h);
},_handleMouseOut:function(j){var m=this,i=m._element.getBoundingClientRect(),k=i.left,l=i.right,n=i.top,h=i.bottom;
if((j.clientX<k||j.clientX>l||j.clientY<n||j.clientY>h)&&m._determineContentMode()===c.LightBoxContentMode.Image&&m._renderMode!=c.RenderMode.Mobile){m._showPrevButton(false);
m._showNextButton(false);
}m._lastMousePosition=c.LightBoxMousePosition.Outside;
},_handleKeyDown:function(h){var k=h.data.sender,i=k._element,j=k._clientSettings._allowKeyboardNavigation;
if(i.style.display==="none"){return;
}if(j||k._maximizeMode!=c.LightBoxMaximizeMode.None){if(h.ctrlKey&&h.keyCode===89){h.preventDefault();
k._focusControl();
}if(document.activeElement===i||document.activeElement===k._wrapper||k._maximizeMode!=c.LightBoxMaximizeMode.None){switch(h.keyCode){case 27:h.preventDefault();
k._forceExitFullscreen();
break;
case 37:h.preventDefault();
j?k.prev():a.noop();
break;
case 39:h.preventDefault();
j?k.next():a.noop();
break;
}}}},_handleAutoResize:function(h){var i=this;
clearTimeout(i.timeoutIdentifier);
i.timeoutIdentifier=setTimeout(a.proxy(i._autoResizeLightBox,i),200);
},_handleMetaViewport:function(){if(!$telerik.isTouchDevice){return;
}var k=this,i=k._clientID+"_meta",j=document.getElementById(i),h="";
if(k._maximizeMode==c.LightBoxMaximizeMode.Forced||document.documentElement.clientWidth<=640){h="user-scalable=no,initial-scale=1";
if(!j){if(a("meta[name=viewport]").length>0){return;
}j=document.createElement("meta");
j.id=i;
j.setAttribute("name","viewport");
document.head.appendChild(j);
}}if(j){j.setAttribute("content",h);
}},_autoResizeLightBox:function(){var h=this;
if(h._element.style.visibility=="hidden"||h._element.style.display=="none"){return;
}h._resize();
},_focusControl:function(){var h=this;
if(h._enableAriaSupport){h._$descriptionBox.focus();
}if(h._clientSettings._allowKeyboardNavigation&&document.activeElement!==h._element&&document.activeElement!==h._wrapper){if(h._tabIndex){h._element.tabIndex=h._tabIndex;
}h._$element.focus();
}},_getCurrentItem:function(){return this.get_items().getItem(this._currentItemIndex);
},_showLightBoxStructure:function(o){var n=this,m=o?"":"none",k=n._determineContentMode(),l=n._getCurrentItem(),i=n._$imageElement,j=n._$itemTemplate,h=n._$contentFrame;
n._showCloseButton(o);
n._$descriptionBox.css({display:n._descriptionCollapsed?"none":m});
if(k===c.LightBoxContentMode.Image){if(!n._isImageAnimation(n._getCurrentAnimation())){n._switchContainerVisibility(i,o);
}h.hide();
if(j){j.hide();
}}else{if(k===c.LightBoxContentMode.Iframe){i.hide();
n._switchContainerVisibility(h,o);
if(j){j.hide();
}}else{if(k===c.LightBoxContentMode.Empty){i.hide();
h.hide();
j.hide();
n._$descriptionTemplate.hide();
}}}if(l._hasItemTemplate){h.hide();
i.hide();
n._switchContainerVisibility(j,o);
}if(l._hasDescriptionTemplate){n._$description.hide();
n._$title.hide();
n._$descriptionTemplate.css({display:m});
}else{n._$description.css({display:m});
n._$title.css({display:m});
n._$descriptionTemplate.hide();
}if(!o){n._showPrevButton(o);
n._showNextButton(o);
}if(n._clientSettings._showItemsCounter===false){n._$itemsCounter.hide();
}},_switchContainerVisibility:function(h,i){if(i){h.show();
h.css({visibility:"visible"});
}else{h.css({visibility:"hidden"});
}},_isNullOrEmpty:function(h){if(!h){h="";
}return !a.trim(h.toString());
},_imageTap:function(i){var k=this,h=k._$descriptionBox,j;
if(k._descriptionPosition==c.LightBoxDescriptionPosition.OverlayBottom||k._descriptionPosition==c.LightBoxDescriptionPosition.OverlayTop){h.slideToggle({complete:function(){k._descriptionCollapsed=h.css("display")=="none";
}});
}if(!k._removeNextButton){j=k._$nextButton.css("right")=="10px"?-100:10;
k._$nextButton.animate({right:j});
}if(!k._removePrevButton){j=k._$prevButton.css("left")=="10px"?-100:10;
k._$prevButton.animate({left:j});
}},_closeButtonClick:function(h){h.stopPropagation();
this.hide();
return false;
},_maximizeButtonClick:function(h){h.stopPropagation();
this.maximize();
},_restoreButtonClick:function(h){h.stopPropagation();
this.restore();
},_imageAnimationStart:function(i,h){var j=this;
if(j._animationInProgress){h.set_cancel(true);
return;
}j._animationInProgress=true;
if($telerik.isIE7){j._$itemBox.css("overflow","visible");
}if(j._renderMode==c.RenderMode.Mobile){j._$itemBox.height(h.get_$newImage().height());
}if(j._renderMode==c.RenderMode.Lite){h.get_$newImage().css({paddingLeft:j._$element.css("paddingLeft")});
}j._$imageElement.css({position:"absolute",paddingTop:parseInt(j._$imageElement.css("paddingTop"),10)||j._paddingTB/2});
},_imageAnimationEnd:function(j,i){var k=this,h=i.get_$image();
if($telerik.isIE7){k._$itemBox.css("overflow","hidden");
}h.css({position:"relative",paddingTop:parseInt(h.css("paddingTop"),10)-k._paddingTB/2});
if(k._renderMode==c.RenderMode.Lite){h.css({paddingLeft:0});
}k._animationInProgress=false;
},_getDefaultWidth:function(){return a(window).width()/3;
},_getDefaultHeight:function(){return a(window).height()/3;
},_showLoadingPanel:function(){var i=this,h=this._getLoadingPanel();
if(h&&!i._loading){i._hideLoadingPanel();
i._loading=true;
h.show(this._clientID);
}},_hideLoadingPanel:function(){var i=this,h=this._getLoadingPanel();
i._loading=false;
if(h){h.hide(this._clientID);
}},_getLoadingPanel:function(){var h=this;
if(!h._loadingPanel&&!h._isNullOrEmpty(h._loadingPanelID)){h._loadingPanel=$find(h._loadingPanelID);
}return h._loadingPanel;
},_removeDimensionProperties:function(h){if(!h||!h.style){return;
}h.style.width=null;
h.style.height=null;
},_setOverflows:function(){var j=this,h=j._$element,i=j._getOuterEffectSize()+j._getButtonStickOutSize();
j._overflows=h.height()+i>=a(window).height()?"y":h.width()+i>a(window).width()?"x":false;
},_getImageDimensions:function(h,i){h.get(0).style.width=null;
h.get(0).style.height=null;
var k=i.width,j=i.height,l=h.height(),m=h.width(),n;
if(m>k){h.width(k);
l=h.height();
}if(l>j){h.width(h.width()*(j/l)).height(j);
}n={width:h.width(),height:h.height()};
h.get(0).style.width=null;
h.get(0).style.height=null;
return n;
},_determineFitModeContentDimensions:function(j,i){var h,n=j.width,k=j.height,m=i.width,l=i.height;
if(n>m){h=m/n;
n=n*h;
k=k*h;
}else{if(n<m){h=m/n;
n=n*h;
k=k*h;
}}if(k>l){h=l/k;
n=n*h;
k=k*h;
}return{width:Math.round(n),height:Math.round(k)};
},_getAvailableContentSpace:function(i){var k=this,h=i||k._getContentDimensions(),l=h.width,j=h.height;
if(k._overflows||k._maximizeMode!=c.LightBoxMaximizeMode.None){if(k._maximizeMode!=c.LightBoxMaximizeMode.None){l=document.documentElement.clientWidth-k._paddingLR;
}else{if(k._overflows){l=Math.min(k._renderMode==c.RenderMode.Mobile&&k._determineContentMode()==c.LightBoxContentMode.Image?l:k._$element.width()-k._paddingLR,a(window).width()-k._paddingLR-k._getOuterEffectSize()-k._getButtonStickOutSize());
}}if(k._overflows=="y"||k._maximizeMode!=c.LightBoxMaximizeMode.None){j=document.documentElement.clientHeight-k._paddingTB-k._getOuterEffectSize()-k._getDescriptionHeight(l)-k._getButtonStickOutSize();
}}return{width:l,height:j};
},_getContentDimensions:function(){var n=this;
var j=n._determineContentMode();
var h=j==c.LightBoxContentMode.Image?n._$imageElement:a();
n._removeDimensionProperties(h.get(0));
var l=n._getCurrentItem();
var i={width:h.width()||n._getDefaultWidth(),height:h.height()||n._getDefaultHeight()};
var k=n._clientSettings._contentResizeMode||c.LightBoxContentResizeMode.Fit;
var o;
var m;
if((n._overflows||n._maximizeMode!=c.LightBoxMaximizeMode.None)){if(j==c.LightBoxContentMode.Image&&k==c.LightBoxContentResizeMode.None){return n._getImageDimensions(h,n._getAvailableContentSpace(i));
}else{if(k==c.LightBoxContentResizeMode.Fill||j!=c.LightBoxContentMode.Image){return n._getAvailableContentSpace(i);
}else{if(k==c.LightBoxContentResizeMode.Fit){return n._determineFitModeContentDimensions(i,n._getAvailableContentSpace(i));
}}}}if(!n._isNullOrEmpty(l.get_width())){o=parseFloat(l.get_width());
}else{if(!n._isNullOrEmpty(n._width)){o=parseFloat(n._width,10);
}else{o=i.width;
}}if(!n._isNullOrEmpty(l.get_height())){m=parseFloat(l.get_height());
}else{if(!n._isNullOrEmpty(n._height)){m=parseFloat(n._height,10);
}else{m=i.height;
}}return{width:o,height:m};
},_getFrameDimensions:function(){if(this._maximizeMode!=c.LightBoxMaximizeMode.None){return{};
}var k=this;
var i=k._paddingTB==0?30:k._paddingTB;
var h=k._getAvailableContentSpace(),l=h.width+k._paddingLR,j=h.height+i+k._getDescriptionHeight(h.width);
return{width:l,height:j,marginLeft:-l/2-k._paddingLR/2-k._getButtonStickOutSize()/2,marginTop:-j/2-k._paddingTB/2+k._getButtonStickOutSize()/2};
},_getButtonStickOutSize:function(){var j=this,h=j._$closeButton,i=0;
if(j._$closeButton.length&&h.is(":visible")&&j._renderMode!=c.RenderMode.Mobile){i=(j._$element.offset().top-h.offset().top);
}return i;
},_getOuterEffectSize:function(){var j=this,h=j._$element.find(".rltbGlowEffect"),i=0;
if(h.length){i=h.outerHeight()-j._$element.height();
}else{if(j._renderMode==c.RenderMode.Mobile&&document.documentElement.clientWidth>640){i=18;
}}return i;
},_resizeContent:function(l){var m=this,j=m._getContentDimensions(),k=m._determineContentMode(),h=k==c.LightBoxContentMode.Image?m._$imageElement:m._$contentFrame,i=m._getAvailableContentSpace(j),n;
h.css(j);
if($telerik.isIE7||m._getCurrentItem()._get_isEmpty()){m._$itemBox.css(i);
}else{m._removeDimensionProperties(m._$itemBox.get(0));
}if(m._clientSettings._contentResizeMode!=c.LightBoxContentResizeMode.Fill){n=Math.round((i.height-h.height())/2);
h.css("paddingLeft",0).css({paddingLeft:Math.round((m._$itemBox.width()-h.width())/2),paddingTop:n,paddingBottom:n});
}},_resizeFrame:function(){var i=this,h=i._getFrameDimensions();
i._$element.css(h);
},_resize:function(){var h=this;
h._toggleMaximizeStyles();
h._toggleMaximizeRestoreButtons();
h._overflows=false;
h._resizeFrame();
h._setOverflows();
if(h._overflows){h._resizeFrame();
}h._resizeContent();
h._handleMetaViewport();
},_toggleMaximizeStyles:function(){var i=this,h=i._$element;
if(i._maximizeMode!=c.LightBoxMaximizeMode.None){h.addClass("rltbMaximized").css({top:0,left:0,width:"100%",height:"100%",marginTop:0,marginLeft:0});
}else{h.removeClass("rltbMaximized").css({top:"50%",left:"50%"});
}},_getDescriptionHeight:function(k){var j=this,i=j._$element.width(),h=0;
if((j._descriptionPosition!=c.LightBoxDescriptionPosition.OverlayBottom&&j._descriptionPosition!=c.LightBoxDescriptionPosition.OverlayTop)){j._$element.width(k+j._paddingLR);
h=j._$descriptionBox.outerHeight()+j._paddingTB/2;
j._$element.width(i);
}return h;
},_showCloseButton:function(h){var i=this;
if(!i._removeCloseButton){i._$closeButton.css({display:h?"":"none"});
}},_showPrevButton:function(h){var i=this;
if(!i._removePrevButton){i._$prevButton.css({display:h?"":"none"});
}},_showNextButton:function(h){var i=this;
if(!i._removeNextButton){i._$nextButton.css({display:h?"":"none"});
}},_onZoneClick:function(i){var m=this,h=m._element.getBoundingClientRect(),l=m._$element.width()/2+h.left,j=i.clientX<l&&i.clientX>=h.left,k=i.clientX>l&&i.clientX<=h.left+m._$element.width();
if(i.clientY>=h.top&&i.clientY<=h.top+m._$element.height()){if(j){m.prev();
}else{if(k){m.next();
}}}},_createItems:function(){var o=this,k=o._items=new c.LightBoxItemCollection(o._clientID),m=o._data._itemsData,j;
for(var h=0,n=m.length;
h<n;
h++){j=new c.LightBoxItem();
j._description=m[h].Description;
j._imageUrl=m[h].ImageUrl;
j._navigateUrl=m[h].NavigateUrl;
j._targetControlID=m[h].TargetControlID;
j._title=m[h].Title;
if(o._isNullOrEmpty(m[h].Width)&&m[h].HasItemTemplate){j._width=o._width?o._width:o._getDefaultWidth();
}else{j._width=m[h].Width;
}if(o._isNullOrEmpty(m[h].Height)&&m[h].HasItemTemplate){j._height=o._height?o._height:o._getDefaultHeight();
}else{j._height=m[h].Height;
}j._hasItemTemplate=m[h].HasItemTemplate;
j._hasDescriptionTemplate=m[h].HasDescriptionTemplate;
j._isRendered=m[h].IsRendered;
k.add(j);
}},_determineNavigationButtonsVisibility:function(i){var n=this,j=n._currentItemIndex===0,k=n._currentItemIndex>=n.get_items().count()-1,h=n._determineContentMode(),m,l;
if(!n._isWaiting||n._items.count()===1){n._showPrevButton(false);
n._showNextButton(false);
return;
}if(i){m=n._$element.width()/2+n._$element.offset().left;
l=i.clientX<m;
n._lastMousePosition=l?c.LightBoxMousePosition.Left:c.LightBoxMousePosition.Right;
}else{if(n._lastMousePosition==c.LightBoxMousePosition.Outside&&h===c.LightBoxContentMode.Image&&n._renderMode!=c.RenderMode.Mobile){n._showPrevButton(false);
n._showNextButton(false);
return;
}l=n._lastMousePosition==c.LightBoxMousePosition.Left;
}if(n._renderMode!=c.RenderMode.Mobile){n._showPrevButton((h!==c.LightBoxContentMode.Image||l)&&(!j||n._loopItems));
n._showNextButton((h!==c.LightBoxContentMode.Image||!l)&&(!k||n._loopItems));
}else{n._showPrevButton(true);
n._showNextButton(true);
}},_determineContentMode:function(){var i=this,h=i._getCurrentItem();
if(!i._isNullOrEmpty(h.get_imageUrl())){return c.LightBoxContentMode.Image;
}else{if(!i._isNullOrEmpty(h.get_navigateUrl())){return c.LightBoxContentMode.Iframe;
}else{if(h._get_isEmpty()){return c.LightBoxContentMode.Empty;
}}}return c.LightBoxContentMode.Template;
},_saveFrameDimensions:function(){var h=this._$element;
this._frameDimensions={width:h.width(),height:h.height(),marginLeft:h.css("marginLeft"),marginTop:h.css("marginTop")};
},_restoreFrameDimensions:function(){this._$element.css(this._frameDimensions);
},_loaded:function(){var i=this,h;
if(i._callback){i._hideLoadingPanel();
i._showLightBoxStructure(true);
i._saveFrameDimensions();
i._resize();
i._animateElement(function(){if(i._callback){h=i._callback;
i._callback=null;
h();
}});
}},_isImageAnimation:function(h){return(h!=Telerik.Web.UI.LightBoxAnimationType.None&&h!=Telerik.Web.UI.LightBoxAnimationType.Resize&&h!=Telerik.Web.UI.LightBoxAnimationType.Fade);
},_getAnimationSpeed:function(){var h=this;
switch(h._currentAction){case c.LightBoxAction.Prev:return h._clientSettings._prevAnimationSpeed||400;
case c.LightBoxAction.Next:return h._clientSettings._nextAnimationSpeed||400;
case c.LightBoxAction.Show:return h._clientSettings._showAnimationSpeed||400;
case c.LightBoxAction.Hide:return h._clientSettings._hideAnimationSpeed||400;
}},_getAnimationEasing:function(){var i=this,h;
switch(i._currentAction){case c.LightBoxAction.Prev:h=i._clientSettings._prevAnimationEasing||c.LightBoxEasingType.linear;
break;
case c.LightBoxAction.Next:h=i._clientSettings._nextAnimationEasing||c.LightBoxEasingType.linear;
break;
case c.LightBoxAction.Show:h=i._clientSettings._showAnimationEasing||c.LightBoxEasingType.linear;
break;
case c.LightBoxAction.Hide:h=i._clientSettings._hideAnimationEasing||c.LightBoxEasingType.linear;
break;
}return c.LightBoxEasingType.toString(h);
},_displayControl:function(l){var m=this,j=m._getCurrentAnimation(),k=m._getCurrentItem(),i=m._getAnimationSpeed(),h=m._getAnimationEasing();
if(m._animationInProgress){return;
}m._isWaiting=false;
if(!m._isNullOrEmpty(k.get_navigateUrl())){m._ensureIframeIsCreated();
}m._$element.off("mousemove");
m._showLightBoxStructure(false);
if(l===0){m._resizeFrame();
}if(j==c.LightBoxAnimationType.None||m._isImageAnimation(j)||l==2){m._$element.show();
m._showLoadingPanel();
m._load(a.proxy(m._onShowed,m));
}else{if(j==c.LightBoxAnimationType.Resize){m._$element.show(i/2,h,function(){m._showLoadingPanel();
m._load(function(){m._showLightBoxStructure(true);
m._resizeContent();
m._onShowed();
});
});
}else{if(j==c.LightBoxAnimationType.Fade){m._$element.fadeIn(i/2,h,a.proxy(m._complete,m,2));
m._showLoadingPanel();
m._load(a.proxy(m._complete,m,2));
}}}},_animateElement:function(l){var o=this,h=o._getCurrentAnimation(),m=o._determineContentMode(),k=o._getAnimationSpeed(),i=o._getAnimationEasing(),n,j;
if(h==c.LightBoxAnimationType.Resize){n=o._getFrameDimensions();
o._restoreFrameDimensions();
o._showLightBoxStructure(false);
o._$element.animate(n,k/2,i,a.proxy(l,o)).css("overflow","visible");
}else{if(h==c.LightBoxAnimationType.Fade){o._$imageElement.add(o._$contentFrame).hide();
switch(m){case c.LightBoxContentMode.Image:o._$imageElement.fadeIn(k/2,i,a.proxy(l,o));
break;
case c.LightBoxContentMode.Iframe:o._$contentFrame.fadeIn(k/2,i,a.proxy(l,o));
break;
default:l();
break;
}}else{if(o._isImageAnimation(h)){j=function(p){o._imageAnimations.remove_animationEnd(j);
l();
};
o._imageAnimations.add_animationEnd(j);
o._imageAnimations.show(o._$imageElement.hide(),{type:c.LightBoxAnimationType.toString(h),speed:k,easing:i});
}else{l();
}}}},_complete:function(h){if(++this._completeCount==h){this._completeCount=0;
this._onShowed();
}},_load:function(h){var k=this,j=k._getCurrentItem(),i=k._determineContentMode();
k._callback=h;
if(!j._hasDescriptionTemplate){k._$description.html(j.get_description());
k._$title.html(j.get_title());
}if(k._clientSettings._showItemsCounter!==false){k._$itemsCounter.html(String.format(k._itemsCounterFormatString,k._currentItemIndex+1,k.get_items().count()));
}if(j._get_hasTemplate()&&j._hasItemTemplate){k._loaded();
return;
}if(i==c.LightBoxContentMode.Image){if(k._$imageElement.attr("src")==j.get_imageUrl()){k._loaded();
}else{k._$imageElement.attr("src",j.get_imageUrl());
}}else{if(i==c.LightBoxContentMode.Iframe){if(k._$contentFrame.attr("src")==j.get_navigateUrl()){k._loaded();
}else{k._$contentFrame.show();
k._$contentFrame.attr("src",j.get_navigateUrl());
}}else{k._loaded();
}}},_getCurrentAnimation:function(){var i=this,h=c.LightBoxAnimationType.None;
switch(i._currentAction){case c.LightBoxAction.Show:h=i._clientSettings._showAnimation||c.LightBoxAnimationType.None;
break;
case c.LightBoxAction.Prev:h=i._clientSettings._prevAnimation||c.LightBoxAnimationType.None;
break;
case c.LightBoxAction.Next:h=i._clientSettings._nextAnimation||c.LightBoxAnimationType.None;
break;
}if((i._isImageAnimation(h)&&i._determineContentMode()!=Telerik.Web.UI.LightBoxContentMode.Image)||(h==c.LightBoxAnimationType.Resize&&i._maximizeMode!=c.LightBoxMaximizeMode.None)){h=Telerik.Web.UI.LightBoxAnimationType.None;
}return h;
},_setCurrentAction:function(h){var i=this;
if(h<i._currentItemIndex){i._currentAction=c.LightBoxAction.Prev;
}else{if(h>i._currentItemIndex){i._currentAction=c.LightBoxAction.Next;
}else{i._currentAction=c.LightBoxAction.Show;
}}},_ensureIframeIsCreated:function(){var i=this,h="<iframe style='display:none' frameborder='0' class='rltbActiveFrame'></iframe>";
if(!i._$contentFrame.get(0)){i._$itemBox.append(h);
i._$contentFrame=i._$element.find(".rltbItemBox .rltbActiveFrame").on("load",a.proxy(i._loaded,i));
}},_toggleMaximizeRestoreButtons:function(){var j=this,h=j._$maximizeButton,i=j._$restoreButton;
if(j._maximizeMode==c.LightBoxMaximizeMode.None){h.css("visibility","visible");
h.show();
i.hide();
}else{if(j._maximizeMode==c.LightBoxMaximizeMode.Forced){h.hide();
i.css("visibility","visible");
i.show();
}}},_adjustItemIndex:function(h){var k=this,i=k.get_items().get_count()-1,j=h;
if(h<0){j=k._loopItems?i:0;
}else{if(h>i){j=k._loopItems?0:i;
}}k._currentItemIndex=j;
},_constructPostBackData:function(i,h){return String.format("FireCommand:{0}|;{1}|;",i,h);
},_executePostBackEvent:function(h){var i="__doPostBack('{0}','{1}')";
i=i.replace("{0}",this._uniqueID);
i=i.replace("{1}",h);
eval(i);
},_ensureTemplatesLoaded:function(){var i=this,h=i._getCurrentItem();
if(i._clientSettings._descriptionTemplate||i._clientSettings._itemTemplate){i._instantiateTemplates();
}else{if(h._get_hasTemplate()&&!h._isRendered){i.fireCommand("NavigateTo",i._currentItemIndex);
return true;
}}return false;
},_enterNativeFullscreenMode:function(){var j=this;
var i=j.get_element();
var h=j._$element;
if(i.requestFullscreen){i.requestFullscreen();
}else{if(i.webkitRequestFullscreen){i.webkitRequestFullscreen();
h.width("100%");
h.height("100%");
}else{if(i.mozRequestFullScreen){i.mozRequestFullScreen();
}else{if(i.msRequestFullscreen){i.msRequestFullscreen();
}else{j._isInNativeFullscreenMode=false;
}}}}},_exitNativeFullscreenMode:function(){var h=this;
h._userExitFullscreen=true;
if(document.cancelFullscreen){document.cancelFullscreen();
}else{if(document.webkitCancelFullScreen){document.webkitCancelFullScreen();
}else{if(document.mozCancelFullScreen){document.mozCancelFullScreen();
}else{if(document.msCancelFullscreen){document.msCancelFullscreen();
}else{if(document.exitFullscreen){document.exitFullscreen();
}else{if(document.msExitFullscreen){document.msExitFullscreen();
}else{h._clientSettings._fullscreenMode=null;
}}}}}}},get_rippleZonesConfiguration:function(){return[{element:this.get_element(),rippleConfigurations:[{containerSelector:".rltbPrevButtonWrapper, .rltbNextButtonWrapper",rippleType:Telerik.Web.UI.MaterialRippleType.Icon,maxRippleSize:106}]}];
},show:function(){var i=this;
var h;
if(i.get_items().count()===0){return;
}i._adjustItemIndex(i._currentItemIndex);
if(!i._ensureTemplatesLoaded()){i._onShowing();
i._currentAction=c.LightBoxAction.Show;
if(i._modal){i._$overlay.show();
}this._displayControl(0);
}if(i._enableRippleEffect&&!i._toolBarRippleInitialized&&Telerik.Web.UI.MaterialRippleManager.getInstance()){setTimeout(function(){h=Telerik.Web.UI.MaterialRippleManager.getInstance();
if(i._$maximizeButton.length){h.initializeRipple(i._$maximizeButton.get(0),{rippleType:Telerik.Web.UI.MaterialRippleType.Icon,maxRippleSize:i._$maximizeButton.width()/0.6});
}if(i._$restoreButton.length){h.initializeRipple(i._$restoreButton.get(0),{rippleType:Telerik.Web.UI.MaterialRippleType.Icon,maxRippleSize:i._$restoreButton.width()/0.6});
}if(i._$closeButton.length){h.initializeRipple(i._$closeButton.get(0),{rippleType:Telerik.Web.UI.MaterialRippleType.Icon,maxRippleSize:i._$closeButton.outerWidth()/0.6});
}i._toolBarRippleInitialized=true;
});
}},hide:function(){var l=this,j=l._clientSettings._hideAnimation||c.LightBoxAnimationType.None,i,h,k;
l._currentAction=c.LightBoxAction.Hide;
i=l._getAnimationSpeed();
h=l._getAnimationEasing();
l._isWaiting=false;
l._onClosing();
l._hideLoadingPanel();
l._determineNavigationButtonsVisibility();
if(j==c.LightBoxAnimationType.Resize){l._showLightBoxStructure(false);
if(l._element.style.width=="100%"||l._element.style.height=="100%"){l._$element.css({marginTop:-(document.documentElement.clientHeight/2),marginLeft:-(document.documentElement.clientWidth/2),left:"50%",top:"50%"});
}l._$closeButton.hide();
l._$element.hide(i,h,function(){l._$overlay.hide();
l._onClosed();
});
}else{if(j==c.LightBoxAnimationType.None){l._$overlay.hide();
l._$element.hide();
l._onClosed();
}else{if(j==c.LightBoxAnimationType.Fade){l._$element.fadeOut(i,h,function(){l._$overlay.hide();
l._onClosed();
});
}else{if(l._isImageAnimation(j)){k=function(){l._$overlay.hide();
l._imageAnimations.remove_animationEnd(k);
l._$element.hide();
l._onClosed();
};
l._imageAnimations.add_animationEnd(k);
l._imageAnimations.hide(l._$imageElement,{type:c.LightBoxAnimationType.toString(j),speed:i,easing:h,dispose:false});
}}}}},maximize:function(){var h=this;
h._maximizeMode=c.LightBoxMaximizeMode.Forced;
if(h.get_fullscreenMode()){h._enterNativeFullscreenMode();
}h._resize();
},restore:function(){var h=this;
h._maximizeMode=c.LightBoxMaximizeMode.None;
if(h.get_fullscreenMode()){h._exitNativeFullscreenMode();
}h._resize();
},get_modal:function(){return this._modal;
},set_modal:function(h){this._modal=h;
},get_loopItems:function(){return this._loopItems;
},set_loopItems:function(h){this._loopItems=h;
},get_items:function(){return this._items;
},get_currentItemIndex:function(){return this._currentItemIndex;
},set_currentItemIndex:function(h){h=parseInt(h,10);
this._setCurrentAction(h);
this._currentItemIndex=h;
},set_preventOverlayClose:function(h){var i=this;
if(h){i._$overlay.off(e);
}else{i._$overlay.on(e,function(j){j.stopPropagation();
i._focusControl();
i.hide();
});
}i._clientSettings._preventOverlayClose=h;
},get_preventOverlayClose:function(){return this._clientSettings._preventOverlayClose;
},set_navigationMode:function(h){var i=this;
i._clientSettings._navigationMode=h;
if(h==c.LightBoxNavigationMode.Zone){i._$element.css({cursor:"pointer"}).off(e).on(e,function(j){j.stopPropagation();
i._focusControl();
i._onZoneClick(j);
});
}else{i._$element.css({cursor:""}).off(e);
}},get_navigationMode:function(){return this._clientSettings._navigationMode;
},get_fullscreenMode:function(){return this._clientSettings._fullscreenMode;
},set_animation:function(h,i){var j=this;
if((h>=0&&h<4)&&(i>=0&&i<3)){switch(h){case c.LightBoxAction.Show:j._clientSettings._showAnimation=i;
break;
case c.LightBoxAction.Hide:j._clientSettings._hideAnimation=i;
break;
case c.LightBoxAction.Prev:j._clientSettings._prevAnimation=i;
break;
case c.LightBoxAction.Next:j._clientSettings._nextAnimation=i;
break;
}}},next:function(){var h=this;
h._currentAction=c.LightBoxAction.Next;
h.navigateTo(h._currentItemIndex+1);
},prev:function(){var h=this;
h._currentAction=c.LightBoxAction.Prev;
h.navigateTo(h._currentItemIndex-1);
},first:function(){this._currentAction=c.LightBoxAction.Prev;
this.navigateTo(0);
},last:function(){var h=this;
h._currentAction=c.LightBoxAction.Next;
h.navigateTo(h.get_items().get_count()-1);
},navigateTo:function(j,i){var n=this,l=n._currentItemIndex,k,h,m;
j=parseInt(j,10);
if(n._animationInProgress){return;
}m=n._getCurrentItem();
n._setCurrentAction(j);
k=(n._currentAction==c.LightBoxAction.Next)||(n._currentAction==c.LightBoxAction.Prev);
n._adjustItemIndex(j);
if((l==n._currentItemIndex&&k)||(!i&&n._onNavigating(n._currentItemIndex))){return;
}if(!n._isNullOrEmpty(m.get_navigateUrl())){n._$contentFrame.attr("src","");
}if(!n._preserveTemplates){if(m._hasItemTemplate){n._$itemTemplate.children().remove();
m._isRendered=false;
}else{if(m._hasDescriptionTemplate){n._$descriptionTemplate.children().remove();
m._isRendered=false;
}}}h=n._getCurrentItem();
if(h._get_hasTemplate()&&!h._isRendered){if(n._clientSettings._descriptionTemplate||n._clientSettings._itemTemplate){n._instantiateTemplates();
}else{n.fireCommand("NavigateTo",n._currentItemIndex);
return false;
}}n._displayControl(1);
},showPrevButton:function(h){this._removePrevButton=!h;
},showNextButton:function(h){this._removeNextButton=!h;
},showCloseButton:function(h){var i=this;
i._removeCloseButton=!h;
i._$closeButton.css({display:h?"":"none"});
if($telerik.isIE7){i._$closeButton.css({visibility:h?"":"hidden"});
}},fireCommand:function(j,i){var k=this,h=new Sys.CancelEventArgs();
h.get_commandName=function(){return j;
};
h.get_commandArgument=function(){return i;
};
k._onCommand(h);
if(h.get_cancel()){return false;
}k._executePostBackEvent(k._constructPostBackData(j,i));
return true;
},_initializeAutoDataBind:function(){var h=this;
if(h._clientDataSourceID){h._clientDataSource=$find(h._clientDataSourceID);
if(h._clientDataSource){h._bindClientDataSource();
}}},_bindClientDataSource:function(){var j=this,h=j._clientDataSource,i;
h.set_allowPaging(false);
j._clientDataSource.fetch(function(k){i=k.get_data();
j._dataSource=i;
j.dataBind(true);
});
},dataBind:function(k){var p=this,j=p._dataSource,o=0,l=j.length;
if(!a.isArray(j)){return;
}if(!p._items){p._items=new c.LightBoxItemCollection(p._clientID);
}if(!k){var h=new Sys.CancelEventArgs();
a.raiseControlEvent(p,"dataBinding",h);
if(h.get_cancel()){return;
}}for(var m=o,n=l;
m<n;
m++){p._createItem(j[m],m);
}a.raiseControlEvent(p,"dataBound",{});
},_createItem:function(i,j){var k=this,h=new c.LightBoxItem();
if(k._clientSettings._itemTemplate){h._hasItemTemplate=true;
}else{if(k._imageUrlField&&i[k._imageUrlField]){h._imageUrl=i[k._imageUrlField];
}else{if(k._navigateUrlField&&i[k._navigateUrlField]){h._navigateUrl=i[k._navigateUrlField];
}}}if(k._clientSettings._descriptionTemplate){h._hasDescriptionTemplate=true;
}else{if(k._titleField){h._title=i[k._titleField];
}if(k._descriptionField){h._description=i[k._descriptionField];
}if(k._targetControlIDField){h._targetControlID=i[k._targetControlIDField];
}}k._items.add(h);
},_instantiateTemplates:function(){var k=this,h=k._getBindingContext(k._dataSource[k._currentItemIndex],k._currentItemIndex),j,i;
if(k._clientSettings._itemTemplate){j=k._createTemplate(k._clientSettings._itemTemplate,"ItemTemplate",h);
k._$itemTemplate.empty().append(k._renderTemplate(j,"ItemTemplate",h));
}if(k._clientSettings._descriptionTemplate){i=k._createTemplate(k._clientSettings._descriptionTemplate,"DescriptionTemplate",h);
k._$descriptionTemplate.empty().append(k._renderTemplate(i,"DescriptionTemplate",h));
}},_getBindingContext:function(h,i){var j=this;
return a.extend({},h,{item:h,index:i,dataIndex:typeof(i)!=="undefined"?i:null,owner:j,format:this._formatValue});
},_renderTemplate:function(l,k,h){var m=this,j;
try{j=l(h);
}catch(i){throw Error.invalidOperation(String.format("Error rendering {0} in {1}: {2}",k,m._clientID,i.message));
}return j;
},_getTemplateFunction:function(j,i){var l=this,k;
if(!j){throw Error.argumentNull(j,String.format("Missing client HTML template: {0}",i));
}try{k=c.Template.compile(j);
}catch(h){throw Error.invalidOperation(String.format("Error creating {0} in {1}: {2}",i,l._clientID,h.message));
}return k;
},_createTemplate:function(j,i,h){var k=this;
return k._getTemplateFunction(j,i);
},_formatValue:function(i,h){if(typeof(i)==="undefined"||i===null){return"";
}if(i.toString().indexOf("/Date(")!=-1){i=new Date(parseInt(i.replace("/Date(","").replace(")/",""),10));
}if(h){if(h.indexOf("{0:")<0){h="{0:"+h+"}";
}}else{h="{0}";
}return String.localeFormat(h,i);
},_onCommand:function(h){a.raiseControlEvent(this,"command",h);
},_onClosing:function(){a.raiseControlEvent(this,"closing",{});
},_onClosed:function(){var i=this,h=i._getCurrentItem();
if(i._$contentFrame.get(0)){i._$contentFrame.attr("src","");
}if(!i._preserveTemplates){if(h._hasItemTemplate){i._$itemTemplate.children().remove();
h._isRendered=false;
}else{if(h._hasDescriptionTemplate){i._$descriptionTemplate.children().remove();
h._isRendered=false;
}}}i._maximizeMode=c.LightBoxMaximizeMode.None;
a.raiseControlEvent(i,"closed",{});
},_onShowing:function(){this._$element.off("mousemove");
a.raiseControlEvent(this,"showing",{});
},_onShowed:function(){var k=this,h=k._$element,i,j;
k._focusControl();
if(k._getCurrentItem()._hasItemTemplate&&k._$itemBox.height()===0){k._$itemBox.css(k._getAvailableContentSpace(k._getContentDimensions()));
}h.off("mousemove");
if(k._items.count()==1){k._showNextButton(false);
k._showPrevButton(false);
}else{if(k._determineContentMode()!==c.LightBoxContentMode.Image||k._renderMode===c.RenderMode.Mobile){i=k._currentItemIndex===0;
j=k._currentItemIndex>=k.get_items().count()-1;
k._showPrevButton(!i||k._loopItems);
k._showNextButton(!j||k._loopItems);
}else{h.on("mousemove",a.proxy(k._handleMouseMove,k));
}}k._$prevButton.add(k._$nextButton).off(e);
if(!k._removePrevButton){k._$prevButton.on(e,function(l){l.preventDefault();
l.stopPropagation();
h.off("mousemove");
k._$prevButton.hide();
k.prev();
k._focusControl();
return false;
});
}if(!k._removeNextButton){k._$nextButton.on(e,function(l){l.preventDefault();
l.stopPropagation();
h.off("mousemove");
k._$nextButton.hide();
k.next();
k._focusControl();
return false;
});
}k._isWaiting=true;
if(k._currentAction==c.LightBoxAction.Next&&k._lastMousePosition==c.LightBoxMousePosition.Right||k._currentAction==c.LightBoxAction.Prev&&k._lastMousePosition==c.LightBoxMousePosition.Left){k._determineNavigationButtonsVisibility();
}k._overflows=false;
a.raiseControlEvent(k,"showed",{});
},_onNavigating:function(h){return a.raiseCancellableControlEvent(this,"navigating",{itemIndex:h});
}};
a.registerControlEvents(c.RadLightBox,["load","closing","closed","showing","showed","navigating","destroying","command","dataBinding","dataBound"]);
c.RadLightBox.registerClass("Telerik.Web.UI.RadLightBox",c.RadWebControl);
function d(h,i){return h.each(function(){var s=30,o,j;
function p(){h.off("touchmove MSPointerMove");
k(i.swipe);
l();
}function r(){if(n(event)){k(i.swipeStart);
o=m(event);
h.on("touchmove MSPointerMove",q);
}}h.on("touchstart MSPointerDown",r);
h.on("touchend touchcancel MSPointerUp",p);
function n(t){return t.touches.length==1;
}function m(t){return{x:t.touches[0].pageX,y:t.touches[0].pageY};
}function q(){j=m(event);
}function k(t){var u={startPosition:o,endPosition:j};
if(t){t(u);
}}function l(){if(!j){k(i.tap);
return;
}var v=j.x-o.x,w=j.y-o.y,t=Math.abs(v),u=Math.abs(w);
if(t>=u){if(t>=s&&u<(t/2)){k(v>0?i.swipeRight:i.swipeLeft);
}}else{if(u>=s&&t<(u/2)){k(w>0?i.swipeDown:i.swipeUp);
}}o=null;
j=null;
}});
}})(Telerik.Web.UI,Sys.UI,$telerik.$);
var $T=Telerik.Web.UI;
$T.LightBoxNavigationMode=function(){};
$T.LightBoxNavigationMode.prototype={Button:0,Zone:1};
$T.LightBoxNavigationMode.registerEnum("Telerik.Web.UI.LightBoxNavigationMode",false);
$T.LightBoxAnimationType=function(){};
$T.LightBoxAnimationType.prototype={None:0,Fade:1,Resize:2,Blocks:3,BigBlocks:4,SmallBlocks:5,HorizontalResize:6,VerticalResize:7,DiagonalResize:8,HorizontalSlide:9,VerticalSlide:10,HorizontalStripes:11,VerticalStripes:12,CollapsingHorizontalStripes:13,CollapsingVerticalStripes:14};
$T.LightBoxAnimationType.registerEnum("Telerik.Web.UI.LightBoxAnimationType",false);
$T.LightBoxEasingType=function(){};
$T.LightBoxEasingType.prototype={linear:0,easeInSine:1,easeOutSine:2,easeInOutSine:3,easeInQuad:4,easeOutQuad:5,easeInOutQuad:6,easeInCubic:7,easeOutCubic:8,easeInOutCubic:9,easeInQuart:10,easeOutQuart:11,easeInOutQuart:12,easeInQuint:13,easeOutQuint:14,easeInOutQuint:15,easeInExpo:16,easeOutExpo:17,easeInOutExpo:18,easeInCirc:19,easeOutCirc:20,easeInOutCirc:21,easeInBack:22,easeOutBack:23,easeInOutBack:24,easeInElastic:25,easeOutElastic:26,easeInOutElastic:27,easeInBounce:28,easeOutBounce:29,easeInOutBounce:30};
$T.LightBoxEasingType.registerEnum("Telerik.Web.UI.LightBoxEasingType",false);
$T.LightBoxContentResizeMode=function(){};
$T.LightBoxContentResizeMode.prototype={Fit:0,Fill:1,None:2};
$T.LightBoxContentResizeMode.registerEnum("Telerik.Web.UI.LightBoxContentResizeMode",false);
$T.LightBoxContentMode=function(){};
$T.LightBoxContentMode.prototype={Template:0,Image:1,Iframe:2,Empty:3};
$T.LightBoxContentMode.registerEnum("Telerik.Web.UI.LightBoxContentMode",false);
$T.LightBoxAction=function(){};
$T.LightBoxAction.prototype={Show:0,Hide:1,Prev:2,Next:3};
$T.LightBoxAction.registerEnum("Telerik.Web.UI.LightBoxAction",false);
$T.LightBoxMousePosition=function(){};
$T.LightBoxMousePosition.prototype={Outside:0,Left:1,Right:2};
$T.LightBoxMousePosition.registerEnum("Telerik.Web.UI.LightBoxMousePosition",false);
$T.LightBoxMaximizeMode=function(){};
$T.LightBoxMaximizeMode.prototype={None:0,Auto:1,Forced:2};
$T.LightBoxMaximizeMode.registerEnum("Telerik.Web.UI.LightBoxMaximizeMode",false);
$T.LightBoxMainAnimationAction=function(){};
$T.LightBoxMainAnimationAction.prototype={Show:0,Hide:1,ShowHide:2};
$T.LightBoxMainAnimationAction.registerEnum("Telerik.Web.UI.LightBoxMainAnimationAction",false);
$T.LightBoxDescriptionPosition=function(){};
$T.LightBoxDescriptionPosition.prototype={Bottom:0,Top:1,OverlayTop:2,OverlayBottom:3};
$T.LightBoxDescriptionPosition.registerEnum("Telerik.Web.UI.LightBoxDescriptionPosition",false);
if(typeof(Sys)!=='undefined')Sys.Application.notifyScriptLoaded();