Type.registerNamespace("Telerik.Web.UI");
(function(a,b){a.PivotGridColumnResizer=function(){a.PivotGridColumnResizer.initializeBase(this);
this._owner=null;
this._columnHeaderTable=null;
this._hasVerticalScroll=false;
this._resizeableCells=[];
this._resizeTolerance=$telerik.isTouchDevice?10:5;
this._originalCursor=null;
this._originalTitle=null;
this._isMouseOverResizeHandle=false;
this._isResizeInProgress=false;
this._columnResizingFired=false;
this._resizePivotGridOnColumnResize=false;
this._isRealTimeResize=null;
this._currentWidth=null;
this._currentCell=null;
this._currentColIndex=null;
this._canDestroy=true;
this._leftResizer=null;
this._rightResizer=null;
this._resizerToolTip=null;
this._resizerToolTipFormatString=null;
this._onMouseDownDelegate=null;
this._onMouseUpDelegate=null;
this._onMouseMoveDelegate=null;
this._onMouseMoveResizeDelegate=null;
};
a.PivotGridColumnResizer.prototype={initialize:function(){a.PivotGridColumnResizer.callBaseMethod(this,"initialize");
var d=this;
var c=d._owner;
d._hasVerticalScroll=c.get_clientSettings()._scrolling._allowVerticalScroll;
d._columnHeaderTable=d._hasVerticalScroll?c._columnHeaderTable:c._dataTable;
d._resizeableCells=d._getResizeableCells(d._columnHeaderTable);
d._originalCursor=d._columnHeaderTable.style.cursor;
d._originalTitle=d._columnHeaderTable.title;
d._isRealTimeResize=c._clientSettings._resizing._enableRealTimeResize;
d._resizerToolTipFormatString=c._clientSettings._clientMessages._columnResizeTooltipFormatString||"Width: <strong>{0}</strong> <em>pixels</em>";
if(!$telerik.isTouchDevice){d._onMouseMoveDelegate=$telerik.addMobileHandler(d,d._columnHeaderTable,"mousemove",d._onMouseMoveHandler,null,true);
}d._onMouseDownDelegate=$telerik.addMobileHandler(d,d._columnHeaderTable,"mousedown",d._onMouseDownHandler,null,true);
},dispose:function(){var c=this;
if(c._onMouseDownDelegate){$telerik.removeMobileHandler(c._columnHeaderTable,"mousedown",c._onMouseDownDelegate,null,true);
}if(c._onMouseMoveDelegate){$telerik.removeMobileHandler(c._columnHeaderTable,"mousemove",c._onMouseMoveDelegate,null,true);
}c._destroyResizers();
a.PivotGridColumnResizer.callBaseMethod(c,"dispose");
},get_owner:function(){return this._owner;
},set__owner:function(c){this._owner=c;
},_onMouseDownHandler:function(d){var c=a.PivotGrid.GetTouchCurrentElement(d);
if(!a.PivotGrid.IsDomElement(c)){return false;
}var g=this;
if($telerik.isTouchDevice){var f=g._getMouseOverCell(d);
g._currentCell=f;
if(f){g._isMouseOverResizeHandle=g._getIsMouseOverResizeHandle(d,f);
}}if(g._isMouseOverResizeHandle){this._eventPosMouseDown=this._getEventPosX(d);
this._isResizeInProgress=true;
g._currentCell.style.cursor="e-resize";
g._currentColIndex=g._getCurrentColIndex(g._currentCell.id);
g._onMouseMoveResizeDelegate=$telerik.addMobileHandler(g,document,"mousemove",g._onMouseMoveResizeHandler,null,true);
g._onMouseUpDelegate=$telerik.addMobileHandler(g,document,"mouseup",g._onMouseUpHandler,null,true);
g._createResizers();
g._positionResizers();
}a.PivotGrid.ClearDocumentEvents();
},_getCurrentColIndex:function(f){var g=f.split("_");
var h=g[g.length-1];
var c=this._owner._columnHeaderCells;
for(var e=0;
e<c.length;
e++){var d=c[e];
if(d==h){return e;
}}},_createResizers:function(){var d=this;
var c=d._owner;
d._leftResizer=document.createElement("span");
d._rightResizer=document.createElement("span");
d._resizerToolTip=document.createElement("span");
d._resizerToolTip.style.display=c._clientSettings._clientMessages._columnResizeTooltipFormatString?"none":"";
if(d._owner.Skin!=""){d._resizerToolTip.className=String.format("PivotGridToolTip PivotGridToolTip_{0}",c.Skin);
d._leftResizer.className=String.format("PivotGridLeftResizer PivotGridLeftResizer_{0}",c.Skin);
d._rightResizer.className=String.format("PivotGridRightResizer PivotGridRightResizer_{0}",c.Skin);
}d._resizerToolTip.innerHTML=d._applyTooltipText(d._currentCell.offsetWidth);
document.body.appendChild(d._leftResizer);
document.body.appendChild(d._rightResizer);
document.body.appendChild(d._resizerToolTip);
d._resizerToolTip.style.width=d._resizerToolTip.clientWidth+(parseInt(d._currentCell.offsetWidth,10).toString().length>=3?0:10)+"px";
d._canDestroy=true;
},_positionResizers:function(){var c=this._currentCell;
var f=this._findPosY(c);
this._leftResizer.style.top=f+"px";
this._leftResizer.style.left=this._findPosX(c)+"px";
this._rightResizer.style.top=this._leftResizer.style.top;
this._rightResizer.style.left=parseInt(this._leftResizer.style.left,10)+c.offsetWidth+"px";
var e=parseInt(this._rightResizer.style.top,10)-this._resizerToolTip.offsetHeight-2;
if(e<0){e+=(this._resizerToolTip.offsetHeight+c.offsetHeight+2);
}this._resizerToolTip.style.top=e+"px";
var d=parseInt(this._rightResizer.style.left,10)-5;
this._resizerToolTip.style.left=d+"px";
if(parseInt(this._leftResizer.style.left,10)<this._findPosX(this._owner.get_element())){this._leftResizer.style.display="none";
}this._calculateResizersHeight();
},_calculateResizersHeight:function(){var d=this._columnHeaderTable;
var c=this._currentCell;
var e=this._hasVerticalScroll?this._owner._dataTable.parentNode.clientHeight:this._owner._dataTable.tBodies[0].offsetHeight;
if(d&&c){this._leftResizer.style.height=e+c.offsetHeight+"px";
}this._rightResizer.style.height=this._leftResizer.style.height;
},_destroyResizers:function(){var c=this;
if(c._canDestroy){if(c._onMouseUpDelegate){$telerik.removeMobileHandler(document,"mouseup",c._onMouseUpDelegate,null,true);
c._onMouseUpDelegate=null;
}if(c._onMouseMoveResizeDelegate){$telerik.removeMobileHandler(document,"mousemove",c._onMouseMoveResizeDelegate,null,true);
c._onMouseMoveResizeDelegate=null;
}c._isResizeInProgress=false;
if(c._currentWidth!=null&&c._currentWidth>0){this._resizeInternal(this._currentWidth);
c._currentWidth=null;
}if(c._currentCell){c._currentCell.style.cursor=c._originalCursor;
c._currentCell.title=c._originalTitle;
}if(c._leftResizer){document.body.removeChild(c._leftResizer);
}if(c._rightResizer){document.body.removeChild(c._rightResizer);
}if(c._resizerToolTip){document.body.removeChild(c._resizerToolTip);
}c._leftResizer=null;
c._rightResizer=null;
c._resizerToolTip=null;
c._canDestroy=false;
}},_onMouseUpHandler:function(c){this._destroyResizers();
a.PivotGrid.RestoreDocumentEvents();
},_onMouseMoveResizeHandler:function(c){var d=this;
if($telerik.isTouchDevice){c.preventDefault();
}d._move(c);
},_move:function(d){var o=this;
var g=o._owner;
var h=g.get_element();
var c=this._findPosX(this._currentCell);
this._leftResizer.style.left=c+"px";
var m=this._rightResizer.style.left;
var f=this._getEventPosX(d);
if($telerik.isChrome&&this._eventPosMouseDown&&(Math.abs(this._eventPosMouseDown-f)<=1)){return;
}var n=f-this._findPosX(h);
this._rightResizer.style.left=f+"px";
var q=parseInt(this._rightResizer.style.left,10)-parseInt(this._leftResizer.style.left,10);
if(q<=0||n>=h.offsetWidth){this._rightResizer.style.left=m;
return;
}var l=a.PivotGrid.BuildEventArgs(new Sys.CancelEventArgs(),{column:this._currentCell,width:q});
this._owner.raise_columnResizing(l);
this._columnResizingFired=true;
if(l.get_cancel()){return;
}var k=parseInt(this._rightResizer.style.left,10)-5;
this._resizerToolTip.style.left=k+"px";
var j=this._resizerToolTip.offsetHeight;
this._resizerToolTip.innerHTML=this._applyTooltipText(q);
if(this._resizerToolTip.offsetHeight>j){this._resizerToolTip.style.width=parseInt(this._resizerToolTip.style.width,10)+10+"px";
}this._currentWidth=q;
if(!this._isRealTimeResize){return;
}this._resizeInternal(this._currentWidth);
c=this._findPosX(this._currentCell);
this._leftResizer.style.left=c+"px";
this._rightResizer.style.left=c+this._currentCell.offsetWidth+"px";
this._resizerToolTip.style.left=parseInt(this._rightResizer.style.left,10)-5+"px";
var i=this._findPosY(this._currentCell);
if(this._findPosY(this._leftResizer)!=i){var p=i;
this._leftResizer.style.top=p+"px";
this._rightResizer.style.top=this._leftResizer.style.top;
}this._calculateResizersHeight();
},_resize:function(f,g){var c=this._owner._columnHeaderCells[f];
for(var e=0;
e<this._resizeableCells.length;
e++){var d=this._resizeableCells[e];
if(d.id.indexOf(c,d.id.length-c.length)!==-1){this._currentCell=d;
}}this._currentColIndex=f;
this._resizeInternal(g);
},_resizeInternal:function(i){i=parseInt(i,10);
if(!(i>=0&&this._owner._clientSettings._resizing._allowColumnResize)){return;
}var c;
if(!this._columnResizingFired){c=a.PivotGrid.BuildEventArgs(new Sys.CancelEventArgs(),{column:this._currentCell,width:i});
this._owner.raise_columnResizing(c);
if(c.get_cancel()){return false;
}}if(this._hasVerticalScroll){this._setTableColumnWidth(this._owner._columnHeaderTable,i);
this._setTableColumnWidth(this._owner._dataTable,i);
this._owner._dataTable.style.width=this._owner._columnHeaderTable.style.width;
}else{this._setTableColumnWidth(this._owner._dataTable,i);
}if(!this._isResizeInProgress){var g=this._currentCell.id.split("_");
var e=g[g.length-1];
var d="col"+e;
var f=d+","+i+";";
if(this._owner._resizedColumns.indexOf(d)>-1){var h=new RegExp(d+",.*?;");
this._owner._resizedColumns=this._owner._resizedColumns.replace(h,f);
}else{this._owner._resizedColumns+=f;
}this._owner.updateClientState();
}this._owner.repaint();
c=a.PivotGrid.BuildEventArgs(Sys.EventArgs.Empty,{column:this._currentCell,width:i});
this._owner.raise_columnResized(c);
},_setTableColumnWidth:function(h,i){var d=h.getElementsByTagName("colgroup")[0];
if(d){var e=d.getElementsByTagName("col");
var c=e[this._currentColIndex];
if(c&&i>0){var f=c.style.width?c.style.width:this._currentCell.offsetWidth;
var g=i-parseInt(f,10);
h.style.width=(h.offsetWidth+g)+"px";
c.style.width=i+"px";
}}},_onMouseMoveHandler:function(c){var h=this;
if(h._isResizeInProgress){return;
}var g=h._owner;
var f=h._getMouseOverCell(c);
if(f){if(h._getIsMouseOverResizeHandle(c,f)){this._isMouseOverResizeHandle=true;
f.style.cursor="e-resize";
this._currentCell=f;
var d=g._clientSettings._clientMessages._dragToResize;
f.title=d?d:"Drag to resize";
}else{this._isMouseOverResizeHandle=false;
f.style.cursor=h._originalCursor;
f.title=h._originalTitle;
}}},_getFirstParentByTagName:function(c,d){while(c&&c.parentNode){if(c.tagName.toLowerCase()==d.toLowerCase()){return c;
}c=c.parentNode;
}return null;
},_getResizeableCells:function(e){var f=[];
var k=[];
if(this._hasVerticalScroll){f=e.rows;
}else{var m=e.getElementsByTagName("thead")[0];
if(m){f=m.rows;
}}for(var g=0;
g<f.length;
g++){var l=f[g];
var d=l.cells;
for(var h=0;
h<d.length;
h++){var c=d[h];
if(c.tagName.toLowerCase()=="th"&&c.id){k.push(c);
}}}return k;
},_getIsMouseOverResizeHandle:function(d,c){var g=parseInt(d.clientX,10)+parseInt($telerik.getScrollOffset(document.body,true).x,10);
var h;
if($telerik.isOpera){h=$telerik.originalGetLocation(c).x;
}else{h=$telerik.getLocation(c).x;
}var f=h+c.offsetWidth;
if((g>=f-this._resizeTolerance)&&(g<=f+this._resizeTolerance)){return true;
}return false;
},_getMouseOverCell:function(d){var c=a.PivotGrid.GetTouchCurrentElement(d);
if(!a.PivotGrid.IsDomElement(c)){return null;
}c=this._getFirstParentByTagName(c,"th");
if(a.PivotGrid.IsDomElement(c)&&c&&c.id){return c;
}else{return null;
}},_getEventPosX:function(c){if($telerik.isTouchDevice){return $telerik.getTouchEventLocation(c).x;
}else{var d=parseInt(c.clientX,10)+parseInt($telerik.getScrollOffset(document.body,true).x,10);
return d;
}},_findPosX:function(c){return this._getLocation(c).x;
},_findPosY:function(c){return this._getLocation(c).y;
},_getLocation:function(c){if($telerik.isOpera){return $telerik.originalGetLocation(c);
}return $telerik.getLocation(c);
},_applyTooltipText:function(d){var c=/\{0[^\}]*\}/g;
return this._resizerToolTipFormatString.replace(c,d);
}};
a.PivotGridColumnResizer.registerClass("Telerik.Web.UI.PivotGridColumnResizer",Sys.Component);
})(Telerik.Web.UI,undefined);
if(typeof(Sys)!=='undefined')Sys.Application.notifyScriptLoaded();