Type.registerNamespace("Telerik.Web.UI.Scheduler.Views.Timeline.GroupedByResource");
(function(a,d){var b=Telerik.Web.UI.Scheduler,c=b.Views.Timeline;
c.GroupedByResource.Model=function(g,e,f){c.GroupedByResource.Model.initializeBase(this,[g]);
this._groupingResource=e;
this._isVertical=f;
this._timelineModels=[];
this._resources=null;
if(Telerik.Web.UI.Scheduler.Rendering.HorizontalBlockCollection){this._allDayBlocks=new Telerik.Web.UI.Scheduler.Rendering.HorizontalBlockCollection();
}};
c.GroupedByResource.Model.prototype={initialize:function(){this._resources=this._owner.get_resources().getResourcesByType(this._groupingResource);
for(var e=0;
e<this._resources.get_count();
e++){this._timelineModels[e]=new c.Model(this._owner);
}},addToBlocks:function(f){var e=this._getAppointmentModelIndex(f.appointment);
f.appointment.__modelIndex=e;
this._timelineModels[e].addToBlocks(f);
},removeFromBlock:function(f){var e=f.appointment.__modelIndex;
this._timelineModels[e].removeFromBlock(f);
},resetBlocks:function(){var g=this._timelineModels;
for(var e=0,f=g.length;
e<f;
e++){g[e].resetBlocks();
}},getTimeSlotFromDomElement:function(e){var g=this._getRawIndexFromDomElement(e);
var i=this._getTimeFromDomElement(e);
var h=this._resources.getResource(g.modelIndex);
var f=this._timelineModels[0]._slotDurationInMinutes;
return new c.GroupedByResource.TimeSlot(g,i,f,h,e);
},_getMaxAppointmentGrowth:function(e){if(this._isVertical){return this._getNumberOfSlots();
}else{var f=this.getTimeSlotFromDomElement(e);
return(this._getNumberOfSlots()-f.get_rawIndex().intervalIndex-1);
}},_getTimeFromDomElement:function(e){var f=this._getRawIndexFromDomElement(e);
return this._timelineModels[0]._getTimeFromIndex(f);
},_getRawIndexFromDomElement:function(f){while(f&&(f.tagName.toUpperCase()!="TD")){f=f.parentNode;
}if(!f){return null;
}var i=f.parentNode;
if(!this._isVertical){var e=i.cells.length/this._resources.get_count();
var h=Math.floor(f.cellIndex/e);
var g=f.cellIndex-(h*e);
return{intervalIndex:g,modelIndex:h};
}else{return{intervalIndex:f.cellIndex,modelIndex:i.rowIndex};
}},_getRawIndexFromStartTime:function(e){return this._timelineModels[0]._getRawIndexFromStartTime(e);
},_getAppointmentModelIndex:function(e){var g=-1;
var f=this;
e.get_resources().forEach(function(h){var i=f._resources.getResourceByTypeAndKey(h.get_type(),h.get_key());
if(i){g=Array.indexOf(f._resources._array,i);
}});
return g;
},_getAllDayTimeSlotForAppointmentPart:function(e){return this._getTimeSlotFromStartTime(e.start,e.modelIndex);
},_getTimeSlotFromStartTime:function(h,f){var g=this._getRawIndexFromStartTime(h);
g.modelIndex=f;
var e=this._getDomElementFromRawIndex(g);
return this.getTimeSlotFromDomElement(e);
},getTimeSlotForAppointment:function(e){var f=this._getAppointmentModelIndex(e);
if(f==-1){return null;
}var g=this._getTimeSlotFromStartTime(e.get_start(),f);
return g;
},_getDomElementFromRawIndex:function(g){if(g.modelIndex===d){return this._timelineModels[0]._getDomElementFromRawIndex(g.intervalIndex);
}var f=this._owner.get_element();
var h=g.modelIndex;
var e=g.intervalIndex;
if(this._isVertical){return a("div.rsTimelineView table.rsAllDayTable",f)[0].tBodies[0].rows[h].cells[e];
}e+=this._getNumberOfSlots()*g.modelIndex;
return a("div.rsTimelineView table.rsAllDayTable",f)[0].tBodies[0].rows[0].cells[e];
},_getSourceCellOffsetOfMovedAppointment:function(f,g){var e=Math.floor(parseInt(f.style.left,10)/100)||0,h=this._getRawIndexFromDomElement(g);
return h.intervalIndex-e;
},isVisible:function(e){var g=c.GroupedByResource.Model.callBaseMethod(this,"isVisible",[e]);
var f=this._getAppointmentModelIndex(e)!=-1;
return g&&f;
},_getRenderer:function(){if(!this._renderer){this._renderer=new b.Rendering.ResourceGroupedTimelineViewRenderer(this);
}return this._renderer;
}};
c.GroupedByResource.Model.registerClass("Telerik.Web.UI.Scheduler.Views.Timeline.GroupedByResource.Model",c.ModelBase);
c.GroupedByResource.TimeSlot=function(g,i,f,h,e){this._resource=h;
c.GroupedByResource.TimeSlot.initializeBase(this,[g,i,f,e]);
};
c.GroupedByResource.TimeSlot.prototype={get_index:function(){var e=this.get_rawIndex();
var f=c.GroupedByResource.TimeSlot.callBaseMethod(this,"get_index");
return String.format("{0}:{1}",e.modelIndex,f);
},get_resource:function(){return this._resource;
}};
c.GroupedByResource.TimeSlot.registerClass("Telerik.Web.UI.Scheduler.Views.Timeline.GroupedByResource.TimeSlot",c.TimeSlot);
})($telerik.$);
if(typeof(Sys)!=='undefined')Sys.Application.notifyScriptLoaded();