Type.registerNamespace("Telerik.Web.UI");
Telerik.Web.UI.TreeListKeyboardNavigation=function(){Telerik.Web.UI.TreeListKeyboardNavigation.initializeBase(this);
this._owner=null;
this._submitElements=[];
this._itemForFocusedControl=null;
this._isInsertFormFocused=false;
this._startRangeIndex=null;
this._isFocusKeyPressed=false;
this._insertDeleteHandled=false;
this._documentKeyDownDelegate=null;
this._onKeyDownDelegate=null;
this._onKeyPressDelegate=null;
};
Telerik.Web.UI.TreeListKeyboardNavigation.prototype={initialize:function(){Telerik.Web.UI.TreeListKeyboardNavigation.callBaseMethod(this,"initialize");
if(this._owner){var e=this._owner.get_element();
e.tabIndex=0;
this._documentKeyDownDelegate=Function.createDelegate(this,this._documentKeyDown);
window.$addHandler(document,"keydown",this._documentKeyDownDelegate);
this._onKeyDownDelegate=Function.createDelegate(this,this._onKeyDownHandler);
window.$addHandler(e,"keydown",this._onKeyDownDelegate);
this._onKeyPressDelegate=Function.createDelegate(this,this._onKeyPressHandler);
window.$addHandler(e,"keypress",this._onKeyPressDelegate);
this._initializeKeyboardNavigationSettings();
if(this._owner._activeRowIndex){var c=this._owner.get_dataItems();
if(c.length>0){var b=parseInt(this._owner._activeRowIndex,10);
var d=c[b];
if(d){this._setActiveRow(d.get_element());
}}}if(this._owner._shouldFocusOnPage){try{this._owner._shouldFocusOnPage=false;
e.focus();
}catch(a){}}this._initializeSubmitControls();
this._focusControlInEditForm();
}},dispose:function(){this._cleanUp();
Telerik.Web.UI.TreeListKeyboardNavigation.callBaseMethod(this,"dispose");
},_cleanUp:function(){this._submitElements=[];
this._itemForFocusedControl=null;
this._isInsertFormFocused=false;
this._isFocusKeyPressed=false;
this._insertDeleteHandled=false;
this._startRangeIndex=null;
this._detachKeyHandlers();
Telerik.Web.UI.RadTreeList.RestoreDocumentEvents();
},_detachKeyHandlers:function(){if(this._documentKeyDownDelegate){window.$removeHandler(document,"keydown",this._documentKeyDownDelegate);
this._documentKeyDownDelegate=null;
}if(this._onKeyDownDelegate){this._onKeyDownDelegate=null;
}if(this._onKeyPressDelegate){this._onKeyPressDelegate=null;
}},_initializeSubmitControls:function(){this._submitElements=[{tagName:"input",attributes:{type:"text"},submit:true}];
},_focusControlInEditForm:function(){var a=this._owner._controlToFocus;
if(this._owner.get_allowKeyboardNavigation()&&a!=null&&a!=""){setTimeout(function(){try{var d=false;
var b=$find(a);
if(b==null){b=$get(a);
}else{d=true;
}if(b==null){b=document.getElementsByName(a.replace(/_/ig,"$"))[0];
}if(b!=null){if(b.focus){b.focus();
}else{if(d){if(b._focused!=undefined){b._focused=true;
}if(b.setFocus){b.setFocus();
}}}if(b.select){b.select();
}}}catch(c){}},0);
}},_initializeKeyboardNavigationSettings:function(){var a=this._owner._clientSettings._keyboardNavigationSettings;
if(!a){a=this._owner._clientSettings._keyboardNavigationSettings={};
}if(a._focusKey===undefined){a._focusKey=89;
}if(a._expandChildItemsKey===undefined){a._expandChildItemsKey=39;
}if(a._collapseChildItemsKey===undefined){a._collapseChildItemsKey=37;
}if(a._deleteActiveRowKey===undefined){a._deleteActiveRowKey=127;
}if(a._exitEditInsertModeKey===undefined){a._exitEditInsertModeKey=27;
}if(a._initInsertKey===undefined){a._initInsertKey=73;
}a._navigateUpKey=38;
a._navigateDownKey=40;
a._pageUpKey=33;
a._pageDownKey=34;
a._spaceKey=32;
a._enterKey=13;
},_shouldFocusTreeListOnDocumentKeyDown:function(a,b){var c=this._owner._clientSettings._keyboardNavigationSettings;
return this._owner._clientSettings._allowKeyboardNavigation&&a.ctrlKey&&b==c._focusKey;
},_documentKeyDown:function(a){a=a||window.event;
this._isFocusKeyPressed=false;
var b=a.keyCode||a.charCode;
if(this._shouldFocusTreeListOnDocumentKeyDown(a,b)){if(this._owner.get_element().focus){this._isFocusKeyPressed=true;
this._owner.get_element().focus();
}}},_onKeyDownHandler:function(c){var f=c.keyCode||c.charCode;
var b=(f==this._owner._clientSettings._keyboardNavigationSettings._deleteActiveRowKey);
var d=(f==this._owner._clientSettings._keyboardNavigationSettings._initInsertKey);
if(b||(d&&!c.shiftKey)){this._insertDeleteHandled=true;
this._raiseKeyPressInternal(c);
}var a=(f>=37&&f<=40);
var g=(f==this._owner._clientSettings._keyboardNavigationSettings._pageUpKey||f==this._owner._clientSettings._keyboardNavigationSettings._pageDownKey);
if(((Telerik.Web.Browser.edge||$telerik.isIE||$telerik.isChrome||$telerik.isSafari||$telerik.isOpera)&&(a||g))||(($telerik.isChrome||$telerik.isSafari||$telerik.isOpera)&&f==this._owner._clientSettings._keyboardNavigationSettings._exitEditInsertModeKey)){this._raiseKeyPressInternal(c);
}},_onKeyPressHandler:function(a){if(($telerik.isFirefox)&&(this._insertDeleteHandled==true)){this._insertDeleteHandled=false;
return;
}this._raiseKeyPressInternal(a);
},_raiseKeyPressInternal:function(c){var d=c.keyCode||c.charCode;
if(!this._owner._canRaiseItemEvent(c)&&d!=this._owner._clientSettings._keyboardNavigationSettings._exitEditInsertModeKey&&d!=this._owner._clientSettings._keyboardNavigationSettings._enterKey){return;
}var a=this._getAction(c);
var g=Telerik.Web.UI.TreeListKeyBoardNavigationType;
var f=(a==g.NavigateDown||a==g.NavigateUp);
if((f||a==g.Select)&&c.shiftKey||(f&&c.ctrlKey)){if(this._startRangeIndex==null){this._startRangeIndex=this._owner._activeRowIndex;
}}else{this._startRangeIndex=null;
}var b=new Telerik.Web.UI.TreeListKeyPressEventArgs(c,a,this._isFocusKeyPressed,this._owner._clientSettings._keyboardNavigationSettings._focusKey);
this._owner.raise_keyPress(b);
if(b.get_cancel()){return;
}this._handleTreeListKeyboardAction(c,a);
},_handleTreeListKeyboardAction:function(b,a){var c=Telerik.Web.UI.TreeListKeyBoardNavigationType;
switch(a){case c.NavigateDown:this._handleNavigateDown(b);
break;
case c.NavigateUp:this._handleNavigateUp(b);
break;
case c.Expand:case c.Collapse:this._handleExpandCollapse(b);
break;
case c.PageUp:this._handlePageUp(b);
break;
case c.PageDown:this._handlePageDown(b);
break;
case c.Select:if(this._owner._selection){if(this._owner._data&&this._owner._data._allowMultiItemSelection){this._handleMultiSelection(b);
break;
}else{this._handleSingleSelection(b);
break;
}}break;
case c.Edit:this._handleEdit(b);
break;
case c.Cancel:this._handleExitEditInsert(b);
break;
case c.InitInsert:this._handleInitInsert(b);
break;
case c.Delete:this._handleDelete(b);
break;
case c.Update:this._handleUpdate(b);
break;
case c.Insert:this._handleInsert(b);
break;
case c.RootInsert:this._handleRootInsert(b);
break;
default:}},_getAction:function(b){var a=null;
var c=b.keyCode||b.charCode;
if(c==this._owner._clientSettings._keyboardNavigationSettings._navigateDownKey){a=Telerik.Web.UI.TreeListKeyBoardNavigationType.NavigateDown;
}else{if(c==this._owner._clientSettings._keyboardNavigationSettings._navigateUpKey){a=Telerik.Web.UI.TreeListKeyBoardNavigationType.NavigateUp;
}else{if(c==this._owner._clientSettings._keyboardNavigationSettings._collapseChildItemsKey){a=Telerik.Web.UI.TreeListKeyBoardNavigationType.Collapse;
}else{if(c==this._owner._clientSettings._keyboardNavigationSettings._expandChildItemsKey){a=Telerik.Web.UI.TreeListKeyBoardNavigationType.Expand;
}else{if(c==this._owner._clientSettings._keyboardNavigationSettings._pageUpKey){a=Telerik.Web.UI.TreeListKeyBoardNavigationType.PageUp;
}else{if(c==this._owner._clientSettings._keyboardNavigationSettings._pageDownKey){a=Telerik.Web.UI.TreeListKeyBoardNavigationType.PageDown;
}else{if(this._shouldSelectOnSpace(b,c)){a=Telerik.Web.UI.TreeListKeyBoardNavigationType.Select;
}else{if(c==this._owner._clientSettings._keyboardNavigationSettings._enterKey){a=this._determineActionForEnter(b);
}else{if(c==this._owner._clientSettings._keyboardNavigationSettings._exitEditInsertModeKey){a=Telerik.Web.UI.TreeListKeyBoardNavigationType.Cancel;
}else{if(c==this._owner._clientSettings._keyboardNavigationSettings._initInsertKey){a=Telerik.Web.UI.TreeListKeyBoardNavigationType.InitInsert;
}else{if(c==this._owner._clientSettings._keyboardNavigationSettings._deleteActiveRowKey){a=Telerik.Web.UI.TreeListKeyBoardNavigationType.Delete;
}}}}}}}}}}}return a;
},_shouldSelectOnSpace:function(a,b){if(b==this._owner._clientSettings._keyboardNavigationSettings._spaceKey&&this._owner._clientSettings._selecting&&this._owner._clientSettings._selecting._allowItemSelection){return true;
}return false;
},_determineActionForEnter:function(c){var a=Telerik.Web.UI.TreeListKeyBoardNavigationType.Edit;
if(this._owner._clientSettings._keyboardNavigationSettings._allowSubmitOnEnter){var h=this.getTargetElement(c);
var b=this._canSubmit(h);
if(b){var d=this._getFocusedFormType(h);
var f=Telerik.Web.UI.TreeListFormItemType;
switch(d){case f.EditForm:a=Telerik.Web.UI.TreeListKeyBoardNavigationType.Update;
break;
case f.InsertForm:a=Telerik.Web.UI.TreeListKeyBoardNavigationType.Insert;
break;
case f.RootInsertForm:a=Telerik.Web.UI.TreeListKeyBoardNavigationType.RootInsert;
break;
default:a=null;
}}else{if(h===this._owner.get_element()){if(this._owner._activeRow){var g=this._getActiveRowItem();
this._itemForFocusedControl=g;
if(g.get_isInEditMode()){a=Telerik.Web.UI.TreeListKeyBoardNavigationType.Update;
}else{if(g.get_isChildInserted()){a=Telerik.Web.UI.TreeListKeyBoardNavigationType.Insert;
}}}else{if(this._owner.get_isItemInserted()){a=Telerik.Web.UI.TreeListKeyBoardNavigationType.RootInsert;
}}}}}return a;
},_getFocusedFormType:function(d){var c=this._getParentItemForElement(d);
if(c!=null){this._itemForFocusedControl=c;
var a=c.get_isInEditMode();
var b=c.get_isChildInserted();
if(a&&b){return this._isInsertFormFocused?Telerik.Web.UI.TreeListFormItemType.InsertForm:Telerik.Web.UI.TreeListFormItemType.EditForm;
}else{if(a){return Telerik.Web.UI.TreeListFormItemType.EditForm;
}else{if(b){return Telerik.Web.UI.TreeListFormItemType.InsertForm;
}}}return null;
}else{if(this._owner.get_isItemInserted()&&this._isRootInsertItemFocused(d)){return Telerik.Web.UI.TreeListFormItemType.RootInsertForm;
}}return null;
},_canSubmit:function(g){var f=true;
var c=false;
for(var d=0;
d<this._submitElements.length;
d++){var b=this._submitElements[d];
if(b.tagName&&b.tagName.toLowerCase()!==g.tagName.toLowerCase()){continue;
}if(b.attributes){var e=true;
for(var a in b.attributes){if(a==="class"){e=g.className.indexOf(b.attributes[a])>-1;
}else{e=g[a]===b.attributes[a];
}if(!e){break;
}}if(!e){continue;
}}f=f&&!!b.submit;
c=true;
if(!f){return false;
}}if(!c){f=false;
}return f;
},_validateEditInsertForm:function(a){if(this._owner._validationSettings._enableValidation){var b=this._owner._validationSettings._commandsToValidate;
if(b.toString().indexOf(a)>-1){var c=this._owner._validationSettings._validationGroup;
if(typeof(Page_ClientValidate)=="function"){var d=Page_ClientValidate(c);
if(d!=true){return false;
}}}}return true;
},_handleEdit:function(a){if(this._owner._activeRow&&this._owner._canRaiseItemEvent(a)){var b=this._getActiveRowItem();
if(!b.get_isInEditMode()){this._owner.fireCommand("Edit",b.get_displayIndex());
}}$telerik.cancelRawEvent(a);
},_handleUpdate:function(a){if(this._itemForFocusedControl&&this._validateEditInsertForm("Update")){this._owner.fireCommand("Update",this._itemForFocusedControl.get_displayIndex());
}$telerik.cancelRawEvent(a);
},_handleInsert:function(a){if(this._itemForFocusedControl&&this._validateEditInsertForm("PerformInsert")){this._owner.fireCommand("PerformInsert",this._itemForFocusedControl.get_displayIndex());
}$telerik.cancelRawEvent(a);
},_handleRootInsert:function(a){if(this._validateEditInsertForm("PerformInsert")){this._owner.fireCommand("PerformInsert");
}$telerik.cancelRawEvent(a);
},_handleDelete:function(a){if(this._owner._activeRow){var b=this._getActiveRowItem();
this._owner.fireCommand("Delete",b.get_displayIndex());
}$telerik.cancelRawEvent(a);
},_handleExitEditInsert:function(b){var g=this.getTargetElement(b);
var a=this._canSubmit(g);
if(a){var c=this._getFocusedFormType(g);
var d=Telerik.Web.UI.TreeListFormItemType;
switch(c){case d.EditForm:if(this._itemForFocusedControl){this._owner.fireCommand("Cancel",this._itemForFocusedControl.get_displayIndex());
}break;
case d.InsertForm:if(this._itemForFocusedControl){this._owner.fireCommand("CancelInsert",this._itemForFocusedControl.get_displayIndex());
}break;
case d.RootInsertForm:this._owner.fireCommand("CancelInsert");
break;
default:}}else{if(g===this._owner.get_element()){if(this._owner._activeRow){var f=this._getActiveRowItem();
if(f.get_isInEditMode()){this._owner.fireCommand("Cancel",f.get_displayIndex());
}else{if(f.get_isChildInserted()){this._owner.fireCommand("CancelInsert",f.get_displayIndex());
}else{if(this._owner.get_isItemInserted()){this._owner.fireCommand("CancelInsert");
}}}}else{if(this._owner.get_isItemInserted()){this._owner.fireCommand("CancelInsert");
}}}}$telerik.cancelRawEvent(b);
},_handleInitInsert:function(a){if(this._owner._activeRow&&a.ctrlKey){var b=this._getActiveRowItem();
if(b&&!b.get_isChildInserted()){this._owner.fireCommand("InitInsert",b.get_displayIndex());
}}else{if(a.shiftKey&&!this._owner.get_isItemInserted()){this._owner.fireCommand("InitInsert");
}}$telerik.cancelRawEvent(a);
},_handleSingleSelection:function(a){if(this._owner._activeRow){var b=this._getActiveRowItem();
if(this._owner._clientSettings._selecting._allowToggleSelection){this._toggleSelection(b);
}else{if(!b.get_selected()){this._owner.selectItem(b);
}}$telerik.cancelRawEvent(a);
}},_toggleSelection:function(a){if(a.get_selected()){this._owner.deselectItem(a);
}else{this._owner.selectItem(a);
}},_handleMultiSelection:function(b){var a;
if(this._owner._activeRow){var d=this._getActiveRowItem();
if(b.ctrlKey){this._toggleSelection(d);
}else{if(b.shiftKey){a=this._getActiveRowItem();
this._performRangeSelection(a);
}else{var f=this._owner.get_selectedItems();
for(var c=0;
c<f.length;
c++){a=f[c];
if(a.get_displayIndex()!=d.get_displayIndex()){this._owner.deselectItem(a);
}}if(this._owner._clientSettings._selecting._allowToggleSelection){this._toggleSelection(d);
}else{if(!d.get_selected()){this._owner.selectItem(d);
}}}}$telerik.cancelRawEvent(b);
}},_selectItemsInRange:function(d,a){var c=this._owner.get_dataItems();
for(var b=d;
b<=a;
b++){this._owner.selectItem(c[b]);
}},_performRangeSelection:function(a){if(this._startRangeIndex!==0&&!this._startRangeIndex){return;
}this._owner.deselectAllItems();
if(this._startRangeIndex>a.get_displayIndex()){this._selectItemsInRange(a.get_displayIndex(),this._startRangeIndex);
}else{this._selectItemsInRange(this._startRangeIndex,a.get_displayIndex());
}},_handleNavigateDown:function(a){var b=this._getNextActiveRow();
var c;
if(b){if(this._owner._activeRow){this._clearActiveRowCssClass();
}if(!a.ctrlKey&&!a.shiftKey&&this._owner._selection){c=$find(b.id);
this._owner.deselectAllItems();
this._owner.selectItem(c);
}if(a.shiftKey&&this._owner._selection&&this._owner._data._allowMultiItemSelection){c=$find(b.id);
this._performRangeSelection(c);
}this._setActiveRow(b);
}$telerik.cancelRawEvent(a);
},_handleNavigateUp:function(a){var b=this._getPreviousActiveRow();
var c;
if(b){if(this._owner._activeRow){this._clearActiveRowCssClass();
}if(!a.ctrlKey&&!a.shiftKey&&this._owner._selection){c=$find(b.id);
this._owner.deselectAllItems();
this._owner.selectItem(c);
}if(a.shiftKey&&this._owner._selection&&this._owner._data._allowMultiItemSelection){c=$find(b.id);
this._performRangeSelection(c);
}this._setActiveRow(b);
}$telerik.cancelRawEvent(a);
},_handleExpandCollapse:function(b){if(this._owner._activeRow){var a=this._getActiveRowItem();
var c=b.keyCode||b.charCode;
if((c==this._owner._clientSettings._keyboardNavigationSettings._expandChildItemsKey&&a.get_expanded())||(c==this._owner._clientSettings._keyboardNavigationSettings._collapseChildItemsKey&&!a.get_expanded())){$telerik.cancelRawEvent(b);
return;
}this._owner.fireCommand("ExpandCollapse",a.get_displayIndex());
}$telerik.cancelRawEvent(b);
},_handlePageUp:function(a){var b=null;
var c=null;
b=this._owner.get_currentPageIndex();
c=this._owner.get_pageCount();
b++;
if(b<c){this._owner._shouldFocusOnPage=true;
this._owner.updateClientState();
this._owner.page("Next");
}$telerik.cancelRawEvent(a);
},_handlePageDown:function(a){var b=null;
b=this._owner.get_currentPageIndex();
b--;
if(b>-1){this._owner._shouldFocusOnPage=true;
this._owner.updateClientState();
this._owner.page("Prev");
}$telerik.cancelRawEvent(a);
},_getNextActiveRow:function(){var c=this._owner.get_dataItems();
var a;
if(this._owner._activeRow){a=this._getActiveRowItem();
}else{if(this._owner._selection&&this._owner._selectedIndexes.length>0){return c[this._owner._selectedIndexes[0]].get_element();
}return c[0].get_element();
}var b=parseInt(a.get_displayIndex(),10);
var e=b+1;
if(e==c.length&&this._owner._clientSettings._keyboardNavigationSettings._allowActiveRowCycle){return c[0].get_element();
}var d=c[e];
if(d){return d.get_element();
}else{return null;
}},_getPreviousActiveRow:function(){var c=this._owner.get_dataItems();
var a;
if(this._owner._activeRow){a=this._getActiveRowItem();
}else{if(this._owner._selection&&this._owner._selectedIndexes.length>0){return c[this._owner._selectedIndexes[0]].get_element();
}return c[0].get_element();
}var b=parseInt(a.get_displayIndex(),10);
if(b==0){if(this._owner._clientSettings._keyboardNavigationSettings._allowActiveRowCycle){return c[c.length-1].get_element();
}}var e=b-1;
var d=c[e];
if(d){return d.get_element();
}else{return null;
}},_clearActiveRowCssClass:function(){var a=this._owner._activeRow.className;
a=a.replace("rtlRActive","").replace(/^\s+|\s+$/g,"");
this._owner._activeRow.className=a;
},_setActiveRow:function(c){this._owner._activeRow=c;
var a=$find(this._owner._activeRow.id);
if(!a){a=$find(this._owner._activeRow.id);
}this._owner._activeRowIndex=a.get_displayIndex();
var b=this._owner._activeRow.className+" rtlRActive";
b=b.replace(/^\s+|\s+$/g,"");
this._owner._activeRow.className=b;
},_getActiveRowItem:function(){return $find(this._owner._activeRow.id);
},_getParentItemForElement:function(a){var c=new RegExp("^"+this._owner.get_id()+".*__\\d$");
if(this._owner._isInPlaceEditMode){while(a&&a.parentNode&&a.id!=this._owner.get_id()){if(a.tagName.toLowerCase()=="tr"&&c.test(a.id)){return $find(a.id);
}a=a.parentNode;
}}else{while(a&&a.parentNode&&a.id!=this._owner.get_id()){if(a.tagName.toLowerCase()=="tr"&&!a.id){var b=a.previousSibling;
if(!b){a=a.parentNode;
continue;
}if(b&&c.test(b.id)){return $find(a.previousSibling.id);
}else{if(b.previousSibling&&c.test(b.previousSibling.id)){this._isInsertFormFocused=true;
return $find(b.previousSibling.id);
}}}a=a.parentNode;
}}return null;
},_isRootInsertItemFocused:function(a){var b=new RegExp("^"+this._owner.get_id()+".*__0$");
while(a&&a.parentNode&&a.id!=this._owner.get_id()){if(a.tagName.toLowerCase()=="tr"&&a.nextSibling&&b.test(a.nextSibling.id)){return true;
}a=a.parentNode;
}return false;
},getTargetElement:function(a){a=a||window.event;
return a.target||a.srcElement;
},get_owner:function(){return this._owner;
},set_owner:function(a){this._owner=a;
}};
Telerik.Web.UI.TreeListKeyboardNavigation.registerClass("Telerik.Web.UI.TreeListKeyboardNavigation",Sys.Component);
Telerik.Web.UI.TreeListKeyBoardNavigationType=function(){};
Telerik.Web.UI.TreeListKeyBoardNavigationType.prototype={None:0,NavigateUp:1,NavigateDown:2,Expand:3,Collapse:4,PageUp:5,PageDown:6,Select:7,Edit:8,Cancel:9,InitInsert:10,Delete:11,Update:12,Insert:13,RootInsert:14};
Telerik.Web.UI.TreeListKeyBoardNavigationType.registerEnum("Telerik.Web.UI.TreeListKeyBoardNavigationType");
Telerik.Web.UI.TreeListFormItemType=function(){};
Telerik.Web.UI.TreeListFormItemType.prototype={InsertForm:0,EditForm:1,RootInsertForm:2};
Telerik.Web.UI.TreeListFormItemType.registerEnum("Telerik.Web.UI.TreeListFormItemType");
Telerik.Web.UI.TreeListKeyPressEventArgs=function(b,a,d,c){Telerik.Web.UI.TreeListKeyPressEventArgs.initializeBase(this);
this._keyCode=(d&&a==null)?c:b.keyCode||b.charCode;
this._isShiftPressed=b.shiftKey;
this._isCtrlPressed=b.ctrlKey;
this._isAltPressed=b.altKey;
this._domEvent=b;
this._navigationType=a;
};
Telerik.Web.UI.TreeListKeyPressEventArgs.prototype={get_keyCode:function(){return this._keyCode;
},get_isShiftPressed:function(){return this._isShiftPressed;
},get_isCtrlPressed:function(){return this._isCtrlPressed;
},get_isAltPressed:function(){return this._isAltPressed;
},get_domEvent:function(){return this._domEvent;
},get_keyboardNavigationType:function(){return this._navigationType;
},set_keyboardNavigationType:function(a){this._navigationType=a;
}};
Telerik.Web.UI.TreeListKeyPressEventArgs.registerClass("Telerik.Web.UI.TreeListKeyPressEventArgs",Sys.CancelEventArgs);
if(typeof(Sys)!=='undefined')Sys.Application.notifyScriptLoaded();